-- 游戏核心逻辑
Lua_MainData = class("Lua_MainData");
function Lua_MainData:ctor()
	self:superCall("ctor");
    self:initDefRequire();
	self:initProxy();
end

function Lua_MainData:dispose()
    self:clearTimer();
end

function Lua_MainData:initDefRequire()
    checkRequire("Lua_DefineConfig");
    checkRequire("Lua_RedPointIcon");
    checkRequire("Lua_DragListContainer");
    checkRequire("Lua_DragCustomBtnList");
    checkRequire("Lua_TextArea");
    checkRequire("Lua_ButtonList");
    checkRequire("Lua_CirculateList");
    checkRequire("Lua_RoundList");
    checkRequire("Lua_ScrollText");
    checkRequire("Lua_ThingTableGen");
    checkRequire("Lua_CShaprFunction");
    checkRequire("Lua_BuffIcon");
    checkRequire("Lua_MainMenuIcon");
    checkRequire("Lua_AvatarItem");
    checkRequire("Lua_MoneyItem");
    checkRequire("Lua_ItemIcon");
    checkRequire("Lua_ItemIconCell");
    checkRequire("Lua_ItemIconList");
    checkRequire("Lua_NumberImage");
    checkRequire("Lua_NumericKeyboardInputItem");
    checkRequire("Lua_NumberInputItem");
    checkRequire("Lua_SliderProgressBar");
    checkRequire("Lua_TipsBaseWindow");
    checkRequire("Lua_IconSkipItem");
    checkRequire("Lua_HeroItemIcon");
    checkRequire("Lua_ModelScenePanel");
    checkRequire("Lua_MultiModelScenePanel");
    checkRequire("Lua_HeroGridViewPanel");
    checkRequire("Lua_SkillIconItem");
    checkRequire("Lua_CampSiftPanel");
    checkRequire("Lua_CampCareerSiftPanel");
    checkRequire("Lua_ConsumeIconItem");
    checkRequire("Lua_AttrIconItem");
    checkRequire("Lua_RechargeConfigData");
    checkRequire("Lua_SpliceTextItem");
    checkRequire("Lua_ModelCameraManager");
end

function Lua_MainData:initProxy()
    Lua_ProxyManager.addProxy("Lua_RedPointProxy");
    Lua_ProxyManager.addProxy("Lua_PackProxy");
    Lua_ProxyManager.addProxy("Lua_HeroProxy");
    Lua_ProxyManager.addProxy("Lua_ThingProxy");
    Lua_ProxyManager.addProxy("Lua_MainViewProxy");
    Lua_ProxyManager.addProxy("Lua_RoleProxy");
    Lua_ProxyManager.addProxy("Lua_VipProxy");
    Lua_ProxyManager.addProxy("Lua_MainLineProxy");
    Lua_ProxyManager.addProxy("Lua_WelfareProxy");
    Lua_ProxyManager.addProxy("Lua_MailProxy");
    Lua_ProxyManager.addProxy("Lua_RecruitProxy");
    Lua_ProxyManager.addProxy("Lua_HeroAssemblyProxy");
    Lua_ProxyManager.addProxy("Lua_FightProxy");
    Lua_ProxyManager.addProxy("Lua_RechargeProxy");
    Lua_ProxyManager.addProxy("Lua_ChatProxy");
    Lua_ProxyManager.addProxy("Lua_ShopProxy");
    Lua_ProxyManager.addProxy("Lua_OnlineRewardProxy");
    Lua_ProxyManager.addProxy("Lua_FriendProxy");
    Lua_ProxyManager.addProxy("Lua_ArtifactProxy");
    Lua_ProxyManager.addProxy("Lua_ClimbTowerProxy");
    Lua_ProxyManager.addProxy("Lua_EquipProxy");
    Lua_ProxyManager.addProxy("Lua_ArenaProxy");
    Lua_ProxyManager.addProxy("Lua_TrialProxy");
    Lua_ProxyManager.addProxy("Lua_RunesProxy");
    Lua_ProxyManager.addProxy("Lua_LifeTreeProxy");
    Lua_ProxyManager.addProxy("Lua_LuckyTurntableProxy");
    Lua_ProxyManager.addProxy("Lua_DownLoadRewardProxy");
    Lua_ProxyManager.addProxy("Lua_ExpeditionProxy");
    Lua_ProxyManager.addProxy("Lua_TalentProxy");
    Lua_ProxyManager.addProxy("Lua_InfinityHallProxy");
    Lua_ProxyManager.addProxy("Lua_FirstRechargeProxy");
    Lua_ProxyManager.addProxy("Lua_ChampionshipProxy");
    Lua_ProxyManager.addProxy("Lua_AllianceProxy");
    Lua_ProxyManager.addProxy("Lua_ChaosForestProxy");
    Lua_ProxyManager.addProxy("Lua_TenRecruitSelectProxy");
    Lua_ProxyManager.addProxy("Lua_SevenDayProxy");     
    Lua_ProxyManager.addProxy("Lua_StarTrialProxy");
    Lua_ProxyManager.addProxy("Lua_OperationalActivitiesProxy");
    Lua_ProxyManager.addProxy("Lua_RaccoonMartProxy");
    Lua_ProxyManager.addProxy("Lua_CrossServerProxy");
    Lua_ProxyManager.addProxy("Lua_VideosProxy");
    Lua_ProxyManager.addProxy("Lua_TaskProxy");
    Lua_ProxyManager.addProxy("Lua_SceneProxy");
    Lua_ProxyManager.addProxy("Lua_RankProxy");
    Lua_ProxyManager.addProxy("Lua_ExcellentActivityProxy");
    Lua_ProxyManager.addProxy("Lua_PeakDuelProxy");
    Lua_ProxyManager.addProxy("Lua_DailyRechargeProxy");
    Lua_ProxyManager.addProxy("Lua_LimitTimeGiftProxy");
    Lua_ProxyManager.addProxy("Lua_WarOrderProxy");
    Lua_ProxyManager.addProxy("Lua_CollectionProxy");
    Lua_ProxyManager.addProxy("Lua_NewHeroActivityProxy");
    Lua_ProxyManager.addProxy("Lua_EquipCopyProxy");
    Lua_ProxyManager.addProxy("Lua_GuideProxy");
    Lua_ProxyManager.addProxy("Lua_OpenServerCarnivalProxy");
    Lua_ProxyManager.addProxy("Lua_CollectionBookProxy");
    Lua_ProxyManager.addProxy("Lua_HundredCeremonyProxy");
    Lua_ProxyManager.addProxy("Lua_KunXuHolyLandProxy");
    Lua_ProxyManager.addProxy("Lua_ExclusivePlanProxy");
    Lua_ProxyManager.addProxy("Lua_LimitedTimeActivityProxy");
    Lua_ProxyManager.addProxy("Lua_QuestionProxy");
    Lua_ProxyManager.addProxy("Lua_OpenServerTrialProxy");
    Lua_ProxyManager.addProxy("Lua_TownTreasureProxy");
end

-- 配置加载完成，进入游戏世界（场景）
function Lua_MainData:onFirstEnterGame(isPlayVideo)
    -- DataCenter.deviceQuality:updateQuality(); -- 设置游戏性能
    -- -- DataCenter.mainLineSceneController:enterScene(DataCenter.mainLineData.curSceneId);
    -- -- Scene3DManager.instance:OpenSceneBySceneId(DataCenter.mainLineData.curSceneId, 0, true);
    -- Lua_WindowUtil.openWin("Lua_RoleInfoWindow", Lua_WinParam.ACTION_OPEN);
    -- Lua_WindowUtil.openWin("Lua_MainMenuWindow", Lua_WinParam.ACTION_OPEN);
    -- Lua_WindowUtil.openWin("Lua_MainIconWindow", Lua_WinParam.ACTION_OPEN);
    -- Lua_WindowUtil.openWin("Lua_ChatIconWindow", Lua_WinParam.ACTION_OPEN);
    -- Lua_MsgUtil.callFunc("UPDATE_MAIN_MENU", Lua_MenuViewDefine.MEBULIST_ALL);
    -- -- if GlobalVar.screenOffsetTopH > 0 or GlobalVar.screenOffsetBottomH > 0 then
    -- --     Lua_WindowUtil.openWin("Lua_LiuHaiMaskWindow", Lua_WinParam.ACTION_OPEN);
    -- -- end

    -- if not isPlayVideo then
    --     checkRequire("tb_monster_player");
    --     checkRequire("tb_monster");
    -- end

    -- Lua_ProxyManager.getProxy("Lua_RoleProxy"):sRoleWorldLv();-- 获取世界等级请求
    -- Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroFashion();-- 英雄时装请求
    -- Lua_ProxyManager.getProxy("Lua_MailProxy"):sGetMailInfo();-- 获取邮件信息
    -- Lua_ProxyManager.getProxy("Lua_RunesProxy"):sRunesInfo(); -- 符石请求
    -- Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sEquipCopyVideo();
    if DataCenter.modelCameraManager == nil then
        DataCenter.modelCameraManager = Lua_ModelCameraManager.new();
    end

    self.firstUpdateIdx = 0;
    if not self.bAddTimer then
        self.bAddTimer = true;
        Lua_CommonUtil.addTimer("onFirstEnterGameUpdate", 0.1, self, self.onFirstEnterGameUpdate, isPlayVideo);
    end
end

function Lua_MainData:clearTimer()
    if self.bAddTimer then
        self.bAddTimer = false;
        self.firstUpdateIdx = 0;
        Lua_CommonUtil.removeTimer(self, self.onFirstEnterGameUpdate);
    end
end

function Lua_MainData:onFirstEnterGameUpdate(isPlayVideo)
    self.firstUpdateIdx = self.firstUpdateIdx + 1;
    if self.firstUpdateIdx == 1 then
        DataCenter.deviceQuality:updateQuality(); -- 设置游戏性能
    elseif self.firstUpdateIdx == 2 then
        Lua_WindowUtil.openWin("Lua_RoleInfoWindow", Lua_WinParam.ACTION_OPEN);
    elseif self.firstUpdateIdx == 3 then
        Lua_WindowUtil.openWin("Lua_MainMenuWindow", Lua_WinParam.ACTION_OPEN);
    elseif self.firstUpdateIdx == 4 then
        Lua_WindowUtil.openWin("Lua_MainIconWindow", Lua_WinParam.ACTION_OPEN);
    elseif self.firstUpdateIdx == 5 then
        Lua_WindowUtil.openWin("Lua_ChatIconWindow", Lua_WinParam.ACTION_OPEN);
    elseif self.firstUpdateIdx == 6 then
        Lua_MsgUtil.callFunc("UPDATE_MAIN_MENU", Lua_MenuViewDefine.MEBULIST_ALL);
    elseif self.firstUpdateIdx == 7 then
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sRoleWorldLv();-- 获取世界等级请求
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroFashion();-- 英雄时装请求
        Lua_ProxyManager.getProxy("Lua_MailProxy"):sGetMailInfo();-- 获取邮件信息
        Lua_ProxyManager.getProxy("Lua_RunesProxy"):sRunesInfo(); -- 符石请求
        Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sFightReplay(); -- 魔灵岛队伍上轮战斗录像
        Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sFightReplay(); -- 请求巅峰对决上次战斗
        if not DataCenter.funcOpenData:isOpened(10252) then -- 精英赛
            local open_days = DataCenter.roleData.open_days;
            if open_days > 1 and open_days < 4 then
                Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sStartTick();
            else
                DataCenter.mainMenuData:setIconShowInfo(30021, false);
            end
        end
    else
        self:clearTimer();
    end
end

-- 游戏中功能开启请求服务端数据在Lua_MainViewProxy
function Lua_MainData:initServerInfo()
    if DataCenter == nil then
        return;
    end

    -- 开发调试数据
    if Lua_PlatformUtil.IsNoSdk() then
        local cmd = ProtoPublic_pb.Proto10111999();
        cmd.cmd_name = "global_data";
        cmd.param1 = 1;
        sendMsg(10111999, cmd);
    end

    -- 主线推图
    if DataCenter.funcOpenData:isOpened(10003) then
        Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sMainLineInfo();
    end

    if DataCenter.funcOpenData:isOpened(10095) then
        Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sHookInfo();
    end

    if DataCenter.funcOpenData:isOpened(10221) then
        Lua_ProxyManager.getProxy("Lua_MainLineProxy"):sTaskInfo();
    end
    
    -- 首充请求
    if DataCenter.funcOpenData:isOpened(10182) then
        Lua_ProxyManager.getProxy("Lua_FirstRechargeProxy"):sFirstRechargeInfo();
    end

    -- 个人信息 形象装扮
    if DataCenter.funcOpenData:isOpened(10024) then
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sDressUpInfo(Lua_DressUpDefine.MAINTYPE_HEAD);
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sDressUpInfo(Lua_DressUpDefine.MAINTYPE_FRAME);
        -- Lua_ProxyManager.getProxy("Lua_RoleProxy"):sDressUpInfo(Lua_DressUpDefine.MAINTYPE_BUBBLE);
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sDressUpInfo(Lua_DressUpDefine.MAINTYPE_TITLE);
    end

    -- 每日签到
    if DataCenter.funcOpenData:isOpened(10016) then
        Lua_ProxyManager.getProxy("Lua_WelfareProxy"):sSignInInfo();
    end

    -- 同调器
    if DataCenter.funcOpenData:isOpened(10148) then
        Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):slifeTreeInfo();
    end

    -- 英雄之力
    if DataCenter.funcOpenData:isOpened(10149) then
        Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sStatue();
    end

    -- 在线奖励
    if DataCenter.funcOpenData:isOpened(10014) then
        Lua_ProxyManager.getProxy("Lua_OnlineRewardProxy"):sOnlineInfo();
    end

    -- 日常任务请求
    if DataCenter.funcOpenData:isOpened(10194) then
        Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskInfo();
    end

    -- 日常任务-活跃战令
    if DataCenter.funcOpenData:isOpened(10223) then
        Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskActiveWarInfo(0);
    end

    -- 八日登录请求
    if DataCenter.funcOpenData:isOpened(10019) then
        Lua_ProxyManager.getProxy("Lua_SevenDayProxy"):sSevenDaySigInInfo();
    end

    -- 等级礼包
    if DataCenter.funcOpenData:isOpened(10181) then
        Lua_ProxyManager.getProxy("Lua_WelfareProxy"):sOpenGradeGiftInfo();
    end

    -- 主线任务请求
    if DataCenter.funcOpenData:isOpened(10028) then
        Lua_ProxyManager.getProxy("Lua_TaskProxy"):sExploreTourInfo();
    end

    -- 成长投资
    if DataCenter.funcOpenData:isOpened(10257) then
        Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sInvestmentLogin();
    end

    -- 十连自选
    if DataCenter.funcOpenData:isOpened(10189) then
        Lua_ProxyManager.getProxy("Lua_TenRecruitSelectProxy"):sTenRecruitSelectInfo();
    end

    -- 月卡
    if DataCenter.funcOpenData:isOpened(10009) then
        Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sMonthCardInInfo();
    end

    -- 战令
    Lua_ProxyManager.getProxy("Lua_WarOrderProxy"):resetRedPoint();

    -- 无穷战殿
    if DataCenter.funcOpenData:isOpened(10195) then
        Lua_ProxyManager.getProxy("Lua_InfinityHallProxy"):sInfinityHall(0);
        Lua_ProxyManager.getProxy("Lua_InfinityHallProxy"):sRewardInfo(1);
        Lua_ProxyManager.getProxy("Lua_InfinityHallProxy"):sRewardInfo(2);
    end

    -- 兑换活动
    if DataCenter.funcOpenData:isOpened(10217) then
        Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sCashRewardInfo();
    end

    -- 开服狂欢
    if DataCenter.funcOpenData:isOpened(10219) then
        Lua_ProxyManager.getProxy("Lua_OpenServerCarnivalProxy"):sOpenServerCarnivalInfo();
    end

    -- 升星专属（本地）
    if DataCenter.funcOpenData:isOpened(10201) then
        Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sUpStarOfServerInfo();
    end

    -- 普通幸运转盘
    if DataCenter.funcOpenData:isOpened(10204) then
        Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sLuckyTurntableInfo(Lua_LuckyTurntableData.ordinaryTurnTable);
        Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sCumulateDrawInfo(Lua_LuckyTurntableData.ordinaryTurnTable);
    end

    -- 高级幸运转盘
    if DataCenter.funcOpenData:isOpened(10205) then
        Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sLuckyTurntableInfo(Lua_LuckyTurntableData.seniorTurnTable);
        Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sCumulateDrawInfo(Lua_LuckyTurntableData.seniorTurnTable);
    end

    -- 斗技场
    if DataCenter.funcOpenData:isOpened(10224) then
        Lua_ProxyManager.getProxy("Lua_ArenaProxy"):sArenaInfo();
    end

    -- 每日礼包
    if DataCenter.funcOpenData:isOpened(10010) then
        Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sDailyGiftInInfo();
    end

    -- 每周礼包
    if DataCenter.funcOpenData:isOpened(10202) then
        Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sWeeklyGiftInInfo();
    end

    -- 每月礼包
    if DataCenter.funcOpenData:isOpened(10203) then
        Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sMonthlyGiftInInfo();
    end

    -- 每日特惠
    if DataCenter.funcOpenData:isOpened(10256) then
        Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sDailyDiscountInfo();
    end

    -- 积天豪礼
    if DataCenter.funcOpenData:isOpened(10207) then
        Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sCumulateGiftInfo();
    end

    -- 英雄集结
    if DataCenter.funcOpenData:isOpened(10206) then
        Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sHeroGatherInfo();
    end

    -- 每日充值
    if DataCenter.funcOpenData:isOpened(10025) then
        Lua_ProxyManager.getProxy("Lua_DailyRechargeProxy"):sDailyRechargeInfo();
    end

    -- 日常试炼
    if DataCenter.funcOpenData:isOpened(10094) then
        Lua_ProxyManager.getProxy("Lua_TrialProxy"):refreshRedPoint();
    end

    -- VIP
    if DataCenter.funcOpenData:isOpened(10017) then
        Lua_ProxyManager.getProxy("Lua_VipProxy"):sGetVipPanelInfo();
    end

    -- 魔灵岛
    if DataCenter.funcOpenData:isOpened(10222) then
        Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sEquipCopy();
        Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sFirstPassRankInfo();
    end

    -- 边境远征
    if DataCenter.funcOpenData:isOpened(10092) then
        Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sExpeditionInfo();
    end

    -- 命格
    if DataCenter.funcOpenData:isOpened(10210) then
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sFateInfo();
    end

    -- 神器
    if DataCenter.funcOpenData:isOpened(10209) then
        Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sArtifactInfo();
    end

    -- 神器幻化
    -- if DataCenter.funcOpenData:isOpened(10211) then
    --     Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sClothesInfo();
    -- end

    -- 混沌森林
    if DataCenter.funcOpenData:isOpened(10190) then
        Lua_ProxyManager.getProxy("Lua_ChaosForestProxy"):sWinInfo();
        Lua_ProxyManager.getProxy("Lua_ChaosForestProxy"):sRecordInfo();
    end

    -- 通天塔
    if DataCenter.funcOpenData:isOpened(10188) then
        Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerInfo(0);
    end

    -- 好友
    if DataCenter.funcOpenData:isOpened(10265) then
        Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetFriendListInfo(Lua_FriendData.FRIEND_TYPE);
    end

    -- 小卖部
    if DataCenter.funcOpenData:isOpened(10076) then
        Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sWishBlessInfo();-- 老客回顾
        Lua_ProxyManager.getProxy("Lua_RecruitProxy"):sRecruitMain();
    end

    -- 收藏册
    if DataCenter.funcOpenData:isOpened(10239) then
        Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sGetCBPageInfo();
        Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sGetCBOrdinaryCardInfo();
		Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sAdmireOtherPlayer(0); 
        Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sGetCBRankInfo(); --红点
        Lua_ProxyManager.getProxy("Lua_CollectionBookProxy"):sHeroFetter(); -- 更新角色信息   
    end

    -- 百抽盛典
    if DataCenter.funcOpenData:isOpened(10241) then
        Lua_ProxyManager.getProxy("Lua_HundredCeremonyProxy"):sHundredCeremonyInfo();
    end

    -- 昆墟圣地
    if DataCenter.funcOpenData:isOpened(10245) then
        Lua_ProxyManager.getProxy("Lua_KunXuHolyLandProxy"):sGetKunXuInfo(0); --请求活动界面信息:首次开启标志 0跳过 1开启
    end

    -- 炼金坊
    if DataCenter.funcOpenData:isOpened(10249) then
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sAlchemyInfo()
    end

    -- 藏品柜
    if DataCenter.funcOpenData:isOpened(10218) then
        Lua_ProxyManager.getProxy("Lua_CollectionProxy"):sCollectionInfo();
    end

    -- 独家企划
    if DataCenter.funcOpenData:isOpened(10247) then
        Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sExclusivePlanInfo();
        Lua_ProxyManager.getProxy("Lua_ExclusivePlanProxy"):sGetTaskInfo();
    end

    -- 星河殿
    if DataCenter.funcOpenData:isOpened(10227) then
        Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sChapterInfo();
        Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sStarTrialInfo(0);
    end

    -- 钻石礼包
    if DataCenter.funcOpenData:isOpened(10023) then
        Lua_ProxyManager.getProxy("Lua_RechargeProxy"):sRechargeInfo();
        Lua_ProxyManager.getProxy("Lua_VipProxy"):sGetVipPanelInfo();
    end

    -- 新服专享
    if DataCenter.funcOpenData:isOpened(10192) then
        Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sNewServeGiftInfo();
    end

    -- 公会
    if DataCenter.funcOpenData:isOpened(10007) and DataCenter.roleData.league_id ~= 0 then
        Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetAllianceInfo(); -- 提前获取公会信息，避免跳转报错
        Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceBossInfo(0); -- 提前获得公会boss信息
        Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceScience(0); -- 刷新公会科技红点
        Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceRedPacketInfo(); --刷新公会红包领取次数

        if DataCenter.funcOpenData:isOpened(10287) then
            Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealEntrance(); -- 请求公会交易次数信息
        end
    end

    -- 星河试炼
    if DataCenter.funcOpenData:isOpened(10235) then
        Lua_ProxyManager.getProxy("Lua_LimitedTimeActivityProxy"):sStarRiverTrialInfo(0);
    end

    -- 精英赛
    if DataCenter.funcOpenData:isOpened(10252) then
        Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sWinInfo();
    end

    -- 特卖店(红点)
    if DataCenter.funcOpenData:isOpened(10226) then
        Lua_ProxyManager.getProxy("Lua_ShopProxy"):sShopInfo(Lua_ShopData.SPIRIT_SHOP);
    end

    -- 专属订阅
    if DataCenter.funcOpenData:isOpened(10240) then
        Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sPersonReadInfo();
    end

    -- 录像馆
    if DataCenter.funcOpenData:isOpened(10200) then
        Lua_ProxyManager.getProxy("Lua_VideosProxy"):sLikeInfo();
    end

    -- 英雄赠礼
    if DataCenter.funcOpenData:isOpened(10282) then
        Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sOpenServerHeroGiftInfo();
    end

    -- 英雄降临
    if DataCenter.funcOpenData:isOpened(10283) then
        Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroComeInfo();
    end

    -- 古城秘藏
    if DataCenter.funcOpenData:isOpened(10285) then
        Lua_ProxyManager.getProxy("Lua_TownTreasureProxy"):sActivityInfo();
        Lua_ProxyManager.getProxy("Lua_TownTreasureProxy"):sTaskInfo();
    end

    -- 英雄挑战
    if DataCenter.funcOpenData:isOpened(10286) then
        Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroChallengeInfo();
    end

    -- 巅峰对决
    if DataCenter.funcOpenData:isOpened(10284) then
        Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDInfo();
    end

    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLineup(); -- 英雄布阵请求，在所有请求最后
end