-- 悬浮菜单
Lua_MenuPopListWindow = class("Lua_MenuPopListWindow", Lua_Window)
function Lua_MenuPopListWindow:ctor()
    self:superCall("ctor")

    self.w = 200
    self.h = 165
    self.windowName = "Lua_MenuPopListWindow"
    self.showBlackMask = true
    self.blackAlpha = 0.01
    self.showWinBg = true
    self.winBgAtlas = "common_altas_4"
    self.winBgSprite = "xui_jmd_widget_17"
    self.isClickClose = true
end

function Lua_MenuPopListWindow:buildShowItem()
    self:superCall("buildShowItem")
end

function Lua_MenuPopListWindow:dispose()
    if self.menuList then
        self.menuList:dispose()
        self.menuList = nil
    end
    self:superCall("dispose")
end

function Lua_MenuPopListWindow:showWin(param)
	self:superCall("showWin", param)

	LuaUtil.setObjPos(self.content, param.posX, param.posY, 0)

	local data = param.menu
	local len
    if data.typeof ~= nil and data:typeof() == type_str_array then
        len = data:getSize();
    else
        len = #data;
    end
    local width = len * 44 + (len - 1) * 5
    self.winBg:SetDimensions(self.w, width + 23)

    if self.menuList == nil then
		self.menuList = Lua_DragList.new(self.content, 188, width, Lua_AxisDefine.Vertical)
		self.menuList:setListCell(Lua_MenuPopListItem, 188, 44, 1)
		self.menuList:setCellSpacing(0, 5)
    end
	self.menuList:setArrayData(data)
	self.menuList.canDrag = not self.menuList.isTheEnd
end




















Lua_MenuPopListItem = class("Lua_MenuPopListItem", Lua_ListCell)
function Lua_MenuPopListItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_MenuPopListItem:buildShowItem()
	self:superCall("buildShowItem")

	self.menuBg = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_jmd_widget_18", 0, 0, 0, 0)

	self.menuText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 24)
	self.menuText.pivotValue = 4
	self.menuText.alignmentValue = 4
	self.menuText.horizontalOverflowValue = 1
	self.menuText.verticalOverflowValue = 1
	self.menuText.colorStr = Lua_ColorDefine.transColor("F0EBE3")
end

function Lua_MenuPopListItem:dispose()
	if self.data then
		self.data:dispose()
		self.data = nil
	end
	self:superCall("dispose")
end

function Lua_MenuPopListItem:setData(data)
	self.data = data
	self.menuText.text = Lua_MenuPopListData.getBtnLabel(data.munuType)
end

function Lua_MenuPopListItem:onPressClick()
	if self.data == nil then
		return
	end
	self.data.callBack(self.data.owner)
end