Lua_ArtifactSkillItem = class("Lua_ArtifactSkillItem", Lua_DisplayObject)
function Lua_ArtifactSkillItem:ctor(p)
	self:superCall("ctor", p, "ArtifactSkillItem_skin")
end

function Lua_ArtifactSkillItem:buildShowItem()
	self:superCall("buildShowItem")
	self.icon:addClickFuntion(self, self.onCheckSkill)
	self.unlockText:setEnable(false)
end

function Lua_ArtifactSkillItem:dispose()
	self:superCall("dispose")
end

function Lua_ArtifactSkillItem:onCheckSkill(go)
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_ArtifactSkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_ArtifactSkillItem:setSkillId(id)
	if id and id > 0 then
		self.bg:setAltas("hero_embattle", "xui_zd_widget_6")
		self:setData(Lua_SkillConfigData.getConfigData(id))
	else
		self:setData(nil)
		if id == nil then
			self.bg:setAltas("hero_embattle", "xui_zd_widget_6")
			self.unlockText:setEnable(true)
		else
			self.bg:setAltas("hero_embattle", "xui_zd_widget_5")
			self.unlockText:setEnable(false)
		end
	end
end

function Lua_ArtifactSkillItem:setData(data)
	self.data = data
	if data == nil then
		self.content.name = self.classname
		self.icon:setEnable(false)
		self.levelBg:setEnable(false)
		self.levelText:setEnable(false)
		self.energyIcon:setEnable(false)
		self.energyText:setEnable(false)
	else
		self.content.name = data.skillId
		self.icon:setEnable(true)
		self.icon:setAltas(data.atlas, data.sprite)

		self.levelBg:setEnable(true)
		self.levelText:setEnable(true)
		self.levelText.text = data.level

		self.energyIcon:setEnable(true)
		self.energyText:setEnable(true)
		self.energyText.text = data.costEnergy
	end
end

function Lua_ArtifactSkillItem:hideLevel()
	self.levelBg:setEnable(false)
	self.levelText:setEnable(false)
end

function Lua_ArtifactSkillItem:hideEnergy()
	self.energyIcon:setEnable(false)
	self.energyText:setEnable(false)
end