--英雄阵营和职业筛选
checkRequire("Lua_CampSiftBaseItem")
Lua_CampCareerSiftPanel = class("Lua_CampCareerSiftPanel", Lua_DisplayObject)
function Lua_CampCareerSiftPanel:ctor(p)
	self:superCall("ctor", p, "CampSiftPanel_skin");
end

function Lua_CampCareerSiftPanel:buildShowItem()
	self:superCall("buildShowItem")
end

-- 间距，色值，字号，大小
function Lua_CampCareerSiftPanel:setSiftItem(spaceValue, colorStr, fontSize, scale)
	self.spaceValue = spaceValue;
	self.colorStr = colorStr;
	self.fontSize = fontSize;
	self.scale = scale;
end

--展示的数据
function Lua_CampCareerSiftPanel:setArrayData(data)
	self.scale = self.scale == nil and 1 or self.scale;
	self.spaceValue = self.spaceValue == nil and 65 or self.spaceValue;

	self.itemArr = Array();
	self.posxArr = Array();
	self.campTypeDic = {};
	local len = data:getSize()
	local item
	local w = -(self.spaceValue * len) / 2 + self.spaceValue -- 偏移值
	local posX
	for i = 1, len do
		item = Lua_CampSiftBaseItem.new(self.content, self.spaceValue, self.colorStr, self.fontSize)

		posX = ((i - 1) % len) * self.spaceValue + w
		item:setLocation(posX, 0, 0)
		item:setScale(self.scale, self.scale);
		item:setData(data[i]);
		self.campTypeDic[data[i]] = i;
		item:setClickCallBack(self, self.onCampSelected)

		self.posxArr:add(posX);
		self.itemArr:add(item);
	end

	self.bUnfold = false
	self.unfoldBg:setLocation(-260 + self.spaceValue, 35, 0)
	self.campLabel:setLocation(-182 + self.spaceValue, 0, 0)
	self.careerLabel:setLocation(-182 + self.spaceValue, 70, 0)
	self:updateUnfold()
	self.bg.clickScale = false
	self.bg:addClickFuntion(self, self.onBgClick)
	self.btnUnfold:addClickFuntion(self, self.onUnfoldClick);
end

function Lua_CampCareerSiftPanel:dispose()
	if self.itemArr then
		self.itemArr:dispose()
		self.itemArr:clear()
		self.itemArr = nil
	end
	if self.posxArr then
		self.posxArr:clear()
		self.posxArr = nil
	end
	if self.careerArr then
		self.careerArr:dispose()
		self.careerArr:clear()
		self.careerArr = nil
	end
	if self.campArr then
		self.campArr:dispose()
		self.campArr:clear()
		self.campArr = nil
	end
	self.campLimitDic = nil
	self.campTypeDic = nil;
	self.owner = nil
	self.callBack = nil
	self:superCall("dispose")
end

function Lua_CampCareerSiftPanel:setCallBack(owner, callBack)
	self.owner = owner
	self.callBack = callBack
end

function Lua_CampCareerSiftPanel:setLimitCamp(campLimitDic, campLimitTips)
	self.campLimitDic = campLimitDic
	self.campLimitTips = campLimitTips
	local item
	for i = 1, self.itemArr:getSize() do
		item = self.itemArr[i]
		item:setIconGray(item.data ~= 0 and self.campLimitDic[item.data] == nil)
	end
end

function Lua_CampCareerSiftPanel:setSelected(campType, careerType, isUpdate)
	if self.campType == campType and self.careerType == careerType and isUpdate ~= true then
		return
	end
	if self.bUnfold then
		self:reserSelected()
		self:onCallBack()
	else
		self.careerType = careerType
		self:onCampSelected(campType)
	end
end

function Lua_CampCareerSiftPanel:onCampSelected(campType)
	if self.itemArr == nil then
		return
	end

	if campType ~= 0 and self.campLimitDic and self.campLimitDic[campType] == nil then
		OperateAlert.show(self.campLimitTips)
		return
	end
	local index = self.campTypeDic[campType];
	self.campType = campType
	local posX
	local item
	for i = 1, self.itemArr:getSize() do
		posX = self.posxArr[i]
		item = self.itemArr[i]
		if i > index then -- 往右移
			item:setLocation(posX + self.spaceValue / 2, item.y, 0)
		else -- 往左移
			item:setLocation(posX - self.spaceValue / 2, item.y, 0)
		end
		item:setSelectEnable(item.data == campType)
	end

	self:onCallBack()
end

function Lua_CampCareerSiftPanel:onCallBack()
	if self.owner and self.callBack then
		self.callBack(self.owner, self.campType, self.careerType)
	end
end

function Lua_CampCareerSiftPanel:onBgClick(go)

end

function Lua_CampCareerSiftPanel:onUnfoldClick(go)
	self.bUnfold = not self.bUnfold
	self:updateUnfold()
end

function Lua_CampCareerSiftPanel:updateUnfold()
	for i = 1, self.itemArr:getSize() do
		self.itemArr[i]:setEnable(not self.bUnfold)
	end
	self.unfoldObject:SetActive(self.bUnfold)
	if self.bUnfold then
		self.btnUnfold:setAltas("common_altas_2", "xui_common_button_034_p")
		self.btnUnfold:setLocation(-260 + self.spaceValue, 70, 0)
	else
		self.btnUnfold:setAltas("common_altas_2", "xui_common_button_034_n")
		self.btnUnfold:setLocation(-260 + self.spaceValue, 0, 0)
	end
	if self.bUnfold then
		if self.careerArr == nil then
			self.careerArr = Array()
			local arr = DataCenter.heroUtil.careerAllInfo
			local item
			for i = 1, arr:getSize() do
				item = Lua_CareerIconItem.new(self.unfoldObject)
				item:setLocation(-50 + (i - 1) * 70, 70, 0)
				item:setData(arr[i], self, self.onCareerClick)
				item:setSelected(arr[i] == self.careerType)
				self.careerArr:add(item)
			end

			self.campArr = Array()
			arr = DataCenter.heroUtil.siftAllInfo
			for i = 1, arr:getSize() do
				item = Lua_CampIconItem.new(self.unfoldObject)
				item:setLocation(-50 + (i - 1) * 70, 0, 0)
				item:setData(arr[i], self, self.onCampClick)
				item:setSelected(arr[i] == self.campType)
				item:setGray(arr[i] ~= 0 and self.campLimitDic and self.campLimitDic[item.data] == nil)
				self.campArr:add(item)
			end
		else
			self:reserSelected()
		end
	end
end

function Lua_CampCareerSiftPanel:reserSelected()
	for i = 1, self.careerArr:getSize() do
		self.careerArr[i]:setSelected(self.careerArr[i].data == self.careerType)
	end
	for i = 1, self.campArr:getSize() do
		self.campArr[i]:setSelected(self.campArr[i].data == self.campType)
	end	
end

function Lua_CampCareerSiftPanel:onCareerClick(careerType)
	self.careerType = careerType
	for i = 1, self.careerArr:getSize() do
		self.careerArr[i]:setSelected(self.careerArr[i].data == careerType)
	end
	self:onCallBack()
end

function Lua_CampCareerSiftPanel:onCampClick(campType)
	if campType ~= 0 and self.campLimitDic and self.campLimitDic[campType] == nil then
		OperateAlert.show(self.campLimitTips)
		return
	end

	for i = 1, self.campArr:getSize() do
		self.campArr[i]:setSelected(self.campArr[i].data == campType)
	end
	self:onCampSelected(campType)
end
















Lua_CareerIconItem = class("Lua_CareerIconItem", Lua_DisplayObject)
function Lua_CareerIconItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_CareerIconItem:buildShowItem()
	self:superCall("buildShowItem")

	self.showIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0)
	self.showIcon:addClickFuntion(self, self.onClick)

	self.selectIcon = UICreate.createUIAtlasImage(self.content, "common_altas_2", "xui_common_button_038_p", 0, 0, 0, 0)
	self.selectIcon:setEnable(false)
end

function Lua_CareerIconItem:dispose()
	self.showIcon = nil
	self.data = nil
	self.owner = nil
	self.callBack = nil
	self:superCall("dispose")
end

function Lua_CareerIconItem:setData(data, owner, callBack)
	self.data = data
	self.owner = owner
	self.callBack = callBack
	if data == 0 then
		self.showIcon:setAltas("common_altas_2", "xui_common_attribute_16_n")
	else
		self.showIcon:setAltas("common_altas_2", "xui_common_button_0"..34 + data.."_n")
	end
end

function Lua_CareerIconItem:setSelected(bValue)
	if bValue then
		if self.data == 0 then
			self.showIcon:setAltas("common_altas_2", "xui_common_attribute_16_p")
		else
			self.selectIcon:setEnable(true)
		end
	else
		if self.data == 0 then
			self.showIcon:setAltas("common_altas_2", "xui_common_attribute_16_n")
		else
			self.selectIcon:setEnable(false)
		end
	end
end

function Lua_CareerIconItem:onClick(go)
	if self.owner and self.callBack then
		self.callBack(self.owner, self.data)
	end
end




















Lua_CampIconItem = class("Lua_CampIconItem", Lua_DisplayObject)
function Lua_CampIconItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_CampIconItem:buildShowItem()
	self:superCall("buildShowItem")

	self.showIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0)
	self.showIcon:addClickFuntion(self, self.onClick)
end

function Lua_CampIconItem:dispose()
	self.showIcon = nil
	self.data = nil
	self.owner = nil
	self.callBack = nil
	self:superCall("dispose")
end

function Lua_CampIconItem:setData(data, owner, callBack)
	self.data = data
	self.owner = owner
	self.callBack = callBack
	self.showIcon:setAltas("common_altas_2", "xui_common_attribute_"..16 + data.."_n")
end

function Lua_CampIconItem:setSelected(bValue)
	if bValue then
		self.showIcon:setAltas("common_altas_2", "xui_common_attribute_"..16 + self.data.."_p");
	else
		self.showIcon:setAltas("common_altas_2", "xui_common_attribute_"..16 + self.data.."_n");
	end
end

function Lua_CampIconItem:setGray(bValue)
	self.showIcon:setGray(bValue)
end

function Lua_CampIconItem:onClick(go)
	if self.owner and self.callBack then
		self.callBack(self.owner, self.data)
	end
end