-- 阵容筛选页签item
Lua_CampSiftBaseItem = class("Lua_CampSiftBaseItem", Lua_DisplayObject);
function Lua_CampSiftBaseItem:ctor(p, namePosX, colorStr, fontSize)
    self.namePosX = namePosX == nil and 0 or namePosX;
    self.colorStr = colorStr == nil and "FFFFFF" or colorStr;
    self.fontSize = fontSize == nil and 30 or fontSize;
    self:superCall("ctor", p);
end

function Lua_CampSiftBaseItem:buildShowItem()
    self:superCall("buildShowItem");

    self.show_icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
    self.show_icon:addClickFuntion(self, self.onSiftBtnClick);

    self.show_name = UICreate.createLabel(self.content, nil, self.namePosX, 0, 100, 40, self.fontSize);
    self.show_name.pivot = UIUtils.Pivot.Center;
    self.show_name.alignmentValue = 4;
    self.show_name.horizontalOverflowValue = 1;
    self.show_name.fontName = Lua_MyUISettings.huakangFontName;
    self.show_name.colorStr = Lua_ColorDefine.transColor(self.colorStr);
    self.show_name:setEnable(false);
end

function Lua_CampSiftBaseItem:dispose()
    self.show_icon = nil;
    self.show_name = nil;
    if self.redPointIcon ~= nil then
        self.redPointIcon:dispose();
        self.redPointIcon = nil;
    end
    self.owner = nil;
    self.callBack = nil;
    self.data = nil;
    self:superCall("dispose");
end

function Lua_CampSiftBaseItem:setData(data)
    self.data = data;

    self.show_icon:setAltas("common_altas_2", "xui_common_attribute_"..16 + data.."_n");
    self.show_name:setLangValue(126050 + data);
end

function Lua_CampSiftBaseItem:setClickCallBack(owner, callBack)
    self.owner = owner;
    self.callBack = callBack;
end

function Lua_CampSiftBaseItem:onSiftBtnClick(go)
    if self.data == nil then
        return;
    end

    if self.owner ~= nil and self.callBack ~= nil then
        self.callBack(self.owner, self.data);
    end
end

function Lua_CampSiftBaseItem:setSelectEnable(bSelect)
    if bSelect then
        self.show_icon:setAltas("common_altas_2", "xui_common_attribute_"..16 + self.data.."_p");
    else
        self.show_icon:setAltas("common_altas_2", "xui_common_attribute_"..16 + self.data.."_n");
    end
    self.show_name:setEnable(bSelect);
end

-- 红点
function Lua_CampSiftBaseItem:showRedPoint(bShow)
    if bShow then
        if self.redPointIcon == nil then
            self.redPointIcon = Lua_RedPointIcon.new(self.content);
            self.redPointIcon:setLocation(24, 17);
            self.redPointIcon:createRedPointEff();
        end
        self.redPointIcon:updateRedPointShow(true);
    else
        if self.redPointIcon ~= nil then
            self.redPointIcon:updateRedPointShow(false);
        end
    end
end

function Lua_CampSiftBaseItem:setIconGray(bGray)
    self.show_icon:setGray(bGray);
end