--英雄阵营筛选
checkRequire("Lua_CampSiftBaseItem")
Lua_CampSiftPanel = class("Lua_CampSiftPanel", Lua_DisplayObject)
function Lua_CampSiftPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CampSiftPanel:buildShowItem()
	self:superCall("buildShowItem")
end

-- 间距，色值，字号，大小
function Lua_CampSiftPanel:setSiftItem(spaceValue, colorStr, fontSize, scale)
	self.spaceValue = spaceValue;
	self.colorStr = colorStr;
	self.fontSize = fontSize;
	self.scale = scale;
end

--展示的数据
function Lua_CampSiftPanel:setArrayData(data)
	self.scale = self.scale == nil and 1 or self.scale;
	self.spaceValue = self.spaceValue == nil and 65 or self.spaceValue;

	self.itemArr = Array();
	self.posxArr = Array();
	self.campTypeDic = {};
	local len = data:getSize()
	local item
	local w = -(self.spaceValue * len) / 2 + self.spaceValue -- 偏移值
	local posX
	for i = 1, len do
		item = Lua_CampSiftBaseItem.new(self.content, self.spaceValue, self.colorStr, self.fontSize)

		posX = ((i - 1) % len) * self.spaceValue + w
		item:setLocation(posX, 0, 0)
		item:setScale(self.scale, self.scale);
		item:setData(data[i]);
		self.campTypeDic[data[i]] = i;
		item:setClickCallBack(self, self.onCampSelected)

		self.posxArr:add(posX);
		self.itemArr:add(item);
	end
end

function Lua_CampSiftPanel:dispose()
	if self.itemArr then
		self.itemArr:dispose()
		self.itemArr:clear()
		self.itemArr = nil
	end
	if self.posxArr then
		self.posxArr:clear()
		self.posxArr = nil
	end


	self.campLimitDic = nil
	self.campTypeDic = nil;
	self.owner = nil
	self.callBack = nil
	self:superCall("dispose")
end

function Lua_CampSiftPanel:setCallBack(owner, callBack)
	self.owner = owner
	self.callBack = callBack
end

function Lua_CampSiftPanel:setLimitCamp(campLimitDic, campLimitTips)
	self.campLimitDic = campLimitDic
	self.campLimitTips = campLimitTips
	local item
	for i = 1, self.itemArr:getSize() do
		item = self.itemArr[i]
		item:setIconGray(item.data ~= 0 and self.campLimitDic[item.data] == nil)
	end
end

function Lua_CampSiftPanel:setSelected(campType, isUpdate)
	if self.campType == campType and isUpdate ~= true then
		return
	end
	self:onCampSelected(campType);
end

function Lua_CampSiftPanel:onCampSelected(campType)
	if self.itemArr == nil then
		return
	end

	if campType ~= 0 and self.campLimitDic and self.campLimitDic[campType] == nil then
		OperateAlert.show(self.campLimitTips)
		return
	end
	local index = self.campTypeDic[campType];
	self.campType = campType
	local posX
	local item
	for i = 1, self.itemArr:getSize() do
		posX = self.posxArr[i]
		item = self.itemArr[i]
		if i > index then -- 往右移
			item:setLocation(posX + self.spaceValue / 2, item.y, 0)
		else -- 往左移
			item:setLocation(posX - self.spaceValue / 2, item.y, 0)
		end
		item:setSelectEnable(item.data == campType)
	end

	self:onCallBack()
end

function Lua_CampSiftPanel:onCallBack()
	if self.owner and self.callBack then
		self.callBack(self.owner, self.campType);
	end
end