--九宫布阵

--layout: 九宫排列方式 默认1
--1: 1 2 3  2: 3 6 9
--	 4 5 6     2 5 8
--   7 8 9     1 4 7

-- direction: 朝向
--1: 左右反方向
--1: 1 2 3  2: 9 6 3
--	 4 5 6     8 5 2
--   7 8 9     7 4 1
--2: 上下反方向
--1: 7 8 9  2: 3 6 9
--	 4 5 6     2 5 8
--   1 2 3     1 4 7
Lua_HeroGridViewPanel = class("Lua_HeroGridViewPanel", Lua_DisplayObject)
function Lua_HeroGridViewPanel:ctor(p)
	self:superCall("ctor", p)
end

function Lua_HeroGridViewPanel:buildShowItem()
	self:superCall("buildShowItem")
	self.gridNum = 10
	self:setLayout()
	self:setGridCell()
	self.bCanClick = false
end

function Lua_HeroGridViewPanel:dispose()
	if self.itemArr then
		self.itemArr:dispose()
		self.itemArr:clear()
		self.itemArr = nil
	end
	self:superCall("dispose")
end

function Lua_HeroGridViewPanel:setLayout(layout, direction)
	self.layout = layout or 1		-- layout：排列方式
	self.direction = direction or 0	-- direction：朝向 0默认 1左右反方向 2上下反方向	
end

function Lua_HeroGridViewPanel:setGridCell(cellWidth, cellHeight, cellClass)
	self.cellWidth = cellWidth or 75
	self.cellHeight = cellHeight or 75
	self.cellClass = cellClass
end

function Lua_HeroGridViewPanel:setCanClick(bCanClick)
	self.bCanClick = bCanClick
end

function Lua_HeroGridViewPanel:setRoleId(roleId, serverFlag, isRobot)
	self.roleId = roleId
	self.serverFlag = serverFlag
	self.isRobot = isRobot
end

function Lua_HeroGridViewPanel:setParams(param1, param2)
	self.param1 = param1
	self.param2 = param2
end

-- list：结构体名：ProtoShowHero
function Lua_HeroGridViewPanel:setDataByProto(list)
	self:initItem()
	if list then
		local obj
		local vo
		for i = 1,  #list do
			obj = list[i]
			if obj.pos and self.itemArr[obj.pos] and obj.hero_id and tonumber(obj.hero_id) > 0 then
				local config = Lua_HeroConfigData.getConfig(obj.hero_id)
				if config == nil then
					config = Lua_MonsterConfigData.getMonsterConfig(obj.hero_id)
					vo = Lua_HeroVo.new(config.heroId)
				else
					vo = Lua_HeroVo.new(obj.hero_id)
				end
				vo:fromServer(obj)
				vo.otherLineup = list
				self.itemArr[obj.pos]:setData(3, vo)
			end
		end
	end
end

-- list：结构体名：ProtoHeroBaseInfo
function Lua_HeroGridViewPanel:setDataByProto2(list)
	self:initItem()
	if list then
		local obj
		local vo
		for i = 1,  #list do
			obj = list[i]
			if obj.pos and self.itemArr[obj.pos] and obj.hero_id and tonumber(obj.hero_id) > 0 then
				vo = Lua_HeroVo.new(obj.hero_id)
				vo.unique_id = tonumber(obj.unique_id)
				vo.level = obj.level
				vo.quality = obj.quality
				vo.quality_star = obj.quality_star
				vo.otherLineup = list
				self.itemArr[obj.pos]:setData(4, vo)
			end
		end
	end
end

-- lineupType：布阵类型 
-- lineupIdx
function Lua_HeroGridViewPanel:setDataByLineupType(lineupType, lineupIdx)
	self:initItem()
	local vo = DataCenter.heroLineupData:getLineupVo(lineupType)
	local standArr = vo:getHeroArr(lineupIdx)
	for i = 1, standArr:getSize() do
		vo = DataCenter.heroData:getItemByUniqueId(standArr[i])
		if self.itemArr[i] and vo then
			self.itemArr[i]:setData(2, vo)
		end
	end
end

-- 配置表数据[战斗单位tb_monster配置id,站位]
function Lua_HeroGridViewPanel:setDataByConfig(list, lineupIdx)
	self:initItem()
	if list then
		list = list[lineupIdx]
		local index
		local config
		for i = 1, #list do
			index = list[i][2]
			if self.itemArr[index] ~= nil then
				config = Lua_MonsterConfigData.getMonsterConfig(list[i][1])
				self.itemArr[index]:setData(1, config.heroVo)
			end
		end
	end
end

function Lua_HeroGridViewPanel:setStandType(stand_type)
	self:initItem()
	local list = DataCenter.heroLineupUtil:getPosListByType(stand_type)
	if list then
		local standIdx
		for i = 1, #list do
			standIdx = list[i]
			if self.itemArr[standIdx] == nil then
				self.itemArr[standIdx]:setStandIdx(nil)
			else
				self.itemArr[standIdx]:setStandIdx(standIdx)
			end
		end
	end
end

function Lua_HeroGridViewPanel:initItem()
	local item
	if self.itemArr == nil then
		self.itemArr = Array()
		local cellClass = self.cellClass or Lua_HeroGridViewItem
		local posX
		local posY
		for i = 1, self.gridNum do
			item = cellClass.new(self.content)
			posX = self:getLayoutX(i)
			posY = self:getLayoutY(i)
			item:setLocation(posX, posY, 0)
			item:setIndex(i)
			item:setCanClick(self.bCanClick)
			item:setStandIdx(nil)
			item:setRoleId(self.roleId, self.serverFlag, self.isRobot)
			item:setParams(self.param1, self.param2)
			item:setData()
			self.itemArr:add(item)
		end
	else
		for i = 1, self.gridNum do
			item = self.itemArr[i]
			item:setCanClick(self.bCanClick)
			item:setStandIdx(nil)
			item:setRoleId(self.roleId, self.serverFlag, self.isRobot)
			item:setParams(self.param1, self.param2)
			item:setData()
		end
	end
end

function Lua_HeroGridViewPanel:getLayoutX(index)
	-- if self.layout == 1 then
	-- 	if self.direction == 1 then
	-- 		--暂不实现，看需求
	-- 	else
	-- 		return (index - 1) % 3 * self.cellWidth - self.cellWidth;
	-- 	end
	-- elseif self.layout == 2 then
	-- 	if self.direction == 1 then
	-- 		return -Mathf.Floor((index - 1) / 3) * self.cellWidth + self.cellWidth;
	-- 	else
	-- 		return Mathf.Floor((index - 1) / 3) * self.cellWidth - self.cellWidth;
	-- 	end
	-- end
	if index < 4 then
		return -self.cellWidth + (index - 1) * self.cellWidth
	elseif index < 8 then
		return self.cellWidth + self.cellWidth / 2 + (index - 7) * self.cellWidth
	elseif index < 11 then
		return self.cellWidth + (index - 10) * self.cellWidth
	end
	return 0
end

function Lua_HeroGridViewPanel:getLayoutY(index)
	-- if self.layout == 1 then
	-- 	if self.direction == 2 then
	-- 		return Mathf.Floor((index - 1) / 3) * self.cellHeight - self.cellHeight;
	-- 	else
	-- 		return -Mathf.Floor((index - 1) / 3) * self.cellHeight + self.cellHeight;
	-- 	end
	-- elseif self.layout == 2 then
	-- 	if self.direction == 2 then
	-- 		--暂不实现，看需求
	-- 	else
	-- 		return ((index - 1) % 3) * self.cellHeight - self.cellHeight;
	-- 	end
	-- end
	if self.direction == 2 then
		if index < 4 then
			return -self.cellHeight
		elseif index < 8 then
			return 0
		elseif index < 11 then
			return self.cellHeight
		end
	else
		if index < 4 then
			return self.cellHeight
		elseif index < 8 then
			return 0
		elseif index < 11 then
			return -self.cellHeight
		end
	end
	return 0
end


















Lua_HeroGridViewItem = class("Lua_HeroGridViewItem", Lua_DisplayObject)
function Lua_HeroGridViewItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_HeroGridViewItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_bz_widget_9", 0, 0, 0, 0)
end

function Lua_HeroGridViewItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose()
		self.itemIcon = nil
	end
	self:superCall("dispose")
end

function Lua_HeroGridViewItem:setCanClick(bCanClick)
	self.bCanClick = bCanClick
	if self.itemIcon == nil then
		return
	end
	
	if bCanClick then
		self.itemIcon:setClick(self, self.onIconClick)
	else
		self.itemIcon:setClick(nil, nil)
	end
end

function Lua_HeroGridViewItem:onIconClick()
	if self.data == nil then
		return
	end

	if self.isRobot == 1 then
		OperateAlert.showLangValue(126323)
		return
	end

	if self.dataType == 1 then -- 配置表怪物
		Lua_WindowUtil.openWin("Lua_HeroDesWindow", Lua_WinParam.ACTION_OPEN, self.data)
	elseif self.dataType == 4 then -- ProtoHeroBaseInfo
		if self.roleId and self.roleId > 0 then -- 这里指的是请求类型
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sCheckHeroInfo(self.data.unique_id, self.roleId)
		else
			Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, self.data)
		end
	else -- 布阵上阵英雄 ProtoShowHero英雄
		if self.roleId and self.roleId > 0 then -- 这里指的是角色ID
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sCheckRoleHeroInfo(self.data.unique_id, self.roleId)
		else
			Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, self.data)
		end
	end
end

function Lua_HeroGridViewItem:setIndex(idx)
	self.content.name = self.classname..idx
end

function Lua_HeroGridViewItem:setStandIdx(standIdx)

end

function Lua_HeroGridViewItem:setRoleId(roleId, serverFlag, isRobot)
	self.roleId = tonumber(roleId)
	self.serverFlag = serverFlag
	self.isRobot = isRobot
end

function Lua_HeroGridViewItem:setParams(param1, param2)

end

function Lua_HeroGridViewItem:setData(dataType, data)
	self.dataType = dataType
	self.data = data
	if data == nil then
		self.bg:setEnable(true)
		if self.itemIcon ~= nil then
			self.itemIcon:setEnable(false)
			self.itemIcon:setClick(nil, nil)
		end
	else
		self.bg:setEnable(false)
		if self.itemIcon == nil then
			self.itemIcon = Lua_ItemIcon.new(self.content)
			self.itemIcon:setScale(0.6, 0.6, 1)
		end
		self.itemIcon:setEnable(true)
		self.itemIcon:setData(data)
		if self.bCanClick then
			self.itemIcon:setClick(self, self.onIconClick)
		else
			self.itemIcon:setClick(nil, nil)
		end
	end
end










Lua_HeroGridViewItem2 = class("Lua_HeroGridViewItem2", Lua_HeroGridViewItem)
function Lua_HeroGridViewItem2:ctor(p)
	self:superCall("ctor", p)
end

function Lua_HeroGridViewItem2:buildShowItem()
	self:superCall("buildShowItem")
	self.bg:setAltas("common_altas_4", "xui_jys_widget_7")
	self.bg:SetDimensions(118, 118)
	self.bg:setScale(0.6, 0.6, 1)
end

function Lua_HeroGridViewItem2:setData(dataType, data)
	self:superCall("setData", dataType, data)
	if self.itemIcon then
		self.itemIcon:setScale(0.6, 0.6, 1)
	end
end