-- 光环图标
Lua_HeroLineupAureoleItem = class("Lua_HeroLineupAureoleItem", Lua_DisplayObject);
function Lua_HeroLineupAureoleItem:ctor(p, showType)
    self.showType = showType == nil and 1 or showType;-- 1 左侧，2右侧
    self:superCall("ctor", p,"HeroLineupAureoleItem_skin");
end

function Lua_HeroLineupAureoleItem:buildShowItem()
    self:superCall("buildShowItem");

    self.forceNum = Lua_NumberImage.new(self.content);
    self.forceNum.firstStr = "xui_zl1_number_10";
    self.forceNum.preStr = "xui_zl1_number_0";
    self.forceNum.numOffsetX = -4;
    self.forceNum.num = 0;

    if self.showType == 1 then
        self.name.pivotValue = 3;
        self.name.alignmentValue = 3;
        self.name:setLocation(47, 18, 0);
        self.force_icon:setLocation(56.5, -28, 0);
        self.forceNum:setLocation(57.5, -28, 0);
        self.forceNum.pivot = 1;
    else
        self.name.pivotValue = 5;
        self.name.alignmentValue = 5;
        self.name:setLocation(-47, 18, 0);
        self.force_icon:setLocation(-56.5, -28, 0);
        self.forceNum:setLocation(-57.5, -28, 0);
        self.forceNum.pivot = -1;
    end

    self.icon:addClickFuntion(self, self.onAureoleBtnClick);
end

function Lua_HeroLineupAureoleItem:dispose()
    if self.forceNum ~= nil then
        self.forceNum:dispose();
        self.forceNum = nil;
    end
    self:superCall("dispose");
end

function Lua_HeroLineupAureoleItem:setData(aureole_id, name, force)
    self.aureole_id = aureole_id;

    local config = DataCenter.heroLineupUtil:getAureoleConfig(aureole_id);
    if config == nil then
        self.icon:setAltas("hero_embattle", "xui_bz_button_10_n");
    else
        self.icon:setAltas(config.atlas, config.sprite);
    end

    self.name.text = name;
    self.forceNum.num = force;
end

function Lua_HeroLineupAureoleItem:onAureoleBtnClick(go)
	Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_OPEN, self.aureole_id);
end