Lua_ItemIcon = class("Lua_ItemIcon", Lua_DisplayObject);
function Lua_ItemIcon:ctor(p)
	self.itemW = 124;
	self.itemH = 124;
	self.minX = 0;
	self.maxX = 0;
	self.minY = 0;
	self.maxY = 0;
	self:superCall("ctor", p);
end

function Lua_ItemIcon:buildShowItem()
	self:superCall("buildShowItem");
	self:setRectSize(self.itemW, self.itemH)
	self.isShowBtns = false;
	self.iconBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_itembg_0", 0, 0, self.itemW, self.itemH);
	self.iconBg.name = "iconBg";
	self.iconImg = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
end

function Lua_ItemIcon:dispose()
	if self.iconEff ~= nil then
		self.iconEff:dispose();
		self.iconEff = nil;
	end
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self.iconBg = nil;
	self.iconImg = nil;
	self.campIcon = nil;
	self._txt_right_top = nil;
	self._txt_right_down = nil;
	self.strengthenLvSpr = nil;
	self.equip_lock_spr = nil;
	self.strengthenLvTxt = nil;
	self.equip_grade_spr = nil;
    if self.starArr ~= nil then
		self.starArr:dispose();
		self.starArr:clear();
		self.starArr = nil;
	end
	if self.starEffectArr ~= nil then
		self.starEffectArr:dispose();
		self.starEffectArr:clear();
		self.starEffectArr = nil;
	end
	self._data = nil;
	self.owner = nil;
	self.callBack = nil;
	self:superCall("dispose");
end

function Lua_ItemIcon:setScale(scaleX, scaleY)
	self:superCall("setScale", scaleX, scaleY)

	if self._txt_middle then
		self._txt_middle:setScale(1 / scaleX, 1 / scaleY)
		self._txt_middle.fontSize = Mathf.Ceil(24 * scaleX)
	end
	if self._txt_right_top then
		self._txt_right_top:setScale(1 / scaleX, 1 / scaleY)
		self._txt_right_top.fontSize = Mathf.Ceil(24 * scaleX)
	end
	if self._txt_right_down then
		self._txt_right_down:setScale(1 / scaleX, 1 / scaleY)
		self._txt_right_down.fontSize = Mathf.Ceil(24 * scaleX)
	end
end

function Lua_ItemIcon:setData(data)
	self._data = data;
	if data == nil then
		self.content.name = self.classname;
		self.iconBg:setAltas("common_altas_1", "xui_common_itembg_0");
		self:setIconImg(nil, nil);
		self:showNum(0);
		self:show_level(nil);
		self:showCampIcon(false);
		self:showStar(nil);
		self:showRedPoint(false);
		self:showEffect(false);
		self:setStrengthenLv(nil);
		self:setEquipGrade(nil);
		self:setEquipLock(false);
		self:showTimeTips(nil);
		self:setDoubleIcon(nil);
		self:setTrialIcon(nil);
	else
		self.content.name = data.id;
		self.iconImg.name = data.id;
		if data.color == nil then
			self.iconBg:setAltas("common_altas_1", "xui_common_itembg_0");
		else
			self.iconBg:setAltas("common_altas_1", "xui_common_itembg_"..data.color);
		end
		self:setIconImg(data.atlas, data.sprite);
		self:show_level(data.level);
		self:showNum(data.count);
		self:showCampIcon(true);
		self:showStar(data.star);
		self:showEffect(true);
		self:setEquipLock(data.lockState);
		self:setStrengthenLv(data.strengthenLv);
		self:setEquipGrade(data.equipGrade);
		self:showTimeTips(data.showTimeText);
		self:setDoubleIcon(data.show_time);
		self:setTrialIcon(data.trial_state);
	end
	self:updateSiblingIndex();
end

function Lua_ItemIcon.Get:data()
    return self._data;
end

function Lua_ItemIcon:setIconBg(atlas, sprite)
	if atlas == nil or sprite == nil then
		self.iconBg:setEnable(false);
	else
		self.iconBg:setAltas(atlas, sprite);
		self.iconBg:resetSize();
	end
end

function Lua_ItemIcon:setIconImg(atlas, sprite)
	if atlas == nil or sprite == nil then
		self.iconImg:setEnable(false);
	else
		self.iconImg:setEnable(true);
		self.iconImg:setAltas(atlas, sprite);
		self.iconImg:resetSize();
	end
end

function Lua_ItemIcon.Get:txt_middle()
	if self._txt_middle == nil then
		self._txt_middle = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 24);
		self._txt_middle.pivotValue = 4;
		self._txt_middle.fontName = Lua_MyUISettings.fangzhengFontName;
		self._txt_middle.alignmentValue = 4;
		self._txt_middle.horizontalOverflowValue = 1;
		self._txt_middle.effectStyle = 2;
		self._txt_middle.colorStr = Lua_ColorDefine.transColor("EFF1E4");
		self._txt_middle.effectColorStr = Lua_ColorDefine.transColor("424242");
		self._txt_middle:setEffectDistance(2, 2);
	end
	self._txt_middle:setScale(1 / self.scaleX, 1 / self.scaleY)
	self._txt_middle.fontSize = Mathf.Ceil(24 * self.scaleX)
	return self._txt_middle;
end

function Lua_ItemIcon.Get:txt_right_top()
	if self._txt_right_top == nil then
		self._txt_right_top = UICreate.createLabel(self.content, nil, 57, 47, 100, 31, 24);
		self._txt_right_top.pivotValue = 5;
		self._txt_right_top.alignmentValue = 5;
		self._txt_right_top.horizontalOverflowValue = 1;
		self._txt_right_top.effectStyle = 2;
		self._txt_right_top:setEffectDistance(2, 2);
	end
	self._txt_right_top:setScale(1 / self.scaleX, 1 / self.scaleY)
	self._txt_right_top.fontSize = Mathf.Ceil(24 * self.scaleX)
	if self.data ~= nil and self.data.is_resonance and self.data.is_resonance == true then -- 同调器状态
		self._txt_right_top.colorStr = Lua_ColorDefine.transColor("29CEFE");
	else
		self._txt_right_top.colorStr = Lua_ColorDefine.transColor("FFFFFF");
	end
	self._txt_right_top.effectColorStr = Lua_ColorDefine.transColor("000000");
	return self._txt_right_top;
end

function Lua_ItemIcon.Get:txt_right_down()
	if self._txt_right_down == nil then
		self._txt_right_down = UICreate.createLabel(self.content, nil, 54, -42.5, 100, 31, 24);
		self._txt_right_down.pivotValue = 5;
		self._txt_right_down.alignmentValue = 5;
		self._txt_right_down.horizontalOverflowValue = 1;
		self._txt_right_down.effectStyle = 2;
		self._txt_right_down.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self._txt_right_down.effectColorStr = Lua_ColorDefine.transColor("5F5763");
		self._txt_right_down:setEffectDistance(2, 2);
	end
	self._txt_right_down:setScale(1 / self.scaleX, 1 / self.scaleY)
	self._txt_right_down.fontSize = Mathf.Ceil(24 * self.scaleX)
	return self._txt_right_down;
end

-- 0中间 1左上 2右上 3左下 4右下
function Lua_ItemIcon:showText(pos, str)
	if strIsNullOrEmpty(str) then
		if pos == 0 then
			if self._txt_middle then
				self._txt_middle:setEnable(false)
			end
		elseif pos == 2 then
			if self._txt_right_top ~= nil then
				self._txt_right_top:setEnable(false);
			end
		elseif pos == 4 then
			if self._txt_right_down ~= nil then
				self._txt_right_down:setEnable(false);
			end
		end
	else
		if pos == 0 then
			self.txt_middle:setEnable(true)
			self.txt_middle.text = str
		elseif pos == 2 then
			self.txt_right_top:setEnable(true);
			self.txt_right_top.text = str;
		elseif pos == 4 then
			self.txt_right_down:setEnable(true);
			self.txt_right_down.text = str;
		end
	end
end

-- 右上角等级文本
function Lua_ItemIcon:show_level(level)
	level = level == nil and 0 or level;
	if level > 0 then
		self:showText(2, level);
	else
		self:showText(2, nil);
	end
end

function Lua_ItemIcon:showNum(num, mustShow)
	num = num == nil and 0 or num;
	if self.data == nil or self.data.main_type == Lua_PackDefine.TOTEM then -- 图腾
		mustShow = false;
	end
	if num > 0 and mustShow ~= false then
		self:showText(4, numberTrans(num));
	else
		self:showText(4, nil);
	end
end

-- style = 1:haveNum/needNum  style = 2:needNum/haveNum
function Lua_ItemIcon:showNumLimit(style, needNum, haveNum)
	local str;
	if style == 1 then
		if haveNum >= needNum then
			str = spliceStr("<color=#", Lua_ColorDefine.GREEN_STR, ">", haveNum, "</color>/", needNum);
		else
			str = spliceStr("<color=#", Lua_ColorDefine.RED_STR, ">", haveNum, "</color>/", needNum);
		end
	elseif style == 2 then
		if haveNum >= needNum then
			str = spliceStr("<color=#", Lua_ColorDefine.GREEN_STR, ">", needNum, "</color>/", haveNum);
		else
			str = spliceStr("<color=#", Lua_ColorDefine.RED_STR, ">", needNum, "</color>/", haveNum);
		end
	end
	self:showText(4, str);
end

-- 显示星
function Lua_ItemIcon:showStar(star)
	if self.data ~= nil then
		if self.data.isHeroSystem or self.data.main_type == Lua_PackDefine.HERO then -- 英雄
			self:showHeroStar(self.data.quality, self.data.quality_star)
			return
		end
	end

	if self.starArr ~= nil then
        for i=1,self.starArr:getSize() do
        	self.starArr[i]:setEnable(false);
        end
    end

    if star ~= nil then
        if self.starArr == nil then
            self.starArr = Array();
        end
        local item;
        local starWidth = 13;
        for i = 1, star do
            item = self.starArr[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
                self.starArr:add(item);
            end
            item:setScale(1, 1, 1);
            item:setAltas("common_altas_1", "xui_common_label_09");
        	item:resetSize();
            item:setEnable(true);
            item:setLocation(-1 * starWidth * star / 2 + starWidth * (i-1) + starWidth / 2, -54.5, 0);
        end
    end

    self:showHeroStarEffect(nil, nil)
end

function Lua_ItemIcon:showHeroStar(quality, quality_star)
    if self.starArr ~= nil then
        for i = 1, self.starArr:getSize() do
            self.starArr[i]:setEnable(false);
        end
    end

    if quality ~= nil and quality_star ~= nil and quality <= 4 and quality_star > 0  then
        if self.starArr == nil then
            self.starArr = Array();
        end
        local item;
        local starWidth = 20;
        for i = 1, quality_star do
            item = self.starArr[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
                self.starArr:add(item);
            end
            
            item:setScale(0.64, 0.64, 0.64);
            item:setAltas("common_altas_4", "xui_common_label_15");
            item:resetSize();
            item:setEnable(true);
            item:setLocation(-1 * starWidth * quality_star / 2 + starWidth * (i-1) + starWidth / 2, -45, 0);
        end
    end

    self:showHeroStarEffect(quality, quality_star);
end

function Lua_ItemIcon:showHeroStarEffect(quality, quality_star)
	if self.starEffectArr ~= nil then
        for i = 1, self.starEffectArr:getSize() do
            self.starEffectArr[i]:setEnable(false);
        end
    end

    if quality ~= nil and quality_star ~= nil and quality >= 5 and quality_star > 0  then
        if self.starEffectArr == nil then
            self.starEffectArr = Array();
        end
        local starWidth = 20;
        for i = 1, quality_star do
            local effect = self.starEffectArr[i];
            if effect == nil then
                effect = UICreate.createModelEffImg(self.content, "/effects/scsEffects/yinxiong_fire", "yinxiong_fire", 0, 0, 180, 180);
				effect:setCamField(100, 1, 100, true);
                self.starEffectArr:add(effect);
            end
            effect:setEnable(true);
            effect:setLocation(-1 * starWidth * quality_star / 2 + starWidth * (i-1) + starWidth / 2, -49, 0);
        end  
    end
end

function Lua_ItemIcon:showEffect(bValue)
	if not bValue or self.data == nil or strIsNullOrEmpty(self.data.iconEff) then
		if self.iconEff then
			self.iconEff:setEnable(false);
		end
	else
		if self.iconEff == nil then
			self.iconEff = UICreate.createUIEffect(self.content, self.data.iconEffUrl, self.data.iconEff, 0, 0)
		else
			self.iconEff:setEnable(true);
			self.iconEff:setUrl(self.data.iconEffUrl, self.data.iconEff);
		end
	end
end

-- 装备上锁
function Lua_ItemIcon:setEquipLock(bState, posX, posY)
	if bState then
		local x = posX or 48;
		local y = posY or 45;
		if self.equip_lock_spr == nil then
			self.equip_lock_spr = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_label_23", x, y, 0, 0);
		end
		self.equip_lock_spr:setLocation(x, y, 0);
		self.equip_lock_spr:setEnable(true);
	else
		if self.equip_lock_spr ~= nil then
			self.equip_lock_spr:setEnable(false);
		end
	end
end

-- 强化等级
function Lua_ItemIcon:setStrengthenLv(level)
	if level ~= nil and level > 0 then
		if self.strengthenLvTxt == nil then
			self.strengthenLvSpr = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_zb_widget_2", -33, 43, 45, 25);

			self.strengthenLvTxt = UICreate.createLabel(self.content, nil, -36, 43, 100, 31, 18);
			self.strengthenLvTxt.pivotValue = 4;
			self.strengthenLvTxt.alignmentValue = 4;
			self.strengthenLvTxt.horizontalOverflowValue = 1;
			self.strengthenLvTxt.effectStyle = 2;
			self.strengthenLvTxt.colorStr = Lua_ColorDefine.transColor("ffe688");
			self.strengthenLvTxt.effectColorStr = Lua_ColorDefine.transColor("2f2f2f");
			self.strengthenLvTxt:setEffectDistance(2, 2);
		end
		self.strengthenLvTxt.text = "+"..level;
		self.strengthenLvTxt:setEnable(true);
		self.strengthenLvSpr:setEnable(true);
	else
		if self.strengthenLvTxt ~= nil then
			self.strengthenLvSpr:setEnable(false);
			self.strengthenLvTxt:setEnable(false);
		end
	end
end

-- 装备评级
function Lua_ItemIcon:setEquipGrade(equip_grade)--待UI到位 进行完善
	if equip_grade ~= nil and equip_grade > 0 then
		if self.equip_grade_spr == nil then
			self.equip_grade_spr = UICreate.createUIAtlasImage(self.content, nil, nil, -36.5, -36, 0, 0);
		end
		self.equip_grade_spr:setAltas("common_altas_3", "xui_zb_label_"..(2+ equip_grade));
		self.equip_grade_spr:setEnable(true);
	else
		if self.equip_grade_spr ~= nil then
			self.equip_grade_spr:setEnable(false);
		end
	end
end

function Lua_ItemIcon:showTimeTips(str)
	if strIsNullOrEmpty(str) then
		if self.timeBg then
			self.timeBg:setEnable(false);
			self.timeTxt:setEnable(false);
		end
	else
		if self.timeBg == nil then
			self.timeBg = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_bb_widget_1", 0, 42, 0, 0);

			self.timeTxt = UICreate.createLabel(self.content, nil, 52, 42, 100, 31, 22);
			self.timeTxt.alignmentValue = 5;
			self.timeTxt.pivotValue = 5;
			self.timeTxt.horizontalOverflowValue = 1;
			self.timeTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
			self.timeTxt.effectStyle = 2;
			self.timeTxt.effectColorStr = Lua_ColorDefine.transColor("000000");
			self.timeTxt:setEffectDistance(2, 2);
		end
		self.timeBg:setEnable(true);
		self.timeTxt:setEnable(true);
		self.timeTxt.text = str;
	end
end

-- 设置阵营图标
function Lua_ItemIcon:setTypeIcon(campType)
	if campType ~= nil and campType > 0 then
		if self.campIcon == nil then
			self.campIcon = UICreate.createUIAtlasImage(self.content, nil, nil, -37, 37, 0, 0);
		end
		if campType == 999 then--随机图标
			self.campIcon:setAltas("common_altas_1", "xui_common_button_016");
			self.campIcon:setScale(0.9, 0.9, 0.9);
		else
			if campType >= 7 then
				campType = campType + 7;
			end
			self.campIcon:setAltas("common_altas_2", "xui_common_attribute_"..(campType + 6));
			self.campIcon:setScale(1, 1, 1);
		end
		self.campIcon:resetSize();
		self.campIcon:setEnable(true);
	else
		if self.campIcon ~= nil then
			self.campIcon:setEnable(false);
		end
	end
end

-- 展示阵营图标
function Lua_ItemIcon:showCampIcon(bShow)
	if bShow == true and self.data ~= nil then
		if self.data.main_type == Lua_PackDefine.EQUIP then--装备
			if self.data.isServerRace == true then
				self:setTypeIcon(self.data.race_camp);
			elseif self.data.isCfgRace == true then--有配置种族
				self:setTypeIcon(self.data.cfgRace);
			else
				self:setTypeIcon(nil);
			end
		else
			self:setTypeIcon(self.data.campType);
		end
	else
		self:setTypeIcon(0);
	end
end

-- 勾选遮罩
function Lua_ItemIcon:setDrawMask(bState, atlas, sprite)
	if bState then
		if self.drawMask == nil then
			atlas = atlas or "common_altas_3";
			sprite = sprite or "xui_common_label_14";
			self.drawMask = UICreate.createUIAtlasImage(self.content, atlas, sprite, 0, 0, 0, 0);
		end
		self:updateSiblingIndex();
		self.drawMask:setEnable(true);
	else
		if self.drawMask ~= nil then
			self.drawMask:setEnable(false);
		end
	end
end

-- 遮罩
function Lua_ItemIcon:setMask(bState)
	if bState then
		if self.maskIcon == nil then
			self.maskIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_mask_01", 0, 0, 0, 0);
		end
		self:updateSiblingIndex();
		self.maskIcon:setEnable(true);
	else
		if self.maskIcon ~= nil then
			self.maskIcon:setEnable(false);
		end
	end
end

-- 锁
function Lua_ItemIcon:setLock(bState, atlas, sprite)
	if bState then
		if self.lockIcon == nil then
			atlas = atlas or "common_altas_1";
			sprite = sprite or "xui_common_button_023";
			self.lockIcon = UICreate.createUIAtlasImage(self.content, atlas, sprite, 0, 0, 0, 0);
		end
		self.lockIcon:setEnable(true);
	else
		if self.lockIcon ~= nil then
			self.lockIcon:setEnable(false);
		end
	end
end

-- 红点
function Lua_ItemIcon:showRedPoint(bShow)
	if bShow then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(45, 45);
			self.redPointIcon:createRedPointEff();
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

-- 展示剪影
function Lua_ItemIcon:setShadow(bState, atlas, sprite)
	if bState then
		if self.shadowIcon == nil then
			self.shadowIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
		end
		self.shadowIcon:setAltas(atlas, sprite)
		self.shadowIcon:setEnable(true);
	else
		if self.shadowIcon ~= nil then
			self.shadowIcon:setEnable(false);
		end
	end
end

-- 多倍图标
function Lua_ItemIcon:setDoubleIcon(showNum)
	if showNum ~= nil and showNum > 1 then
		if self.doubleIcon == nil then
			self.doubleIcon = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_yzsb_label_1", 28, 41, 0, 0);
			self.doubleIcon:setScale(0.8, 0.8, 1);

			self.doubleTxt = UICreate.createLabel(self.content, nil, 32, 39, 100, 43, 30);
			self.doubleTxt:setRot(0, 0,-14);
			self.doubleTxt:setScale(0.8, 0.8, 1);
			self.doubleTxt.alignmentValue = 4;
			self.doubleTxt.fontName = Lua_MyUISettings.fangzhengFontName;
			self.doubleTxt.horizontalOverflowValue = 1;
			self.doubleTxt.colorStr = Lua_ColorDefine.transColor("FFEEB6");
			self.doubleTxt.effectStyle = 2;
			self.doubleTxt.effectColorStr = Lua_ColorDefine.transColor("C2594D");
			self.doubleTxt:setEffectDistance(3, 3);
		end
		self.doubleTxt.text = (showNum * 100).."%";
		self.doubleTxt:setEnable(true);
		self.doubleIcon:setEnable(true);
	else
		if self.doubleIcon ~= nil then
			self.doubleTxt:setEnable(false);
			self.doubleIcon:setEnable(false);
		end
	end
end


-- 试用英雄图标
function Lua_ItemIcon:setTrialIcon(val)
	if val then
		if self.trialIcon == nil then
			self.trialIcon = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_xz_label_1", 40, 15, 0, 0);
		end
		self.trialIcon:setEnable(true);
	else
		if self.trialIcon ~= nil then
			self.trialIcon:setEnable(false);
		end
	end
end

function Lua_ItemIcon:updateSiblingIndex()
	local index = self.iconImg.siblingIndex;

	if self.drawMask ~= nil then
		index = index + 1;
		self.drawMask.siblingIndex = index;
	end
	if self.equip_grade_spr ~= nil then
		index = index + 1;
		self.equip_grade_spr.siblingIndex = index;
	end
	if self.maskIcon ~= nil then
		index = index + 1;
		self.maskIcon.siblingIndex = index;
	end
	if self.starArr ~= nil then
        for i=1,self.starArr:getSize() do
        	index = index + 1;
        	self.starArr[i].siblingIndex = index;
        end
    end
	if self._txt_right_top ~= nil then
		index = index + 1;
		self._txt_right_top.siblingIndex = index;
	end
	if self._txt_right_down ~= nil then
		index = index + 1;
		self._txt_right_down.siblingIndex = index;
	end
end

function Lua_ItemIcon:setGray(val)
	if self.iconBg ~= nil then self.iconBg:setGray(val); end
	if self.iconImg ~= nil then self.iconImg:setGray(val); end
	if self._txt_right_top ~= nil then self._txt_right_top:setGray(val); end
	if self._txt_right_down ~= nil then self._txt_right_down:setGray(val); end
	if self.campIcon ~= nil then self.campIcon:setGray(val); end
	if self.starArr ~= nil then
        for i=1,#self.starArr do
        	self.starArr[i]:setGray(val);
        end
    end
end

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
-- 设置点击处理

function Lua_ItemIcon:checkInBound(touchX, touchY)
	local posX = self.posX or 0
	local posY = self.posY or 0
	local scaleX = self.scaleX or 1
	local scaleY = self.scaleY or 1
	local minX = posX - self.itemW / 2 * scaleX
	local maxX = posX + self.itemW / 2 * scaleX
	local minY = posY - self.itemH / 2 * scaleY
	local maxY = posY + self.itemH / 2 * scaleY
	if touchX >= minX and touchX <= maxX and touchY >= minY and touchY <= maxY then
		return true
	end
	return false
end

function Lua_ItemIcon:setCanClick(bValue)
	self.iconBg.clickScaleVal = -0.05
	if bValue then
		self.iconBg.mouseEnable = true;
		self.iconBg:addClickFuntion(self, self.onItemClick);
	else
		self.iconBg.mouseEnable = false;
		self.iconBg:removeClickFuntion(self, self.onItemClick);
	end
end

function Lua_ItemIcon:setClick(owner, callBack)
	self.owner = owner;
	self.callBack = callBack;
	if owner == nil or callBack == nil then
		self:setCanClick(false);
	else
		self:setCanClick(true);
	end
end

function Lua_ItemIcon.Set:isShowBtns(val)
    self._isShowBtns = val;
end

function Lua_ItemIcon.Get:isShowBtns()
    return self._isShowBtns;
end

function Lua_ItemIcon:onItemClick(go)
	if self.owner == nil or self.callBack == nil then
		DataCenter.packUtil:showItemInfo(self.data, self.isShowBtns);
	else
		self.callBack(self.owner, self.data);
	end
end