-- 界面模型场景展示（例如伙伴、主角）
Lua_ModelScenePanel = class("Lua_ModelScenePanel");
function Lua_ModelScenePanel:ctor()
	self:superCall("ctor");
	self._canRot = true;
	self.rotBgWidth = 500;
	self.rotBgHeight = 500;
	self.rotBgPosx = 0;
	self.rotBgPosy = 0;
	self.bSceneShow = false;
	self.bModelLoaded = false;
	self.bActComplete = true;
	self.stopRot = false;
	self.startDir = 0;
	self.camControllerId = getTime();
end

function Lua_ModelScenePanel.Get:rotBg()
	if self._rotBg == nil then
		self._rotBg = UICreate.createUIAtlasImage(self.parent, "common_altas_1", "black_mask", self.rotBgPosx, self.rotBgPosy, self.rotBgWidth, self.rotBgHeight);
		self._rotBg.siblingIndex = 0;
		self._rotBg.name = "rotBg";
		self._rotBg.clickScale = false;
		self._rotBg.alpha = 0.01;
		self._rotBg:addClickFuntion(self, self.onClickHandle)
		self._rotBg:addMousDownFuntion(self,self.onMouseDownHandle);
		self._rotBg:addMouseUpFuntion(self,self.onMouseUpHandle);
	end
	return self._rotBg
end

function Lua_ModelScenePanel:setParent(p)
	self.parent = p;
	if self._canRot == true then
		self.rotBg:setParent(self.parent);
		self.rotBg:SetDimensions(self.rotBgWidth, self.rotBgHeight);
		self.rotBg:setLocation(self.rotBgPosx, self.rotBgPosy);
	    self.rotBg.mouseEnable = true;
	end
end

function Lua_ModelScenePanel:dispose()
	Lua_MsgUtil.callFunc("MODEL_SCENE_HIDE", self.curShowSceneId);
	
	self.parent = nil;
	self.curShowModelIdx = -1; -- 1, frist 2 sec
	if self.firstModel ~= nil then
		self.firstModel:dispose();
		self.firstModel = nil;
	end

	if self.secModel ~= nil then
		self.secModel:dispose();
		self.secModel = nil;
	end

    self:clearTimer();
    -- ModelCameraManager.instance:changeAniController(nil);
    DataCenter.modelCameraManager:changeAniController(self.camControllerId, self.curShowSceneId, nil);
    local sceneId = DataCenter.modelCameraManager.curShowSceneId;
    if  self.oldShowSceneId ~= nil and self.oldShowSceneId > 0 and (sceneId == nil or sceneId ~= self.oldShowSceneId) then
    	Scene3DManager.instance:destroyScene(self.oldShowSceneId, 0);
    end

    if self.curShowSceneId ~= nil and self.curShowSceneId > 0 and (sceneId == nil or sceneId ~= self.curShowSceneId) then
    	Scene3DManager.instance:destroyScene(self.curShowSceneId, 0);
    end

    self.camControllerId = nil;
    self.camControllerName = nil;
	self.oldShowSceneId = nil;
	self.curShowSceneId = 0;
    self.modelTab = nil;
	self.modelLoadedFun = nil;
	self.modelAniFun = nil;
	self.sceneTab = nil;
	self.sceneShowFun = nil;
	self.sceneLoadedFun = nil;
	if self._rotBg then
		self._rotBg:dispose()
		self._rotBg = nil;
	end
	self.owner = nil;
	self.callBack = nil;
	self:superCall("dispose");
end

function Lua_ModelScenePanel:setClick(owner, callBack)
	self.owner = owner;
	self.callBack = callBack;
end

function Lua_ModelScenePanel:setModelEnable(value)
	if self.curShowModelIdx == 1 then
		if self.firstModel then
			if value == true then
				self.firstModel:setEnable(true)
			else
				self.firstModel:clearLoad()
				self.firstModel:setEnable(false)
			end
		end
	else
		if self.secModel then
			if value == true then
				self.secModel:setEnable(true)
			else
				self.secModel:clearLoad()
				self.secModel:setEnable(false)
			end
		end
	end
end

function Lua_ModelScenePanel:setRotBgPos(posx, posy)
	self.rotBgPosx = posx;
	self.rotBgPosy = posy;
	if self._rotBg ~= nil then
		self._rotBg:setLocation(posx, posy);
	end
end

function Lua_ModelScenePanel:setRotBgDimensions(w, h)
	self.rotBgWidth = w;
	self.rotBgHeight = h;
	if self._rotBg ~= nil then
		self._rotBg:SetDimensions(w, h);
	end
end

function Lua_ModelScenePanel.Set:canRot(value)
	self._canRot = value;
	if value == true then
		if self.parent ~= nil then
		    self.rotBg.mouseEnable = true;
		end
	else
		self:clearTimer();
		if self._rotBg ~= nil then
			self._rotBg.mouseEnable = false;
		end
	end
end

function Lua_ModelScenePanel:onClickHandle(go)
	if self.owner and self.callBack then
		self.callBack(self.owner);
	end    
end

function Lua_ModelScenePanel:onMouseDownHandle(go, state)
    self:onPress(go, true);
end

function Lua_ModelScenePanel:onMouseUpHandle(go, state)
    self:onPress(go, false);
end

function Lua_ModelScenePanel:onPress(go, state)
    if self.curShowModel == nil or self.stopRot == true then
        return;
    end

    if state == true then
        self.startMousePos = CommonUtil.mousePositionX;
        if self._isClick ~= true then
            self._isClick = true;
            Lua_CommonUtil.addTimer("onRotHeroModel", 0.01, self, self.onRotHeroModel);
        end
    else
        self:clearTimer();
    end
end

function Lua_ModelScenePanel:onRotHeroModel()
    local pos = CommonUtil.mousePositionX;
    local d = self.startMousePos - pos;
    self.startMousePos = pos;
    self.startDir = self.startDir + d;
    self.curShowModel:setRot(self.startDir);
end

function Lua_ModelScenePanel:clearTimer()
    if self._isClick == true then
        self._isClick = false;
        Lua_CommonUtil.removeTimer(self,self.onRotHeroModel);
    end
end

-- 当前显示的模型
function Lua_ModelScenePanel.Get:curShowModel()
	if self.curShowModelIdx == 1 then
		return self.firstModel;
	elseif self.curShowModelIdx == 2 then
		return self.secModel;
	end
	return nil;
end

-- 是否显示模型
function Lua_ModelScenePanel.Get:bShowModel()
	return self.curShowModelIdx == 1 or self.curShowModelIdx == 2;
end

-- sceneId 场景id
-- modelUrl 模型url
-- avatarName 模型资源名
-- camControllerName 模型相机节点名
function Lua_ModelScenePanel:showModelScene(sceneId, modelUrl, avatarName, camControllerName, bPlanarShadow)
	if sceneId == nil or sceneId == 0 then
        LogManager.LogError(data.id .. data.name.."未配置对应界面的场景id", true);
        return;
    end

    -- 场景
    self.bModelLoaded = false;
    self.camControllerName = camControllerName;
    if self.curShowSceneId ~= sceneId or not Scene3DManager.instance:isShowingScene(sceneId, 0) then
        self.bSceneShow = false;
        self.bSceneLoaded = false;
        local lastSceneId = self.curShowSceneId;
        self.curShowSceneId = sceneId;
        Scene3DManager.instance:OpenSceneBySceneId(sceneId, self, self.onShowScene, self.onSceneLoaded); -- 有配置则下一帧才回调
        if lastSceneId ~= nil and lastSceneId ~= self.oldShowSceneId and lastSceneId ~= sceneId then
        	if self.curShowModelIdx == 1 then
        		if self.firstModel ~= nil then
		    		self.firstModel:setSceneInfo(sceneId, 0);
		    	end
        	elseif self.curShowModelIdx == 2 then
        		if self.secModel ~= nil then
		    		self.secModel:setSceneInfo(sceneId, 0);
		    	end
        	end
	        self:destroyShowScene(lastSceneId);
	    end
    elseif self.bSceneShow then -- 已经显示完成
    	-- ModelCameraManager.instance:changeAniController(self.camControllerName); 
    	DataCenter.modelCameraManager:changeAniController(self.camControllerId, self.curShowSceneId, self.camControllerName);
    end

    -- 模型
    self:clearTimer();
    if bPlanarShadow == nil then bPlanarShadow = false; end
    if strIsNullOrEmpty(modelUrl) then -- 没有模型
    	self.bModelLoaded = true;
    	self.curShowModelIdx = -1;
    	if self.firstModel ~= nil then
    		self.firstModel:setSceneInfo(sceneId, 0);
    		self.firstModel:clearLoad();
    		self.firstModel:setEnable(false);
    	end
    	if self.secModel ~= nil then
    		self.secModel:setSceneInfo(sceneId, 0);
    		self.secModel:clearLoad();
    		self.secModel:setEnable(false);
    	end
    else
    	local url = UrlManager.fixFileSuffix(modelUrl);
    	if self.curShowModelIdx == 1 then
    		if self.firstModel.url == url then
    			if self.secModel ~= nil then -- 目的是模型对象不随场景销毁而被销毁
    				self.secModel:setSceneInfo(sceneId, 0);
		    		self.secModel:clearLoad();
		    	end
    			self.firstModel:setSceneInfo(sceneId, 0);
		    	self.firstModel.bPlanarShadow = bPlanarShadow;
    			self.firstModel:setFullUrl(url, avatarName, modelName, nil);
    		else
    			if self.firstModel ~= nil then
    				self.firstModel:setSceneInfo(sceneId, 0);
		    		self.firstModel:clearLoad();
		    	end

    			self.curShowModelIdx = 2;
    			if self.secModel ~= nil then
	    			self.secModel:setSceneInfo(sceneId, 0);
	    		else
	    			self.secModel = ModelEffComponent(sceneId, 0);
		        	self.secModel:setLuaCallBack(self, self.onSecLoadedModel, self.onSecModelAniComplete);
	    		end
	    		self.secModel.bPlanarShadow = bPlanarShadow;
				self.secModel:setFullUrl(url, avatarName, modelName, nil);
    		end
    	elseif self.curShowModelIdx == 2 then
    		if self.secModel.url == url then
    			if self.firstModel ~= nil then
    				self.firstModel:setSceneInfo(sceneId, 0);
		    		self.firstModel:clearLoad();
		    	end

    			self.secModel:setSceneInfo(sceneId, 0);
    			self.secModel.bPlanarShadow = bPlanarShadow;
    			self.secModel:setFullUrl(url, avatarName, modelName, nil);
    		else
    			if self.secModel ~= nil then
    				self.secModel:setSceneInfo(sceneId, 0);
		    		self.secModel:clearLoad();
		    	end

    			self.curShowModelIdx = 1;
    			if self.firstModel ~= nil then
	    			self.firstModel:setSceneInfo(sceneId, 0);
	    		else
	    			self.firstModel = ModelEffComponent(sceneId, 0);
		        	self.firstModel:setLuaCallBack(self, self.onFirstLoadedModel, self.onFirstModelAniComplete);
	    		end
	    		self.firstModel.bPlanarShadow = bPlanarShadow;
				self.firstModel:setFullUrl(url, avatarName, modelName, nil);
    		end
    	else
    		self.curShowModelIdx = 1;
    		if self.firstModel ~= nil then
    			self.firstModel:setSceneInfo(sceneId, 0);
    		else
    			self.firstModel = ModelEffComponent(sceneId, 0);
	        	self.firstModel:setLuaCallBack(self, self.onFirstLoadedModel, self.onFirstModelAniComplete);
    		end
    		self.firstModel.bPlanarShadow = bPlanarShadow;
        	self.firstModel:setFullUrl(url, avatarName, modelName, nil);
    	end
    end

    if self.bSceneShow and not self.bModelLoaded then -- 如果场景已显示完成，需要隐藏旧的
    	if self.curShowModelIdx == 1 then
    		if self.secModel ~= nil then
    			self.secModel:setEnable(false);
    		end
    	elseif self.curShowModelIdx == 2 then
    		if self.firstModel ~= nil then
    			self.firstModel:setEnable(false);
    		end
    	end
    end
end

function Lua_ModelScenePanel:onShowScene(sceneId)
    if sceneId == self.curShowSceneId then
        -- ModelCameraManager.instance:changeAniController(self.camControllerName); 
        DataCenter.modelCameraManager:changeAniController(self.camControllerId, self.curShowSceneId, self.camControllerName);
        if not strIsNullOrEmpty(self.camControllerName) then
	        local cfg = Lua_SceneConfigData.getSceneConfig(sceneId);
			if cfg ~= nil then
				local uiSceneCam = cfg.uiSceneCam;
				local px = (uiSceneCam ~= nil and #uiSceneCam > 0) and uiSceneCam[1] or 0;
				local py = (uiSceneCam ~= nil and #uiSceneCam > 1) and uiSceneCam[2] or 0;
				local pz = (uiSceneCam ~= nil and #uiSceneCam > 2) and uiSceneCam[3] or 0;
				local rx = (uiSceneCam ~= nil and #uiSceneCam > 3) and uiSceneCam[4] or 0;
				local ry = (uiSceneCam ~= nil and #uiSceneCam > 4) and uiSceneCam[5] or 180;
				local rz = (uiSceneCam ~= nil and #uiSceneCam > 5) and uiSceneCam[6] or 0;
				ModelCameraManager.instance:setCamInfo(px, py, pz, rx, ry, rz);
			end
		end

		self.bSceneShow = true;
		self:destroyShowScene(self.oldShowSceneId);
        self.oldShowSceneId = self.curShowSceneId;
		self:checkShowCompleted();
        if self.sceneTab ~= nil and self.sceneShowFun ~= nil then
			self.sceneShowFun(self.sceneTab, sceneId);
		end
		Lua_MsgUtil.callFunc("MODEL_SCENE_SHOW", self.curShowSceneId);
    end
end

function Lua_ModelScenePanel:onSceneLoaded(sceneId)
	print("Lua_ModelScenePanel:onSceneLoaded", sceneId);
	if sceneId == self.curShowSceneId then
        self.bSceneLoaded = true;
        if self.sceneTab ~= nil and self.sceneLoadedFun ~= nil then
			self.sceneLoadedFun(self.sceneTab, sceneId);
		end
    end
end

function Lua_ModelScenePanel:destroyShowScene(sceneId)
	if sceneId ~= nil and sceneId > 0 then
		local cfg = Lua_SceneConfigData.getSceneConfig(sceneId);
		if cfg ~= nil and cfg.bControllDispose then
			Scene3DManager.instance:destroyScene(sceneId, 0);
		end
	end
end

function Lua_ModelScenePanel:onFirstLoadedModel()
	if self.curShowModelIdx == 1 then -- 当前显示
		self.bModelLoaded = true;
	    self:checkShowCompleted();
	    if self.modelTab ~= nil and self.modelLoadedFun ~= nil then
			self.modelLoadedFun(self.modelTab);
		end
	else
		self.firstModel:setEnable(false);
	end
end

function Lua_ModelScenePanel:onFirstModelAniComplete()
	if self.curShowModelIdx == 1 then
	    self.bActComplete = true;
	    if not strIsNullOrEmpty(self.nextActName) then
	    	self:setActionName(self.nextActName);
	    elseif self.nextAct ~= nil then 
	    	self:setModelAct(self.nextAct);
	    end

	    if self.modelTab ~= nil and self.modelAniFun ~= nil then
			if not strIsNullOrEmpty(self.modelActName) then
				self.modelAniFun(self.modelTab, self.modelActName);
			elseif self.modelAct ~= nil and self.modelAct > 0 then
				self.modelAniFun(self.modelTab, self.modelAct);
			end
		end
	end
end

function Lua_ModelScenePanel:onSecLoadedModel()
	if self.curShowModelIdx == 2 then --当前显示
	    self.bModelLoaded = true;
	    self:checkShowCompleted();
	    if self.modelTab ~= nil and self.modelLoadedFun ~= nil then
			self.modelLoadedFun(self.modelTab);
		end
	else
		self.secModel:setEnable(false);
	end
end

function Lua_ModelScenePanel:onSecModelAniComplete()
	if self.curShowModelIdx == 2 then
	    self.bActComplete = true;
	    if not strIsNullOrEmpty(self.nextActName) then
	    	self:setActionName(self.nextActName);
	    elseif self.nextAct ~= nil then 
	    	self:setModelAct(self.nextAct);
	    end

	    if self.modelTab ~= nil and self.modelAniFun ~= nil then
			if not strIsNullOrEmpty(self.modelActName) then
				self.modelAniFun(self.modelTab, self.modelActName);
			elseif self.modelAct ~= nil and self.modelAct > 0 then
				self.modelAniFun(self.modelTab, self.modelAct);
			end
		end
	end
end

function Lua_ModelScenePanel:checkShowComplete(bCheckModelLoaded)
	if not self.bSceneShow then
		return false;
	end
	if bCheckModelLoaded then
		return  self.bModelLoaded;
	end
	return true;
    -- return self.bSceneShow and self.bModelLoaded; 
end

function Lua_ModelScenePanel:checkShowCompleted()
	-- 场景模型都加载完成则显示场景
	if self.bSceneShow then 
		if self.bModelLoaded then
			local model = nil;
			if self.curShowModelIdx == 1 then
				model = self.firstModel;
				if self.secModel ~= nil then
					self.secModel:setEnable(false);
				end
			elseif self.curShowModelIdx == 2 then
				model = self.secModel;
				if self.firstModel ~= nil then
					self.firstModel:setEnable(false);
				end
			end

			if model ~= nil then
				model:setEnable(false);
				model:setEnable(true);
				if self.modelAct ~= nil then
				    self:setModelAct(self.modelAct, self.nextAct, self.stopRot);
				elseif self.modelActName ~= nil then
				    self:setActionName(self.modelActName, self.nextActName, self.stopRot);
			    end

			    if self.modelDir ~= nil then 
			    	model:setRot(self.modelDir);
			    	self.startDir = self.modelDir;
			    	self.modelDir = nil;
			    end
			    if self.modelScale ~= nil then
			    	model:setScale(self.modelScale);
			    end
			end
		else -- 场景好了，模型没好，则把旧的隐藏
			if self.curShowModelIdx == 1 then
				if self.secModel ~= nil then
					self.secModel:setEnable(false);
				end
			elseif self.curShowModelIdx == 2 then
				if self.firstModel ~= nil then
					self.firstModel:setEnable(false);
				end
			end
		end
	else
		if self.bModelLoaded then -- 模型先加好需要等场景
			if self.curShowModelIdx == 1 then
				self.firstModel:setEnable(false);
			elseif self.curShowModelIdx == 2 then
				self.secModel:setEnable(false);
			end
		end
	end
end

function Lua_ModelScenePanel:setModelDir(dir)
	if dir == nil then dir = 0; end
    self.modelDir = dir;
    if self.curShowModel ~= nil and self.bModelLoaded then
    	self.startDir = dir;
    	self.modelDir = nil;
    	self.curShowModel:setRot(dir);
    end
end

function Lua_ModelScenePanel:setModelAct(act, nextAct, bStopRot)
	self.stopRot = bStopRot ~= nil and bStopRot or false;
	self.nextAct = nextAct;
	self.modelAct = act;
	local curModel = self.curShowModel;
	if curModel ~= nil and self.bModelLoaded and self.bSceneShow then
		if act ~= nil and act > 0 then
	        curModel:setAction(act);
	        if not strIsNullOrEmpty(self.camControllerName) then
		        ModelCameraManager.instance:setAction(act);
		    end
	        self.bActComplete = false;
	    else
	    	act = 0;
	        curModel:setAction(0);
	        if not strIsNullOrEmpty(self.camControllerName) then
		        ModelCameraManager.instance:setAction(0);
		    end
	        self.bActComplete = true;
	        self.stopRot = false;
	        self.nextAct = nil;
	    end

		local list = self:getEffListByActId(act);
		if list ~= nil then
			if list.typeof ~= nil and list:typeof() == "Array" then
				for i = 1, list:getSize() do
					curModel:addHangerEff(list[i]);
				end
			else
				for i = 1, #list do
					curModel:addHangerEff(list[i]);
				end
			end
		end
    end
end

function Lua_ModelScenePanel:setModelScale(value)
	value = value or 1
	self.modelScale = value
	if self.curShowModel ~= nil and self.bModelLoaded then
		self.curShowModel:setScale(value)
	end
end

function Lua_ModelScenePanel:setActionName(actName, nextActName, bStopRot)
	self.stopRot = bStopRot ~= nil and bStopRot or false;
	self.nextActName = nextActName;
	self.modelActName = actName;
	if self.curShowModel ~= nil and self.bModelLoaded and self.bSceneShow then
		if strIsNullOrEmpty(self.modelActName) then
	        self.curShowModel:setActionName(Lua_ThingDefine.UIWAIT_STR);
	        if not strIsNullOrEmpty(self.camControllerName) then
		        ModelCameraManager.instance:setAction(Lua_ThingDefine.UIWAIT_STR);
		    end
	        self.bActComplete = true;
	        self.nextActName = nil;
	        self.stopRot = false;
	    else
	        self.curShowModel:setActionName(actName);
	        if not strIsNullOrEmpty(self.camControllerName) then
		        ModelCameraManager.instance:setActionName(actName);
		    end
	        self.bActComplete = false;
	    end
    end
end

function Lua_ModelScenePanel:addSceneCallBack(tab, showFun, loadedFun)
	if tab == nil then
		return;
	end

	if showFun == nil and loadedFun == nil then
		return;
	end

	self.sceneTab = tab;
	self.sceneShowFun = showFun;
	self.sceneLoadedFun = loadedFun;
	if self.bSceneShow and self.sceneShowFun then
		self.sceneShowFun(self.sceneTab, sceneId);
	end
	if self.bSceneLoaded and self.sceneLoadedFun then
		self.sceneLoadedFun(self.sceneTab, sceneId);
	end
end

function Lua_ModelScenePanel:addModelCallBack(tab, loadedFun, aniCompleteFun)
	if tab == nil then
		return;
	end

	if loadedFun == nil and aniCompleteFun == nil then
		return;
	end

	self.modelTab = tab;
	self.modelLoadedFun = loadedFun;
	self.modelAniFun = aniCompleteFun;
	if self.bModelLoaded and self.modelLoadedFun then
		self.modelLoadedFun(self.modelTab);
	end
	if self.bActComplete and self.modelAniFun then
		if not strIsNullOrEmpty(self.modelActName) then
			self.modelAniFun(self.modelTab, self.modelActName);
		elseif self.modelAct ~= nil and self.modelAct > 0 then
			self.modelAniFun(self.modelTab, self.modelAct);
		end
	end
end

function Lua_ModelScenePanel:addActIdEffs(actId, effAvatarName)
	if self.effActDic == nil then
		self.effActDic = {};
	end
	self.effActDic[actId] = effAvatarName;
end

-- 根据动作id获取播放特效
function Lua_ModelScenePanel:getEffListByActId(act)
	if self.effActDic == nil then
		return nil;
	end
	if act == nil then
		act = self.modelAct;
	end
	if act == 0 then -- 待机
		act = Lua_ThingDefine.UIWAIT;
	end
	return self.effActDic[act];
end