-- 数字键盘
Lua_NumericKeyboardWindow = class("Lua_NumericKeyboardWindow", Lua_Window);
function Lua_NumericKeyboardWindow:ctor()
	self:superCall("ctor");

	self.w = 260;
	self.h = 330;
	self.layer = MainWinDefine.TIPS_WINDOW_LAYER;
	self.windowName = "Lua_NumericKeyboardWindow";
	self.showBlackMask = true;
	self.blackAlpha = 0.01;
	self.isStickTop = false;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_009";
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_NumericKeyboardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.curNum = 0;
	self.minNum = 0;
	self.maxNum = 0;

	local arr = Array();
	arr:add(7);
	arr:add(8);
	arr:add(9);
	arr:add(4);
	arr:add(5);
	arr:add(6);
	arr:add(1);
	arr:add(2);
	arr:add(3);
	arr:add(0);
	arr:add(LanUtil.getValue(309031));
	arr:add(LanUtil.getValue(309032));

	self.numList = Lua_DragList.new(self.content, 231, 295, Lua_AxisDefine.Vertical);
	self.numList.canDrag = false;
	self.numList:setListCell(Lua_NumericKeyboardItem, 72, 70, 3);
	self.numList:setCellSpacing(5, 5);
	self.numList:setArrayData(arr);

	self:addLuaEvent("NUMBER_INOUT_CLICK", self, self.onNumberClick);
end

function Lua_NumericKeyboardWindow:dispose()
	if self.numList ~= nil then
		self.numList:dispose();
		self.numList = nil;
	end
	self.owner = nil;
	self.callBack = nil;
	self:superCall("dispose");
end

function Lua_NumericKeyboardWindow:showWin(param)
	self:superCall("showWin", param);
	LuaUtil.setObjPos(self.content, param.posX, param.posY, 0);
	self.curNum = param.curNum;
	self.minNum = param.minNum;
	self.maxNum = param.maxNum;
	self.owner = param.owner;
	self.callBack = param.callBack;
end

function Lua_NumericKeyboardWindow:onNumberClick(data)
	if data.state == 0 then -- 删除
		self.curNum = Mathf.Floor(self.curNum / 10);
		self:updateInputNum(false);
	elseif data.state == 1 then -- 关闭
		self:updateInputNum(true);
		self:hide();
	elseif data.state == 2 then -- 数字
		self.curNum = self.curNum * 10 + tonumber(data.num);
		self:updateInputNum(true);
	end
end

function Lua_NumericKeyboardWindow:updateInputNum(checkBorder)
	if checkBorder == true then
		local num = self.curNum;
		if self.curNum < self.minNum then
			num = self.minNum;
		elseif self.curNum > self.maxNum then
			num = self.maxNum;
		end
		self.curNum = num;
	end

	if self.owner ~= nil and self.callBack ~= nil then
		self.callBack(self.owner, self.curNum);
	end
end




















Lua_NumericKeyboardItem = class("Lua_NumericKeyboardItem", Lua_ListCell);
function Lua_NumericKeyboardItem:ctor(p)
	self:superCall("ctor", p);
	self.state = 1;
end
function Lua_NumericKeyboardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.numImg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_039_n", 0, 0, 0, 0);

	self.numText = UICreate.createLabel(self.content, nil, 0, 0, 50, 50, 30);
	self.numText.pivot = Lua_WindowUtil.getPivot(4);
	self.numText.alignmentValue = 4;
end

function Lua_NumericKeyboardItem:dispose()
	self:superCall("dispose");
end

function Lua_NumericKeyboardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.numText.text = data;
	if data == LanUtil.getValue(309031) then
		self.numText.fontSize = 22;
	elseif data == LanUtil.getValue(309032) then
		self.numText.fontSize = 22;
	end
end

function Lua_NumericKeyboardItem:onPressClick()
	local data = {};
	if self.data == LanUtil.getValue(309031) then
		data.state = 0;
	elseif self.data == LanUtil.getValue(309032) then
		data.state = 1;
	else
		data.state = 2;
		data.num = self.data;
	end
	Lua_MsgUtil.callFunc("NUMBER_INOUT_CLICK", data);
end