Lua_RotAction = class("Lua_RotAction");
function Lua_RotAction:ctor(sp)
	self.actObject = sp;
	self.startRot = 0;
end

-- speed, allRot 需要同符号
function Lua_RotAction:setParams(speed, allRot, owner, callBack)
	self.speed = speed;
	self.allRot = allRot;
	self.owner = owner;
	self.callBack = callBack;
end

function Lua_RotAction:onEnterFrame()
	if self.startCircle == true then
		local pt = getTime() - self.startTime;
		if self.runTime <= pt then
			self.curRot = self.startRot + self.allRot;
			self.startCircle = false;
			if self.owner ~= nil and self.callBack ~= nil then
				self.callBack(self.owner);
			end
			Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
		else
			self.curRot = self.startRot + self.startSpeed * pt - self.speed * pt * pt / 2;
		end
		LuaUtil.setObjRot(self.actObject.mainContent, 0, 0, self.curRot);
	end
end

function Lua_RotAction:setRot(val)
	self.startRot = val;
	LuaUtil.setObjRot(self.actObject.mainContent, 0, 0, val);
end

function Lua_RotAction:start()
	self.runTime = Mathf.Sqrt(2 * self.allRot / self.speed);
	self.startSpeed = self.runTime * self.speed;
	self.curRot = 0;
	self.startRot = 0;
	self.startTime = getTime();
	self.startCircle = true;
	Lua_CommonUtil.addTimer("Lua_RotAction", 0.01, self, self.onEnterFrame);
end

function Lua_RotAction:stop()
	Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
end

function Lua_RotAction:dispose()
	self:stop();
	self.owner = nil;
	self.callBack = nil;
	self.actObject = nil;
	self.startCircle = false;
end