-- 文本描述拖拽
Lua_TextArea = class("Lua_TextArea", Lua_DisplayObject);
function Lua_TextArea:ctor(p, width, height)
	self.areaWidth = width;
	self.areaHeight = height;
	self:superCall("ctor", p);
end

function Lua_TextArea:buildShowItem()
	self:superCall("buildShowItem");
	self:setRectSize(self.areaWidth, self.areaHeight);

	self.areaContainer = Lua_DragContainer.new(self.content, self.areaWidth, self.areaHeight, Lua_AxisDefine.Vertical);
	self.areaContainer:setMaskOffect(5, 0) -- 文本会被裁剪
end

function Lua_TextArea:setText(str, fontSize, lineSpacing, wordSpacing, colorStr)
	local data = { width = self.areaWidth, h = self.areaHeight, str = str, 
		fontSize = (fontSize == nil) and 22 or fontSize,
		lineSpacing = (lineSpacing == nil) and 1 or lineSpacing,
		wordSpacing = (wordSpacing == nil) and 0 or wordSpacing,
		colorStr = (colorStr == nil) and "FFFFFF" or colorStr
	 };
	self.areaContainer:clearList();
	self.areaContainer:addSubContainer(Lua_TextAreaItem, data, true, 5); -- 文本会被裁剪
	self.areaContainer:moveToIndex(1, true);
	self.areaContainer.canDrag = not self.areaContainer.isTheEnd;
end

function Lua_TextArea:dispose()
	if self.areaContainer ~= nil then
		self.areaContainer:dispose();
		self.areaContainer = nil;
	end
	self:superCall("dispose");
end





















Lua_TextAreaItem = class("Lua_TextAreaItem", Lua_DragContainerItem);
function Lua_TextAreaItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TextAreaItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_TextAreaItem:dispose()
	self:superCall("dispose");
end

function Lua_TextAreaItem:getWidth()
	if self.textField == nil then
		return 0;
	end
	return self.textField.width;
end

function Lua_TextAreaItem:getHeight()
	if self.textField == nil then
		return 0;
	end
	return self.textField.height;
end

function Lua_TextAreaItem:setData(data)
	if self.textField == nil then
		self.textField = UICreate.createLabel(self.content, nil, 0, 0, 0, 0, 22);
	end
	self.textField:SetDimensions(data.width, 0)
	self.textField.fontSize = data.fontSize
	self.textField.lineSpacing = data.lineSpacing
	self.textField.verticalOverflowValue = 1;
	self.textField.wordSpacing = data.wordSpacing
	self.textField.colorStr = Lua_ColorDefine.transColorStr(data.colorStr)
	self.textField.text = data.str;
	self.textField:resetSize();
end