--联盟系统 联盟Data
checkRequire("Lua_AllianceInfoVo");
checkRequire("Lua_AllianceMemberVo");
checkRequire("Lua_AllianceScienceConfigVo");
checkRequire("Lua_AllianceScienceTypeVo");
checkRequire("Lua_AllianceBossStageVo");
checkRequire("Lua_AllianceTreasuryVo");
checkRequire("Lua_AllianceRedPacketVo");
checkRequire("Lua_AllianceDealTypeVo");
Lua_AllianceData = class("Lua_AllianceData");

--联盟职位
Lua_AllianceData.DUTY_TYPE = {
    COMMANDER = 1,--会长
    VICE_COMMANDER = 2,--副会长
    ELITE_MEMBER = 3,--精英
    GENERAL_MEMBER = 4,--普通成员
};
--联盟操作
Lua_AllianceData.OPERATION_TYPE = {
    AUTH_VICE_COMMANDER = 1,--授权副会长
    AUTH_ELITE_POSITION = 2,--授权精英职位
    AUTH_GENERAL_MEMBER = 3,--授权普通成员
    EXPEL_ALLIANCE = 4,--逐出联盟
    APPLY_HANDEL = 5,--申请处理
    HADN_OVER = 6,--移交会长
    MODIF_NOTICE = 7,--修改公告
    ENTER_ACTIVITY = 8,--报名活动
    DISMISS = 9,--解散
    MODIF_HEAD = 10,--修改头像
    SET_LEAGUE_INFO = 11,--设置联盟信息
    OPEN_LEAGUE_DARE = 12,--开启联盟挑战
    VIEW_MEMBER_INFO = 13,--查看成员信息
    EXIT_LEAGUE = 14,--自愿退出联盟
    MASS_LEAGUE_MAIL = 15,--群发邮件
    BOSS_ASSEMBLY = 16,--Boss集结号角
};
--红包主类型
Lua_AllianceData.RED_PACKET_MAIN_TYPE = {
	LEAGUE = 1,--联盟红包
	WELFARE = 2,--福利红包
};
--宝库主类型
Lua_AllianceData.TREASURY_TYPE = {
	ITEM = 1,--1:道具
	CHIP = 2,--2:碎片
	EQUIP = 3,--3:装备
	RUNE = 4,--4:符文
};
--科技显示节点
Lua_AllianceData.SCIENTCE_POINT_NUM = 6;

function Lua_AllianceData:ctor()
	self:dispose();
end

function Lua_AllianceData:dispose()
	if self.topLogList ~= nil then
		self.topLogList:dispose();
		self.topLogList:clear();
		self.topLogList = nil;
	end

	self.myLeagueInfo = nil;
	self.curTreasuryType = nil;
	self.myContribTime = 0;

	self._redStateDic = nil;
	self._scienceInfoDic = nil;

	self.leagueRedPacketNum = 0;
	self.welfareRedPacketNum = 0;

	self.lastQuitTick = 0;

	self:disposeAllianceList();
	self:clearAllPlayRedPacket();

	self.curSelectType = 1;
	self.selectHeroVo = nil;
	self.selectHeroDic = {};
	self.convertHeroUid = nil;
end

function Lua_AllianceData:disposeAllianceList()
	self.leagueList = nil;
	self.leagueListArr = nil;
	self.leagueLimitArr = nil;
	self.leagueSearchArr = nil;
	self.leagueSearchLimitArr = nil;
end

function Lua_AllianceData.Get:isOpenKuafu()
	return DataCenter.funcOpenData:isOpened(10251);
end















-------------------------------主界面-------------------------------

function Lua_AllianceData:fromServer50106001(msg)--请求联盟列表(返回)
	if self.leagueList == nil then
		self.leagueList = {};
		self.leagueListArr = Array();
		self.leagueLimitArr = Array();
	end

	self.lastQuitTick = tonumber(msg.last_quit_tick);
	self.isPageEnd = msg.is_last_num == 1; -- 是否是最后一页 1：是最后一页 0：不是

	local vo;
	for k, v in ipairs(msg.league_list) do
		vo = self.leagueList[v.id];
		if vo == nil then
			vo = Lua_AllianceInfoVo.new(v);
			self.leagueList[v.id] = vo;
		else
			vo:fromServer(v);
		end
		
		if not vo.isMaxMember then
			self.leagueLimitArr:add(vo);
		end
		self.leagueListArr:add(vo);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_LIST");
end

function Lua_AllianceData:fromServer50106032(msg)--请求联盟搜索(返回)
	self.leagueSearchArr = Array();
	self.leagueSearchLimitArr = Array();

	local vo;
	for k, v in ipairs(msg.league) do
		vo = self.leagueList[v.id];
		if vo == nil then
			vo = Lua_AllianceInfoVo.new(v);
			self.leagueList[v.id] = vo;
		else
			vo:fromServer(v);
		end
		
		if not vo.isMaxMember then
			self.leagueSearchLimitArr:add(vo);
		end
		self.leagueSearchArr:add(vo);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_SEARCH_LIST");
end

function Lua_AllianceData:fromServer50106004(msg)--请求申请加入联盟(返回)
	local vo;
	for k, v in ipairs(msg.league_info) do
		vo = self.leagueList[v.id];
		if vo ~= nil then
			vo.hasApply = v.has_apply;
		end
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_LIST");
end

function Lua_AllianceData:fromServer50106002(msg)--请求联盟界面信息(返回)
	if self.myLeagueInfo == nil then
		self.myLeagueInfo = Lua_AllianceInfoVo.new();
	end
	self.myLeagueInfo:fromServer(msg.league);--联盟信息
	self.leaderInfoList = msg.leader_info;
	self.active_value = msg.active_value;

	if self.topLogList ~= nil then
		self.topLogList:dispose();
		self.topLogList:clear();
		self.topLogList = nil;
	end
	self.topLogList = Array();
	for k, v in ipairs(msg.log_list) do--日志列表
		self.topLogList:add(v);
	end

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
end

function Lua_AllianceData:fromServer50106018(msg)--请求联盟群发邮件返回
	if self.myLeagueInfo ~= nil then
		self.myLeagueInfo.leftMailNum = msg.left_mail_num; -- 剩余群发邮件次数
	end
end

function Lua_AllianceData:fromServer80106009(msg)--通知玩家联盟信息
	if self.myLeagueInfo == nil then
		self.myLeagueInfo = Lua_AllianceInfoVo.new();
	end
	print("更新类型："..msg.type)
	local types = msg.type;
	if types == 1 then--1.联盟头像变化
		self.myLeagueInfo.head = msg.league_info.head;
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
	elseif types == 2 then--2.联盟等级变化
		-- self.myLeagueInfo.level = msg.league_info.level;
		-- self.myLeagueInfo.buildExp = msg.league_info.build_val;
		DataCenter.roleData.league_level = msg.league_info.level;
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetAllianceInfo();
		-- Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
	elseif types == 5 then--5.联盟职位变化 
		DataCenter.roleData.league_position = msg.league_position;
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_POSITION");
	elseif types >= 3 and types <= 8 and types ~= 5 then--3.加入联盟 4.退出联盟 6.创建联盟 7.踢出联盟通知 8.解散联盟通知
		if types == 7 then
			OperateAlert.show(LanUtil.formateStr(201252, self.myLeagueInfo.name));
		end

		self.myLeagueInfo:fromServer(msg.league_info);
		DataCenter.roleData:updateAllianceInfo(self.myLeagueInfo.id, self.myLeagueInfo.name, msg.league_position, self.myLeagueInfo.level);
		Lua_MsgUtil.callFunc("CHECK_LEAGUE_INFO");

		if types == 3 or types == 6 then
			if DataCenter.funcOpenData:isOpened(10287) then -- 刷新交易行红点
            	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealEntrance();
        	end
		elseif types == 4 or types == 7 or types == 8 then
			Lua_MsgUtil.callFunc("CLOSE_LEAGUE_OTHER_WINDOW");
		end

		self:updateRedPoint(); -- 刷新公会科技红点
		self:checkDealRedPoint(); -- 刷新公会交易行红点
	elseif types == 9 then -- 联盟活跃度更新
		self.active_value = msg.active_value;
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_ACTIVE_VALUE");
	elseif types == 10 then -- 通知联盟建设值更新
		self.myLeagueInfo.buildExp = msg.league_info.build_val;
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
	end
end

function Lua_AllianceData:fromServer80106066(msg)--更新红点
	if self._redStateDic == nil then
		self._redStateDic = {};
	end
	for k, v in ipairs(msg.red_state_list) do
		self._redStateDic[v.key] = v.value; -- value: 1：有红点 0：没有红点
	end

	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueRedPacketRob, self:getRedDotState(1));
	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueRedPacketWelfare, self:getRedDotState(6));

	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueCompeteNum, self:getRedDotState(2)); -- 挑战次数和抢夺次数
	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueCompeteLogUpdate, self:getRedDotState(4));
	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueCompeteLogSluff, self:getRedDotState(7)); -- 公会对抗回抢

	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueGrowth, self:getRedDotState(3));
	
	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.LeagueBoss, self:getRedDotState(5));
end

function Lua_AllianceData:getRedDotState(key)
	if self._redStateDic == nil then
		return 0;
	end
	if self._redStateDic[key] == nil then
		self._redStateDic[key] = 0;
	end
	return self._redStateDic[key];
end


















-------------------------------成员管理-------------------------------

function Lua_AllianceData:fromServer50106008(msg)--请求解散联盟(返回)
	self.myLeagueInfo.startDiscussTick = tonumber(msg.start_dismiss_tick);
	Lua_MsgUtil.callFunc("START_DISMISS_LEAGUE");
end

function Lua_AllianceData:fromServer50106010(msg)--请求联盟成员列表(返回)
	self.memberArr = Array();
	self.memberList = {};

	local vo;
	local viceLeaderNum = 0;
	local eliteNum = 0;
	for k, v in ipairs(msg.member_list) do
		vo = Lua_AllianceMemberVo.new(v);
		self.memberArr:add(vo);
		self.memberList[tonumber(vo.roleId)] = vo;

		if vo.position == Lua_AllianceData.DUTY_TYPE.VICE_COMMANDER then
			viceLeaderNum = viceLeaderNum + 1;
		elseif vo.position == Lua_AllianceData.DUTY_TYPE.ELITE_MEMBER then
			eliteNum = eliteNum + 1;
		end
	end
	self.memberArr:sort("sort", true);
	self.viceLeaderCount = viceLeaderNum;
	self.eliteCount = eliteNum;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");
end

function Lua_AllianceData:fromServer50106005(msg)--请求联盟申请审核(返回)
	-- 申请信息
	self:updataApplyList(msg.apply_member_info);

	-- 社区人数已满
	local limitNum = msg.is_over_limit;
	if limitNum ~= nil and limitNum == 1 then
		OperateAlert.showLangValue(201139);
	end

	-- 玩家已在其他联盟
	if msg.join_other_league_role_list ~= nil and #msg.join_other_league_role_list > 0 then
		for i = 1, #msg.join_other_league_role_list do
			OperateAlert.showLangValue(201233);
		end
	end

	if self.myLeagueInfo ~= nil then
		self.myLeagueInfo.memberAmount = msg.member_num; -- 成员数量
		self.myLeagueInfo.force = tonumber(msg.force); -- 联盟战力
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
	end
end

function Lua_AllianceData:fromServer50106007(msg)--请求逐玩家出联盟(返回)
	local vo = self.memberList[tonumber(msg.member_id)];
	if vo ~= nil then
		self.memberArr:removeItem(vo);
		self.memberList[tonumber(msg.member_id)] = nil;
	end
	if self.myLeagueInfo ~= nil then
		self.myLeagueInfo.memberAmount = msg.member_num; -- 成员数量
		self.myLeagueInfo.force = tonumber(msg.force); -- 联盟战力
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");
end

function Lua_AllianceData:fromServer50106011(msg)--请求任命成员职务(返回)
	local vo = self.memberList[tonumber(msg.member_info.member_id)];
	if vo ~= nil then
		if vo.position == Lua_AllianceData.DUTY_TYPE.VICE_COMMANDER then
			self.viceLeaderCount = self.viceLeaderCount - 1;
		elseif vo.position == Lua_AllianceData.DUTY_TYPE.ELITE_MEMBER then
			self.eliteCount = self.eliteCount - 1;
		end

		vo.position = msg.member_info.member_position;

		if vo.position == Lua_AllianceData.DUTY_TYPE.VICE_COMMANDER then
			self.viceLeaderCount = self.viceLeaderCount + 1;
		elseif vo.position == Lua_AllianceData.DUTY_TYPE.ELITE_MEMBER then
			self.eliteCount = self.eliteCount + 1;
		end
	end
	self.memberArr:sort("sort", true);
	OperateAlert.showLangValue(201143);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");
end

function Lua_AllianceData:fromServer50106012(msg)--请求转让会长(返回)
	local vo;
    for k, v in ipairs(msg.member_info) do
    	vo = self.memberList[tonumber(v.member_id)];
    	if vo ~= nil then
    		vo.position = v.member_position;
    	end
    end
	self.memberArr:sort("sort", true);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");

	OperateAlert.showLangValue(201253);
end

function Lua_AllianceData:updataApplyList(data)--更新联盟申请列表
	local arr = Array();
	local vo;
	for k, v in ipairs(data) do--申请列表
		vo = Lua_AllianceMemberVo.new(v);
		arr:add(vo);
	end
	arr:sort("sortTime", true);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_APPLYLIST", arr);
end

function Lua_AllianceData:fromServer50106015(msg)--请求联盟日志列表(返回)
	local LogList = {};
	for k, v in ipairs(msg.log_list) do--日志列表
		if LogList[v.type] == nil then
			LogList[v.type] = Array();

			if LogList[0] == nil then
				LogList[0] = Array();
			end
		end
		LogList[0]:add(v);
		LogList[v.type]:add(v);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_LOGLIST", LogList);
end

function Lua_AllianceData:fromServer50106028(msg)--请求联盟设置返回
	self.myLeagueInfo.levelCond = msg.level_cond;
	self.myLeagueInfo.forceCond = msg.force_cond;
	self.myLeagueInfo.autoJoin = msg.auto_join;
	self.myLeagueInfo.declaration = msg.declaration;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_INFO");
end

function Lua_AllianceData.Get:getCurLevelVo()
	if self.myLeagueInfo == nil then 
		return nil;
	end
	return self.myLeagueInfo.curLevelVo;
end

function Lua_AllianceData:getCurDutyPower(type)
	return DataCenter.allianceUtil:getDutyPower(DataCenter.roleData.league_position, type);
end























-------------------------------联盟排名-------------------------------

function Lua_AllianceData:fromServer50106017(msg)--请求联盟排行信息返回
	self.curPage = msg.num; -- 第几页
	self.isPageEnd = msg.is_last_num == 1; -- 是否是最后一页 1：是最后一页 0：不是

	if self.curPage == 1 then
		self.leagueRankArr = Array();
	end
	for k, v in ipairs(msg.league_list) do
		self.leagueRankArr:add(v);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_RANK", msg);
end




















-------------------------------联盟科技-------------------------------

function Lua_AllianceData:updateScienceInfo(msg, isPlayEff)--请求联盟科技界面(返回)
	self.isPlayEff = isPlayEff;
	if msg.science_type ~= nil then
		if not self.isPlayEff or not self:checkSaveScience(msg) then
			self:setScienceInfoDic(msg);
		end
	else
		for i = 1, #msg do
			self:setScienceInfoDic(msg[i]);
		end
	end
	self:updateRedPoint();
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_SCIENCEINFO");
end

function Lua_AllianceData:resetScienceInfo(msg)
	self:updateScienceInfo(msg.league_science, false);

	-- 刷新公会交易行
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealEntrance();
end

function Lua_AllianceData:checkSaveScience(msg)
	local index = DataCenter.allianceUtil:getScienceNode(msg.science_id);
	if index == Lua_AllianceData.SCIENTCE_POINT_NUM then
		self._saveScienceMsg = msg;
		return true;
	end
	return false;
end

function Lua_AllianceData:refreshLastScienceInfo()
	if self._saveScienceMsg ~= nil then
		self:setScienceInfoDic(self._saveScienceMsg);
		self._saveScienceMsg = nil;
	end
end

function Lua_AllianceData:setScienceInfoDic(msg)
	if self._scienceInfoDic == nil then
		self._scienceInfoDic = {};
	end

	local _type = msg.science_type;
	if self._scienceInfoDic[_type] ~= nil then
		self._scienceInfoDic[_type]:fromServer(msg);
	else
		self._scienceInfoDic[_type] = Lua_AllianceScienceTypeVo.new(msg);
	end
end

function Lua_AllianceData:getScienceInfo(_type)
	if self._scienceInfoDic ~= nil then
		return self._scienceInfoDic[_type];
	end
	return nil;
end

function Lua_AllianceData:updateRedPoint()
	if self._scienceInfoDic ~= nil then
		local isJoin = DataCenter.roleData:isJoinTheLeague();
		local redDotId;
		for k, v in pairs(self._scienceInfoDic) do
			redDotId = DataCenter.allianceUtil:getScienceRedDot(k);
			DataCenter.redPointData:updateRedPointState(redDotId, isJoin and v:updateRedState());
		end
	end
end
























-------------------------------联盟Boss-------------------------------

function Lua_AllianceData:fromServer50106023(msg)--请求联盟BOSS界面(返回)
	self.showId = msg.show_id;--显示的关卡id
	self.topId = msg.top_id;--当前最高可挑战关卡id
	self.topState = msg.top_state;--当前最高关卡状态 0：未通关 1:已通关
	self.leftBlood = tonumber(tostring(msg.left_blood));--显示关卡的剩余血量
	self.maxBlood = tonumber(tostring(msg.max_blood));--boss最大血量
	self.leftTimes = msg.left_times;--剩余次数
	self.leftBuyTimes = msg.left_buy_times;--剩余可购次数
	self.lastHurt = msg.last_hurt;--上一轮挑战伤害
	self.buffAdd = msg.buff_add;--buff加成百分比
	self.buffLast = msg.buff_last;--buff剩余时间 单位秒
	self.coolEndTick = msg.cool_end_tick;--号角冷却结束时间
	self.topFight = msg.top_fight;--本人今日是否有挑战过当前最高关卡， 0 没有，1有
	self.rankList = msg.rank_list;--伤害前三
	self.is_have_kill = msg.is_have_kill; -- 是否击杀过本章boss 0未击杀过 1击杀过

	self.bossStageInfo = Lua_AllianceBossStageVo.new(self.showId);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSINFO");
end

function Lua_AllianceData:fromServer50106024(msg)--请求联盟BOSS的伤害排行(返回)
	self.rankStageId = msg.stage_id;
	self.leftPraiseNum = msg.left_praise_num;
	self.myBossHurtInfo = msg.self_rank;

	self.bossHurtArr = Array();
	self.bossHurtList = {};
	local vo;
	for k, v in ipairs(msg.rank_list) do
		vo = {};
		vo.rank = v.rank;
		vo.playerId = tonumber(v.player_id);
		vo.playerName = v.player_name;
		vo.headIcon = v.head_icon;
		vo.hurt = v.hurt;
		vo.fightRecordId = tonumber(v.fight_record_id);
		vo.praiseNum = tonumber(v.praise_num);
		vo.isPraised = v.is_praised;--是否有点赞 0未点赞 1已点赞
		self.bossHurtArr:add(vo);
		self.bossHurtList[vo.playerId] = vo;
	end
	self.bossHurtArr:sort("rank", false);

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSHURTRANK");
end

function Lua_AllianceData:fromServer50106026(msg)--请求联盟BOSS扫荡(返回)
	if self.showId ~= msg.stage_id then
		self.bossStageInfo = Lua_AllianceBossStageVo.new(msg.stage_id);
	end
	
	self.showId = msg.stage_id;
	self.topId = msg.top_stage_id;
	self.leftBlood = tonumber(tostring(msg.boss_left_blood));
	self.maxBlood = tonumber(tostring(msg.max_blood));
	self.leftTimes = msg.left_free_times;
	self.leftBuyTimes = msg.left_buy_times;
	self.rankList = msg.rank_list;
	self.lastHurt = msg.last_hurt;
	self.buffAdd = msg.buff_add;
	self.buffLast = msg.buff_add_expired_tick;
	self.is_have_kill = msg.is_have_kill;

	OperateAlert.show(LanUtil.formateStr(201180, msg.boss_hurt));

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSINFO");
end

function Lua_AllianceData:fromServer80106027(msg)--通知boss挑战结果
	if self.showId ~= msg.stage_id then
		self.bossStageInfo = Lua_AllianceBossStageVo.new(msg.stage_id);
	end
	
	self.showId = msg.stage_id;
	self.topId = msg.top_stage_id;
	self.leftBlood = tonumber(tostring(msg.left_blood));
	self.maxBlood = tonumber(tostring(msg.max_blood));
	self.leftTimes = msg.left_free_time;
	self.leftBuyTimes = msg.left_buy_time;
	self.coolEndTick = msg.cool_end_tick;
	self.buffAdd = msg.buff_add;
	self.buffLast = msg.buff_add_expired_tick;
	self.rankList = msg.rank_role_list;
	self.lastHurt = msg.boss_hurt;--boss伤害
	self.is_have_kill = msg.is_have_kill;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSINFO");
end

function Lua_AllianceData:fromServer50106030(msg)--请求联盟boss次数购买(返回)
	self.leftTimes = msg.left_free_times;
	self.leftBuyTimes = msg.left_buy_times;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSINFO");
end

function Lua_AllianceData:fromServer50106031(msg)--请求联盟boss集结(返回)
	self.coolEndTick = msg.cool_end_tick;--号角冷却结束时间
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_MASSCOOL");
end

function Lua_AllianceData:fromServer50106034(msg)--请请求增加联盟boss的buff效果(返回)
	self.buffAdd = msg.buff_add;
	self.buffLast = msg.buff_expired_tick;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSBUFF");
end

function Lua_AllianceData:fromServer50106036(msg)--请求伤害排行点赞返回
	self.leftPraiseNum = msg.left_praise_num;

	local vo;
	if self.bossHurtList ~= nil then
		vo = self.bossHurtList[tonumber(msg.role_id)];
	end
	if vo ~= nil then
		vo.praiseNum = tonumber(msg.praise_num);
		vo.isPraised = 1;--是否有点赞 0未点赞 1已点赞
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_BOSSHURTRANK");
end




















-------------------------------联盟成长-------------------------------

function Lua_AllianceData:fromServer50106038(msg)--请求联盟成长信息返回
	self.dailyBuildVal = msg.daily_build_val;--今日建设值
	self.weekBuildVal = msg.week_build_val;--本周建设值

	self.lvlRewardList = {};
	for k, v in ipairs(msg.lvl_reward) do --等级奖励 key:等级 value:0:不可领取 1可领取 2已领取
		self.lvlRewardList[v.key] = v;
	end

	self.taskTimeArr = {};
	for k, v in ipairs(msg.build_task_info) do--建设任务信息 key：任务Id value：完成次数
		self.taskTimeArr[v.key] = v.value;
	end

	self:updateContribInfo(msg.contrib_info);

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_GROWUPINFO");
end

function Lua_AllianceData:fromServer50106019(msg)--请求联盟捐献(返回)
	OperateAlert.showLangValue(201258);
end

function Lua_AllianceData:fromServer50106020(msg)--请求联盟领取捐献累积礼包(返回)
	self:updateContribInfo(msg.league_contrib);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REWARDGIFT");
end

function Lua_AllianceData:updateContribInfo(msg)
	self.curContribValue = msg.league_contrib;--联盟贡献值

	self.myContribTime = 0;--捐献次数
	if self.myContribInfo == nil then
		self.myContribInfo = {};--贡献信息
	end
	for k, v in ipairs(msg.contrib_info) do
		self.myContribInfo[v.key] = v.value;
		self.myContribTime = self.myContribTime + v.value;
	end
	self.isContribLimit = self.myContribTime >= DataCenter.allianceUtil:getConstConfig("daily_contri_limit", 1);--是否达到每日捐献上限

	if self.contribRewardInfo == nil then
		self.contribRewardInfo = {};--贡献奖励领取信息
	end
	for k, v in ipairs(msg.daily_contrib_reward) do
		self.contribRewardInfo[v.key] = v.value;
	end
end

function Lua_AllianceData:updateLevelRewardInfo(msg)
	self.lvlRewardList[msg.cur_lvl_reweard.key] = msg.cur_lvl_reweard;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_LEVELREWARD");
end

function Lua_AllianceData.Get:getCurLevelReward()
	if self.lvlRewardList ~= nil then
		local noReward = nil;
		local hasReward = nil;
		local lastReward = nil;
		for k, v in pairs(self.lvlRewardList) do
			if v.value == 0 and noReward == nil then
				noReward = v;
			elseif v.value == 1 and hasReward == nil then
				hasReward = v;
			end
			lastReward = v;
		end

		if hasReward ~= nil then
			return hasReward;
		elseif noReward ~= nil then
			return noReward;
		else
			return lastReward;
		end
	end
	return nil;
end

function Lua_AllianceData:levelRewardState(level)
	local state = 0;
	if self.lvlRewardList ~= nil and self.lvlRewardList[level] then
		state = self.lvlRewardList[level].value;
	end
	return state;
end






























-------------------------------联盟宝库-------------------------------

function Lua_AllianceData:updateAllianceTreasuryInfo(msg)--请求联盟宝库信息返回
	local id;
	local vo;
	local treasuryVoList = {};
	self.treasuryNumList = {};
	for k, v in ipairs(msg.goods_info) do
		id = v.item.id;
		vo = Lua_AllianceTreasuryVo.new(id);
		vo:fromServer(v);

		if treasuryVoList[id] == nil then
			treasuryVoList[id] = Array();
		end
		treasuryVoList[id]:add(vo);

		if self.treasuryNumList[id] == nil then
			self.treasuryNumList[id] = 0;
		end
		self.treasuryNumList[id] = self.treasuryNumList[id] + 1;
	end

	self.treasuryLog = msg.transaction_record;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_TREASURY_INFO", treasuryVoList);
end

function Lua_AllianceData:showAllianceTreasuryItemInfo(msg)--请求联盟宝库商品信息返回
	local vo;
	if msg.treasury_type == Lua_AllianceData.TREASURY_TYPE.EQUIP then
		vo = Lua_ToolVo.new(msg.equip_info.id);
		vo:fromServer(msg.equip_info);
	elseif msg.treasury_type == Lua_AllianceData.TREASURY_TYPE.RUNE then
		vo = Lua_ToolVo.new(msg.rune_info.id);
		vo:fromServer(msg.rune_info);
	end

	if vo ~= nil then
		DataCenter.packUtil:showItemInfo(vo, false);
	end
end





















-------------------------------联盟红包-------------------------------

function Lua_AllianceData:fromServer80106037(msg)--通知联盟红包有联盟红包可领
	if self.playRedPacketArr == nil then
		self.playRedPacketArr = Array();
		self.playRedPacketList = {};
	end

	local uid = tonumber(msg.red_pack_uid); 
	if msg.is_draw_done == 0 then
		if self.playRedPacketList[uid] == nil and DataCenter.sceneData.curSceneId == Lua_SceneDefine.MAINCITY 
			and Lua_WindowUtil.isWindowShowing("Lua_MainMenuWindow") then

			self.playRedPacketArr:add(uid);
			self.playRedPacketList[uid] = msg;
			Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REDPACKET_NOTICE");
		end
	else
		self:removePlayRedPacket(uid, true);
	end
end

function Lua_AllianceData:removePlayRedPacket(uid, isSend)
	if self.playRedPacketList ~= nil and self.playRedPacketList[uid] ~= nil then
		self.playRedPacketArr:removeItem(uid);
		self.playRedPacketList[uid] = nil;

		if isSend then
			Lua_MsgUtil.callFunc("REMOVE_LEAGUE_REDPACKET", uid);
		end
	end
end

function Lua_AllianceData:getPlayRedPacketArr()
	if self.playRedPacketArr ~= nil and self.playRedPacketArr:getSize() > 0 then
		local isCheck1 = self:getRedPacketLeftNum(Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE) <= 0;
		local isCheck2 = self:getRedPacketLeftNum(Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE) <= 0;
		if isCheck1 or isCheck2 then
			local arr = Array();
			local data;
			for i = 1, self.playRedPacketArr:getSize() do
				data = self:getPlayRedPacketInfo(self.playRedPacketArr[i]);
				if (isCheck1 and data.red_pack_type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE)
					or (isCheck2 and data.red_pack_type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE) then
					arr:add(self.playRedPacketArr[i]);
				end
			end

			for i = 1, arr:getSize() do
				self:removePlayRedPacket(arr[i], false);
			end
		end
	end
	return self.playRedPacketArr;
end

function Lua_AllianceData:getPlayRedPacketInfo(uid)
	if self.playRedPacketList ~= nil and self.playRedPacketList[uid] ~= nil then
		return self.playRedPacketList[uid];
	end
	return nil;
end

function Lua_AllianceData:clearAllPlayRedPacket()
	self.playRedPacketArr = nil;
	self.playRedPacketList = nil;
end

function Lua_AllianceData:fromServer50106047(msg)--请求联盟红包信息返回
	self.robRedPacketArr = Array();
	local vo;
	for k, v in ipairs(msg.red_pack_info) do
		vo = Lua_AllianceRedPacketVo.new(v.red_pack_conf_id, v.red_pack_type);
		vo:updateRobInfo(v);
		self.robRedPacketArr:add(vo);
	end

	local info = msg.left_red_pack_draw_times;
	for i = 1, #info do
		if info[i].key == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
			self.leagueRedPacketNum = info[i].value;
		elseif info[i].key == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
			self.welfareRedPacketNum = info[i].value;
		end
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_ROB_REDPACKET");
end

function Lua_AllianceData:fromServer50106049(msg)--请求领取联盟红包返回
	if self.robRedPacketArr ~= nil then
		for i = 1, self.robRedPacketArr:getSize() do
			if self.robRedPacketArr[i].redPackUid == tonumber(msg.red_pack_uid) then
				self.robRedPacketArr[i].state = msg.draw_state;
				break;
			end
		end
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_ROB_REDPACKET");
	end
	self:removePlayRedPacket(tonumber(msg.red_pack_uid), true);
end

function Lua_AllianceData:updateAllianceRedPacket(msg)--更新联盟红包信息
	local arr = Array();
	local vo;
	for k, v in ipairs(msg) do
		vo = Lua_AllianceRedPacketVo.new(v.key, Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE);
		vo:updateSendInfo(v);
		arr:add(vo);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REDPACKET", arr);
end

function Lua_AllianceData:updateWelfareRedPacket(msg)--更新福利红包信息
	local arr = DataCenter.allianceUtil:getWelfareRedPacketArr();
	for i = 1, arr:getSize() do
		arr[i]:dispose();
	end

	local vo;
	for k, v in ipairs(msg) do
		vo = DataCenter.allianceUtil:getWelfareRedPacketVo(v.key);
		vo:updateSendInfo(v);
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_WELFARE_REDPACKET");
end

function Lua_AllianceData:fromServer80106067(msg)
	local lastNum;
	if msg.key == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
		lastNum = self.leagueRedPacketNum;
		self.leagueRedPacketNum = msg.value;
	elseif msg.key == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
		lastNum = self.welfareRedPacketNum;
		self.welfareRedPacketNum = msg.value;
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REDPACKET_LEFT_NUM");

	if lastNum ~= 0 and msg.value == 0 then
		Lua_MsgUtil.callFunc("REFRESH_LEAGUE_REDPACKET_NOTICE");
	end
end

function Lua_AllianceData:getRedPacketLeftNum(types)
	if types == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
		return self.leagueRedPacketNum;
	elseif types == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
		return self.welfareRedPacketNum;
	end
	return 0;
end



























-------------------------------联盟挑战-------------------------------

function Lua_AllianceData:fromServer50106051(msg)--请求开启联盟挑战返回
	self.challengeId = msg.challenge_id;--联盟挑战id

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceChallenge(0);
end

function Lua_AllianceData:fromServer50106052(msg)--更新联盟挑战界面
	self.challengeId = msg.challenge_id;--联盟挑战id
	self.challengeStartTick = msg.challenge_start_tick;--挑战开始时间
	self.challengeLeftBlood = msg.boss_left_blood;--boss剩余血量
	self.lastChallengeHurt = msg.last_challenge_hurt;--上次挑战伤害
	self.challengeRanklist = msg.role_list;--伤害前三
	self.leftFreeTimes = msg.left_free_times;--剩余免费次数
	self.leftBuyTimes = msg.left_buy_times;--剩余购买次数
	self:updateChallengRewardInfo(msg.blood_reward_info);
	
	if tonumber(self.challengeId) == 0 then
		local defaultChallengeId;
		if self.challengeType ~= nil then
			defaultChallengeId = DataCenter.allianceUtil:getChallengeDefaultId(self.challengeType);
		else
			defaultChallengeId = DataCenter.allianceUtil:getChallengeDefaultId(1);
		end

		self.challengeInfo = DataCenter.allianceUtil:getChallengeConfigVo(defaultChallengeId);
		self.isOpenChallenge = false;
	else
		self.challengeInfo = DataCenter.allianceUtil:getChallengeConfigVo(self.challengeId);
		self.isOpenChallenge = self.judgeChallengeOpen;
	end
	self.challengeType = self.challengeInfo.boss_type;

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_INFO");
end

function Lua_AllianceData:fromServer50106056(msg)--请求联盟挑战扫荡返回
	self.challengeStartTick = msg.challenge_start_tick;--挑战开始时间
	self.challengeLeftBlood = msg.boss_left_blood;--boss剩余血量
	self.challengeRanklist = msg.role_list;--伤害前三
	self.leftFreeTimes = msg.left_free_times;--剩余免费次数
	self.leftBuyTimes = msg.left_buy_times;--剩余购买次数
	self:updateChallengRewardInfo(msg.blood_reward_info);

	self.isOpenChallenge = self.judgeChallengeOpen;
	
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_INFO");
end

function Lua_AllianceData:fromServer80106057(msg)--通知联盟挑战信息
	self.challengeId = msg.challenge_id;--联盟挑战id
	self.challengeLeftBlood = msg.boss_left_blood;--boss剩余血量
	self.lastChallengeHurt = msg.boss_hurt;--boss伤害
	self.challengeRanklist = msg.role_list;--伤害前三
	self.leftFreeTimes = msg.left_free_times;--剩余免费次数
	self.leftBuyTimes = msg.left_buy_times;--剩余购买次数
	self:updateChallengRewardInfo(msg.boss_blood_reward );

	self.challengeInfo = DataCenter.allianceUtil:getChallengeConfigVo(self.challengeId);
	self.challengeType = self.challengeInfo.boss_type;

	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_INFO");
end

function Lua_AllianceData:fromServer50106059(msg)--购买联盟挑战次数返回
	self.leftFreeTimes = msg.left_free_times;--剩余免费次数
	self.leftBuyTimes = msg.left_buy_times;--剩余购买次数
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_INFO");
end

function Lua_AllianceData:fromServer50106060(msg)--请求弹劾联盟主管返回
	local obj;
	local vo;
	for i = 1, #msg.member_info do
		obj = msg.member_info[i];
		vo = self.memberList[tonumber(obj.member_id)];
		if vo ~= nil then
			vo.position = obj.member_position;
		end
	end
	self.memberArr:sort("sort", true);
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEMEMEBER_INFO");
end

function Lua_AllianceData:updateChallengRewardInfo(msg)--更新联盟挑战奖励信息
	self.challengeRewardInfo = {};
	for k, v in ipairs(msg) do
		self.challengeRewardInfo[v.key] = v.value;
	end
end

function Lua_AllianceData.Get:judgeChallengeOpen()
	if self.challengeStartTick ~= nil and self.challengeStartTick ~= 0 then
		local time = DataCenter.roleData.serverTime - self.challengeStartTick;
		if time <= DataCenter.allianceUtil:getConstConfig("league_challenge_tick", 1) then
			return true;
		end
	end
	return false;
end














-------------------------------公会对抗-------------------------------

function Lua_AllianceData:fromServer50106062(msg)--请求公会对抗信息返回
	self.competeStage = msg.stage; --阶段 1：对抗期 2：休赛期
	self.competeJoinType = msg.join_ype; --1.参与公会对抗 2.本周创建的对抗未能参与 3.不满足活跃条件未能参数
	self.competeEndTick = msg.stage_end_tick; --阶段结束时间
	self.competeFightNum = msg.left_fight_times; --剩余挑战次数
	self.competeGrabNum = msg.left_grab_times; --剩余抢夺次数
	self.competeSluffbNum = msg.left_recapture_times; --剩余回抢次数
	self.competeBossId = msg.boss_id; --BossId
	self.competeMyRank = msg.self_rank; --自己排名信息
	self.competeUsInfo = msg.self_league_info; --己方公会对抗排行信息
	self.competeMatchInfo = msg.match_league_info; --匹配的公会对抗排行信息
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_INFO");
end

function Lua_AllianceData:fromServer50106063(msg)--请求公会对抗日志返回
	self.competeLogType = msg.type;
	self.competeLogList = msg.log_list;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_LOG");
end

function Lua_AllianceData:fromServer50106064(msg)--请求公会对抗伤害排名返回
	self.isPageEnd = msg.is_end;
	self.competeUsInfo = msg.self_rank;
	self.competeMatchInfo = msg.match_rank;
	self.competeHurtList = msg.rank_list;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_RANK");
end

function Lua_AllianceData:fromServer50106065(msg)--请求公会对抗成员排名信息返回
	self.competeRankList = msg.rank_list;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_HURT");
end

function Lua_AllianceData:fromServer50106068(msg)
	if msg.result == 0 then
		if Lua_WindowUtil.isOpenWin("Lua_LeagueDuelLineupWindow") then return end

		self.enemyId = msg.grab_player_id;
		self.enemyFlag = msg.server_flag;

		local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELROB);
		DataCenter.preLoadData:preShowScene("Lua_LeagueDuelLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
	else
		if msg.result == 1 then
			OperateAlert.showLangValue(201310);
		elseif msg.result == 2 then
			OperateAlert.showLangValue(201311);
		elseif msg.result == 3 or msg.result == 6 then
			OperateAlert.showLangValue(201312);
		elseif msg.result == 4 then
			OperateAlert.showLangValue(201314);
		elseif msg.result == 5 then
			OperateAlert.showLangValue(201315);
		end
	end
end

function Lua_AllianceData:onSceneShow(param)
	DataCenter.preLoadData:removeBySign("Lua_LeagueDuelLineupWindow", self, self.onSceneShow);

	local list = { template_id = Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELROB, enemyId = self.enemyId, 
				enemyFlag = self.enemyFlag, grabType = self.grabType, recordId = self.recordId };
	Lua_WindowUtil.openWin("Lua_LeagueDuelLineupWindow", Lua_WinParam.ACTION_OPEN, list);
end

function Lua_AllianceData:setGrabInfo(roleId, recordId)
	self.grabType = tonumber(tostring(roleId)) == DataCenter.roleData.roleId and 2 or 1;
	self.recordId = recordId;
end

function Lua_AllianceData.Get:isDailyHurt()
	return DataCenter.allianceUtil:getConstConfig("combat_fight_times", 1) > self.competeFightNum;
end
























-------------------------------公会交易行-------------------------------

function Lua_AllianceData:fromServer50208001(msg)
	local arr = self.getDealTypeArr;
	for i = 1, arr:getSize() do
		arr:dispose();
	end

	local info = msg.transaction_times_info;
	for i = 1, #info do
		arr[info[i].type]:fromServer(info[i]);
	end
	self.activeNum = msg.active_value;
	self:checkDealRedPoint();
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_ENTRANCE");
end

function Lua_AllianceData.Get:getDealTypeArr()
	if self._dealTypeArr == nil then
		self._dealTypeArr = Array();
		local config = getConfig("league_transaction_type");
		local vo;
		for i = 1, #config do
			vo = Lua_AllianceDealTypeVo.new(i, config[i]);
			self._dealTypeArr:add(vo);
		end
	end
	return self._dealTypeArr;
end

function Lua_AllianceData.Get:getCurTypeInfo()
	return self.getDealTypeArr[self.curSelectType];
end

function Lua_AllianceData:fromServer50208002(msg)
	self.dealHeroNumDic = {};
	local info = msg.hero_info; 
	for i = 1, #info do
		self.dealHeroNumDic[tonumber(info[i].key)] = info[i].value;
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_INFO");
end

function Lua_AllianceData:getBuyHeroArr(campType)
	local arr = Array();
	local idArr = DataCenter.allianceUtil:getDealHeroIdArr(self.curSelectType, campType);
	local num;
	local sort;
	for i = 1, idArr:getSize() do
		num = self.dealHeroNumDic[idArr[i]];
		if num == nil then
			num = 0;
		end
		if num > 0 then
			sort = i - 1000;
		else
			sort = i;
		end
		arr:add({id = idArr[i], num = num, sort = sort});
		arr:sort("sort", false);
	end
	return arr;
end

function Lua_AllianceData:getDealPackHeroArr(campType)
    local duelArr = DataCenter.allianceUtil:getDealHeroIdArr(self.curSelectType, campType);
    local uidArr;
    local heroVo;
    local arr = Array();
    local selectId = self.selectHeroVo ~= nil and self.selectHeroVo.id or 0;
    for i = 1, duelArr:getSize() do
        uidArr = DataCenter.heroData:getHeroUidArrById(duelArr[i]);
        if uidArr ~= nil then
            for j = 1, uidArr:getSize() do
                heroVo = DataCenter.heroData:getItemByUniqueId(uidArr[j]);
                if heroVo ~= nil and heroVo.id ~= selectId
                	and heroVo.isCultivateStar == false and heroVo.is_league_transaction == false and not heroVo.trial_state
                    and (campType == Lua_HeroUtil.All_TYPE or heroVo.campType == campType) then
                    arr:add(heroVo);
                end
            end
        end
    end
    return arr;
end

function Lua_AllianceData:fromServer50208003(msg)
	if #msg.role_list > 0 then
		Lua_WindowUtil.openWin("Lua_AllianceDealSellListWindow", Lua_WinParam.ACTION_OPEN, msg.role_list);
	else
		OperateAlert.showLangValue(201425);
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealInfo(self.curSelectType, Lua_HeroUtil.All_TYPE);
	end
end

function Lua_AllianceData:fromServer50208004(msg)
	if msg.result == 1 then
		local vo = self.getDealTypeArr[msg.type];
		if vo ~= nil then
			vo.leftTime = msg.left_times;
		end
		self.activeNum = msg.active_value;

		OperateAlert.showLangValue(201426);
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealInfo(self.curSelectType, Lua_HeroUtil.All_TYPE);
	end
end

function Lua_AllianceData:fromServer50208005(msg)
	if msg.result == 1 then
		OperateAlert.showLangValue(201427);
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealPlanInfo(self.curSelectType);
	else
		OperateAlert.showLangValue(201428);
	end
end

function Lua_AllianceData:fromServer50208006()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueDealPlanInfo(self.curSelectType);
end


function Lua_AllianceData:fromServer50208007(msg)
	self.schemeList = msg.scheme_list;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_PLAN");
end

function Lua_AllianceData:fromServer50208009(msg)
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_LOG", msg.log_list);
end

function Lua_AllianceData:fromServer80208011(msg)
	local vo = self.getDealTypeArr[msg.type];
	if vo ~= nil then
		vo.leftTime = msg.left_times;
	end
	self.schemeList = msg.scheme_list;
	self.activeNum = msg.active_value;
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_REDRESH");
end

function Lua_AllianceData:isHeroRacking(heroId)
	for i = 1, #self.schemeList do
		if tonumber(self.schemeList[i].require_hero) == heroId then
			return true;
		end
	end
	return false;
end

function Lua_AllianceData:isHeroSelect(unique_id)
	local typeInfo = self.getCurTypeInfo;
	for i = 1, typeInfo.sell_hero_num do
		if self.selectHeroDic[i] ~= nil and self.selectHeroDic[i].unique_id == unique_id then
			return true;
		end
	end
	return false;
end

function Lua_AllianceData:setHeroSelectDic(heroVo)
	local typeInfo = self.getCurTypeInfo;
	local curIdx;
	local freeIdx;
	for i = 1, typeInfo.sell_hero_num do
		if self.selectHeroDic[i] ~= nil then
			if self.selectHeroDic[i].unique_id == heroVo.unique_id then
				curIdx = i;
			elseif self.selectHeroDic[i].id == heroVo.id then
				OperateAlert.showLangValue(201429);
				return;
			end
		else
			if freeIdx == nil then
				freeIdx = i;
			end
		end
	end

	if curIdx ~= nil then
		self.selectHeroDic[curIdx] = nil;
	elseif freeIdx ~= nil then
		local state, str = self:checkLineupNumState(self.checkLineupList, heroVo.unique_id);
		if state == false then
			OperateAlert.show(LanUtil.formateStr(201431, str));
			return;
		elseif heroVo.lock_state == true then
			local tipsData = {
				btnType = 1,
				des = LanUtil.getValue(201432),
				owner = self,
				sureFun = function()
					Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(heroVo.unique_id, 0);
					self.selectHeroDic[freeIdx] = heroVo;
					Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_HERO_SELECT");
				end
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
			return;
		end
		
		self.selectHeroDic[freeIdx] = heroVo;
	else
		OperateAlert.showLangValue(201430);
		return;
	end
	Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DEAL_HERO_SELECT");
end

function Lua_AllianceData.Get:checkLineupList()
    local config;
    local lineupList = {};
    for uid, v in pairs(self.selectHeroDic) do
    	if v.lineupDic ~= nil then
    		for lineup_type, vul in pairs(v.lineupDic) do
    			config = getConfig("hero_camp_lineup", lineup_type);
    			if config ~= nil and config.can_cancel == 1 then
    				if lineupList[lineup_type] == nil then
    					lineupList[lineup_type] = 1;
    				else
    					lineupList[lineup_type] = lineupList[lineup_type] +1;
    				end
    			end
    		end
    	end
    end
    return lineupList;
end

function Lua_AllianceData:checkLineupNumState(lineupList, select_uid)
	if lineupList == nil then
		lineupList = {};
	end

    local hvo = DataCenter.heroData:getItemByUniqueId(select_uid);
    local config;
    if hvo ~= nil and hvo.lineupDic ~= nil then
        for lineup_type, vul in pairs(hvo.lineupDic) do
            config = getConfig("hero_camp_lineup", lineup_type);
            if config ~= nil and config.can_cancel == 1 then
	            if lineupList[lineup_type] == nil then
	                lineupList[lineup_type] = 1;
	            else
	                lineupList[lineup_type] = lineupList[lineup_type] +1;
	            end

	            if lineupList[lineup_type] >= DataCenter.heroLineupData:getLineupHeroTotalNum(lineup_type) then
	                return false, config.name;
	            end
	        end
        end
    end
    return true;
end

function Lua_AllianceData:checkDealRedPoint()
	local arr = self.getDealTypeArr;
	for i = 1, arr:getSize() do
		arr[i]:checkRedPoint();
	end
end