--公会系统 交易行类型Vo
Lua_AllianceDealTypeVo = class("Lua_AllianceDealTypeVo");

function Lua_AllianceDealTypeVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig("league_transaction_type", self.id);
	end
end

function Lua_AllianceDealTypeVo:dispose()
	self.leftTime = nil;
	self.refreshTick = nil;
	self.isTransaction = nil;
end

function Lua_AllianceDealTypeVo:fromServer(msg)
	self.leftTime = msg.left_times; -- 剩余次数
	self.refreshTick = msg.refresh_tick; -- 刷新时间
	self.isTransaction = msg.is_have_transaction; -- 是否有交易过 1：有 0：没有
end

function Lua_AllianceDealTypeVo:checkRedPoint()
	if self.red_id ~= nil then
		local isOpen = DataCenter.funcOpenData:isOpened(self.function_id);
		local isCan = self.leftTime ~= nil and self.leftTime > 0;
		local isJoin = DataCenter.roleData:isJoinTheLeague();
		DataCenter.redPointData:updateRedPointState(self.red_id, isOpen and isCan and isJoin);
	end
end

-------------------配置数据-------------------

function Lua_AllianceDealTypeVo.Get:times() -- 次数
	return self.config.times;
end

function Lua_AllianceDealTypeVo.Get:scheme_limit() -- 方案上限
	return self.config.scheme_limit;
end

function Lua_AllianceDealTypeVo.Get:sell_hero_num() -- 寄售的英雄数量上限
	return self.config.sell_hero_num;
end

function Lua_AllianceDealTypeVo.Get:function_id() -- 功能开启id
	return self.config.function_id;
end

function Lua_AllianceDealTypeVo.Get:transaction_cost() -- 交易消耗
	return self.config.transaction_cost;
end

function Lua_AllianceDealTypeVo.Get:name() -- 名字
	return self.config.name;
end

function Lua_AllianceDealTypeVo.Get:describe() -- 描述
	return self.config.describe;
end

function Lua_AllianceDealTypeVo.Get:left_icon_res() -- 左上角图标资源
	return self.config.left_icon_res;
end

function Lua_AllianceDealTypeVo.Get:show_icon_res() -- 显示图标资源
	return self.config.show_icon_res;
end

function Lua_AllianceDealTypeVo.Get:no_open_path_id() -- 未开启时跳转Id
	return self.config.no_open_path_id;
end

function Lua_AllianceDealTypeVo.Get:red_id() -- 红点
	return self.config.red_id;
end