--联盟系统 红包Vo
Lua_AllianceRedPacketVo = class("Lua_AllianceRedPacketVo");

function Lua_AllianceRedPacketVo:ctor(id, type, config)
	self.id = id;
	self.type = type;
	self.config = config;
	if self.config == nil then
		if self.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
			self.config = getConfig("league_red_package", self.id);
		elseif self.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
			self.config = getConfig("league_welfare_red_package", self.id);
		end
	end

	self:dispose();
end

function Lua_AllianceRedPacketVo:dispose()
	self.showNum = 0;
end

-------------------发红包-------------------

function Lua_AllianceRedPacketVo:updateSendInfo(msg)
	self.showNum = msg.value;--红包个数
end

function Lua_AllianceRedPacketVo.Get:sendSort()
	local sort = self.id;
	if self.showNum > 0 then
		sort = sort - 10000;
	end
	return sort;
end

-------------------抢红包-------------------

function Lua_AllianceRedPacketVo:updateRobInfo(msg)
	self.redPackUid = tonumber(msg.red_pack_uid);--红包唯一id
	self.playerName = msg.name;--红包发送人昵称
	self.state = msg.is_draw;--0 未领取 1 已领取
	self.motto = msg.motto;--箴语
	self.leftNum = msg.left_num; -- 剩余多少份 0 已枪完
end

function Lua_AllianceRedPacketVo.Get:sort()
	local val = self.state * 2;
	if val == 0 and self.leftNum <= 0 then
		val = 3;
	end

	local limitNum;
	if self.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
		limitNum = DataCenter.allianceData.leagueRedPacketNum;
	elseif self.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
		limitNum = DataCenter.allianceData.welfareRedPacketNum;
	end
	if limitNum <= 0 and val == 0 then
		val = 1;
	end
	return val;
end

function Lua_AllianceRedPacketVo.Get:showDesc()
	if self.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
		return self.motto;
	elseif self.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
		return self.desc;
	end
end

function Lua_AllianceRedPacketVo.Get:showItem()
	if self.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
		return self.red_package_item;
	elseif self.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
		return self.red_package_item[1];
	end
end

---------------------------联盟红包配置---------------------------

function Lua_AllianceRedPacketVo.Get:recharge_id()--充值id
	return self.config.recharge_id;
end

function Lua_AllianceRedPacketVo.Get:price()--红包金额
	return self.config.price;
end

function Lua_AllianceRedPacketVo.Get:ret_reward()--返还奖励
	return self.config.ret_reward;
end

---------------------------福利红包配置---------------------------

function Lua_AllianceRedPacketVo.Get:desc()--描述
	return self.config.desc;
end

function Lua_AllianceRedPacketVo.Get:league_position()--限定职位
	return self.config.league_position;
end

---------------------------通用配置数据---------------------------

function Lua_AllianceRedPacketVo.Get:single_send_num()--单次发送个数
	return self.config.single_send_num;
end

function Lua_AllianceRedPacketVo.Get:red_package_item()--红包内道具
	return self.config.red_package_item;
end

function Lua_AllianceRedPacketVo.Get:red_package_name()--红包名称
	return self.config.red_package_name;
end