--联盟系统 联盟Proxy
checkRequire("Lua_AllianceData");
checkRequire("Lua_AllianceUtil");
Lua_AllianceProxy = class("Lua_AllianceProxy");

function Lua_AllianceProxy:ctor()
	DataCenter.allianceUtil = Lua_AllianceUtil.new();
	DataCenter.allianceData = Lua_AllianceData.new();

	--主界面
	Lua_MsgUtil.addLuaMsg(50106001, self, self.rGetAllianceList);--获取联盟列表(返回)
	Lua_MsgUtil.addLuaMsg(50106004, self, self.rJoinAlliance);--请求申请加入联盟(返回)
	Lua_MsgUtil.addLuaMsg(50106032, self, self.rAllianceSearch);--请求联盟搜索(返回)
    Lua_MsgUtil.addLuaMsg(50106002, self, self.rGetAllianceInfo);--请求联盟界面信息(返回)
    Lua_MsgUtil.addLuaMsg(50106018, self, self.rSendMassMail);--请求联盟群发邮件返回
    Lua_MsgUtil.addLuaMsg(80106009, self, self.UpdateAllianceInfo);--玩家联盟信息通知(主动)
    Lua_MsgUtil.addLuaMsg(50106003, self, self.rCreateAlliance);-- 社区创建(返回)
    Lua_MsgUtil.addLuaMsg(80106066, self, self.iRefreshLeagueRedDot);--通知公会红点(主动)
    
    --成员管理
    Lua_MsgUtil.addLuaMsg(50106005, self, self.rCheckApply);--请求联盟申请审核(返回)
    Lua_MsgUtil.addLuaMsg(50106007, self, self.rExpelMember);--请求逐玩家出联盟(返回)
    Lua_MsgUtil.addLuaMsg(50106008, self, self.rDisbandAlliance);--请求解散联盟(返回)
    Lua_MsgUtil.addLuaMsg(50106010, self, self.rGetMemberList);--请求联盟成员列表(返回)
    Lua_MsgUtil.addLuaMsg(50106011, self, self.rAppointMemberDuty);--请求任命成员职务(返回)
    Lua_MsgUtil.addLuaMsg(50106012, self, self.rTranferCommander);--请求转让会长(返回)
    Lua_MsgUtil.addLuaMsg(50106014, self, self.rGetApplyList);--请求联盟申请列表(返回)
    Lua_MsgUtil.addLuaMsg(50106015, self, self.rGetLogList);--请求查看联盟日志(返回)
    Lua_MsgUtil.addLuaMsg(50106028, self, self.rSetAllianceInfo);--请求联盟设置返回
    Lua_MsgUtil.addLuaMsg(50106060, self, self.rImpeachDirector);--请求弹劾联盟主管返回

    --联盟排名
    Lua_MsgUtil.addLuaMsg(50106017, self, self.rAllianceRank);--请求联盟排行信息返回

    --联盟科技
    Lua_MsgUtil.addLuaMsg(50106021, self, self.rAllianceScience);--请求联盟科技界面(返回)
    Lua_MsgUtil.addLuaMsg(50106022, self, self.rAllianceSciencePoint);--请求联盟点亮联盟科技节点
    Lua_MsgUtil.addLuaMsg(50106035, self, self.rResetAllianceScience);--请求重置联盟科技(返回)

    --联盟Boss
    Lua_MsgUtil.addLuaMsg(50106023, self, self.rAllianceBossInfo);--请求联盟BOSS界面(返回)
    Lua_MsgUtil.addLuaMsg(50106024, self, self.rAllianceBossHurtRank);--请求联盟BOSS的伤害排行(返回)
    Lua_MsgUtil.addLuaMsg(50106026, self, self.rAllianceBossSweep);--请求联盟BOSS扫荡(返回)
    Lua_MsgUtil.addLuaMsg(80106027, self, self.rAllianceBossFightResult);--通知boss挑战结果
    Lua_MsgUtil.addLuaMsg(50106030, self, self.rAllianceBossBuyTime);--请求联盟boss次数购买(返回)
    Lua_MsgUtil.addLuaMsg(50106031, self, self.rAllianceBossMass);--请求联盟boss集结(返回)
    Lua_MsgUtil.addLuaMsg(50106034, self, self.rAddAllianceBossBuff);--请求增加联盟boss的buff效果(返回)
    Lua_MsgUtil.addLuaMsg(50106036, self, self.rAllianceHurtRankLike);--请求伤害排行点赞返回

    --联盟成长
    Lua_MsgUtil.addLuaMsg(50106019, self, self.rAllianceContribute);--请求联盟捐献(返回)
    Lua_MsgUtil.addLuaMsg(50106020, self, self.rAllianceContributeGift);--请求联盟领取捐献累积礼包(返回)
    Lua_MsgUtil.addLuaMsg(50106038, self, self.rAllianceGrowUpInfo);--请求联盟成长信息返回
    Lua_MsgUtil.addLuaMsg(50106040, self, self.rAllianceLevelGift);--请求领取联盟等级礼包返回
    Lua_MsgUtil.addLuaMsg(80106040, self, self.rUpdateAllianceLevelGift);--通知联盟等级礼包更新

    --联盟宝库
    Lua_MsgUtil.addLuaMsg(50106041, self, self.rAllianceTreasuryInfo);--请求联盟宝库信息返回
    Lua_MsgUtil.addLuaMsg(50106042, self, self.rTreasuryPutItem);--请求放入联盟宝库商品返回
    Lua_MsgUtil.addLuaMsg(50106043, self, self.rTreasuryBuy);--请求购买联盟宝库商品返回
    Lua_MsgUtil.addLuaMsg(50106054, self, self.rAllianceTreasuryItemInfo);--请求联盟宝库商品信息返回
    Lua_MsgUtil.addLuaMsg(50106055, self, self.rAllianceTreasuryLogDetail);--请求联盟宝库交易详细信息返回

    --联盟红包
    Lua_MsgUtil.addLuaMsg(80106037, self, self.rAllianceRedPacketPlay);--通知联盟红包有联盟红包可领
    Lua_MsgUtil.addLuaMsg(50106044, self, self.rAllianceRedPacketInface);--请求联盟红包界面返回
    Lua_MsgUtil.addLuaMsg(50106045, self, self.rSendAllianceRedPacket);--请求发送联盟红包返回
    Lua_MsgUtil.addLuaMsg(50106046, self, self.rWalfareRedPacketInfo);--请求福利红包信息返回
    Lua_MsgUtil.addLuaMsg(50106039, self, self.rSendWalfareRedPacket);--请求发送福利红包返回
    Lua_MsgUtil.addLuaMsg(50106047, self, self.rAllianceRedPacketInfo);--请求联盟红包信息返回
    Lua_MsgUtil.addLuaMsg(50106048, self, self.rViewAllianceRedPacket);--请求查看联盟红包领取详情返回
    Lua_MsgUtil.addLuaMsg(50106049, self, self.rReceiveAllianceRedPacket);--请求领取联盟红包返回
    Lua_MsgUtil.addLuaMsg(50106050, self, self.rllianceRedPacketRank);--请求联盟红包排行榜信息返回
    Lua_MsgUtil.addLuaMsg(80106067, self, self.iRefeshRedPacketGetNum);--请求联盟红包排行榜信息返回

    --联盟挑战
    Lua_MsgUtil.addLuaMsg(50106051, self, self.rOpenAllianceChallenge);--请求开启联盟挑战返回
    Lua_MsgUtil.addLuaMsg(50106052, self, self.rAllianceChallengeInfo);--请求联盟挑战信息返回
    Lua_MsgUtil.addLuaMsg(50106053, self, self.rAllianceChallengeReward);--请求领取联盟boss血量奖励返回
    Lua_MsgUtil.addLuaMsg(50106056, self, self.rAllianceChallengeSweep);--请求联盟挑战扫荡返回
    Lua_MsgUtil.addLuaMsg(80106057, self, self.rAllianceChallengeBossResult);--通知联盟挑战信息
    Lua_MsgUtil.addLuaMsg(50106058, self, self.rAllianceChallengeRank);--请求联盟挑战伤害排行返回
    Lua_MsgUtil.addLuaMsg(50106059, self, self.rbuyAllianceChallengeTime);--购买联盟挑战次数返回

    -- 排行榜功能
    Lua_MsgUtil.addLuaMsg(50106033, self, self.rOtherAllianceInfo);--请求其他联盟信息(返回)

    -- 公会对抗
    Lua_MsgUtil.addLuaMsg(50106062, self, self.rLeagueCompeteInfo);--请求公会对抗信息返回
    Lua_MsgUtil.addLuaMsg(50106063, self, self.rLeagueCompeteLog);--请求公会对抗日志返回
    Lua_MsgUtil.addLuaMsg(50106064, self, self.rLeagueCompeteHurt);--请求公会对抗伤害排名返回
    Lua_MsgUtil.addLuaMsg(50106065, self, self.rLeagueCompeteRank);--请求公会对抗成员排名信息返回
    Lua_MsgUtil.addLuaMsg(50106066, self, self.rLeagueCompeteRob);--请求公会对抗抢夺返回
    Lua_MsgUtil.addLuaMsg(50106068, self, self.rLeagueCompeteGrab);--请求公会对抗帮抢信息返回

    -- 公会交易行
    Lua_MsgUtil.addLuaMsg(50208001, self, self.rLeagueDealEntrance); -- 请求公会交易次数信息返回
    Lua_MsgUtil.addLuaMsg(50208002, self, self.rLeagueDealInfo); -- 请求公会交易行信息返回
    Lua_MsgUtil.addLuaMsg(50208003, self, self.rLeagueDealHeroDetail); -- 请求公会交易行英雄交易详情返回
    Lua_MsgUtil.addLuaMsg(50208004, self, self.rLeagueDealConvertHero); -- 请求兑换公会交易行英雄返回
    Lua_MsgUtil.addLuaMsg(50208005, self, self.rLeagueDealMakePlan); -- 请求制作交易方案方案返回
    Lua_MsgUtil.addLuaMsg(50208006, self, self.rLeagueDealRemovePlan); -- 请求删除英雄交易方案返回
    Lua_MsgUtil.addLuaMsg(50208007, self, self.rLeagueDealPlanInfo); -- 请求英雄交易方案返回
    Lua_MsgUtil.addLuaMsg(50208009, self, self.rLeagueDealLog); -- 请求工会交易日志返回
    Lua_MsgUtil.addLuaMsg(80208011, self, self.iLeagueDealPlanUpdate); -- 通知方案更新

    Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.onMoneyUpdate); 
end

function Lua_AllianceProxy:onMoneyUpdate(dic)
	if dic[Lua_ResourcesDefine.GOLD] == nil and dic[Lua_ResourcesDefine.TRUTH_POWER] == nil then
		return;
	end
	DataCenter.allianceData:updateRedPoint();
end

------------------------------------上行------------------------------------

---------------------------------联盟主界面---------------------------------

function Lua_AllianceProxy:sGetAllianceList(num)--请求联盟列表
	local cmd = ProtoPublic_pb.Proto10106001();
	cmd.num = num;
	sendMsg(10106001, cmd);
end

function Lua_AllianceProxy:sGetAllianceInfo()--请求联盟界面信息
	sendMsg(10106002);
end

function Lua_AllianceProxy:sCreateAlliance(name, forceCond, levelCond, autoJoin, declaration)--请求创建联盟
	local cmd = ProtoPublic_pb.Proto10106003();
	cmd.name = name;--联盟名字
	cmd.force_cond = forceCond;--战力条件
	cmd.level_cond = levelCond;--等级条件
	cmd.auto_join = autoJoin;--是否需要验证加入 0不需要 1需要
	if declaration ~= nil then
		cmd.declaration = declaration;--联盟宣言
	end
	sendMsg(10106003, cmd);
end

function Lua_AllianceProxy:sJoinAlliance(leagueId)--请求申请加入联盟
	local cmd = ProtoPublic_pb.Proto10106004();
	cmd.league_id = leagueId;--指定的联盟id
	sendMsg(10106004, cmd);
end

function Lua_AllianceProxy:sAllianceSearch(leagueName)--请求联盟搜索
	local cmd = ProtoPublic_pb.Proto10106032();
	cmd.league_name = leagueName;
	sendMsg(10106032, cmd);
end

---------------------------------联盟管理---------------------------------

function Lua_AllianceProxy:sCheckApply(type, playerId)--请求联盟申请审核
	local cmd = ProtoPublic_pb.Proto10106005();
	cmd.type = type;--1 通过，2 拒绝，3 一键通过，4 一键取消
	if playerId ~= nil then
		cmd.player_id = playerId;--玩家id
	end
	sendMsg(10106005, cmd);
end

function Lua_AllianceProxy:sExitAlliance()--请求退出联盟
	sendMsg(10106006);
end

function Lua_AllianceProxy:sExpelMember(memberId)--请求逐玩家出联盟
	local cmd = ProtoPublic_pb.Proto10106007();
	cmd.member_id = memberId;--成员id
	sendMsg(10106007, cmd);
end

function Lua_AllianceProxy:sDisbandAlliance(type)--请求解散联盟
	local cmd = ProtoPublic_pb.Proto10106008();
	cmd.op_type = type;--1:请求开始解散联盟 2：取消解散联盟 3：确认解散联盟
	sendMsg(10106008, cmd);
end

function Lua_AllianceProxy:sGetMemberList()--请求联盟成员列表
	sendMsg(10106010);
end

function Lua_AllianceProxy:sAppointMemberDuty(memberId, duty)--请求任命成员职务
	local cmd = ProtoPublic_pb.Proto10106011();
	cmd.member_id = tonumber(memberId);--成员id
	cmd.position = duty;--职位, 2 副会长, 3 精英, 4 普通成员
	sendMsg(10106011, cmd);
end

function Lua_AllianceProxy:sTranferCommander(memberId)--请求转让会长
	local cmd = ProtoPublic_pb.Proto10106012();
	cmd.member_id = tonumber(memberId);--新会长的玩家id
	sendMsg(10106012, cmd);
end

function Lua_AllianceProxy:sGetApplyList()--请求联盟申请列表
	sendMsg(10106014);
end

function Lua_AllianceProxy:sGetLogList()--请求联盟日志列表
	sendMsg(10106015);
end

function Lua_AllianceProxy:sReviseAllianceIocn(headIcon)--请求修改联盟头像
	local cmd = ProtoPublic_pb.Proto10106016();
	cmd.head_icon = headIcon;--新的头像Id
	sendMsg(10106016, cmd);
end

function Lua_AllianceProxy:sSendMassMail(str)--请求联盟群发邮件
	local cmd = ProtoPublic_pb.Proto10106018();
	cmd.content = str;--邮件内容
	sendMsg(10106018, cmd);
end

function Lua_AllianceProxy:sSetAllianceInfo(autoJoin, forceCond, levelCond, declaration)--请求联盟设置
	local cmd = ProtoPublic_pb.Proto10106028();
	cmd.auto_join = autoJoin;--是否需要验证加入 0不需要 1需要
	cmd.force_cond = forceCond;--战力条件
	cmd.level_cond = levelCond;--等级条件
	if declaration ~= nil then
		cmd.league_declaration = declaration;--联盟宣言
	end
	sendMsg(10106028, cmd);
end

---------------------------------联盟排行---------------------------------

function Lua_AllianceProxy:sAllianceRank(num)--请求联盟排行
	local cmd = ProtoPublic_pb.Proto10106017();
	cmd.num = num; -- 0 刷新 1：下一页
	sendMsg(10106017, cmd);
end

---------------------------------联盟成长---------------------------------

function Lua_AllianceProxy:sAllianceContribute(id)--请求联盟捐献
	local cmd = ProtoPublic_pb.Proto10106019();
	cmd.id = id;--捐献id
	sendMsg(10106019, cmd);
end

function Lua_AllianceProxy:sAllianceContributeGift(gift_id)--请求联盟领取捐献累积礼包
	local cmd = ProtoPublic_pb.Proto10106020();
	cmd.gift_id = gift_id;--礼包id
	sendMsg(10106020, cmd);
end

function Lua_AllianceProxy:sAllianceGrowUpInfo()--请求联盟成长信息
	sendMsg(10106038);
end

function Lua_AllianceProxy:sAllianceLevelGift(level)--请求领取联盟等级礼包
	local cmd = ProtoPublic_pb.Proto10106040();
	cmd.level = level;--礼包id
	sendMsg(10106040, cmd);
end


---------------------------------联盟科技---------------------------------

function Lua_AllianceProxy:sAllianceScience(science_type)--请求联盟科技界面
	local cmd = ProtoPublic_pb.Proto10106021();
	cmd.science_type = science_type;--联盟科技类型
	sendMsg(10106021, cmd);
end


function Lua_AllianceProxy:sAllianceSciencePoint(science_type)--请求联盟点亮联盟科技节点
	local cmd = ProtoPublic_pb.Proto10106022();
	cmd.science_type = science_type;--科技类型
	sendMsg(10106022, cmd);
end

function Lua_AllianceProxy:sResetAllianceScience(science_type)--请求重置联盟科技
	local cmd = ProtoPublic_pb.Proto10106035();
	cmd.science_type = science_type;--科技类型
	sendMsg(10106035, cmd);
end

---------------------------------联盟Boss---------------------------------

function Lua_AllianceProxy:sAllianceBossInfo(show_id)--请求联盟boss界面
	local cmd = ProtoPublic_pb.Proto10106023();
	cmd.show_id = show_id;--显示的关卡id 0：当前正挑战的关卡
	sendMsg(10106023, cmd);
end

function Lua_AllianceProxy:sAllianceBossHurtRank(stage_id)--请求联盟BOSS的伤害排行
	local cmd = ProtoPublic_pb.Proto10106024();
	cmd.stage_id = stage_id;--关卡id
	sendMsg(10106024, cmd);
end

function Lua_AllianceProxy:sAllianceBossSweep(stage_id, auto_buy)--请求联盟BOSS扫荡
	local cmd = ProtoPublic_pb.Proto10106026();
	cmd.stage_id = stage_id;--关卡id
	cmd.auto_buy = auto_buy;--1 自动购买 0 不自动购买
	sendMsg(10106026, cmd);
end

function Lua_AllianceProxy:sAllianceBossBuyTime()--请求联盟boss次数购买
	sendMsg(10106030);
end

function Lua_AllianceProxy:sAllianceBossMass()--请求联盟boss集结
	sendMsg(10106031);
end

function Lua_AllianceProxy:sAddAllianceBossBuff()--请求增加联盟boss的buff效果
	sendMsg(10106034);
end

function Lua_AllianceProxy:sAllianceHurtRankLike(rank_member_id, stage_id)--请求伤害排行点赞
	local cmd = ProtoPublic_pb.Proto10106036();
	cmd.rank_member_id = rank_member_id;--伤害排行玩家id
	cmd.stage_id = stage_id;--关卡id
	sendMsg(10106036, cmd);
end

---------------------------------联盟宝库---------------------------------

function Lua_AllianceProxy:sAllianceTreasuryInfo(type)--请求联盟宝库信息
	local cmd = ProtoPublic_pb.Proto10106041();
	cmd.type = type;--宝库类型
	sendMsg(10106041, cmd);
end

function Lua_AllianceProxy:sTreasuryPutItem(item_id, amount, item_uid)--请求放入联盟宝库商品
	local cmd = ProtoPublic_pb.Proto10106042();
	cmd.item_id = item_id;
	cmd.amount = amount;
	if item_uid ~= nil then
		cmd.item_uid = item_uid;
	end
	sendMsg(10106042, cmd);
end

function Lua_AllianceProxy:sTreasuryBuy(key, value, type)--请求购买联盟宝库商品
	local cmd = ProtoPublic_pb.Proto10106043();
	cmd.item_info.key = key;
	cmd.item_info.value = value;
	cmd.type = type;
	sendMsg(10106043, cmd);
end

function Lua_AllianceProxy:sAllianceTreasuryItemInfo(treasury_type, grid)--请求联盟宝库商品信息
	local cmd = ProtoPublic_pb.Proto10106054();
	cmd.treasury_type = treasury_type;--宝库类型
	cmd.grid = grid;--宝库格子
	sendMsg(10106054, cmd);
end

function Lua_AllianceProxy:sAllianceTreasuryLog()--请求联盟宝库交易详细信息
	sendMsg(10106055);
end


---------------------------------联盟红包---------------------------------

function Lua_AllianceProxy:sAllianceRedPacketInface()--请求联盟红包界面
	sendMsg(10106044);
end

function Lua_AllianceProxy:sSendAllianceRedPacket(recharge_id, motto)--请求发送联盟红包
	local cmd = ProtoPublic_pb.Proto10106045();
	cmd.recharge_id = recharge_id;--充值id
	cmd.motto = motto;--红包箴言
	sendMsg(10106045, cmd);
end

function Lua_AllianceProxy:sWalfareRedPacketInfo()--请求福利红包信息
	sendMsg(10106046);
end

function Lua_AllianceProxy:sSendWalfareRedPacket(welfare_red_pack_id, motto)--请求发送福利红包
	local cmd = ProtoPublic_pb.Proto10106039();
	cmd.welfare_red_pack_id = welfare_red_pack_id;--福利红包id
	cmd.motto = motto;
	sendMsg(10106039, cmd);
end

function Lua_AllianceProxy:sAllianceRedPacketInfo()--请求联盟红包信息
	sendMsg(10106047);
end

function Lua_AllianceProxy:sViewAllianceRedPacket(red_pack_id)--请求查看联盟红包领取详情
	local cmd = ProtoPublic_pb.Proto10106048();
	cmd.red_pack_id = red_pack_id;--红包id
	sendMsg(10106048, cmd);
end

function Lua_AllianceProxy:sReceiveAllianceRedPacket(red_pack_id)--请求领取联盟红包
	local cmd = ProtoPublic_pb.Proto10106049();
	cmd.red_pack_id = red_pack_id;--红包id
	sendMsg(10106049, cmd);
end

function Lua_AllianceProxy:sllianceRedPacketRank()--请求联盟红包排行榜信息
	sendMsg(10106050);
end

---------------------------------联盟挑战---------------------------------

function Lua_AllianceProxy:sOpenAllianceChallenge(boss_type)--请求开启联盟挑战
	local cmd = ProtoPublic_pb.Proto10106051();
	cmd.boss_type = boss_type;--开启的挑战id
	sendMsg(10106051, cmd);
end

function Lua_AllianceProxy:sAllianceChallenge(boss_type)--请求联盟挑战信息
	local cmd = ProtoPublic_pb.Proto10106052();
	cmd.boss_type = boss_type;--boss类型 0请求当前联盟挑战
	sendMsg(10106052, cmd);
end

function Lua_AllianceProxy:sAllianceChallengeReward(reward_id)--请求领取联盟boss血量奖励
	local cmd = ProtoPublic_pb.Proto10106053();
	cmd.reward_id = reward_id;
	sendMsg(10106053, cmd);
end

function Lua_AllianceProxy:sAllianceChallengeSweep()--请求联盟挑战扫荡
	sendMsg(10106056);
end

function Lua_AllianceProxy:sAllianceChallengeRank(boss_type)--请求联盟挑战伤害排行
	local cmd = ProtoPublic_pb.Proto10106058();
	cmd.boss_type = boss_type;
	sendMsg(10106058, cmd);
end

function Lua_AllianceProxy:sbuyAllianceChallengeTime()--购买联盟挑战次数
	sendMsg(10106059);
end

function Lua_AllianceProxy:sImpeachDirector()--请求弹劾联盟主管
	sendMsg(10106060);
end



---------------------------------排行榜功能---------------------------------

function Lua_AllianceProxy:sOtherAllianceInfo(league_id)--请求其他联盟信息
	if DataCenter.roleData:isSameAlliance(league_id) then
		OperateAlert.showLangValue(123659);
		return;
	end

	local cmd = ProtoPublic_pb.Proto10106033();
	cmd.league_id = tonumber(league_id);--联盟id
	sendMsg(10106033, cmd);
end



---------------------------------公会对抗---------------------------------

function Lua_AllianceProxy:sLeagueCompeteInfo()--请求公会对抗信息
	sendMsg(10106062);
end

function Lua_AllianceProxy:sLeagueCompeteLog(_type)--请求公会对抗日志
	local cmd = ProtoPublic_pb.Proto10106063();
	cmd.type = _type;--1.战场日志 2：我的日志
	sendMsg(10106063, cmd);
end

function Lua_AllianceProxy:sLeagueCompeteHurt(page)--请求公会对抗伤害排名
	local cmd = ProtoPublic_pb.Proto10106064();
	cmd.page = page;--0:刷新 1:下一页
	sendMsg(10106064, cmd);
end

function Lua_AllianceProxy:sLeagueCompeteRank(_type)--请求公会对抗成员排名信息
	local cmd = ProtoPublic_pb.Proto10106065();
	cmd.type = _type;--1:己方 2:匹配方
	sendMsg(10106065, cmd);
end

function Lua_AllianceProxy:sLeagueCompeteRob(role_id)--请求公会对抗抢夺
	local cmd = ProtoPublic_pb.Proto10106066();
	cmd.role_id = role_id;
	sendMsg(10106066, cmd);
end

function Lua_AllianceProxy:sLeagueCompeteGrab(record_id)--请求公会对抗帮抢信息
	local cmd = ProtoPublic_pb.Proto10106068();
	cmd.record_id = record_id;
	sendMsg(10106068, cmd);
end



---------------------------------公会交易行---------------------------------

function Lua_AllianceProxy:sLeagueDealEntrance() -- 请求公会交易次数信息
	sendMsg(10208001);
end

function Lua_AllianceProxy:sLeagueDealInfo(types, camp) -- 请求公会交易行信息
	local cmd = ProtoPublic_pb.Proto10208002();
	cmd.type = types;
	cmd.camp = camp;
	sendMsg(10208002, cmd);
end

function Lua_AllianceProxy:sLeagueDealHeroDetail(hero_id) -- 请求公会交易行英雄交易详情
	local cmd = ProtoPublic_pb.Proto10208003();
	cmd.hero_id = hero_id;
	sendMsg(10208003, cmd);
end

function Lua_AllianceProxy:sLeagueDealConvertHero(hero_id, player_id, hero_uid) -- 请求兑换公会交易行英雄
	local cmd = ProtoPublic_pb.Proto10208004();
	cmd.hero_id = hero_id;
	cmd.player_id = player_id;
	cmd.hero_uid = hero_uid;
	sendMsg(10208004, cmd);
end

function Lua_AllianceProxy:sLeagueDealMakePlan() -- 请求制作交易方案
	local cmd = ProtoPublic_pb.Proto10208005();
	cmd.require_hero = DataCenter.allianceData.selectHeroVo.id;

	local typeInfo = DataCenter.allianceData.getCurTypeInfo;
	local heroVo;
	for i = 1, typeInfo.sell_hero_num do
		heroVo = DataCenter.allianceData.selectHeroDic[i];
		if heroVo ~= nil then
			cmd.sell_hero_list:append(heroVo.unique_id);
		end
	end
	sendMsg(10208005, cmd);
end

function Lua_AllianceProxy:sLeagueDealRemovePlan(hero_id) -- 请求删除英雄交易方案
	local cmd = ProtoPublic_pb.Proto10208006();
	cmd.hero_id = hero_id;
	sendMsg(10208006, cmd);
end

function Lua_AllianceProxy:sLeagueDealPlanInfo(t) -- 请求英雄交易方案
	local cmd = ProtoPublic_pb.Proto10208007();
	cmd.type = t;
	sendMsg(10208007, cmd);
end

function Lua_AllianceProxy:sLeagueDealLog(t) -- 请求工会交易日志
	local cmd = ProtoPublic_pb.Proto10208009();
	cmd.type = t;
	sendMsg(10208009, cmd);
end

































------------------------------------下行------------------------------------

---------------------------------联盟主界面---------------------------------

function Lua_AllianceProxy:rGetAllianceList(mp)--获取联盟列表(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106001();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106001(msg);
	end
end

function Lua_AllianceProxy:rAllianceSearch(mp)--请求联盟搜索(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106032();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106032(msg);
	end
end


function Lua_AllianceProxy:rGetAllianceInfo(mp)--请求联盟界面信息(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106002();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106002(msg);
	end
end

function Lua_AllianceProxy:rSendMassMail(mp)--请求联盟群发邮件返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106018();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106018(msg);
	end
end

function Lua_AllianceProxy:rJoinAlliance(mp)--请求申请加入联盟(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106004();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106004(msg);
	end
end

function Lua_AllianceProxy:UpdateAllianceInfo(mp)--玩家联盟信息通知(主动)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80106009();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer80106009(msg);
	end
end

function Lua_AllianceProxy:rCreateAlliance(mp)--社区创建(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106003();
		msg:ParseFromString(mp.data);
		if msg.fail_type == 1 then
			OperateAlert.show(LanUtil.formateStr(201236, msg.league_name));
		end
	end
end

function Lua_AllianceProxy:iRefreshLeagueRedDot(mp)--通知公会会红点(主动)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80106066();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer80106066(msg);
	end
end

---------------------------------联盟管理---------------------------------

function Lua_AllianceProxy:rCheckApply(mp)--请求联盟申请审核(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106005();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106005(msg);
	end
end

function Lua_AllianceProxy:rGetApplyList(mp)--请求联盟申请列表(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106014();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updataApplyList(msg.apply_list);
	end
end

function Lua_AllianceProxy:rExpelMember(mp)--请求逐玩家出联盟(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106007();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106007(msg);
	end
end

function Lua_AllianceProxy:rDisbandAlliance(mp)--请求解散联盟(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106008();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106008(msg);
	end
end

function Lua_AllianceProxy:rGetMemberList(mp)--请求联盟成员列表(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106010();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106010(msg);
	end
end

function Lua_AllianceProxy:rAppointMemberDuty(mp)--请求任命成员职务(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106011();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106011(msg);
	end
end

function Lua_AllianceProxy:rTranferCommander(mp)--请求转让会长(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106012();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106012(msg);
	end
end

function Lua_AllianceProxy:rGetLogList(mp)--请求查看联盟日志(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106015();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106015(msg);
	end
end

function Lua_AllianceProxy:rSetAllianceInfo(mp)--请求联盟设置返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106028();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106028(msg);
	end
end

function Lua_AllianceProxy:rImpeachDirector(mp)--请求弹劾联盟主管返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106060();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106060(msg);
	end
end

---------------------------------联盟排名---------------------------------

function Lua_AllianceProxy:rAllianceRank(mp)--请求联盟排行信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106017();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106017(msg);
	end
end

---------------------------------联盟科技---------------------------------

function Lua_AllianceProxy:rAllianceScience(mp)--请求联盟科技界面(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106021();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateScienceInfo(msg.science_info, false);
	end
end

function Lua_AllianceProxy:rAllianceSciencePoint(mp)--请求联盟点亮联盟科技节点
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106022();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateScienceInfo(msg.science_info, true);
	end
end

function Lua_AllianceProxy:rResetAllianceScience(mp)--请求重置联盟科技(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106035();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:resetScienceInfo(msg);
	end
end

---------------------------------联盟Boss---------------------------------

function Lua_AllianceProxy:rAllianceBossInfo(mp)--请求联盟BOSS界面(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106023();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106023(msg);
	end
end

function Lua_AllianceProxy:rAllianceBossHurtRank(mp)--请求联盟BOSS的伤害排行(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106024();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106024(msg);
	end
end

function Lua_AllianceProxy:rAllianceBossSweep(mp)--请求联盟BOSS扫荡(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106026();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106026(msg);
	end
end

function Lua_AllianceProxy:rAllianceBossFightResult(mp)--通知boss挑战结果
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80106027();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer80106027(msg);
	end
end

function Lua_AllianceProxy:rAllianceBossBuyTime(mp)--请求联盟boss次数购买(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106030();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106030(msg);
	end
end

function Lua_AllianceProxy:rAllianceBossMass(mp)--：请求联盟boss集结(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106031();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106031(msg);
	end
end

function Lua_AllianceProxy:rAddAllianceBossBuff(mp)--请求增加联盟boss的buff效果(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106034();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106034(msg);
	end
end

function Lua_AllianceProxy:rAllianceHurtRankLike(mp)--请求伤害排行点赞返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106036();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106036(msg);
	end
end

---------------------------------联盟成长---------------------------------

function Lua_AllianceProxy:rAllianceContribute(mp)--请求联盟捐献(返回)
	if mp.errno == 0 then
		DataCenter.allianceData:fromServer50106019(msg);
	end
end

function Lua_AllianceProxy:rAllianceContributeGift(mp)--请求联盟领取捐献累积礼包(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106020();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106020(msg);
	end
end

function Lua_AllianceProxy:rAllianceGrowUpInfo(mp)--请求联盟成长信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106038();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106038(msg);
	end
end

function Lua_AllianceProxy:rAllianceLevelGift(mp)--请求领取联盟等级礼包返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106040();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateLevelRewardInfo(msg);
	end
end

function Lua_AllianceProxy:rUpdateAllianceLevelGift(mp)--通知联盟等级礼包更新
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80106040();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateLevelRewardInfo(msg);
	end
end

---------------------------------联盟宝库---------------------------------

function Lua_AllianceProxy:rAllianceTreasuryInfo(mp)--请求联盟宝库信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106041();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateAllianceTreasuryInfo(msg);
	end
end

function Lua_AllianceProxy:rTreasuryPutItem(mp)--请求放入联盟宝库商品返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106042();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("LEAGUE_TREASURY_DEPOSIT_ITEM");
	end
end

function Lua_AllianceProxy:rTreasuryBuy(mp)--请求购买联盟宝库商品返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106043();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateAllianceTreasuryInfo(msg);
	end
end

function Lua_AllianceProxy:rAllianceTreasuryItemInfo(mp)--请求联盟宝库商品信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106054();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:showAllianceTreasuryItemInfo(msg);
	end
end

function Lua_AllianceProxy:rAllianceTreasuryLogDetail(mp)--请求联盟宝库交易详细信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106055();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("LEAGUE_TREASURY_LOG_DETAIL", msg.transaction_info);
	end
end

---------------------------------联盟红包---------------------------------

function Lua_AllianceProxy:rAllianceRedPacketPlay(mp)--通知联盟红包有联盟红包可领
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80106037();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer80106037(msg);
	end
end

function Lua_AllianceProxy:rAllianceRedPacketInface(mp)--请求联盟红包界面返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106044();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateAllianceRedPacket(msg.left_num_list);
	end
end

function Lua_AllianceProxy:rSendAllianceRedPacket(mp)--请求发送联盟红包返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106045();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateAllianceRedPacket(msg.left_num_list);
	end
end

function Lua_AllianceProxy:rWalfareRedPacketInfo(mp)--请求福利红包信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106046();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateWelfareRedPacket(msg.red_pack_info);
	end
end

function Lua_AllianceProxy:rSendWalfareRedPacket(mp)--请求发送福利红包返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106039();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateWelfareRedPacket(msg.welfare_red_pack_info);
	end
end

function Lua_AllianceProxy:rAllianceRedPacketInfo(mp)--请求联盟红包信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106047();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106047(msg);
	end
end

function Lua_AllianceProxy:rViewAllianceRedPacket(mp)--请求查看联盟红包领取详情返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106048();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REDPACKET_DETAIL", msg);
	end
end

function Lua_AllianceProxy:rReceiveAllianceRedPacket(mp)--请求领取联盟红包返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106049();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106049(msg);
	end
end

function Lua_AllianceProxy:rllianceRedPacketRank(mp)--请求联盟红包排行榜信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106050();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_REDPACKET_RANK", msg);
	end
end

function Lua_AllianceProxy:iRefeshRedPacketGetNum(mp)--通知公会红包剩余次数
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80106067();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer80106067(msg.left_red_pack_draw_times);
	end
end

---------------------------------联盟挑战---------------------------------

function Lua_AllianceProxy:rOpenAllianceChallenge(mp)--请求开启联盟挑战返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80106067();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106051(msg);
	end
end

function Lua_AllianceProxy:rAllianceChallengeInfo(mp)--请求联盟挑战信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106052();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106052(msg);
	end
end

function Lua_AllianceProxy:rAllianceChallengeReward(mp)--请求领取联盟boss血量奖励返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106053();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:updateChallengRewardInfo(msg.blood_reward_info);
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_REWARD");
	end
end

function Lua_AllianceProxy:rAllianceChallengeSweep(mp)--请求联盟挑战扫荡返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106056();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106056(msg);
	end
end

function Lua_AllianceProxy:rAllianceChallengeBossResult(mp)--通知联盟挑战信息
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80106057();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer80106057(msg);
	end
end

function Lua_AllianceProxy:rAllianceChallengeRank(mp)--请求联盟挑战伤害排行返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106058();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_CHALLENGE_RANK", msg.role_list);
	end
end

function Lua_AllianceProxy:rbuyAllianceChallengeTime(mp)--购买联盟挑战次数返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106059();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106059(msg);
	end
end

---------------------------------排行榜功能---------------------------------

function Lua_AllianceProxy:rOtherAllianceInfo(mp)--请求其他联盟信息(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106033();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_LeagueDetailWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

---------------------------------公会对抗---------------------------------

function Lua_AllianceProxy:rLeagueCompeteInfo(mp)--请求公会对抗信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106062();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106062(msg);
	end
end

function Lua_AllianceProxy:rLeagueCompeteLog(mp)--请求公会对抗日志返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106063();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106063(msg);
	end
end

function Lua_AllianceProxy:rLeagueCompeteHurt(mp)--请求公会对抗伤害排名返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106064();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106064(msg);
	end
end

function Lua_AllianceProxy:rLeagueCompeteRank(mp)--请求公会对抗成员排名信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106065();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106065(msg);
	end
end

function Lua_AllianceProxy:rLeagueCompeteRob(mp)--请求公会对抗抢夺返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106066();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_LEAGUE_DUEL_ROB_INFO", msg);
	end
end

function Lua_AllianceProxy:rLeagueCompeteGrab(mp)--请求公会对抗帮抢信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50106068();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50106068(msg);
	end
end



---------------------------------公会交易行---------------------------------

function Lua_AllianceProxy:rLeagueDealEntrance(mp) -- 请求公会交易次数信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50208001();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50208001(msg);
	end
end

function Lua_AllianceProxy:rLeagueDealInfo(mp) -- 请求公会交易行信息返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50208002();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50208002(msg);
	end
end

function Lua_AllianceProxy:rLeagueDealHeroDetail(mp) -- 请求公会交易行英雄交易详情返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50208003();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50208003(msg);
	end
end

function Lua_AllianceProxy:rLeagueDealConvertHero(mp) -- 请求兑换公会交易行英雄返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50208004();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50208004(msg);
	end
end

function Lua_AllianceProxy:rLeagueDealMakePlan(mp) -- 请求制作交易方案方案返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50208005();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50208005(msg);
	end
end

function Lua_AllianceProxy:rLeagueDealRemovePlan(mp) -- 请求删除英雄交易方案返回
	if mp.errno == 0 then
		DataCenter.allianceData:fromServer50208006();
	end
end

function Lua_AllianceProxy:rLeagueDealPlanInfo(mp) -- 请求英雄交易方案返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50208007();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50208007(msg);
	end
end

function Lua_AllianceProxy:rLeagueDealLog(mp) -- 请求工会交易日志返回
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50208009();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer50208009(msg);
	end
end

function Lua_AllianceProxy:iLeagueDealPlanUpdate(mp) -- 通知方案更新
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80208011();
		msg:ParseFromString(mp.data);
		DataCenter.allianceData:fromServer80208011(msg);
	end
end