--联盟系统 联盟功能悬浮菜单按钮Vo
Lua_AllianceMenuListVo = class("Lua_AllianceMenuListVo");

-- 悬浮菜单按钮类型
-------------------------------------联盟---------------------------------------------
Lua_AllianceMenuListVo.MEMBER_INFO = "MEMBER_INFO"; --玩家信息 
Lua_AllianceMenuListVo.APPOINT_DUTY = "APPOINT_DUTY"; --任命 
Lua_AllianceMenuListVo.TRANSFER_LEADER = "TRANSFER_LEADER"; --转让盟主
Lua_AllianceMenuListVo.EXPEL_MEMBER = "EXPEL_MEMBER"; --逐出成员

Lua_AllianceMenuListVo.VICE_LEADER_DUTY = "VICE_LEADER_DUTY"; --副盟主职位 
Lua_AllianceMenuListVo.ELITE_DUTY = "ELITE_DUTY"; --精英职位 
Lua_AllianceMenuListVo.GENERAL_DUTY = "GENERAL_DUTY"; --成员职位

Lua_AllianceMenuListVo.APPLY_INFO = "APPLY_INFO"; --申请信息 
Lua_AllianceMenuListVo.MASS_MAIL = "MASS_MAIL"; --群发邮件 
Lua_AllianceMenuListVo.EXIT_LEAGUE = "EXIT_LEAGUE"; --退出联盟
Lua_AllianceMenuListVo.DISMISS = "DISMISS"; --解散联盟

function Lua_AllianceMenuListVo:ctor(mainBtnType, data, subListData)
	self.mainBtnType = mainBtnType;
	self.data = data;
	self.subListData = subListData;
	self.owner = self;
	self.onClick = self.onClick;
end


function Lua_AllianceMenuListVo.Get:btnName()
	if self.mainBtnType == Lua_AllianceMenuListVo.MEMBER_INFO then
		return LanUtil.getValue(201122);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.APPOINT_DUTY then
		return LanUtil.getValue(201123);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.TRANSFER_LEADER then
		return LanUtil.getValue(201124);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.EXPEL_MEMBER then
		return LanUtil.getValue(201125);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.VICE_LEADER_DUTY then
		return LanUtil.formateStr(201126, DataCenter.allianceData.viceLeaderCount, DataCenter.allianceData.getCurLevelVo.vice_leader_num);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.ELITE_DUTY then
		return LanUtil.formateStr(201127, DataCenter.allianceData.eliteCount, DataCenter.allianceData.getCurLevelVo.elite_num);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.GENERAL_DUTY then
		return LanUtil.getValue(201128);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.APPLY_INFO then
		return LanUtil.getValue(201129);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.MASS_MAIL then
		return LanUtil.getValue(201130);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.EXIT_LEAGUE then
		return LanUtil.getValue(201131);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.DISMISS then
		return LanUtil.getValue(201173);
	end
end

function Lua_AllianceMenuListVo:onClick()
	if self.mainBtnType == Lua_AllianceMenuListVo.MEMBER_INFO then
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.data.roleId, self.data.serverFlag);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.TRANSFER_LEADER then
		self:showTranferCommanderTip();
	elseif self.mainBtnType == Lua_AllianceMenuListVo.EXPEL_MEMBER then
		self:showExpelMemberTip();
	elseif self.mainBtnType == Lua_AllianceMenuListVo.VICE_LEADER_DUTY then
		if DataCenter.allianceData.viceLeaderCount >= DataCenter.allianceData.getCurLevelVo.vice_leader_num then
			OperateAlert.showLangValue(201142);
			return;
		end
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAppointMemberDuty(self.data, Lua_AllianceData.DUTY_TYPE.VICE_COMMANDER);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.ELITE_DUTY then
		if DataCenter.allianceData.eliteCount >= DataCenter.allianceData.getCurLevelVo.elite_num then
			OperateAlert.showLangValue(201142);
			return;
		end
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAppointMemberDuty(self.data, Lua_AllianceData.DUTY_TYPE.ELITE_MEMBER);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.GENERAL_DUTY then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAppointMemberDuty(self.data, Lua_AllianceData.DUTY_TYPE.GENERAL_MEMBER);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.APPLY_INFO then
		Lua_WindowUtil.openWin("Lua_AllianceApplyWindow", Lua_WinParam.ACTION_OPEN);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.MASS_MAIL then
		Lua_WindowUtil.openWin("Lua_AllianceMailWindow", Lua_WinParam.ACTION_OPEN);
	elseif self.mainBtnType == Lua_AllianceMenuListVo.EXIT_LEAGUE then
		if DataCenter.allianceData.competeStage == 1 and DataCenter.allianceData.competeJoinType == 1 then
			local tipsData = {
				btnType = 1,
				des = LanUtil.getValue(201290);
				cancelLabel = LanUtil.getValue(201288);
				sureLabel = LanUtil.getValue(201291);
				owner = self;
				sureFun = self.showExitLeagueTip;
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
		else
			self:showExitLeagueTip();
		end
	elseif self.mainBtnType == Lua_AllianceMenuListVo.DISMISS then
		if DataCenter.allianceData.competeStage == 1 and DataCenter.allianceData.competeJoinType == 1 then
			OperateAlert.showLangValue(201292);
			return;
		end
		Lua_WindowUtil.openWin("Lua_AllianceDisbandWindow", Lua_WinParam.ACTION_OPEN);
	end

	if self.subListData == nil then
		Lua_WindowUtil.openWin("Lua_AllianceMenuListWindow", Lua_WinParam.ACTION_CLOSE);
	else
		Lua_MsgUtil.callFunc("OPEN_MENULIST_SUBBTN", self.mainBtnType);
	end
end

function Lua_AllianceMenuListVo:showTranferCommanderTip()
	if self.data.online == 0 and self.data.offlineTime >= DataCenter.allianceUtil:getConstConfig("leader_offline", 1) then
		OperateAlert.showLangValue(201145);
		return;
	end
		
	local tipsData = {
		des = LanUtil.formateStr(201146, self.data.name), btnType = 1,
		time = DataCenter.allianceUtil:getConstConfig("league_sure_click_time", 5)[4],
		owner = self, callData = self.data.roleId
	};
	tipsData.sureFun = function(owner, data)
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sTranferCommander(data.callData);
	end
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceMenuListVo:showExpelMemberTip()
	local tipsData = {
		des = LanUtil.formateStr(201144, self.data.name),
		time = DataCenter.allianceUtil:getConstConfig("league_sure_click_time", 5)[3],
		btnType = 1, owner = self, callData = self.data.roleId
	};
	tipsData.sureFun = function(owner, data)
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sExpelMember(data.callData);
	end
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceMenuListVo:showExitLeagueTip()
	local tipsData = {
		des = LanUtil.getValue(201141),
		time = DataCenter.allianceUtil:getConstConfig("league_sure_click_time", 5)[2],
		btnType = 1, owner = self
	};
	tipsData.sureFun = function()
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sExitAlliance();
	end
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end