--联盟系统 联盟Util
checkRequire("Lua_AllianceLevelVo");
checkRequire("Lua_AllianceContributeTypeVo");
checkRequire("Lua_AllianceContributeRewardVo");
checkRequire("Lua_AllianceBossStageVo");
checkRequire("Lua_AllianceBossRankRewardVo");
checkRequire("Lua_AllianceRedPacketVo");
checkRequire("Lua_AllianceTreasuryVo");
checkRequire("Lua_AllianceBuildTaskVo");
checkRequire("Lua_AllianceChallengeConfigVo");
Lua_AllianceUtil = class("Lua_AllianceUtil");

function Lua_AllianceUtil:ctor()
end

function Lua_AllianceUtil:dispose()
end

function Lua_AllianceUtil:getConstConfig(key, type)
	if self._constConfig == nil then
		self._constConfig = getConfig("league_const");
	end
    local config = self._constConfig[key];
    if config ~= nil then
        if type == 1 then
            return config.value;
        elseif type == 2 then
            return config.float_value1;
        elseif type == 3 then
            return config.float_value2;
        elseif type == 4 then
            return config.strvalue;
       	elseif type == 5 then
            return config.jsonvalue;
        elseif type == 6 then
            return config.value2;
        elseif type == 7 then
            return config.value3;
        end
    end
    return nil;
end

-- 根据位置返回连联盟所处的身份
function Lua_AllianceUtil:getLeagueIdentityByPosition(position)
    local identityList = self:getConstConfig("position_name", 5);
    return identityList[position];
end

function Lua_AllianceUtil:getLevelConfig(level, name)
	if self._levelConfig == nil then
		self._levelConfig = getConfig("league_level");
	end
    local config = self._levelConfig[level];
    if config ~= nil then
    	return config[name];
    end
    return nil;
end

function Lua_AllianceUtil:getDutyPower(duty, type)
    if self._dutyPowerList == nil then
        self._dutyPowerList = {};
        local config = getConfig("league_right");
        for k, v in pairs(config) do
            for i, j in pairs(v.position_list) do
                if self._dutyPowerList[j] == nil then
                    self._dutyPowerList[j] = Array();
                end
                self._dutyPowerList[j]:add(k);
            end
        end
    end

    local isTrue = false;
    if self._dutyPowerList[duty] ~= nil then
        isTrue = self._dutyPowerList[duty]:indexOf(type) ~= -1;
    end
    return isTrue;
end

function Lua_AllianceUtil.Get:getAllianceLevelArr()
    if self._allianceLevelArr == nil then
        self._allianceLevelArr = Array();
        local config = getConfig("league_level");
        local vo;
        for k, v in pairs(config) do
            vo = Lua_AllianceLevelVo.new(v.id, v);
            self._allianceLevelArr:add(vo);
        end
    end
    return self._allianceLevelArr;
end

--获取联盟头像
function Lua_AllianceUtil:getAllianceHeadByIndex(index, types)
    if types == 1 then--小头像
        return "allianceHead_" .. index.."_s"
    elseif types == 2 then--大头像
        return "allianceHead_" .. index.."_b"
    end
    return "";
end














-------------------------------联盟Boss-------------------------------

function Lua_AllianceUtil:initAllianceBossInfo()
    if self._allianceBossInfo == nil then
        self._allianceBossInfo = {};
        self._allianceBossArr = Array();

        local config = getConfig("league_boss");
        local vo;
        for k, v in pairs(config) do
            vo = Lua_AllianceBossStageVo.new(v.id, v);
            self._allianceBossInfo[v.id] = vo;
            self._allianceBossArr:add(vo);
        end
    end
end

function Lua_AllianceUtil.Get:getAllianceBossArr()
    self:initAllianceBossInfo();
    return self._allianceBossArr;
end

function Lua_AllianceUtil:getAllianceBossVo(id)
    self:initAllianceBossInfo();
    return self._allianceBossInfo[id];
end

function Lua_AllianceUtil:getBossRankRewardArr(stageId)
    if self._bossRankRewardList == nil then
        self._bossRankRewardList = {};

        local config = getConfig("league_boss_rank");
        local vo;
        for k, v in pairs(config) do
            vo = Lua_AllianceBossRankRewardVo.new(v.id, v);

            if self._bossRankRewardList[v.stage_id] == nil then
                self._bossRankRewardList[v.stage_id] = Array();
            end
            self._bossRankRewardList[v.stage_id]:add(vo);
        end
    end
    return self._bossRankRewardList[stageId];
end





















-------------------------------联盟红包-------------------------------

function Lua_AllianceUtil.Get:getAllianceRedPacketArr()
     if self._allianceRedPacketArr == nil then
        self._allianceRedPacketArr = Array();
        local config = getConfig("league_red_package");
        local vo;
        for k, v in pairs(config) do
            vo = Lua_AllianceRedPacketVo.new(k, Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE, v);
            self._allianceRedPacketArr:add(vo);
        end
    end
    return self._allianceRedPacketArr;
end

function Lua_AllianceUtil:getWelfareRedPacketArr()
     if self._welfareRedPacketArr == nil then
        self._welfareRedPacketArr = Array();
        self._welfareRedPacketDic = {};

        local config = getConfig("league_welfare_red_package");
        local vo;
        for k, v in pairs(config) do
            vo = Lua_AllianceRedPacketVo.new(k, Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE, v);
            self._welfareRedPacketArr:add(vo);
            self._welfareRedPacketDic[k] = vo;
        end
    end
    return self._welfareRedPacketArr;
end

function Lua_AllianceUtil:getWelfareRedPacketVo(id)
    if self._welfareRedPacketDic == nil then
        self:getWelfareRedPacketArr();
    end
    return self._welfareRedPacketDic[id];
end

function Lua_AllianceUtil:getWelfareRedPacketLimitArr(duty)
    local arr = self:getWelfareRedPacketArr();
    local limitArr = Array();
    for i = 1, arr:getSize() do
        if arr[i].league_position == nil or arr[i].league_position >= duty then
            limitArr:add(arr[i]);
        end
    end
    return limitArr;
end















-------------------------------联盟宝库-------------------------------

function Lua_AllianceUtil:getAllianceTreasuryArrByPack(treasuryType)
    if self._allianceTreasuryList == nil then
        self._allianceTreasuryList = {};
        local config = getConfig("league_treasury");
        for k, v in pairs(config) do
            if self._allianceTreasuryList[v.type] == nil then
                self._allianceTreasuryList[v.type] = Array();
            end
            self._allianceTreasuryList[v.type]:add(v);
        end
    end

    local itemInfo;
    if treasuryType == Lua_AllianceData.TREASURY_TYPE.EQUIP then
        itemInfo = self.getAllianceEquipInfo;
    elseif treasuryType == Lua_AllianceData.TREASURY_TYPE.RUNE then
        itemInfo = self.getAllianceRuneInfo;
    end

    local arr = self._allianceTreasuryList[treasuryType];
    local packItemArr = Array();
    local vo;
    local uidArr;
    local packNum;
    if arr ~= nil then
        for i = 1, arr:getSize() do 
            if itemInfo ~= nil then
                uidArr = itemInfo[arr[i].id];
                if uidArr ~= nil then
                    for i = 1, uidArr:getSize() do
                        vo = Lua_AllianceTreasuryVo.new(arr[i].id);
                        vo.packNum = 1;
                        vo.uniqueId = uidArr[i];
                        packItemArr:add(vo); 
                    end
                end
            else
                vo = Lua_AllianceTreasuryVo.new(arr[i].id);
                vo.packNum = DataCenter.packData:getItemCountById(arr[i].id);
                if vo.packNum > 0 then
                    packItemArr:add(vo); 
                end        
            end   
        end
    end
    return packItemArr;
end

function Lua_AllianceUtil.Get:getAllianceEquipInfo()
    local evo;
    local list = {};
    local equipVoArr = DataCenter.equipData.equipPackUidArr;
    for i = 1, equipVoArr:getSize() do
        evo = DataCenter.equipData:getEquipVoByUid(equipVoArr[i]);
        if list[evo.id] == nil then
            list[evo.id] = Array();
        end 
        list[evo.id]:add(evo.unique_id);
    end
    return list;
end

function Lua_AllianceUtil.Get:getAllianceRuneInfo()
    local list = {};
    local runeVoArr = DataCenter.runesData.getRunesPackInfo;
    for i = 1, runeVoArr:getSize() do
        if list[runeVoArr[i].id] == nil then
            list[runeVoArr[i].id] = Array();
        end 
        list[runeVoArr[i].id]:add(runeVoArr[i].unique_id);
    end
    return list;
end

-------------------------------联盟成长-------------------------------

function Lua_AllianceUtil.Get:getContributeTypeArr()
    if self._contributeTypeArr == nil then
        self._contributeTypeArr = Array();
        local config = getConfig("league_contribute");
        local vo;
        for k, v in pairs(config) do
            vo = Lua_AllianceContributeTypeVo.new(v.id, v);
            self._contributeTypeArr:add(vo);
        end
    end
    return self._contributeTypeArr;
end

function Lua_AllianceUtil.Get:getContributeRewardArr()
    if self._contributeRewardArr == nil then
        self._contributeRewardArr = Array();
        local config = getConfig("league_contribute_reward");
        local vo;
        for k, v in pairs(config) do
            vo = Lua_AllianceContributeRewardVo.new(v.id, v);
            self._contributeRewardArr:add(vo);
        end
    end
    return self._contributeRewardArr;
end

function Lua_AllianceUtil.Get:getBuildTaskArr()
    if self._buildTaskArr == nil then
        self._buildTaskArr = Array();
        local config = getConfig("league_build_task");
        local vo;
        for k, v in pairs(config) do
            vo = Lua_AllianceBuildTaskVo.new(v.id, v);
            self._buildTaskArr:add(vo);
        end
    end
    return self._buildTaskArr;
end
















-------------------------------联盟挑战-------------------------------


function Lua_AllianceUtil:initChallengeInfo()
    if self._challengeInfo == nil then
        self._challengeInfo = {};
         local config = getConfig("league_challenge");
         for k, v in pairs(config) do
            if self._challengeInfo[v.boss_type] == nil then
                self._challengeInfo[v.boss_type] = Array();
            end
            self._challengeInfo[v.boss_type]:add(v);
        end 
    end
end

function Lua_AllianceUtil.Get:getChallengeTypeArr()
    self:initChallengeInfo();

    if self._challengeTypeArr == nil then
        self._challengeTypeArr = Array();
        for k, v in pairs(self._challengeInfo) do
            self._challengeTypeArr:add(k);
        end
        self._challengeTypeArr:sortf(self, self.sortChallengeTypeArr);
    end
    return self._challengeTypeArr;
end

function Lua_AllianceUtil:sortChallengeTypeArr(a, b)
    return a.id > b.id;
end

function Lua_AllianceUtil:getChallengeConfigVo(id)
    if self._challengeConfigList == nil then
        self._challengeConfigList = {};
    end
    if self._challengeConfigList[id] == nil then
        self._challengeConfigList[id] = Lua_AllianceChallengeConfigVo.new(id);
    end
    return self._challengeConfigList[id];
end

function Lua_AllianceUtil:getChallengeDefaultId(bossType)
    self:initChallengeInfo();

    local arr = self._challengeInfo[bossType];
    if arr ~= nil then
        for i = 1, arr:getSize() do
            if arr[i].difficulty_type == 2 and arr[i].difficulty_level == 1 then
                return arr[i].id;
            end
        end
    end
    return nil;
end




















-------------------------------公会技巧-------------------------------

function Lua_AllianceUtil:getScienceNode(id)
    if self.scienceConfig == nil then
        self.scienceConfig = getConfig("league_science");
    end

    local data = self.scienceConfig[id];
    if data ~= nil then
        return data.node;
    end
    return nil;
end

function Lua_AllianceUtil:getScienceRedDot(idx)
    if self._scienceRedDotList == nil then
        self._scienceRedDotList = {Lua_RedPointList.LeagueScienceDef, Lua_RedPointList.LeagueScienceAtt, 
            Lua_RedPointList.LeagueScienceAss, Lua_RedPointList.LeagueScienceCon};
    end
    return self._scienceRedDotList[idx];
end















-------------------------------公会对抗-------------------------------

function Lua_AllianceUtil.Get:getLeagueDuelRuleConfig()
    if self._leagueDuelRuleConfig == nil then
        self._leagueDuelRuleConfig = getConfig("league_combat_rule");
    end
    return self._leagueDuelRuleConfig;
end

function Lua_AllianceUtil.Get:getCompeteLeagueRewardConfig()
    if self._competeLeagueRewardConfig == nil then
        self._competeLeagueRewardConfig = getConfig("league_combat_rank_reward");
    end
    return self._competeLeagueRewardConfig;
end

function Lua_AllianceUtil.Get:getCompeteRewardConfig()
    if self._competeRewardConfig == nil then
        self._competeRewardConfig = getConfig("league_combat_member_rank_reward");
    end
    return self._competeRewardConfig;
end

function Lua_AllianceUtil:getCompeteReward(_type, rank)
    local config;
    if _type == 1 then
        config = self.getCompeteLeagueRewardConfig;
    else
        config = self.getCompeteRewardConfig;
    end
    
    local rankRange;
    for k, v in pairs(config) do
        rankRange = v.rank_range;
        if rankRange[2] ~= nil then
            if rank == rankRange[1] or rank == rankRange[2] or (rank > rankRange[1] and rank < rankRange[2]) then
                return v.reward;
            end
        elseif rank == rankRange[1] then
            return v.reward;
        end
    end
    return nil;
end

function Lua_AllianceUtil:transNumber(num, isShow)
    num = tonumber(tostring(num));
    isShow = isShow == nil and true or isShow;
    local absNum = Mathf.Abs(num);
    local str;
    if absNum < 1000 then
        str = num;
    elseif absNum < 1000000 then
        str = getPreciseDecimal(absNum / 1000, 1) .. "k";
    else
        str = getPreciseDecimal(absNum / 1000000, 1) .. "m";
    end

    if num >= 0 then
        if isShow then
            str = "+" .. str 
        end
    else
        str = "-" .. str 
    end
    return str;
end










-------------------------------公会交易行-------------------------------

function Lua_AllianceUtil:getDealConstConfig(key, type)
    if self._dealConstConfig == nil then
        self._dealConstConfig = getConfig("league_transaction_const");
    end
    local config = self._dealConstConfig[key];
    if config ~= nil then
        if type == 1 then
            return config.int_value;
        elseif type == 2 then
            return config.str_value;
        elseif type == 3 then
            return config.json_value;
        end
    end
    return nil;
end

function Lua_AllianceUtil.Get:getDealHeroDic()
    if self._dealHeroDic == nil then
        self._dealHeroDic = {};
        local config = getConfig("league_transaction_pool");
        for k, v in pairs(config) do
            if self._dealHeroDic[v.type] == nil then
                self._dealHeroDic[v.type] = {};
            end
            self._dealHeroDic[v.type][v.camp] = v.hero_list;
        end
    end
    return self._dealHeroDic;
end

function Lua_AllianceUtil:getDealHeroIdArr(t, campType)
    local arr = Array();
    local list;
    if campType == Lua_HeroUtil.All_TYPE then
        local siftArr = DataCenter.heroUtil.siftInfo;
        for i = 1, siftArr:getSize() do
            list = self.getDealHeroDic[t][siftArr[i]];
            for j = 1, #list do
                arr:add(list[j]);
            end
        end
    else
        list = self.getDealHeroDic[t][campType];
        for i = 1, #list do
            arr:add(list[i]);
        end
    end
    return arr;
end