Lua_ArenaData = class("Lua_ArenaData");
Lua_ArenaData.dailyArenaReward = 1; -- 每日奖励
Lua_ArenaData.seasonArenaReward = 2; -- 赛季奖励
function Lua_ArenaData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ArenaData:dispose()
	self.isSettleTime = false; -- 是否结算时间中

	self.self_rank = 0;
	self.self_score = 0;
	self.role_list = nil;
	self.free_times = 0;
	self.recharge_times = 0;
	self.skip_fight = 0;
	self.fight_times = 0;
	self.settle_tick = 0;
	self.boxStateDic = nil;
	self.likeTimes = 0;
	self.daily_settle_tick = 0;
	self.settle_tick = 0;
end

function Lua_ArenaData:fromServer50187001(msg)
	if msg == nil then
		return;
	end
	self.self_rank = msg.self_rank; -- 玩家排名
	self.self_score = msg.self_score -- 玩家积分
	self.role_list = msg.role_list; -- 挑战对手列表
	self.free_times = msg.free_times; -- 剩余免费次数
	self.recharge_times = msg.recharge_times; -- 每日付费购买挑战剩余次数
	self.skip_fight = msg.skip_fight; -- 是否跳过战斗：1是，0否
	self.fight_times = msg.fight_times; -- 挑战次数
	self.settle_tick = msg.settle_tick; -- 结算时间戳
	self:setBoxRewardState(msg.reward_list);
end

function Lua_ArenaData:fromServer50187002(msg)
	if msg == nil then
		return;
	end
	
	self.role_list = msg.role_list; -- 挑战对手列表
end

function Lua_ArenaData:fromServer50187003(msg, arr)
	if msg == nil then
		return;
	end
	self:setBoxRewardState(msg.reward_list, arr);
end

function Lua_ArenaData:setBoxRewardState(list, arr)
	self.bBoxReward = false;
	if list == nil then
		return;
	end

	if self.boxStateDic == nil then
		self.boxStateDic = {};
	end
	local obj;
	for i = 1, #list do
		obj = list[i];
		if tonumber(obj.value) == 1 then
			self.bBoxReward = true;
		end
		if arr and tonumber(obj.value) == 2 and tonumber(obj.value) ~= self.boxStateDic[tonumber(obj.key)] then
			arr:add(tonumber(obj.key));
		end
		self.boxStateDic[tonumber(obj.key)] = tonumber(obj.value);
	end

	self:checkRedPoint();
end

function Lua_ArenaData:getBoxRewardState(id)
	return self.boxStateDic[id];
end

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
function Lua_ArenaData:checkRedPoint()
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Arena_FreeTimes, self.isSettleTime ~= true and self.free_times > 0);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Arena_Reward, self.bBoxReward == true);
end