checkRequire("Lua_ArenaUtil");
checkRequire("Lua_ArenaData");
Lua_ArenaProxy = class("Lua_ArenaProxy");
function Lua_ArenaProxy:ctor()
	DataCenter.arenaUtil = Lua_ArenaUtil.new();
	DataCenter.arenaData = Lua_ArenaData.new();

	Lua_MsgUtil.addLuaMsg(50187001, self, self.rArenaInfo); -- 请求斗技场信息（返回）
	Lua_MsgUtil.addLuaMsg(50187002, self, self.rRefreshOpponent); -- 请求刷新挑战对手（返回）
	Lua_MsgUtil.addLuaMsg(50187003, self, self.rReceiveBoxReward); -- 请求领取挑战次数奖励（返回）
	Lua_MsgUtil.addLuaMsg(50187004, self, self.rReportInfo); -- 请求斗技场战报信息（返回）
	Lua_MsgUtil.addLuaMsg(50187005, self, self.rRankInfo); -- 请求斗技场排行信息（返回）
	Lua_MsgUtil.addLuaMsg(50187006, self, self.rLikePlayer); -- 请求点赞排行榜玩家（返回）
	Lua_MsgUtil.addLuaMsg(50187007, self, self.rSkipFight); -- 请求勾选跳过战斗（返回）
	Lua_MsgUtil.addLuaMsg(50187008, self, self.rReadRewardInfo); -- 请求查看排名奖励（返回）

	Lua_MsgUtil.addLuaMsg(80187004, self, self.updateRecord); -- 斗技场防守失败（通知）
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 事件监听





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求斗技场信息
function Lua_ArenaProxy:sArenaInfo()
	sendMsg(10187001);
end

-- 请求刷新挑战对手
function Lua_ArenaProxy:sRefreshOpponent()
	sendMsg(10187002);
end

-- 请求领取挑战次数奖励
function Lua_ArenaProxy:sReceiveBoxReward(index)
	local cmd = ProtoPublic_pb.Proto10187003();
	cmd.index = index;
	sendMsg(10187003, cmd);
end

-- 请求斗技场战报信息
function Lua_ArenaProxy:sReportInfo()
	sendMsg(10187004);
end

-- 请求斗技场排行信息
function Lua_ArenaProxy:sRankInfo(page)
	local cmd = ProtoPublic_pb.Proto10187005();
	cmd.page = page;
	sendMsg(10187005, cmd);
end

-- 请求领取挑战次数奖励
function Lua_ArenaProxy:sLikePlayer(player_id)
	local cmd = ProtoPublic_pb.Proto10187006();
	cmd.player_id = tonumber(player_id);
	sendMsg(10187006, cmd);
end

-- 请求勾选跳过战斗
function Lua_ArenaProxy:sSkipFight()
	sendMsg(10187007);
end

-- 请求勾选跳过战斗
function Lua_ArenaProxy:sReadRewardInfo()
	sendMsg(10187008);
end







------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_ArenaProxy:rArenaInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50187001();
		msg:ParseFromString(mp.data);
		DataCenter.arenaData:fromServer50187001(msg);
		Lua_MsgUtil.callFunc("UPDATE_ARENA_INFO");
	end
end

function Lua_ArenaProxy:rRefreshOpponent(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50187002();
		msg:ParseFromString(mp.data);
		DataCenter.arenaData:fromServer50187002(msg);
		OperateAlert.showLangValue(303019);
		Lua_MsgUtil.callFunc("UPDATE_ARENA_OPPONENT");
	end
end

function Lua_ArenaProxy:rReceiveBoxReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50187003();
		msg:ParseFromString(mp.data);
		local arr = Array();
		DataCenter.arenaData:fromServer50187003(msg, arr);
		Lua_MsgUtil.callFunc("UPDATE_ARENA_REWARD", arr);
	end
end

function Lua_ArenaProxy:rReportInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50187004();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_ARENA_REPORT", msg);
	end
end

function Lua_ArenaProxy:rRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50187005();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_ARENA_RANK", msg);
	end
end

function Lua_ArenaProxy:rLikePlayer(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50187006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_SINGLE_ARENA_RANK", msg);
	end
end

function Lua_ArenaProxy:rSkipFight(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50187007();
		msg:ParseFromString(mp.data);
		DataCenter.arenaData.skip_fight = msg.state;
	end
end

function Lua_ArenaProxy:rReadRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50187008();
		msg:ParseFromString(mp.data);
		DataCenter.arenaData.daily_settle_tick = msg.daily_settle_tick;
		DataCenter.arenaData.settle_tick = msg.settle_tick;
		Lua_MsgUtil.callFunc("UPDATE_SHOWTIME");
	end
end

function Lua_ArenaProxy:updateRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80187004();
		msg:ParseFromString(mp.data);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Arena_Record, msg.state == 1);
	end
end