Lua_ArenaUtil = class("Lua_ArenaUtil");
function Lua_ArenaUtil:ctor()
    self:superCall("ctor");
end

function Lua_ArenaUtil:getConstConfig(key, valType)
    local config = getConfig("arena_const", key);
    if config ~= nil then
        if valType == 1 then
            return config.value;
        elseif valType == 2 then
            return config.float_value;
        elseif valType == 3 then
            return config.strvalue;
        elseif valType == 4 then
            return config.jsonvalue;
        end
    end
    return nil;
end

function Lua_ArenaUtil:initRewardInfo()
    if self.rewardDic == nil then
        self.rewardDic = {};
        local config = getConfig("arena_settle_reward");
        for k,v in pairs(config) do
            if self.rewardDic[v.type] == nil then
                self.rewardDic[v.type] = Array();
            end
            self.rewardDic[v.type]:add(v);
        end
        for k,v in pairs(self.rewardDic) do
            v:sort("id", false);
        end
    end
end

function Lua_ArenaUtil:getRewardsArr(rType)
    self:initRewardInfo();
    return self.rewardDic[rType];
end

function Lua_ArenaUtil:getBoxArr(sortType)
    if self.boxArr == nil then
        self.boxArr = Array();
        local config = getConfig("arena_week_reward");
        for k,v in pairs(config) do
            self.boxArr:add(v);
        end
    end
    if sortType == 1 then
        self.boxArr:sort("id", false);
    elseif sortType == 2 then
        self.boxArr:sortf(self, self.boxSortFun);
    end
    return self.boxArr;
end

function Lua_ArenaUtil:boxSortFun(a, b)
    local state_a = DataCenter.arenaData:getBoxRewardState(a.id);
    local state_b = DataCenter.arenaData:getBoxRewardState(b.id);
    if state_a == 0 and state_b == 1 then
        return false;
    elseif state_a == 0 and state_b == 2 then
        return true;
    elseif state_a == 1 and state_b ~= 1 then
        return true;
    elseif state_a == 2 and state_b ~= 2 then
        return false;
    else
        if a.id > b.id then
            return false;
        end
    end
    return true;
end