-- 兑换活动
checkRequire("Lua_CashRewardVo")
Lua_CashRewardData = class("Lua_CashRewardData")
function Lua_CashRewardData:ctor()
	self.actIdx = { 101026, 101025, 101024, 101023 }; --活动id
	self.actSort = { 13, 12, 11, 10 }; --活动顺序
	self:dispose();

	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateRedDot);--道具数量增加时更新红点
	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateRedDot); 
end

function Lua_CashRewardData:dispose()
	self.roundConfigDic = nil;
	self.curActivityId = nil;
	self.lastActivityId = nil;
end

function Lua_CashRewardData:fromServer50197024(msg)
	if msg == nil then
		return;
	end

	local list = msg.round_state;
	if #list <= 0 then
		DataCenter.internalActData:updateActivityInfo(101026); -- 活动界面是否开启
		DataCenter.internalActData:updateActivityInfo(101025); -- 活动界面是否开启
		DataCenter.internalActData:updateActivityInfo(101024); -- 活动界面是否开启
		DataCenter.internalActData:updateActivityInfo(101023); -- 活动界面是否开启
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CashReward_Wind, false);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CashReward_Ground, false);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CashReward_Water, false);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.CashReward_Fire, false);
		return;
	end
	
	self.curActivityId = #list > 0 and tonumber(list[1].round_id) or nil;
	if #list == 2 then
		self.lastActivityId = tonumber(list[2].round_id);
	end

	if self.roundConfigDic == nil then
		self.roundConfigDic = {};
		local config = getConfig("cash_reward");
		local obj;
		local vo;
		for i, v in pairs(config) do
			obj = v;
			vo = self:getRoundConfigDicById(obj.id);
			if vo == nil then 
				vo = Lua_CashRewardVo.new(obj.id,self.actIdx[i]);
				self.roundConfigDic[obj.id] = vo;
				if type(vo.id) ~= "number" then 
					self.roundSort = vo.roundSort;
				end
			end
		end
	end
	self:updateServerInfo(msg);
	self:sortActivity(msg);
	self:updateActivityInfo();
end

-- 活动排序
function Lua_CashRewardData:sortActivity(msg)
	local obj;
	local actId;
	local actVo;
	local count = #self.roundSort
	local arrSort = { 13, 12, 11, 10 }; -- 需与self.actSort保持一致

	if msg ~= nil and #msg.round_state == 2 then
		obj = msg.round_state;
		local isChange = (obj[1].round_id == self.roundSort[1] and obj[2].round_id == self.roundSort[4]) or 
							(obj[2].round_id == self.roundSort[1] and obj[1].round_id == self.roundSort[4]);
		if isChange then
			arrSort[1], arrSort[4] = self.actSort[4], self.actSort[1];
		end
	end

	for i = 1, count  do
		obj = self.roundSort[i];
		actId = self.roundConfigDic[obj].actIdx;
		actVo = DataCenter.internalActData:getActivityVo(actId); -- 获取活动信息
		actVo.sort = arrSort[i];
	end
end

-- 更新活动信息：活动开启或关闭
function Lua_CashRewardData:updateActivityInfo()
	local obj;
	local actId;
	local actVo;
	local openState;
	local closeTick;

	for i = 1, #self.roundConfigDic do
		obj = self.roundConfigDic[i];
		actId = obj.actIdx; -- 活动id
		closeTick = obj.closeTick; -- 关闭时间戳
		actVo = DataCenter.internalActData:getActivityVo(actId); -- 获取活动信息
		openState = (obj.closeResidueTime == nil or obj.closeResidueTime <= 0 ) and 0 or 1; -- 1：开启，0：关闭
		DataCenter.internalActData:updateActivityInfo(actId, openState, closeTick); -- 活动界面是否开启
	end
end

-- 更新服务端数据
function Lua_CashRewardData:updateServerInfo(msg)
	if #msg.round_state > 2 then
		return;
	end

	local list = msg.round_state;
	local idDic = {};
	local actRedPoint;
	local obj;
	local vo;

	for i = 1, #list do
		obj = list[i];
		idDic[i] = obj.round_id;
		vo = self:getRoundConfigDicById(obj.round_id);
		vo:updateServerInfo(obj);

		-- 红点
		actRedPoint = self:judgeRedPointName(vo.roundId);
		local bShow = vo.closeResidueTime > 0 and (vo.showRedPoint == 1 or vo.hasReward);
		DataCenter.redPointData:updateRedPointState(actRedPoint, bShow);
	end

	for i = 1, #self.roundConfigDic do
		obj = self.roundConfigDic[i];
		if obj.roundId ~= idDic[1] and (idDic[2] == nil and true or obj.roundId ~= idDic[2]) then
			obj.closeResidueTime = 0;
		end
	end
end

--通过id获取轮次道具等信息
function Lua_CashRewardData:getRoundConfigDicById(id)
	if id == nil or self.roundConfigDic == nil or self.roundConfigDic[id] == nil then
		return nil;
	end
	return self.roundConfigDic[id];
end

-- 根据roundID获取红点表中对应红点
function Lua_CashRewardData:judgeRedPointName(roundId)
	if roundId == nil then
		return;
	end

	if roundId == 1 then 
		return Lua_RedPointList.CashReward_Wind;
	elseif roundId == 2 then
		return Lua_RedPointList.CashReward_Ground;
	elseif roundId == 3 then
		return Lua_RedPointList.CashReward_Water;
	elseif roundId == 4 then
		return Lua_RedPointList.CashReward_Fire;
	end
end

function Lua_CashRewardData:updateRedDot(dic)
	if not DataCenter.funcOpenData:isOpened(10217) then
		return;
	end

	self:updateSingleRedDot(self.curActivityId, dic);
	self:updateSingleRedDot(self.lastActivityId, dic);
end

function Lua_CashRewardData:updateSingleRedDot(actId, dic)
	local actVo = self:getRoundConfigDicById(actId);
	local bOpened = actVo ~= nil and actVo.closeResidueTime ~= nil and actVo.closeResidueTime > 0;
	if bOpened then
		local costId = getConfig("cash_reward", actId, "item_cost");
		local hasReward = actVo.hasReward;
		if hasReward ~= true and costId ~= nil and dic[costId] ~= nil then
			actVo:hasReceiveReward();
			local actRedPoint = self:judgeRedPointName(actId);
			local bShow = actVo.showRedPoint == 1 or actVo.hasReward;
			DataCenter.redPointData:updateRedPointState(actRedPoint, bShow);
		end
	end
end