Lua_ChampionshipChatItem = class("Lua_ChampionshipChatItem", Lua_DragContainerItem)
function Lua_ChampionshipChatItem:ctor(p)
	self:superCall("ctor", p, "ChampionshipChatItem_skin");
end

function Lua_ChampionshipChatItem:buildShowItem()
	self:superCall("buildShowItem");
	self.height = 0;
end

function Lua_ChampionshipChatItem:dispose()
	if self.emjioEff then
		self.emjioEff:dispose();
		self.emjioEff = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipChatItem:getWidth()
    return 720;
end

function Lua_ChampionshipChatItem:getHeight()
	return self.height + 50;
end

function Lua_ChampionshipChatItem:setData(data)
	self.nameText.text = data.chat_player.name;
	self.nameText:resetSize();

	local info = data.class_event_chat_role
	local config = getConfig("classic_event_guess_level_reward", info.guess_level);
	self.levelIcon:setAltas("championship_1", config.icon_sprite);
	self.levelText.text = LanUtil.formateStr(10054, tostring(info.guess_level));

	self.quizText.text = LanUtil.formateStr(540052, tostring(info.guess_win_rate), tostring(info.guess_times));
	self.quizText:setLocation(self.nameText.posX + self.nameText.width + 10.5, -17, 0);

	if data.content_type == Lua_ChatData.CONTENT_DYNANIC_EMOJI then
		self.chatText.text = nil;

		local emojiInfo = DataCenter.chatData:getConfigById(data.content);
		if self.emjioEff == nil then
			self.emjioEff = UICreate.createUIEffect(self.content, emojiInfo.url, emojiInfo.matName, -276, -165);
			self.emjioEff.anchorValue = 1;
		else
			self.emjioEff:setEnable(true);
			self.emjioEff:setUrl(emojiInfo.url, emojiInfo.matName);
		end

		self.height = 111;
	else
		if self.emjioEff then
			self.emjioEff:setEnable(false)
		end
		local str = data:getMsg(false, false)
		local arr = Lua_ChatUtil.genChatString(str);
		local len = arr:getSize();
		local iconId;
		local tempStr = "";
		local emojiInfo;
		for i = 1, len do
			if Lua_ChatUtil.isChatFace(arr[i]) == true then
				iconId = string.sub(arr[i], 2, 4);
				emojiInfo = DataCenter.chatData:getConfigById(iconId);
				tempStr = tempStr..spliceEmojiStr(emojiInfo.sprite, Lua_ChatUtil.FACE_SIZE, Lua_ChatUtil.FACE_SIZE);
			else
				tempStr = tempStr..arr[i];
			end
		end
		self.chatText.text = Lua_ChatUtil.getRealStr(tempStr);
		self.chatText:resetPreferredSize();
		self.height = self.chatText.preferredHeight;
	end
end