checkRequire("Lua_ChampionshipUtil");
checkRequire("Lua_ChampionshipData");
Lua_ChampionshipProxy = class("Lua_ChampionshipProxy");
function Lua_ChampionshipProxy:ctor()
	DataCenter.championshipUtil = Lua_ChampionshipUtil.new();
	DataCenter.championshipData = Lua_ChampionshipData.new();

	Lua_MsgUtil.addLuaMsg(80148001, self, self.onQuizResult); -- 通知精英赛竞猜结果
	Lua_MsgUtil.addLuaMsg(80148002, self, self.onTurnOn); -- 精英赛开始通知
	Lua_MsgUtil.addLuaMsg(80148003, self, self.onPersonalResult); -- 通知精英赛个人排名
	-- Lua_MsgUtil.addLuaMsg(80148011, self, self.updateStageInfo); -- 通知精英赛阶段信息
	Lua_MsgUtil.addLuaMsg(80148015, self, self.onEndResult); -- 通知精英赛活动结束
	Lua_MsgUtil.addLuaMsg(80148019, self, self.onQuizInfo); -- 通知精英赛竞猜信息
	Lua_MsgUtil.addLuaMsg(80148022, self, self.onFightResult); -- 通知精英赛上轮战斗结果
	Lua_MsgUtil.addLuaMsg(80148023, self, self.rRedPointState); -- 通知精英赛红点
	Lua_MsgUtil.addLuaMsg(80148024, self, self.updateQuizRate); -- 通知精英赛竞猜进度信息

	Lua_MsgUtil.addLuaMsg(50148020, self, self.rWinInfo); -- 请求精英赛大厅信息返回
	Lua_MsgUtil.addLuaMsg(50148021, self, self.rScheduleInfo); -- 请求精英赛赛程信息返回
	Lua_MsgUtil.addLuaMsg(50148002, self, self.rQuizInfo); -- 请求精英赛竞猜信息返回
	Lua_MsgUtil.addLuaMsg(50148003, self, self.rQuizBetting); -- 请求进行精英赛竞猜返回
	Lua_MsgUtil.addLuaMsg(50148004, self, self.rBattleInfo); -- 请求精英赛淘汰赛对战信息返回
	Lua_MsgUtil.addLuaMsg(50148005, self, self.rRankInfo); -- 请求精英排名信息返回
	-- Lua_MsgUtil.addLuaMsg(50148006, self, self.rRecordInfo); -- 请求精英赛竞选记录返回
	Lua_MsgUtil.addLuaMsg(50148007, self, self.rQuizRecordInfo); -- 请求精英赛竞猜记录返回
	Lua_MsgUtil.addLuaMsg(50148010, self, self.rLike); -- 请求精英赛排行榜点赞返回
	Lua_MsgUtil.addLuaMsg(50148012, self, self.rReceiveEnvelope); -- 请求领取竞猜红包返回
	Lua_MsgUtil.addLuaMsg(50148013, self, self.rQuizTaskInfo); -- 请求竞猜任务返回
	Lua_MsgUtil.addLuaMsg(50148014, self, self.rQuizLevelInfo); -- 请求竞猜任务返回
	Lua_MsgUtil.addLuaMsg(50148016, self, self.rEnvelopeInfo); -- 请求查看竞猜红包的领取信息返回
	Lua_MsgUtil.addLuaMsg(50148025, self, self.rStartTick); -- 请求精英赛开始时间返回
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 事件监听





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行

-- 请求精英赛大厅信息
function Lua_ChampionshipProxy:sWinInfo()
	sendMsg(10148020);
end

-- 请求精英赛赛程信息
function Lua_ChampionshipProxy:sScheduleInfo()
	sendMsg(10148021);
end

-- 请求精英赛竞猜信息
function Lua_ChampionshipProxy:sQuizInfo()
	sendMsg(10148002);
end

-- 请求进行精英赛竞猜
function Lua_ChampionshipProxy:sQuizBetting(player_id, number)
	local cmd = ProtoPublic_pb.Proto10148003();
	cmd.player_id = tonumber(player_id);
	cmd.number = number;
	sendMsg(10148003, cmd);
end

-- 请求精英赛淘汰赛对战信息
function Lua_ChampionshipProxy:sBattleInfo(type, range)
	local cmd = ProtoPublic_pb.Proto10148004();
	cmd.type = type;
	cmd.range = range;
	sendMsg(10148004, cmd);
end

-- 请求精英赛排行榜信息
function Lua_ChampionshipProxy:sRankInfo()
	sendMsg(10148005);
end

-- 请求精英赛竞选记录
-- function Lua_ChampionshipProxy:sRecordInfo()
-- 	sendMsg(10148006);
-- end

-- 请求精英赛竞猜记录
function Lua_ChampionshipProxy:sQuizRecordInfo()
	sendMsg(10148007);
end

-- 请求精英赛排行榜点赞
function Lua_ChampionshipProxy:sLike(role_id, type)
	local cmd = ProtoPublic_pb.Proto10148010();
	cmd.role_id = tonumber(role_id);
	cmd.type = type;
	sendMsg(10148010, cmd);
end

-- 请求领取竞猜红包
function Lua_ChampionshipProxy:sReceiveEnvelope()
	sendMsg(10148012);
end

-- 请求竞猜任务信息
function Lua_ChampionshipProxy:sQuizTaskInfo()
	sendMsg(10148013);
end

-- 请求竞猜等级奖励信息
function Lua_ChampionshipProxy:sQuizLevelInfo()
	sendMsg(10148014);
end

-- 请求查看竞猜红包的领取信息
function Lua_ChampionshipProxy:sEnvelopeInfo()
	sendMsg(10148016);
end

-- 请求领取竞猜任务奖励
function Lua_ChampionshipProxy:sQuizTaskReward(guess_task_id)
	local cmd = ProtoPublic_pb.Proto10148017();
	cmd.guess_task_id = guess_task_id;
	sendMsg(10148017, cmd);
end

-- 请求领取竞猜任务奖励
function Lua_ChampionshipProxy:sQuizLevelReward(reward_id)
	local cmd = ProtoPublic_pb.Proto10148018();
	cmd.reward_id = reward_id;
	sendMsg(10148018, cmd);
end

-- 请求精英赛开始时间
function Lua_ChampionshipProxy:sStartTick()
	sendMsg(10148025);
end









------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_ChampionshipProxy:onQuizResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148001();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChampionshipQuizResultWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

function Lua_ChampionshipProxy:onTurnOn(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148002();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData.bInitServer = false;
		if msg.type == 1 then
			Lua_WindowUtil.openWin("Lua_ChampionshipTipsWindow", Lua_WinParam.ACTION_OPEN, msg.tick);
		end
	end
end

function Lua_ChampionshipProxy:onPersonalResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148003();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChampionshipResultWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

--[[function Lua_ChampionshipProxy:updateStageInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148011();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData:fromServer80148011(msg);
	end
end--]]

function Lua_ChampionshipProxy:onEndResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148015();
		msg:ParseFromString(mp.data);
		self:sWinInfo();
		DataCenter.mainMenuData:setIconShowInfo(30021, false);
		Lua_WindowUtil.openWin("Lua_ChampionshipTopThreeWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

function Lua_ChampionshipProxy:onQuizInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148019();
		msg:ParseFromString(mp.data);
		if not Lua_WindowUtil.isWindowShowing("Lua_ChampionshipWindow") then
			Lua_WindowUtil.openWin("Lua_ChampionshipTurnOnWindow", Lua_WinParam.ACTION_OPEN, msg);
		end
	end
end

function Lua_ChampionshipProxy:onFightResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148022();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChampionshipFightResultWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

function Lua_ChampionshipProxy:rRedPointState(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148023();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData:fromServer80148023(msg);
	end
end

function Lua_ChampionshipProxy:updateQuizRate(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80148024();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_QUIZ_RATE", msg);
	end
end

function Lua_ChampionshipProxy:rWinInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148020();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData:fromServer50148020(msg);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_INFO");
	end
end

function Lua_ChampionshipProxy:rScheduleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148021();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData:fromServer50148021(msg);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_SCHEDULE_INFO");
	end
end

function Lua_ChampionshipProxy:rQuizInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148002();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_QUIZ_INFO", msg);
	end
end

function Lua_ChampionshipProxy:rQuizBetting(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148003();
		msg:ParseFromString(mp.data);
		OperateAlert.showLangValue(540074);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_QUIZ_BETTING_UPDATE", msg);
		Lua_WindowUtil.openWin("Lua_ChampionshipQuizBettingWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_ChampionshipProxy:rBattleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148004();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData:fromServer50148004(msg);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_BATTLE_INFO", msg);
	end
end

function Lua_ChampionshipProxy:rRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148005();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_RANK_UPDATE", msg);
	end
end

function Lua_ChampionshipProxy:rRecordInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_RECORD_UPDATE", msg);
	end
end

function Lua_ChampionshipProxy:rQuizRecordInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148007();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_QUIZ_RECORD_UPDATE", msg);
	end
end

function Lua_ChampionshipProxy:rLike(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148010();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData.leftPariseTimes = msg.left_praise_times;
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_LIKE_UPDATE", msg);
		if msg.left_praise_times <= 0 then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Championship_Like, false);
		end
	end
end

function Lua_ChampionshipProxy:rReceiveEnvelope(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148012();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_RED_ENVELOPE", msg);
		Lua_WindowUtil.openWin("Lua_ChampionshipQuizRedEnvelopeWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

function Lua_ChampionshipProxy:rQuizTaskInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148013();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData:fromServer50148013(msg);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_QUIZ_TASK");
	end
end

function Lua_ChampionshipProxy:rQuizLevelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148014();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData:fromServer50148014(msg);
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_QUIZ_LEVEL");
	end
end

function Lua_ChampionshipProxy:rEnvelopeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148016();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChampionshipQuizRedEnvelopeWindow", Lua_WinParam.ACTION_OPEN, msg);
	end
end

function Lua_ChampionshipProxy:rStartTick(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50148025();
		msg:ParseFromString(mp.data);
		DataCenter.championshipData:fromServer50148025(msg);
	end
end