Lua_ChampionshipQuizTaskVo = class("Lua_ChampionshipQuizTaskVo");
function Lua_ChampionshipQuizTaskVo:ctor(id, config)
	self._id = id;
	self._config = config;
end

function Lua_ChampionshipQuizTaskVo.Get:id()
	return self._id;
end

function Lua_ChampionshipQuizTaskVo.Get:config()
	if self._config == nil then
		self._config = getConfig("classic_event_guess_task", self.id);
	end
	return self._config;
end

function Lua_ChampionshipQuizTaskVo:fromServerInfo(msg)
	if msg == nil or msg.key ~= self.id then
		return;
	end

	self._schedule = tonumber(msg.value); -- 完成进度
	self._rState = msg.other; -- 奖励状态 0不可领取 1可领取 2已领取
end

function Lua_ChampionshipQuizTaskVo.Get:schedule()
	return self._schedule or 0;
end

function Lua_ChampionshipQuizTaskVo.Get:rState()
	return self._rState or 0;
end

function Lua_ChampionshipQuizTaskVo.Get:sortWeight()
	local sortWeight;
	if self.rState == 2 then
		sortWeight = 10000;
	elseif self.rState == 1 then
		sortWeight = 100;
	else
		sortWeight = 1000;
	end
	return self.sort + sortWeight;
end

-------------------- 配置数据 --------------------

function Lua_ChampionshipQuizTaskVo.Get:desc()
	return self.config.desc;
end

function Lua_ChampionshipQuizTaskVo.Get:task_reward()
	return self.config.task_reward;
end

function Lua_ChampionshipQuizTaskVo.Get:num()
	return self.config.num or 1;
end

function Lua_ChampionshipQuizTaskVo.Get:sort()
	return self.config.sort or 0;
end