checkRequire("Lua_ChatVo");
checkRequire("Lua_ChatUtil");
checkRequire("Lua_ChatChannelData");
Lua_ChatData = class("Lua_ChatData")

-- 频道类型
Lua_ChatData.CHANNEL_ALL_MSG = 0; --全部
Lua_ChatData.CHANNEL_WORLD = 1; --世界频道
Lua_ChatData.CHANNEL_LEAGUE = 2; --联盟频道
Lua_ChatData.CHANNEL_SYSTEM = 3; --系统频道
Lua_ChatData.CHANNEL_FRIEND = 4; --私聊频道
Lua_ChatData.CHANNEL_CROSS_SERVER = 5; --跨服频道
Lua_ChatData.CHANNEL_CHAMPIONSHIP = 6; --精英赛频道
Lua_ChatData.CHANNEL_PEAKDUEL = 7; --巅峰对决频道 

-- 内容类型
Lua_ChatData.CONTENT_TEXT = 1; --文字
Lua_ChatData.CONTENT_VOICE = 2; --语音
Lua_ChatData.CONTENT_SYSTEM = 3; --系统
Lua_ChatData.CONTENT_FIGHT_VIDEO = 4; --战斗录像
Lua_ChatData.CONTENT_PEAKDUEL_RECORD = 5; --巅峰对决战绩
Lua_ChatData.CONTENT_COLLECTION = 6; --藏品
Lua_ChatData.CONTENT_EQUIP_COPY = 7; --寂灭岛队伍邀请
Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD = 8;--收藏册单个卡牌
Lua_ChatData.CONTENT_COLLECTION_BOOK = 9;--整个收藏册
Lua_ChatData.CONTENT_RECRUIT_LUCKY = 10;-- 招募欧气分享
Lua_ChatData.CONTENT_DYNANIC_EMOJI = 11;-- 动态表情
Lua_ChatData.CONTENT_LEAGUE_DUEL_GRAB = 12; -- 公会对抗帮抢

Lua_ChatData.CONTENT_XUANYAO = 0; --炫耀
Lua_ChatData.CONTENT_POINT = 50; --@玩家

-- 附件类型
Lua_ChatData.ANNEX_ITEM = 1; --道具
Lua_ChatData.ANNEX_HERO = 2; --明星分享
Lua_ChatData.ANNEX_PEAKDUEL_RECORD = 3; --巅峰对决战绩
Lua_ChatData.ANNEX_FIGHT_VIDEO = 4; --战斗记录分享
Lua_ChatData.ANNEX_COLLECTION = 5; --藏品分享
Lua_ChatData.ANNEX_EQUIP_COPY = 7; --寂灭岛队伍邀请
Lua_ChatData.ANNEX_COLLECTIONBOOK_CARD = 8;--收藏册单个卡牌
Lua_ChatData.ANNEX_COLLECTION_BOOK = 9;--整个收藏册
Lua_ChatData.ANNEX_RECRUIT_LUCKY = 10; -- 招募欧气分享
Lua_ChatData.ANNEX_LEAGUE_DUEL_GRAB = 11; -- 公会对抗帮抢

function Lua_ChatData:ctor()
    self:dispose();
end

function Lua_ChatData:dispose()
    self._lastMsgParseTime = nil;
    self:clearMsgParseTimer();
    self.bFirstEnter = false;
    self.singleAllDic = {}
	self.privateDic = {};
	self.newNumber = {};
    self.privateNewNumber={};
    self.contentData = nil;
    self.contentType = 0;
    self.openChannelTag = 0;
    self.pointList = {}
    self.showPrivateList = Array();
    self.selectPrivate = 0;
    self.act_check_state = false;
    self.crossServerState = false;
    self.chatSettingDic = {};

    self.lastestRoleAvatar = {};
    if self.chatDic == nil then
        self.chatDic = {};
    else
        for k, arr in pairs(self.chatDic) do
            local len = arr:getSize();
            while (len > 0) do
                self:returnChatVo(arr:remove(len));
                len = len - 1;
            end
        end
    end

    self._latestChatVo = nil; -- 最新聊天信息
    if self.showChatIconWins then
        self.showChatIconWins:clear()
        self.showChatIconWins = nil
    end
    self.chatIconPos = nil

    if self.delayBoardState then
        for k,v in pairs(self.delayBoardState) do
            self.delayBoardState[k] = nil
        end
    end
    if self.delayBoardDic then
        for k, v in pairs(self.delayBoardDic) do
            v:dispose()
            v:clear()
            self.delayBoardDic[k] = nil
        end
    end

    if self._broadcastMsgMpsArr ~= nil then
        self._broadcastMsgMpsArr:clear();
    end

    if self._chatMsgMpsArr ~= nil then
        self._chatMsgMpsArr:clear();
    end

    ChatUtil.removeAllChatVideo(); -- 清除语音
end

function Lua_ChatData:returnBroadcastVo(vo)
    if vo == nil then 
        return; 
    end

    vo:clean();
    if self._idleBroadcastVos == nil then
        self._idleBroadcastVos = Array();
        self._idleBroadcastVos:add(vo);
    elseif self._idleBroadcastVos:getSize() < 100 then
        self._idleBroadcastVos:add(vo);
    end
end

function Lua_ChatData:createBroadcastVo(config)
    local vo = nil;
    if self._idleBroadcastVos ~= nil then
        vo = self._idleBroadcastVos:remove();
    end
    if vo == nil then
        vo = Lua_BroadcastVo.new(config);
    else
        vo.config = config;
    end
    return vo;
end

function Lua_ChatData:returnChatVo(vo)
    if vo == nil then 
        return; 
    end

    vo:clean();
    if self._idleChatVos == nil then
        self._idleChatVos = Array();
        self._idleChatVos:add(vo);
    elseif self._idleChatVos:getSize() < 200 then
        self._idleChatVos:add(vo);
    end
end

function Lua_ChatData:createChatVo()
    local vo = nil;
    if self._idleChatVos ~= nil then
        vo = self._idleChatVos:remove();
    end
    if vo == nil then
        vo = Lua_ChatVo.new();
    end
    return vo;
end

function Lua_ChatData:setChatShowItem(val, data)
	if data == nil then
		self.contentType = 0;
	else
		self.contentType = val;
	end
    self.contentData = data;
end

-- 打开聊天窗口时， 默认打开的聊天频道
function Lua_ChatData:getAutoOpenChannel()
    local chatPriority = Lua_ChatData.CHANNEL_WORLD; -- 所有频道均无消息时，打开世界频道
    local priorityList = Lua_ChatUtil.getChatPriority();
    for k, v in ipairs(priorityList) do
        if v.id == Lua_ChatData.CHANNEL_FRIEND and self:getAllPrivateNewMsgNum() > 0 then
            chatPriority = v.id;
            break;
        elseif self:getChannelNewMsgNum(v.id) > 0 then
            chatPriority = v.id;
            break;
        end
    end
    return chatPriority;
end

function Lua_ChatData:getChannelNewMsgNum(channel)
    if Lua_ChatUtil.checkChannelOpen(channel)==false then
        return 0;
    end
    if channel == Lua_ChatData.CHANNEL_FRIEND then
        return self:getAllPrivateNewMsgNum()
    end
    if self:getChatSettingByChannel(channel) == 0 then
        self.newNumber[channel] = 0;
        return 0;
    end
	if self.newNumber[channel] == nil then
		return 0;
	end
	return self.newNumber[channel];
end
function Lua_ChatData:setChannelNewMsgNum(channel, val)
    if Lua_ChatUtil.checkChannelOpen(channel) == false then
        self.newNumber[channel] = 0;
    else
        self.newNumber[channel] = val;
    end
end
function Lua_ChatData:getPointList(channel)
    if self.pointList==nil or self.pointList[channel]==nil then
        return Array();
    end
    return self.pointList[channel];
end

function Lua_ChatData:reomvePointListItem(channel, item)
    if self.pointList==nil then
        self.pointList={};
    end
    if self.pointList[channel] == nil then
        self.pointList[channel]=Array();
    end
    self.pointList[channel]:removeItem(item);
end

function Lua_ChatData:addChat(chatVo)
	if self.chatDic[chatVo.channel] == nil then
		self.chatDic[chatVo.channel] = Array();
	end
    if self.pointList[chatVo.channel] == nil then
        self.pointList[chatVo.channel] = Array();
    end

	local arr = self.chatDic[chatVo.channel];
	arr:add(chatVo);

    local msg_limit = Lua_ChatChannelData.getConfigDataById(chatVo.channel).msg_limit;
	while (arr:getSize() > msg_limit) do
        if self.pointList[chatVo.channel][1] == 1 then
            self.pointList[chatVo.channel]:remove(1);
        end
        for i = 1, self.pointList[chatVo.channel]:getSize() do
            local temp = self.pointList[chatVo.channel][i];
            self.pointList[chatVo.channel][i] = temp - 1;
        end

        local bUse = false;
        local v = arr:remove(1);
        if v.chat_player ~= nil then
            local rid = tonumber(v.chat_player.id);
            if self.singleAllDic ~= nil and self.singleAllDic[rid] ~= nil and self:isSaveToAll(v) then
                for j = 1, self.singleAllDic[rid]:getSize() do
                    if self.singleAllDic[rid][j] == v then
                        v.useStep = 1;
                        bUse = true;
                        break;
                    end
                end
            end
        end

        if not bUse then
            self:returnChatVo(v);
        end
	end

    if chatVo.chat_player ~= nil then
        local rid = tonumber(chatVo.chat_player.id);
        if self:isSaveToAll(chatVo) then
            if self.singleAllDic[rid] == nil then
                self.singleAllDic[rid] = Array();
            end

            self.singleAllDic[rid]:add(chatVo);
            while (self.singleAllDic[rid]:getSize() > 16) do
                local v = self.singleAllDic[rid]:remove(1);
                if v.useStep ~= nil and v.useStep == 1 then
                    self:returnChatVo(v);
                end
            end
        end
    end

    if self.openChannelTag ~= chatVo.channel and not chatVo.bReadMessage then
        local count = self:getChannelNewMsgNum(chatVo.channel);
        self:setChannelNewMsgNum(chatVo.channel, count + 1);
    end

    if self.openChannelTag == chatVo.channel and self.openChannelTag ~= Lua_ChatData.CHANNEL_FRIEND and not chatVo.bReadMessage then
        Lua_ProxyManager.getProxy("Lua_ChatProxy"):sReadChat(DataCenter.chatData.openChannelTag);
    end

    if Lua_ChatUtil.checkHasPoint(chatVo.content) and not chatVo.info_offline and self.openChannelTag ~= chatVo.channel then
        self.pointList[chatVo.channel]:add(arr:getSize());
    end

    -- print("addChat", chatVo.recordInfo.total_force)
	Lua_MsgUtil.callFunc("ADD_CHAT_MSG", chatVo);
end

function Lua_ChatData:getSingleMsgList(rid)
    rid=tonumber(rid);
    if self.singleAllDic[rid] == nil then
        return Array();
    else
        return self.singleAllDic[rid];
    end
end

function Lua_ChatData:getChannelMsgList(channel)
    if self.chatDic[channel] == nil then
        return Array();
    else
        return self.chatDic[channel];
    end
end

function Lua_ChatData:getPrivateMsgList(role_id)
	local rid = tonumber(role_id);
	if self.privateDic[rid] == nil then
		return Array();
	else
		return self.privateDic[rid];
	end
end

function Lua_ChatData:clearPrivateMsgList(rid)
    rid=tonumber(rid);
    self.privateDic[rid] = nil;
end

function Lua_ChatData:getShowPrivateList()
    return self.showPrivateList;
end

function Lua_ChatData:setShowPrivateList(info,isRemove)
    local removeIndex=0;
    for i = 1, self.showPrivateList:getSize() do
        if tonumber(info.id) == tonumber(self.showPrivateList[i].id) then
            removeIndex = i;
        end
    end
    if removeIndex ~= 0 then
        -- local count = self:getPrivateNewMsgNum(info.id);
        -- self:setPrivateNewMsgNum(info.id, count + 1);
        -- self:setPrivateNewMsgNum(info.id, 0);
        -- self.showPrivateList:remove(removeIndex);
        -- if isRemove==nil or isRemove==false then
        --     self.showPrivateList:add(info);
        -- end
        if isRemove == nil or isRemove == false then
            if removeIndex == 1 then -- 排序，后来居上
                self.showPrivateList[removeIndex] = info;
            else
                self.showPrivateList:remove(removeIndex);
                self.showPrivateList:unshift(info);
            end
        else
            self.showPrivateList:remove(removeIndex);
        end
    elseif isRemove == nil or isRemove == false then
        local show_limit=Lua_ChatChannelData.getConfigDataById(Lua_ChatData.CHANNEL_FRIEND).showPrivateCount;
        if self.showPrivateList:getSize() >= show_limit then
            self.showPrivateList:remove(1);
        end
        self.showPrivateList:unshift(info);
    end
    -- 更新私聊窗口，更新好友头像
    if isRemove ~= true then
        Lua_MsgUtil.callFunc("CHAT_UPDATE_FRIEND");
    end
end
function Lua_ChatData:addPrivateChat(chatVo)
    local rid;
    local myselfInfo; --自身信息
    local privateInfo = chatVo.chat_player; --私聊目标
    local bMySelf = Lua_ChatUtil.judgeIsPlayer(privateInfo.id);
    if bMySelf then -- 是否是玩家自身发送的消息 
        privateInfo = chatVo.private_player;
        myselfInfo = chatVo.chat_player;
    else
        privateInfo = chatVo.chat_player;
        myselfInfo = chatVo.private_player;
    end
    rid = tonumber(privateInfo.id);


	if self.privateDic[rid] == nil then
		self.privateDic[rid] = Array();
	end
    if self.singleAllDic[rid] == nil then
        self.singleAllDic[rid] = Array();
    end
   
    self:setShowPrivateList(privateInfo);
    
    -- 私聊双方各自最新的信息 friendInfo：私聊目标  playerInfo：玩家自身
    self.lastestRoleAvatar[rid] = { friendInfo = privateInfo, playerInfo = myselfInfo };

	local arr = self.privateDic[rid];
	arr:add(chatVo);
    local msg_limit = Lua_ChatChannelData.getConfigDataById(chatVo.channel).msg_limit;
	while (arr:getSize() > msg_limit) do
        local bUse = false;
        local v = arr:remove(1);
        if v.chat_player ~= nil then
            local rid = tonumber(v.chat_player.id);
            if self.singleAllDic ~= nil and self.singleAllDic[rid] ~= nil and self:isSaveToAll(v) then
                for j = 1, self.singleAllDic[rid]:getSize() do
                    if self.singleAllDic[rid][j] == v then
                        v.useStep = 1;
                        bUse = true;
                        break;
                    end
                end
            end
        end

        if not bUse then
            self:returnChatVo(v);
        end
	end

    if self:isSaveToAll(chatVo) then
        self.singleAllDic[rid]:add(chatVo);
        while (self.singleAllDic[rid]:getSize() > 16) do
            local v = self.singleAllDic[rid]:remove(1);
            if v.useStep ~= nil and v.useStep == 1 then
                self:returnChatVo(v);
            end
        end
    end

    local bCalculate = (self.openChannelTag ~= chatVo.channel or self.selectPrivate ~= rid ) and chatVo.bReadMessage == false and not bMySelf;
    if bCalculate then
        local count=self:getPrivateNewMsgNum(rid);
        self:setPrivateNewMsgNum(rid,count+1);
    end

    -- 新消息下发时刚好处于该私聊窗口
    if self.openChannelTag == chatVo.channel and self.selectPrivate == rid then
        Lua_ProxyManager.getProxy("Lua_ChatProxy"):sReadChat(rid);
    end
	Lua_MsgUtil.callFunc("ADD_CHAT_MSG", chatVo);
end

function Lua_ChatData:isSaveToAll(chatVo)
    if chatVo.content_type == Lua_ChatData.CONTENT_VOICE then
        return false;
    end
    if chatVo.channel == Lua_ChatData.CHANNEL_WORLD
        or chatVo.channel == Lua_ChatData.CHANNEL_LEAGUE
        or chatVo.channel == Lua_ChatData.CHANNEL_FRIEND
        or chatVo.channel == Lua_ChatData.CHANNEL_CROSS_SERVER then
        return true;
    end
    return false;
end
function Lua_ChatData:getPrivateNewMsgNum(rid)
    rid=tonumber(rid);
    if self.privateNewNumber[rid] == nil or self:getChatSettingByChannel(Lua_ChatData.CHANNEL_FRIEND) == 0 then
        self.privateNewNumber[rid] = 0;
        return 0;
    end
    return self.privateNewNumber[rid];
end
function Lua_ChatData:setPrivateNewMsgNum(rid, val)
    if rid == nil then
        return;
    end
    rid=tonumber(rid);
    if Lua_ChatUtil.checkChannelOpen(Lua_ChatData.CHANNEL_FRIEND) == false then
        self.privateNewNumber[rid] = 0;
    else
        self.privateNewNumber[rid] = val;
    end
end

function Lua_ChatData:getAllPrivateNewMsgNum()
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_FRIEND) == 0 then
        self.privateNewNumber = {};
        return 0
    end
    local count=0;
    for k,v in pairs(self.privateNewNumber) do
        count=count+v;
    end
    return count;
end

function Lua_ChatData:getAllChannelNewMsgNum()
    local count=0;
    for k,v in pairs(self.newNumber) do
        count = count + self:getChannelNewMsgNum(k);
    end
    count = count + self:getAllPrivateNewMsgNum();
    return count;
end

function Lua_ChatData:shieldShowRedDotCount()
    local count=0
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_WORLD) == 0 then
        count=count+self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_WORLD);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_LEAGUE) == 0 then
        count=count+self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_LEAGUE);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_CROSS_SERVER) == 0 then
        count=count+self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_CROSS_SERVER);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_FRIEND) == 0 then
        count=count+self:getAllPrivateNewMsgNum();
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_SYSTEM) == 0 then
        count=count+self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_SYSTEM);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_CHAMPIONSHIP) == 0 then
        count = count + self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_CHAMPIONSHIP);
    end
    if self:getChatSettingByChannel(Lua_ChatData.CHANNEL_PEAKDUEL) == 0 then
        count = count + self:getChannelNewMsgNum(Lua_ChatData.CHANNEL_PEAKDUEL);
    end
    return count;
end

-- 服务端下发处理数据
function Lua_ChatData:updataChatSetting(list)
    -- for k,v in ipairs(list) do
    --     self.chatSettingDic[tonumber(v)] = 0;
    -- end
    for k, v in pairs(self.chatSettingDic) do
       self.chatSettingDic[k] = nil;
    end

    if #list == 0 then
        return;
    end

    local channelId;
    for i = 1, #list do
        channelId = tonumber(list[i]);
        self:setChatSettingByChannel(channelId, 0);
    end
end

function Lua_ChatData:setChatSettingByChannel(channel,value)
    self.chatSettingDic[channel] = value
end

function Lua_ChatData:getChatSettingByChannel(channel) -- 1：开启红点提示  0：关闭红点提示
    if channel == Lua_ChatData.CHANNEL_CHAMPIONSHIP or channel == Lua_ChatData.CHANNEL_PEAKDUEL then
        return 0;
    end
    if self.chatSettingDic[channel] ~= nil then
        return self.chatSettingDic[channel]
    end
    return 1;
end

function Lua_ChatData:checkSelectPrivate()
    if tonumber(self.selectPrivate) == 0 then
        local tempId = 0;
        local privateList = DataCenter.chatData:getShowPrivateList();
        for i = 1, privateList:getSize() do
            local redCount=DataCenter.chatData:getPrivateNewMsgNum(privateList[i].id);
            if redCount > 0 then
                tempId = tonumber(privateList[i].id);
                break;
            end
        end

        if tempId == 0 and privateList:getSize() > 0 then
            self.selectPrivate = tonumber(privateList[privateList:getSize()].id);
        else
            self.selectPrivate = tonumber(tempId);
        end
    end
end

------------------------------ 公共处理 ------------------------------
function Lua_ChatData:getChannelArr()
    if self.channelList == nil then
        self.channelList = Array();
        local config = getConfig("chat");
        for k, v in pairs(config) do
            if v.show_type == 1 then
                self.channelList:add(k);
            end
        end
        self.channelList:sortf(self, self.onChannelSort);
    end
    return self.channelList;
end

function Lua_ChatData:onChannelSort(a, b)
    a = Lua_ChatChannelData.getConfigDataById(a)
    b = Lua_ChatChannelData.getConfigDataById(b)
    if a.sort > b.sort then
        return false;
    end
    return true;
end





------------------------------ 聊天处理 ------------------------------
function Lua_ChatData:addChatMsg(msg)
    if msg == nil then
        return;
    end
    if not Lua_ChatUtil.checkChannelOpen(msg.chat_type) then
        return;
    end
    if msg.chat_player ~= nil and DataCenter.friendData:isBacklistById(msg.chat_player.id) then
        return;
    end

    local vo = self:createChatVo();
    vo:fromServer(msg);
    self:setLatestChat(vo);
    if msg.chat_type == Lua_ChatData.CHANNEL_FRIEND then
        self:addPrivateChat(vo);
    else
        self:addChat(vo)
    end
end

function Lua_ChatData:setLatestChat(vo)
    if vo == nil or vo.channel == nil or 
        vo.channel == Lua_ChatData.CHANNEL_CHAMPIONSHIP or 
        vo.channel == Lua_ChatData.CHANNEL_PEAKDUEL then
        return;
    end
    if self._latestChatVo == nil or vo.sendTick > self._latestChatVo.sendTick then
        self._latestChatVo = vo;
    end
end

function Lua_ChatData.Get:latestChatVo()
    return self._latestChatVo;
end





------------------------------ 广播处理 ------------------------------

function Lua_ChatData:playBroadcast(msg)
    if msg == nil then
        return;
    end

    local config = getConfig("broadcast", msg.shout_id);
    if config == nil then
        return;
    end

    local vo = self:createBroadcastVo(config);
    vo:fromServer(msg);
    self:playBroadcastByVo(vo);
end

function Lua_ChatData:playBroadcastByVo(vo)
    if vo == nil then
        return;
    end

    if vo.isFighting == true then
        self:setDelayBroadcast(vo.id)
    end
    if self:addDelayBroadcast(vo) then
        return;
    end

    local bUse = false;
    if vo.type == 1 or vo.type == 3 then
        bUse = true;
        Lua_WindowUtil.openWin("Lua_BulletinBoardSecWindow", Lua_WinParam.ACTION_OPEN, vo);
    end

    if vo.channel then
        for i = 1, #vo.channel do
            local chatVo = self:createChatVo();
            chatVo.channel = vo.channel[i];
            chatVo.type = Lua_ChatData.CONTENT_TEXT;
            chatVo.content = vo.chatContent
            chatVo.broadcast_type = vo.broadType;
            chatVo.sendTick = DataCenter.roleData.serverTime;
            self:setLatestChat(chatVo);
            self:addChat(chatVo);
        end
    end

    if not bUse then -- 未用于广播
        self:returnBroadcastVo(vo);
    end
end

function Lua_ChatData:setDelayBroadcast(id)
    id = id or 0; -- 0表示所有广播都要延迟
    if self.delayBoardState == nil then
        self.delayBoardState = {};
    end
    self.delayBoardState[id] = 1;
    print("setDelayBroadcast", id);
end

function Lua_ChatData:addDelayBroadcast(vo)
    if self.delayBoardState then
        if self.delayBoardState[vo.id] == 1 then
            if self.delayBoardDic == nil then
                self.delayBoardDic = {}
            end
            if self.delayBoardDic[vo.id] == nil then
                self.delayBoardDic[vo.id] = Array();
            end
            self.delayBoardDic[vo.id]:add(vo);
            return true
        elseif self.delayBoardState[0] == 1 then
            if self.delayBoardDic == nil then
                self.delayBoardDic = {}
            end
            if self.delayBoardDic[0] == nil then
                self.delayBoardDic[0] = Array();
            end
            self.delayBoardDic[0]:add(vo);
            return true            
        end
    end
    return false;
end

function Lua_ChatData:playNextBroadcast(id)
    if self.delayBoardState == nil then
        return;
    end

    id = id or 0;
    self.delayBoardState[id] = nil;
    
    if self.delayBoardDic == nil or self.delayBoardDic[id] == nil then
        return;
    end

    local arr = self.delayBoardDic[id];
    arr:sort("priority", true);
    for i = 1, arr:getSize() do
        self:playBroadcastByVo(arr[i]);
    end
    self.delayBoardDic[id] = nil;
end

-- 登录广播
function Lua_ChatData:playEnterBroadcast()
    if self.bFirstEnter == true then
        return;
    end
    self.bFirstEnter = true;

    -- local config = getConfig("broadcast", 1000);
    -- local vo = Lua_BroadcastVo.new(config);
    -- vo.content = LanUtil.replaceStr(config.board_content, "{0}", DataCenter.roleData.name);
    -- self:playBroadcastByVo(vo);
end






------------------------------ 表情 ------------------------------
function Lua_ChatData:getEmjioListByType(type)
    if self.emjioList == nil then
        self.emjioList = {};

        local list;
        local config = getConfig("chat_emoji");
        for k, v in pairs(config) do
            list = self.emjioList[v.type];
            if list == nil then
                self.emjioList[v.type] = {};
                list = self.emjioList[v.type];
            end
            list[#list + 1] = v.id;
        end
    end

    for k, v in pairs(self.emjioList) do
        table.sort(v, function(a, b)
            local AVo = self:getConfigById(a);
            local BVo = self:getConfigById(b);
            return AVo.sort < BVo.sort; end
         )
    end

    return self.emjioList[type];
end

function Lua_ChatData:getConfigById(id)
    return getConfig("chat_emoji", id);
end





------------------------------ 好友处理 ------------------------------

-- 删除好友聊天处理
function Lua_ChatData:removeFriendInfo(friendId)
    local arr = self.latestChatVoArr;
    if arr ~= nil then
        self.latestChatVoArr = Array();
        local vo;
        for i = 1, arr:getSize() do
            vo = arr[1];
            if vo ~= nil and vo.chat_player ~= nil and vo.chat_player.id ~= friendId then
                self.latestChatVoArr:add(vo);
            end
        end
    end

    self:setShowPrivateList({id = friendId}, true);
    self:setPrivateNewMsgNum(friendId, 0);
    Lua_MsgUtil.callFunc("REMOVE_FRIEND_UPDATE");
end





------------------------------ 聊天图标 ------------------------------
function Lua_ChatData:checkChatIconStateByWinName(winName, bShow)
    if DataCenter.bConfigLoaded ~= true then
        return
    end

    local config = Lua_WinConfigData.getConfigData(winName)
    if config == nil or config.chatPos == nil then
        return
    end

    if self.showChatIconWins == nil then
        self.showChatIconWins = Array()
    end
    if bShow then
        if self.showChatIconWins:indexOf(winName) == -1 then
            self.showChatIconWins:add(winName)
        end
    else
        self.showChatIconWins:removeItem(winName)
    end
    local len = self.showChatIconWins:getSize()
    if len > 0 then
        for i = 1, len do
            for j = i + 1, len do
                local a1 = self.showChatIconWins[i]
                local d1 = WindowMananger.getInstance():getWindowDepth(a1)
                local b1 = self.showChatIconWins[j]
                local d2 = WindowMananger.getInstance():getWindowDepth(b1)
                if d1 < d2 then
                    self.showChatIconWins[i] = b1
                    self.showChatIconWins[j] = a1
                end
            end
        end
    end

    if len > 0 then
        if self.chatIconPos then
            Lua_MsgUtil.callFunc("CHAT_ICON_POS_UPDETA", self.chatIconPos)
        else
            config = Lua_WinConfigData.getConfigData(self.showChatIconWins[1])
            if config and config.chatPos then
                Lua_MsgUtil.callFunc("CHAT_ICON_POS_UPDETA", config.chatPos)
            end
        end
    else
        config = Lua_WinConfigData.getConfigData("default")
        if config and config.chatPos then
            Lua_MsgUtil.callFunc("CHAT_ICON_POS_UPDETA", config.chatPos)
        end
    end
end

-- 添加聊天下发消息（优先）
function Lua_ChatData:addChatMsgMp(mp)
    if mp == nil or mp.errno ~= 0 then
        return;
    end

    if not self._bMsgParseTimer then
        local t = getTime();
        if not DataCenter.loginData.isInGameWorld or self._lastMsgParseTime == nil or t - self._lastMsgParseTime >= 0.2 then
            self._lastMsgParseTime = t;
            local msg = ProtoPublic_pb.Proto80105002();
            msg:ParseFromString(mp.data);
            self:addChatMsg(msg);
            return; 
        end
    end

    if self._chatMsgMpsArr == nil then
        self._chatMsgMpsArr = Array();
    end
    self._chatMsgMpsArr:add(mp.data);
    self:addMsgParseTimer();
end

-- 添加广播下发消息
function Lua_ChatData:addBroadcastMsgMp(mp)
    if mp == nil or mp.errno ~= 0 then
        return;
    end

    if not self._bMsgParseTimer then
        local t = getTime();
        if not DataCenter.loginData.isInGameWorld or self._lastMsgParseTime == nil or t - self._lastMsgParseTime >= 0.2 then
            self._lastMsgParseTime = t;
            local msg = ProtoPublic_pb.Proto80105004();
            msg:ParseFromString(mp.data);
            self:playBroadcast(msg);
            return;
        end
    end
    
    if self._broadcastMsgMpsArr == nil then
        self._broadcastMsgMpsArr = Array();
    end
    self._broadcastMsgMpsArr:add(mp.data);
    self:addMsgParseTimer();
end

function Lua_ChatData:addMsgParseTimer()
    if not self._bMsgParseTimer then
        self._bMsgParseTimer = true;
        Lua_CommonUtil.addTimer("onParseChatAndBroadcastMsg", 0.2, self, self.onParseChatAndBroadcastMsg);
    end
end

function Lua_ChatData:clearMsgParseTimer()
    if self._bMsgParseTimer then
        self._bMsgParseTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onParseChatAndBroadcastMsg);
    end
end

-- 解析聊天数据
function Lua_ChatData:onParseChatAndBroadcastMsg()
    self._lastMsgParseTime = getTime();

    -- 未打开广播的话先判断广播
    local bCheckBroadcast = self._broadcastMsgMpsArr ~= nil and self._broadcastMsgMpsArr:getSize() > 0;
    if bCheckBroadcast and not Lua_WindowUtil.isOpenWin("Lua_BulletinBoardSecWindow") then
        local data = self._broadcastMsgMpsArr:shift();
        if data ~= nil then
            local msg = ProtoPublic_pb.Proto80105004();
            msg:ParseFromString(data);
            self:playBroadcast(msg);
            -- print("1延迟解析 _broadcastMsgMpsArr", self._broadcastMsgMpsArr:getSize());
            return;
        end
    end

    if self._chatMsgMpsArr ~= nil and self._chatMsgMpsArr:getSize() > 0 then
        local data = self._chatMsgMpsArr:shift();
        if data ~= nil then
            local msg = ProtoPublic_pb.Proto80105002();
            msg:ParseFromString(data);
            self:addChatMsg(msg);
            -- print("延迟解析 _chatMsgMpsArr", self._chatMsgMpsArr:getSize());
            return;
        end
    end

    if bCheckBroadcast then
        local data = self._broadcastMsgMpsArr:shift();
        if data ~= nil then
            local msg = ProtoPublic_pb.Proto80105004();
            msg:ParseFromString(data);
            self:playBroadcast(msg);
            -- print("2延迟解析 _broadcastMsgMpsArr", self._broadcastMsgMpsArr:getSize());
            return;
        end
    end

    -- 都完成则移除
    self:clearMsgParseTimer();
end

