Lua_ChatVo = class("Lua_ChatVo")
function Lua_ChatVo:ctor()
    self:superCall("ctor");
    self.useStep = 0;
end

function Lua_ChatVo:clean()
    self.useStep = 0;
    self.bChangeInfo = false;
    self._bRecordInfo = false;
    self._recordInfo = nil;
    self.channel = nil; -- 频道类型
    self.content_type = nil; -- 内容类型
    self._content = nil; -- 文字内容
    self.voice_id = nil; -- 语音id
    self.voice_len = nil; -- 语音时长
    self._add_list = nil; -- 聊天附件
    self._send_tick = nil; -- 发送时间
    self.chat_player = nil; -- 发起聊天的玩家信息
    self.private_player = nil; -- 私聊时，私聊目标信息
    self.bReadMessage = nil; -- 是否已读 0：未读 1：已读
    self.class_event_chat_role = nil; -- 精英赛聊天角色
    self._bReadMessage = nil;
    self._info_offline = nil;
    self._broadcast_type = nil;
    if self.msgParseDic ~= nil then
        table.clear(self.msgParseDic);
    end
end

function Lua_ChatVo:fromServer(msg)
    self.useStep = 0;
    self.channel = msg.chat_type; -- 频道类型
    self.content_type = msg.content_type; -- 内容类型
    self._content = msg.wcontent; -- 文字内容
    self.voice_id = msg.voice_id; -- 语音id
    self.voice_len = msg.voice_sec; -- 语音时长
    self._add_list = msg.add_list; -- 聊天附件
    self._send_tick = tonumber(msg.send_tick); -- 发送时间
    self.chat_player = msg.show; -- 发起聊天的玩家信息
    self.private_player = msg.private_show; -- 私聊时，私聊目标信息
    self.bReadMessage = tonumber(msg.is_read) == 1; -- 是否已读 0：未读 1：已读
    self.class_event_chat_role = msg.class_event_chat_role; -- 精英赛聊天角色
    self.bChangeInfo = true;
    self._bRecordInfo = true;
    self._recordInfo = nil;
end

function Lua_ChatVo.Get:addInfo()
    if self._add_list == nil or self._add_list[1] == nil then
        return nil;
    end
    return self._add_list[1];
end

function Lua_ChatVo.Set:sendTick(value)
    self._send_tick = value;
end

function Lua_ChatVo.Get:sendTick()
    return self._send_tick or 0;
end

function Lua_ChatVo.Get:recordInfo()
    if self._bRecordInfo then
        self._bRecordInfo = false;
        self._recordInfo = nil;
        local info = self.addInfo
        if info ~= nil then
            if self.content_type == Lua_ChatData.CONTENT_FIGHT_VIDEO and info.addit_type == Lua_ChatData.ANNEX_FIGHT_VIDEO then
                self._recordInfo = info.record_info;
            elseif self.content_type == Lua_ChatData.CONTENT_PEAKDUEL_RECORD and info.addit_type == Lua_ChatData.ANNEX_PEAKDUEL_RECORD then
                self._recordInfo = info.standings_info;
            elseif self.content_type == Lua_ChatData.CONTENT_COLLECTION and info.addit_type == Lua_ChatData.ANNEX_COLLECTION then
                self._recordInfo = info.collection_info;
            elseif self.content_type == Lua_ChatData.CONTENT_EQUIP_COPY and info.addit_type == Lua_ChatData.ANNEX_EQUIP_COPY then
                self._recordInfo = info.silent_island_invite;
            elseif self.content_type == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD and info.addit_type == Lua_ChatData.ANNEX_COLLECTIONBOOK_CARD then
                self._recordInfo = info.card_info;
            elseif self.content_type == Lua_ChatData.CONTENT_COLLECTION_BOOK and info.addit_type == Lua_ChatData.ANNEX_COLLECTION_BOOK then
                self._recordInfo = info.card_info;  
            elseif self.content_type == Lua_ChatData.CONTENT_RECRUIT_LUCKY and info.addit_type == Lua_ChatData.ANNEX_RECRUIT_LUCKY then
                self._recordInfo = info.recruit_show;
            elseif self.content_type == Lua_ChatData.CONTENT_LEAGUE_DUEL_GRAB and info.addit_type == Lua_ChatData.ANNEX_LEAGUE_DUEL_GRAB then
                self._recordInfo = info.grab_info;
            end
        end
    end
    return self._recordInfo;
end

function Lua_ChatVo.Get:content()
    if self.bChangeInfo then
        self.bChangeInfo = false;
        local info = self.addInfo
        if info ~= nil then
            if self.content_type == Lua_ChatData.CONTENT_FIGHT_VIDEO and info.addit_type == Lua_ChatData.ANNEX_FIGHT_VIDEO then
                self._content = spliceStr("<url=checkVideo_", self.recordInfo.record_id, ">", self._content, "</url>");
            elseif self.content_type == Lua_ChatData.CONTENT_PEAKDUEL_RECORD and info.addit_type == Lua_ChatData.ANNEX_PEAKDUEL_RECORD then
                self._content = spliceStr("<url=pdRecord_", self.recordInfo.region_id, "_", self.recordInfo.role_id, "_", self.recordInfo.server_flag, ">", self._content, "</url>");
            elseif self.content_type == Lua_ChatData.CONTENT_COLLECTION and info.addit_type == Lua_ChatData.ANNEX_COLLECTION then
                self._content = spliceStr("<url=collection_", self.recordInfo.collection_id, ">", self._content, "</url>");
            elseif self.content_type == Lua_ChatData.CONTENT_RECRUIT_LUCKY and info.addit_type == Lua_ChatData.ANNEX_RECRUIT_LUCKY then
                self._content = LanUtil.formateStr(171049, self._content);
            elseif self.content_type == Lua_ChatData.CONTENT_LEAGUE_DUEL_GRAB and info.addit_type == Lua_ChatData.ANNEX_LEAGUE_DUEL_GRAB then
                self._content = spliceStr("<url=leagueSluff_", self.recordInfo.grab_record_id, "_", self.recordInfo.share_player_id, ">", self._content, "</url>");
            end
        end
    end
    return self._content;
end

function Lua_ChatVo.Set:content(val)
    self._content = val;
end

function Lua_ChatVo.Get:broadcast_type()
    return self._broadcast_type;
end

function Lua_ChatVo.Set:broadcast_type(val)
    self._broadcast_type = val;
end

function Lua_ChatVo:getMsg(showChannel, showName, point)
    local showChannelVal = showChannel and 1 or 0;
    local showNameVal = showName and 1 or 0;
    local pointVal = (point ~= nil and point ~= 1) and 1 or 0;
    local val = showChannelVal * 1000 + showNameVal * 100 + pointVal;
    if self.msgParseDic ~= nil then
        if self.msgParseDic[val] ~= nil then
            return self.msgParseDic[val];
        end 
    else
        self.msgParseDic = {};
    end

    local str = "";
    if showChannel == true then
        str = str.."　　　";
    end

    if showName == true and self.chat_player.name ~= nil and string.len(self.chat_player.name) > 0 then
        str = spliceStr(str, "<color=#", Lua_ColorDefine.GREEN_STR, ">", self.chat_player.name, "</color>:");
    end
    if showName == true and self.private_player.name ~= nil and string.len(self.private_player.name) > 0 then
        str = spliceStr(str, "<color=#", Lua_ColorDefine.GREEN_STR, ">", self.private_player.name, "</color>:");
    end

    if point ~= nil and point ~= 1 then
        str = spliceStr("<color=#a16a3e>", str, self.content, "</color>");
    else
        str = spliceStr("<color=#4a6793>", str, self.content, "</color>");
    end

    str = string.gsub(str, "◆", " ");
    self.msgParseDic[val] = str;
    return str;
end

function Lua_ChatVo.Get:info_offline()
    if self._info_offline == nil then
        return false;
    end
    return self._info_offline;
end

function Lua_ChatVo.Set:info_offline(val)
    self._info_offline = val;
end

-- 已读
function Lua_ChatVo.Get:bReadMessage()
    if self._bReadMessage == nil then
        return false;
    end
    return self._bReadMessage;
end

function Lua_ChatVo.Set:bReadMessage(val)
    self._bReadMessage = val;
end