checkRequire("Lua_ChatWithChanelItem");
checkRequire("Lua_ChatHeadRightItem");
checkRequire("Lua_ChatHeadLeftItem");
Lua_ChatDragContainerItem = class("Lua_ChatDragContainerItem", Lua_DragContainerItem);
function Lua_ChatDragContainerItem:ctor(p)
	self:superCall("ctor", p);
	self.itemDic = {};
end

function Lua_ChatDragContainerItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ChatDragContainerItem:setData(vo)
	-- self.chatData = vo; -- 没看懂有用？？？
	self.chatItem = self:genItem(vo);
	self.chatItem:setRectAnchor(1);
end

function Lua_ChatDragContainerItem:getWidth()
    return 680;
end

function Lua_ChatDragContainerItem:getHeight()
	return self.chatItem:getHeight();
end

function Lua_ChatDragContainerItem:dispose()
	if self.itemDic ~= nil then
		for k, v in pairs(self.itemDic) do
			v:dispose();
			self.itemDic[k] = nil;
		end
		self.itemDic = nil;
	end
	if self.chatItem ~= nil then
		self.chatItem:dispose();
		self.chatItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ChatDragContainerItem:onPressClick()
	self.chatItem:onPressClick();
end

function Lua_ChatDragContainerItem:genItem(chatVo)
	local key;
	if chatVo.chat_player == nil or chatVo.chat_player.id == nil or tonumber(chatVo.chat_player.id) == 0 then
		key = "Lua_ChatWithChanelItem";
	elseif DataCenter.roleData:isMyself(chatVo.chat_player.id) then
		key = "Lua_ChatHeadRightItem";
	else
		key = "Lua_ChatHeadLeftItem";
	end

	for k, v in pairs(self.itemDic) do
		if k ~= key then
			v:setEnable(false);
		end
	end
	local chatItem = self.itemDic[key];
	if chatItem == nil then
		chatItem = checkRequire(key);
		chatItem = chatItem.new(self.content, 680);
		self.itemDic[key] = chatItem;
	end
	chatItem:setEnable(true);
	chatItem:setData(680, chatVo);
	return chatItem;
end