checkRequire("Lua_ChatUtil");
Lua_ChatFriendHeadItem = class("Lua_ChatFriendHeadItem",Lua_ListCell)
function Lua_ChatFriendHeadItem:ctor(p)
    self:superCall("ctor",p,"ChatFriendHeadItem_skin");
end

function Lua_ChatFriendHeadItem:buildShowItem()
    self:superCall("buildShowItem");

    self.headIconItem = Lua_ChatHeadIconItem.new(self.content);
    self.headIconItem:setSiblingIndex(1);
    self.headIconItem:setLocation(0, 8, 0);
    self.headIconItem:setEnable(false);

    self.nameStr:setEnable(false);
    self.redDot:setEnable(false);
    self.chatCount:setEnable(false);
    self.selectSp:setEnable(false);
    self.closeBtn:setEnable(false);
    self.addBg:setEnable(false);
    self.addSp:setEnable(false);
    self.closeBtn:addClickFuntion(self, self.onCloseBtnClick);
end

function Lua_ChatFriendHeadItem:setData(data)
    self.data = data
    if data.notMax ~=nil and data.notMax == true then
        self.addBg:setEnable(true);
        self.addSp:setEnable(true);
        self.nameStr:setEnable(true);
        self.nameStr:setLangValue(171007);
        self.headIconItem:setEnable(false);
        self.redDot:setEnable(false);
        self.chatCount:setEnable(false);
        self.selectSp:setEnable(false);  
        self.closeBtn:setEnable(false);
    else
        self.addBg:setEnable(false);
        self.addSp:setEnable(false);
        self.headIconItem:setEnable(true);
        self.nameStr:setEnable(true);
        self.closeBtn:setEnable(true);
        local count=DataCenter.chatData:getPrivateNewMsgNum(self.data.id);
        if count>0 then
            self.redDot:setEnable(true);
            self.chatCount:setEnable(true);
            if count > 99 then
                count = "99+";
            end
            self.chatCount.text = count;
        end
        self.nameStr.text = data.name;
        self.headIconItem:setData(data);
        self:setSelected();
    end
end

function Lua_ChatFriendHeadItem:onPressClick()
    if self.data.notMax ~=nil and self.data.notMax == true then
        Lua_WindowUtil.openWin("Lua_FriendBaseWindow", Lua_WinParam.ACTION_OPEN,1);
        Lua_WindowUtil.openWin("Lua_ChatWindow", Lua_WinParam.ACTION_CLOSE);
    else
        -- 点击玩家私聊窗口时，默认已读取
        Lua_ProxyManager.getProxy("Lua_ChatProxy"):sReadChat(self.data.id);
        Lua_MsgUtil.callFunc("CHAT_FRIEND_SELECT", self.data.id);
    end
end

function Lua_ChatFriendHeadItem:onCloseBtnClick()
    DataCenter.chatData:setShowPrivateList(self.data,true);
    DataCenter.chatData:setPrivateNewMsgNum(self.data.id, 0);
    if tonumber(DataCenter.chatData.selectPrivate) == tonumber(self.data.id) then
        DataCenter.chatData.selectPrivate=0;
    end
    Lua_MsgUtil.callFunc("CHAT_FRIEND_CLOSE");
end

function Lua_ChatFriendHeadItem:setSelected()
    if self.data.notMax ~=nil and self.data.notMax == true then
        return
    end
    if tonumber(self.data.id)==tonumber(DataCenter.chatData.selectPrivate) then
        self.nameStr:setLocation(0, -45, 0);
        self.headIconItem:setLocation(0, 15, 0);
        self.closeBtn:setLocation(52, 43, 0);

        self.selectSp:setEnable(true);
        self.redDot:setEnable(false);
        self.chatCount:setEnable(false);
        DataCenter.chatData:setPrivateNewMsgNum(self.data.id, 0);
    else
        self.nameStr:setLocation(0, -52, 0);
        self.headIconItem:setLocation(0, 8, 0);
        self.closeBtn:setLocation(42, 32, 0);
        self.selectSp:setEnable(false);
    end
end
function Lua_ChatFriendHeadItem:dispose()
    self:superCall("dispose");
end