Lua_ChatHeadIconItem = class("Lua_ChatHeadIconItem", Lua_DisplayObject);
function Lua_ChatHeadIconItem:ctor(p, needClick)
    self.needClick = needClick ~= nil and needClick or false;
    self:superCall("ctor", p);
end

function Lua_ChatHeadIconItem:buildShowItem()
    self:superCall("buildShowItem");

    self.headItem = Lua_AvatarItem.new(self.content);
    self.headItem:setScale(0.68, 0.68, 1);

    if self.needClick then
        self.headItem.avatarIcon.clickScale = false;
        self.headItem.avatarIcon:addMousDownFuntion(self, self.onHeadClick);
        self.headItem.avatarIcon:addMouseUpFuntion(self, self.onHeadUpClick);
    end
end

function Lua_ChatHeadIconItem:clean()
    self.data = nil;
    self.player_id = nil;
    Lua_CommonUtil.removeTimer(self, self.onRightCheckPoint);
end

function Lua_ChatHeadIconItem:dispose()
    Lua_CommonUtil.removeTimer(self, self.onRightCheckPoint);

    self.data = nil;
    if self.headItem ~= nil then
        self.headItem:dispose();
        self.headItem = nil;
    end
    self:superCall("dispose");
end

function Lua_ChatHeadIconItem:setData(data)
    self.data = data;
    self.player_id = data.id;

    self.headItem:setRoleDressUp(data.dress_info, true);
    self.headItem:setRoleLevel2(data.level);
end

function Lua_ChatHeadIconItem:onHeadClick()
    self.isPoint = false;
    self.startTime = getTime();
    if tonumber(self.player_id) == tonumber(DataCenter.roleData.roleId) then
        OperateAlert.showLangValue(171025);
        return;
    end

    if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_FRIEND then
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.player_id, self.data.server_flag);
        return;
    end
    
    Lua_CommonUtil.addTimer("onRightCheckPoint", 0.01, self, self.onRightCheckPoint);
end

function Lua_ChatHeadIconItem:onHeadUpClick()
    Lua_CommonUtil.removeTimer(self, self.onRightCheckPoint);
    if self.isPoint == true then
        return;
    end

    if DataCenter.chatData.openChannelTag == Lua_ChatData.CHANNEL_FRIEND then
        return;
    end

    if tonumber(self.player_id) == tonumber(DataCenter.roleData.roleId) then
        return;
    end

    Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.player_id, self.data.server_flag);
end

function Lua_ChatHeadIconItem:onRightCheckPoint()
    if (getTime() - self.startTime) > 2 then
        self.isPoint = true;
        Lua_CommonUtil.removeTimer(self, self.onRightCheckPoint);
        DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_POINT, self.data);
        Lua_MsgUtil.callFunc("CHAT_SHOW_TYPE_UPDATE");
    end
end