-- 收藏册单个卡牌
Lua_CollectionBookSingleCardItem = class("Lua_CollectionBookSingleCardItem", Lua_DisplayObject);
function Lua_CollectionBookSingleCardItem:ctor(p,t)
	self:superCall("ctor", p, "CollectionBookSingleCardItem_skin");
	self.dire = t;--1左边，2右边
end
function Lua_CollectionBookSingleCardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.flashItem = Lua_CommonFlashCardItem.new(self.content);
	self.flashItem:setCallBack(self, self.onOpenSingleCardClick);
end

function Lua_CollectionBookSingleCardItem:clean()
	self.playerInfo = nil;
	self.flashItem:clean();
end

function Lua_CollectionBookSingleCardItem:getWidth()
	return 400;
end

function Lua_CollectionBookSingleCardItem:getHeight()
	return 180;
end

function Lua_CollectionBookSingleCardItem:setData(chatVo)
	local info = chatVo.recordInfo;
	if info == nil then
		return;
	end

	-- clean会将回调清空
	self.flashItem:setCallBack(self, self.onOpenSingleCardClick);

	-- self.playerInfo = chatVo.chat_player;
	self.cardId = tonumber(info.value);--;101000105201
	self.time = tonumber(info.sub);
	if DataCenter.collectionBookUtil:getSingleCardConfigById(self.cardId) then
		local flashId = DataCenter.collectionBookUtil:getCardConfigByCardIdAndType(self.cardId, Lua_CollectionBookUtil.FLASH_ID);
		local flashInfo = Lua_FlashCardVo.new(flashId);
		local facScale = flashInfo.showNewCard and 0.28 or 0.36;
		self.flashItem:setScale(facScale, facScale);
		self.flashItem:setData(flashInfo);
		--特效
		local bShowEffect = DataCenter.collectionBookUtil:checkShowEffectByCardId(self.cardId);
		self.flashItem:showEffect(bShowEffect, "ui_scc_sk_0002", 0, 0, 1);

		self.playerInfo = chatVo.chat_player;
		self.contentTxt.text = LanUtil.formateStr(410059, flashInfo.flash_card_name);
		self.contentTxt:resetSize();
		local widget = self.contentTxt.preferredWidth;
		widget = widget <= 238 and 238 or widget;
		self.bg:SetDimensions(widget + 30, 322);

		if self.dire == 1 then
			self.bg:setAltas("chat_atlas", "ui_liaotian_window_003");
			self.flashItem:setLocation(146, -39);
			self.contentTxt:setLocation(42, 116);
		else
			self.bg:setAltas("chat_atlas", "ui_liaotian_window_002");
			self.flashItem:setLocation(135, -39);
		end
	end
end

function Lua_CollectionBookSingleCardItem:onOpenSingleCardClick()
	if self.playerInfo == nil then
		return;
	end

	DataCenter.collectionBookData:updateCardInfoById(self.cardId, nil, true, self.time);
	DataCenter.collectionBookData:setOtherPlayerInfo(self.playerInfo);
	Lua_WindowUtil.openWin("Lua_CollectionBookShareCardWindow", Lua_WinParam.ACTION_OPEN, {cardId = self.cardId, isOpenFromChat = true});
	Lua_WindowUtil.openWin("Lua_ChatWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_CollectionBookSingleCardItem:dispose()
	if self.flashItem ~= nil then
		self.flashItem:dispose();
		self.flashItem = nil;
	end
	self:superCall("dispose");
end
