checkRequire("Lua_ChatData");
checkRequire("Lua_BroadcastVo")
Lua_ChatProxy = class("Lua_ChatProxy")
function Lua_ChatProxy:ctor()
	self:superCall("ctor");
	DataCenter.chatData = Lua_ChatData.new();

	Lua_MsgUtil.addLuaMsg(80105002, self, self.returnChatMsg);
	Lua_MsgUtil.addLuaMsg(80105003, self, self.returnAutoBroadcasting);
	Lua_MsgUtil.addLuaMsg(80105004, self, self.onSystemBroadcasting);
    Lua_MsgUtil.addLuaMsg(80105009, self, self.rSetCrossServerState);
    Lua_MsgUtil.addLuaMsg(80105010, self, self.setShowOrHideActChatMsg);
    Lua_MsgUtil.addLuaMsg(80105011, self, self.updataChatSetting);
end

------------------------------ 上行 ------------------------------
-- 通知服务端玩家信息已读取（服务端那边判断时间戳，下次登陆时判断是否已读取） --私聊信息：id为私聊好友id， 其余频道：id为频道id
function Lua_ChatProxy:sReadChat(id)
    local cmd = ProtoPublic_pb.Proto10105012();
    cmd.friend_id = id;
    sendMsg(10105012, cmd);
end

------------------------------ 下行 ------------------------------
function Lua_ChatProxy:returnChatMsg(mp)
    DataCenter.chatData:addChatMsgMp(mp);
    -- local msg = ProtoPublic_pb.Proto80105002();
    -- msg:ParseFromString(mp.data);
    -- DataCenter.chatData:addChatMsg(msg);
    -- return nil, false;
end

function Lua_ChatProxy:returnAutoBroadcasting(mp)
    if DataCenter.bConfigLoaded ~= true then
        return;
    end
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80105003();
        msg:ParseFromString(mp.data);
        local vo = DataCenter.chatData:createBroadcastVo();
        vo.type = msg.type;
        vo.content = msg.content;
        DataCenter.chatData:playBroadcastByVo(vo);
    end
end

function Lua_ChatProxy:onSystemBroadcasting(mp)
    if DataCenter.bConfigLoaded ~= true then
        return;
    end
    DataCenter.chatData:addBroadcastMsgMp(mp);
    -- if mp.errno == 0 then
    --     local msg = ProtoPublic_pb.Proto80105004();
    --     msg:ParseFromString(mp.data);
    --     DataCenter.chatData:playBroadcast(msg);
    -- end
end

function Lua_ChatProxy:rSetCrossServerState(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80105009();
        msg:ParseFromString(mp.data);
        if tonumber(msg.flag) == 1 then
            DataCenter.chatData.crossServerState = true;
        else
            DataCenter.chatData.crossServerState = false;
        end
    end
end

function Lua_ChatProxy:setShowOrHideActChatMsg(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80105010();
        msg:ParseFromString(mp.data);
        DataCenter.chatData.act_check_state = (msg.state == 1);
    end
end

function Lua_ChatProxy:updataChatSetting(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80105011();
        msg:ParseFromString(mp.data);
        DataCenter.chatData:updataChatSetting(msg.channel_list);
    end
end