Lua_ChatUtil = { };
Lua_ChatUtil.MAX_FACE_INDEX = 15;
Lua_ChatUtil.FACE_SPACE = "　";
Lua_ChatUtil.FACE_SIZE = 45; -- 表情大小
Lua_ChatUtil.FACE_BYTE = 2 * 3; --单个表情在text所占的字节数 (共2个中文字符)
-- function Lua_ChatUtil.genChatString(str)
--     local rs = Array();
--     local startIndex = 0;
--     local endIndex = 0;
--     local lastStart = 1;
--     while true do
--         startIndex, endIndex = string.find(str, "/%d%d%d", endIndex + 1);
--         if startIndex == nil then break end
--         if lastStart < startIndex then
--             rs:add(string.sub(str, lastStart, startIndex - 1));
--         end
--         rs:add(string.sub(str, startIndex, endIndex));
--         lastStart = endIndex + 1;
--     end
--     local stringLen = string.len(str);
--     if lastStart ~= stringLen then
--         rs:add(string.sub(str, lastStart, stringLen));
--     end
--     return rs;
-- end

function Lua_ChatUtil.genChatString(str)
    local rs = Array();
    local startIndex = 0;
    local endIndex = 0;
    local lastStart = 1;
    local residueLen = string.len(str);
    local faceLen = string.len("/000");
    while true do
        startIndex, endIndex = string.find(str, "/%d%d%d", endIndex + 1);
        if startIndex == nil then break end
        if lastStart < startIndex then
            rs:add(string.sub(str, lastStart, startIndex - 1));
            residueLen = residueLen - (startIndex - 1 - lastStart);
        end
        rs:add(string.sub(str, startIndex, endIndex));
        lastStart = endIndex + 1;
        residueLen = residueLen - faceLen;
    end

    if residueLen > 0 then
        rs:add(string.sub(str, lastStart, lastStart+residueLen));
    end
    -- 打印数据
    -- for i = 1, rs:getSize() do
    --     print("整体内容:"..str,"arr长度:"..rs:getSize(), "arr["..i.."]:".. rs[i], "arr["..i.."]:字节长度:"..string.len(rs[i]), "/%d%d%d的长度:"..faceLen);
    -- end
    return rs;
end

function Lua_ChatUtil.sendMsg(channel, str, checkFilter, checkSen)
    if checkSen ~= nil and checkSen == true then
        str = string.gsub(str, "%&", "");
        str = string.gsub(str, "%s", "");
        if string.len(str) == 0 then
            OperateAlert.showLangValue(171023);
            return;
        end
    end

    local cmd = ProtoPublic_pb.Proto10105001();
    cmd.content_type = 1;
    cmd.voice_sec = 0;
    cmd.private_role_id = 0;

    local contentData = DataCenter.chatData.contentData;
    if contentData ~= nil then
        if DataCenter.chatData.contentType == Lua_ChatData.CONTENT_FIGHT_VIDEO then
            cmd.content_type = Lua_ChatData.CONTENT_FIGHT_VIDEO;

            local add_list = getProtoMsg("ProtoChatAddition");
            add_list.addit_type = Lua_ChatData.ANNEX_FIGHT_VIDEO;
            add_list.record_info.record_id = tonumber(contentData);
            add_list.record_info.server_flag = DataCenter.roleData.server_flag;

            cmd.add_list:addToList(add_list);
        elseif DataCenter.chatData.contentType == Lua_ChatData.CONTENT_PEAKDUEL_RECORD then
            cmd.content_type = Lua_ChatData.CONTENT_PEAKDUEL_RECORD;

            local add_list = getProtoMsg("ProtoChatAddition");
            add_list.addit_type = Lua_ChatData.ANNEX_PEAKDUEL_RECORD;
            add_list.standings_info.region_id = contentData.region_id;
            add_list.standings_info.role_id = DataCenter.roleData.roleId;
            add_list.standings_info.standings_type = contentData.standings_type;
            add_list.standings_info.server_flag = DataCenter.roleData.server_flag;

            cmd.add_list:addToList(add_list);
        elseif DataCenter.chatData.contentType == Lua_ChatData.CONTENT_COLLECTION then
            cmd.content_type = Lua_ChatData.CONTENT_COLLECTION;

            local add_list = getProtoMsg("ProtoChatAddition");
            add_list.addit_type = Lua_ChatData.ANNEX_COLLECTION;
            add_list.collection_info.collection_id = contentData;

            cmd.add_list:addToList(add_list);
        elseif DataCenter.chatData.contentType == Lua_ChatData.CONTENT_XUANYAO then
            cmd.content_type = Lua_ChatData.CONTENT_XUANYAO;
        elseif DataCenter.chatData.contentType == Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD then --单个收藏册卡牌分享
            cmd.content_type = Lua_ChatData.CONTENT_COLLECTIONBOOK_CARD;
            
            local add_list = getProtoMsg("ProtoChatAddition");
            add_list.addit_type = Lua_ChatData.ANNEX_COLLECTIONBOOK_CARD;
            add_list.card_info.key = DataCenter.roleData.roleId;
            add_list.card_info.value = contentData.cardId;
            add_list.card_info.sub = contentData.active_time;

            cmd.add_list:addToList(add_list);
        elseif DataCenter.chatData.contentType == Lua_ChatData.CONTENT_COLLECTION_BOOK then --整个收藏册
            cmd.content_type = Lua_ChatData.CONTENT_COLLECTION_BOOK;
            
            local add_list = getProtoMsg("ProtoChatAddition");
            add_list.addit_type = Lua_ChatData.ANNEX_COLLECTION_BOOK;
            add_list.card_info.key = DataCenter.roleData.roleId;

            cmd.add_list:addToList(add_list);
        elseif DataCenter.chatData.contentType == Lua_ChatData.CONTENT_RECRUIT_LUCKY then -- 小卖部欧气分享
            cmd.content_type = Lua_ChatData.CONTENT_RECRUIT_LUCKY;

            local add_list = getProtoMsg("ProtoChatAddition");
            add_list.addit_type = Lua_ChatData.ANNEX_RECRUIT_LUCKY;
            add_list.recruit_show.recruit_type = contentData.recruit_type;
            add_list.recruit_show.luck_num = tonumber(contentData.luck_num);
            add_list.recruit_show.recruit_tick = tonumber(contentData.recruit_tick);

            local obj = contentData.hero_list;
            if obj ~= nil then
                for i = 1, #obj do
                    add_list.recruit_show.hero_list:append(tonumber(obj[i]));
                end
            end

            obj = contentData.flash_maps;
            if obj ~= nil then
                for i = 1, #obj do
                    local struct = getProtoMsg("ProtoPairLong");
                    struct.key = tonumber(obj[i].key);
                    struct.value = tonumber(obj[i].value);
                    add_list.recruit_show.flash_maps:addToList(struct);
                end
            end

            cmd.add_list:addToList(add_list);
        elseif DataCenter.chatData.contentType == Lua_ChatData.CONTENT_DYNANIC_EMOJI then -- 动态表情
            cmd.content_type = Lua_ChatData.CONTENT_DYNANIC_EMOJI;
        elseif DataCenter.chatData.contentType == Lua_ChatData.CONTENT_LEAGUE_DUEL_GRAB then -- 公会对抗帮抢
            cmd.content_type = Lua_ChatData.CONTENT_LEAGUE_DUEL_GRAB;

            local add_list = getProtoMsg("ProtoChatAddition");
            add_list.addit_type = Lua_ChatData.ANNEX_LEAGUE_DUEL_GRAB;
            add_list.grab_info.grab_player_id = tonumber(tostring(contentData.otherId));
            add_list.grab_info.share_player_id = tonumber(tostring(contentData.roleId));
            add_list.grab_info.grab_record_id = tonumber(tostring(contentData.recordId));
            cmd.add_list:addToList(add_list);
        end
        DataCenter.chatData:setChatShowItem(0, nil);
    end

    if channel == Lua_ChatData.CHANNEL_FRIEND then
        cmd.private_role_id = DataCenter.chatData.selectPrivate;
    end

    if checkFilter == true then
        str = FilterText.GetInstance():GetFilterStr(str, 0);
        --    print("1checkFilter == true",str);
        -- str = ChatUtil.getFilterStr(str, Lua_ChatChannelData.getConfigDataById(channel).num_limit);
        -- str = Lua_ChatUtil.validStringAndEmoji(str, Lua_ChatChannelData.getConfigDataById(channel).num_limit);
        --    print("2checkFilter == true",str);
    end
    cmd.chat_type = channel;
    cmd.wcontent = str;
    --print(str);
    --print("频道：",cmd.chat_type, "发送内容类型", cmd.content_type, "发送内容", cmd.wcontent)
    sendMsg(10105001, cmd);
end

function Lua_ChatUtil.sendVoiceMsg(channel)
    local voiceByte = ChatRecordSound.getInstance().soundByte;
    if voiceByte == nil then
        return;
    end
    local voiceTime = ChatRecordSound.getInstance().voiceTime;
    ChatRecordSound.getInstance():clear();
    if voiceTime < 1 then
        OperateAlert.showLangValue(171019);
        return;
    end
    local cmd = ProtoPublic_pb.Proto10105001();
    local str1 = "";
    local vtype = 1;
    if voiceByte == nil then
        OperateAlert.show("没有声音数据");
        return;
    end
    cmd.content_type = 2;
    cmd.voice_sec = Mathf.Floor(voiceTime + 0.5);
    cmd.wcontent = str1;
    cmd.chat_type = channel;
    if channel == Lua_ChatData.CHANNEL_FRIEND then
        cmd.private_role_id=DataCenter.chatData.selectPrivate;
    end

    local wba=WriteByteArray();
    wba:writeInt32(vtype);
    wba:writeByteList(voiceByte);

    local nnn =MsgPacket();
    nnn.data = wba:getBytes();

    cmd.vcontent = nnn.data;
    sendMsg(10105001, cmd);
end
function Lua_ChatUtil.isChatFace(str)
    local len = string.len(str);
    if len ~= 4 then
        return false;
    end
    local startIndex = 0;
    local endIndex = 0;
    startIndex, endIndex = string.find(str, "/%d%d%d", 1);
    if startIndex == nil then
        return false;
    end
    local num = tonumber(string.sub(str, 2, 4));
    if num >= 0 and num <= Lua_ChatUtil.MAX_FACE_INDEX then
        return true;
    end
    return false;
end

function Lua_ChatUtil.urlClickHandle(urlStr, vo)
    if strIsNullOrEmpty(urlStr) then
        return;
    end

    local arr = string.split(urlStr, "_");
    if arr[1] == "playerClick" then
        local rid = tonumber(arr[2]);
        if rid <= 0 then
            OperateAlert.showLangValue(171028);
            return;
        end
        if DataCenter.roleData:isMyself(rid) then
            OperateAlert.showLangValue(171025);
            return;
        end
        Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(rid);
    elseif arr[1] == "itemClick" then
        local index = tonumber(arr[2])
        if vo and vo.getItemInfo ~= nil then
            Lua_PackUtil.showItemInfo(vo:getItemInfo(index));
        end
    elseif arr[1] == "openUrl" then
        local str = "";
        local len = arr:getSize();
        for i = 2, len do
            str = str .. arr[i];
            if i ~= len then
                str = str .. "_";
            end
        end
        UnityEngine.Application.OpenURL(str);
    elseif arr[1] == "openWin" then
        Lua_WindowUtil.openWin(arr[2] .. "_" .. arr[3], Lua_WinParam.ACTION_OPEN, tonumber(arr[4]));
    elseif arr[1] == "checkVideo" then
        if arr[2] ~= nil then
            Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(arr[2], Lua_FightDefine.REPLAY_VIDEO);
        end
    elseif arr[1] == "pdRecord" then
        if arr[2] ~= nil and arr[3] ~= nil and arr[4] ~= nil then
            local param = { regionId = tonumber(arr[2]), roleId = tonumber(arr[3]), serverFlag = arr[4], bChat = true };
            Lua_WindowUtil.openWin("Lua_PeakDuelStandingsWindow", Lua_WinParam.ACTION_OPEN, param);
        end
    elseif arr[1] == "collection" then
        if arr[2] ~= nil then
            local funOpenId = getConfig("collection_cabinet_const", "function_id", "value");
            if DataCenter.funcOpenData:isOpened(funOpenId, true) then
                local itemId = tonumber(arr[2]);
                if DataCenter.roleData:isMyself(vo.chat_player.id) then
                    Lua_WindowUtil.openWin("Lua_CollectionDetailWindow", Lua_WinParam.ACTION_OPEN, {id = itemId, isShowInfo = true});
                else
                    Lua_ProxyManager.getProxy("Lua_CollectionProxy"):sOtherCollectionInfo(vo.chat_player.id, itemId);
                end
            end
        end
    elseif arr[1] == "recruitLucky" then
        Lua_WindowUtil.openWin("Lua_RecruitShareHeroWindow", Lua_WinParam.ACTION_OPEN, vo.recordInfo);
    elseif arr[1] == "leagueSluff" then
        DataCenter.allianceData:setGrabInfo(arr[3], arr[2])
        Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteGrab(arr[2]);
    end
end

function Lua_ChatUtil.replaceChatMsg(str)
    str = Lua_ChatUtil.fullToHalf(str);
    local restr = {
        { "一", "1" },{ "二", "2" },{ "三", "3" },{ "四", "4" },{ "五", "5" },{ "六", "6" },{ "七", "7" },{ "八", "8" },{ "九", "9" },{ "零", "0" },
        { "①", "1" },{ "②", "2" },{ "③", "3" },{ "④", "4" },{ "⑤", "5" },{ "⑥", "6" },{ "⑦", "7" },{ "⑧", "8" },{ "⑨", "9" },{ "⑩", "10" }
    };
    for i, v in ipairs(restr) do
        str = string.gsub(str, v[1], v[2]);
    end
    return str;
end
function Lua_ChatUtil.checkSendMsg(str)
    str = string.gsub(str, "/%d%d%d", "  ");
    local numcount = Lua_ChatUtil.findNumberCount(str);
    local worldcount = Lua_ChatUtil.findWorldCount(str);
    if numcount == worldcount then
        -- 纯数字
        if numcount >= 7 then
            return 1;
        else
            return 0;
        end
    else
        if worldcount >= 5 then
            return 2;
        else
            return 0;
        end
    end
end
function Lua_ChatUtil.findNumberCount(str)
    local num = 0;
    local index = 1;
    while true do
        local a = string.find(str, "%d", index);
        if a == nil then
            break;
        end
        index = a + 1;
        num = num + 1;
    end
    return num;
end
function Lua_ChatUtil.findWorldCount(str)
    local num = 0;
    local index = 1;
    while true do
        local a = string.find(str, "%w", index);
        if a == nil then
            break;
        end
        index = a + 1;
        num = num + 1;
    end
    return num;
end
-- 全角转半角
function Lua_ChatUtil.fullToHalf(str)
    local newStr = "";
    local pos = 1;
    while pos <= #str do
        local oneCount = Lua_ChatUtil.getOneCount(string.byte(str, pos));
        if oneCount == 3 then
            local char = string.sub(str, pos, pos + 2);
            local unicodeNum = Lua_ChatUtil.utf8ToNum(char);
            -- print(unicodeNum);
            if unicodeNum == 12288 then -- 全角空格
                unicodeNum = 32;
                nextStr = string.char(unicodeNum);
                pos = pos + oneCount;
            elseif unicodeNum >= 65281 and unicodeNum <= 65374 then -- 其它全角字符
                unicodeNum = unicodeNum - 65248;
                nextStr = string.char(unicodeNum);
                pos = pos + oneCount;
            else  -- 中文
                nextStr = string.sub(str, pos, pos);
                pos = pos + 1;
            end
        else
            nextStr = string.sub(str, pos, pos);
            pos = pos + 1;
        end
        newStr = newStr .. nextStr;
    end
    return newStr;
end
-- utf8转unicode有效码值
function Lua_ChatUtil.utf8ToNum(char)
    local num = 0;
    local pos = 1;
    while pos <= #char do
        local oneCount = Lua_ChatUtil.getOneCount(string.byte(char, pos));
        if oneCount < 1 then
            num = string.byte(char, pos);
            oneCount = 1;
        else
            boundary = 8;
            i = oneCount + 1;
            while i < boundary * oneCount do
                if i % boundary == 0 then -- 8位后处理下一字节，根据编码规则跳过首两位
                    i = i + 2;
                end                
                local weiCount = boundary - i % boundary; -- 一个字节的剩余位数
                local val1 = 2 ^(weiCount - 1);
                local val2 = string.byte(char, pos + Mathf.Floor(i / boundary)); -- 获取当前字节
                local newNum = Lua_BitOperation.lShift(num, 1); 
                if Lua_BitOperation.andOp(val1, val2) ~= 0 then -- 判断当前位是否为1
                    -- print(1)
                    num = Lua_BitOperation.orOp(newNum, 1);
                else
                    -- print(0)
                    num = newNum;
                end
                i = i + 1;
            end
        end
        pos = pos + oneCount;
    end
    return num;
end
-- 获取一个字节中，从最高位开始连续的1的个数
function Lua_ChatUtil.getOneCount(num)
    if nil == num then
        return -1
    end
    local count = 0
    while Lua_BitOperation.andOp(num, 0x80) ~= 0 do
        -- 和10000000进行与操作判断最高位是否为1
        count = count + 1
        num = Lua_BitOperation.lShift(num, 1);
    end
    return count
end

function Lua_ChatUtil.checkChannelOpen(channel, showTips)
    local channelInfo = Lua_ChatChannelData.getConfigDataById(channel);
    if not DataCenter.funcOpenData:isOpened(channelInfo.openId, showTips) then
        return false;
    end

    if channel == Lua_ChatData.CHANNEL_LEAGUE and DataCenter.roleData.league_id <= 0 then
        if showTips then
            OperateAlert.showLangValue(171039);
        end
        return false;
    elseif channel == Lua_ChatData.CHANNEL_CROSS_SERVER and DataCenter.chatData.crossServerState == false then
        if showTips then
            OperateAlert.showLangValue(171029);
        end
        return false;
    end

    return true;
end

function Lua_ChatUtil.checkHasPoint(content)
    local index = string.find(content,"@"..DataCenter.roleData.name.." ");
    if index == nil then
        return false;
    end
    return true;
end

-- 去除富文本颜色, 文本链接
function Lua_ChatUtil.getRealStr(str)
    local showStr = Lua_ChatUtil.setShowStr(str, "<color=#", "</color>");
    showStr = Lua_ChatUtil.setShowStr(showStr, "<url=", "</url>");
    return showStr;
end

--清除文本中不显示的字符
function Lua_ChatUtil.setShowStr(str, firstStr, lastStr)
    local showStr = string.gsub(str, lastStr, "");
    while true do
        local startIndex = string.find(showStr, firstStr);
        if startIndex == nil then break; end
        local endIndex = string.find(showStr, ">", startIndex + 1);
        if endIndex == nil then break;  end
        showStr = string.sub(showStr, 1, startIndex - 1) .. string.sub(showStr, endIndex + 1);
    end
    return showStr;
end

-- 判断玩家是否为私聊的发起者
function Lua_ChatUtil.judgeIsPlayer(private_playerId)
    local roleId = DataCenter.roleData.roleId;
    return roleId == tonumber(private_playerId);
end

function Lua_ChatUtil.getChatPriority()
    if Lua_ChatUtil.chatPriority == nil then
        Lua_ChatUtil.chatPriority = {};
        local chatConfig = getConfig("chat");
        local count;
        for k, v in pairs(chatConfig) do
            if v.show_type == 1 then
                count = #Lua_ChatUtil.chatPriority + 1;
                Lua_ChatUtil.chatPriority[count] = { id = k, priority = v.priority};
            end
        end

        table.sort(Lua_ChatUtil.chatPriority, function(a, b)
            return a.priority < b.priority;end);
    end

    return Lua_ChatUtil.chatPriority;
end

-- 根据总的字节数（totalByte）、当前字符数（currentByte）截取字符串inputstr中有效的字符串
function Lua_ChatUtil.subStr(inputstr, totalByte, currentByte)
    local lenInByte = #inputstr
    local colorStartStr, colorEndStr = "<color=#", "</color>";
    local i = 1;
    local hasColorStr = false;
    local startIndex, endIndex = 0, 0; -- <color=#>的初始、结束索引
    local colorEndStartIndex, colorEndEndIndex = 0, 0;  --</color>的初始、结束索引
    while (i<=lenInByte) do
        -- 忽略color值设置
        startIndex = string.find(inputstr, colorStartStr, i);
        endIndex = string.find(inputstr, ">", i);
        if startIndex ~= nil and endIndex ~= nil and i >= startIndex then
            i = endIndex + 1;
            hasColorStr = true;
            -- print(string.sub(inputstr, 1, i - 1), "hasColorStr:",hasColorStr,startIndex, endIndex)
        else
            colorEndStartIndex, colorEndEndIndex = string.find(inputstr, colorEndStr, i);
            if hasColorStr == true and colorEndEndIndex ~= nil and i >= colorEndStartIndex then
                i = colorEndEndIndex + 1;
                hasColorStr = false;
            else
                -- startIndex, endIndex = string.find
                local curByte = string.byte(inputstr, i)
                local byteCount = 1;
                if curByte>0 and curByte<=127 then
                    byteCount = 1; --1字节字符
                elseif curByte>=192 and curByte<223 then
                    byteCount = 2; --双字节字符
                elseif curByte>=224 and curByte<239 then
                    byteCount = 3; --汉字
                elseif curByte>=240 and curByte<=247 then
                    byteCount = 4; --4字节字符
                end

                if currentByte + byteCount > totalByte then
                    break;
                end

                currentByte = currentByte + byteCount;
                i = i + byteCount;
            end
        end
    end

    return currentByte, string.sub(inputstr, 1, i - 1), hasColorStr; -- 当前字节数、有效字符、是否有</color>被截取掉
end

-- 检测发送的消息中表情特殊编码是否完整，字符串及表情均为有效的，且长度为validStrLen
function Lua_ChatUtil.validStringAndEmoji(str, validStrLen)
    local arr = Lua_ChatUtil.genChatString(str);
    local len = arr:getSize();
    local totalByte = validStrLen * 3; -- text显示字符的总字节数，3为一个中文字符所占的字节;
    local faceByte = Lua_ChatUtil.FACE_BYTE; --单个表情在text所占的字节数 
    -- local faceSize = 30; -- 表情显示大小
    local curByte = 0; -- 当前字节数
    local calByte = 0; -- 预计算 字节数

    local tempStr = "";
    for i = 1, len do
        if Lua_ChatUtil.isChatFace(arr[i]) == true then
            calByte  = curByte + faceByte;
            if calByte > totalByte then
                break;
            end
            curByte = calByte;
            tempStr = tempStr .. arr[i];
        else
            local subStr;
            curByte, subStr = Lua_ChatUtil.subStr(arr[i], totalByte, curByte);  
            tempStr = tempStr..subStr;
        end
    end
    return tempStr;
end

function Lua_ChatUtil.calcInputTextLen(str)
    local arr = Lua_ChatUtil.genChatString(str);
    local len = 0;
    local chineseLen = 3; -- utf8中中文的长度，表情当成一个中文输入
    for i = 1, arr:getSize() do
        if Lua_ChatUtil.isChatFace(arr[i]) == true then
            len = len + chineseLen;
        else
            len = len + string.len(arr[i]);
        end
    end
    return len;
end