--爬塔数据
checkRequire("Lua_ClimbTowerVo");
Lua_ClimbTowerData = class("Lua_ClimbTowerData")
function Lua_ClimbTowerData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ClimbTowerData:dispose()
	self.bInit = false;
	self._towerDic = nil;
	if self._towerArr ~= nil then
		self._towerArr:clear();
		self._towerArr = nil;
	end
end

function Lua_ClimbTowerData:initTowerInfo()
	if self.bInit ~= true then
		self.bInit = true;
		self._towerDic = {};
		self._towerArr = Array();
		local vo;
		local config = getConfig("towerscript_list");
		for k,v in pairs(config) do
			vo = Lua_ClimbTowerVo.new(k, v);
			self._towerDic[k] = vo;
			self._towerArr:add(k);
		end
		self._towerArr:sortf(self, self.onTowerSortFun)
	end
end

function Lua_ClimbTowerData:onTowerSortFun(a, b)
	local vo_a = self:getTowerVoById(a);
	local vo_b = self:getTowerVoById(b);
	if vo_a.sort > vo_b.sort then
		return false;
	end
	return true;
end

function Lua_ClimbTowerData.Get:towerDic()
	self:initTowerInfo();
	return self._towerDic;
end

function Lua_ClimbTowerData.Get:towerArr()
	self:initTowerInfo();
	return self._towerArr;
end

function Lua_ClimbTowerData:fromServer50185001(msg)
	if msg == nil then
		return;
	end
	self:updateSingleTower(msg.tower_list);
end

function Lua_ClimbTowerData:fromServer80185001(msg)
	if msg == nil then
		return;
	end
	self:updateSingleTower(msg.tower);
end

function Lua_ClimbTowerData:updateSingleTower(msg)
	local vo = self:getTowerVoById(msg.index);
	if vo == nil then
		return;
	end
	vo:fromServer(msg);
	self:checkRedPoint(vo);
end

-- 通过副本类型获取vo
function Lua_ClimbTowerData:getTowerVoById(index)
	index = tonumber(index)
    if self.towerDic == nil then
        return nil;
    end
    return self.towerDic[index];
end

-- 获取关卡奖励领取状态 0不可领取 1领取 2已领取
function Lua_ClimbTowerData:getStageRewardState(index, stage_id)
	local vo = self:getTowerVoById(index);
	if vo == nil then
		return 0;
	end
	if vo.receiveDic == nil or vo.receiveDic[stage_id] == nil then
		if stage_id < vo.cur_stage_id then
			return 2;
		elseif stage_id > vo.cur_stage_id then
			return 0;
		else
			if vo.cur_stage_state == 0 then -- 当前关卡未通关
				return 0;
			else
				return 2;
			end
		end
	end
	return vo.receiveDic[stage_id];
end

function Lua_ClimbTowerData:checkCampTowerIsOpen()
	if DataCenter.funcOpenData:isOpened(10183) or DataCenter.funcOpenData:isOpened(10184) 
		or DataCenter.funcOpenData:isOpened(10185) or DataCenter.funcOpenData:isOpened(10186) then
		return true;
	end
	return false;
end

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
function Lua_ClimbTowerData:checkRedPoint(vo)
	if DataCenter.funcOpenData:isOpened(vo.func_id) then
		local state = false;
		if vo.pass_stage_state ~= nil and #vo.pass_stage_state > 0 then
			state = true;
		end
		DataCenter.redPointData:updateRedPointState(vo.redpointId, state); -- 奖励红点
		DataCenter.redPointData:updateRedPointState(vo.loginId, vo.isOpened); -- 登录红点

		-- 每日奖励红点
		if vo.id == Lua_ClimbTowerUtil.LIGHT_ID and vo.daily_gift_state ~= nil then
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ClimbTower_9_Daily, vo.daily_gift_state.value == 1);
		end
	end
end