checkRequire("Lua_CollectionBookData");
checkRequire("Lua_CollectionBookUtil");
Lua_CollectionBookProxy = class("Lua_CollectionBookProxy");
function Lua_CollectionBookProxy:ctor()
    DataCenter.collectionBookUtil = Lua_CollectionBookUtil.new();
    DataCenter.collectionBookData = Lua_CollectionBookData.new();

    Lua_MsgUtil.addLuaMsg(50203001, self, self.rGetCBPageInfo);--请求卡册封面信息(返回)
    Lua_MsgUtil.addLuaMsg(50203003, self, self.rGetCBOrdinaryCardInfo);--请求卡册普卡信息(返回)
    Lua_MsgUtil.addLuaMsg(50203005, self, self.rActiveCardInfo);--请求激活卡牌信息(返回)
    Lua_MsgUtil.addLuaMsg(50203006, self, self.rPlaceCardInBookInfo);--请求卡牌放入卡册(返回)
    Lua_MsgUtil.addLuaMsg(50203007, self, self.rAdmireCountInfo);--请求点赞其他玩家(返回)
    Lua_MsgUtil.addLuaMsg(50203008, self, self.rGetCBRankInfo);--请求查看玩家卡册排行榜信息(返回)
    Lua_MsgUtil.addLuaMsg(50203009, self, self.rReceivedReward);--请求领取奖励(返回)
    Lua_MsgUtil.addLuaMsg(50203010, self, self.rOtherPlayerCBookInfo);--请求玩家卡册信息(返回)
    Lua_MsgUtil.addLuaMsg(80203008, self, self.rUpdateCollectionBookRank);-- 通知收藏册排行榜刷新(返回)跨天

    Lua_MsgUtil.addLuaMsg(50114019, self, self.rHeroFetter);      -- 羁绊(返回)
    Lua_MsgUtil.addLuaMsg(50114037, self, self.rReceivedFetterReward);      -- 羁绊奖励领取(返回)
    Lua_MsgUtil.addLuaMsg(80114019, self, self.rUpdateHeroFetter);      -- 通知羁绊状态变更(返回)
end

function Lua_CollectionBookProxy:sGetCBPageInfo()--请求卡册封面信息
    sendMsg(10203001);
end

function Lua_CollectionBookProxy:sGetCBOrdinaryCardInfo()--请求卡册普卡信息
    sendMsg(10203003);
end

function Lua_CollectionBookProxy:sSaveCBPageInfo(list)--请求保存新的卡册封面信息
    if next(list) ~= nil then
        local cmd = ProtoPublic_pb.Proto10203004();
        for i = 1, #list do
            cmd.cover_list:append(list[i]);
        end
        sendMsg(10203004, cmd);
    end
end

function Lua_CollectionBookProxy:sActiveCardInfo(card_id) -- 请求激活卡牌
    local cmd = ProtoPublic_pb.Proto10203005();
    cmd.card_id = card_id;--激活卡牌id
    sendMsg(10203005, cmd);
end

function Lua_CollectionBookProxy:sPlaceCardInBookInfo(card_id) -- 请求卡牌放入卡册
    local cmd = ProtoPublic_pb.Proto10203006();
    cmd.card_id = card_id;
    sendMsg(10203006, cmd);
end

function Lua_CollectionBookProxy:sAdmireOtherPlayer(player_id) --请求给其他玩家点赞
    local cmd = ProtoPublic_pb.Proto10203007();
    cmd.player_id = tonumber(player_id);
    sendMsg(10203007, cmd);
end

function Lua_CollectionBookProxy:sGetCBRankInfo() --请求查看玩家卡册排行榜信息
    sendMsg(10203008);
end

function Lua_CollectionBookProxy:sReceivedReward(bag_id) --请求领取奖励
    local cmd = ProtoPublic_pb.Proto10203009();
    cmd.bag_id = bag_id;
    sendMsg(10203009, cmd);
end

function Lua_CollectionBookProxy:sFindOtherCards(player_id) --请求请求玩家卡册信息
    local cmd = ProtoPublic_pb.Proto10203010();
    cmd.player_id = player_id;
    sendMsg(10203010, cmd);
end

-- 英雄羁绊
function Lua_CollectionBookProxy:sHeroFetter()
    sendMsg(10114019);
end

--请求领取羁绊奖励
function Lua_CollectionBookProxy:sReceiveFetterReward(fetter_id) 
    local cmd = ProtoPublic_pb.Proto10114037();
    cmd.fetter_id = fetter_id;
    sendMsg(10114037, cmd);
end




------------------------------------ 下行 ------------------------------------

function Lua_CollectionBookProxy:rGetCBPageInfo(mp)--请求卡册封面信息(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50203001();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer50203001(msg);
        Lua_MsgUtil.callFunc("UPDATE_CBWEAPON_CARDCOUNT"); -- 卡牌数量更新
        Lua_MsgUtil.callFunc("UPDATE_CBWEAPON_CARDINFO");
    end
end

function Lua_CollectionBookProxy:rGetCBOrdinaryCardInfo(mp)--请求卡册普卡信息(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50203003();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer50203003(msg);
    end
end

function Lua_CollectionBookProxy:rActiveCardInfo(mp)--请求激活卡牌信息(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50203005();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer50203005(msg);
        Lua_WindowUtil.openWin("Lua_CollectionBookActiveCardWindow", Lua_WinParam.ACTION_OPEN, tonumber(msg.card_id));
        Lua_MsgUtil.callFunc("UPDATE_CBCARDDETAIL_ACTIVECARD");
    end
end

function Lua_CollectionBookProxy:rPlaceCardInBookInfo(mp)--请求卡牌放入卡册(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50203006();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer50203006(msg);
        Lua_MsgUtil.callFunc("UPDATE_CBCARDDETAIL_PUSHBOOK");
    end
end

function Lua_CollectionBookProxy:rAdmireCountInfo(mp)--请求点赞其他玩家(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50203007();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer50203007(msg);
    end
end

function Lua_CollectionBookProxy:rGetCBRankInfo(mp)--请求查看玩家卡册排行榜信息(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50203008();
        msg:ParseFromString(mp.data);
        -- DataCenter.collectionBookData:fromServer50203008(msg);
        Lua_MsgUtil.callFunc("OPEN_CBRANKPANEL", msg);
    end
end

function Lua_CollectionBookProxy:rReceivedReward(mp)--请求领取奖励(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50203009();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer50203009(msg);
        
        Lua_MsgUtil.callFunc("UPDATE_CBCARDDETAIL_REWARD"); -- 卡牌详情界面红点
        Lua_MsgUtil.callFunc("UPDATE_CBCARDDETAIL_UPDATECARD_REDPOINT");--卡册主界面卡牌红点
    end
end

function Lua_CollectionBookProxy:rOtherPlayerCBookInfo(mp)--请求玩家卡册信息(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50203010();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer50203010(msg);
        Lua_WindowUtil.openWin("Lua_CollectionBShareWeaponWindow", Lua_WinParam.ACTION_OPEN);
    end
end

-- 英雄羁绊(返回)
function Lua_CollectionBookProxy:rHeroFetter(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114019();
        msg:ParseFromString(mp.data);
        -- print("英雄羁绊(返回)")
        DataCenter.collectionBookData:fromServer50114019(msg);
        Lua_MsgUtil.callFunc("UPDATE_COLLECTBOOK_HEROFETTER_INFO");
    end
end

-- 羁绊奖励领取(返回)
function Lua_CollectionBookProxy:rReceivedFetterReward(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50114037();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer50114037(msg);
        Lua_MsgUtil.callFunc("UPDATE_COLLECTBOOK_HEROFETTER_INFO");
    end
end

-- 通知羁绊状态变更(返回)
function Lua_CollectionBookProxy:rUpdateHeroFetter(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80114019();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer80114019(msg);
        Lua_MsgUtil.callFunc("UPDATE_COLLECTBOOK_HEROFETTER_INFO", true);
    end
end

-- 通知收藏册排行榜刷新(返回)跨天
function Lua_CollectionBookProxy:rUpdateCollectionBookRank(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80203008();
        msg:ParseFromString(mp.data);
        DataCenter.collectionBookData:fromServer80203008(msg);
        Lua_MsgUtil.callFunc("COLLECTIONBOOK_UPDATE_RANK_OVERDAY");
    end
end

