checkRequire("Lua_CollectionData");
Lua_CollectionProxy = class("Lua_CollectionProxy");
function Lua_CollectionProxy:ctor()
	DataCenter.collectionData = Lua_CollectionData.new();

	Lua_MsgUtil.addLuaMsg(50200001, self, self.rCollectionInfo);
	Lua_MsgUtil.addLuaMsg(80200004, self, self.nCollectionInfo);
	Lua_MsgUtil.addLuaMsg(50200005, self, self.rOtherCollectionInfo);
end

-- 请求藏品柜信息（返回）
function Lua_CollectionProxy:rCollectionInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50200001();
		msg:ParseFromString(mp.data);
		DataCenter.collectionData:fromServerCollection(msg);
		Lua_MsgUtil.callFunc("UPDATE_COLLECTION_CABINET_INFO");
	end
end

-- 通知藏品更新（通知）
function Lua_CollectionProxy:nCollectionInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80200004();
		msg:ParseFromString(mp.data);
		DataCenter.collectionData:fromServerCollection(msg);
		Lua_MsgUtil.callFunc("UPDATE_COLLECTION_CABINET_INFO", true);
	end
end

-- 请求其他角色藏品信息（返回）
function Lua_CollectionProxy:rOtherCollectionInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50200005();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_CollectionDetailWindow", Lua_WinParam.ACTION_OPEN, msg.collection_info);
	end
end





-- 请求藏品柜信息
function Lua_CollectionProxy:sCollectionInfo()
	sendMsg(10200001);
end

-- 请求激活藏品 collection_id 藏品id
function Lua_CollectionProxy:sActiveCollection(collection_id)
	local cmd = ProtoPublic_pb.Proto10200002();
	cmd.collection_id = collection_id;
	sendMsg(10200002, cmd);
end

-- 请求领取藏品激活奖励 collection_id 藏品id
function Lua_CollectionProxy:sReceiveCollection(collection_id)
	local cmd = ProtoPublic_pb.Proto10200003();
	cmd.collection_id = collection_id;
	sendMsg(10200003, cmd);
end

-- 请求角色藏品信息 role_id 角色id，collection_id 藏品id
function Lua_CollectionProxy:sOtherCollectionInfo(role_id, collection_item_id)
	local cmd = ProtoPublic_pb.Proto10200005();
	cmd.role_id = role_id;
	cmd.collection_item_id = collection_item_id;
	sendMsg(10200005, cmd);
end