-- 跨服时空数据
Lua_CrossServerData = class("Lua_CrossServerData")
function Lua_CrossServerData:ctor()
	self:dispose();
end

function Lua_CrossServerData:dispose()
	self.open_day = 0;
	self.reset_tick = 0;
	self.world_level = 0;
	self.server_list = {};
end

function Lua_CrossServerData:fromServer50198001(msg)
	if msg == nil then
		return;
	end
	self.open_day = msg.open_day; -- 跨服重置时间
	self.reset_tick = msg.reset_tick; -- 玩家所在服的开服天数
	self.world_level = msg.world_level; -- 玩家所在服的当前世界等级
	self.server_list = msg.cluster_server_list; -- 玩法跨服组的服务器信息列表
end

-- 功能开启描述
function Lua_CrossServerData:openedDes(funcId)
	local funcOpenVo = DataCenter.funcOpenUtil:getFuncOpenVoById(funcId);
	if funcOpenVo == nil then return ""; end

	local targetVal;
	local bool;
	local showValue;
	if funcOpenVo.des_list then
		for k,v in pairs(funcOpenVo.des_list) do
			targetVal = funcOpenVo[v[1]];
			if targetVal then
				if v[1] == "world_level" then
					bool = self.world_level < targetVal;
					showValue = targetVal;
				elseif v[1] == "open_day" then
					bool = self.open_day < targetVal;
					showValue = targetVal - self.open_day;
				end

				if bool then
					showValue = LanUtil.formateStr(v[2], showValue);
					break;
				end
			end
		end
	end
	return showValue or funcOpenVo.advanceMessage;
end