-- 寂灭岛首通排行榜配置表Vo
Lua_EquipCopyRankVo = class("Lua_EquipCopyRankVo")
function Lua_EquipCopyRankVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig("equip_copy_single", id);
	end
end

function Lua_EquipCopyRankVo:dispose()
	self:resetServerInfo();
end

-- 重置服务端数据
function Lua_EquipCopyRankVo:resetServerInfo()
	-- 首通
	self.firstPassTime = nil;
	self.hasReward = nil;

	-- 极限战力、极限回合
	-- self.hurtCollect = nil;
	self.record_id = nil;
	self.round = nil;
	self.force = nil;

	-- 共有
	self.showRole = nil;
end

function Lua_EquipCopyRankVo:updateServerInfo(serverInfo)
	self:dispose();

	-- 首通
	self.firstPassTime = self:dealwithTime(serverInfo.first_pass_tick);
	self.hasReward = serverInfo.is_draw_reward; -- 是否有领取首通奖励 0未领取 1已领取

	-- 极限战力、极限回合
	-- self.hurtCollect = serverInfo.hurt_collect;
	self.record_id = serverInfo.record_id;
	self.round = serverInfo.round;
	self.force = serverInfo.force;

	-- 人物信息
	self.showRole = serverInfo.show_role;
end

-- 更新首通奖励领取状态
function Lua_EquipCopyRankVo:updateFistPassReceive(is_draw_reward)
	self.hasReward = is_draw_reward;
end

-- 处理首通时间格式,如：2022.02.02
function Lua_EquipCopyRankVo:dealwithTime(first_pass_tick)
	local time = tonumber(first_pass_tick);
	return os.date("%Y", time).."."..os.date("%m", time)..".".. os.date("%d", time);
end





-- 难度名字
function Lua_EquipCopyRankVo.Get:name()
	return self.config.name;
end

-- boss难度
function Lua_EquipCopyRankVo.Get:difficulty()
	return self.config.difficulty;
end

-- boss阵营
function Lua_EquipCopyRankVo.Get:camp()
	return self.config.camp;
end

-- 首通奖励
function Lua_EquipCopyRankVo.Get:reward()
	if self._reward == nil then
		local _reward = self.config.first_pass_reward[1];
		self._reward = Lua_ToolVo.createToolVo(_reward[1], _reward[2]);
	end
	return self._reward;
end

-- 首通奖励
function Lua_EquipCopyRankVo.Get:sort()
	local weight = 0;
	if self.hasReward == 0 then --可领取
		weight = 1000000000000;
	elseif self.hasReward == 1 then--已领取
		weight = 100000000;
	else
		weight = 10000000000;--未达成
	end
	weight = weight - self.difficulty *10000;

	return weight;
end