checkRequire("Lua_UpStarOfServerVo");
Lua_UpStarOfServerData = class("Lua_UpStarOfServerData")
function Lua_UpStarOfServerData:ctor()
	self:dispose();
end

function Lua_UpStarOfServerData:dispose()
	self.rewardArr = nil;
	self.rewardDic = nil;
	self._constConfig = nil;
end

function Lua_UpStarOfServerData:fromServer50197009(msg)
	if msg == nil then
		return;
	end

	self:initRewardInfo();
	self.heroId = msg.hero_id; -- 英雄id 0移除
	self.quality = msg.quality; -- 质量
	self.qualityStar = msg.quality_star; -- 质量星级
	self.heroState = msg.hero_state; -- 英雄状态 1已选择 2已锁定
	self.endTimes = msg.end_time; -- 距离结束剩余时间戳
	self.curSelectHero = self:getCurSelectHero();

	local obj;
	local vo;
	local state = false;
	for i = 1, #msg.gift_state do
		obj = msg.gift_state[i];
		vo = self.rewardDic[obj.quality][obj.quality_star];
		if vo then
			vo:updateTimes(obj.free_times, obj.recharge_times);
		end

		if not state and msg.hero_state == 2 and obj.free_times > 0 and msg.quality >= vo.quality and msg.quality_star >= vo.qualityStar then
			state = true;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.ExcellentAct_UpStarOfServer, state);
end

function Lua_UpStarOfServerData:getCurSelectHero()
	if self.heroId == 0 then
		return nil;
	end

	local packHeroUidArr = DataCenter.heroData.allHeroUidArr;
	local cond = self.constConfig.lock_hero_cond;
	local heroVo;
	local targetVo;
	for i = 1, packHeroUidArr:getSize() do
		heroVo = DataCenter.heroData:getItemByUniqueId(packHeroUidArr[i]);
		if heroVo.id == self.heroId and heroVo.quality >= cond[1] and heroVo.star >= cond[2] and heroVo.is_league_transaction == false and not heroVo.trial_state then
			if targetVo and heroVo.quality > targetVo.quality and heroVo.star > targetVo.star then
				targetVo = heroVo;
			end
			targetVo = targetVo or heroVo;
		end
	end

	if targetVo == nil then -- 误删、回退
		targetVo = Lua_ToolVo.createToolVo(self.heroId);
		targetVo.quality = self.quality;
		targetVo.quality_star = self.quality_star;
	end
	return targetVo;
end

-- 获取满足条件的最高品质且最高星级的 HeroVo
function Lua_UpStarOfServerData:getHeroListArr(camp)
	local star = DataCenter.heroUtil:getHeroAwakenStarByQuality(4, 0);
	local idArr = DataCenter.heroUtil:getHeroIdArr(star, camp);
	local targetVo;
	local cond = self.constConfig.lock_hero_cond;
	local maxQuality;
	local maxStar;
	local uidArr;
	local heroVo;
	local arr = Array();
	for i = 1, idArr:getSize() do -- 存在英雄
		if DataCenter.heroData:isExistHeroById(idArr[i]) then
			uidArr = DataCenter.heroData:getHeroUidArrById(idArr[i]);
			if uidArr ~= nil then
				heroVo = DataCenter.heroData:getItemByUniqueId(uidArr[1]);
				targetVo = heroVo;
				maxQuality = heroVo.quality;
				maxStar = heroVo.quality_star;
				for j = 2, uidArr:getSize() do
					heroVo = DataCenter.heroData:getItemByUniqueId(uidArr[j]);
					if maxQuality < heroVo.quality and maxStar < heroVo.quality_star and heroVo.is_league_transaction == false and not heroVo.trial_state then
						targetVo = heroVo;
						maxQuality = heroVo.quality;
						maxStar = heroVo.quality_star;
					end
				end
				if maxQuality >= cond[1] and maxStar >= cond[2] then
					arr:add(targetVo);
				end
			end
		end
	end
	arr:sort("heroForce", true);
	return arr;
end

-- 升星专属（开服）奖励配置
function Lua_UpStarOfServerData:initRewardInfo()
	if self.rewardArr == nil then
		self.rewardArr = Array();
		self.rewardDic = {};

		local config = getConfig("star_particular_local");
		local vo;
		for k,v in pairs(config) do
			if v.recharge_id then
				vo = Lua_UpStarOfServerVo.new(k, v);
				if self.rewardDic[vo.quality] == nil then
					self.rewardDic[vo.quality] = {};
				end
				self.rewardDic[vo.quality][vo.qualityStar] = vo;
				self.rewardArr:add(vo);
			end
		end
		self.rewardArr:sort("id", false);
	end
end

-- 升星专属（开服）常量配置
function Lua_UpStarOfServerData.Get:constConfig()
	if self._constConfig == nil then
		self._constConfig = getConfig("star_particular_local", "const");
	end
	return self._constConfig;
end