Lua_UpStarOfServerVo = class("Lua_UpStarOfServerVo");
function Lua_UpStarOfServerVo:ctor(id, config)
	self.id = id;
	self._config = config;

	self:dispose();
end

function Lua_UpStarOfServerVo:dispose()
	self._personRewardArr = nil;
end

function Lua_UpStarOfServerVo:updateTimes(freeTimes, rechargeTimes)
	self.freeTimes = freeTimes;
	self.rechargeTimes = rechargeTimes;
	for i = 1, self.personRewardArr:getSize() do
		self.personRewardArr[i].times = rechargeTimes;
	end
end

function Lua_UpStarOfServerVo.Get:config()
	if self._config == nil then
		self._config = getConfig("star_particular_local", self.id);
	end
	return self._config;
end

-- 充值id
function Lua_UpStarOfServerVo.Get:rechargeId()
	return self.config.recharge_id;
end

-- 品质
function Lua_UpStarOfServerVo.Get:quality()
	return self.config.quality_star_list[1];
end

-- 品质星级
function Lua_UpStarOfServerVo.Get:qualityStar()
	return self.config.quality_star_list[2];
end

-- 免费奖励列表
function Lua_UpStarOfServerVo.Get:freeReward()
	return self.config.free_reward[1];
end

-- 专属奖励列表
function Lua_UpStarOfServerVo.Get:personReward()
	return self.config.person_reward;
end

-- 专属奖励列表
function Lua_UpStarOfServerVo.Get:personRewardArr()
	if self._personRewardArr == nil then
		self._personRewardArr = Array();

		for i = 1, #self.personReward do
			self._personRewardArr:add({key = self.personReward[i][1], value = self.personReward[i][2]});
		end
	end
	return self._personRewardArr;
end

-- 总免费限购次数
function Lua_UpStarOfServerVo.Get:totalFreeTimes()
	return self.config.limit_times_list[1];
end

-- 总专属限购次数
function Lua_UpStarOfServerVo.Get:totalRechargeTimes()
	return self.config.limit_times_list[2];
end

-- 免费限购次数
function Lua_UpStarOfServerVo.Get:freeTimes()
	if self._freeTimes == nil then
		self._freeTimes = self.totalFreeTimes;
	end
	return self._freeTimes;
end

-- 免费限购次数
function Lua_UpStarOfServerVo.Set:freeTimes(times)
	self._freeTimes = times;
end

-- 专属限购次数
function Lua_UpStarOfServerVo.Get:rechargeTimes()
	if self._rechargeTimes == nil then
		self._rechargeTimes = self.totalRechargeTimes;
	end
	return self._rechargeTimes;
end

-- 专属限购次数
function Lua_UpStarOfServerVo.Set:rechargeTimes(times)
	self._rechargeTimes = times;
end