Lua_investmentVo = class("Lua_investmentVo")
function Lua_investmentVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig("grow_up_invest", id);
	end
end

function Lua_investmentVo:fromServer(step, isUnlock, stateInfo)
	self.state = stateInfo.value;
	self.seniorState = stateInfo.ex_value;
	self.isUnlock = isUnlock;
	self.step = step;
end

function Lua_investmentVo.Get:baseVoArr()
	if self._baseVoArr == nil then
		self._baseVoArr = Array();
		local baseVo;
		for i = 1, #self.baseRewardList do
			baseVo = Lua_ToolVo.createToolVo(self.baseRewardList[i][1], self.baseRewardList[i][2]);
			self._baseVoArr:add(baseVo);
		end
	end
	return self._baseVoArr;
end

function Lua_investmentVo.Get:extraVoArr()
	if self._extraVoArr == nil then
		self._extraVoArr = Array();
		local extraVo;
		for i = 1, #self.extraRewardList do
			extraVo = Lua_ToolVo.createToolVo(self.extraRewardList[i][1], self.extraRewardList[i][2]);
			self._extraVoArr:add(extraVo);
		end
	end
	return self._extraVoArr;
end

function Lua_investmentVo.Get:extraMoney()
	if self._extraMoney == nil then
		self._extraMoney = 0;
		for i = 1, #self.extraRewardList do
			self._extraMoney = self._extraMoney + self.extraRewardList[i][2];
		end
	end
	return self._extraMoney;
end

function Lua_investmentVo.Get:nextVo()
	local vo = DataCenter.investmentData:getInvestmentVo(tonumber(self.id) + 1);
	if vo ~= nil and vo.step == self.step then
		return vo;
	end
	return nil;
end

-------------------- 配置数据 --------------------

function Lua_investmentVo.Get:extraRewardList()
	return self.config.adv_reward;
end

function Lua_investmentVo.Get:level()
	return self.config.reward_level;
end

function Lua_investmentVo.Get:baseRewardList()
	return self.config.normal_reward;
end