Lua_ExpeditionUtil = class("Lua_ExpeditionUtil");
function Lua_ExpeditionUtil:ctor()
	self:superCall("ctor");
end

function Lua_ExpeditionUtil:getConstConfig(key, valType, defaultVal)
	local config = getConfig("expedition_const", key);
	if config ~= nil then
		if valType == 1 then
            return config.value;
        elseif valType == 2 then
        	return config.strvalue;
        elseif valType == 3 then
        	return config.jsonvalue;
        end
	end
	return defaultVal;
end

function Lua_ExpeditionUtil:getBuffInfo(id)
	if id == nil then
		return nil;
	end
	return getConfig("expedition_buff", id);
end

function Lua_ExpeditionUtil:getMapArr(layer, difficulty)
	if self.layerDic == nil then
		self.layerDic = {};
	end

	local id = layer * 1000 + difficulty * 100;
	if self.layerDic[id] == nil then
		self.layerDic[id] = Array();
		local config;
		for i = 0, 10 do
			config = getConfig("expedition_map", id + i);
			if config ~= nil then
				self.layerDic[id]:add(config);
			end
		end
		self.layerDic[id]:sort("id", true);
	end
	return self.layerDic[id];
end

function Lua_ExpeditionUtil:getLatticeInfo(id)
	if id == nil then
		return nil;
	end
	return getConfig("expedition_map_info", id);
end

function Lua_ExpeditionUtil:getStoreInfo(id)
	if id == nil then
		return nil;
	end
	return getConfig("expedition_shop", id);
end

function Lua_ExpeditionUtil:getStarInfo()
	return getConfig("expedition_star_reward");
end