-- 战斗
checkRequire("Lua_FightData");
checkRequire("Lua_FightUtil");
checkRequire("Lua_FightDefine");
Lua_FightProxy = class("Lua_FightProxy");
function Lua_FightProxy:ctor()
    self:superCall("ctor");
    self:initCSharpFormation();
	DataCenter.fightData = Lua_FightData.new();
	DataCenter.fightUtil = Lua_FightUtil.new();

    Lua_MsgUtil.addEventListener("hideFightToBackStageByTemplateId", self, self.onHideFightToBackStage); -- 根据模板隐藏战斗到后台
    Lua_MsgUtil.addEventListener("showFightToStageByTemplateId", self, self.onShowFightToStage); -- 根据模板显示战
    -- Lua_MsgUtil.addEventListener("FIGHTPLAY_ENTER", self, self.onFightPlayEnter);
    Lua_MsgUtil.addEventListener("FIGHTPLAY_COMPLETE", self, self.onFightPlayCompleted);

	Lua_MsgUtil.addLuaMsg(80102001, self, self.rFightRecordUpdate); -- 通知战斗记录
    Lua_MsgUtil.addLuaMsg(80102002, self, self.rFightRecordSegmentUpdate); -- 通知战斗记录剩余分段数据
    Lua_MsgUtil.addLuaMsg(80102003, self, self.rFightResult); -- 通知战斗结算
    Lua_MsgUtil.addLuaMsg(80102004, self, self.rTeamFightResult); -- 通知多阵容战斗结算
    Lua_MsgUtil.addLuaMsg(80161013, self, self.rPDFightResult);  -- 通知巅峰对决战斗结算
    Lua_MsgUtil.addLuaMsg(80201019, self, self.rECFightResult); -- 通知寂灭岛战斗结算
    Lua_MsgUtil.addLuaMsg(50102006, self, self.rFightHurtCollect); -- 请求战斗伤害统计信息返回
end

-- 设置战斗位置行列信息
function Lua_FightProxy:initCSharpFormation()
    local fightPlayerManager = FightPlayManager.instance;
    fightPlayerManager:setFightCampPos(1, 1, 2);
    fightPlayerManager:setFightCampPos(2, 1, 4);
    fightPlayerManager:setFightCampPos(3, 1, 6);
    fightPlayerManager:setFightCampPos(4, 2, 1);
    fightPlayerManager:setFightCampPos(5, 2, 3);
    fightPlayerManager:setFightCampPos(6, 2, 5);
    fightPlayerManager:setFightCampPos(7, 2, 7);
    fightPlayerManager:setFightCampPos(8, 3, 2);
    fightPlayerManager:setFightCampPos(9, 3, 4);
    fightPlayerManager:setFightCampPos(10, 3, 6);
end

---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 事件监听
-- 根据模板隐藏战斗到后台
function Lua_FightProxy:onHideFightToBackStage(templateId)
    DataCenter.fightData:hideFightToBackStage(templateId);
end

-- 根据模板显示战斗
function Lua_FightProxy:onShowFightToStage(templateId)
    DataCenter.fightData:showFightToStage(templateId);
end

-- function Lua_FightProxy:onFightPlayEnter(templateId)

-- end

-- 战斗播放完成
function Lua_FightProxy:onFightPlayCompleted(templateId)
    if templateId == Lua_FightDefine.TEMPLATE_ID_INFINITYHALL_1 then -- 无尽火域单人
        Lua_ProxyManager.getProxy("Lua_InfinityHallProxy"):sRewardInfo(1);
    elseif templateId == Lua_FightDefine.TEMPLATE_ID_INFINITYHALL_2 then -- 无尽火域团队
        Lua_ProxyManager.getProxy("Lua_InfinityHallProxy"):sRewardInfo(2);
    elseif templateId == Lua_FightDefine.TEMPLATE_ID_PEAKDUEL then -- 巅峰对决
        Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDInfo()
    end
end





---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 上行
-- 请求开始战斗
function Lua_FightProxy:sStartFight(template_id, stage_id, player_id, skill_id, grid_index, camp_index, is_jump, grab_type, grab_record_id)
    if self.sTemplateId == template_id and self.sFightTime and getTime() - self.sFightTime <= 1 then
        return;
    end
    self.sTemplateId = template_id;
    self.sFightTime = getTime();

    print("请求开始战斗 10102001 template_id : "..template_id)
    LogManager.showLog("请求开始战斗 10102001 template_id : "..template_id);

    local msg = ProtoPublic_pb.Proto10102001();
    msg.template_id = template_id; -- 战斗模板配置id
    msg.stage_id = stage_id == nil and 0 or stage_id; -- 关卡id
    msg.player_id = player_id == nil and 0 or tonumber(player_id);-- 挑战玩家id（斗技场）
    msg.skill_id = skill_id == nil and 0 or tonumber(skill_id); -- 选择的buff（技能）id
    msg.grid_index = grid_index == nil and 0 or grid_index; -- 格子索引（神陵密境）
    msg.camp_index = camp_index == nil and 0 or camp_index; -- 上场英雄索引（神陵密境）
    msg.is_jump = is_jump == nil and 0 or is_jump; -- 是否跳过并连续挑战（1：是，0：否）（神陵密境）
    msg.grab_type = grab_type == nil and 0 or grab_type; -- 抢夺类型：0：普通抢夺 1:帮抢 2：回抢
    msg.grab_record_id = grab_record_id == nil and 0 or grab_record_id; -- 抢夺的record_id
    DataCenter.fightData:recordSendFightMsg(msg)
    sendMsg(10102001, msg);
end

-- 请求处理战斗结果
function Lua_FightProxy:sFightResult(recordId, rType, roration)
    local msg = ProtoPublic_pb.Proto10102002();
    msg.record_id = recordId; -- 战斗记录id
    msg.type = rType; -- 1：接受战斗结果，2：放弃战斗结果
    msg.roration = roration == nil and 0 or roration; -- 在第几轮放弃（无穷战殿）
    sendMsg(10102002, msg);
end

-- 请求战斗回放
function Lua_FightProxy:sFightReplay(record_id, flag, server_flag, rotation, _type)
    if self.rRecordId == record_id and self.sReplayTime and getTime() - self.sReplayTime <= 1 then
        return;
    end
    self.rRecordId = record_id;
    self.sReplayTime = getTime();
    
    local msg = ProtoPublic_pb.Proto10102005();
    msg.record_id = tonumber(record_id); -- 战斗记录id
    msg.flag = (flag == nil) and 0 or flag; -- 客户端用标识 录像馆为播放速度索引
    msg.server_flag = (server_flag == nil) and "" or server_flag; -- 服务器标识 巅峰对决聊天查看
    msg.rotation = (rotation == nil) and 0 or rotation; -- 轮次：0所有轮次，其他值为指定轮次
    msg.type = (_type == nil) and 0 or _type; -- 查看的回放类型 1：巅峰对决大师录像
    sendMsg(10102005, msg);
end

-- 请求战斗伤害统计信息
function Lua_FightProxy:sFightHurtCollect(record_id, _type)
    local msg = ProtoPublic_pb.Proto10102006();
    msg.record_id = tonumber(record_id); -- 战斗记录id
    msg.type = (_type == nil) and 0 or _type;
    sendMsg(10102006, msg);
end




---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-- 下行
--通知战斗记录
function Lua_FightProxy:rFightRecordUpdate(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80102001();
        msg:ParseFromString(mp.data);
        DataCenter.fightData:addFightRecord(msg);
    end
end

-- 后续战斗数据
function Lua_FightProxy:rFightRecordSegmentUpdate(mp)
    if mp.errno == 0 then
        DataCenter.fightData:parseFightRecordSegentMsg(mp);
    end
end

function Lua_FightProxy:rFightResult(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80102003();
        msg:ParseFromString(mp.data);
        LogManager.showLog("通知战斗结算 80102003 "..msg.record_id.." templateId = "..msg.template_id);
        DataCenter.fightData:updateFightResult(msg);
    end
end

function Lua_FightProxy:rTeamFightResult(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80102004();
        msg:ParseFromString(mp.data);
        DataCenter.fightData:updateFightResult(msg);
    end
end

function Lua_FightProxy:rPDFightResult(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80161013();
        msg:ParseFromString(mp.data);
        DataCenter.fightData:updateFightResult(msg);
    end
end

function Lua_FightProxy:rECFightResult(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80201019();
        msg:ParseFromString(mp.data);
        DataCenter.fightData:updateFightResult(msg);
    end
end

-- 请求战斗伤害统计信息返回
function Lua_FightProxy:rFightHurtCollect(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50102006();
        msg:ParseFromString(mp.data);
        Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, msg.hurt_collect_info);
    end
end