-- 战斗站位数据
Lua_FightCampPosConfig = class("Lua_FightCampPosConfig");
function Lua_FightCampPosConfig.getConfigData(id)
    if Lua_FightCampPosConfig.configsDic == nil then
        Lua_FightCampPosConfig.configsDic = { };
    end
    if Lua_FightCampPosConfig.configsDic[id] == nil then
    	local cfg = getConfig("tb_fight_camppos", id);
    	if cfg == nil then
    		return nil;
    	end
        Lua_FightCampPosConfig.configsDic[id] = Lua_FightCampPosConfig.new(id, cfg);
    end
    return Lua_FightCampPosConfig.configsDic[id];
end

function Lua_FightCampPosConfig:ctor(id, cfg)
    self:superCall("ctor");

    self.id = id;
    self.config = cfg;
    if self.config == nil then
	    self.config = getConfig("tb_fight_camppos", id);
	end
end

function Lua_FightCampPosConfig.Get:attackDir()
	return self.config.attackDir;
end

function Lua_FightCampPosConfig.Get:defendDir()
	return self.config.defendDir;
end

function Lua_FightCampPosConfig.Get:attackCenter()
	return self.config.attackCenter;
end

function Lua_FightCampPosConfig.Get:defendCenter()
	return self.config.defendCenter;
end

function Lua_FightCampPosConfig.Get:attackPosxArr()
	if self.config.attackPosxArr == nil then
		self.config.attackPosxArr = {-200,0,200,-200,0,200,-200,0,200,0};
	end
	return self.config.attackPosxArr;
end

function Lua_FightCampPosConfig.Get:attackPoszArr()
	if self.config.attackPoszArr == nil then
		self.config.attackPoszArr = {200,200,200,400,400,400,600,600,600,800};
	end
	return self.config.attackPoszArr;
end

function Lua_FightCampPosConfig.Get:defendPosxArr()
	if self.config.defendPosxArr == nil then
		self.config.defendPosxArr = {-200,0,200,-200,0,200,-200,0,200,0};
	end
	return self.config.defendPosxArr;
end

function Lua_FightCampPosConfig.Get:defendPoszArr()
	if self.config.defendPoszArr == nil then
		self.config.defendPoszArr = {-200,-200,-200,-400,-400,-400,-600,-600,-600,-800};
	end
	return self.config.defendPoszArr;
end

function Lua_FightCampPosConfig:getPosxByIdx(formationType, idx)
	if idx == nil or idx == 0 then
		idx = 11;
	end

	local list;
	if formationType == Lua_FightDefine.FIGHT_ATTACKER then
		list = self.attackPosxArr;
	else
		list = self.defendPosxArr;
	end

	if list ~= nil and #list >= idx then
		return list[idx];
	end
	return 0;
end

function Lua_FightCampPosConfig:getPoszByIdx(formationType, idx)
	if idx == nil or idx == 0 then
		idx = 11;
	end
	
	local list;
	if formationType == Lua_FightDefine.FIGHT_ATTACKER then
		list = self.attackPoszArr;
	else
		list = self.defendPoszArr;
	end

	if list ~= nil and #list >= idx then
		return list[idx];
	end
	return 0;
end

function Lua_FightCampPosConfig:getDirByType(formationType)
	local dir;
	if formationType == Lua_FightDefine.FIGHT_ATTACKER then
		dir = self.attackDir;
	else
		dir = self.defendDir;
	end

	if dir == nil then
		dir = formationType == Lua_FightDefine.FIGHT_ATTACKER and 90 or 270;
	end
	return dir;
end