-- 战斗模板配置表信息
Lua_FightTemplateConfigData = class("Lua_FightTemplateConfigData");
function Lua_FightTemplateConfigData.getConfigData(id)
    if id == nil then
        return nil;
    end

    if Lua_FightTemplateConfigData.configsDic == nil then
        Lua_FightTemplateConfigData.configsDic = { };
    end
    if Lua_FightTemplateConfigData.configsDic[id] == nil then
    	local cfg = getConfig("tb_fight_template", id);
    	if cfg == nil then
    		return nil;
    	end
        Lua_FightTemplateConfigData.configsDic[id] = Lua_FightTemplateConfigData.new(id, cfg);
    end
    return Lua_FightTemplateConfigData.configsDic[id];
end

function Lua_FightTemplateConfigData.getAllTempConfig()
    if Lua_FightTemplateConfigData.configArr == nil then
        Lua_FightTemplateConfigData.configArr = Array();
        Lua_FightTemplateConfigData.testConfigArr = Array();
        if Lua_FightTemplateConfigData.configsDic == nil then
            Lua_FightTemplateConfigData.configsDic = {};
        end

        local config = getConfig("tb_fight_template");
        for k, v in pairs(config) do
            local vo = Lua_FightTemplateConfigData.configsDic[k];
            if vo == nil then
                vo = Lua_FightTemplateConfigData.new(k, v);
                Lua_FightTemplateConfigData.configsDic[k] = vo;
            end
            Lua_FightTemplateConfigData.configArr:add(vo);
            if vo.sys_type == 999 then
                Lua_FightTemplateConfigData.testConfigArr:add(vo);
            end
        end
    end
    return Lua_FightTemplateConfigData.configArr;
end

function Lua_FightTemplateConfigData.getTestTempConfig()
    local arr = Lua_FightTemplateConfigData.getAllTempConfig();
    return Lua_FightTemplateConfigData.testConfigArr;
end

function Lua_FightTemplateConfigData:ctor(id, cfg)
    self:superCall("ctor");

    self.id = id;
    self.config = cfg;
    if self.config == nil then
	    self.config = getConfig("tb_fight_template", id);
	end
end

function Lua_FightTemplateConfigData:getSpeedIdxCond(idx)
    if idx > 1 and self.speedCond ~= nil and self.speedCond[idx - 1] ~= nil then
        return self.speedCond[idx - 1];
    end
    return 0;
end

function Lua_FightTemplateConfigData:checkSpeedIsOpen(idx)
    local condId = self:getSpeedIdxCond(idx);
    return DataCenter.funcOpenData:isOpened(condId);
end

-------------------- 配置数据 --------------------

function Lua_FightTemplateConfigData.Get:title()
    return self.config.title;
end

-- 战斗类型
function Lua_FightTemplateConfigData.Get:sys_type()
    return self.config.sys_type;
end

-- 阵容类型
function Lua_FightTemplateConfigData.Get:lineup_type()
    return self.config.lineup_type;
end

-- 战斗场景id
function Lua_FightTemplateConfigData.Get:scene_id()
    return self.config.scene_id;
end

function Lua_FightTemplateConfigData.Get:ignore_result()
    return self.config.ignore_result;
end

-- 最大回合
function Lua_FightTemplateConfigData.Get:maxRound()
    if self.config == nil or self.config.max_round == nil then
        return 0;
    end
    return self.config.max_round;
end

-- 失败界面跳转功能ICON
function Lua_FightTemplateConfigData.Get:failOpenIcons()
    return self.config.failOpenIcons;
end

function Lua_FightTemplateConfigData.Get:winOpenWin()
    return self.config.winOpenWin
end

function Lua_FightTemplateConfigData.Get:failOpenWin()
    return self.config.failOpenWin;
end

-- 是否结算后退出场景
function Lua_FightTemplateConfigData.Get:needResultWinExitFight()
    return self.config.needResultWinExitFight or 0;
end

function Lua_FightTemplateConfigData.Get:skipCond()
    return self.config.skip_cond;
end

function Lua_FightTemplateConfigData.Get:speedCond()
    return self.config.speed_cond;
end

function Lua_FightTemplateConfigData.Get:hangCond()
    return self.config.hang_cond;
end

function Lua_FightTemplateConfigData.Get:pauseCond()
    return self.config.pause_cond;
end

function Lua_FightTemplateConfigData.Get:starDialogIntervalTime()
    if self._starDialogIntervalTime == nil then
        self._starDialogIntervalTime = self.config.starDialogIntervalTime;
        if self._starDialogIntervalTime == nil or self._starDialogIntervalTime <= 0 then
            self._starDialogIntervalTime = 0;
        else
            self._starDialogIntervalTime = self._starDialogIntervalTime * 0.001;
        end
    end
    return self._starDialogIntervalTime;
end

function Lua_FightTemplateConfigData.Get:starDialogRate()
    if self._starDialogRate == nil then
        self._starDialogRate = self.config.starDialogRate;
        if self._starDialogRate == nil or self._starDialogRate <= 0 then
            self._starDialogRate = 0;
        end
    end
    return self._starDialogRate;
end

function Lua_FightTemplateConfigData.Get:starDeadDailogRate()
    if self._starDeadDailogRate == nil then
        self._starDeadDailogRate = self.config.starDeadDailogRate;
        if self._starDeadDailogRate == nil or self._starDeadDailogRate <= 0 then
            self._starDeadDailogRate = 0;
        end
    end
    return self._starDeadDailogRate;
end

function Lua_FightTemplateConfigData.Get:sceneDialogIntervalTime()
    if self._sceneDialogIntervalTime == nil then
        self._sceneDialogIntervalTime = self.config.sceneDialogIntervalTime;
        if self._sceneDialogIntervalTime == nil or self._sceneDialogIntervalTime <= 0 then
            self._sceneDialogIntervalTime = 0;
        else
            self._sceneDialogIntervalTime = self._sceneDialogIntervalTime * 0.001;
        end
    end
    return self._sceneDialogIntervalTime;
end

function Lua_FightTemplateConfigData.Get:sceneDialogRate()
    if self._sceneDialogRate == nil then
        self._sceneDialogRate = self.config.sceneDialogRate;
        if self._sceneDialogRate == nil or self._sceneDialogRate <= 0 then
            self._sceneDialogRate = 0;
        end
    end
    return self._sceneDialogRate;
end

function Lua_FightTemplateConfigData.Get:sceneDialogPosArr()
    return self.config.sceneDialogPosArr;
end

function Lua_FightTemplateConfigData:getRandomSceneDialogPos(dic)
    if self.config.sceneDialogPosArr ~= nil and #self.config.sceneDialogPosArr > 0 then
        local step = 10;
        while true do
            step = step - 1;
            local idx = Mathf.Ceil(Mathf.Random(1, #self.config.sceneDialogPosArr));
            if dic == nil or dic[idx] ~= true then
                return self.config.sceneDialogPosArr[idx], idx;
            end

            if step <= 0 then
                break;
            end
        end
    end
    return nil, nil;
end

function Lua_FightTemplateConfigData:getRandomSceneDialog()
    if self.config.sceneDialogIds ~= nil and #self.config.sceneDialogIds > 0 then
        local idx = Mathf.Ceil(Mathf.Random(1, #self.config.sceneDialogIds));
        return self.config.sceneDialogIds[idx];
    end
    return 0;
end

function Lua_FightTemplateConfigData.Get:normal_show()
    return self.config.normal_show;
end

function Lua_FightTemplateConfigData.Get:replay_show()
    return self.config.replay_show;
end

function Lua_FightTemplateConfigData.Get:video_show()
    return self.config.video_show;
end

function Lua_FightTemplateConfigData.Get:show_result_cond()
    return self.config.show_result_cond;
end

function Lua_FightTemplateConfigData.Get:hang_close_win()
    return self.config.hang_close_win;
end

function Lua_FightTemplateConfigData.Get:not_run_back()
    return self.config.not_run_back or 0;
end

function Lua_FightTemplateConfigData.Get:run_back_cond()
    return self.config.run_back_cond;
end

function Lua_FightTemplateConfigData.Get:speedKey()
    return self.config.speed_key;
end