-- 战斗配置表数据
Lua_FightUtil = class("Lua_FightUtil");

-- 战斗开始特效播放时间
function Lua_FightUtil.Get:startEffectTime()
	if self._startEffectTime == nil then
		self._startEffectTime = getConfig("const", "fight_startEffect_time", "value");
		if self._startEffectTime == nil then
			self._startEffectTime = 1.5;
		else
			self._startEffectTime = self._startEffectTime / 1000;
		end
	end
	return self._startEffectTime;
end

-- 战斗出生特效时间
function Lua_FightUtil.Get:animalBornEffTime()
	if self._animalBornEffTime == nil then
		self._animalBornEffTime = getConfig("const", "fight_animalBornEff_time", "value");
		if self._animalBornEffTime == nil then
			self._animalBornEffTime = 1;
		else
			self._animalBornEffTime = self._animalBornEffTime / 1000;
		end
	end
	return self._animalBornEffTime;
end

-- 战斗模型显示时间：依据出生特效总时间的80%
function Lua_FightUtil.Get:animalBornTime()
	return self.animalBornEffTime * 0.8;
end

function Lua_FightUtil.Get:initFormationTime()
	if self._initFormationTime == nil then
		self._initFormationTime = getConfig("const", "fight_initformation_time", "value");
		if self._initFormationTime == nil then
			self._initFormationTime = 2;
		else
			self._initFormationTime = self._initFormationTime / 1000;
		end
	end
	return self._initFormationTime;
end

function Lua_FightUtil.Get:roundIntervalTime()
	if self._roundIntervalTime == nil then
		self._roundIntervalTime = getConfig("const", "fight_round_intervalTime", "value");
		if self._roundIntervalTime == nil then
			self._roundIntervalTime = 0.3;
		else
			self._roundIntervalTime = self._roundIntervalTime / 1000;
		end
	end
	return self._roundIntervalTime;
end

function Lua_FightUtil.Get:playOverIntervalTime()
	if self._playOverIntervalTime == nil then
		self._playOverIntervalTime = getConfig("const", "fight_playOver_time", "value");
		if self._playOverIntervalTime == nil then
			self._playOverIntervalTime = 2;
		else
			self._playOverIntervalTime = self._playOverIntervalTime / 1000;
		end
	end
	return self._playOverIntervalTime;
end

function Lua_FightUtil.Get:resultWinCloseTime()
	if self._resultWinIntervalClickTime == nil then
		self._resultWinIntervalClickTime = getConfig("const", "fight_resultwin_closeTime", "value");
		if self._resultWinIntervalClickTime == nil then
			self._resultWinIntervalClickTime = 5;
		else
			self._resultWinIntervalClickTime = self._resultWinIntervalClickTime;
		end
	end
	return self._resultWinIntervalClickTime;
end

-- 战斗舞台中心
function Lua_FightUtil:getSceneFightCenter(sceneId)
	return Lua_SceneConfigData.getSceneConfig(sceneId).fightStageCenterPos;
end

-- 战斗变更位置移动时间
function Lua_FightUtil:getPosChangeMoveTime()
	if self._fightSkillDragTargetTime == nil then
		self._fightSkillDragTargetTime = getConfig("const", "fight_skill_dragTarget_time", "value");
		if self._fightSkillDragTargetTime == nil then
			self._fightSkillDragTargetTime = 0.3;
		else
			self._fightSkillDragTargetTime = self._fightSkillDragTargetTime / 1000;
		end
	end
	return self._fightSkillDragTargetTime;
end

-- 战斗回合结束退场时间间隔
function Lua_FightUtil:getRotOverRemoveTime()
	if self._fightRotOverRemoveTime == nil then
		self._fightRotOverRemoveTime = getConfig("const", "fight_rotover_removetime", "value");
		if self._fightRotOverRemoveTime == nil then
			self._fightRotOverRemoveTime = 0.5;
		else
			self._fightRotOverRemoveTime = self._fightRotOverRemoveTime / 1000;
		end
	end
	return self._fightRotOverRemoveTime;
end

function Lua_FightUtil.Get:guardOffsetVec()
	if self._guardOffsetVec == nil then
		local list = getConfig("const", "fight_guard_offset", "jsonvalue");
		if list == nil then
			self._guardOffsetVec = Vector3(0, 0, 0);
		elseif #list > 1 then
			self._guardOffsetVec = Vector3(list[1], 0, list[2]);
		elseif #list > 0 then
			self._guardOffsetVec = Vector3(list[1], 0, 0);
		end
	end
	return self._guardOffsetVec;
end

function Lua_FightUtil.Get:skillHurtWaitTime()
	if self._skillHurtWaitTime == nil then
		self._skillHurtWaitTime = getConfig("const", "fight_skill_wait_time", "floatvalue");
		if self._skillHurtWaitTime == nil then
			self._skillHurtWaitTime = 0.5;
		end
	end
	return self._skillHurtWaitTime;
end