checkRequire("Lua_FirstRechargeRewardVo");
checkRequire("Lua_FirstRechargeConfigVo");
Lua_FirstRechargeData = class("Lua_FirstRechargeData");
function Lua_FirstRechargeData:ctor()
end

function Lua_FirstRechargeData:dispose()
	self.totalRecharge = 0;
	self.showIdx = 1;
	self.uiVersion = nil;
	self.totalCount = nil;
	self.actReward = nil;
	self._firstRechargeDic = nil;
	self._heroInfoDic = nil;
	self.actDayDic = {};
	self.allRewardDic = {};
end

function Lua_FirstRechargeData:fromServer50110002(msg)
	if msg == nil then
		return;
	end

	if self.uiVersion ~= msg.selectPanelType then
		self:dispose();
	end
	self.totalRecharge = msg.total_recharge; -- 累计充值金额
	self.uiVersion = msg.selectPanelType; -- 首充版本类型
	self:initActReward();

	local obj;
	local drawCount = 0;
	local vo;
	self.drawCountDic = {};
	for i = 1, #msg.draw_state do
		obj = msg.draw_state[i];
		self.actDayDic[obj.grade] = obj.activeted_day; -- 激活天数
		if self.drawCountDic[obj.grade] == nil then
			self.drawCountDic[obj.grade] = 0;
		end

		for j = 1, #obj.draw_list do
			drawCount = drawCount + 1;
			vo = self:getFirstRechargeVo(obj.draw_list[j]);
			if vo ~= nil then
				vo:setDrawState(true);
				if obj.draw_list[j] ~= self.actReward.id then
					self.drawCountDic[obj.grade] = self.drawCountDic[obj.grade] + 1;
				end
			end
		end
	end

	-- print(self.totalCount, drawCount);
	if DataCenter.funcOpenData:isOpened(10182) then
		DataCenter.mainMenuData:setIconShowInfo(30005, self.totalCount > drawCount);
	end
	self:updateFRRetState();
end

-- 激活奖励只有第一档有激活奖励
function Lua_FirstRechargeData:initActReward()
	local dic = self.firstRechargeDic[self.uiVersion];
	if self.totalCount == nil then -- 全部奖励数量
		self.totalCount = 0;
		for i = 1, #dic do
			self.totalCount = self.totalCount + dic[i]:getSize();
		end
	end

	if self.actReward == nil then
		self.actReward = dic[1]:remove(1);
	end
end

-- 全部奖励
function Lua_FirstRechargeData.Get:firstRechargeDic()
	if self._firstRechargeDic == nil then
		self._firstRechargeDic = {};

		local config = getConfig("recharge_first");
		for k,v in pairs(config) do
			if self._firstRechargeDic[v.version] == nil then
				self._firstRechargeDic[v.version] = {};
			end
			if self._firstRechargeDic[v.version][v.grade] == nil then
				self._firstRechargeDic[v.version][v.grade] = Array();
			end
			vo = self:getFirstRechargeVo(k);
			self._firstRechargeDic[v.version][v.grade]:add(vo);
		end

		for uiVersion,info in pairs(self._firstRechargeDic) do
			for i = 1, #info do
				info[i]:sort("id", false);
			end
		end
	end
	return self._firstRechargeDic;
end

function Lua_FirstRechargeData:getFirstRechargeVo(id)
	if self.allRewardDic[id] == nil then
		local config = getConfig("recharge_first", id);
		if config == nil then
			return;
		end
		self.allRewardDic[id] = Lua_FirstRechargeRewardVo.new(id, config);
	end
	return self.allRewardDic[id];
end

-- 更新首充红点状态
function Lua_FirstRechargeData:updateFRRetState()
	self.showIdx = 1;
	
	local dic = self.firstRechargeDic[self.uiVersion];
	local showRedDotState = false;
	local arr;
	for i = 1, #dic do
		if i == 1 then
			if self.actDayDic[i] > 0 and not self.actReward.drawState then
				self.showIdx = i;
				showRedDotState = true;
				break;
			end
		else
			arr = dic[i];
			for j = 1, arr:getSize() do
				if self.actDayDic[i] >= j and not arr[j].drawState then
					self.showIdx = i;
					showRedDotState = true;
					break;
				end
			end
			if showRedDotState == true then
				break;
			end
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.FirstRecharge, showRedDotState);
end

-- 第一档判断是否领取完
function Lua_FirstRechargeData.Get:oneDrawState()
	local arr = self.firstRechargeDic[self.uiVersion][1];
	return arr[arr:getSize()].drawState;
end

-- 根据版本类型分类
function Lua_FirstRechargeData.Get:heroInfoDic()
	if self._heroInfoDic == nil then
		self._heroInfoDic = {};

		local vo;
		local config = getConfig("recharge_first_config");
		for k,v in pairs(config) do
			vo = Lua_FirstRechargeConfigVo.new(k, v);
			if self._heroInfoDic[v.version] == nil then
				self._heroInfoDic[v.version] = Array();
			end
			self._heroInfoDic[v.version]:add(vo);
		end

		for i = 1, #self._heroInfoDic do
			self._heroInfoDic[i]:sort("id", false);
		end
	end
	return self._heroInfoDic;
end