checkRequire("Lua_FriendData")
Lua_FriendProxy = class("Lua_FriendProxy")
function Lua_FriendProxy:ctor()
    DataCenter.friendData = Lua_FriendData.new();

    -- 80107008是多余的，50107009和50107010的返回使用50107001

    Lua_MsgUtil.addLuaMsg(50107001, self, self.rGetFriendListInfo);
    Lua_MsgUtil.addLuaMsg(50107002, self, self.rApplyFriend);
    Lua_MsgUtil.addLuaMsg(50107003, self, self.rApplyFriendResult); -- 返回好友申请结果，是否存在对方好友栏已满或在对方黑名单上
    Lua_MsgUtil.addLuaMsg(50107007, self, self.rFindFriendInfo);
    Lua_MsgUtil.addLuaMsg(80107014, self, self.updateFriendRedPoint); -- 好友赠送礼物、好友申请页签红点

    Lua_MsgUtil.addLuaMsg(50107010, self, self.rGiveGiftToFriend);
    Lua_MsgUtil.addLuaMsg(50107012, self, self.rReceiveGiftOfFriend);
    Lua_MsgUtil.addLuaMsg(50107013, self, self.rReceiveGiftsOfFriend);
    Lua_MsgUtil.addLuaMsg(80107015, self, self.aRemoveFriend);
end

-------------------- 返回 --------------------

-- 获取好友列表(返回)
function Lua_FriendProxy:rGetFriendListInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107001();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107001(msg);
        Lua_MsgUtil.callFunc("SET_FRIENDPANEL_INFO", msg.type);
    end
end

-- 请求好友申请(返回)
function Lua_FriendProxy:rApplyFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107002();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107002(msg);
        Lua_MsgUtil.callFunc("SET_FRIENDPANEL_INFO");
    end
end

-- 请求返回好友申请结果，是否存在对方好友栏已满或在对方黑名单上
function Lua_FriendProxy:rApplyFriendResult(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107003();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107003(msg);
    end
end

-- 请求搜索好友(返回)
function Lua_FriendProxy:rFindFriendInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107007();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107007(msg);
        Lua_MsgUtil.callFunc("UPDATA_ADDFRIEND_INFO");
    end
end

function Lua_FriendProxy:updateFriendRedPoint(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80107014();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer80107014(msg);
        Lua_MsgUtil.callFunc("UPDATA_FRIEND_SENDRECBTN");
    end
end

-- 请求赠送好友礼物（返回）
function Lua_FriendProxy:rGiveGiftToFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107010();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107010(msg);
    end
end

-- 请求领取好友礼物（返回）
function Lua_FriendProxy:rReceiveGiftOfFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107012();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107012(msg);
    end
end

-- 一键领取所有礼物（返回）
function Lua_FriendProxy:rReceiveGiftsOfFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50107013();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer50107013(msg);
    end
end

-- 通知好友删除
function Lua_FriendProxy:aRemoveFriend(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80107015();
        msg:ParseFromString(mp.data);
        DataCenter.friendData:fromServer80107015(msg);
    end
end


















-------------------- 请求 --------------------

-- 获取好友相关列表 type 1 好友，2 黑名单，3 好友申请列表，4 已删除好友，5 推荐好友
function Lua_FriendProxy:sGetFriendListInfo(type)
    local msg = ProtoPublic_pb.Proto10107001();
    msg.type = type;
    sendMsg(10107001, msg);
end

-- 请求好友申请 friend_id 好友id
function Lua_FriendProxy:sApplyFriend(friend_id, server_flag)
    local msg = ProtoPublic_pb.Proto10107002();
    msg.friend_id = friend_id;
    msg.server_flag = server_flag;
    sendMsg(10107002, msg);
end 

-- 请求好友申请审核 type 1.同意所有 2.拒绝所有 3.同意单个好友申请 4.拒绝单个好友申请 apply_id 申请的玩家id
function Lua_FriendProxy:sCheckApplyFriend(type, playerInfo)
    local msg = ProtoPublic_pb.Proto10107003();
    msg.type = type;

    if playerInfo ~= nil then
        msg.apply_id = playerInfo;
    end
    sendMsg(10107003, msg);
end

-- 请求删除好友 friend_id 要删除的好友id
function Lua_FriendProxy:sRemoveFriend(friend_id)
    local msg = ProtoPublic_pb.Proto10107004();
    msg.friend_id = friend_id;
    sendMsg(10107004, msg);
end 

-- 请求加入黑名单 id 玩家id
function Lua_FriendProxy:sAddBackList(id, server_flag)
    local msg = ProtoPublic_pb.Proto10107005();
    msg.id = id;
    msg.server_flag = server_flag;
    sendMsg(10107005, msg);
end

-- 请求删除黑名单 id 玩家id
function Lua_FriendProxy:sRemoveBackList(id)
    local msg = ProtoPublic_pb.Proto10107006();
    msg.id = id;
    sendMsg(10107006, msg);
end

-- 请求搜索好友 name 玩家名
function Lua_FriendProxy:sFindFriendInfo(name)
    local msg = ProtoPublic_pb.Proto10107007();
    msg.name = name;
    sendMsg(10107007, msg);
end

-- 请求赠送好友礼物 friend_id 好友id
function Lua_FriendProxy:sGiveGiftToFriend(friend_id)
    local msg = ProtoPublic_pb.Proto10107010();
    msg.friend_id = friend_id;
    sendMsg(10107010, msg);
end

-- 请求领取好友赠送礼物 friend_id 好友id
function Lua_FriendProxy:sReceiveGiftOfFriend(friend_id)
    local msg = ProtoPublic_pb.Proto10107012();
    msg.friend_id = friend_id;
    sendMsg(10107012, msg);
end

-- 一键领取、赠送所有好友礼物
function Lua_FriendProxy:sReceiveGiftsOfFriend()
    sendMsg(10107013);
end