Lua_FuncPlayVo = class("Lua_FuncPlayVo");
function Lua_FuncPlayVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_FuncPlayVo.Get:config()
	if self._config == nil then
		self._config = getConfig("function_play", id);
	end
	return self._config;
end

-------------------- 配置数据 --------------------

function Lua_FuncPlayVo.Get:name()
	return self.config.name;
end

function Lua_FuncPlayVo.Get:iconAtlas()
	return self.config.icon_atlas;
end

function Lua_FuncPlayVo.Get:iconSprite()
	return self.config.icon_sprite;
end

function Lua_FuncPlayVo.Get:iconPath()
	return self.config.icon_path;
end

function Lua_FuncPlayVo.Get:iconWidth()
	return self.config.icon_width or 0;
end

function Lua_FuncPlayVo.Get:iconHeight()
	return self.config.icon_height or 0;
end

function Lua_FuncPlayVo.Get:showPos()
	if self._showPos == nil then
		if self.config.show_pos then
			local x = #self.config.show_pos > 0 and self.config.show_pos[1] or 0;
			local y = #self.config.show_pos > 1 and self.config.show_pos[2] or 0;
			self._showPos = {x, y};
		else
			self._showPos = {0, 0};
		end
	end
	return self._showPos;
end

function Lua_FuncPlayVo.Get:clickOffset()
	if self._clickOffset == nil then
		if self.config.click_offset then
			local x = #self.config.click_offset > 0 and self.config.click_offset[1] or 0;
			local y = #self.config.click_offset > 1 and self.config.click_offset[2] or 0;
			local z = #self.config.click_offset > 2 and self.config.click_offset[3] or 0;
			local w = #self.config.click_offset > 3 and self.config.click_offset[4] or 0;
			self._clickOffset = {x, y, z, w};
		else
			self._clickOffset = {0, 0, 0, 0};
		end
	end
	return self._clickOffset;
end

function Lua_FuncPlayVo.Get:pathId()
	return self.config.path_id;
end

function Lua_FuncPlayVo.Get:namePos()
	if self._namePos == nil then
		if self.config.name_pos then
			local x = #self.config.name_pos > 0 and self.config.name_pos[1] or 0;
			local y = #self.config.name_pos > 1 and self.config.name_pos[2] or 0;
			self._namePos = {x, y};
		else
			self._namePos = {0, 0};
		end
	end
	return self._namePos;
end

function Lua_FuncPlayVo.Get:redPointId()
	if self._redPointId == nil  then
		if self.config.red_point_id == nil then
			if self.pathId and self.pathId > 0 then
				local vo = DataCenter.funcPathUtil:getFuncPathVo(self.pathId)
				self._redPointId = vo.red_point_id
			end
		else
			self._redPointId = self.config.red_point_id
		end
	end
	return self._redPointId
end

function Lua_FuncPlayVo.Get:redPos()
	if self._redPos == nil then
		if self.config.red_pos then
			local x = #self.config.red_pos > 0 and self.config.red_pos[1] or 0;
			local y = #self.config.red_pos > 1 and self.config.red_pos[2] or 0;
			self._redPos = {x, y};
		else
			self._redPos = {0, 0};
		end
	end
	return self._redPos;
end

function Lua_FuncPlayVo.Get:templateList()
	if self._templateList == nil  then
		if self.config.template_list == nil then
			if self.pathId and self.pathId > 0 then
				local vo = DataCenter.funcPathUtil:getFuncPathVo(self.pathId)
				self._templateList = vo.template_list
			end
		else
			self._templateList = self.config.template_list
		end
	end
	return self._templateList
end

function Lua_FuncPlayVo.Get:uiEffName()
	return self.config.ui_effect
end

function Lua_FuncPlayVo.Get:uiEffUrl()
	if self._uiEffUrl == nil then
		self._uiEffUrl = LanUtil.StringProfile("/effects/uiEffects/", self.uiEffName);
	end
	return self._uiEffUrl;
end