-- 英雄时装
Lua_HeroFashionVo = class("Lua_HeroFashionVo")
function Lua_HeroFashionVo:ctor(id)
    self.id = id;
    self.tick = 0;
    self.config = getConfig("hero_clothes",id);
end

function Lua_HeroFashionVo:fromServerInfo(msg)
	self.tick = tonumber(msg.tick);--时装过期时间戳，0表示无限期
    self.is_click = msg.is_click;--是否访问过皮肤红点 0未访问 1已访问
    self.is_activate = msg.is_activate;--激活状态，0未激活，1已激活
end

--穿戴的时装id
function Lua_HeroFashionVo.Get:clothes_id()
    if self._clothes_id == nil then
        return 0;
    end
    return self._clothes_id;
end

function Lua_HeroFashionVo.Set:clothes_id(val)
    self._clothes_id = val;
end

--激活状态，0未激活，1已激活
function Lua_HeroFashionVo.Get:is_activate()
    if self._is_activate == nil then
        if self.is_initial == 1 then
            return 1;
        end
        return 0;
    end
    return self._is_activate;
end

function Lua_HeroFashionVo.Set:is_activate(val)
    self._is_activate = val;
end

--是否已穿戴时装
function Lua_HeroFashionVo.Get:isUseClothes()
    if self.clothes_id == self.id then
        return true;
    else
        if self.is_initial == 1 and self.clothes_id == 0 then --穿戴默认皮肤
            return true;
        end
    end

    return false;
end

function Lua_HeroFashionVo.Get:showTime()
    return self.tick - DataCenter.roleData.serverTime;
end

--时装名字
function Lua_HeroFashionVo.Get:name()
    return self.config.name;
end

--是否是初始时装
function Lua_HeroFashionVo.Get:is_initial()
    if self.config.is_initial == nil then
        return 0;
    end
    return self.config.is_initial;
end

--时装image
function Lua_HeroFashionVo.Get:path()
    if self.config.path ~= nil then
        return "/images/hero_fashion/"..self.config.path..".png";
    end
    return "";
end

--属性描述
function Lua_HeroFashionVo.Get:attr_des()
    if self.config.attr_des == nil then
        return "";
    end
    return self.config.attr_des;
end









--时装红点
function Lua_HeroFashionVo.Get:fashionRedDot()
    if self.is_initial == 1 then--默认皮肤
        return false;
    end

    --未访问过皮肤/已激活/未穿戴
    if self.is_click == 0 and self.is_activate == 1 and self.clothes_id == 0 then
        return true;
    end
    return false;
end