-- 英雄升星消耗vo
Lua_HeroUpStarCostVo = class("Lua_HeroUpStarCostVo")
function Lua_HeroUpStarCostVo:ctor(id)
	self.id = tonumber(id);
end

--消耗材料的索引
function Lua_HeroUpStarCostVo.Set:costMaterialsIndex(val)
	self._costMaterialsIndex = val;
end

function Lua_HeroUpStarCostVo.Get:costMaterialsIndex()
	return self._costMaterialsIndex;
end

function Lua_HeroUpStarCostVo.Get:star()
	return self.heroVo.star;
end

function Lua_HeroUpStarCostVo.Set:quality(val)
	self._quality = val;
end

function Lua_HeroUpStarCostVo.Get:quality()
	return self._quality;
end

function Lua_HeroUpStarCostVo.Set:quality_star(val)
	self._quality_star = val;
end

function Lua_HeroUpStarCostVo.Get:quality_star()
	return self._quality_star;
end

function Lua_HeroUpStarCostVo.Set:campType(val)
	self._campType = val;
end

function Lua_HeroUpStarCostVo.Get:campType()
	return self._campType;
end

function Lua_HeroUpStarCostVo.Set:needNum(val)
	self._needNum = val;
end

function Lua_HeroUpStarCostVo.Get:needNum()
	return self._needNum;
end

function Lua_HeroUpStarCostVo.Get:heroVo()
	if self._heroVo == nil then
		self._heroVo = Lua_HeroVo.new(self.id);
		self._heroVo.quality = self.quality;
		self._heroVo.quality_star = self.quality_star;
		self._heroVo.campType = self.campType;
	end
	return self._heroVo;
end

--是否需要自动选择明星
function Lua_HeroUpStarCostVo.Get:isAutoSelect()
	if self.id ~= 0 and self.star <= 5 then
		return true;
	end
	return false;
end

----是否需要自动选择明星(快捷升星)
function Lua_HeroUpStarCostVo.Get:isFastAutoSelect()
	if self.star == 3 or self.star == 4 or self.id ~= 0  then
		return true;
	end
	return false;
end


function Lua_HeroUpStarCostVo.Get:isSpeed()
	return self._isSpeed;
end

function Lua_HeroUpStarCostVo.Set:isSpeed(val)
	self._isSpeed = val;
end

-- 初始化选择材料数据
function Lua_HeroUpStarCostVo:initialCostInfo()
	if self.isSpeed == true then
		if self.isFastAutoSelect == false then
			return;
		end
	else
		if self.isAutoSelect == false  then
			return;
		end
	end
	local unique_id;
	local select_num = 0;
    local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(self.star);
    self:sortHeroInfo(heroUidArr)
    for i=1, heroUidArr:getSize() do
    	unique_id = heroUidArr[i];
        if unique_id ~= DataCenter.heroUpStarData.curSelectHeroUid and DataCenter.heroUpStarData:isSelectHeroUidByUid(unique_id) == false then
            hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
       		if self.id ~= 0 then
       	      	if hvo.isSpecialState ~= true and hvo.id == self.id and hvo.campType == self.campType and hvo.star == self.star and hvo.is_league_transaction == false and not hvo.trial_state then
	                select_num = select_num + 1;
	                DataCenter.heroUpStarData:addSelectedUidState(self.costMaterialsIndex, unique_id);
            	end
       		else
	       		if hvo.isSpecialState ~= true and hvo.campType == self.campType and hvo.star == self.star and hvo.is_league_transaction == false and not hvo.trial_state then
	                select_num = select_num + 1;
	                DataCenter.heroUpStarData:addSelectedUidState(self.costMaterialsIndex, unique_id);
            	end
	       	end
        end
        if select_num >= self.needNum then
    		break;
    	end
    end
end


-- 英雄升星排序
function Lua_HeroUpStarCostVo:sortHeroInfo(arr)
    local len = arr:getSize();
    if len == 1 then
        return;
    end
    for i = 1, len do
        for j = i + 1, len do
            local a = DataCenter.heroData:getItemByUniqueId(arr[i]).upStarSort;
            local b = DataCenter.heroData:getItemByUniqueId(arr[j]).upStarSort;
            if a > b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

--选择了英雄数量
function Lua_HeroUpStarCostVo.Get:selectHeroNum()
	return DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.costMaterialsIndex);
end