-- 英雄升星数据
Lua_HeroUpStarData = class("Lua_HeroUpStarData")
function Lua_HeroUpStarData:ctor()
    self:superCall("ctor");
    self:dispose();
end

function Lua_HeroUpStarData:dispose()
    self.curSelectHeroUid = nil;
    self.selectHeroUidDic = nil;
    self.selectCostIndexInfo = nil;
end

-- 初始化升星数据
function Lua_HeroUpStarData:initUpStarData(huid)
    self.curSelectHeroUid = huid;
    if self.selectHeroUidDic == nil then
        self.selectHeroUidDic = {};--已选的英雄唯一id
    else
        table.clear(self.selectHeroUidDic)
    end
    if self.selectCostIndexInfo == nil then
        self.selectCostIndexInfo = {};--根据材料索引记录已选的的英雄id
    else
        table.clear(self.selectCostIndexInfo)
    end
end

-- 展示满足升星材料条件的数据 
function Lua_HeroUpStarData:showHeroInfo(heroUpStarCostVo)
    local id = heroUpStarCostVo.id;
    local star = heroUpStarCostVo.star;
    local campType = heroUpStarCostVo.campType;
    local costIndex = heroUpStarCostVo.costMaterialsIndex;

    local vo;
    local unique_id;
    local arr = Array();
    if id == 0 then--不指定英雄，才能用万能道具
        --万能道具
        local pack_info = DataCenter.packData:getUnIdList(Lua_PackDefine.ALMIGHTY_HERO);
        for i=1,pack_info:getSize() do
            unique_id = pack_info[i];
            vo = DataCenter.packData:getItemVoByUnId(unique_id);
            if campType ~= 0 then --指定类型
                if vo.campType == campType and vo.star == star then
                    for j=1, vo.count do
                        local uid = vo.id.."00000000000"..j;
                        arr:add(uid);         
                    end
                end
            elseif star ~= 0 then --指定星级
                if vo.star == star then
                    for j=1, vo.count do
                        local uid = vo.id.."00000000000"..j;
                        arr:add(uid);         
                    end
                end
            end
        end
    end
    -- print("万能道具  =",arr:getSize())
    local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
    self:sortHeroInfo(heroUidArr);
    for i=1, heroUidArr:getSize() do
        unique_id = heroUidArr[i];
        if unique_id ~= self.curSelectHeroUid then--筛选掉当前英雄，和已经选择的英雄
            if self:isSelectHeroUidByUid(unique_id) == true then--筛选掉已经选择的英雄
                if self:isSelectHeroUidByIndex(costIndex, unique_id) == true then --当前材料索引下已选的英雄需要显示出来
                    arr:add(unique_id);
                end
            else
                vo = DataCenter.heroData:getItemByUniqueId(unique_id);
                if id ~= 0 then --指定英雄
                    -- print(vo.id," 指定英雄 = =",id)
                    if vo.id == id and vo.campType == campType and vo.star == star and vo.is_league_transaction == false and not vo.trial_state then
                        -- print("id = =",vo.id)
                        arr:add(unique_id);
                    end
                elseif campType ~= 0 then --指定类型
                    if vo.campType == campType and vo.star == star and vo.is_league_transaction == false and not vo.trial_state then
                        arr:add(unique_id);
                    end
                elseif star ~= 0 then --指定星级
                    if vo.star == star and vo.is_league_transaction == false and not vo.trial_state then
                        arr:add(unique_id);
                    end
                end
            end
        end
    end

    return arr;
end

-- 英雄升星排序
function Lua_HeroUpStarData:sortHeroInfo(arr)
    local len = arr:getSize();
    if len <= 1 then
        return;
    end
    for i = 1, len do
        for j = i + 1, len do
            local a = DataCenter.heroData:getItemByUniqueId(arr[i]).upStarSort;
            local b = DataCenter.heroData:getItemByUniqueId(arr[j]).upStarSort;
            if a > b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

--设置选择Uid状态
function Lua_HeroUpStarData:addSelectedUidState(costMaterialsIndex, unique_id)
    if self.selectHeroUidDic == nil then
        self.selectHeroUidDic = {};
    end
    self.selectHeroUidDic[unique_id] = 1;

    if self.selectCostIndexInfo == nil then
        self.selectCostIndexInfo = {};
    end
    if self.selectCostIndexInfo[costMaterialsIndex] == nil then
        self.selectCostIndexInfo[costMaterialsIndex] = {};
    end
    self.selectCostIndexInfo[costMaterialsIndex][unique_id] = 1;
end

--删除选择Uid状态
function Lua_HeroUpStarData:delSelectedUidState(costMaterialsIndex, unique_id)
    self.selectHeroUidDic[unique_id] = nil;
    self.selectCostIndexInfo[costMaterialsIndex][unique_id] = nil;
end

--筛选当前材料索引是否选了该英雄唯一id
function Lua_HeroUpStarData:isSelectHeroUidByIndex(costMaterialsIndex, unique_id)
    if self.selectCostIndexInfo == nil or self.selectCostIndexInfo[costMaterialsIndex] == nil then
        return false;
    end

    if self.selectCostIndexInfo[costMaterialsIndex][unique_id] == 1 then
        return true;
    end
    return false;
end

--是否选择该唯一id
function Lua_HeroUpStarData:isSelectHeroUidByUid(unique_id)
    if self.selectHeroUidDic == nil or self.selectHeroUidDic[unique_id] == nil then
        return false;
    end
    return self.selectHeroUidDic[unique_id] == 1;
end

--记录已解除上阵状态的英雄Uid
function Lua_HeroUpStarData:initRemoveLineupStateDic(state)
    if state then
        if self.selectHeroUidDic ~= nil then
            for uid, v in pairs(self.selectHeroUidDic) do
                if v == 1 then
                    self.removeLineupStateDic[uid] = 1;
                end
            end
        end
    else
        self._removeLineupStateDic = nil;
    end
end

function Lua_HeroUpStarData.Get:removeLineupStateDic()
    if self._removeLineupStateDic == nil then
        self._removeLineupStateDic = {};
    end

    return self._removeLineupStateDic;
end

-- 获取选择材料的数量
function Lua_HeroUpStarData:getSelectHeroNumByIndex(costMaterialsIndex)
    if self.selectCostIndexInfo[costMaterialsIndex] == nil then
        return 0;
    end
    local num = 0;
    local list = self.selectCostIndexInfo[costMaterialsIndex];
    for k,v in pairs(list) do
        if v == 1 then
            num = num +1;
        end
    end
    return num;
end

-- 是否可以升星
function Lua_HeroUpStarData:isUpStar(need_num)
    if self.selectCostIndexInfo == nil then
        return false;
    end
    local c_num = 0;
    local list = self.selectCostIndexInfo;
    for k,v in pairs(list) do
        local num = 0;
        for k, val in pairs(v) do
            if val == 1 then
                num = num +1;
            end
        end
        c_num = c_num + num;
    end
    -- print(c_num,"  是否可以升星  ",need_num)
    return c_num >= need_num;
end

-- 记录初始数据
function Lua_HeroUpStarData:tagInitInfo()
    local list1 = {};
    local list2 = {};
    for uid, v in pairs(self.selectHeroUidDic) do
        list1[uid] = v;
    end

    for index, dic in pairs(self.selectCostIndexInfo) do
        if list2[index] == nil then
            list2[index] = {};
        end
        for uid,v in pairs(dic) do
            list2[index][uid] = v;
        end
    end
    return list1, list2;
end

-- 把数据更新为初始数据域
function Lua_HeroUpStarData:updateTagInitInfo(list1, list2)
    if list1 == nil then
        return;
    end
    self.selectHeroUidDic = {};
    for uid, v in pairs(list1) do
        self.selectHeroUidDic[uid] = v;
    end


    if list2 == nil then
        return;
    end
    self.selectCostIndexInfo = {};
    for index, dic in pairs(list2) do
        if self.selectCostIndexInfo[index] == nil then
            self.selectCostIndexInfo[index] = {};
        end
        for uid,v in pairs(dic) do
            self.selectCostIndexInfo[index][uid] = v;
        end
    end
end

-- 选择的英雄所在的阵容和已选择的英雄所在的阵容数量 > 所在阵容的数量才可以下阵
function Lua_HeroUpStarData:checkLineupNumState(select_uid)
    if self.selectHeroUidDic == nil or select_uid == nil then
        return true;
    end

    
    local hvo;
    local config;
    local lineupList = {};
    for uid, v in pairs(self.selectHeroUidDic) do
        if v >= 1 then
            hvo = DataCenter.heroData:getItemByUniqueId(uid);
            if hvo.lineupDic ~= nil then
                for lineup_type, vul in pairs(hvo.lineupDic) do
                    config = getConfig("hero_camp_lineup", lineup_type);
                    if config ~= nil and config.can_cancel == 1 then
                        if lineupList[lineup_type] == nil then
                            lineupList[lineup_type] = 1;
                        else
                            lineupList[lineup_type] = lineupList[lineup_type] +1;
                        end
                    end
                end
            end
        end
    end

    hvo = DataCenter.heroData:getItemByUniqueId(select_uid);
    if hvo ~= nil and hvo.lineupDic ~= nil then
        for lineup_type, vul in pairs(hvo.lineupDic) do
            config = getConfig("hero_camp_lineup", lineup_type);
            if config ~= nil and config.can_cancel == 1 then
                if lineupList[lineup_type] == nil then
                    lineupList[lineup_type] = 1;
                else
                    lineupList[lineup_type] = lineupList[lineup_type] +1;
                end

                if lineupList[lineup_type] >= DataCenter.heroLineupData:getLineupHeroTotalNum(lineup_type) then
                    return false, config.name;
                end
            end
        end
    end

    return true;
end

-- 对应索引位材料是否足够 
function Lua_HeroUpStarData:isHaveHeroCost(heroUpStarCostVo)
    local id = heroUpStarCostVo.id;
    local star = heroUpStarCostVo.star;
    local campType = heroUpStarCostVo.campType;
    local costIndex = heroUpStarCostVo.costMaterialsIndex;

    local vo;
    local unique_id;
    if id == 0 then--不指定英雄，才能用万能道具
        --万能道具
        local pack_info = DataCenter.packData:getUnIdList(Lua_PackDefine.ALMIGHTY_HERO);
        for i=1,pack_info:getSize() do
            unique_id = pack_info[i];
            vo = DataCenter.packData:getItemVoByUnId(unique_id);
            if campType ~= 0 then --指定类型
                if vo.campType == campType and vo.star == star then
                    return true;
                end
            elseif star ~= 0 then --指定星级
                if vo.star == star then
                    return true;
                end
            end
        end
    end
    -- print("万能道具  =",arr:getSize())
    local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
    for i=1, heroUidArr:getSize() do
        unique_id = heroUidArr[i];
        if unique_id ~= self.curSelectHeroUid then--筛选掉当前英雄，和已经选择的英雄
            if self:isSelectHeroUidByUid(unique_id) == true then--筛选掉已经选择的英雄
                if self:isSelectHeroUidByIndex(costIndex, unique_id) == true then --当前材料索引下已选的英雄需要显示出来
                    return true;
                end
            else
                vo = DataCenter.heroData:getItemByUniqueId(unique_id);
                if id ~= 0 then --指定英雄
                    -- print(vo.id," 指定英雄 = =",id)
                    if vo.id == id and vo.campType == campType and vo.star == star and vo.is_league_transaction == false and not vo.trial_state then
                        -- print("id = =",vo.id)
                        return true;
                    end
                elseif campType ~= 0 then --指定类型
                    if vo.campType == campType and vo.star == star and vo.is_league_transaction == false and not vo.trial_state then
                        return true;
                    end
                elseif star ~= 0 then --指定星级
                    if vo.star == star and vo.is_league_transaction == false and not vo.trial_state then
                        return true;
                    end
                end
            end
        end
    end

    return false;
end




----------------------------------升星红点 -------------------------------------------

-- 英雄升星红点
function Lua_HeroUpStarData:checkUpStarRedDot(heroVo)
    if heroVo.isMaxStar == true then--最大星级
        return false;
    end

    if heroVo.heroUpStarVo.isMeetUpStarCost ~= true then--升级材料不足
        return false;
    end

    local list = heroVo.heroUpStarVo.upgrade_material;
    if list == nil then
        return false;
    end
    local id;
    local star;
    local campType;
    local costIndex;
    local needNum;

    local vo;
    local unique_id;
    local heroUidArr;

    local needAllNum = 0;--需要的总数量
    local select_num = 0;--选择的数量
    local tag_list = {}
    for i=1,#list do
        id = list[i][4];
        star = DataCenter.heroUtil:getHeroAwakenStarByQuality(list[i][1][1],list[i][1][2]);
        campType = list[i][2];
        needNum = list[i][3];
        needAllNum = needAllNum + needNum;


        if id == 0 then--不指定英雄，才能用万能道具
            --万能道具
            local pack_info = DataCenter.packData:getUnIdList(Lua_PackDefine.ALMIGHTY_HERO);
            for i=1,pack_info:getSize() do
                unique_id = pack_info[i];
                vo = DataCenter.packData:getItemVoByUnId(unique_id);
                if campType ~= 0 then --指定类型
                    if vo.campType == campType and vo.star == star then
                        for j=1, vo.count do
                            needNum = needNum -1;
                            select_num = select_num +1;
                            if needNum == 0 then
                                break;
                            end
                        end
                    end
                elseif star ~= 0 then --指定星级
                    if vo.star == star then
                        for j=1, vo.count do
                            needNum = needNum -1;
                            select_num = select_num +1;
                            if needNum == 0 then
                                break;
                            end
                        end
                    end
                end
            end
        end
        
        --消耗英雄
        if needNum > 0 then
            heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
            for i=1, heroUidArr:getSize() do
                unique_id = heroUidArr[i];
                vo = DataCenter.heroData:getItemByUniqueId(unique_id);
                if unique_id ~= heroVo.unique_id and tag_list[unique_id] == nil and vo.isSpecialState == false and vo.is_league_transaction == false and not vo.trial_state then--筛选掉当前英雄/和已经参与升星的英雄/有特殊状态无法参与升星
                    if id ~= 0 then --指定英雄
                        -- print(vo.id," 指定英雄 = =",id)
                        if vo.id == id and vo.campType == campType and vo.star == star then
                            -- print("id = =",vo.id)
                            needNum = needNum -1;
                            tag_list[unique_id] = 1;
                            select_num = select_num +1;
                            if needNum == 0 then
                                break;
                            end
                        end
                    elseif campType ~= 0 then --指定类型
                        if vo.campType == campType and vo.star == star then
                            needNum = needNum -1;
                            tag_list[unique_id] = 1;
                            select_num = select_num +1;
                            if needNum == 0 then
                                break;
                            end
                        end
                    elseif star ~= 0 then --指定星级
                        if vo.star == star then
                            needNum = needNum -1;
                            tag_list[unique_id] = 1;
                            select_num = select_num +1;
                            if needNum == 0 then
                                break;
                            end
                        end
                    end
                end
            end
        end
    end

    if needAllNum ~= 0 and needAllNum <= select_num then
        return true;
    end
    return false;
end

-- 英雄升星单个材料红点
function Lua_HeroUpStarData:upStarMaterialRedDot(upStarCostVo)
    local id = upStarCostVo.id;
    local star = upStarCostVo.star;
    local campType = upStarCostVo.campType;
    local needNum = upStarCostVo.needNum;
    local select_num = self:getSelectHeroNumByIndex(upStarCostVo.costMaterialsIndex);--当前材料组已经选择英雄的数量
    local cur_need_num = needNum-select_num;--当前需要选择的数量

    local tag_list = {};--已记录的 uid
    local list = self.selectCostIndexInfo;
    for index, uidlist in pairs(list) do
        for uid,v in pairs(uidlist) do
            if tag_list[uid] == nil then
                tag_list[uid] = v;
            end
        end
    end

    local vo;
    local unique_id;
    if id == 0 then--不指定英雄，才能用万能道具
        --万能道具
        local pack_info = DataCenter.packData:getUnIdList(Lua_PackDefine.ALMIGHTY_HERO);
        for i=1,pack_info:getSize() do
            unique_id = pack_info[i];
            vo = DataCenter.packData:getItemVoByUnId(unique_id);
            if campType ~= 0 then --指定类型
                if vo.campType == campType and vo.star == star then
                    for j=1, vo.count do
                        local uid = vo.id.."00000000000"..j;
                        if tag_list[uid] == nil then
                            cur_need_num = cur_need_num -1;
                            if cur_need_num <= 0 then
                                return true;
                            end
                        end    
                    end
                end
            elseif star ~= 0 then --指定星级
                if vo.star == star then
                    for j=1, vo.count do
                        local uid = vo.id.."00000000000"..j;
                        if tag_list[uid] == nil then
                            cur_need_num = cur_need_num -1;
                            if cur_need_num <= 0 then
                                return true;
                            end
                        end     
                    end
                end
            end
        end
    end

    
    local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(star);
    for i=1, heroUidArr:getSize() do
        unique_id = heroUidArr[i];
        vo = DataCenter.heroData:getItemByUniqueId(unique_id);
        if unique_id ~= self.curSelectHeroUid and tag_list[unique_id] == nil and vo.lock_state == false and vo.is_league_transaction == false and not vo.trial_state then--筛选掉当前英雄/和已经参与升星的英雄/没上锁
            if id ~= 0 then --指定英雄
                -- print(vo.id," 指定英雄 = =",id)
                if vo.id == id and vo.campType == campType and vo.star == star then
                    -- print("id = =",vo.id)
                    cur_need_num = cur_need_num -1;
                    if cur_need_num <= 0 then
                        return true;
                    end
                end
            elseif campType ~= 0 then --指定类型
                if vo.campType == campType and vo.star == star then
                    cur_need_num = cur_need_num -1;
                    if cur_need_num <= 0 then
                        return true;
                    end
                end
            elseif star ~= 0 then --指定星级
                if vo.star == star then
                    cur_need_num = cur_need_num -1;
                    if cur_need_num <= 0 then
                        return true;
                    end
                end
            end
        end
    end

    return false;
end