-- 英雄 升级
Lua_HeroUpgradeVo = class("Lua_HeroUpgradeVo")
function Lua_HeroUpgradeVo:ctor(initial_awaken_star_id)
    self.initial_awaken_star_id = initial_awaken_star_id;--初始星级
end

function Lua_HeroUpgradeVo:updateServerInfo(level,awaken_star_id, is_resonance, trial_state)
    self.level = level;
    self.awaken_star_id = awaken_star_id;
    self.is_resonance = is_resonance;
    self.trial_state = trial_state;
end

-- 升级配置
function Lua_HeroUpgradeVo.Get:levelCostConfig() 
   return DataCenter.heroUtil:getHeroLevelCostConfig(self.level);
end

--是否满足同调器等级
function Lua_HeroUpgradeVo.Get:bResonanceLevel() 
    local lvl = self.levelCostConfig.resonance;
    if lvl == nil then
        return true;
    end

    return  DataCenter.lifeTreeData.cur_level >= lvl;
end

--是否可以突破
function Lua_HeroUpgradeVo.Get:isBreak() 
    return self.levelCostConfig.is_break~=nil;
end

-- 当前星级的等级上限
function Lua_HeroUpgradeVo.Get:limit_level()
    return DataCenter.heroUtil:getHeroAwakenStarConfigInfo(self.awaken_star_id).lvl_limit;
end

-- 初始星级升级等级上限
function Lua_HeroUpgradeVo.Get:initial_lvl_limit()
    return DataCenter.heroUtil:getHeroAwakenStarConfigInfo(self.initial_awaken_star_id).lvl_limit;
end

-- 是否是最大等级
function Lua_HeroUpgradeVo.Get:isMaxLevel()
    if self.level >= self.limit_level then
        return true;
    end
    return false;
end

-- 是否可以升级英雄
function Lua_HeroUpgradeVo.Get:isUpgradeHero()
    local arr = Array();
    local cost_list = self.levelCostConfig.upgrade_exp;
    if cost_list ~= nil then
        local bagNum;
        for i=1,#cost_list do
            bagNum = DataCenter.packData:getItemCountById(cost_list[i][1]);
            if bagNum < cost_list[i][2] then
                return cost_list[i][1];
            end
        end
    end

    return true;
end











------------------------------------升级-------------------------------------------------------

-- 一次最大升级值
function Lua_HeroUpgradeVo.Get:oneMaxUpgradeLevel()
    if self.isBreak == true then--当前是突破
        return 0;
    end

    local rapid_upgrade = DataCenter.heroUtil.rapid_upgrade;
    if self.level >= rapid_upgrade[1] then--当前等级超出快速升级最高等级上限
        return 0;
    end

    return rapid_upgrade[2];
end

-- 当前材料可以升多少级
function Lua_HeroUpgradeVo.Get:upgradelimit()
    local maxLvl = self.oneMaxUpgradeLevel;
    if maxLvl == 0 then
        return 0;
    end
    local bagNum;
    local needNum;
    local costData;
    local cost_list;
    local up_lvl = 0;--可升等级
    local tag_list = {};--[id] = num;
    for j=1, maxLvl do
        costData = DataCenter.heroUtil:getHeroLevelCostConfig(self.level + j-1);-- -1 是当前等级

        cost_list = costData.upgrade_exp;
        if costData.is_break == 1 then--突破
            break;
        end
        local up_num = 0;
        local len = #cost_list;
        for i=1, len do
            needNum = cost_list[i][2];
            bagNum = DataCenter.packData:getItemCountById(cost_list[i][1]);
            if tag_list[cost_list[i][1]] == nil then
                tag_list[cost_list[i][1]] = bagNum;
            end
            tag_list[cost_list[i][1]] = tag_list[cost_list[i][1]] - needNum;
            if tag_list[cost_list[i][1]] >= 0 then
                up_num  = up_num +1;
            else
                up_num = up_num -1;
            end
        end
        if up_num == len then--材料够升一级
            up_lvl = up_lvl +1;
        end
    end
    if up_lvl + self.level > self.initial_lvl_limit then--材料可升等级大于升级上限，显示最大可升等级
        up_lvl = self.initial_lvl_limit - self.level;
    end
    tag_list = nil;
    return up_lvl;
end


-- 最大升级消耗
function Lua_HeroUpgradeVo:maxUpgradeCost(up_lvl)
    if up_lvl == 0 then-- 0 ：材料不够升一级，需要展示升一级的数据
        up_lvl = 1;
    end
    local costData;
    local cost_list;
    local tag_list = {};-- [id] = num;
    for j=1, up_lvl do
        costData = DataCenter.heroUtil:getHeroLevelCostConfig(self.level + j-1);-- -1 是当前等级
        cost_list = costData.upgrade_exp;
        for i=1,#cost_list do
            if tag_list[cost_list[i][1]] == nil then
                tag_list[cost_list[i][1]] = cost_list[i][2];
            else
                tag_list[cost_list[i][1]] = tag_list[cost_list[i][1]] + cost_list[i][2];
            end
        end
    end

    local arr = Array();
    local upgradeCostVo;
    for id, num in pairs(tag_list) do
        upgradeCostVo = Lua_HeroCostMaterialsVo.new(id);
        upgradeCostVo.needNum = num;
        arr:add(upgradeCostVo);
    end
    tag_list = nil;
    arr:sort("sort",true);--升序
    return arr;
end

-- 升级消耗 数据
function Lua_HeroUpgradeVo.Get:upgradeCostInfo()
    if self.oneMaxUpgradeLevel > 0 then--快捷升级上限
        return self:maxUpgradeCost(self.upgradelimit);
    end

    --升一级消耗
    local arr = Array();
    local cost_list = self.levelCostConfig.upgrade_exp;
    if cost_list ~= nil then
        for i=1,#cost_list do
            local upgradeCostVo = Lua_HeroCostMaterialsVo.new(cost_list[i][1]);
            arr:add(upgradeCostVo);
            arr[i].needNum = cost_list[i][2];
        end
    end

    return arr;
end













------------------------------------等级直升-------------------------------------------------------
-- 当前等级 是否可以升到 指定等级
function Lua_HeroUpgradeVo:bUpLimitLevel(limit_level)
    local data = DataCenter.heroUtil:getHeroLevelCostConfig(limit_level);
    if data == nil then
        return false;
    end

    local bagNum = 0;
    local needNum = 0;
    local cur_list = self.levelCostConfig.rebuild_exp;--当前已消耗材料
    local all_list = data.rebuild_exp;--总材料
    for i=1, #all_list do
        bagNum = DataCenter.packData:getItemCountById(all_list[i][1]);
        if cur_list == nil or cur_list[i] == nil then
            needNum = all_list[i][2];
        else
            needNum = all_list[i][2] - cur_list[i][2];
        end
        
        if bagNum < needNum then
            return false;
        end
    end

    return true;
end

--当前材料 直升等级上限
function Lua_HeroUpgradeVo.Get:upMaxLevel()
    local limit_level = self.initial_lvl_limit;--初始星级最高升级上限
    if self.level > limit_level then
        limit_level = DataCenter.heroUtil:getHeroLevelCostConfig(self.level).lvl_limit;--升级配置当前等级最高升级上限
    end

    if limit_level - self.level < DataCenter.heroUtil.show_button_lvl_limit then--直升等级幅度限制
        return 0;
    end

    local bUpLimitLevel = self:bUpLimitLevel(limit_level);
    if bUpLimitLevel then
        return limit_level;
    end

    return 0;

    -- local data;
    -- local item_id;
    -- local bag_list = {};
    -- local need_list = {};
    -- for i = self.level+1, limit_level do
    --     data = DataCenter.heroUtil:getHeroLevelCostConfig(i);
    --     if data == nil then
    --         return 0
    --     end
    --     local list = data.upgrade_exp;
    --     for i=1,#list do
    --         item_id = list[i][1];
    --         if need_list[item_id] == nil then
    --             need_list[item_id] = list[i][2];
    --             bag_list[item_id] = DataCenter.packData:getItemCountById(item_id);
    --         else
    --             need_list[item_id] = need_list[item_id] + list[i][2];
    --         end
    --         if bag_list[item_id] < need_list[item_id] then
    --             return 0;
    --         end
    --     end
    -- end
end

-- 升级到最大等级 数据
function Lua_HeroUpgradeVo:upgradeMaxCostInfo(max_lvl)
    local arr = Array();
    local tag_list = {};
    local curCostData = self.levelCostConfig;
    if curCostData ~= nil then
        local list = curCostData.rebuild_exp;
        if list ~= nil then
            for i = 1, #list do
                tag_list[list[i][1]] = list[i][2];
            end
        end
    end

    local maxCostData = DataCenter.heroUtil:getHeroLevelCostConfig(max_lvl);
    if maxCostData ~= nil then
        local cost_list = maxCostData.rebuild_exp;
        local upgradeCostVo;
        if cost_list ~= nil then
            for i = 1, #cost_list do
                upgradeCostVo = Lua_HeroCostMaterialsVo.new(cost_list[i][1]);
                if tag_list[cost_list[i][1]] ~= nil then
                    upgradeCostVo.needNum = cost_list[i][2] - tag_list[cost_list[i][1]];
                else
                    upgradeCostVo.needNum = cost_list[i][2];
                end

                if upgradeCostVo.show_needNum > 0 then
                    arr:add(upgradeCostVo);
                end
            end
            -- arr:sort("sort",true);--升序
        end
    end
    tag_list = nil;
    return arr;
end


-- 重修材料返还数据
function Lua_HeroUpgradeVo.Get:rebuildMaterialsInfo()
    return self.levelCostConfig.rebuild_exp;
end







---------------------------------- 红点 -------------------------------------------

-- 是否可以升级英雄红点
function Lua_HeroUpgradeVo.Get:isUpgradeLvlRed()
    if not self.bResonanceLevel then--不满足同调器等级
        return false;
    end

    local bagNum;
    local cost_list = self.levelCostConfig.upgrade_exp;
    if cost_list ~= nil then
        for i=1,#cost_list do
            bagNum = DataCenter.packData:getItemCountById(cost_list[i][1]);
            if bagNum < cost_list[i][2] then
                return false;
            end
        end
    end

    return true;
end

-- 升级红点
function Lua_HeroUpgradeVo.Get:heroUpgradeReddot()
    if self.trial_state == true then -- 试用状态
        return false;
    end

    if self.is_resonance == true then -- 同调器状态
        return false;
    end

    if self.isMaxLevel == true then -- 是否是最大等级
        return false;
    end

    if self.isUpgradeLvlRed == true then--是否可以升级
        return true;
    end
    return false;
end