-- 英雄系统配置数据
checkRequire("Lua_HeroTabVo");
-- checkRequire("Lua_HeroAwakenTypeVo");
checkRequire("Lua_HeroWeaponVo");
Lua_HeroUtil = class("Lua_HeroUtil");
-- 英雄标签
Lua_HeroUtil.HERO_TYPE = 1; -- 英雄
Lua_HeroUtil.ATLAS_TYPE = 2;-- 图鉴
Lua_HeroUtil.HRAT_TYPE = 3; -- 热度
-- 英雄类型
Lua_HeroUtil.All_TYPE = 0;  -- 全部
Lua_HeroUtil.WIND_TYPE = 3; -- 风
Lua_HeroUtil.WATER_TYPE = 1;-- 水
Lua_HeroUtil.FIRE_TYPE = 2; -- 火
Lua_HeroUtil.SOIL_TYPE = 4; -- 土
Lua_HeroUtil.LIGHT_TYPE = 5;-- 光
Lua_HeroUtil.DARK_TYPE = 6; -- 暗


--英雄布阵类型
Lua_HeroUtil.LINEUP_MAIN_TYPE = 1; -- 主线剧情
Lua_HeroUtil.LINEUP_ARENA_DEFENSIZE = 2; -- 斗技场防守
Lua_HeroUtil.LINEUP_ARENA_ATTACK = 5; -- 斗技场进攻
Lua_HeroUtil.LINEUP_INFINITYHALL_SINGLE = 6; -- 无穷战殿单人
Lua_HeroUtil.LINEUP_INFINITYHALL_TEAM = 7; -- 无穷战殿团队
Lua_HeroUtil.LINEUP_EXPEDITION = 13; -- 边境远征
Lua_HeroUtil.LINEUP_CHAMPIONSHIP = 15; -- 冠军赛
Lua_HeroUtil.LINEUP_STARTRIAL = 16; -- 星魂试炼
Lua_HeroUtil.LINEUP_CHAOSFOREST = 17; -- 混沌森林
Lua_HeroUtil.LINEUP_LEAGUEBOSS = 18; -- 联盟Boss
Lua_HeroUtil.LINEUP_PEAKDUEL = 19; -- 巅峰对决
Lua_HeroUtil.LINEUP_MONSTERTRIAL = 20; -- 魔神试炼
Lua_HeroUtil.LINEUP_STORY = 21; -- 剧情关卡
Lua_HeroUtil.LINEUP_LRAGUEDUEL_ATTACK = 32; -- 公会对抗进攻
Lua_HeroUtil.LINEUP_LRAGUEDUEL_DEFENSIZE = 33; -- 公共对抗防守

-- 布阵item的位置;
Lua_HeroUtil.LINEUP_ITEM_POS = {-244, -154, -28, 64, 155, 246};
Lua_HeroUtil.GOSSIP_LINEUP_ITEM_POS = {-280, -171, -35, 71, 177, 283};
function Lua_HeroUtil:ctor()
    self:superCall("ctor");
end

---------------------------------- 工具接口 -------------------------------------------

-- 英雄阵营页签
function Lua_HeroUtil.Get:siftAllInfo()
    if self._siftAllInfo == nil then
        self._siftAllInfo = Array();
        self._siftAllInfo:add(Lua_HeroUtil.All_TYPE);
        self._siftAllInfo:add(Lua_HeroUtil.WATER_TYPE);
        self._siftAllInfo:add(Lua_HeroUtil.SOIL_TYPE);
        self._siftAllInfo:add(Lua_HeroUtil.FIRE_TYPE);
        self._siftAllInfo:add(Lua_HeroUtil.WIND_TYPE);
        
        -- self._siftAllInfo:add(Lua_HeroUtil.LIGHT_TYPE);
        -- self._siftAllInfo:add(Lua_HeroUtil.DARK_TYPE);
    end
    return self._siftAllInfo;
end

-- 英雄阵营页签
function Lua_HeroUtil.Get:siftInfo()
    if self._siftInfo == nil then
        self._siftInfo = Array();
        self._siftInfo:add(Lua_HeroUtil.WATER_TYPE);
        self._siftInfo:add(Lua_HeroUtil.SOIL_TYPE);
        self._siftInfo:add(Lua_HeroUtil.FIRE_TYPE);
        self._siftInfo:add(Lua_HeroUtil.WIND_TYPE);
        -- self._siftInfo:add(Lua_HeroUtil.LIGHT_TYPE);
        -- self._siftInfo:add(Lua_HeroUtil.DARK_TYPE);
    end
    return self._siftInfo;
end

function Lua_HeroUtil.Get:careerAllInfo()
    if self._careerAllInfo == nil then
        self._careerAllInfo = Array();
        self._careerAllInfo:add(0);
        self._careerAllInfo:add(2);
        self._careerAllInfo:add(4);
        self._careerAllInfo:add(1);
        self._careerAllInfo:add(3);
    end
    return self._careerAllInfo;
end

--获取英雄职业名称
function Lua_HeroUtil:getHeroCareer(career)
    career = tonumber(career);
    if career < 1 or career > 4 then
        return "";
    end
    return LanUtil.getValue(126044 + career);
end

-- 英雄阵营名
function Lua_HeroUtil:getCampName(campType)
    campType = tonumber(campType);
    if campType < 1 or campType > 6 then
        return "";
    end
    return LanUtil.getValue(126030 + campType);
end

-- 英雄质量名
function Lua_HeroUtil:getHeroQualityName(quality, quality_star)
    if quality == nil or quality == 0 then
        return "";
    end

    local str = LanUtil.getValue(126003 + quality);
    if quality_star ~= nil and quality_star > 0 then
        str = str..LanUtil.formateStr(126075,quality_star);
    end
    return str;
end









---------------------------------- 配置数据 -------------------------------------------

-- 英雄升级属性加成配置 数据
function Lua_HeroUtil:getHeroLevelPropConfig(level) 
    if self._levelPropConfig == nil then
        self._levelPropConfig = getConfig("hero_level_prop");
    end
    return self._levelPropConfig[level];
end

-- 英雄传记
function Lua_HeroUtil:getHeroDesConfig(id) 
    if self._heroDesConfig == nil then
        self._heroDesConfig = getConfig("hero_des");
    end
    return self._heroDesConfig[id];
end

-- 英雄升级
function Lua_HeroUtil:getHeroLevelCostConfig(level) 
    if self._heroLevelCostConfig == nil then
        self._heroLevelCostConfig = getConfig("hero_level_cost");
    end
    return self._heroLevelCostConfig[level];
end

-- 英雄星级替换
function Lua_HeroUtil:getHeroReplaceStarCfg(id) 
    if self._heroReplaceStarCfg == nil then
        self._heroReplaceStarCfg = getConfig("hero_star_id");
    end
    return self._heroReplaceStarCfg[id];
end

-- 获取觉醒星级id
function Lua_HeroUtil:getHeroAwakenStarId(quality, quality_star)
    if quality == nil then
        quality = 1;
    end
    quality_star = quality_star or 0;
    return quality * 100 + quality_star;
end

-- 通过觉醒星级id 获取觉醒星级（转化为原来的星级）
function Lua_HeroUtil:getHeroAwakenStar(id)
    if id == nil  then
        return 0;
    end
    local data = self:getHeroAwakenStarConfigInfo(id);
    if data == nil or data.change_id == nil then
        return 0;
    end
    return data.change_id;
end

-- 通过质量，质量星级 获取觉醒星级（转化为原来的星级）
function Lua_HeroUtil:getHeroAwakenStarByQuality(quality, quality_star)
    local id = self:getHeroAwakenStarId(quality, quality_star);
    return self:getHeroAwakenStar(id);
end


-- 通过质量，质量星级 获取英雄觉醒星级表
function Lua_HeroUtil:getHeroAwakenStarConfigByQuality(quality, quality_star)
    local id = self:getHeroAwakenStarId(quality, quality_star);
    return self:getHeroAwakenStarConfigInfo(id);
end

-- 英雄觉醒星级表
function Lua_HeroUtil:getHeroAwakenStarConfigInfo(id)
    if id == nil then
        return nil;
    end
    return getConfig("hero_awaken_star", id);
end

















---------------------------------- 英雄常量数据 -------------------------------------------

-- 背包大小
function Lua_HeroUtil.Get:pack_size()
    return getConfig("hero_const","pack_size","value");
end 

-- 快速升级
function Lua_HeroUtil.Get:rapid_upgrade()
    return getConfig("hero_const","rapid_upgrade","arr_value");
end

-- 基础属性
function Lua_HeroUtil.Get:hero_base_attr()
    return getConfig("hero_const","hero_base_attr","arr_value");
end

-- 特殊属性
function Lua_HeroUtil.Get:hero_special_attr()
    return getConfig("hero_const","hero_special_attr","arr_value");
end

-- 英雄的职业类型数量
function Lua_HeroUtil.Get:career_num()
    return getConfig("hero_const","career_num","value");
end 

-- 升星一键选择材料星级限制
function Lua_HeroUtil.Get:up_star_limit()
    if self._up_star_limit == nil then
        local up_star_limit = getConfig("hero_const","up_star_limit","arr_value");
        self._up_star_limit = self:getHeroAwakenStarByQuality(up_star_limit[1], up_star_limit[2]);
    end
    return self._up_star_limit;
end 

-- 快捷升星一键升星星级限制
function Lua_HeroUtil.Get:quick_up_star_limit()
    if self._quick_up_star_limit == nil then
        local quick_up_star_limit = getConfig("hero_const","quick_up_star_limit","arr_value");
        self._quick_up_star_limit = self:getHeroAwakenStarByQuality(quick_up_star_limit[1], quick_up_star_limit[2]);
    end
    return self._quick_up_star_limit;
end

-- 英雄升星材料不足跳转id
function Lua_HeroUtil.Get:hero_goto_itemid()
    return getConfig("hero_const","hero_goto_itemid","value");
end

-- 全部属性
function Lua_HeroUtil.Get:hero_all_attr()
    if self._hero_all_attr == nil then
        self._hero_all_attr = {};
        for i=1,#self.hero_base_attr do
            self._hero_all_attr[i] = self.hero_base_attr[i]; 
        end
        local index = #self._hero_all_attr
        for i=1,#self.hero_special_attr do
            index = index +i;
            self._hero_all_attr[index] = self.hero_special_attr[i]; 
        end
    end
    return self._hero_all_attr;
end

-- 万能英雄
function Lua_HeroUtil.Get:almighty_list()
    if self._almighty_list == nil then
        self._almighty_list = {};
        local list = getConfig("hero_const","almighty_list","arr_value");
        for i=1,#list do
            local tvo = Lua_ToolVo.new(list[i]);
            if tvo ~= nil then
                if self._almighty_list[tvo.campType] == nil then
                    self._almighty_list[tvo.campType] = {};
                end
                self._almighty_list[tvo.campType][tvo.star] = list[i];
            end
        end
    end
    return self._almighty_list;
end

-- 获取万能英雄id
function Lua_HeroUtil:getAlmightyId(camp, star)
    if self.almighty_list[camp] ~= nil and self.almighty_list[camp][star] ~= nil then
        return self.almighty_list[camp][star];
    end
    return nil;
end

-- 播放台词间隔
function Lua_HeroUtil.Get:play_line_interval()
    return getConfig("hero_const", "play_line_interval", "value") or 0;
end

-- 闪卡最大序号
function Lua_HeroUtil.Get:hero_card_max_serial()
    return getConfig("hero_const","hero_card_max_serial","value");
end

-- 显示直升等级限制
function Lua_HeroUtil.Get:show_button_lvl_limit()
    return getConfig("hero_const","show_button_lvl_limit","value");
end

-- 获取英雄阵营描述
function Lua_HeroUtil:getCampDic(camp)
    local list = getConfig("hero_const", "camp_des_list", "arr_value");

    local des = ""
    if list ~= nil then
        for i=1,#list do
            if list[i][1] == camp then
                des = list[i][2];
                break;
            end
        end
    end

    return des;
end

-- 获取英雄阵营克制数据
function Lua_HeroUtil:getShowCampInfo(camp)
    local list = getConfig("hero_const", "camp_restrain_list", "arr_value");

    local list1 = {};
    local list2 = {};
    if list ~= nil then
        for i=1,#list do
            if list[i][1] == camp then
                list1 = list[i][2];
                list2 = list[i][3];
                break;
            end
        end
    end

    return list1, list2;
end








---------------------------------- 英雄评论-------------------------------------------

-- 英雄评论字数限制
function Lua_HeroUtil.Get:hero_comment_limit()
    return getConfig("hero_const","hero_comment_limit","value");
end

-- 英雄评论点赞间隔
function Lua_HeroUtil.Get:hero_comment_time()
    return getConfig("hero_const","hero_comment_time","value");
end





---------------------------------- 英雄回退-------------------------------------------

-- -- 回退最低星级
function Lua_HeroUtil.Get:rebuild_limit() 
    if self._rebuild_limit == nil then
        local rebuild_limit = getConfig("hero_const","rollback_limit","arr_value");
        self._rebuild_limit = self:getHeroAwakenStarByQuality(rebuild_limit[1][1], rebuild_limit[1][2]);
    end
    return self._rebuild_limit;
end

-- 回退最高星级
function Lua_HeroUtil.Get:rollback_high()
    if self._rollback_high == nil then
        local rollback_high = getConfig("hero_const","rollback_high","arr_value");
        self._rollback_high = self:getHeroAwakenStarByQuality(rollback_high[1], rollback_high[2]);
    end
    return self._rollback_high;
end

-- 回退Tips按钮倒计时
function Lua_HeroUtil.Get:rebuild_time()
    return getConfig("hero_const","rebuild_time","value");
end

-- 每日回退次数
function Lua_HeroUtil.Get:rollback_num()
    return getConfig("hero_const","rollback_num","value");
end





---------------------------------- 英雄流放-------------------------------------------

-- 最多一次流放数量
function Lua_HeroUtil.Get:cancle_number()
    return getConfig("hero_const", "cancle_number", "value");
end

-- 英雄可流放最大星级
function Lua_HeroUtil.Get:decompose_max_star()
    if self._decompose_max_star == nil then
        local decompose_max_star = getConfig("hero_const","decompose_max_star","arr_value");
        self._decompose_max_star = self:getHeroAwakenStarByQuality(decompose_max_star[1], decompose_max_star[2]);
    end
    return self._decompose_max_star;
end




---------------------------------- 英雄置换-------------------------------------------

--可置换的最低星级
function Lua_HeroUtil.Get:replace_star()
    return getConfig("hero_const","replace_star","value");
end

--回退资源材料比例
function Lua_HeroUtil.Get:rebuild_ratio()
    return getConfig("hero_const","rebuild_ratio","float_value");
end





---------------------------------- 英雄重修 -------------------------------------------

-- 每日重修次数
function Lua_HeroUtil.Get:rebuild_times()
    return getConfig("hero_const","rebuild_bout","value");
end

-- 当前英雄重修后下次重修时间
function Lua_HeroUtil.Get:rebuild_next_time()
    return getConfig("hero_const","rebuild_NextTime","value");
end

-- 重修确定tips倒计时
function Lua_HeroUtil.Get:rebuild_down_time()
    return getConfig("hero_const","rebuild_down_time","value");
end

-- 重修消耗
function Lua_HeroUtil:rebuild_money(level)
    if self._rebuild_money == nil then
        self._rebuild_money = getConfig("hero_const","rebuild_money","arr_value");
    end
    for i=1,#self._rebuild_money do
        local min_lvl = self._rebuild_money[i][1];
        local max_lvl = self._rebuild_money[i][2];
        if level >= min_lvl and level <= max_lvl then
            return self._rebuild_money[i][3];
        end
    end

    return 0;
end






---------------------------------- 英雄栏扩展消耗 -------------------------------------------

-- 英雄栏扩展消耗数据
function Lua_HeroUtil:getBagCostVoById(id)
    if self._bagCosConfig == nil then
        self._bagCosConfig = getConfig("hero_bag_cost");
    end
    return self._bagCosConfig[id];
end












---------------------------------- 英雄页签 -------------------------------------------

-- 英雄页签数据
function Lua_HeroUtil:heroTabInfo()
    if self._heroTabInfo == nil then
        self.heroTabDic = {};
        self._heroTabInfo = Array();
        local list = getConfig("hero_tab");
        local vo;
        for k,v in ipairs(list) do
            vo = Lua_HeroTabVo.new(tonumber(k),v);
            self._heroTabInfo:add(vo);
            self.heroTabDic[k] = vo;
        end
        self._heroTabInfo:sort("sort",false);
    end
    return self._heroTabInfo;
end

-- 获取页签vo
function Lua_HeroUtil:getHeroTabVoById(id)
    if self.heroTabDic == nil then
        self:heroTabInfo();
    end
    return self.heroTabDic[id];
end

function Lua_HeroUtil:updateTabInfo(hvo, selectId, isShowAtlasTab)
    selectId = selectId == nil and 1 or selectId;
    local tabVo;
    local index = 0;
    local curSelectIdx = 1;--当前选中的id的列表索引（默认为1）
    local curSelectTabId = 1;--当前选中的id（默认为1）
    local arr = Array();
    local tabInfo = self:heroTabInfo();
    local limit_star;
    for i = 1, tabInfo:getSize() do
        tabVo = tabInfo[i];
        limit_star = self:getHeroAwakenStarByQuality(tabVo.condition1, tabVo.condition3);
        local showTabState = true;--页签显隐状态
        if isShowAtlasTab == true then--图鉴
            if tabVo.isShowAtlas == 1 and tabVo.tab_shield == 0  then
                tabVo.showRedDotState = false;
                tabVo.showGrayState = false;
                if tabVo.tab_show == 0 then--需要条件开启
                    if hvo.star >= limit_star and hvo.level >= tabVo.condition2 then
                        showTabState = true;
                        if tabVo.id == 6 then -- 神兵
                            if not showGrayState then
                                showTabState = hvo.weaponId > 0;
                            else
                                showTabState = false;
                            end
                        end
                    else
                        showTabState = false;
                    end
                end
                if showTabState then
                    index = index + 1;
                    if selectId == tabVo.id then
                        curSelectIdx = index;
                        curSelectTabId = tabVo.id;
                    end
                    arr:add(tabVo);
                end
            end
        else
            local showTipsDes = "";--提示描述
            local showGrayState = false;--置灰状态

            --页签状态处理
            if tabVo.tab_shield == 0 then--不需要屏蔽
                if tabVo.tab_show == 0 then--需要条件开启
                    if hvo.star >= limit_star and hvo.level >= tabVo.condition2 then
                        showGrayState = false;--满足条件，不需要置灰
                    else
                        showGrayState = true;
                    end

                    if tabVo.tab_advance == 1 then--需要预告
                        if tabVo.id == 6 then -- 神兵
                            showTabState = hvo.weaponId > 0
                        else
                            showTabState = true;
                        end
                    else
                        if tabVo.id == 6 then -- 神兵
                            if not showGrayState then
                                showTabState = hvo.weaponId > 0
                            else
                                showTabState = false
                            end
                        else
                            showTabState = not showGrayState;
                        end
                    end
                else
                    if tabVo.id == 3 then --升星
                        if hvo.trial_state == true then--英雄试用状态
                            showGrayState = true;
                            showTipsDes = LanUtil.getValue(126218);
                        end
                    end
                    showTabState = true;
                end
            else--页签屏蔽
                showTabState = false;
            end
            tabVo.showTipsDes = showTipsDes;
            tabVo.showTabState = showTabState;
            tabVo.showGrayState = showGrayState;

            if showTabState then
                index = index + 1;
            end
            -- 红点处理
            local showRedDotState = false;--红点状态
            if showTabState == true and showGrayState == false then
                if selectId == tabVo.id then
                    curSelectIdx = index;
                    curSelectTabId = tabVo.id;
                end
                --红点处理
                if hvo.isShowFight == true then--主线阵容
                    if tabVo.id == 1 then--升级
                        showRedDotState = hvo.heroUpgradeVo.heroUpgradeReddot;
                    elseif tabVo.id == 3 then --升星
                        showRedDotState = DataCenter.heroData.redDotOnClickStateDic[hvo.unique_id] and DataCenter.heroUpStarData:checkUpStarRedDot(hvo);
                    elseif tabVo.id == 4 then --皮肤
                        showRedDotState = DataCenter.heroData:checkFashionRedDot(hvo);
                    elseif tabVo.id == 5 then --觉醒
                        showRedDotState = false;
                    end
                else
                    if tabVo.id == 1 and DataCenter.lifeTreeData:getGridIndexByUid(hvo.unique_id) ~= nil then--在同调器中的英雄 升级
                        showRedDotState = hvo.heroUpgradeVo.heroUpgradeReddot;
                    end
                end
                if tabVo.id == 2 then --装备
                    if showRedDotState == false then
                        showRedDotState = DataCenter.equipData:checkEquipRedDotState(hvo.unique_id);--装备
                    end
                    if showRedDotState == false then
                        showRedDotState = DataCenter.runesData:checkRunesRedDotState(hvo);--符石
                    end
                end
                if tabVo.id == 6 then -- 神兵
                    showRedDotState = DataCenter.heroData:checkWeaponRedPoint(hvo)
                end
            end

            if hvo.trial_state then -- 试用状态处理
                showRedDotState = false;
            end
            tabVo.showRedDotState = showRedDotState;

            if showTabState == true then
                arr:add(tabVo);
            end
        end
    end

    return arr, curSelectIdx,curSelectTabId;
end






---------------------------------- 外部接口 -------------------------------------------
--根据星级或者阵容获取明星id列表
function Lua_HeroUtil:getHeroIdArr(star, camp)
    if self._heroIdList == nil then
        self._heroIdList = {};
        self._heroIdStarList = {};
        self._heroIdCampList = {};
        local config = getConfig("hero");
        for k, v in pairs(config) do
            if v.is_shield ~= 1 and v.is_monster ~= 1 then--未屏蔽/是英雄
                if self._heroIdList[v.initial_star] == nil then
                    self._heroIdList[v.initial_star] = {};
                    self._heroIdStarList[v.initial_star] = Array();
                end
                if self._heroIdList[v.initial_star][v.camp] == nil then
                    if self._heroIdCampList[v.camp] == nil then
                        self._heroIdCampList[v.camp] = Array();
                    end
                    self._heroIdList[v.initial_star][v.camp] = Array();
                end
                self._heroIdList[v.initial_star][v.camp]:add(k);
                self._heroIdStarList[v.initial_star]:add(k);
                self._heroIdCampList[v.camp]:add(k);
            end
        end
    end

    if star == nil then
        return self._heroIdCampList[camp];
    elseif camp == nil then
        return self._heroIdStarList[star];
    else
        return self._heroIdList[star][camp];
    end
end


------------------------------ 英雄觉醒 ------------------------------

-- -- 觉醒栏解锁所需的觉醒等级
-- function Lua_HeroUtil.Get:awaken_column_unlock()
--     if self._awaken_column_unlock == nil then
--         self._awaken_column_unlock = getConfig("hero_const", "awaken_column_unlock", "arr_value");
--     end
--     return self._awaken_column_unlock;
-- end

-- -- 觉醒最高等级
-- function Lua_HeroUtil.Get:awaken_max_level()
--     if self._awaken_max_level == nil then
--         self._awaken_max_level = getConfig("hero_const", "awaken_max_level", "value");
--     end
--     return self._awaken_max_level;
-- end

-- function Lua_HeroUtil:getAwakenConfig(id)
--     return getConfig("hero_awaken", id);
-- end

-- function Lua_HeroUtil:getAwakenTypeArr(awaken_id, recom_awake)
--     local arr = Array();
--     local config = getConfig("hero_awaken_type");
--     local awakenCfg;
--     for k,v in pairs(config) do
--         if awaken_id == nil or awaken_id <= 0 then
--             arr:add({ id = k, bRecom = k == recom_awake });
--         else
--             awakenCfg = self:getAwakenConfig(awaken_id);
--             arr:add({ id = k, bUseing = k == awakenCfg.type });
--         end
--     end
--     return arr;
-- end

-- function Lua_HeroUtil:getAwakenTypeVo(id, config)
--     if id == nil or id <= 0 then
--         return nil;
--     end

--     if self.awakenTypeDic == nil then
--         self.awakenTypeDic = {};
--     end
--     if self.awakenTypeDic[id] == nil then
--         self.awakenTypeDic[id] = Lua_HeroAwakenTypeVo.new(id, config);
--     end
--     return self.awakenTypeDic[id];
-- end













---------------------------------- 英雄神兵 -------------------------------------------
function Lua_HeroUtil:getHeroWeaponVo(id)
    if self.weaponDic == nil then
        self.weaponDic = {};
    end
    if self.weaponDic[id] == nil then
       local config = getConfig("hero_weapon", id);
        if config == nil then
            return nil;
        end
        self.weaponDic[id] = Lua_HeroWeaponVo.new(id, config);
    end
    return self.weaponDic[id];
end

function Lua_HeroUtil.Get:weapon_unlock_star()
    if self._weapon_unlock_star == nil then
        local weapon_unlock_star = getConfig("hero_const","weapon_unlock_star","arr_value");
        self._weapon_unlock_star = self:getHeroAwakenStarByQuality(weapon_unlock_star[1], weapon_unlock_star[2]);
    end
    return self._weapon_unlock_star;
end

-- (基础属性值 * 基础属性评分系数) + 特殊属性固定评分 + 技能固定评分
function Lua_HeroUtil:calcWeaponScore(config, score)
    local value = 0
    local vo
    -- for k,v in pairs(config.prop) do
    --     vo = DataCenter.attributesUtil:createAttrVo(k)
    --     value = value + vo.weapon_coefficient * v
    --     value = value + vo.weapon_fixed
    -- end
    -- value = Mathf.Floor(value + 0.5) -- 四舍五入
    for i = 1, #config.skill do
        vo = Lua_SkillConfigData.getConfigData(config.skill[i])
        value = value + vo.grade
    end
    return value + score
end






---------------------------------------- 新英雄功能开启 ----------------------------------------
function Lua_HeroUtil:getNewHeroFuncOpenState(heroId, operateType)
	local id;
	if operateType == Lua_NewHeroFuncOpen.atlas then
		id = getConfig("hero_function_open", heroId, "atlas");
	elseif operateType == Lua_NewHeroFuncOpen.dress then
		id = getConfig("hero_function_open", heroId, "dress");
	elseif operateType == Lua_NewHeroFuncOpen.hero_palace then
		id = getConfig("hero_function_open", heroId, "hero_palace");
	elseif operateType == Lua_NewHeroFuncOpen.collection_book then
		id = getConfig("hero_function_open", heroId, "collection_book");
	elseif operateType == Lua_NewHeroFuncOpen.advance_recruit then
		id = getConfig("hero_function_open", heroId, "advance_recruit");
	elseif operateType == Lua_NewHeroFuncOpen.item then
		id = getConfig("hero_function_open", heroId, "item");
	elseif operateType == Lua_NewHeroFuncOpen.mail then
		id = getConfig("hero_function_open", heroId, "mail");
	elseif operateType == Lua_NewHeroFuncOpen.transaction then
		id = getConfig("hero_function_open", heroId, "transaction");
	end

	if id then
		local configOpenDay = getConfig("hero_function_open_cond", id, "open_day");
		return configOpenDay <= DataCenter.roleData.open_days, configOpenDay;
	end
	return true, 0;
end