Lua_HeroAssemblyData = class("Lua_HeroAssemblyData")
function Lua_HeroAssemblyData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_HeroAssemblyData:dispose()
	self.selectHeroVo = nil;--记录选择的明星Vo

	self.oneKeyUpStarUidList = {};--记录一键升星所有使用过的唯一id
	self.oneKeyUpStarCostInfo = {};--一键升星所有消耗材料信息
	self.oneKeyUpStarVoArr = Array();--一键升星本体材料Vo(界面显示)
	self.oneKeyUpStarSubVoList = {};--一键升星子材料Vo(界面显示)
	self.onKeySelectUidList = {};--一键升星选择的主体唯一id

	self.decomposeUidList = {};--流放明星的唯一id列表
	self.decomposeCount = 0;---流放明星数量
	self._removeLineupStateDic = nil;--记录上阵英雄选中状态

	self.replacementSelectList = {};--置换材料选择
	self.selectReplacementCostNum = 0;--材料选择数量
	self.replacementCostHeroVo = nil;--消耗材料的id
end

function Lua_HeroAssemblyData:fromServer80183001(msg)
	self.rollbackState = msg.rollback_state;--回退功能开启状态 0：未开启， 1：已开启
	self.replaceState = msg.replace_state;--置换功能开启状态 0：未开启， 1：已开启
	self.cancellingState = msg.cancelling_state;--自动流放功能开启状态 0：未开启， 1：已开启
	self.rollbackTime = msg.rollback_time;  -- 今日回退次数
	Lua_MsgUtil.callFunc("UPDATE_HEROASSEMBLY_STATE");
end

function Lua_HeroAssemblyData:fromServer80183002(msg)
	if self.autoDecoItemDic == nil then
		self.autoDecoItemDic = {};
	end
	DataCenter.packData:getRewardDic(msg.item_list, self.autoDecoItemDic)
end

------------------------------------快捷升星------------------------------------

--获取明星已选择材料的数量
function Lua_HeroAssemblyData.Get:getCurHeroSelectedNum()
	local num = 0;
	if self.selectHeroVo ~= nil then
		local info = self.selectHeroVo.heroUpStarVo.speedyCostHeroInfo;
		for i = 1, info:getSize() do
			num = num + info[i].selectHeroNum;
		end
	end
	return num;
end

--当前选择明星是否能升星
function Lua_HeroAssemblyData.Get:isCurHeroCanUpStar()
	return self.getCurHeroSelectedNum >= self.selectHeroVo.heroUpStarVo.config.speed_all_num;
end

--初始化一键升星的所有数据
function Lua_HeroAssemblyData:initOneKeyUpStarAllInfo()
	self.oneKeyUpStarUidList = {};--记录一键升星所有使用过的唯一id
	self.oneKeyUpStarCostInfo = {};--一键升星消耗材料信息
	self.oneKeyUpStarVoArr = Array();--一键升星本体材料Vo(界面显示)
	self.oneKeyUpStarSubVoList = {};--一键升星子材料Vo(界面显示)
	self.onKeySelectUidList = {};--一键升星选择的主体唯一id

	local star_limit = DataCenter.heroUtil.quick_up_star_limit;
	local arr = DataCenter.heroAssemblyUtil:getUpStarInfoByCampType(Lua_HeroUtil.All_TYPE);
	for i = 1, arr:getSize() do
		if arr[i].heroVo.star <= star_limit then
			self:initOneKeyCostInfo(arr[i].getUpStarMeetTime, arr[i].heroVo);
		end
	end
end

--初始化一键升星材料选择
function Lua_HeroAssemblyData:initOneKeyCostInfo(upStarMeetTime, heroVo)
	if upStarMeetTime <= 0 then return end

	for i = 1, upStarMeetTime do
		local selectHeroUid;--本体唯一id
		local isCanSelect;
		local select_num;
		local needNum;
		local info = heroVo.heroUpStarVo.oneKeyCostHeroInfo;--一键升星材料
		local hvo;
		for j = 1, info:getSize() do
			select_num = 0;
			needNum = info[j].needNum;
			local heroUidArr = DataCenter.heroData:getHeroUidArrByStar(info[j].star);
			for k = 1, heroUidArr:getSize() do
				if select_num >= needNum then
					break;
				end

				local unique_id = heroUidArr[k];
				if self.oneKeyUpStarUidList[unique_id] ~= 1 then
					hvo = DataCenter.heroData:getItemByUniqueId(unique_id);

					isCanSelect = false;
					if info[j].id ~= 0 then
						if hvo.isSpecialState == false and hvo.id == info[j].id and hvo.campType == info[j].campType and hvo.star == info[j].star and hvo.is_league_transaction == false and not hvo.trial_state then
							isCanSelect = true;
						end
					else
						if hvo.isSpecialState == false and hvo.campType == info[j].campType and hvo.star == info[j].star and hvo.is_league_transaction == false and not hvo.trial_state then
							isCanSelect = true;
						end
					end

					if isCanSelect then
						select_num = select_num + 1;
						self.oneKeyUpStarUidList[unique_id] = 1;

						if j == 1 then
							selectHeroUid = unique_id;
							self.onKeySelectUidList[unique_id] = 1;
							self.oneKeyUpStarVoArr:add(hvo);
						end

						if self.oneKeyUpStarCostInfo[selectHeroUid] == nil then
							self.oneKeyUpStarCostInfo[selectHeroUid] = {};
						end
						if self.oneKeyUpStarCostInfo[selectHeroUid][j] == nil then
							self.oneKeyUpStarCostInfo[selectHeroUid][j] = {};
						end
						self.oneKeyUpStarCostInfo[selectHeroUid][j][unique_id] = 1;

						if self.oneKeyUpStarSubVoList[selectHeroUid] == nil then
							self.oneKeyUpStarSubVoList[selectHeroUid] = Array();
						end
						if j ~= 1 then
							self.oneKeyUpStarSubVoList[selectHeroUid]:add(hvo);
						end
					end
				end
			end

			if select_num < needNum then
				if selectHeroUid ~= nil then
					hvo = self.oneKeyUpStarVoArr:remove(self.oneKeyUpStarVoArr:getSize());
					self.onKeySelectUidList[hvo.unique_id] = nil;
					self.oneKeyUpStarCostInfo[selectHeroUid] = nil;
					self.oneKeyUpStarSubVoList[selectHeroUid] = nil;
				end
				return;
			end
		end
	end
end

--获取一键升星的界面数据
function Lua_HeroAssemblyData.Get:getOneKeyUpStarShowArr()
	local arr = Array();
	for k, v in pairs(self.oneKeyUpStarVoArr) do
		arr:add(v);
	end
	return arr;
end





























------------------------------------英雄流放------------------------------------

--更新单个流放英雄选择
function Lua_HeroAssemblyData:setDecomposeUidListBySelect(uid)
	if self.decomposeUidList[uid] ~= 1 then
		if self.decomposeCount < 15 then
			self.decomposeUidList[uid] = 1;
			self.decomposeCount = self.decomposeCount + 1;
		end
	else
		self.decomposeUidList[uid] = nil;
		self.decomposeCount = self.decomposeCount - 1;
	end
end

--更新流放英雄选择
function Lua_HeroAssemblyData:initDecomposeUidList()
	self.decomposeUidList = {};
	self.decomposeCount = 0;
end

--记录已解除上阵状态的英雄Uid
function Lua_HeroAssemblyData.Get:removeLineupStateDic()
    if self._removeLineupStateDic == nil then
        self._removeLineupStateDic = {};
    end

    return self._removeLineupStateDic;
end

-- 选择的英雄所在的阵容和已选择的英雄所在的阵容数量 > 所在阵容的数量才可以下阵
function Lua_HeroAssemblyData:checkLineupNumState(select_uid)
    if self.decomposeUidList == nil or select_uid == nil then
        return true;
    end

    
    local hvo;
    local config;
    local lineupList = {};
    for uid, v in pairs(self.decomposeUidList) do
        if v >= 1 then
            hvo = DataCenter.heroData:getItemByUniqueId(uid);
            if hvo.lineupDic ~= nil then
                for lineup_type, vul in pairs(hvo.lineupDic) do
	            	config = getConfig("hero_camp_lineup", lineup_type);
		            if config ~= nil and config.can_cancel == 1 then
	                    if lineupList[lineup_type] == nil then
	                        lineupList[lineup_type] = 1;
	                    else
	                        lineupList[lineup_type] = lineupList[lineup_type] +1;
	                    end
	                end
                end
            end
        end
    end

    hvo = DataCenter.heroData:getItemByUniqueId(select_uid);
    if hvo ~= nil and hvo.lineupDic ~= nil then
        for lineup_type, vul in pairs(hvo.lineupDic) do
            config = getConfig("hero_camp_lineup", lineup_type);
            if config ~= nil and config.can_cancel == 1 then
	            if lineupList[lineup_type] == nil then
	                lineupList[lineup_type] = 1;
	            else
	                lineupList[lineup_type] = lineupList[lineup_type] +1;
	            end

	            if lineupList[lineup_type] >= DataCenter.heroLineupData:getLineupHeroTotalNum(lineup_type) then
	                return false, config.name;
	            end
	        end
        end
    end

    return true;
end

--根据阵容排序流放英雄列表
function Lua_HeroAssemblyData:sortDecomposeHeroArr(campType)
	local _arr = DataCenter.heroData.allHeroUidArr;
	local heroVo, openState, openDay;
	local arr = Array();
	for i = 1, _arr:getSize() do
		heroVo = DataCenter.heroData:getItemByUniqueId(_arr[i]);
		openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(heroVo.id, Lua_NewHeroFuncOpen.dress); -- 达到开服天数限制才显示
		if heroVo.star <= DataCenter.heroUtil.decompose_max_star
			and (campType == Lua_HeroUtil.All_TYPE or heroVo.campType == campType)
			and heroVo.is_league_transaction == false and not heroVo.trial_state
			and openState then
				arr:add(_arr[i]);
		end
	end
	self:decomposeSort(arr);
	return arr;
end

--流放英雄数组排序
function Lua_HeroAssemblyData:decomposeSort(arr)
    local len = arr:getSize();
    if len <= 1 then
        return;
    end

    for i = 1, len do
        for j = i + 1, len do
            local a = DataCenter.heroData:getItemByUniqueId(arr[i]).decomposeSort;
            local b = DataCenter.heroData:getItemByUniqueId(arr[j]).decomposeSort;
            if a > b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end

--流放英雄快速选择
function Lua_HeroAssemblyData:fastDecomposeSelect(arr)
	for i = 1, arr:getSize() do
		local unique_id = arr[i];
		local vo = DataCenter.heroData:getItemByUniqueId(unique_id);

		if self.decomposeCount >= 15 then
			return;
		end

		if self.decomposeUidList[unique_id] ~= 1 and vo.star <= 3 and not vo.lock_state and not vo.isUpLineup and not vo.is_resonance then
			self:setDecomposeUidListBySelect(unique_id);
		end
	end
end

--判断流放列表中是否有6星集以上英雄
function Lua_HeroAssemblyData.Get:isExitHeroSixStar()
	for k, v in pairs(self.decomposeUidList) do
		local vo = DataCenter.heroData:getItemByUniqueId(k);
		if vo.star >= 6 then
			return true;
		end
	end
	return false;
end


--获取流放返回的经验
function Lua_HeroAssemblyData.Get:getDecomposeExpArr()
	local vo;
	local cfgData;
	local info = {};
	for k, v in pairs(self.decomposeUidList) do
		if v == 1 then
			vo = DataCenter.heroData:getItemByUniqueId(k);
			cfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(vo.awaken_star_id);
			if cfgData ~= nil and cfgData.resource ~= nil then
				local resource_list = cfgData.resource;
				for i = 1, #resource_list do
					if info[resource_list[i][1]] == nil then
						info[resource_list[i][1]] = 0;
					end
					info[resource_list[i][1]] = info[resource_list[i][1]] + resource_list[i][2];
				end
			end

			local rebuild_list = vo.heroUpgradeVo.rebuildMaterialsInfo;
			if rebuild_list ~= nil then
				for i = 1, #rebuild_list do
					if info[rebuild_list[i][1]] == nil then
						info[rebuild_list[i][1]] = 0;
					end
					info[rebuild_list[i][1]] = info[rebuild_list[i][1]] + rebuild_list[i][2];
				end
			end
		end
	end

	local arr = Array();
	for k, v in pairs(info) do
		arr:add({id = k, num = v});
	end
	return arr;
end

function Lua_HeroAssemblyData:showAutoDecomposeReward()
	local arr;
	if self.autoDecoItemDic ~= nil then
		arr = DataCenter.packData:getRewardList(self.autoDecoItemDic);
		self.autoDecoItemDic = nil;
	end
	if arr ~= nil and arr:getSize() > 0 then
		Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, arr);
	end
end

-- 策划新增需求：小卖部使用钻石招募时，有特殊奖励（经验等）需与流放奖励共同展示
-- 故 将特殊奖励存储于self.autoDecoItemDic中
function Lua_HeroAssemblyData:addRewardInAutoDecoItemDic(rewardList)
	if self.autoDecoItemDic == nil then
		self.autoDecoItemDic = {};
	end
	DataCenter.packData:getRewardDic(rewardList, self.autoDecoItemDic)
end

































































------------------------------------英雄置换------------------------------------

--获取置换的英雄列表
function Lua_HeroAssemblyData:getReplacementHeroArr(campType)
	local arr = Array();
	local replaceStar = DataCenter.heroUtil.replace_star;
	local uidDic = DataCenter.heroData.heroStarDic;
	for k, v in pairs(uidDic) do
		if k >= replaceStar then
			local uidArr = DataCenter.heroData:getHeroUidArrByStar(k);
			local length = uidArr:getSize();
			if length > 0 then
				for j = 1, length do
					local vo = DataCenter.heroData:getItemByUniqueId(uidArr[j]);
					if campType == Lua_HeroUtil.All_TYPE or vo.campType == campType and vo.is_league_transaction == false and not vo.trial_state then
						arr:add(vo);
					end
				end
			end
		end
	end
	arr:sortf(self, self.sortReplacementArr);
	return arr;
end

function Lua_HeroAssemblyData:sortReplacementArr(a, b)
	if a.star > b.star or a.campType > b.campType then
		return false;
	end
	return true;
end

--获取置换的英雄材料列表
function Lua_HeroAssemblyData.Get:getReplacementSelectArr()
	local arr = Array();
	local uidArr = DataCenter.heroData:getHeroUidArrByStar(5);
	for i = 1, uidArr:getSize() do
		local vo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
		if self.selectHeroVo.campType == vo.campType and self.selectHeroVo.id ~= vo.id and vo.initial_star == 5 and vo.is_league_transaction == false and not vo.trial_state then
			if self.selectHeroVo.star <= 9 then
				arr:add(vo);
			else
				if vo.rarity >= 5 then
					arr:add(vo);
				end
			end
		end
	end
	arr:sortf(self, self.sortReplacementSelect);
	return arr;
end

--排序置换的英雄材料列表
function Lua_HeroAssemblyData:sortReplacementSelect(a, b)
	if a.id > b.id then
		return false;
	end
	return true;
end

--获取置换的英雄材料最大选择数
function Lua_HeroAssemblyData.Get:getReplacementMaxNum()
	local num = 0;
	if self.selectHeroVo ~= nil then
		num = DataCenter.heroUtil:replaceConfig(self.selectHeroVo.star).target_hero_num;
	end
	return num;
end

--获取置换消耗资源信息
-- function Lua_HeroAssemblyData.Get:getReplacementCostInfo()
-- 	local star = 8;
-- 	if self.selectHeroVo ~= nil then
-- 		star = self.selectHeroVo.star;
-- 	end
-- 	return DataCenter.heroUtil:replaceConfig(star).cost[1];
-- end

--判断是否能继续添加材料
function Lua_HeroAssemblyData.Get:isMaxLimit()
	return self.selectReplacementCostNum >= self.getReplacementMaxNum;
end

--选择消耗材料
function Lua_HeroAssemblyData:selectReplacementCost(uid)
	if self.replacementSelectList[uid] ~= 1 then
		self.replacementSelectList[uid] = 1;
		self.selectReplacementCostNum = self.selectReplacementCostNum + 1;
	else
		self.replacementSelectList[uid] = nil;
		self.selectReplacementCostNum = self.selectReplacementCostNum - 1;
	end
end

--重置置换数据
function Lua_HeroAssemblyData:clearReplacementInfo()
	self.replacementSelectList = {};--置换材料选择
	self.selectReplacementCostNum = 0;--材料选择数量
	self.replacementCostHeroVo = nil;--消耗材料的id
end

--材料消耗返回
function Lua_HeroAssemblyData.Get:rebuildCostArr()
	local costList = {};
	local costVoArr = Array();
	for k, v in pairs(self.replacementSelectList) do
		if v == 1 then
			local vo = DataCenter.heroData:getItemByUniqueId(k);
			if vo.level > 1 then
				local levelInfo = DataCenter.heroUtil:getHeroLevelCostConfig(vo.level);
				for m, n in pairs(levelInfo.rebuild_exp) do
					if costList[n[1]] == nil then
						costList[n[1]] = 0;
					end
					costList[n[1]] = costList[n[1]] + n[2];
				end
			end
		end
	end

	for k, v in pairs(costList) do
		local vo = Lua_ToolVo.createToolVo(k, v);
		costVoArr:add(vo);
	end
	return costVoArr;
end