checkRequire("Lua_HeroFastUpStarVo");
Lua_HeroAssemblyUtil = class("Lua_HeroAssemblyUtil");
Lua_HeroAssemblyUtil.heroId = 101000904;
Lua_HeroAssemblyUtil.sceneId = 40112;
function Lua_HeroAssemblyUtil:ctor()
	self:superCall("ctor");
    self:dispose();
end

function Lua_HeroAssemblyUtil:dispose()
    self._upStarActiveNumDic = nil;
end

------------------------------------快捷升星------------------------------------

function Lua_HeroAssemblyUtil:init()
	if self.bInit == nil or self.bInit == false then
		self.bInit = true;
		self.upStarInfoDic = {};
		self.upStarInfoArr = Array();
		local config = getConfig("hero_speedy");
		local vo;
		for k,v in pairs(config) do
			vo = Lua_HeroFastUpStarVo.new(k, v);
			self.upStarInfoDic[k] = vo;
			self.upStarInfoArr:add(k);
		end
	end
end

function Lua_HeroAssemblyUtil:getUpStarInfoByCampType(campType)
	self:init();
	local arr = Array();
	local len = self.upStarInfoArr:getSize();
	local uid, vo, openState, openDay;
	for i = 1, len do
		uid = self.upStarInfoArr[i];
		vo = self.upStarInfoDic[uid];
		openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(vo.hero_id, Lua_NewHeroFuncOpen.dress); -- 达到开服天数限制才显示
		if (campType == Lua_HeroUtil.All_TYPE or vo.heroVo.campType == campType) and openState then
			arr:add(vo);
		end
	end

	arr:sort("sort", false);
	return arr;
end

function Lua_HeroAssemblyUtil:getUpStarCampRedDot(campType)
	self:init();
	local len = self.upStarInfoArr:getSize();
	local uid;
	local vo;
	for i = 1, len do
		uid = self.upStarInfoArr[i];
		vo = self.upStarInfoDic[uid];
		if campType == Lua_HeroUtil.All_TYPE or vo.heroVo.campType == campType then
			if vo.isCanUpStar then
				return true;
			end
		end
	end
	
	return false;
end

--能否默认一键升星
function Lua_HeroAssemblyUtil.Get:isCanOneKeyUpStar()
	self:init();
	local star_limit = DataCenter.heroUtil.quick_up_star_limit;
	for i = 1, self.upStarInfoArr:getSize() do
		uid = self.upStarInfoArr[i];
		vo = self.upStarInfoDic[uid];
		if vo.isCanUpStar and vo.heroVo.star <= star_limit then
			return true;
		end
	end
	return false;
end

--是否存在能升星的公式
function Lua_HeroAssemblyUtil.Get:isExitUpStar()
	self:init();
	local openState, openDay;
	for i = 1, self.upStarInfoArr:getSize() do
		uid = self.upStarInfoArr[i];
		vo = self.upStarInfoDic[uid];
		openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(vo.hero_id, Lua_NewHeroFuncOpen.dress); -- 达到开服天数限制才显示
		if vo.isCanUpStar and openState then
			return true;
		end
	end
	return false;
end

--记录快捷升星英雄升星可选择材料数量（避免多次排序影响性能）[hid] = num
function Lua_HeroAssemblyUtil.Get:upStarActiveNumDic()
	if self._upStarActiveNumDic == nil then
		self._upStarActiveNumDic = {};
	end

	return self._upStarActiveNumDic;
end








------------------------------------英雄回退------------------------------------

--获取回退的英雄列表
function Lua_HeroAssemblyUtil:getReshapeHeroArr(campType)
	local uidDic = DataCenter.heroData.heroStarDic;
	local vo, openState, openDay;
	local arr = Array();
	for k, v in pairs(uidDic) do
		hvo = DataCenter.heroData:getItemByUniqueId(v);
		if k >= DataCenter.heroUtil.rebuild_limit and k <= DataCenter.heroUtil.rollback_high then
			for j = 1, v:getSize() do
				vo = DataCenter.heroData:getItemByUniqueId(v[j]);
				-- 达到开服天数限制才显示
				openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(vo.id, Lua_NewHeroFuncOpen.hero_palace);
				if (campType == Lua_HeroUtil.All_TYPE or vo.campType == campType) and not vo.is_league_transaction and openState and not vo.trial_state then
					arr:add(vo);
				end
			end
		end
	end
	arr:sort("decomposeSort", false);
	return arr;
end
