-- 英雄图鉴数据
checkRequire("Lua_HeroAtlasVo");
Lua_HeroAtlasData = class("Lua_HeroAtlasData");
function Lua_HeroAtlasData:ctor()
    self:superCall("ctor");
    self:dispose()
end

function Lua_HeroAtlasData:dispose()
    self.heroIdDic = nil;--英雄id集合 list[hero_id] = atlas_id
    self.heroAtlasDic = nil;--图鉴数据
    self.heroActivateDic = nil;--英雄激活id状态 list[hero_id] = bool

    self.heroAtlasArr = nil;
    self.raritallDic = nil;
    self.raritCampDic = nil;
    self.raritIndexDic = nil;
    self.raritAllIndexDic = nil;
end

function Lua_HeroAtlasData:getheroAtlasDic() -- 英雄图鉴配置
    if self.heroAtlasDic == nil then
        self.heroIdDic = {};
        self.heroAtlasDic = {};
        local avo;
        local arr =  Array();
        local cfg = getConfig("hero_atlas");
        for k,v in pairs(cfg) do
            if v.isShow == 1 then
                avo = Lua_HeroAtlasVo.new(k,v);
                self.heroAtlasDic[k] = avo;
                self.heroIdDic[v.hero_id] = k;
                arr:add(k);
            end
        end
        self:sortAtlas(arr);
    end
end

function Lua_HeroAtlasData:sortAtlas(arr)
    -- 进行排序
    local len = arr:getSize();
    for i = 1, len do
        for j = i + 1, len do
            local a = self.heroAtlasDic[arr[i]].sort;
            local b = self.heroAtlasDic[arr[j]].sort;
            if a < b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
    self.heroAtlasArr = arr;
end

function Lua_HeroAtlasData:fromServer50114006(msg)
    if msg == nil then
        return;
    end
    if self.heroAtlasDic == nil then
        self:getheroAtlasDic();
    end
    self.heroActivateDic = {};
    local avo;
    local list = msg.hero_list;
    for i=1,#list do
        avo = self.heroAtlasDic[tonumber(list[i])]
        if avo ~= nil then
            avo.isActivate = true;
            self.heroActivateDic[avo.hero_id] = true;
        else
            -- print("no hero_atlas-英雄图鉴表 id =  =",v);
        end
    end
end

--图鉴属性
function Lua_HeroAtlasData:fromServer50114023(msg)
    if msg == nil then
        return;
    end
    local vo = self.heroAtlasDic[tonumber(msg.atlas_id)];
    if vo ~= nil then
        vo:fromServerInfo(msg);
    end
end

-- 通id引获取VO
function Lua_HeroAtlasData:getAtlasVoById(aid)
    if self.heroAtlasDic ~= nil and self.heroAtlasDic[tonumber(aid)] ~= nil then
        return self.heroAtlasDic[tonumber(aid)];
    end
    return nil;
end

--获取英雄图鉴激活状态
function Lua_HeroAtlasData:getAtlasStateByHid(hero_id)
    if self.heroActivateDic ~= nil and self.heroActivateDic[tonumber(hero_id)] == true then
        return true;
    end
    return false;
end

-- 图鉴 获取对应类型所有数据
function Lua_HeroAtlasData:getHeroAtlasArr(_rarity, _campType)
    if self.raritallDic == nil then
        self.campTypeDic = {};
        self.raritallDic = {};
        self.raritCampDic = {};
        self.raritAllIndexDic = {};
        self:getheroAtlasDic();

        local rarity, campType, openState, openDay;
        for i = 1, self.heroAtlasArr:getSize() do
            avo = self:getAtlasVoById(self.heroAtlasArr[i]);
            openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(avo.hero_id, Lua_NewHeroFuncOpen.atlas); -- 达到开服天数限制才显示
            if openState then
                rarity = avo.heroVo.rarity;
                campType = avo.heroVo.campType;
                if self.raritallDic[rarity] == nil then
                    self.raritallDic[rarity] = Array();
                end
                self.raritallDic[rarity]:add(self.heroAtlasArr[i]);
                self.raritAllIndexDic[avo.hero_id] = i;

                if self.campTypeDic[campType] == nil then
                    self.campTypeDic[campType] = Array();
                end
                self.campTypeDic[campType]:add(self.heroAtlasArr[i]);

                if self.raritCampDic[campType] == nil then
                    self.raritCampDic[campType] = {};
                end
                if self.raritCampDic[campType][rarity] == nil then
                    self.raritCampDic[campType][rarity] = Array();
                end
                self.raritCampDic[campType][rarity]:add(self.heroAtlasArr[i]);
            end
        end
    end

    if _campType == Lua_HeroUtil.All_TYPE then
        return self.raritallDic[_rarity];
    else
        return self.raritCampDic[_campType][_rarity];
    end
end

-- 获取索引
function Lua_HeroAtlasData:getRarityArrIndex(id, rarity, campType)
    if self.raritallDic == nil then
        self:getheroAtlasDic()
        self:getHeroAtlasArr(rarity, campType);
    end
    if campType == Lua_HeroUtil.All_TYPE then
        if self.raritAllIndexDic[id] ~= nil then
            return self.raritAllIndexDic[id];
        end
    else
        if self.raritIndexDic == nil then
            self.raritIndexDic = {};
        end
        if self.raritIndexDic[campType] == nil then
            self.raritIndexDic[campType] = {};
            local avo;
            local hid;
            local index = 0;
            local arr = self.campTypeDic[campType];
            for i=1,arr:getSize() do
                avo = self:getAtlasVoById(arr[i]);
                hid = avo.hero_id;
                if self.raritIndexDic[campType][hid] == nil then
                    index = index + 1;
                    self.raritIndexDic[campType][hid] = index;
                end
            end
        end
        return self.raritIndexDic[campType][id];
    end
    return nil;
end

function Lua_HeroAtlasData:getAtlasInfoByCamp(campType)
    if campType == Lua_HeroUtil.All_TYPE then
        return self.heroAtlasArr;
    else
        return self.campTypeDic[campType];
    end
end

--通过英雄id获取图鉴id
function Lua_HeroAtlasData:getAtlasIdByHid(hid)
    if self.heroAtlasDic == nil then
        self:getheroAtlasDic();
    end

    if self.heroIdDic[hid] ~= nil then
        return self.heroIdDic[hid];
    end
    return nil;
end

--通过英雄id打开对应图鉴属性展示
function Lua_HeroAtlasData:onOpenAtlasWindow(hid, selectBtnId, isShowTab, campType, tag)
    --hid : 英雄id
    --isShowTab ： 是否展示左右切换页签
    --campType  ： 展示campType对应列表数据
    --selectBtnId -- 1 属性 2 装备 3 升星 4 皮肤 5 觉醒
    --tag :默认不需要填,  这里图鉴传值标记特殊处理 非图鉴界面进入英雄详情不展示故事红点和卡片的钻石奖励
    local aid = self:getAtlasIdByHid(hid);
    if aid == nil then
        return;
    end   
    selectBtnId = selectBtnId == nil and 1 or selectBtnId;
    local heroVo = self:getAtlasVoById(aid).heroVo;
    local info = {};
    info.aid = aid;
    info.tagShowCardRedDot = tag;
    info.selectBtn = selectBtnId;
    if isShowTab == nil then -- 打开图鉴属性界面，不展示左右切换页签
        info.isShowTab = false;
    else -- 打开图鉴属性界面，展示左右切换页签
        campType = campType == nil and Lua_HeroUtil.All_TYPE or campType;
        info.isShowTab = true;
        info.createIdx = self:getRarityArrIndex(heroVo.id, heroVo.rarity, campType);
        info.arr = self:getAtlasInfoByCamp(campType);
    end

    DataCenter.preLoadData:preShowModelScene("Lua_HeroShowAtlasAttributeWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, info, heroVo);
end

function Lua_HeroAtlasData:onShowModel(param, modelScenePanel)
    param.modelScenePanel = modelScenePanel;
    Lua_WindowUtil.openWin("Lua_HeroShowAtlasAttributeWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_HeroAtlasData:removeShowModel()
    DataCenter.preLoadData:removeBySign("Lua_HeroShowAtlasAttributeWindow", self, self.onShowModel);
end








---------------------------------- 红点管理 -------------------------------------------

--英雄图鉴闪卡红点更新
function Lua_HeroAtlasData:checkAtlasCarRedDotState()
    if DataCenter.funcOpenData:isOpened(10002) ~= true then
        return
    end
    if self.heroIdDic == nil then
        self:getheroAtlasDic();
    end

    local hvo, openState, openDay;
    local redDotState = false;
    for hero_id, v in pairs(self.heroIdDic) do
        hvo = Lua_HeroVo.new(hero_id);
        openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(hero_id, Lua_NewHeroFuncOpen.atlas); -- 达到开服天数限制才显示
        if hvo ~= nil and hvo.bHeroCardRedDot and openState then
            redDotState = true;
            break
        end
    end
    -- print("英雄图鉴闪卡红点更新 11111 = = ",redDotState)
    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.HeroAtlas, redDotState);
end