Lua_HeroConnectVo = class("Lua_HeroConnectVo")
function Lua_HeroConnectVo:ctor(id, config)
	self:superCall("ctor")
	self.id = id
	self._config = config
	self:init()
end

function Lua_HeroConnectVo:remove()
	if self._condInfo then
		self._condInfo:clear()
		self._condInfo = nil
	end
end

function Lua_HeroConnectVo:init()
	self._isActivate = false
	if self._condInfo == nil then
		self._condInfo = Array()
		local vo
		if self.type == 1 then -- 固定英雄连携
			for i = 1, self.showNum do
				vo = Lua_HeroConnCondVo.new(i, self.id)
				vo.heroId = self.heroList[i]
				self._condInfo:add(vo)
			end
		elseif self.type == 2 then -- 固定阵营连携
			vo = Lua_HeroConnCondVo.new(1, self.id)
			vo.heroId = self.id
			self._condInfo:add(vo)
			for i = 1, self.showNum do
				vo = Lua_HeroConnCondVo.new(i + 1)
				vo.camp = self.camp
				self._condInfo:add(vo)
			end
		elseif self.type == 3 then -- 非固定阵营连携
			vo = Lua_HeroConnCondVo.new(1, self.id)
			vo.heroId = self.id
			vo.camp = Lua_HeroConfigData.getConfig(self.id).camp
			self._condInfo:add(vo)
			for i = 1, self.showNum do
				vo = Lua_HeroConnCondVo.new(i + 1)
				vo.camp = self.campList[i]
				self._condInfo:add(vo)
			end
		elseif self.type == 4 then -- 固定职业连携
			vo = Lua_HeroConnCondVo.new(1, self.id)
			vo.heroId = self.id
			self._condInfo:add(vo)
			for i = 1, self.showNum do
				vo = Lua_HeroConnCondVo.new(i + 1)
				vo.career = self.career
				self._condInfo:add(vo)
			end
		elseif self.type == 5 then -- 非固定职业连携
			vo = Lua_HeroConnCondVo.new(1, self.id)
			vo.heroId = self.id
			vo.career = Lua_HeroConfigData.getConfig(self.id).career
			self._condInfo:add(vo)
			for i = 1, self.showNum do
				vo = Lua_HeroConnCondVo.new(i + 1)
				vo.career = self.careerList[i]
				self._condInfo:add(vo)
			end
		end
	else
		for i = 1, self._condInfo:getSize() do
			self._condInfo[i].state = false
		end
	end
end

function Lua_HeroConnectVo:setData(heroDic, campDic, careerDic)
	local len = self._condInfo:getSize()
	local vo
	local state = true
	if self.type == 1 then
		for i = 1, len do
			vo = self._condInfo[i]
			if heroDic[vo.heroId] then
				vo.state = true
			else
				vo.state = false
				state = false
			end
		end
	elseif self.type == 2 then
		local temp = campDic[self.camp]
		local count = temp and temp:getSize() or 0
		state = (count >= self.num)
		if state then
			for i = 1, len do
				vo = self._condInfo[i]
				vo.state = (temp[i] ~= nil)
			end
		end
	elseif self.type == 3 then
		local count = table.length(campDic)
		state = (count >= self.num)
		if state then
			for i = 1, len do
				vo = self._condInfo[i]
				vo.state = (campDic[vo.camp] ~= nil)
			end
		end
	elseif self.type == 4 then
		local temp = careerDic[self.career]
		local count = temp and temp:getSize() or 0
		state = (count >= self.num)
		if state then
			for i = 1, len do
				vo = self._condInfo[i]
				vo.state = (temp[i] ~= nil)
			end
		end
	elseif self.type == 5 then
		local count = table.length(careerDic)
		state = (count >= self.num)
		if state then
			for i = 1, len do
				vo = self._condInfo[i]
				vo.state = (careerDic[vo.career] ~= nil)
			end
		end
	end
	self._isActivate = state
end

function Lua_HeroConnectVo.Get:condInfo()
	self._condInfo:sort("sortIdx", false)
	return self._condInfo
end

function Lua_HeroConnectVo.Get:showNum()
	if self.type == 1 then
		return #self.heroList
	elseif self.type == 2 or self.type == 4 then
		return self.num - 1
	elseif self.type == 3 then
		return #self.campList
	elseif self.type == 5 then
		return #self.careerList
	end
	return self.num
end

function Lua_HeroConnectVo.Get:isActivate()
	return self._isActivate
end

function Lua_HeroConnectVo.Get:sortIdx()
	if self.isActivate then
		return self.id
	end
	return self.id + 1000000000
end

--------------------------------------------------

function Lua_HeroConnectVo.Get:config()
	if self._config then
		return self._config
	end
	return getConfig("hero_connect", self.id)
end

function Lua_HeroConnectVo.Get:type()
	return self.config.type
end

function Lua_HeroConnectVo.Get:name()
	return self.config.name
end

function Lua_HeroConnectVo.Get:desc()
	return self.config.desc
end

function Lua_HeroConnectVo.Get:heroList()
	return self.config.hero_list
end

function Lua_HeroConnectVo.Get:camp()
	return self.config.camp
end

function Lua_HeroConnectVo.Get:career()
	return self.config.career
end

function Lua_HeroConnectVo.Get:num()
	return self.config.num or 0
end

function Lua_HeroConnectVo.Get:skillId()
	return self.config.skill_id
end

function Lua_HeroConnectVo.Get:campList()
	return self.config.camp_list
end

function Lua_HeroConnectVo.Get:careerList()
	return self.config.career_list
end











Lua_HeroConnCondVo = class("Lua_HeroConnCondVo")
function Lua_HeroConnCondVo:ctor(index, ownerId)
	self:superCall("ctor")
	self.index = index
	self.heroId = nil
	self.camp = nil
	self.career = nil
	if index == 1 then
		self.state = (DataCenter.heroData:getHeroUidArrById(ownerId) ~= nil)
	else
		self.state = false
	end
end

function Lua_HeroConnCondVo.Get:sortIdx()
	if self.state then
		return self.index
	end
	return self.index + 100
end