--英雄装备
checkRequire("Lua_EquipVo");--装备
Lua_EquipData = class("Lua_EquipData")
function Lua_EquipData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_EquipData:dispose()
    self.heroEquipInfoDic = {};--英雄装备记录集合

    self.sortEquipDic = {}; --部位排序标记 dic[part] = bool
    self.heroEquipDic = {}; --英雄身上装备集合 dic[uid] = evo;
    self.equipPartDic = {}; --英雄身上装备部位集合 dic[part] = uid_arr;

    self.bPackState = false;--装备背包更新状态
    self.packPartDic = nil; --背包装备部位集合 dic[part] = uid_arr;
end

-- 更新英雄装备
function Lua_EquipData:updateHeroEquipItem(equip_info, hero_uid, trial_state)
    if equip_info == nil or trial_state == true then
        return;
    end
    if self.heroEquipInfoDic[hero_uid] == nil then
        self.heroEquipInfoDic[hero_uid] = {};
    end
    local unique_id;
    local checkDic = {};--记录当前英雄穿戴的装Uid
    for i=1, #equip_info do
        unique_id = tonumber(equip_info[i].unique_id);
        self.heroEquipInfoDic[hero_uid][unique_id] = 1;
        checkDic[unique_id] = 1;
        self:addEquipItem(equip_info[i], hero_uid);
    end

    local list = self.heroEquipInfoDic[hero_uid];
    for unique_id, value in pairs(list) do
        if checkDic[unique_id] == nil then
            if DataCenter.packData:getItemVoByUnId(tonumber(unique_id)) ~= nil then
                -- print("移除装备    = == ",unique_id)
                self:deleteEquipByUid(tonumber(unique_id));--移除装备
            end
            list[unique_id] = nil;
        end
    end
    checkDic = nil;
end

-- 新增装备
function Lua_EquipData:addEquipItem(serverInfo, hero_uid)
    if serverInfo == nil or hero_uid == nil then
        return nil;
    end
    
    local evo = self.heroEquipDic[tonumber(serverInfo.unique_id)];
    if evo == nil then
        evo = Lua_ToolVo.createToolVo(tonumber(serverInfo.id));
        if self.equipPartDic[evo.part] == nil then
            self.equipPartDic[evo.part] = Array();
        end
        self.equipPartDic[evo.part]:add(tonumber(serverInfo.unique_id));
    end
    evo:fromServer(serverInfo);
    evo.hero_uid = hero_uid;

    self.sortEquipDic[evo.part] = true;
    -- print("新增装备  = =",evo.unique_id)
    self.heroEquipDic[evo.unique_id] = evo;

    return evo;
end

function Lua_EquipData:deleteEquipByUid(unique_id)
    if unique_id == nil then
        return;
    end
    local evo = self.heroEquipDic[tonumber(unique_id)];
    if evo ~= nil then
        self.sortEquipDic[evo.part] = true;
        self.heroEquipDic[tonumber(unique_id)] = nil;
        if self.equipPartDic[evo.part] ~= nil then
            self.equipPartDic[evo.part]:removeItem(tonumber(unique_id));
        end
    end
    evo = nil;
end














--背包部位数据
function Lua_EquipData:getPackPartArrByPart(part)
    self:updatePackPartDic();
    if self.packPartDic == nil or self.packPartDic[part] == nil then
        return nil;
    end
    return self.packPartDic[part];
end

function Lua_EquipData:updatePackPartDic()
    if self.bPackState then
        return self.packPartDic;
    end
    self.bPackState = true;

    self.packPartDic = {};
    local arr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_EQUIP);--装备背包数据
    for i=1,arr:getSize() do--已排过序的这里不在排序
        evo = DataCenter.packData:getItemVoByUnId(arr[i]);
        if evo ~= nil then
            if self.packPartDic[evo.part] == nil then
                self.packPartDic[evo.part] = Array();
            end
            self.packPartDic[evo.part]:add(arr[i]);
        end
    end
    return self.packPartDic;
end



---------------------------------- 数据接口 -------------------------------------------

-- 通过唯一id获取装备vo
function Lua_EquipData:getEquipVoByUid(unique_id)
    if self.heroEquipDic[tonumber(unique_id)] == nil then
        return DataCenter.packData:getItemVoByUnId(tonumber(unique_id));
    end
    return self.heroEquipDic[tonumber(unique_id)];
end









---------------------------------- 界面数据 -------------------------------------------

-- 获取对应部位Uid集合
function Lua_EquipData:getEquipArrByPart(part, cur_equip_uid)--cur_equip_uid当前穿戴的 装备UID，用于排序
    local evo;
    local arr;
    local partArr = Array();

    arr = self.equipPartDic[part];--英雄身上的装备数据
    self:sortEquip(arr, part, cur_equip_uid);
    if arr ~= nil then
        for i=1,arr:getSize() do
            partArr:add(arr[i]);
        end 
    end
    
    arr = self:getPackPartArrByPart(part);--装备背包数据
    if arr ~= nil then
        for i=1,arr:getSize() do--已排过序的这里不在排序
            evo = DataCenter.packData:getItemVoByUnId(arr[i]);
            -- print(evo,"装备背包数据 = =",part,"     ",evo.part)
            if evo ~= nil then
                partArr:add(arr[i]);
            end
        end
    end
    return partArr;
end

-- 穿戴部位排序
function Lua_EquipData:sortEquip(arr, part, cur_equip_uid)
    if arr == nil or self.sortEquipDic[part] ~= true then
        return;
    end
    
    -- 进行排序
    self.sortEquipDic[part] = false;
    local len = arr:getSize();
    if len <= 1 then
        return;
    end
    local a;
    local b;
    for i = 1, len do
        for j = i + 1, len do
            a =  self:getEquipVoByUid(arr[i]).equipSort;
            b = self:getEquipVoByUid(arr[j]).equipSort;
            if cur_equip_uid == arr[i] then
                a = a -10000000000000;
            end
            if cur_equip_uid == arr[j] then
                b = b - 10000000000000;
            end
            if a > b then
                local temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;
            end
        end
    end
end




















---------------------------------- 装备强化 -------------------------------------------
-- 强化石数据
function Lua_EquipData.Get:strongStoneInfo()
    local id;
    local tvo;
    local len;
    local itemNum;
    local arr = Array();
    local tag_list = {};
    local limitNumt = DataCenter.equipUtil.strong_stone_overlap;
    local info = DataCenter.packData:getUnIdList(Lua_PackDefine.MATERIALS, Lua_PackDefine.EQUIP_BAG_STRONG);
    for i=1,info:getSize() do
        tvo = DataCenter.packData:getItemVoByUnId(info[i]);
        if tvo ~= nil then
            id = tvo.id;
            if tag_list[id] == nil then
                tag_list[id] = 1;

                itemNum = DataCenter.packData:getItemCountById(id);--强化石总数量
                len = Mathf.Ceil(itemNum/limitNumt);
                local count = 0;
                for j=1, len do
                    if j < len then
                        count = limitNumt;
                    else
                        count = itemNum - limitNumt*(j-1);
                    end
                    tvo = Lua_ToolVo.createToolVo(id, count);
                    tvo.tag_uid = id.."00000000000"..j;
                    arr:add(tvo);
                end
            end
        end
    end

    return arr;
end













---------------------------------- 红点 -------------------------------------------

-- 背包装备变化，更新装备红点
function Lua_EquipData:updateEquipRedDotState()
    self.bPackState = false;
    DataCenter.heroData:checkHeroRedDotState();
end

-- 检测装备红点
function Lua_EquipData:checkEquipRedDotState(hero_uid)
    local hvo = DataCenter.heroData:getItemByUniqueId(hero_uid);
    if hvo ~= nil then
        local equip_uid;
        local equipInfo = hvo.equipInfo;
        for i=1, 4 do
            equip_uid = equipInfo[i];
            if self:checkEquipChangeRedDot(i, equip_uid) == true then
                return true;
            end
        end
    end

    return false;
end

--装备 穿戴/替換红点
function Lua_EquipData:checkEquipChangeRedDot(part, equip_uid)
    local arr = self:getPackPartArrByPart(part);--装备背包数据
    if arr == nil then
        return false;
    end
    local len = arr:getSize();
    if equip_uid == nil then
        return len > 0;
    else
        local cur_evo = self:getEquipVoByUid(equip_uid);
        if cur_evo == nil then
            return false;
        end
        local evo;
        for i = 1, len do
            if equip_uid ~= arr[i] then
                evo = self:getEquipVoByUid(arr[i]);
                if evo ~= nil and evo.equipScore > cur_evo.equipScore then
                    return true;
                end
            end
        end
    end
    return false;
end

--强化红点
function Lua_EquipData:checkEquipStrongRedDot(equip_uid)
    local evo = self:getEquipVoByUid(equip_uid);
    if evo ~= nil then
        local up_exp = DataCenter.equipUtil:getEquipUpgradeExp(evo.equipLevelId);
        if up_exp ~= 0 then--未满级
            local need_exp = up_exp - evo.equipCurLevelExp;

            local tvo;
            local provideExp;
            local arr = DataCenter.packData:getUnIdList(Lua_PackDefine.MATERIALS, Lua_PackDefine.EQUIP_BAG_STRONG);
            for i=1, arr:getSize() do
                tvo = DataCenter.packData:getItemVoByUnId(arr[i]);
                provideExp = tvo.provideExp * tvo.count;
                need_exp = need_exp - provideExp;
                if need_exp <= 0 then
                    return true;
                end
            end
        end
    end

    return false;
end


