-- Equip配置表数据
Lua_EquipPropConfigData = class("Lua_EquipPropConfigData");
function Lua_EquipPropConfigData.getConfigData(id)
	if Lua_EquipPropConfigData.configDic == nil then
		Lua_EquipPropConfigData.configDic = {};
	end

	id = tonumber(id);
	if Lua_EquipPropConfigData.configDic[id] == nil then
		local cfg = getConfig("equip_prop", id);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_EquipPropConfigData.configDic[id] = Lua_EquipPropConfigData.new(id, cfg);
	end
	return Lua_EquipPropConfigData.configDic[id];
end

function Lua_EquipPropConfigData.getAllequipPropConfig()
	if Lua_EquipPropConfigData.configArr == nil then
		Lua_EquipPropConfigData.configArr = Array();
		if Lua_EquipPropConfigData.configDic == nil then
			Lua_EquipPropConfigData.configDic = {};
		end

		local config = getConfig("equip_prop");
		for k, v in pairs(config) do
			local vo = Lua_EquipPropConfigData.configDic[k];
			if vo == nil then
				vo = Lua_EquipPropConfigData.new(k, v);
				Lua_EquipPropConfigData.configDic[k] = vo;
			end
			Lua_EquipPropConfigData.configArr:add(vo);
		end
		Lua_EquipPropConfigData.configArr:sort("sort", false);
	end
	return Lua_EquipPropConfigData.configArr;
end

function Lua_EquipPropConfigData:ctor(id, config)
	self:superCall("ctor");
    self.id = id;
    self.config = config;
    if self.config == nil then
	    self.config = getConfig("equip_prop", id);
	end
end

-- 是否展示
function Lua_EquipPropConfigData.Get:is_show()
	if self.config.is_show == nil then
		return 0;
	end
	return self.config.is_show;
end

-- 装备名称
function Lua_EquipPropConfigData.Get:equipPropId()
	return self.id;
end

-- 装备名称
function Lua_EquipPropConfigData.Get:name()
	return self.config.name;
end

-- 部位
function Lua_EquipPropConfigData.Get:part()
	return self.config.part;
end

-- 品质
function Lua_EquipPropConfigData.Get:color()
	return self.config.color;
end

-- 星级
function Lua_EquipPropConfigData.Get:star()
	return self.config.initial_star;
end

function Lua_EquipPropConfigData.Get:atlas()
    return self.config.atlas;
end

function Lua_EquipPropConfigData.Get:sprite()
    local sprite = self.config.sprite;
    if sprite == nil then
        sprite = self.id;
    end
    return tostring(sprite);
end

-- 排序
function Lua_EquipPropConfigData.Get:sort()
	return self.config.sort;
end

-- 提供经验
function Lua_EquipPropConfigData.Get:provideExp()
	if self.config.provide_experience == nil then
		return 0;
	end
	return self.config.provide_experience;
end

-- 升级需要经验值
function Lua_EquipPropConfigData.Get:experience()
	return self.config.experience;
end

-- 消耗的道具
function Lua_EquipPropConfigData.Get:consume_item()
	return self.config.consume_item;
end

-- 属性字段
function Lua_EquipPropConfigData.Get:attr_list()
	return self.config.attr_list;
end

-- 评分
function Lua_EquipPropConfigData.Get:score()
	return self.config.score;
end

function Lua_EquipPropConfigData.Get:des()
	return self.config.des;
end

function Lua_EquipPropConfigData.Get:main_type()
    if self.config.main_type == nil then
        return 10;
    end
    return self.config.main_type;
end

function Lua_EquipPropConfigData.Get:colorName()
	return Lua_ColorDefine.getColorStr(self.colorStr, self.name);
end

function Lua_EquipPropConfigData.Get:colorStr()
    return Lua_ColorDefine.getItemColorStr(self.color);
end

function Lua_EquipPropConfigData.Get:race_id()
    return 0;
end