--装备配置
Lua_EquipUtil = class("Lua_HeroEquipUtil");
function Lua_EquipUtil:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_EquipUtil:dispose()
    self.consumeCoinDic = nil;
    self._strongStoneExpArr = nil;
    self.entryScoreDic = nil;
    self.gradeScoreDic = nil;
end




------------------------------------ 装备常量 ------------------------------------

-- 分解反换金币百分比
function Lua_EquipUtil.Get:decompose_ret_coin()
    return getConfig("equip_const","decompose_ret_coin","value1");
end

-- 重铸开启等级
function Lua_EquipUtil.Get:recast_open_level()
    return getConfig("equip_const","recast_open_level","value");
end

-- 跳转id
function Lua_EquipUtil.Get:go_to_id()
    return getConfig("equip_const","go_to_id","value");
end

-- 锁定词条上限
function Lua_EquipUtil.Get:lock_entry_v()
    return getConfig("equip_const", "lock_entry", "value");
end

-- 锁定词条消耗
function Lua_EquipUtil.Get:lock_entry_jv()
    return getConfig("equip_const","lock_entry","json_value");
end

-- 强化大师最小激活id
function Lua_EquipUtil.Get:strong_master_min_id()
    return  getConfig("equip_const","strong_master_min_id","value");
end

-- 强化大师最大激活id
function Lua_EquipUtil.Get:strong_master_max_id()
    return  getConfig("equip_const","strong_master_max_id","value");
end

-- 装备共鸣激活最低id
function Lua_EquipUtil.Get:equip_color_min_id()
    return getConfig("equip_const","equip_color_min_id","value");
end

-- 装备共鸣激活最大id
function Lua_EquipUtil.Get:equip_color_max_id()
    return getConfig("equip_const","equip_color_max_id","value");
end

-- 强化石叠加上限
function Lua_EquipUtil.Get:strong_stone_overlap()
    return getConfig("equip_const","strong_stone_overlap","value");
end

-- 强化大师激活装备个数
function Lua_EquipUtil.Get:activate_master_num()
    return getConfig("equip_const","activate_master_num","value");
end

-- 装备共鸣激活装备个数
function Lua_EquipUtil.Get:activate_resonance_num()
    return getConfig("equip_const","activate_resonance_num","value");
end

--词条解锁个数分数
function Lua_EquipUtil:getEntryScore(unlock_num)
    if self.entryScoreDic == nil then
        self.entryScoreDic = {};
        local list = getConfig("equip_const","entry_score","json_value");
        for i=1,#list do
            self.entryScoreDic[list[i][1]] = list[i][2];
        end
    end

    if self.entryScoreDic[unlock_num] == nil then
        LogManager.LogError("服务端发送评级别错误 = " .. grade, false);
        return 0;
    end
    return self.entryScoreDic[unlock_num];
end

--词条评级分数
function Lua_EquipUtil:getGradeScore(grade)
    if self.gradeScoreDic == nil then
        self.gradeScoreDic = {};
        local list = getConfig("equip_const","entry_grade_score","json_value");
        if list ~= nil then
            for i=1,#list do
                self.gradeScoreDic[list[i][1]] = list[i][2];
            end
        end
    end
    if self.gradeScoreDic[grade] == nil then
        LogManager.LogError("服务端发送评级别错误 = " .. grade, false);
        return 0;
    end
    return self.gradeScoreDic[grade];
end

-- 强化石集合
function Lua_EquipUtil.Get:strongStoneExpArr()
    if self._strongStoneExpArr == nil then
        self._strongStoneExpArr = Array();
        local list = getConfig("equip_const","strength_stone_list","json_value");
        local tvo;
        for i=1,#list do
            tvo = Lua_ToolVo.createToolVo(list[i]);
            self._strongStoneExpArr:add(tvo);
        end
        self._strongStoneExpArr:sort("id", true);
    end

    return self._strongStoneExpArr;
end

-- 获取副属性类型
function Lua_EquipUtil:getExtraPropType(attr_name)
    return getConfig("equip_const","extra_prop_type","json_value",attr_name);
end

--装备词条配置id
function Lua_EquipUtil:getEquipEntryId(part, color, star, attr_name)
    --装备词条配置id = 部位*1000000+品质*100000+星级*10000+属性类型
    local id = 0;
    local typev = self:getExtraPropType(attr_name);
    if typev ~= nil then
        id = part *1000000 + color * 100000 + star*1000 + typev;
    end
    return id;
end

-- 获取装备部位名称
function Lua_EquipUtil:getEquipPartName(part)
    if part <= 4 and part > 0 then
        return LanUtil.getValue(126790+part);
    end
    return "错误部位";
end

--获取属性
function Lua_EquipUtil:getEquipAttrValueStr(value, isPercent)
    if value == nil then
        return "";
    end
    local ratio = isPercent == 1 and 100 or 1;
    local pstr = isPercent == 1 and "%" or "";
    local str;
    if isPercent == 1 then
        str = (Mathf.Floor(value*ratio*10 + 0.5)/10)..pstr;
    else
        str = Mathf.Floor(value*ratio + 0.5)..pstr;
    end
    return str;
end

--获取装备剪影  1 英雄装备panel用   2 装备更换用
function Lua_EquipUtil:getEquipShadow(part, typev)
    if part == 1 then
        if typev == 1 then
            return "xui_hb_tab_1";
        elseif typev == 2 then
            return "xui_zb_icon_3";
        end
    elseif part == 2 then
        if typev == 1 then
            return "xui_hb_tab_4";
        elseif typev == 2 then
            return "xui_zb_icon_4";
        end
    elseif part == 3 then
        if typev == 1 then
            return "xui_hb_tab_3";
        elseif typev == 2 then
            return "xui_zb_icon_1";
        end
    elseif part == 4 then
        if typev == 1 then
            return "xui_hb_tab_2";
        elseif typev == 2 then
            return "xui_zb_icon_2";
        end
    end

    return "";
end










------------------------------------ 装备部位 ------------------------------------
--装备部位
function Lua_EquipUtil:getEquipPartConfigInfo(id)
    return getConfig("equip_part",id);
end


--部位是否解锁
function Lua_EquipUtil:equipPartUnlock(part, hero_lvl, hero_star)
    local info = self:getEquipPartConfigInfo(part);
    local limit_star = DataCenter.heroUtil:getHeroAwakenStarByQuality(info.unlock_quality, info.unlock_star);
    if info ~= nil and info.unlock_lvl <= hero_lvl and limit_star <= hero_star then
        return true;
    end
    return false;
end
















------------------------------------ 装备品质 ------------------------------------

--等级上限
function Lua_EquipUtil:level_limit(id)
    return getConfig("equip_color", id, "level_limit");
end

--品质名字
function Lua_EquipUtil:color_name(id)
    return getConfig("equip_color", id, "name");
end

--共鸣进度值
function Lua_EquipUtil:color_value(id)
    return getConfig("equip_color", id, "value");
end

--副属性解锁限制
function Lua_EquipUtil:getPropLockLimitById(id)
    local list = getConfig("equip_color", id, "prop_lock_limit");
    if id == nil or list == nil then
        return {};
    end
    return list;
end

--等级评级
function Lua_EquipUtil:getEquipGrade(id, extraProp)
    local score = 0;
    local len = #extraProp
    for i=1, len do--副属性评分
        score = score + self:getGradeScore(extraProp[i].grade);
    end
    score = score + self:getEntryScore(len);--解锁副属性个数评分
    local list = getConfig("equip_color", id, "grade");
    if list ~= nil then
        local max;
        local min;
        for i=1,#list do
            max = list[i][2][1];
            min = list[i][2][2];
            if score < max and score >= min then
                return list[i][1];
            end
        end
    end

    return 0;
end

--获取强化石对应的消耗
function Lua_EquipUtil:getStrongIdCostNumById(equip_color_id, id)
    if self.consumeCoinDic == nil then
        self.consumeCoinDic = {};
    end
    if self.consumeCoinDic[equip_color_id] == nil then
        self.consumeCoinDic[equip_color_id] = {};
        local list = getConfig("equip_color",equip_color_id, "consume_coin");
        for i=1,#list do
            self.consumeCoinDic[equip_color_id][list[i][1]] = list[i][2][2];
        end
    end

    if self.consumeCoinDic[equip_color_id] ~= nil and self.consumeCoinDic[equip_color_id][id] ~= nil then
        return self.consumeCoinDic[equip_color_id][id];
    else
        return 0;
    end
end

--获取强化消耗的金币
function Lua_EquipUtil:getStrongCostCoinNum(equip_color_id, selectNumDic)
    if self.consumeCoinDic == nil then
        self.consumeCoinDic = {};
    end

    local cost_num = 0;
    if selectNumDic ~= nil then
        local num;
        for id, count in pairs(selectNumDic) do
            if string.len(id) >= 20 then
                id = string.sub(id,1,9);
            end
            num = self:getStrongIdCostNumById(equip_color_id, tonumber(id));
            cost_num = cost_num + num * count;
        end
    end
    return cost_num;
end

--获取装备额外属性展示
function Lua_EquipUtil:getShowExtraAttrTxt(equip_color_id, part)
    local list = getConfig("equip_color", equip_color_id, "extra_prop_list");
    list = list[part];
    if list == nil then
        return "";
    end

    local name;
    local attrVo;
    local str = "";
    local valueList;--取值范围
    for i=1,#list do
        name = getConfig("equip_entry", list[i], "prop_name");
        if name ~= nil then
            attrVo = DataCenter.attributesUtil:createAttrVo(name);
            if attrVo ~= nil then
                if str == "" then
                    str = "";
                else
                    str = str.."\n";
                end
                valueList = self:getAttrValueLsit(list[i]);
                local str1 = self:getEquipAttrValueStr(valueList[1], attrVo.isPercent);
                local str2 = self:getEquipAttrValueStr(valueList[2], attrVo.isPercent)
                str = str..attrVo.show_name..": ".. str1.."~".. str2;
            end
        end
    end
    
    return str;
end

--获取装备副属性取值范围
function Lua_EquipUtil:getAttrValueLsit(equip_entry_id)
    local list = getConfig("equip_entry", equip_entry_id, "show_prop_list");
    if list == nil then
        return {0, 0};
    end
    return list;
end

--获取重铸材料消耗
function Lua_EquipUtil:getRecastItemArr(id, lock_num)
    local list = getConfig("equip_color", id, "recast_consume");
    if list == nil or list[1] == nil then
        return nil;
    end

    local arr = Array();
    arr:add({itemId = list[1][1], count = list[1][2], sign = 1});--sign 1 正常消耗道具  2 特殊消耗道具
    if lock_num > 0 then--词条上锁数
        for i=1, #self.lock_entry_jv do
            arr:add({itemId = self.lock_entry_jv[i][1], count = self.lock_entry_jv[i][2]*lock_num, sign = 2});--sign 1 正常消耗道具  2 特殊消耗道具
        end
    end
    return arr;
end

--获取重铸金币消耗
function Lua_EquipUtil:getRecastGold(id, index)
    local list = getConfig("equip_color", id, "recast_consume");
    if list == nil or list[index] == nil then
        return nil;
    end
    return list[index][1], list[index][2];
end

--装备品质下级id
function Lua_EquipUtil:getNextEquipColorId(id)
    return getConfig("equip_color", id, "next_id");
end

--获取装备分解返还的材料
function Lua_EquipUtil:getEquipDecomposeInfo(equip_color_id, all_exp, decompose)
    local list = getConfig("equip_color",equip_color_id, "consume_coin");

    local index = 1;
    local tvo = self.strongStoneExpArr[index];--等级最高强化石tvo;
    local provideExp = tvo.provideExp;

    local dic = {};
    local bTag = true;
    while bTag do
        if all_exp >= provideExp then
            all_exp = all_exp - provideExp;
            if dic[tvo.id] == nil then
                dic[tvo.id] = 1;
            else
                dic[tvo.id] = dic[tvo.id] +1;
            end
        else
            index = index + 1;
            tvo = self.strongStoneExpArr[index];
            if tvo ~= nil then
                provideExp = tvo.provideExp;
            else
                all_exp = 0;--跳出循环（进这里说明配置有误）
            end
        end

        bTag = not (all_exp <= 0);
    end

    
    local all_money = 0;
    local arr = Array();
    for id, count in pairs(dic) do--强化石
        tvo = Lua_ToolVo.createToolVo(id, count);
        all_money = all_money + self:getStrongIdCostNumById(equip_color_id, id) * count;
        arr:add(tvo);
    end
    
    for i=1, #decompose do --装备分解单独给的道具
        tvo = Lua_ToolVo.createToolVo(decompose[i][1], decompose[i][2]);
        arr:add(tvo);
    end

    local money_id = Lua_ResourcesDefine.GOLD;--消耗金币id
    local money_count = all_money*self.decompose_ret_coin;
    if money_count > 0 then
        tvo = Lua_ToolVo.createToolVo(money_id, money_count);
        arr:add(tvo);
    end

    arr:sort("sortWeight", true);
    return arr;
end




















------------------------------------ 装备等级 ------------------------------------、

--等级上限
function Lua_EquipUtil:getEquipProp(id)
    return getConfig("equip_level", id, "prop");
end



--装备升级所需的总经验
function Lua_EquipUtil:getEquipExp(id)
    local exp = getConfig("equip_level", id, "exp");
    if exp == nil then
        return 0;
    end
    return exp;
end


--装备升1级所需的经验
function Lua_EquipUtil:getEquipUpgradeExp(level_id)
    local cur_exp = self:getEquipExp(level_id);
    if cur_exp == 0 then
        return 0;--已满级
    end
    local up_exp = self:getEquipExp(level_id - 1);
    return cur_exp - up_exp;
end

--是否最大等级
function Lua_EquipUtil:getEquipMaxLevelByLevelId(id)
    if self:getEquipExp(id) == 0 then
        return true;
    end
    return false;
end

--获取装备属性
function Lua_EquipUtil:getEquipAttrValue(id, attr_name)
    local value = getConfig("equip_level", id, "prop", attr_name);
    if value == nil then
        return 0;
    end

    return value;
end

--选择的经验 可以升到几级 和 剩余的经验 
function Lua_EquipUtil:getEquipStrongLevelAndLeftExp(cur_exp, level_id, show_select_exp)
    local cur_level;--当前等级
    local bUpLevel = true;--是否可以升级
    local need_exp = self:getEquipUpgradeExp(level_id) - cur_exp;
    while bUpLevel do
        -- print(show_select_exp," level_id = =",need_exp,"        ",level_id)
        if need_exp > 0 and show_select_exp - need_exp >= 0 then--够升一级
            level_id = level_id + 1;
            bUpLevel = true;
            show_select_exp = show_select_exp - need_exp;
            need_exp = self:getEquipUpgradeExp(level_id);
            cur_level = getConfig("equip_level", level_id, "level");
        else
            bUpLevel = false;
        end
    end
    return show_select_exp, cur_level;
end

--当前材料提供多少经验
function Lua_EquipUtil:getSelectCostExp(selectlist)
    local vo;
    local num = 0;
    for itemId, count in pairs(selectlist) do
        if string.len(itemId) >= 20 then
            itemId = string.sub(itemId,1,9);
        end
        vo = Lua_ToolVo.new(tonumber(itemId));
        if vo ~= nil then
            num = num + vo.provideExp * count;
        end
    end
    return num;
end

--快速选择 更新选择强化石数量
function Lua_EquipUtil:updateSelectStrongNumDic(need_exp, showDragArr, selectNumDic)
    local tvo;
    local provideExp;--提供的经验
    local can_select_num;--可以选择的数量
    for i=1,showDragArr:getSize() do
        tvo = showDragArr[i];
        provideExp = tvo.provideExp;
        if selectNumDic[tvo.tag_uid] == nil then--当前材料未选择
            selectNumDic[tvo.tag_uid] = 0;
            can_select_num = tvo.count;
        else
            can_select_num = tvo.count - selectNumDic[tvo.tag_uid];--已选择的材料需要筛选掉
        end
        local bBreak = false;
        for i=1, can_select_num do
            if need_exp > 0 then
                need_exp = need_exp - provideExp;
                selectNumDic[tvo.tag_uid] = selectNumDic[tvo.tag_uid] +1;
            else
                bBreak = true;
                break;
            end
        end

        if bBreak then
            break;
        end
    end

    return selectNumDic;
end












------------------------------------ 强化大师 ------------------------------------

--强化大师等级数据
function Lua_EquipUtil:getStrongMasterCfgData(activate_id)
    return getConfig("equip_strong_master",activate_id);
end

--下一个强化大师等级
function Lua_EquipUtil:getNextStrongMasterLevel(activate_id)
    return getConfig("equip_strong_master",activate_id,"next_id");
end

-- 强化大师当前属性
function Lua_EquipUtil:getStrongMasterProp(activate_id)
    local id = activate_id;
    if id == 0 then
        id = self.strong_master_min_id;
    end

    local dic = {};
    local list = getConfig("equip_strong_master",id,"prop");
    for k,v in pairs(list) do
        if activate_id == 0 then
            dic[k] = 0;
        else
            dic[k] = v;
        end
    end

    local next_id = self:getNextStrongMasterLevel(id);
    if activate_id == 0 then
        next_id = id;
    end
    local nextDic = {};
    if next_id ~= nil and next_id ~= 0 then
        list = getConfig("equip_strong_master",next_id,"prop");
        for k,v in pairs(list) do
            nextDic[k] = v;
        end
    end

    return DataCenter.attributesUtil:getAttrArrByDic(dic, nextDic);
end

-- 获取强化大师等级
function Lua_EquipUtil:getEquipMasterLevelByHeroUid(hero_uid)
    local hvo = DataCenter.heroData:getItemByUniqueId(hero_uid);
    if hvo == nil then
        return 0;
    end
    local equipInfo = hvo.equipInfo;

    local evo;
    local activate_lvl;
    local activate_num = 0;
    if equipInfo ~= nil then
        for part, unique_id in pairs(equipInfo) do
            activate_num = activate_num + 1;
            evo = DataCenter.equipData:getEquipVoByUid(unique_id);
            if evo ~= nil then
                if activate_lvl == nil then
                    activate_lvl = evo.equipLevel;
                else
                    if evo.equipLevel < activate_lvl then
                        activate_lvl = evo.equipLevel;
                    end
                end
            end
        end
    end
    if activate_lvl == nil then
        activate_lvl = 0;
    end
    if activate_num ~= self.activate_master_num then
        activate_lvl = 0;
    end
    return activate_lvl;
end

-- 获取强化大师激活id
function Lua_EquipUtil:getMasterActivateIdByMasterLevel(master_level)
    local activate_id = 0;
    if master_level >= self.strong_master_min_id then
        local list = getConfig("equip_strong_master");
        for id, v in pairs(list) do
            local next_lvl = v.next_id;
            if next_lvl == nil then
                next_lvl = 9999999999;
            end
            if id <= master_level and master_level < next_lvl then
                activate_id = id;
            end
        end
    end
    
    return activate_id;
end

-- 获取装备共鸣激活id
function Lua_EquipUtil:getResonanceActivateId(hero_uid)
    local hvo = DataCenter.heroData:getItemByUniqueId(hero_uid);
    local equipInfo = hvo.equipInfo;

    local activate_id = 0;
    local activate_num = 0;
    if equipInfo ~= nil then
        local evo;
        for part, unique_id in pairs(equipInfo) do
            activate_num = activate_num + 1;
            evo = DataCenter.equipData:getEquipVoByUid(unique_id);
            if evo ~= nil then
                if activate_id == 0 then
                    activate_id = evo.equipColorId;
                else
                    if evo.equipColorId < activate_id then
                        activate_id = evo.equipColorId;
                    end
                end
            end
        end
    end
    
    if activate_num ~= self.activate_resonance_num then
        activate_id = 0;
    end
    
    return activate_id;
end

-- 装备共鸣属性
function Lua_EquipUtil:getEpuipReonanceProp(activate_id)
    local id = activate_id;
    if id == 0 then
        id = self.equip_color_min_id;
    end
    
    local dic = {};
    local list = getConfig("equip_color", id, "prop");
    for k,v in pairs(list) do
        if activate_id == 0 then
            dic[k] = 0;
        else
            dic[k] = v;
        end
    end
    local next_id = self:getNextEquipColorId(id);
    if activate_id == 0 then
        next_id = id;
    end
    local nextDic = {};
    if next_id ~= nil and next_id ~= 0 then
        list = getConfig("equip_color", next_id, "prop");
        for k,v in pairs(list) do
            nextDic[k] = v;
        end
    end

    return DataCenter.attributesUtil:getAttrArrByDic(dic, nextDic);
end