--符石vo
Lua_RunesVo = class("Lua_RunesVo", Lua_ToolVo)
function Lua_RunesVo:ctor(id, count)
    self:superCall("ctor", id, count);
end

function Lua_RunesVo:fromServer(msg)

    self.hero_uid = tonumber(msg.hero_uid);  -- 所属英雄唯一Id
    self.unique_id =  tonumber(msg.unique_id);-- 符石唯一id
    
    self.cur_prop = msg.cur_prop;--符石属性
    self.recast_prop = msg.recast_prop;--符石重铸属性
    self.rune_skill_list = msg.rune_skill_list;--技能列表
    self.recast_skill_list = msg.recast_skill_list;--重铸技能列表
    self:resetSort();
end

function Lua_RunesVo:clean()
    self.cur_prop = nil;
    self.recast_prop = nil;
    self.rune_skill_list = nil;
    self.recast_skill_list = nil;
end

--重置排序字段
function Lua_RunesVo:resetSort()
    self._backSort = nil;
    self.allScore = nil;
end










---------------------------------- 配置表数据 -------------------------------------------
-- 评分
-- function Lua_RunesVo.Get:score()
--     return self.config.score;
-- end

-- 合成花费
function Lua_RunesVo.Get:compose_consume()
    return self.config.compose_consume;
end

-- 合成下级符石道具Id
function Lua_RunesVo.Get:next_item_id()
    return self.config.next_item_id;
end

-- 合成成功概率
function Lua_RunesVo.Get:compose_rate()
    return self.config.compose_rate;
end

-- 重铸消耗
function Lua_RunesVo.Get:recast_cost_items()
    return self.config.recast_cost_items;
end

-- 获得属性描述
function Lua_RunesVo.Get:attr_des()
    return self.config.attr_des;
end

-- 符石获得技能描述
function Lua_RunesVo.Get:skill_des()
    return self.config.skill_des;
end









---------------------------------- 功能数据 -------------------------------------------


-- 技能数据
function Lua_RunesVo.Get:heroSkillInfo()
    if self.skillArr == nil then
        self.skillArr = Array();
        local svo;
        local list = self.rune_skill_list;
        for i=1,#list do
            svo = Lua_SkillConfigData.getConfigData(tonumer(list[i]));
            self.skillArr:add(svo);
        end
        self.skillArr:sort("id",true);
    end

    return self.skillArr;
end

--评分
function Lua_RunesVo.Get:score()
    if self.allScore == nil then
        self.allScore = 0;
        if self.cur_prop ~= nil then --属性评分
            local basics_score = 0;
            local special_score = 0;
            for i=1,#self.cur_prop do
                basics_score = DataCenter.runesUtil:getBasicsAttrCoeff(self.cur_prop[i].name)*self.cur_prop[i].value;
                if basics_score > 0 then
                    basics_score = Mathf.Floor(basics_score + 0.5);
                end
                special_score = DataCenter.runesUtil:getSpecialAttrGrade(self.cur_prop[i].name);

                self.allScore = self.allScore + basics_score + special_score;
            end
        end
        if self.rune_skill_list ~= nil then--技能
            local skillVo;
            for i=1, #self.rune_skill_list do
                skillVo = Lua_SkillConfigData.getConfigData(self.rune_skill_list[i]);
                if skillVo ~= nil then
                    self.allScore = self.allScore + skillVo.grade;
                end
            end
        end
    end

    return self.allScore;
end




---------------------------------- 排序 -------------------------------------------

-- 符石排序
function Lua_RunesVo.Get:backSort()
    if self._backSort == nil then
        self._backSort = self.color*100000000000 + self.score;
    end
    return self._backSort;
end
