--战技
Lua_TalentData = class("Lua_TalentData")
function Lua_TalentData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_TalentData:dispose()
    self:initRedDic();
end

function Lua_TalentData:initRedDic()
    self.talentRedDotDic = {};--[uid][part] = bool
end

--领悟数据
function Lua_TalentData:getTalentStudyInfo(_type, list)
    local _list = {};--推荐战技
    if list ~= nil then
        for i=1,#list do
            _list[list[i]] = 1;
        end
    end
    local id_list = {};--可领悟
    local arr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_TALENT);
    local tvo;
    for i = 1, arr:getSize() do
        tvo = DataCenter.packData:getItemVoByUnId(arr[i]);
        if tvo.sub_type == _type then
            id_list[tvo.talent_id] = 1;
        end
    end

    local id;
    local weight;
    local isStudy;
    local isRecommend;
    local info = Array();
    local talentInfo = DataCenter.talentUtil:getTalentInfoByLevel(1);
    if talentInfo ~= nil then
        for i=1,talentInfo:getSize() do
            id = talentInfo[i];
            isStudy = (id_list[id] == 1);--是否领悟
            isRecommend = (_list[id] == 1);--是否推荐
            weight = Lua_TalentConfigData.getConfigData(id).sort;
            if isStudy == true then
                isRecommend = false;
                weight = -1000000000+ weight;
            end
            if isRecommend == true then
                weight = -1000000 + weight;
            end
            info:add({id = id, isSelect = false, isStudy = isStudy, isRecommend = isRecommend,sort = weight});
        end
        info:sort("sort",false);
    end
    return info;
end

--封装数据
function Lua_TalentData:getTalentSealInfo(_type)
    local info = Array();
    local arr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_TALENT);
    local tvo;
    for i = 1, arr:getSize() do
        tvo = DataCenter.packData:getItemVoByUnId(arr[i]);
        if tvo.sub_type == _type then
            info:add({data = tvo, isSelect = false, sort = Lua_TalentConfigData.getConfigData(tvo.talent_id).sort});
        end
    end
    info:sort("sort",false);
    return info;
end











---------------------------------- 红点 -------------------------------------------

-- 检测战技红点
function Lua_TalentData:checkTalentRedDotState(heroVo)
    if heroVo == nil then
        return false;
    end
    -- 战技学习红点
    local red_state = false;
    for i=1,2 do
        if self:getTalentStudyRedDot(heroVo.unique_id, i) == nil then
            self:addStudyRedDic(heroVo, i);--添加战技红点数据
        end
        if red_state == false then
            red_state = self:getTalentStudyRedDot(heroVo.unique_id, i);
        end
    end
    
    if red_state == true then
        return true;
    end

    local isUnlock;
    local talentInfo = heroVo.talentInfo;
    for i=1,2 do
        isUnlock = DataCenter.talentUtil:talentPartUnlock(i, heroVo.level, heroVo.star);
        if isUnlock == true then--部位已解锁
            if talentInfo[i] ~= 0 then--部位已经学习战技
                if self:talentUpgradeRedDot(talentInfo[i]) == true then--战技升级红点
                    return true;
                end
            end
        end
    end

    return false;
end
     
--战技学习红点
function Lua_TalentData:addStudyRedDic(heroVo, part)
    local unique_id = heroVo.unique_id;

    if self.talentRedDotDic[unique_id] == nil then
        self.talentRedDotDic[unique_id] = {};
    end
    if self.talentRedDotDic[unique_id][part] == nil then
        self.talentRedDotDic[unique_id][part] = {};
    end
    local bool = self:checkTalentStudyRedDot(heroVo, part);
    -- print(part," 战技学习红点 ",bool)
    self.talentRedDotDic[unique_id][part] = bool;
end

--获取战技学习红点数组
function Lua_TalentData:getTalentStudyRedDotList(unique_id)
    if self.talentRedDotDic == nil and self.talentRedDotDic[unique_id] == nil then
        return nil;
    end

    return self.talentRedDotDic[unique_id];
end

--获取战技学习红点状态
function Lua_TalentData:getTalentStudyRedDot(unique_id, part)
    if self.talentRedDotDic == nil or self.talentRedDotDic[unique_id] == nil or self.talentRedDotDic[unique_id][part] == nil then
        return nil;
    end

    return self.talentRedDotDic[unique_id][part];
end

--手动更新战技学习红点
function Lua_TalentData:updateTalentStudyRedDotState(heroVo, part, new_stete)
    local list = self:getTalentStudyRedDotList(heroVo.unique_id);
    if list ~= nil and list[part] ~= nil then
        local old_stete = list[part];
        if old_stete == new_stete then
            return;
        end

        list[part] = new_stete;
        if old_stete ~= new_stete then
            if heroVo.isShowFight == true then
                Lua_MsgUtil.callFunc("UPDATE_HERO_REDDOT_STATE");--更新战技学习红点状态
            end
            Lua_MsgUtil.callFunc("UPDATE_TALENT_PANEL_REDDOT_STATE");--更新界面战技学习红点状态
        end
    end
end

--检测学习战技红点
function Lua_TalentData:checkTalentStudyRedDot(heroVo, part)
    local talentInfo = heroVo.talentInfo;
    local left_talent_id = talentInfo[1];--左槽战技id
    local right_talent_id = talentInfo[2];--右槽战技id
    local isUnlock_l = DataCenter.talentUtil:talentPartUnlock(1, heroVo.level, heroVo.star);
    local isUnlock_r = DataCenter.talentUtil:talentPartUnlock(2, heroVo.level, heroVo.star);
    if sUnlock_l == false and isUnlock_r == false then--都未解锁
        return false;
    end
    if left_talent_id ~= 0 and right_talent_id ~= 0 then--已学习战技
        return false;
    end

    local tag_state;--需要判断背包数量
    local tag_talent_id;--需要比较类型的战技id
    if part == 1 then --左槽
        if isUnlock_l == false or left_talent_id ~= 0 then --未解锁/已学习战技
            return false;
        end
        if right_talent_id == 0 then--右槽未学战技
            tag_state = true;
        else
            tag_talent_id = right_talent_id;--右槽已学战技，
        end
    elseif part == 2 then--右槽
        if isUnlock_r == false or right_talent_id ~= 0 then --未解锁/已学习战技
            return false;
        end
        if left_talent_id == 0 then--左槽未学战技，
            tag_state = true;
        else
            tag_talent_id = left_talent_id;--右槽已学战技，
        end
    end

    return self:showRedDotState(tag_state, tag_talent_id);
end

--判断红点
function Lua_TalentData:showRedDotState(tag_state, talent_id)
    if tag_state == true then
        local arr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_TALENT);
        if arr ~= nil and arr:getSize() > 0 then
            return true;
        end
    end

    if talent_id ~= nil then
        local data = Lua_TalentConfigData.getConfigData(talent_id);
        if data ~= nil then
            local talent_type = data.type;
            local arr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_TALENT);
            if arr ~= nil and arr:getSize() > 0 then
                local tvo;
                local _type;
                for i = 1, arr:getSize() do
                    tvo = DataCenter.packData:getItemVoByUnId(arr[i]);
                    _type = Lua_TalentConfigData.getConfigData(tvo.talent_id).type;--背包战技的战技类型
                    if _type ~= talent_type then
                        return true;
                    end
                end
            end
        end
    end

    return false;
end

--战技升级红点
function Lua_TalentData:talentUpgradeRedDot(talent_id)
    local talent_data = Lua_TalentConfigData.getConfigData(talent_id);
    if talent_data == nil then
        return false;
    end
    --满级
    if talent_data.next_id == nil or talent_data.next_id == 0 then
        return false;
    end
    local need_num;
    local have_num;
    local list = talent_data.upgarde_cost;
    for i=1,#list do
        need_num = list[i][2];
        have_num = DataCenter.packData:getItemCountById(list[i][1]);
        if have_num < need_num then
            return false;
        end
    end
    return true;
end