checkRequire("Lua_HundredCeremonyVo");
Lua_HundredCeremonyData = class("Lua_HundredCeremonyData");
function Lua_HundredCeremonyData:ctor()
	self.end_time = 0;
	self._isCanDraw = false;
	self.HundredCeremonyDic = {};
	self._hcGiftInfoArr = Array();
end

function Lua_HundredCeremonyData:dispose()
	if self._hcGiftInfoArr ~= nil then
		self._hcGiftInfoArr:dispose();
		self._hcGiftInfoArr:clear();
	end
	self.HundredCeremonyDic = {};
	self._isCanDraw = false;
	self.end_time = 0;
end

function Lua_HundredCeremonyData:fromServer50197033(msg)
	if msg == nil then
		return;
	end

	self.end_time = msg.end_time; -- 活动结束时间

	-- 奖励状态 key:第几天 value:领取状态(0不可领取 1未领取 2已领取)
	local rewardInfo;
	local id;
	local vo;
	local drwaState;
	self._isCanDraw = false;
	for i = 1, #msg.reward_state do
		rewardInfo = msg.reward_state[i];
		id = tonumber(tostring(rewardInfo.key));
		vo = self.HundredCeremonyDic[id];
		if vo == nil then
			local config = getConfig("hundred_ceremony", id);
			if config ~= nil then
				self.isRefresh = true;
				vo = Lua_HundredCeremonyVo.new(id, config);
				self.HundredCeremonyDic[id] = vo;
				self._hcGiftInfoArr:add(id);
			end
		end
		if vo ~= nil then
			drwaState = tonumber(tostring(rewardInfo.value));
			vo:setHCRewardState(drwaState);
			if not self._isCanDraw and drwaState == 1 then
				self._isCanDraw = true;
			end
		end
	end
	-- 策划要求，暂时不对百抽盛典红点做处理
	-- DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Main_HundredCeremony, self._isCanDraw);
end

function Lua_HundredCeremonyData:getHundredCeremonyVo(id)
	return self.HundredCeremonyDic[id];
end

function Lua_HundredCeremonyData.Get:hcGiftInfoArr()
	if self.isRefresh then
		self.isRefresh = false;
		self._hcGiftInfoArr:sort(nil, false);
	end
	return self._hcGiftInfoArr;
end

function Lua_HundredCeremonyData.Get:showTime()
	return self.end_time - DataCenter.roleData.serverTime;
end

-- 按顺序领取奖励，最后一个领完即结束
function Lua_HundredCeremonyData.Get:isActEnd()
	local len = self.hcGiftInfoArr:getSize();
	-- print(DataCenter.funcOpenData:isOpened(10241), len);
	if not DataCenter.funcOpenData:isOpened(10241) or len == 0 then -- 断线重连时 0
		return false;
	end
	local vo = self:getHundredCeremonyVo(self.hcGiftInfoArr[len]);
	return vo.state == 2;
end

function Lua_HundredCeremonyData.Get:isCanDraw()
	return self._isCanDraw;
end