checkRequire("Lua_InfinityHallTypeVo");
checkRequire("Lua_InfinityHallLayerVo");
Lua_InfinityHallData = class("Lua_InfinityHallData")
function Lua_InfinityHallData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_InfinityHallData:dispose()
	self.bInfinityHallOpened = false;
	self.typeDic = nil;
	self.rewardDic = nil;
end

function Lua_InfinityHallData.Get:curType()
	return self._curType == nil and 1 or self._curType;
end

function Lua_InfinityHallData.Set:choose_hero(value)
	if value == nil or tonumber(value.hero_id) <= 0 then
		self._chooseHeroVo = nil
	else
		if self._chooseHeroVo == nil then
			self._chooseHeroVo = Lua_HeroVo.new(value.hero_id)
		else
			self._chooseHeroVo:setData(value.hero_id)
		end
		self._chooseHeroVo:fromServer(value)
		self._chooseHeroVo.assist = 1;-- 0 不是援助，1 邀请援助
	end
	self._choose_hero = value
end

function Lua_InfinityHallData.Get:choose_hero()
	return self._choose_hero
end

function Lua_InfinityHallData.Get:chooseHeroVo()
	return self._chooseHeroVo
end

function Lua_InfinityHallData:fromServer50193001(msg)
	if msg == nil then
		return;
	end

	self._curType = msg.type; -- 今日模式：1单人，2团队
	local vo = self:getTypeInfo(msg.hall_info.type);
	vo:fromServer(msg.hall_info);
	if vo.id == self._curType then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.InfinityHall_Fight, not vo.bMaxLayer);
	end

	self.choose_hero = msg.choose_hero; -- 今日选择的助阵英雄
	self.set_hero = msg.set_hero; -- 今日设定的支援英雄
	self.daily_stage_id = msg.daily_stage_id; -- 每日奖励关卡id
	self.draw_state = msg.draw_state; -- 每日奖励可领取状态 0无奖励 1可领取 2已领取
	self.daily_times = msg.daily_times; -- 今日通关次数

	self:checkSupportRedPoint();
	self:checkDailyRewardRedPoint();
end

function Lua_InfinityHallData:fromServer50193003(msg)
	if msg == nil then
		return;
	end

	self.choose_hero = msg.hero;
end

function Lua_InfinityHallData:fromServer50193004(msg)
	if msg == nil then
		return;
	end

	self.set_hero = msg.hero;
	self:checkSupportRedPoint();
end

function Lua_InfinityHallData:fromServer50193005(msg)
	if msg == nil then
		return;
	end

	self:setRewardState(msg.reward);
	self:checkRewardRedPoint();
end

function Lua_InfinityHallData:fromServer50193008(msg)
	if msg == nil then
		return;
	end

	self:setRewardState(msg.hall_reward);
	self:checkRewardRedPoint();
end

function Lua_InfinityHallData:fromServer50193009(msg)
	if msg == nil then
		return;
	end

	local vo = self:getTypeInfo(msg.type);
	vo = vo:updateLayerInfo(msg.floor);
	if vo.state == 0 then
		OperateAlert.showLangValue(304004);
	else
		Lua_MsgUtil.callFunc("INFINITYHALL_LAYER_INFO", vo);
	end
end

function Lua_InfinityHallData:getTypeInfo(t)
	if self.typeDic == nil then
		self.typeDic = {};
	end
	if self.typeDic[t] == nil then
		self.typeDic[t] = Lua_InfinityHallTypeVo.new(t);
	end
	return self.typeDic[t];
end

function Lua_InfinityHallData:setRewardState(list)
	if list == nil then
		return;
	end
	if self.rewardDic == nil then
		self.rewardDic = {};
	end

	local obj;
	for i = 1, #list do
		obj = list[i];
		self.rewardDic[tonumber(obj.key)] = tonumber(obj.value);
	end
end

function Lua_InfinityHallData:getRewardState(id)
	if self.rewardDic == nil or self.rewardDic[id] == nil then
		return 0;
	end
	return self.rewardDic[id];
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
function Lua_InfinityHallData:getHeroList(campType, careerType, lineup_type, team_index)
	local arr = Array();
	local heroVo = self.chooseHeroVo
	if heroVo then
		if (campType == 0 or heroVo.campType == campType) and (careerType == 0 or heroVo.career == careerType) then
			arr:add(heroVo);
		end
	end

	local vo = DataCenter.heroLineupData:getLineupVo(lineup_type);
	local uidArr = DataCenter.heroData.allHeroUidArr;
	for i = 1, uidArr:getSize() do
		heroVo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
		if (campType == 0 or heroVo.campType == campType)
			and (careerType == 0 or heroVo.career == careerType)
			and not heroVo.is_league_transaction
			and (not heroVo.trial_state or vo.bShowTrial)
			then
			arr:add(heroVo);
		end
	end

	arr:sortf(self, self.heroListSortFun, { lineup_type = lineup_type, team_index = team_index })
	return arr
end

function Lua_InfinityHallData:heroListSortFun(a, b, param)
	local vo = DataCenter.heroLineupData:getLineupVo(param.lineup_type)
    local _a
    local _b
    local standIdx
	if a.assist == 1 then
		standIdx = vo:getHeroStandIdx(a.unique_id)
		if standIdx then
			_a = 90000000000 + a.heroForce
		else
			_a = a.heroForce
		end
	else
		_a = a:lineupSort(param.lineup_type, param.team_index)
	end
	if b.assist == 1 then
		standIdx = vo:getHeroStandIdx(b.unique_id)
		if standIdx then
			_b = 90000000000 + b.heroForce
		else
			_b = b.heroForce
		end
	else
		_b = b:lineupSort(param.lineup_type, param.team_index)
	end
	
	if _a < _b then
		return false
	elseif _a == _b then
		if a.star < b.star then
			return false
		elseif a.star == b.star then
			if a.level < b.level then
				return false
			elseif a.level == b.level then
				if a.color < b.color then
					return false
				elseif a.color == b.color then
					if a.sort > b.sort then
						return false
					end
				end
			end
		end
	end
    return true
end

-- 判断是否拥有可上阵英雄（与已上阵相同的重复英雄筛除）
function Lua_InfinityHallData:checkPackHaveHero(lineupType)
	local vo = DataCenter.heroLineupData:getLineupVo(lineupType);
	local lineupDic = vo.heroDic;
	local existDic = {} --已上阵英雄
	local heroVo = self.chooseHeroVo
	local uniqueId
	local heroId
	for i = 1, #lineupDic do
		arr = lineupDic[i]
		for j = 1, lineupDic[i]:getSize() do
			uniqueId = lineupDic[i][j]
			if uniqueId > 0 then
				if heroVo and heroVo.unique_id == uniqueId then
					existDic[heroVo.id] = j
				else
					heroId = DataCenter.heroData:getItemByUniqueId(uniqueId).id
					existDic[heroId] = j
				end
			end
		end
	end

	if heroVo and existDic[heroVo.id] == nil then
		return true
	end

	local arr = DataCenter.heroData.allHeroUidArr
	for i = 1, arr:getSize() do
		heroVo = DataCenter.heroData:getItemByUniqueId(arr[i]);
		if existDic[heroVo.id] == nil and not heroVo.is_league_transaction and (not heroVo.trial_state or vo.bShowTrial) then
			return true
		end
	end
	return false
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
function Lua_InfinityHallData:checkSupportRedPoint()
	if self.curType == 2 and self.set_hero == nil or tonumber(self.set_hero.unique_id) <= 0 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.InfinityHall_Support, true);
	else
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.InfinityHall_Support, false);
	end
end

function Lua_InfinityHallData:checkRewardRedPoint()
	local data = self:getTypeInfo(1);
	local arr;
	local state = 0;
	for i = 1, data.layerArr:getSize() do
		arr = data.layerArr[i].rewardArr;
		for j = 1, arr:getSize() do
			state = self:getRewardState(arr[j].id);
			if state == 1 then
				break;
			end
		end
		if state == 1 then
			break;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.InfinityHall_Reward_Single, state == 1);

	data = self:getTypeInfo(2);
	state = 0;
	for i = 1, data.layerArr:getSize() do
		arr = data.layerArr[i].rewardArr;
		for j = 1, arr:getSize() do
			state = self:getRewardState(arr[j].id);
			if state == 1 then
				break;
			end
		end
		if state == 1 then
			break;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.InfinityHall_Reward_Team, state == 1);
end

function Lua_InfinityHallData:checkDailyRewardRedPoint()
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.InfinityHall_Daily_Reward, self.draw_state == 1);
end