Lua_InfinityHallLayerVo = class("Lua_InfinityHallLayerVo")
function Lua_InfinityHallLayerVo:ctor(layerType, id)
	self.layerType = layerType;
	self.id = id;
end

function Lua_InfinityHallLayerVo:fromServer(msg)
	self._round = msg.round; -- 已通关波数
	self._state = msg.state; -- 通关状态：0未解锁，1挑战中，2已通关

	-- 奖励信息：key：索引，value：0不可领取，1可领取，2已领取
	DataCenter.infinityHallData:setRewardState(msg.reward);
end

function Lua_InfinityHallLayerVo.Get:round()
	return self._round == nil and 0 or self._round;
end

function Lua_InfinityHallLayerVo.Set:state(value)
	self._state = value;
end

function Lua_InfinityHallLayerVo.Get:state()
	return self._state == nil and 0 or self._state;
end

function Lua_InfinityHallLayerVo.Get:config()
	local id;
	if self.round <= 0 then
		id = self.layerType * 10000000 + self.id * 1000 + 1;
	else
		id = self.layerType * 10000000 + self.id * 1000 + self.round;
	end
	return DataCenter.infinityHallUtil:getLayerConfig(id);
end

function Lua_InfinityHallLayerVo.Get:force()
	return self.config.force;
end

function Lua_InfinityHallLayerVo.Get:rewardArr()
	if self._rewardArr == nil then
		self._rewardArr = Array();
		local maxRound = DataCenter.infinityHallUtil:getConstConfig("max_round", 1, 0);
		local id;
		local config;
		for i = 1, maxRound do
			id = self.layerType * 10000000 + self.id * 1000 + i;
			config = DataCenter.infinityHallUtil:getLayerConfig(id);
			if config and config.reward then
				self._rewardArr:add(config);
			end
		end
	end
	return self._rewardArr;
end