Lua_InfinityHallTypeVo = class("Lua_InfinityHallTypeVo")
function Lua_InfinityHallTypeVo:ctor(id)
	self.id = id;
	self.maxLayer = DataCenter.infinityHallUtil:getConstConfig("max_floor", 1, 0);
end

function Lua_InfinityHallTypeVo.Get:layerArr()
	if self._layerArr == nil then
		self._layerArr = Array();
		local vo;
		for i = 1, self.maxLayer do
			vo = Lua_InfinityHallLayerVo.new(self.id, i);
			self._layerArr:add(vo);
		end
	end
	return self._layerArr;
end

function Lua_InfinityHallTypeVo:fromServer(msg)
	self.rank_list = msg.rank_list; -- 前三名信息，value：第几层，sub_value：第几波
	self._cur_floor = msg.cur_floor; -- 当前层数
	self:updateLayerInfo(msg.floor); -- 挑战层信息
end

function Lua_InfinityHallTypeVo.Get:cur_floor()
	self._cur_floor = self._cur_floor == nil and 0 or self._cur_floor;
	self._cur_floor = self._cur_floor > self.maxLayer and self.maxLayer or self._cur_floor;
	return self._cur_floor;
end

function Lua_InfinityHallTypeVo.Get:bMaxLayer()
	return self.cur_floor >= self.maxLayer
end

function Lua_InfinityHallTypeVo:getLayerVo(floor)
	return self.layerArr[floor];
end

function Lua_InfinityHallTypeVo:updateLayerInfo(msg)
	for i = 1, msg.floor - 1 do
		self.layerArr[i].state = 2;
	end

	local vo = self.layerArr[msg.floor];
	vo:fromServer(msg);
	return vo;
end