-- 生命树格子
Lua_LifeTreeGridVo = class("Lua_LifeTreeGridVo")
function Lua_LifeTreeGridVo:ctor(id, config)
    self.id = id;
    self.config = config;
    if self.config == nil then
        self.config = getConfig("life_tree_seat", id);
    end
    self:initializeInfo()
end

function Lua_LifeTreeGridVo:initializeInfo()
    self.cold_time = 0;
    self.unique_id = 0;
    self.isUnlock = false;
    self.isAheadUnlock = false;
end

function Lua_LifeTreeGridVo:fromServerInfo(msg)
    self.grid_id = msg.key;    --格子id
    self.cold_time = msg.other;--冷缩时间结束(秒)
    self.hero_uid = tonumber(msg.value);--唯一id
end

-- 移动索引
function Lua_LifeTreeGridVo.Get:moveToIndex()
    return Mathf.Ceil(self.id/5);
end

-- 是否可以解锁
function Lua_LifeTreeGridVo.Get:isAheadUnlock()
    return self._isAheadUnlock;
end

function Lua_LifeTreeGridVo.Set:isAheadUnlock(val)
    self._isAheadUnlock = val;
end

-- 是否解锁
function Lua_LifeTreeGridVo.Get:isUnlock()
    return self._isUnlock;
end

function Lua_LifeTreeGridVo.Set:isUnlock(val)
    self._isUnlock = val;
end

--是否放入英雄
function Lua_LifeTreeGridVo.Get:isPutHero()
    if self.hero_uid > 0 then
        return true;
    end
    return false;
end

-- 解锁道具消耗
function Lua_LifeTreeGridVo.Get:first_cost()
    return self.config.first_cost;
end

-- 替补道具消耗
function Lua_LifeTreeGridVo.Get:other_cost()
    return self.config.other_cost;
end

-- 突破后解锁道具消耗
function Lua_LifeTreeGridVo.Get:break_first_cost()
    return self.config.break_first_cost;
end

-- 突破后替补道具消耗
function Lua_LifeTreeGridVo.Get:break_other_cost()
    return self.config.break_other_cost;
end

--解锁红点
function Lua_LifeTreeGridVo.Get:unlockRedDot()
    if self.isUnlock == false and self.isAheadUnlock == true then
        local cost_id;
        local need_num;
        if DataCenter.lifeTreeData.isBreak == true then
            if self.break_first_cost ~= nil then
                cost_id = self.break_first_cost[1][1];
                need_num = self.break_first_cost[1][2];
            else
                return false;
            end
        else
            if self.first_cost ~= nil then
                cost_id = self.first_cost[1][1];
                need_num = self.first_cost[1][2];
            else
                return false;
            end
        end

        local have_num = DataCenter.packData:getItemCountById(cost_id);
        if have_num >= need_num then
            return true;
        end
    end
    return false;
end