-- 英雄系统配置数据
checkRequire("Lua_HeroTabVo");
Lua_LifeTreeUtil = class("Lua_LifeTreeUtil");
Lua_LifeTreeUtil.sceneId = 40111;
Lua_LifeTreeUtil.sceneId2 = 40118;
function Lua_LifeTreeUtil:ctor()
    self:superCall("ctor");
end

-- 同调器入驻神位数量
function Lua_LifeTreeUtil.Get:enter_amount()
    return getConfig("life_tree_const","enter_amount","value");
end

-- 同调器突破初始等级
function Lua_LifeTreeUtil.Get:life_tree_init_level()
    return getConfig("life_tree_const","life_tree_init_level","value");
end

-- 守护格子上限
function Lua_LifeTreeUtil.Get:grid_limit()
    return getConfig("life_tree_const","grid_limit","value");
end

-- 守护栏位刷新消耗
function Lua_LifeTreeUtil.Get:grid_refresh_cost()
    return getConfig("life_tree_const","grid_refresh_cost","arr_value");
end

-- 守护栏位刷新消耗
function Lua_LifeTreeUtil.Get:grid_select_limit()
    if self._grid_select_limit == nil then
        local grid_select_limit = getConfig("life_tree_const","grid_select_limit","arr_value");
        self._grid_select_limit = DataCenter.heroUtil:getHeroAwakenStarByQuality(grid_select_limit[1], grid_select_limit[2]);
    end
    return self._grid_select_limit;
end







--------------------------------------------  神树  --------------------------------------------
-- 获取神树消耗
function Lua_LifeTreeUtil:lifeTreeCost(id)
    return getConfig("life_tree",id,"consume"); 
end

-- 获取神树是否是最大等级
function Lua_LifeTreeUtil:isMaxLevel(id)
    local next_lvl = getConfig("life_tree",id,"next")
    return next_lvl == 0; 
end








--------------------------------------------  神像  --------------------------------------------

-- 基础属性字段
function Lua_LifeTreeUtil.Get:showBaseProp()
    return getConfig("star_statue_const","statue_show_prop","arr_value");
end

-- 加成属性字段
function Lua_LifeTreeUtil.Get:showAddProp()
    return getConfig("star_statue_const","statue_add_prop","arr_value");
end

-- 宝石属性字段
function Lua_LifeTreeUtil.Get:gemShowProp()
    return getConfig("star_statue_const","gem_show_prop","arr_value");
end

-- 宝石镶嵌次数限制
function Lua_LifeTreeUtil.Get:inset_limit()
    return getConfig("star_statue_const","inset_limit","value");
end

-- 神像初始等级上限
function Lua_LifeTreeUtil.Get:statue_limit()
    return getConfig("star_statue_const","statue_limit","value");
end

-- 神像初始等级上限
function Lua_LifeTreeUtil.Get:star_stone_prop()
    return getConfig("star_statue_const","star_stone_prop","arr_value");
end











-- 神像最大等级上限
function Lua_LifeTreeUtil.Get:statue_max_limit()
    return self.inset_limit+self.statue_limit;
end

-- 宝石转换神像等级
function Lua_LifeTreeUtil:getChangeLevel(num)
    if self.exchange_level == nil then
        self.exchange_level = getConfig("star_statue_const","exchange_level","arr_value");
    end
    return (num/self.exchange_level[1])*self.exchange_level[2];
end

-- 星辉神像能量表
function Lua_LifeTreeUtil:getStatueEnergyInfo(id)
    if self._statueEnergyInfo == nil then
        self._statueEnergyInfo = getConfig("star_statue_energy");
    end
    return self._statueEnergyInfo[id];
end

-- 星辉神像等级表
function Lua_LifeTreeUtil:getStarStatueInfo(id)
    if self._starStatueInfo == nil then
        self._starStatueInfo = getConfig("star_statue");
    end
    return self._starStatueInfo[id];
end

--属性展示
function Lua_LifeTreeUtil:getShowProp(cur_list, next_list)
    local arr = Array();
    if cur_list ~= nil then
        local vo;
        for i = 1, #cur_list do
            vo = DataCenter.attributesUtil:createAttrVo(cur_list[i].name);
            if vo ~= nil then
                vo.value = Mathf.Floor(cur_list[i].value + 0.5);
                if next_list ~= nil then
                    if next_list[i] ~= nil then
                        vo.nextValue = Mathf.Floor(next_list[i].value - cur_list[i].value + 0.5);
                    else
                        vo.nextValue = 0;
                    end
                else
                    vo.nextValue = 0;
                end
                arr:add(vo);
            end
        end
        arr:sort("sort", false);
    end
    return arr;
end

--加成属性展示
function Lua_LifeTreeUtil:getShowAddProp(id)
    local arr = Array();
    local cur_info = self:getStarStatueInfo(id);
    local attr_list = self.showAddProp;
    if attr_list ~= nil then
        local vo;
        local cur_value = 0;
        local next_id = cur_info.next_id;
        for i=1,#attr_list do
            vo = DataCenter.attributesUtil:createAttrVo(attr_list[i]);
            if vo ~= nil then
                cur_value = getConfig("star_statue",id, attr_list[i]);
                vo.value = cur_value;
                if next_id ~= 0 and next_id ~= nil then
                    local next_value = getConfig("star_statue",next_id, attr_list[i]);
                    vo.nextValue = next_value - cur_value;
                else
                    vo.nextValue = 0;
                end
                arr:add(vo);
            end
        end
    end
    return arr;
end

--宝石属性展示
function Lua_LifeTreeUtil:getStatuePropInfo()
    local arr = Array();
    local attr_list = self.star_stone_prop;
    if attr_list ~= nil then
        local vo;
        local cur_value = 0;
        local next_value = 0;
        for k,v in pairs(attr_list) do
            vo = DataCenter.attributesUtil:createAttrVo(k);
            if vo ~= nil then
                vo.value = DataCenter.lifeTreeData.stone_num * v;
                if DataCenter.lifeTreeData.stone_num >= self.inset_limit then
                    vo.nextValue = 0;
                else
                    vo.nextValue = v;
                end
                arr:add(vo);
            end
        end
    end
    arr:sort("sort", false);
    return arr;
end