-- 刘海界面
checkRequire("Lua_MainBaseWindow");
checkRequire("Lua_LiuHaiMaskPanel");
Lua_LiuHaiMaskWindow = class("Lua_LiuHaiMaskWindow", Lua_MainBaseWindow);
function Lua_LiuHaiMaskWindow:ctor()
    self:superCall("ctor");
    self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
    self.windowName = "Lua_LiuHaiMaskWindow";
end

function Lua_LiuHaiMaskWindow:buildShowItem()
    self:superCall("buildShowItem");
    DataCenter.mainMenuData:setMenuState(Lua_MenuViewDefine.INDEX_LIUHAI, false)

    self:checkLiuHaiMask();
    self:updateShowHidePos();
end

function Lua_LiuHaiMaskWindow:dispose()
    self:superCall("dispose");
end

function Lua_LiuHaiMaskWindow:onScreenResize()
    self:superCall("onScreenResize");
    self:checkLiuHaiMask();
end

function Lua_LiuHaiMaskWindow:checkLiuHaiMask()
    local height = GlobalVar.screenOffsetTopH;
    if height > 0 then
        if self.liuHaiMaskPanel == nil then
            local half_h = MainWinDefine.V_height / 2;
            self.liuHaiMaskPanel = Lua_LiuHaiMaskPanel.new(self.content);
            self.liuHaiMaskPanel:setRectAnchor(1);
            self.liuHaiMaskPanel:setLocation(0, half_h, 0);
            self.itemDic[Lua_MenuViewDefine.INDEX_LIUHAI] = { item = self.liuHaiMaskPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(0, half_h, 0) };
        end
        self.liuHaiMaskPanel:setLiuHaiMask(height);
    else
        if self.liuHaiMaskPanel then
            self.liuHaiMaskPanel:setLiuHaiMask(0);
        end
    end

    height = GlobalVar.screenOffsetBottomH;
    if height > 0 then
        if self.bottomMask == nil then
            self.bottomMask = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_027", 0, 0, 0, 0);
            self.bottomMask.anchorValue = 7;
            self.bottomMask.pivotValue = 7;
            self.bottomMask.clickScale = false;
            self.bottomMask.clickSound = nil;
            self.bottomMask:addClickFuntion(self, self.onMaskClick);
        end
        self.bottomMask:setEnable(true);
        self.bottomMask:setLocation(0, -height, 0);
        self.bottomMask:SetDimensions(MainWinDefine.V_width, height);
    else
        if self.bottomMask then
            self.bottomMask:setEnable(false);
        end
    end
end

function Lua_LiuHaiMaskWindow:updateShowHidePos()
    -- local w = MainWinDefine.V_width;
    -- local h = MainWinDefine.V_height;
    -- local half_w = MainWinDefine.V_width / 2;
    local half_h = MainWinDefine.V_height / 2;
    if self.itemDic[Lua_MenuViewDefine.INDEX_LIUHAI] and self.liuHaiMaskPanel then
        self.itemDic[Lua_MenuViewDefine.INDEX_LIUHAI] = { item = self.liuHaiMaskPanel, showPos = Vector3(0, 0, 0), hidePos = Vector3(0, half_h, 0) };
    end
end