-- 右下角图标
Lua_DownRightPanel = class("Lua_DownRightPanel", Lua_DisplayObject);
function Lua_DownRightPanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_DownRightPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.openState = DataCenter.mainMenuData.bDownRightShrinkState;
    self.startX = -62.5;
    self.startY = 204.5;
	self.spaceX = -92.5;
	self.spaceY = 83.5;
	self.iconDic = {};
	self.iconArr = Array();
	
	self.btnUnfold = UICreate.createUIAtlasImage(self.content, "menuIcon", "xui_zjm_btn_008_n", self.startX, self.startY, 0, 0);
	self.btnUnfold:addClickFuntion(self, self.onBtnUnfoldClick);
	
	self.btnAdd = UICreate.createUIAtlasImage(self.content, "menuIcon", "xui_zjm_btn_009_n", self.startX, self.startY, 0, 0);
	if self.openState then
		self.btnAdd:setRot(0, 0, 90);
	else
		self.btnAdd:setRot(0, 0, 0);
	end
	
	self:addLuaEvent("MENUICON_ALL_UPDATE", self, self.onUpdateIcon);
	self:showIcon();
	self:checkRedDot();
end

function Lua_DownRightPanel:dispose()
	TweenUtil.getInstance():stop(self.btnAdd.mainContent);
	local icon;
    while self.iconArr:getSize() > 0 do
        icon = self.iconArr:remove();
        TweenUtil.getInstance():stop(icon.mainContent);
        icon:dispose();
        icon = nil;
    end
    self.iconArr:dispose();
    self.iconArr:clear();
    self.iconArr = nil;
    self.iconDic = nil;

    if self.unfoldRedDot then
    	self.unfoldRedDot:dispose();
    	self.unfoldRedDot = nil;
    end

	self:superCall("dispose");
end

function Lua_DownRightPanel:showIcon()
	local arr = DataCenter.mainMenuData:getMenuDataByPosType(Lua_MenuViewDefine.POS_DOWNRIGHT_ICON);
	if arr == nil then
		return;
	end

    local vo;
    local icon;
    local shIdx = 0;
    local svIdx = 0;
    local hIdx = 0;
    local vIdx = 0;
    local posX;
    local posY;
	for i = 1, arr:getSize() do
		vo = arr[i];
		if self.iconDic[vo.uniqueId] == nil then
			icon = self:addIcon(vo);
			self.iconDic[vo.uniqueId] = icon;
		else
			icon = self.iconDic[vo.uniqueId];
			icon:updateData();
		end

		if vo.put_pos == 1 then -- 横排
			hIdx = hIdx + 1;
			posY = self.startY;
			if vo:checkShrinkShow() == true then
				shIdx = shIdx + 1;
				vo.startX = self.startX + shIdx * self.spaceX;
				vo.startY = posY;

				vo.posX = self.startX + hIdx * self.spaceX;
				vo.posY = posY;

				if self.openState then
					posX = vo.posX;
				else
					posX = vo.startX;
				end
			else
				vo.startX = self.startX;
				vo.startY = self.startY;
				vo.posX = self.startX + hIdx * self.spaceX;
				vo.posY = posY;

				if self.openState then
					posX = vo.posX;
					icon:setAlpha(1);
					icon:setIconEffShow(true);
				else
					posX = vo.startX;
					icon:setAlpha(0);
					icon:setIconEffShow(false);
				end
			end
		else
			vIdx = vIdx + 1;
			posX = self.startX;
			if vo:checkShrinkShow() == true then
				svIdx = svIdx + 1;
				vo.startX = self.startX;
				vo.startY = self.startY + svIdx * self.spaceY;

				vo.posX = posX;
				vo.posY = self.startY + vIdx * self.spaceY;

				if self.openState then
					posY = vo.posY;
				else
					posY = vo.startY;
				end
			else
				vo.startX = self.startX;
				vo.startY = self.startY;
				vo.posX = posX;
				vo.posY = self.startY + vIdx * self.spaceY;

				if self.openState then
					posY = vo.posY;
					icon:setAlpha(1);
					icon:setIconEffShow(true);
				else
					posY = vo.startY;
					icon:setAlpha(0);
					icon:setIconEffShow(false);
				end
			end
		end
		icon:setLocation(posX, posY, 0);
	end
end

function Lua_DownRightPanel:addIcon(vo)
    local icon = Lua_MainMenuIcon.new(self.content);
    icon:setData(vo);
    self.iconArr:add(icon);
    return icon;
end

function Lua_DownRightPanel:onBtnUnfoldClick(go)
	TweenUtil.getInstance():stop(self.btnAdd.mainContent);
	if self.openState then
		TweenUtil.getInstance():addTweenTargetRot(self.btnAdd.mainContent, 1, 0, 0, 0, 0, 0, false);
	else
		TweenUtil.getInstance():addTweenTargetRot(self.btnAdd.mainContent, 1, 0, 0, 0, 90, 0, false);
	end
	self:onShowHide();
	self.openState = not self.openState;
	DataCenter.mainMenuData.bDownRightShrinkState = self.openState;
	self:checkRedDot();
end

function Lua_DownRightPanel:onShowHide()
	local len = self.iconArr:getSize();
	local data;
	if self.openState then
		for i = 1, len do
			data = self.iconArr[i].data;
			if data:checkShrinkShow() == false then
				self.iconArr[i]:addAlphaTween(1, 0, -0.3);
			end
			TweenUtil.getInstance():stop(self.iconArr[i].mainContent);
			TweenUtil.getInstance():addTweenTargetPos(self.iconArr[i].mainContent, 1, 0, data.startX, data.startY, 0, 0, false);
		end
	else
		for i = 1, len do
			data = self.iconArr[i].data;
			if data:checkShrinkShow() == false then
				self.iconArr[i]:addAlphaTween(0, 1, 0.3);
			end
			TweenUtil.getInstance():stop(self.iconArr[i].mainContent);
			TweenUtil.getInstance():addTweenTargetPos(self.iconArr[i].mainContent, 1, 0, data.posX, data.posY, 0, 0, false);
		end
	end
end

function Lua_DownRightPanel:checkRedDot()
	if self.openState then
		if self.unfoldRedDot then
			self.unfoldRedDot:updateRedPointShow(false);
		end
		return;
	end

	local arr = DataCenter.mainMenuData:getMenuDataByPosType(Lua_MenuViewDefine.POS_DOWNRIGHT_ICON);
	if arr == nil then
		if self.unfoldRedDot then
			self.unfoldRedDot:updateRedPointShow(false);
		end
		return;
	end

	local bRedDotState = false;
	for i = 1, arr:getSize() do
		if not arr[i]:checkShrinkShow() and arr[i].bRedDotState then
			bRedDotState = true;
			break;
		end
	end
	if bRedDotState then
		if self.unfoldRedDot == nil then
            self.unfoldRedDot = Lua_RedPointIcon.new(self.content);
            self.unfoldRedDot:createRedPointEff();
            self.unfoldRedDot:setLocation(-37.5, 229.5);
		end
		self.unfoldRedDot:updateRedPointShow(true);
	else
		if self.unfoldRedDot then
			self.unfoldRedDot:updateRedPointShow(false);
		end
	end
end

function Lua_DownRightPanel:onUpdateIcon(param)
    self:showIcon();
end