--联盟系统 游戏主界面红包通知panel
Lua_AllianceRedPacketNoticePanel = class("Lua_AllianceRedPacketNoticePanel", Lua_DisplayObject);

function Lua_AllianceRedPacketNoticePanel:ctor(p)
	self:superCall("ctor", p, "AllianceRedPacketNoticePanel_skin");
end

function Lua_AllianceRedPacketNoticePanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("UPDATE_LEAGUE_REDPACKET_NOTICE", self, self.updateShow);
	self:addLuaEvent("REMOVE_LEAGUE_REDPACKET", self, self.updateNextShow);
	self:addLuaEvent("REFRESH_LEAGUE_REDPACKET_NOTICE", self, self.refreshShow);
end

function Lua_AllianceRedPacketNoticePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.defaultTime = 30;
	self.timer = 0;
	self.isTimer = false;

	self.showImg.alpha = 0.02;
	self.showImg.mouseEnable = false;
	self.showImg:addClickFuntion(self, self.onReceiveBtnClick);
end

function Lua_AllianceRedPacketNoticePanel:dispose()
	if self.showEff ~= nil then
		self.showEff:dispose();
		self.showEff = nil;
	end

	self:removeTimer(self, self.onCountDown);
	DataCenter.allianceData:clearAllPlayRedPacket();
	self:superCall("dispose");
end

function Lua_AllianceRedPacketNoticePanel:updateShow()
	local arr = DataCenter.allianceData:getPlayRedPacketArr();
	if arr ~= nil and arr:getSize() > 0 then
		if not self.isTimer then
			self.isTimer = true;

			self.timer = self.defaultTime;
			self:addTimer("onCountDown", 1, self, self.onCountDown);
			
			if self.showEff == nil then
				self.showEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_gh_hongbao", "ui_gh_hongbao", -360, 720);
			end
			self.showEff:setEnable(true);
			self.showImg.mouseEnable = true;

			self.curUid = arr[1];
		end
	else
		self:removeTimer(self, self.onCountDown);
		self.isTimer = false;
		
		if self.showEff ~= nil then
			self.showEff:setEnable(false);
		end
		self.showImg.mouseEnable = false;

		DataCenter.allianceData:clearAllPlayRedPacket();
	end
end

function Lua_AllianceRedPacketNoticePanel:onCountDown()
	self.timer = self.timer - 1;
	if self.timer == 0 then
		self:removeTimer(self, self.onCountDown);
		self.isTimer = false;

		DataCenter.allianceData:removePlayRedPacket(self.curUid, false);
		self:updateShow();
	end
end

function Lua_AllianceRedPacketNoticePanel:onReceiveBtnClick()
	local data = DataCenter.allianceData:getPlayRedPacketInfo(self.curUid);
	if data ~= nil then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sReceiveAllianceRedPacket(self.curUid);
		if DataCenter.allianceData:getRedPacketLeftNum(data.red_pack_type) <= 0 then
			self:refreshShow();
		end
	end
end

function Lua_AllianceRedPacketNoticePanel:updateNextShow(uid)
	if self.curUid == uid then
		self:refreshShow();
	end
end

function Lua_AllianceRedPacketNoticePanel:refreshShow()
	self:removeTimer(self, self.onCountDown);
	self.isTimer = false;
	self:updateShow();
end