-- 主功能图标
Lua_MainIconPanel = class("Lua_MainIconPanel", Lua_DisplayObject);
function Lua_MainIconPanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_MainIconPanel:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("MENUICON_ALL_UPDATE", self, self.onUpdateIcon);
    self:addLuaEvent("MAIN_ICON_SELECT", self, self.onUpdateSelect);

    self.lineList = Array();
    self.startPosX = 301;
    self.iconDic = {};
    self.iconArr = Array();
    
    self.bottomBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_widget_002", 0, 121, 720, 121 + GlobalVar.screenOffsetBottomH);
    self.bottomBg.pivotValue = 1;
    self:showIcon();
    self:onUpdateSelect(DataCenter.mainMenuData.selectMainIconId);
end

function Lua_MainIconPanel:dispose()
    self.bottomBg = nil;
    if self.lineList then
        self.lineList:dispose();
        self.lineList:clear();
        self.lineList = nil;
    end
    if self.iconArr then
        self.iconArr:dispose();
        self.iconArr:clear();
        self.iconArr = nil;
    end
    self.iconDic = nil;
    self:superCall("dispose");
end

function Lua_MainIconPanel:showIcon()
    local arr = DataCenter.mainMenuData:getMenuDataByPosType(Lua_MenuViewDefine.POS_MAIN_ICON);
    local len = arr:getSize();

    local count = len - 1;
    local posX;
    local step = Mathf.Floor((241.5 * 2) / (count - 1));
    local line;
    for i = 1, count do
        line = self.lineList[i];
        if i > count then
            if line ~= nil then
                line:setEnable(false);
            end
        else
            if line == nil then
                line = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_line_001", 0, 0, 0, 0);
                self.lineList:add(line);
            else
                line:setEnable(true);
            end
            posX = 241.5 - (i - 1) * step;
            line:setLocation(posX, 54, 0);
        end
    end

    step = Mathf.Floor((self.startPosX * 2) / (len - 1));
    local vo;
    local icon;
    for i = 1, len do
        vo = arr[i];
        if self.iconDic[vo.uniqueId] == nil then
            icon = self:addIcon(vo);
            self.iconDic[vo.uniqueId] = icon;
        else
            icon = self.iconDic[vo.uniqueId];
            icon:updateData();
        end
        posX = self.startPosX - (i - 1) * step;
        icon:setLocation(posX, 54, 0);
    end
end

function Lua_MainIconPanel:addIcon(vo)
    local icon = Lua_MainMenuIcon.new(self.content);
    icon:setData(vo);
    self.iconArr:add(icon);
    return icon;
end

function Lua_MainIconPanel:onUpdateIcon(param)
    self:showIcon();
end

function Lua_MainIconPanel:onUpdateSelect(uniqueId)
    if uniqueId == nil then
        return;
    end

    for _, v in pairs(self.iconDic) do
        if v.uniqueId == uniqueId then
            v:setSelected(true);
        else
            v:setSelected(false);
        end
    end
end