Lua_TaskPanel = class("Lua_TaskPanel", Lua_DisplayObject);
function Lua_TaskPanel:ctor(p)
    self:superCall("ctor", p, "TaskPanel_skin");
end

function Lua_TaskPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.redPointIcon = Lua_RedPointIcon.new(self.content, Lua_RedPointList.ExploreTour);
    self.redPointIcon:setLocation(85, 255, 0);

    self:updateInfo();

    self.bg_1.clickScale = false;
    self.bg_1:addClickFuntion(self, self.onBgClcik);
    self.bg_2:addClickFuntion(self, self.onBgClcik);

    self:addLuaEvent("UPDATE_EXPLORER_TOUR_INFO", self, self.updateInfo);
end

function Lua_TaskPanel:dispose()
    if self.redPointIcon ~= nil then
        self.redPointIcon:dispose();
        self.redPointIcon = nil;
    end
    self:superCall("dispose");
end

function Lua_TaskPanel:updateInfo()
    local data = DataCenter.taskData;

    --阶段奖励 0:不可领 1:可领取 2:已领取
    if data.curRewardState == 0 then
        local taskVo;
        local arr = DataCenter.taskUtil:getExploreTourTaskArr(data.curStageId);
        if arr ~= nil then
            arr:sort("sort", false);
            taskVo = arr[1];
        end
        self.titleTxt.text = taskVo.title;
        self.desTxt.text = taskVo.description;
        self.schedule.text = LanUtil.formateStr(310006, numberTrans(taskVo.taskProgress), numberTrans(taskVo.process));
    elseif data.curRewardState == 1 then
        self.titleTxt:setLangValue(310007);
        self.desTxt:setLangValue(310008);
        self.schedule.text = nil
    elseif data.curRewardState == 2 then
        self.titleTxt:setLangValue(310007);
        local artifactId = DataCenter.taskUtil:getExploreTourStageInfo(data.curStageId, "unlock_artifact");
        if artifactId ~= nil then
            self.desTxt:setLangValue(310009);
        end
        self.schedule.text = nil
    end
    
end

function Lua_TaskPanel:onBgClcik()
    Lua_WindowUtil.openWin("Lua_ExploreTourWindow", Lua_WinParam.ACTION_OPEN);
end