-- 新英雄主题活动 Data
checkRequire("Lua_NewHeroUpStarVo");
checkRequire("Lua_NewHeroShopHotVo");
Lua_NewHeroActivityData = class("Lua_NewHeroActivityData");
Lua_NewHeroActivityData.RECRUIT = 20004; -- 新英雄招募
function Lua_NewHeroActivityData:ctor()
	self:dispose();
end

function Lua_NewHeroActivityData:dispose()
	self.loginDay = 1;
	self.sevenDayInfoDic = {};

	self.shopHotDic = {};
	self._shopHotArr = Array();

	self.oneDrawTime = 1; -- 招募一次次数
	self.tenDrawTime = 10; -- 招募十次次数
	self.selectNum = 1; -- 招募选择次数
	self.diamondCost = 0; -- 招募钻石消耗

	self.isUpStarFirst = true;
	self.upStar = 0;
	self.upStarDic = {};
	self.upStarArr = Array();

	self.standRewardArr = Array();
	self.totalRewadArr = Array();
	self.warCoinRewardDic = {};
	self.warCoinTaskDic = {};
	self.warCoinTaskArr = Array();

	self.buffInfo = nil;
	self.stageInfo = nil;
	self.stageInfoDic = {};

	if self.dailyTaskArr ~= nil then
		self.dailyTaskArr:dispose();
		self.dailyTaskArr:clear();
		self.dailyTaskArr = nil;
	end
	if self.periodTaskArr ~= nil then
		self.periodTaskArr:dispose();
		self.periodTaskArr:clear();
		self.periodTaskArr = nil;
	end

	-- 剧情关卡
	self.chapterDic = nil;
	self.chapterIds = nil;
	self.chapterLevelDic = nil;
	self.chapterLevelTotalIds = nil;
	self.showChapterId = nil;
	self.storyCurLevelId = nil;
	self.storyCurFightLevelId = nil;
end










------------------------- 20002 七天登录 -------------------------

function Lua_NewHeroActivityData:fromServer50108019(msg)
	if msg == nil then
		return;
	end

	self.loginDay = msg.login_day; -- 玩家登录天数
	self.curdayEndTick = tonumber(tostring(msg.close_tick)); -- 当天结束戳
	local obj;
	local info;
	for i = 1, #msg.gift_list do
		obj = msg.gift_list[i];
		info = self.sevenDayInfoDic[obj.id];
		if info == nil then
			info = {day = obj.id, itemId = obj.item_list.key, itemCount = obj.item_list.value};
			self.sevenDayInfoDic[obj.id] = info;
		end
		info.state = obj.state;
	end
end










------------------------- 20003 商店热卖 -------------------------

function Lua_NewHeroActivityData:fromServer50108022(msg)
	if msg == nil then
		return;
	end

	local obj;
	local vo;
	for i = 1, #msg.gift_list do
		obj = msg.gift_list[i];
		vo = self.shopHotDic[obj.gift_id];
		if vo == nil then
			vo = Lua_NewHeroShopHotVo.new();
			self.shopHotDic[obj.gift_id] = vo;
			self._shopHotArr:add(obj.gift_id);
		end
		vo:updateShopHotInfo(obj);
	end
end

function Lua_NewHeroActivityData:getTheShopHotVo(giftId)
	return self.shopHotDic[giftId];
end

function Lua_NewHeroActivityData.Get:shopHotArr()
	self._shopHotArr:sortf(self, self.sortShopHotFun);
	return self._shopHotArr;
end

function Lua_NewHeroActivityData:sortShopHotFun(a, b)
	local voA = self:getTheShopHotVo(a);
	local voB = self:getTheShopHotVo(b);
	if (voA.hasTimes > 0 and voB.hasTimes > 0) or (voA.hasTimes <= 0 and voB.hasTimes <= 0) then
		if a > b then
			return false;
		end
	else
		if voB.hasTimes > 0 then
			return false;
		end
	end
	return true;
end










------------------------- 20004 新英雄招募 -------------------------

function Lua_NewHeroActivityData:fromServer50108023(msg)
	self.heroId = msg.hero_id; -- 主题英雄id
	self.costItemId = msg.activity_item_id; -- 活动招募道具id

	self.isDiamondCost = msg.cost_diamond == 1; -- 允许钻石召唤 1允许
	self.oneDrawCost = msg.once_item_cost; -- 一次招募钻石数量
	self.tenDrawCost = msg.ten_item_cost; -- 十次招募钻石数量
	self.oneDrawExp = msg.get_exp; -- 钻石招募一次获取经验值

	self.isFreeDraw = msg.is_first == 1; -- 是否首抽 0否 1是
	self.mustTime = msg.residue_draw_times; -- 招募保底剩余次数

	self.strlist = msg.str_list; -- 字符串杂项
	self.nameAtlas = self.strlist[1];
	self.nameSprite = self.strlist[2];

	self.intlist = msg.int_list; -- 数组杂项
	self.sceneId = self.intlist[5];

	self.diamondLimitNum = msg.cost_limit_times; -- 钻石限制次数上限
	self.diamondCostNum = msg.cost_draw_times; -- 钻石剩余限制次数

	Lua_MsgUtil.callFunc("UPDATE_NEWHERO_RECRUIT");
end

function Lua_NewHeroActivityData:fromServer50108024(msg)
	self.actIdx = msg.act_index;

	-- 限时招募使用钻石招募时，有特殊奖励（经验等）需与流放奖励共同展示
	if #msg.reward_item > 0 then
		DataCenter.heroAssemblyData:addRewardInAutoDecoItemDic(msg.reward_item);
	end

	local vo;
	local arr = Array();
	local heroIdArr = Array();
	local maxHeroQuality = 0;
	for k, v in ipairs(msg.hero_list) do
		vo = Lua_ToolVo.createToolVo(v.value);
		if vo ~= nil then
			if maxHeroQuality < vo.quality then
				maxHeroQuality = vo.quality;
			end
			if vo.quality >= 4 then
				heroIdArr:add(vo.id);
			end
			arr:add(vo);
		end
	end

	if arr:getSize() > 0 then
		local dic = {};
		local itemNum = DataCenter.packData:getItemCountById(self.costItemId);
		if self.selectNum == self.oneDrawTime then
			dic.costId = self.costItemId;
			if itemNum < self.oneDrawTime then
				dic.costTxt = LanUtil.formateStr(140337, numberTrans(itemNum), self.oneDrawTime);
			else
				dic.costTxt = LanUtil.formateStr(140338, numberTrans(itemNum), self.oneDrawTime);
			end
		else
			if self.isDiamondCost and self.diamondCostNum >= self.tenDrawTime and itemNum < self.tenDrawTime then
				dic.costId = Lua_ResourcesDefine.DIAMOND;
				local diamondNum = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.DIAMOND);
				if diamondNum < self.tenDrawCost then
					dic.costTxt = LanUtil.formateStr(140337, numberTrans(diamondNum), self.tenDrawCost);
				else
					dic.costTxt = LanUtil.formateStr(140338, numberTrans(diamondNum), self.tenDrawCost);
				end
			else
				dic.costId = self.costItemId;
				if itemNum < self.tenDrawTime then
					dic.costTxt = LanUtil.formateStr(140337, numberTrans(itemNum), self.tenDrawTime);
				else
					dic.costTxt = LanUtil.formateStr(140338, numberTrans(itemNum), self.tenDrawTime);
				end
			end
		end

		dic.maxQuality = maxHeroQuality;
        dic.itemList = arr;
        dic.heroIdArr = heroIdArr;
		Lua_WindowUtil.openWin("Lua_NewHeroActRecruitShowWindow", Lua_WinParam.ACTION_OPEN, dic);
	end
end

function Lua_NewHeroActivityData:fromServer50108046(msg)
	self.drawTime = msg.draw_times;
	self.rewardList = msg.recruit_reward;
	Lua_MsgUtil.callFunc("UPDATE_NEWHERO_RECRUIT_REWARD");
end










------------------------- 20005 新英雄升星专属 -------------------------

function Lua_NewHeroActivityData:fromServer50108029(msg)
	if msg == nil then
		return;
	end

	self.heroId = msg.hero_id; -- 主题活动英雄id
	self.quality = msg.quality; -- 英雄质量
	self.qualityStar = msg.quality_star; -- 英雄质量星级
	self.eventId = msg.return_id; -- 跳转界面id
	self.upStar = DataCenter.heroUtil:getHeroAwakenStarByQuality(msg.quality, msg.quality_star);
	
	local obj;
	local vo;
	for i = 1, #msg.reward_state do -- 各档位奖励状态
		obj = msg.reward_state[i];
		if self.upStarDic[obj.quality] == nil then
			self.upStarDic[obj.quality] = {};
		end

		vo = self.upStarDic[obj.quality][obj.quality_star];
		if vo == nil then
			vo = Lua_NewHeroUpStarVo.new();
			self.upStarDic[obj.quality][obj.quality_star] = vo;
			self.upStarArr:add(vo);
		end
		vo:updateUpStarVoInfo(obj);
	end

	if self.isUpStarFirst then
		self.isUpStarFirst = false;
		self.upStarArr:sort("freeGiftId", false);
		for i = 1, self.upStarArr:getSize() do
			self.upStarArr[i]:setEndStage(i, i == self.upStarArr:getSize());
		end
	end
end










------------------------- 20006 剧情关卡 -------------------------

function Lua_NewHeroActivityData:fromServer50108025(msg)
	if msg == nil then
		return;
	end

	if self.chapterDic == nil then
		self.chapterDic = {};
		self.chapterIds = {};
	end

	local obj = msg.chapter_info;
	for i = 1, #obj do
		self:updateSingleChapter(obj[i]);
	end

	obj = msg.stage_info;
	for i = 1, #obj do
		self:updateChapterLevelInfo(obj[i]);
	end
end

function Lua_NewHeroActivityData:fromServer80108025(msg)
	if msg == nil then
		return;
	end

	local obj = msg.stage_info;
	for i = 1, #obj do
		self:updateChapterLevelInfo(obj[i]);
	end
end

function Lua_NewHeroActivityData:fromServer50108049(msg)
	if msg == nil then
		return;
	end

	local obj = msg.chapter_reward;
	for i = 1, #obj do
		self:updateSingleChapterReward(obj[i]);
	end
end

function Lua_NewHeroActivityData:updateSingleChapter(storyInfo)
	if storyInfo == nil or self.chapterDic == nil then
		return;
	end

	local chapterId = tonumber(storyInfo.chapter_id);
	local data = self:getChapterDataById(chapterId);
	if data == nil then
		data = { chapterId = chapterId, 
				 title = storyInfo.chapter_title, 
				 content = storyInfo.chapter_value, 
				 openTime = tonumber(storyInfo.chapter_times), 
				 state = 0, -- 领取状态 0 不可领取 1可领取 2已领取
				 rewards = {},
				 levelIds = {} };
		self.chapterIds[#self.chapterIds + 1] = chapterId;
		self.chapterDic[chapterId] = data;
	end
end

function Lua_NewHeroActivityData:updateSingleChapterReward(rewardInfo)
	if rewardInfo == nil or self.chapterDic == nil then
		return;
	end

	local chapterId = tonumber(rewardInfo.chapter_id);
	local data = self:getChapterDataById(chapterId);
	if data ~= nil then
		data.state = tonumber(rewardInfo.state);
		local rewards = data.rewards;
		local obj = rewardInfo.reward;
		for i = 1, #obj do
			rewards[i] = { costId = obj[i].key, count = obj[i].value };
		end
	end
end

function Lua_NewHeroActivityData:updateChapterLevelInfo(levelInfo)
	if self.chapterLevelDic == nil then
		self.chapterLevelDic = {};
		self.chapterLevelTotalIds = {};
	end

	local levelId = tonumber(levelInfo.id);
	local data = self:getChapterLevelInfoByLevelId(levelId);
	if data == nil then
		local sever_rewards = {};
		local obj = levelInfo.reward_list;
		for i = 1, #obj do
			sever_rewards[i] = { levelId = levelId, costId = obj[i].key, count = obj[i].value};
		end

		local chapterId = tonumber(levelInfo.chapter_id);
		data = { 
					levelId = levelId, 
					name = levelInfo.name, 
					chapterId = chapterId, 
					state = levelInfo.state, 
					title = levelInfo.title,
					content = levelInfo.content,
					guideId = levelInfo.story_index;
					needFight = levelInfo.is_fight == 1,
					rewards = sever_rewards};
		local count;
		local chapterData = self:getChapterDataById(chapterId);
		if chapterData ~= nil then
			count = #chapterData.levelIds;
			chapterData.levelIds[count + 1] = levelId;
			table.sort( chapterData.levelIds, function(a, b) return a < b; end);
		end
		self.chapterLevelDic[levelId] = data;
		self.chapterLevelTotalIds[#self.chapterLevelTotalIds + 1] = levelId;
		table.sort(self.chapterLevelTotalIds, function(a, b) return a > b; end);
	else
		data.state = levelInfo.state;
	end
end

function Lua_NewHeroActivityData:getChapterDataById(id)
	if self.chapterDic == nil or self.chapterDic[id] == nil then
		return;
	end
	return self.chapterDic[id];
end

-- 关卡数据
function Lua_NewHeroActivityData:getChapterLevelInfoByLevelId(levelId)
	if self.chapterLevelDic == nil or self.chapterLevelDic[levelId] == nil then
		return;
	end
	return self.chapterLevelDic[levelId];
end

-- 全部关卡
function Lua_NewHeroActivityData:getChapterTotalLevelIds()
	return self.chapterLevelTotalIds;
end

function Lua_NewHeroActivityData:getEnableFightLevelIds()
	local levelIds = self:getChapterTotalLevelIds();
	if levelIds == nil then
		return;
	end

	local count;
	local ids = {};
	for i = #levelIds, 1, -1 do
		local levelData = self:getChapterLevelInfoByLevelId(levelIds[i]);
		if levelData == nil then
			break;
		end

		local bPass = levelData.state == 3;
		ids[#ids + 1] = levelIds[i];
		count = #ids;
		if count >= 3 and not bPass then
			break;
		end
	end
	table.sort( ids, function(a, b) return a > b; end );
	return ids;
end

-- 全部篇章
function Lua_NewHeroActivityData:getTotalChaptersIds()
	table.sort( self.chapterIds, function(a, b) 
		local aVo = self:getChapterDataById(a); --state
		local bVo = self:getChapterDataById(b);
		local aValue = aVo.state == 2 and a * 1000000 or a;
		local bValue = bVo.state == 2 and b * 1000000 or b;
		return aValue < bValue; end);

	return self.chapterIds;
end

function Lua_NewHeroActivityData:checkUnlockChapter(chapterId)
	local chapterData = self:getChapterDataById(chapterId);
	if chapterData then
		return chapterData.openTime - DataCenter.roleData.serverTime, chapterData.openTime;
	end
end

function Lua_NewHeroActivityData.Get:showChapterId()
	return self._showChapterId;
end

function Lua_NewHeroActivityData.Set:showChapterId(value)
	self._showChapterId = value;
end

function Lua_NewHeroActivityData:fromServer50108026(msg)
	if msg == nil then
		return;
	end

	if self.storyLevelHeroVoArr == nil then
		self.storyLevelHeroVoArr = Array();
	else
		self.storyLevelHeroVoArr:dispose();
		self.storyLevelHeroVoArr:clear();
	end

	local heroVo;
	local heroId;
	local monsterData;
	local obj = msg.hero_list;
	self.storyLevelHeroIndexDic = {};
	for i = 1, #obj do
		heroId = tonumber(obj[i]);
		monsterData = Lua_MonsterConfigData.getMonsterConfig(heroId);--Lua_HeroVo.new(heroId);
		heroVo = monsterData.heroVo;
		heroVo.unique_id = heroId;
		heroVo.heroForce = monsterData.force;
		self.storyLevelHeroVoArr:add(heroVo);
		self.storyLevelHeroIndexDic[heroId] = self.storyLevelHeroVoArr:getSize();
	end

	-- 上阵阵容
	local heroVo
	self.storyLevelHeroLineup = msg.hero_lineup;
	self.storyLevelHeroLineupUnique_Ids = {};
	local uniqueId;
	for i = 1, #self.storyLevelHeroLineup do
		local obj = self.storyLevelHeroLineup[i].location_list;
		for i = 1, #obj do
			uniqueId = tonumber(obj[i].value);
			self.storyLevelHeroLineupUnique_Ids[uniqueId] = true;
		end
	end

	self.storyLevelMonsterId = tonumber(msg.monster_fighter);
	self.storyLevelCharacterHeroIdDic = {};
	obj = msg.target_hero;
	for i = 1, #obj do
		heroId = tonumber(obj[i]);
		self.storyLevelCharacterHeroIdDic[heroId] = true;
	end
	self:openStoryLevelLineupWin();
end

function Lua_NewHeroActivityData.Get:storyLevelActId()
	return self._storyLevelActId;
end

function Lua_NewHeroActivityData.Set:storyLevelActId(value)
	self._storyLevelActId = value;
end

function Lua_NewHeroActivityData.Get:storyCurLevelId()
	return self._storyCurLevelId;
end

function Lua_NewHeroActivityData.Set:storyCurLevelId(value)
	self._storyCurLevelId = value;
end

function Lua_NewHeroActivityData.Get:storyCurFightLevelId()
	return self._storyCurFightLevelId;
end

function Lua_NewHeroActivityData.Set:storyCurFightLevelId(value)
	self._storyCurFightLevelId = value;
end

function Lua_NewHeroActivityData:getStoryLevelHeroVoByUId(UId)
	if self.storyLevelHeroVoArr == nil or self.storyLevelHeroIndexDic == nil then
		return;
	end
	local index = self.storyLevelHeroIndexDic[UId];
	local heroVo = self.storyLevelHeroVoArr:getItem(index);
	return heroVo;
end

function Lua_NewHeroActivityData:checkCharacterHero(UId)
	if self.storyLevelCharacterHeroIdDic == nil then
		return;
	end
	return self.storyLevelCharacterHeroIdDic[UId] == true;
end

function Lua_NewHeroActivityData:openStoryLevelLineupWin()
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_STORY);
	DataCenter.preLoadData:preShowScene("Lua_NewHeroActStoryLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_NewHeroActivityData:onSceneShow(param)
	local list = { template_id = Lua_FightDefine.TEMPLATE_ID_STORY, stage_id = self.storyCurLevelId, monster_player_id = self.storyLevelMonsterId };
	Lua_WindowUtil.openWin("Lua_NewHeroActStoryLineupWindow", Lua_WinParam.ACTION_OPEN, list);
end

function Lua_NewHeroActivityData:checkPackHaveHero(teamIdxDic)
	if self.storyLevelHeroVoArr == nil then
		return false
	end

	local existDic = {} --已上阵英雄
	local heroVo
	for i = 1, #teamIdxDic do
		for j = 1, teamIdxDic[i]:getSize() do
			heroVo = self:getStoryLevelHeroVoByUId(teamIdxDic[i][j])
			if heroVo then
				local bExist = existDic[heroVo.id] == i;
				if bExist then
					return true;
				else
					existDic[heroVo.id] = i;
				end
			end
		end
	end
	return false
end

function Lua_NewHeroActivityData.Get:storyLevelFighting()
	return DataCenter.fightData:getRecordIdByTemplateId(1022) > 0;
end

function Lua_NewHeroActivityData:checkStoryEndByLevelId(levelId)
	local levelData = self:getChapterLevelInfoByLevelId(levelId);
	if levelData == nil then
		return;
	end

	local guideId = levelData.guideId;
	local playEnd = DataCenter.guideData:checkGuideEnd(guideId);
	return playEnd;
end

function Lua_NewHeroActivityData:displayWhenStroyEnd()
	local levelData = self:getChapterLevelInfoByLevelId(self.storyCurLevelId);
	if levelData == nil then
		return;
	end

	local bPassLevel = levelData.state == 3;
	local type = bPassLevel and 2 or 1;
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryLevelFighting(self.storyLevelActId, self.storyCurLevelId, type);
end

function Lua_NewHeroActivityData:getStoryLevelLineupHeroList(campType, careerType, lineupType, lineup_index)
	local arr = Array();
	local hreoList = self.storyLevelHeroVoArr;
	if hreoList ~= nil then
		local heroVo;
		for i = 1, hreoList:getSize() do
			heroVo = hreoList[i];
			if (campType == 0 or heroVo.campType == campType) and (careerType == 0 or heroVo.career == careerType) then
				arr:add(heroVo);
			end
		end
	end
	arr:sortf(self, self.storyLevelHeroSortFun, { lineupType = lineupType, lineup_index = lineup_index })
	return arr;
end

function Lua_NewHeroActivityData:checkLineupHero(UID)
	if self.storyLevelHeroLineupUnique_Ids == nil then
		return;
	end
	return self.storyLevelHeroLineupUnique_Ids[UID] == true;
end

function Lua_NewHeroActivityData:storyLevelHeroSortFun(a, b, param)
	local _a = self:checkLineupHero(a.unique_id) and 10000000000 or 0;--a:lineupSort(param.lineupType, param.lineup_index)
	local _b = self:checkLineupHero(b.unique_id) and 10000000000 or 0;--b:lineupSort(param.lineupType, param.lineup_index)
	_a = _a + a.heroForce;
	_b = _b + b.heroForce;
	if _a < _b then
		return false
	elseif _a == _b then
		if a.star < b.star then
			return false
		elseif a.star == b.star then
			if a.level < b.level then
				return false
			elseif a.level == b.level then
				if a.color < b.color then
					return false
				elseif a.color == b.color then
					if a.sort > b.sort then
						return false
					end
				end
			end
		end
	end
	return true
end










------------------------ 20007 新英雄战令 ----------------------------

function Lua_NewHeroActivityData:fromServer50108031(msg)
	if msg == nil then
		return;
	end
	table.sort( msg.reward_list, function(a, b) return a.level < b.level end );

	self.level = msg.level; -- 当前战令等级
	self.totalExe = msg.exe; -- 当前等级的总经验
	self.curExe = msg.cur_exe_process; -- 当前等级已有的经验
	self.payInfo = msg.up_level_item; -- 单位1经验值消耗 key道具id value数量
	self.rechargeUpLv = msg.recharge_up_level; -- 直升等级数

	self.warCoinRechargeId = msg.recharge_id; -- 充值id
	self.warCoinRewardList = msg.reward_list; -- 奖励列表
	self.rechargeState = msg.recharge_state -- 当前高级战令解锁状态，0未解锁，1已解锁
	self.rechargeReward = msg.recharge_reward_list; -- 解锁高级战令直接获得的奖励
	self.rechargeAllReward = msg.total_reward_list; -- 解锁高级战令累计获得的奖励

	local obj;
	local redDotState = false;
	self.showLvIdx = 1;
	for i = 1, #msg.reward_list do
		obj = msg.reward_list[i];
		if obj.reward_state == 2 then
			self.showLvIdx = i;
		end
		if not redDotState and (obj.reward_state == 1 or obj.stage_reward_state == 1) then
			redDotState = true;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.NewHeroWarCoin_Level, redDotState);

	self.dailyTaskTime = msg.reset_time or 0; -- 每日任务结束时间
	self:setTaskByType(msg.task_list);
end

function Lua_NewHeroActivityData:setTaskByType(list)
	if self.dailyTaskArr == nil then
		self.dailyTaskArr = Array();
	end
	if self.periodTaskArr == nil then
		self.periodTaskArr = Array();
	end
	self.dailyTaskArr:clear();
	self.periodTaskArr:clear();

	local redDotState = false;
	for i = 1, #list do
		if list[i].reset_type == 1 then
			self.dailyTaskArr:add(list[i]);
		else
			self.periodTaskArr:add(list[i]);
		end
		if not redDotState and list[i].reward_state == 1 then
			redDotState = true;
		end
	end
	self.dailyTaskArr:sort("task_id", false);
	self.periodTaskArr:sort("task_id", false);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.NewHeroWarCoin_Task, redDotState and self.totalExe > self.curExe);
end











------------------------- 20002 新英雄海报 -------------------------

function Lua_NewHeroActivityData:fromServer80108021(msg)
	Lua_WindowUtil.openWin("Lua_NewHeroActPosterWindow", Lua_WinParam.ACTION_OPEN, msg);
end

------------------------- 20008 新英雄试用 -------------------------

function Lua_NewHeroActivityData:fromServer80108035(msg)
	self.trialActIdx = msg.act_index; -- 后台活动索引
	self.trialHeroId = msg.hero_id; -- 英雄id
	self.trialstate = msg.trial_state; -- 试用状态 0未试用
	self.trialTime = msg.trial_times; -- 试用初始时间 天
	self.isFirst = msg.is_first_show; -- 是否第一次显示
	self.bgPath = msg.bg_path; -- 活动背景图
end

function Lua_NewHeroActivityData:fromServer50108021(msg)
	self.trialstate = msg.trial_state; -- 试用状态 1：已试用 0：未试用

	local heroVo = Lua_HeroVo.new(tonumber(self.trialHeroId));
	local param = { heroVo = heroVo, trialTime = self.trialTime * 24 * 3600 };
	DataCenter.preLoadData:preShowModelScene("Lua_RecruitShowSingleHeroWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, param, heroVo);
	Lua_MsgUtil.callFunc("NEWHERO_TRIAL_GET");
end

function Lua_NewHeroActivityData:onShowModel(param, modelScenePanel, isSuccess)
	if isSuccess == true then
		param.modelScenePanel = modelScenePanel;
		Lua_WindowUtil.openWin("Lua_RecruitShowSingleHeroWindow", Lua_WinParam.ACTION_OPEN, param);
	end
	self:removeShowModel();
end

function Lua_NewHeroActivityData:removeShowModel()
	DataCenter.preLoadData:removeBySign("Lua_RecruitShowSingleHeroWindow", self, self.onShowModel);
end








------------------------- 20009 新英雄英雄试炼 -------------------------

-- 返回英雄试炼界面信息
function Lua_NewHeroActivityData:fromServer50108036(msg)
	if msg == nil then
		return;
	end

	self.curCount = msg.free_times; -- 挑战次数
	self.totalCount = msg.free_limit; -- 总次数
	self.buffInfo = msg.buff_info; -- 增益信息
	self.hurtList = msg.hurt_list; -- 无尽模式阶段伤害
	self.stageInfo = msg.stage_info; -- 关卡信息
	for i = 1, #msg.stage_info do
		self.stageInfoDic[msg.stage_info[i].id] = msg.stage_info[i];
	end
	Lua_MsgUtil.callFunc("UPDATE_HEROTRIAL_INFO");
end

function Lua_NewHeroActivityData:getFightShowInfo(bossHurt)
	local idx;
	local curValue = bossHurt;
	local prevValue = 0;
	for i = 1, #self.hurtList do
		if bossHurt < tonumber(tostring(self.hurtList[i])) then
			idx = i;
			curValue = tonumber(tostring(self.hurtList[i]));
			if i > 1 then
				prevValue = tonumber(tostring(self.hurtList[i - 1]));
			end
			break;
		end
	end
	local isFinally = idx == nil;
	return idx, curValue, prevValue, isFinally;
end

function Lua_NewHeroActivityData:getCurHeroTrialFightSkipState()
	if self.curFightLevelId and self.stageInfoDic then
		local info = self.stageInfoDic[self.curFightLevelId];
		if info and info.win_flag == 0 then
			return true;
		end
	end
	return false;
end

-- 通知英雄试炼增益状态变更
function Lua_NewHeroActivityData:fromServer80108036(msg)
	if msg == nil then
		return;
	end

	if msg.state == 1 then -- 增益状态（0：未升级，1：升级）
		Lua_WindowUtil.openWin("Lua_HeroTrialBuffUpWindow", Lua_WinParam.ACTION_OPEN, self.buffInfo);
		self.buffInfo = msg.buff_info;
	end
end

-- 返回英雄试炼积分排名奖励
function Lua_NewHeroActivityData:fromServer50108037(msg)
	if msg == nil then
		return;
	end
	self.rankReward = msg.rank_reward;
end




















----- 引导用
function Lua_NewHeroActivityData:getStoryLevelResult(levelId, bShowResultWin)
	if levelId == nil then
		return;
	end

	local levelData = self:getChapterLevelInfoByLevelId(levelId);
	if levelData == nil then
		return;
	end

	local result = levelData.state == 3;
	if result and bShowResultWin then
		result = DataCenter.fightData:getRecordFightResultWin(Lua_FightDefine.FIGHT_TYPE_STORYLEVEL, levelId) == true;
	end
	return result;
end