-- 新英雄主题活动 剧情关卡 章节Vo
Lua_NewHeroStoryChapterVo = class("Lua_NewHeroStoryChapterVo");

function Lua_NewHeroStoryChapterVo:ctor()
	self:dispose();
end

function Lua_NewHeroStoryChapterVo:dispose()
	self._isLevelFight = false; -- 存在挑战中的关卡
	self.passLevelNum = 0; -- 通关的关卡数
end

function Lua_NewHeroStoryChapterVo:fromServerInfo(msg)
	self.chapterId = msg.chapter_id; -- 篇章id
	self.chapterTitle = msg.chapter_title; -- 篇章标题
	self.chapterContent = msg.chapter_value; -- 篇章内容
	self.openTime = msg.chapter_times; -- 篇章开启时间戳

	self._isLevelFight = false; -- 是否需要战斗
	self.passLevelNum = 0;

	local vo;
	self.LevelVoArr = Array();
	for k, v in ipairs(msg.story_list) do
		vo = Lua_NewHeroStoryLevelVo.new();
		vo:fromServerInfo(v);
		self.LevelVoArr:add(vo);

		if vo.state == 1 or vo.state == 2 then
			self._isLevelFight = true;
		elseif vo.state == 3 then
			self.passLevelNum = self.passLevelNum + 1;
		end
	end
	self.LevelVoArr:sort("id", false);
end

-- 章节状态 0：未开启 1：未解锁 2：挑战中 3：章节已通关 
function Lua_NewHeroStoryChapterVo.Get:state()
	local state = 0;
	if DataCenter.roleData.serverTime - self.openTime >= 0 then
		if self._isLevelFight then
			state = 2;
		elseif self.passLevelNum == self.LevelVoArr:getSize() then
			state = 3;
		else
			state = 1;
		end
	end
	return state;
end

-- 是否是最后一个
function Lua_NewHeroStoryChapterVo.Get:isTheEnd()
	return DataCenter.newHeroActData.lastChapterId == self.chapterId;
end