Lua_NewHeroUpStarVo = class("Lua_NewHeroUpStarVo");
function Lua_NewHeroUpStarVo:ctor()
	self:dispose();
end

function Lua_NewHeroUpStarVo:dispose()
	self._condStar = nil;
	self._freeVo = nil;
end

function Lua_NewHeroUpStarVo:updateUpStarVoInfo(msg)
	self.quality = msg.quality; -- 质量
	self.qualityStar = msg.quality_star; -- 质量星级

	local freeInfo = msg.free_cell;
	self.freeTimes = freeInfo.curr_times; -- 剩余免费限购次数
	self.totalFreeTimes = freeInfo.limit_times; -- 总免费限购次数
	self.freeGiftId = freeInfo.gift_id; -- 礼包id
	self.freeReward = freeInfo.reward_item; -- 免费奖励

	local rechargeInfo = msg.recharge_cell;
	self.rechargeTimes = rechargeInfo.curr_times; -- 剩余充值限购次数
	self.totalRechargeTimes = rechargeInfo.limit_times; -- 总充值限购次数
	self.rechargeId = rechargeInfo.gift_id; -- 充值id
	self.rechargeReward = rechargeInfo.reward_item; -- 充值奖励
end

function Lua_NewHeroUpStarVo:setEndStage(stage, isEndStage)
	self.stage = stage;
	self.isEndStage = isEndStage;
end

function Lua_NewHeroUpStarVo.Get:isCond()
	local curStar = DataCenter.heroUtil:getHeroAwakenStarByQuality(DataCenter.newHeroActData.quality, DataCenter.newHeroActData.qualityStar);
	return curStar >= self.condStar;
end

function Lua_NewHeroUpStarVo.Get:condStar()
	if self._condStar == nil then
		self._condStar = DataCenter.heroUtil:getHeroAwakenStarByQuality(self.quality, self.qualityStar);
	end
	return self._condStar;
end

function Lua_NewHeroUpStarVo.Get:freeVo()
	if self._freeVo == nil then
		self._freeVo = Lua_ToolVo.createToolVo(self.freeReward[1].id);
	end
	self._freeVo:setData(self.freeReward[1].id);
	self._freeVo:fromServer(self.freeReward[1]);
	return self._freeVo;
end

function Lua_NewHeroUpStarVo.Get:rechargeArr()
	local obj;
	local tvo;
	local arr = Array();
	for i = 1, #self.rechargeReward do
		obj = self.rechargeReward[i];
		tvo = Lua_ToolVo.createToolVo(obj.id);
		tvo.times = self.rechargeTimes;
		tvo:fromServer(obj);
		arr:add(tvo);
	end
	return arr;
end