Lua_OnlineRewardVo = class("Lua_OnlineRewardVo");
function Lua_OnlineRewardVo:ctor(id,config)
	self.id = tonumber(id);
	self.config = config;
	if self.config == nil then
		self.config = getConfig("rewardhall_online", self.id);
	end
end

function Lua_OnlineRewardVo.Get:isReceive()
	return DataCenter.onlineRewardData:getReceiveStateById(self.id);
end

function Lua_OnlineRewardVo.Get:remainTime()
	if self.isReceive then
		return 0;
	end

	local remainTime = self.secs - DataCenter.onlineRewardData.second;
	remainTime = remainTime < 0 and 0 or remainTime;
	return Mathf.Ceil(remainTime);
end

function Lua_OnlineRewardVo.Get:rewardVo()
	if self._rewardVo == nil and self.reward ~= nil then
		self._rewardVo = Lua_ToolVo.createToolVo(self.reward[1], self.reward[2]);
	end
	return self._rewardVo;
end

-- 计时(s)
function Lua_OnlineRewardVo.Get:secs()
	return self.config.secs;
end

-- 奖励
function Lua_OnlineRewardVo.Get:reward()
	return self.config.reward;
end

-- 前一档次
function Lua_OnlineRewardVo.Get:prev_id()
	if self.config.prev_id == nil then
		return 0;
	end
	return self.config.prev_id;
end