Lua_OpenServerCarnivalUtil = class("Lua_OpenServerCarnivalUtil")
function Lua_OpenServerCarnivalUtil:ctor()
end

function Lua_OpenServerCarnivalUtil:dispose()
	self._maxActDay = nil;
	self._activitiesDays = nil;
	self.dayTaskIdsDic = nil;
	self.actDayIds = nil;
end

function Lua_OpenServerCarnivalUtil:getActivitiesDays()
	if self._activitiesDays == nil then
		self._activitiesDays = self:getOCRewardConfig("const", 7);
	end
	return self._activitiesDays;
end

function Lua_OpenServerCarnivalUtil.Get:canExistActivites()
	if self._canExistActivites == nil then
		local param = self:getOCRewardConfig("const", 8);
		if param == nil or param == 0 then
			self._canExistActivites = true;
		else
			self._canExistActivites = false;
		end 
	end
	return self._canExistActivites;
end

function Lua_OpenServerCarnivalUtil:getActivityIndex(curDay, bReturnTime)
	local activitiesDays = self:getActivitiesDays();
	if activitiesDays ~= nil and #activitiesDays > 0  then
		local index = 1;
		local existTime;
		for i = 1, #activitiesDays do
			existTime = activitiesDays[i];
			if curDay >= existTime[1] and curDay <= existTime[2] then
				index = i;
				break;
			end
		end
		if bReturnTime then
			existTime = activitiesDays[index];
			return index, existTime[1], existTime[2];
		else
			return index;
		end
	end
end

function Lua_OpenServerCarnivalUtil:getActivityTimeByActIndex(index)
	if index ~= nil then
		local activitiesDays = self:getActivitiesDays();
		local existTime = activitiesDays[index];
		if existTime ~= nil then
			return existTime[1], existTime[2];
		end
	end
end

-- function Lua_OpenServerCarnivalUtil:getActDayIdList(actIndex)
-- 	if self.actDayIds == nil then
-- 		self.actDayIds = {};
-- 	end

-- 	if actIndex ~= nil then
-- 		if self.actDayIds[actIndex] == nil then
-- 			local dayId;
-- 			local startDay, endDay = self:getActivityTimeByActIndex(actIndex);
-- 			local actIdDays = {};
-- 			for i = startDay, endDay do
-- 				dayId = DataCenter.openServerCarnivalData.dayIdBaseCount + i;
-- 				actIdDays[#actIdDays + 1] = dayId;
-- 			end
-- 			self.actDayIds[actIndex] = actIdDays;
-- 		end
-- 		return self.actDayIds[actIndex];
-- 	end
-- end

function Lua_OpenServerCarnivalUtil:getActDayIdList(actIndex)
	if self.actDayIds == nil then
		self.actDayIds = {};
	end
	local openday = DataCenter.openServerCarnivalData.openDay;
	local curActIndex = self:getActivityIndex(openday);
	if actIndex < curActIndex then
		local startDay, endDay = self:getActivityTimeByActIndex(actIndex);
		openday = endDay;
	end
	openday = openday + DataCenter.openServerCarnivalData.dayIdBaseCount;
	if self.actDayIds[openday] == nil then
		local config = self:getOCRewardConfig(openday, 9);
		local days = {};
		for i = config[1], config[2] do
			days[#days + 1] = i;
		end
		self.actDayIds[openday] = days;
	end
	return self.actDayIds[openday];
end

function Lua_OpenServerCarnivalUtil:getActStrByActIndex(actIndex)
	local str;
	if actIndex == 1 then
		str = "one";
	elseif actIndex == 2 then
		str = "two";
	end
	return str;
end

function Lua_OpenServerCarnivalUtil.Get:maxActDay()
	if self._maxActDay == nil then
		local list = self:getActivitiesDays();
		local _, endDay = self:getActivityTimeByActIndex(#list);
		self._maxActDay = endDay;
	end
	return self._maxActDay;
end

function Lua_OpenServerCarnivalUtil:getOCRewardConfig(id, index)
	local str;
	if index == 0 then -- id的全部配置
		str = nil;
	elseif index == 1 then
		str = "reward_items";
	elseif index == 2 then
		str = "task_id_list";
	elseif index == 3 then
		str = "task_tab";
	elseif index == 4 then
		str = "reward_id";
	elseif index == 5 then
		str = "func_id";
	elseif index == 6 then
		str = "tweenId";
	elseif index == 7 then
		str = "activities_days";
	elseif index == 8 then
		str = "is_single_activity";
	elseif index == 9 then
		str = "show_days";	
	end

	return getConfig("open_carnival_reward", id, str);
end

function Lua_OpenServerCarnivalUtil:getOpenCarnivalConfig(id, index)
	local str;
	if index == 1 then
		str = "condition_id";
		local condId = getConfig("open_carnival", id, str);
		return getConfig("total_task", condId);
	elseif index == 2 then
		str = "title";
	end

	return getConfig("open_carnival", id, str);
end

function Lua_OpenServerCarnivalUtil:getTaskIdListByDayId(dayId)
	if self.dayTaskIdsDic == nil then
		self.dayTaskIdsDic = {};
	end

	if self.dayTaskIdsDic[dayId] == nil then
		local ids = {};
		local taskIdList = self:getOCRewardConfig(dayId, 2);
		for i = 1, #taskIdList do
			ids[#ids + 1] = taskIdList[i];
		end
		self.dayTaskIdsDic[dayId] = ids;
	end
	return self.dayTaskIdsDic[dayId];

end