Lua_HeroChallengeData = class("Lua_HeroChallengeData");
function Lua_HeroChallengeData:ctor()
	self:dispose();
end

function Lua_HeroChallengeData:dispose()
	self.curStageIdx = 1;
	self.end_time = 0;
	self.isFirstEnter = true; -- 未挑战时默认显示红点
end

function Lua_HeroChallengeData:fromServer50197051(msg)
	if msg == nil then
		return;
	end

	self.round = msg.round; -- 轮次
	self.hero_list = msg.hero_list; -- 推荐英雄id列表
	self.monster_id = msg.monster_id; -- 怪物id(怪物配置表id)
	self.daily_max_hurt = msg.daily_max_hurt; -- 当日造成的最大伤害
	self.daily_reward_state = msg.daily_reward_state; -- 每日挑战奖励状态(0不可领取 1可领取 2已领取)
	self.daily_item_list = msg.daily_item_list; -- 每日挑战奖励道具列表
	self.daily_hurt_reward = msg.daily_hurt_reward; -- 每日阶段伤害奖励信息
	self.scene_id = msg.scene_id; -- 场景id
	self.add_prop_list = msg.add_prop_list; -- 推荐英雄加成属性列表
	self.end_time = msg.end_time; -- 结束时间

	local obj;
	self.curStageIdx = 1;
	self.nextStageIdx = nil;
	for i = 1, #msg.daily_hurt_reward do
		obj = msg.daily_hurt_reward[i];
		if obj.is_finish == 0 then -- 是否达成(0否 1是)
			self.nextStageIdx = i;
			break;
		end
		self.curStageIdx = i;
	end
	self.nextStageIdx = self.nextStageIdx == nil and #msg.daily_hurt_reward or self.nextStageIdx;

	local state = (msg.daily_reward_state == 0 and self.isFirstEnter) or msg.daily_reward_state == 1;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerTrial_HeroChallenge, state);
end

function Lua_HeroChallengeData:fromServer50197052(msg)
	if msg == nil then
		return;
	end
	self.rank_reward = msg.rank_reward; -- 排行奖励信息
end

function Lua_HeroChallengeData.Get:residueTime()
	return self.end_time - DataCenter.roleData.serverTime; -- 结束时间
end

function Lua_HeroChallengeData:getFightShowInfo(bossHurt)
	local idx = nil;
	local curValue = bossHurt;
	local prevValue = 0;
	for i = 1, #self.daily_hurt_reward do
		if bossHurt < self.daily_hurt_reward[i].hurt then
			idx = i;
			curValue = self.daily_hurt_reward[i].hurt;
			if i > 1 then
				prevValue = self.daily_hurt_reward[i - 1].hurt;
			end
			break;
		end
	end
	local isFinally = idx == nil;
	return idx, curValue, prevValue, isFinally;
end

function Lua_HeroChallengeData.Get:atlas()
	return getConfig("hero_challenge", "config", "atlas")[self.round];
end

function Lua_HeroChallengeData.Get:title()
	return getConfig("hero_challenge", "config", "title")[self.round];
end