checkRequire("Lua_OpenServerHeroComeTaskVo");
Lua_OpenServerHeroComeData = class("Lua_HeroComeData")
function Lua_OpenServerHeroComeData:ctor()
	self:dispose()
end

function Lua_OpenServerHeroComeData:dispose()
	
end

--服务端数据
function Lua_OpenServerHeroComeData:fromServer50197048(msg)
	if msg == nil then
		return;
	end
	self.heroDrawState = msg.hero_state; --英雄领取状态
	self.activeTime = msg.end_time; --活动时间
	self.loginRedState = msg.red_state; --首登红点
    
    self:updateTaskList(msg.task_progress);
	Lua_MsgUtil.callFunc("UPDATE_HEROCOME_SHOWINFO");
end

--任务完成通知红点
function Lua_OpenServerHeroComeData:fromServer80197051(msg)
	if msg == nil or msg.function_id ~= 10283 or Lua_WindowUtil.isWindowShowing("Lua_OpenServerHeroComeWindow") then
		return;
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerTrial_HeroCome, msg.red_state == 1);
end


--更新任务状态
function Lua_OpenServerHeroComeData:updateTaskList(list)
	if list == nil then
		return;
	end
	local vo;
	local id;
	local completeCount = 0;
	local taskState = false;
	for i = 1, #list do
		id = list[i].key;
		vo = self:getTaskVoById(id);
		if vo ~= nil then
			vo:fromServer(list[i].value, list[i].ex_value);
		end
		if list[i].value == 1 then
			taskState = true;
		end
		if list[i].value == 2 then
			completeCount = completeCount + 1;
		end
	end
	self:updateRedPoint(taskState, completeCount ~= #list);                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
end

--通过id获取任务vo
function Lua_OpenServerHeroComeData:getTaskVoById(id)
	if self.taskVoList == nil then
		self:initTaskInfo();
	end
	return self.taskVoList[id];
end

--初始化任务vo
function Lua_OpenServerHeroComeData:initTaskInfo()
	self.taskVoList = {};
	local config = getConfig("hero_fall");
	local taskVo;
	local id;
	for i = 1, #config do
		id = config[i].id;
		if type(id) == "number" then
			taskVo = Lua_OpenServerHeroComeTaskVo.new(id);
			self.taskVoList[id] = taskVo;
		end
	end
end

--登录、领取更新红点
function Lua_OpenServerHeroComeData:updateRedPoint(taskState, haveTask)
	local firstRedPoint = self.loginRedState == 1 and (haveTask or self.heroDrawState ~= 2);
	local redPointState = taskState or self.heroDrawState == 1 or firstRedPoint;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.OpenServerTrial_HeroCome, redPointState);
end

--英雄id
function Lua_OpenServerHeroComeData.Get:heroId()
	return getConfig("hero_fall", "const", "hero_reward");
end

--英雄立绘路径
function Lua_OpenServerHeroComeData.Get:imgPath()
	return getConfig("hero_fall", "const", "imgPath");
end