checkRequire("Lua_OpenServerHeroGiftData");
checkRequire("Lua_OpenServerHeroComeData");
checkRequire("Lua_HeroChallengeData");
Lua_OpenServerTrialProxy = class("Lua_OpenServerTrialProxy");
function Lua_OpenServerTrialProxy:ctor()
	DataCenter.openServerHeroGiftData = Lua_OpenServerHeroGiftData.new();
	DataCenter.openServerHeroComeData = Lua_OpenServerHeroComeData.new();
	DataCenter.heroChallengeData = Lua_HeroChallengeData.new();

	Lua_MsgUtil.addLuaMsg(50197046, self, self.rOpenServerHeroGiftInfo);
	Lua_MsgUtil.addLuaMsg(50197048, self, self.rHeroComeInfo);
	Lua_MsgUtil.addLuaMsg(50197050, self, self.rHeroComeDrawHero);
	Lua_MsgUtil.addLuaMsg(80197051, self, self.nTaskComplete);

	Lua_MsgUtil.addLuaMsg(50197051, self, self.rHeroChallengeInfo);
	Lua_MsgUtil.addLuaMsg(50197052, self, self.rHeroChallengeRankRewardInfo);
	Lua_MsgUtil.addLuaMsg(50197054, self, self.rHeroChallengeRankInfo);
	
	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateHeroGiftRedDot); -- 货币数量增加时更新红点
	Lua_MsgUtil.addEventListener("RedPoint_Update_State", self, self.updateEntranceRedDot); -- 监听入口红点
end

------------------------------ 英雄赠礼 ------------------------------

-- 请求英雄赠礼界面（返回）
function Lua_OpenServerTrialProxy:rOpenServerHeroGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197046();
		msg:ParseFromString(mp.data);
		DataCenter.openServerHeroGiftData:fromServer50197046(msg);
		Lua_MsgUtil.callFunc("UPDATE_OPENSERVER_HEROGIFT_INFO");
	end
end

function Lua_OpenServerTrialProxy:updateHeroGiftRedDot(dic)
	if DataCenter.funcOpenData:isOpened(10282) then
		DataCenter.openServerHeroGiftData:updateHeroGiftRedDot(dic);
	end
end

function Lua_OpenServerTrialProxy:updateEntranceRedDot(redPointId)
	if DataCenter.funcOpenData:isOpened(10282) then
		DataCenter.openServerHeroGiftData:updateEntranceRedDot(redPointId);
	end
end

-- 请求英雄赠礼界面
function Lua_OpenServerTrialProxy:sOpenServerHeroGiftInfo()
	sendMsg(10197046);
end

-- 请求英雄赠礼抽奖
function Lua_OpenServerTrialProxy:sDrawOpenServerHeroGift()
	sendMsg(10197047);
end










------------------------------ 英雄降临 ------------------------------

-- 返回英雄降临界面数据
function Lua_OpenServerTrialProxy:rHeroComeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197048();
		msg:ParseFromString(mp.data);
		DataCenter.openServerHeroComeData:fromServer50197048(msg);
	end
end

-- 英雄领取返回
function Lua_OpenServerTrialProxy:rHeroComeDrawHero(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197050();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("HEROCOME_SHOW_NEWHERO", msg);
	end
end

-- 任务完成红点通知
function Lua_OpenServerTrialProxy:nTaskComplete(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80197051();
		msg:ParseFromString(mp.data);
		DataCenter.openServerHeroComeData:fromServer80197051(msg);
	end
end

-- 请求英雄降临界面信息
function Lua_OpenServerTrialProxy:sHeroComeInfo()
	sendMsg(10197048);
end

-- 请求领取英雄降临任务奖励
function Lua_OpenServerTrialProxy:sHeroComeDrawTask(id)
	local cmd = ProtoPublic_pb.Proto10197049();
	cmd.task_id = id;
	sendMsg(10197049, cmd);
end

-- 请求领取英雄降临英雄奖励
function Lua_OpenServerTrialProxy:sHeroComeDrawHero()
	sendMsg(10197050);
end










------------------------------ 英雄挑战(本地) ------------------------------

-- 请求英雄挑战界面（返回）
function Lua_OpenServerTrialProxy:rHeroChallengeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197051();
		msg:ParseFromString(mp.data);
		DataCenter.heroChallengeData:fromServer50197051(msg);
		Lua_MsgUtil.callFunc("UPDATE_HEROCHALLENGE_INFO");
	end
end

-- 请求英雄挑战排行奖励信息（返回）
function Lua_OpenServerTrialProxy:rHeroChallengeRankRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197052();
		msg:ParseFromString(mp.data);
		DataCenter.heroChallengeData:fromServer50197052(msg);
		Lua_MsgUtil.callFunc("UPDATE_HEROCHALLENGE_RANKREWARD_INFO");
	end
end

-- 请求英雄挑战排行榜信息（返回）
function Lua_OpenServerTrialProxy:rHeroChallengeRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197054();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_HEROCHALLENGE_RANK_INFO", msg);
	end
end

-- 请求英雄挑战界面
function Lua_OpenServerTrialProxy:sHeroChallengeInfo()
	sendMsg(10197051);
end

-- 请求英雄挑战排行奖励信息
function Lua_OpenServerTrialProxy:sHeroChallengeRankRewardInfo()
	sendMsg(10197052);
end

-- 请求领取英雄挑战每日奖励
function Lua_OpenServerTrialProxy:sHeroChallengeDailyReward()
	sendMsg(10197053);
end

-- 请求英雄挑战排行榜信息
function Lua_OpenServerTrialProxy:sHeroChallengeRankInfo(page)
	local cmd = ProtoPublic_pb.Proto10197054();
	cmd.page = page; -- 0：清空刷新 1：下一页
	sendMsg(10197054, cmd);
end