checkRequire("Lua_OperationalActivitiesUtil")
checkRequire("Lua_BackstageActivitiesData");
checkRequire("Lua_InternalActivitiesData");
checkRequire("Lua_UpStarOfCycleData");
checkRequire("Lua_CustomGiftData");
checkRequire("Lua_LuckyGiftBoxData");
checkRequire("Lua_SpecialDiscountGiftData");
checkRequire("Lua_NewSpecialFundsData");
checkRequire("Lua_BossChallengeData");
checkRequire("Lua_MoreDoubleData");
Lua_OperationalActivitiesProxy = class("Lua_OperationalActivitiesProxy");
function Lua_OperationalActivitiesProxy:ctor()
	DataCenter.operationalActUtil = Lua_OperationalActivitiesUtil.new();
	DataCenter.backstageActData = Lua_BackstageActivitiesData.new();
	DataCenter.internalActData = Lua_InternalActivitiesData.new();
	DataCenter.upStarOfCycleData = Lua_UpStarOfCycleData.new();
	DataCenter.customGiftData = Lua_CustomGiftData.new();
	DataCenter.luckyGiftBoxData = Lua_LuckyGiftBoxData.new();
	DataCenter.specialDiscountGiftData = Lua_SpecialDiscountGiftData.new();
	DataCenter.newSpecialFundsData = Lua_NewSpecialFundsData.new();
	DataCenter.bossChallengeData = Lua_BossChallengeData.new();
	DataCenter.moreDoubleData = Lua_MoreDoubleData.new();--多倍奖励

	Lua_MsgUtil.addLuaMsg(80108001, self, self.updateActivitiesInfo);  -- 通知运营活动列表
	Lua_MsgUtil.addLuaMsg(80108002, self, self.updateActivitiesRedDot);-- 通知运营活动红点
	Lua_MsgUtil.addLuaMsg(80108044, self, self.updateMoreDoubleInfo);  -- 通知多倍活动

	Lua_MsgUtil.addLuaMsg(50108003, self, self.rCumulateRechargeInfo); -- 请求累积充值界面（返回）
	Lua_MsgUtil.addLuaMsg(50108005, self, self.rUpStarOfCycleInfo); -- 请求升星专属界面（返回）
	Lua_MsgUtil.addLuaMsg(50108007, self, self.rCustomGiftInfo); -- 请求定制礼包界面（返回）
	Lua_MsgUtil.addLuaMsg(50108012, self, self.rLuckyGiftBoxInfo); -- 请求幸运礼盒界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108015, self, self.rDrawLuckyGiftBox); -- 请求抽取幸运礼盒道具（返回）
	Lua_MsgUtil.addLuaMsg(50108017, self, self.rBestGiftBoxInfo); -- 请求终极礼盒界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108018, self, self.rLuckyGiftBoxDetailInfo); -- 请求幸运礼盒界面详情信息（返回）
	Lua_MsgUtil.addLuaMsg(50108010, self, self.rSpecialDiscountGiftInfo); --请求特惠礼包界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50197005, self, self.rSpecialFundsInfo); -- 请求超值基金界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108038, self, self.rQuarterHotSellInfo); -- 请求当季热卖界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108040, self, self.rBossChallengeInfo); -- 请求boss挑战界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50108041, self, self.rBossChallengeRankRewardInfo); -- 请求boss挑战排行奖励信息（返回）
	Lua_MsgUtil.addLuaMsg(50108043, self, self.rBossChallengeRankInfo); -- 请求boss挑战排行榜信息（返回）
	Lua_MsgUtil.addLuaMsg(50108044, self, self.rMoreDoubleInfo); -- 请求多倍活动界面（返回）
	Lua_MsgUtil.addLuaMsg(50108045, self, self.rWeekCardInfo); --周卡界面信息(返回)
end



------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求运营活动的界面信息
function Lua_OperationalActivitiesProxy:sActivityInfo(act_index)
    local cmd = ProtoPublic_pb.Proto10108002();
    cmd.act_index = act_index; -- 活动唯一索引
    sendMsg(10108002, cmd);
end

-- 请求领取累积充值奖励
function Lua_OperationalActivitiesProxy:sReceiveReward(act_index, id)
	local cmd = ProtoPublic_pb.Proto10108004();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.id = id; -- 累充档次id
	sendMsg(10108004, cmd);
end

-- 请求解锁升星专属（周期）奖励
function Lua_OperationalActivitiesProxy:sReceiveUpStarReward(act_index, gift_id)
	local cmd = ProtoPublic_pb.Proto10108006();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id; -- 礼包id
	sendMsg(10108006, cmd);
end

-- 请求定制礼包自定义
function Lua_OperationalActivitiesProxy:sDefineCustomGift(act_index, gift_id, reward_list)
	local cmd = ProtoPublic_pb.Proto10108008();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id; -- 礼包id

	local struct;
	for i = 1, reward_list:getSize() do
		if reward_list[i].tvo ~= nil then
			struct = getProtoMsg("ProtoThree");
			struct.key = reward_list[i].tvo.id;
			struct.value = reward_list[i].tvo.count;
			struct.ex_value = reward_list[i].index;
			cmd.reward_list:addToList(struct); -- 自定义奖励道具
		end
	end
	
	sendMsg(10108008, cmd);
end

-- 请求购买0元定制礼包
function Lua_OperationalActivitiesProxy:sBuyCustomGift(act_index, gift_id)
	local cmd = ProtoPublic_pb.Proto10108009();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id; -- 礼包id
	sendMsg(10108009, cmd);
end

-- 请求更换终极礼盒
function Lua_OperationalActivitiesProxy:sChangeBestGiftBox(act_index, advance_gift_index)
	local cmd = ProtoPublic_pb.Proto10108013();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.advance_gift_index = advance_gift_index; -- 当前轮次终极礼盒索引
	sendMsg(10108013, cmd);
end

-- 请求开启下一轮幸运礼盒
function Lua_OperationalActivitiesProxy:sStartNextRounds(act_index)
	local cmd = ProtoPublic_pb.Proto10108014();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108014, cmd);
end

-- 请求抽取幸运礼盒道具
function Lua_OperationalActivitiesProxy:sDrawLuckyGiftBox(act_index, cell_index)
	local cmd = ProtoPublic_pb.Proto10108015();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.cell_index = cell_index; -- 礼盒位置索引
	sendMsg(10108015, cmd);
end

-- 请求终极礼盒界面信息
function Lua_OperationalActivitiesProxy:sBestGiftBoxInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108017();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108017, cmd);
end

-- 请求幸运礼盒界面详情信息
function Lua_OperationalActivitiesProxy:sLuckyGiftBoxDetailInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108018();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108018, cmd);
end

-- 请求领取免费特惠礼包
function Lua_OperationalActivitiesProxy:sBuySpecialDiscountGift(act_index,gift_id)
	local cmd = ProtoPublic_pb.Proto10108011();
	cmd.act_index = act_index; -- 活动唯一索引
	cmd.gift_id = gift_id;
	sendMsg(10108011, cmd);
end

-- 请求领取超值基金奖励
function Lua_OperationalActivitiesProxy:sSpecialFundsReward(act_index)
	local cmd = ProtoPublic_pb.Proto10197006();
	-- cmd.type = 1;
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10197006, cmd);
end

-- 请求购买当季热卖礼包
function Lua_OperationalActivitiesProxy:sBuyQuarterGift(actIdx, id)
	local cmd = ProtoPublic_pb.Proto10108039();
	cmd.act_index = actIdx;
	cmd.id = id;
	sendMsg(10108039, cmd);
end

-- 请求boss挑战排行奖励信息
function Lua_OperationalActivitiesProxy:sBossChallengeRankRewardInfo(act_index)
	local cmd = ProtoPublic_pb.Proto10108041();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108041, cmd);
end

-- 请求领取boss挑战每日奖励
function Lua_OperationalActivitiesProxy:sBossChallengeDailyReward(act_index)
	local cmd = ProtoPublic_pb.Proto10108042();
	cmd.act_index = act_index; -- 活动唯一索引
	sendMsg(10108042, cmd);
end

-- 请求boss挑战排行榜信息
function Lua_OperationalActivitiesProxy:sBossChallengeRankInfo(act_index, page)
	local cmd = ProtoPublic_pb.Proto10108043();
	-- cmd.act_index = act_index; -- 活动唯一索引
	cmd.page = page; -- 0:清空刷新 1:下一页
	sendMsg(10108043, cmd);
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_OperationalActivitiesProxy:updateActivitiesInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108001();
		msg:ParseFromString(mp.data);
		DataCenter.backstageActData:fromServer80108001(msg);
	end
end

function Lua_OperationalActivitiesProxy:updateActivitiesRedDot(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108002();
		msg:ParseFromString(mp.data);
		DataCenter.backstageActData:fromServer80108002(msg);
	end
end

function Lua_OperationalActivitiesProxy:rCumulateRechargeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108003();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("CUMULATE_RECHARGE_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:rUpStarOfCycleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108005();
		msg:ParseFromString(mp.data);
		DataCenter.upStarOfCycleData:fromServer50108005(msg);
		Lua_MsgUtil.callFunc("UPDATE_UPSTAROFCYCLE_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rCustomGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108007();
		msg:ParseFromString(mp.data);
		DataCenter.customGiftData:fromServer50108007(msg);
		Lua_MsgUtil.callFunc("UPDATE_CUSTOMGIFT_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rLuckyGiftBoxInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108012();
		msg:ParseFromString(mp.data);
		DataCenter.luckyGiftBoxData:fromServer50108012(msg);
	end
end

function Lua_OperationalActivitiesProxy:rDrawLuckyGiftBox(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108015();
		msg:ParseFromString(mp.data);
	end
end

function Lua_OperationalActivitiesProxy:rBestGiftBoxInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108017();
		msg:ParseFromString(mp.data);
		DataCenter.luckyGiftBoxData:fromServer50108017(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_BESTGIFT_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rLuckyGiftBoxDetailInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108018();
		msg:ParseFromString(mp.data);
		DataCenter.luckyGiftBoxData:fromServer50108018(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKYGIFTBOX_DETAIL_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rSpecialDiscountGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108010();
		msg:ParseFromString(mp.data);
		DataCenter.specialDiscountGiftData:fromServer50108010(msg);
		Lua_MsgUtil.callFunc("UPDATE_SPECIALDISCOUNTGIFT_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rSpecialFundsInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50197005();
		msg:ParseFromString(mp.data);
		DataCenter.newSpecialFundsData:fromServer50197005(msg);
		Lua_MsgUtil.callFunc("UPDATE_FUNDSITEM_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rQuarterHotSellInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108038();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_QUARTERHOTSELL_PANEL", msg);
	end
end

function Lua_OperationalActivitiesProxy:rBossChallengeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108040();
		msg:ParseFromString(mp.data);
		DataCenter.bossChallengeData:fromServer50108040(msg);
		Lua_MsgUtil.callFunc("UPDATE_BOSSCHALLENGE_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rBossChallengeRankRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108041();
		msg:ParseFromString(mp.data);
		DataCenter.bossChallengeData:fromServer50108041(msg);
		Lua_MsgUtil.callFunc("UPDATE_BOSSCHALLENGE_RANKREWARD_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rBossChallengeRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108043();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_BOSSCHALLENGE_RANK_INFO", msg);
	end
end

function Lua_OperationalActivitiesProxy:updateMoreDoubleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80108044();
		msg:ParseFromString(mp.data);
		DataCenter.moreDoubleData:fromServer80108044(msg);
	end
end

function Lua_OperationalActivitiesProxy:rMoreDoubleInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108044();
		msg:ParseFromString(mp.data);
		DataCenter.moreDoubleData:fromServer50108044(msg);
		Lua_MsgUtil.callFunc("UPDATE_MORE_DOUBLE_INFO");
	end
end

function Lua_OperationalActivitiesProxy:rWeekCardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50108045();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("SHOW_WEEKCARD_PANEL", msg);
	end
end
