-- 内置活动Vo
Lua_InternalActivityVo = class("Lua_InternalActivityVo")
function Lua_InternalActivityVo:ctor(id, config)
	self._id = id;
	self._config = config;
end

function Lua_InternalActivityVo.Get:id()
	return self._id;
end

function Lua_InternalActivityVo.Get:config()
	if self._config == nil then
		self._config = getConfig("internal_activities", self.id);
	end
	return self._config;
end

function Lua_InternalActivityVo:fromServerInfo(open_state, close_tick)
	self.open_state = open_state;
	self.close_tick = close_tick;
end

function Lua_InternalActivityVo.Get:bOpened() -- 默认open_state = nil
	if self.open_state == 0 then
		return false;
	elseif self.open_state == 1 then
		return self.residueTime > 0;
	end
	if self.open_cond then
		for i = 1, #self.open_cond do
			if DataCenter.funcOpenData:isOpened(self.open_cond[i]) then
				return true
			end
		end
	end
	return false;
end

function Lua_InternalActivityVo.Get:residueTime()
	if self.close_tick == nil then
		return 0;
	end
	return self.close_tick - DataCenter.roleData.serverTime;
end

function Lua_InternalActivityVo.Get:hasSecTab()
	local list = self.sec_tab_list;
	if list == nil or #list <= 0 then
		return false;
	end
	return true;
end

function Lua_InternalActivityVo.Get:secTabArr()
	if self._secTabArr == nil then
		self._secTabArr = Array();
		local list = self.sec_tab_list;
		if list ~= nil then
			local vo;
			for i = 1, #list do
				vo = DataCenter.internalActData:getActivityVo(list[i]);
				self._secTabArr:add(vo);
			end
		end
	end
	return self._secTabArr;
end

function Lua_InternalActivityVo.Get:redPointState()
	return DataCenter.redPointData:getRedPointStateById(self.redPointId);
end

function Lua_InternalActivityVo.Get:sort()
	if self._sort ~= nil then
		return self._sort;
	end
	return self.config.sort == nil and 0 or self.config.sort;
end

function Lua_InternalActivityVo.Set:sort(value)
	self._sort = value;
end

-------------------- 配置数据 --------------------

function Lua_InternalActivityVo.Get:name()
	return self.config.name;
end

function Lua_InternalActivityVo.Get:open_cond()
	return self.config.open_cond;
end

function Lua_InternalActivityVo.Get:prompt()
	return self.config.prompt;
end

function Lua_InternalActivityVo.Get:sec_tab_list()
	return self.config.sec_tab_list;
end

function Lua_InternalActivityVo.Get:redPointId()
	return self.config.redPointId;
end

function Lua_InternalActivityVo.Get:panelName()
	return self.config.panel_name;
end

function Lua_InternalActivityVo.Get:iconAtlas()
	return self.config.icon_atlas;
end

function Lua_InternalActivityVo.Get:iconNormal()
	return self.config.icon_normal;
end

function Lua_InternalActivityVo.Get:iconSelected()
	return self.config.icon_selected;
end

function Lua_InternalActivityVo.Get:winBgUrl()
	return self.config.win_bg;
end

function Lua_InternalActivityVo.Get:winBgAnchor()
	return self.config.win_bg_anchor or 1;
end

function Lua_InternalActivityVo.Get:winBgPivot()
	return self.config.win_bg_pivot or 1;
end

function Lua_InternalActivityVo.Get:winBgPosY()
	return self.config.win_bg_posy or 0;
end

function Lua_InternalActivityVo.Get:money_list()
	return self.config.money_list;
end

function Lua_InternalActivityVo.Get:param()
	return self.config.param;
end