Lua_OperationalActivitiesUtil = class("Lua_OperationalActivitiesUtil")
Lua_ActivityList = {
	TYPE_BOSSChallenge = 10007; -- BOSS挑战
	TYPE_NewHeroRecruit = 20004; -- 新英雄招募
	ID_HeroChallenge = 101021; -- 英雄挑战活动ID
	ID_GradeGift = 101002; -- 等级礼包
	ID_HeroGift = 101020; -- 英雄赠礼
	ID_HeroGather = 101016; -- 英雄集结
};

function Lua_OperationalActivitiesUtil:ctor()
	self:superCall("ctor")

	self.actDic = {}
	-- self.actDic[Lua_MenuViewDefine.ICON_WELFARE] = {} -- 福利大厅
	self.actDic[Lua_MenuViewDefine.ICON_EXCELLENT_ACT] = {101001, 101002, 101003, 101010, 101014, 101015, 101016, 101034} -- 精彩活动
	self.actDic[Lua_MenuViewDefine.ICON_LIMITEDTIME_ACT] = {101023, 101024, 101025, 101026, 101027, 101031} -- 限时活动
	self.actDic[Lua_MenuViewDefine.ICON_RACCOON_MART] = {101004, 101009, 101022, 101029} -- 浣熊百货
	self.actDic[Lua_MenuViewDefine.ICON_WAR_ORDER] = {101017, 101018, 101019, 101028, 101032, 101033} -- 开服试炼
	self.actDic[Lua_MenuViewDefine.ICON_OPENSERVERTRIAL] = {101020} -- 战令
	self.actDic[Lua_MenuViewDefine.ICON_HEROCHALLENGE] = {101021} -- 英雄挑战
end

function Lua_OperationalActivitiesUtil:dispose()
	self.preActVo = nil
end

function Lua_OperationalActivitiesUtil:getActivityArr(iconId)
	local arr = Array()
	local tab = {}
	local fixList = self.actDic[iconId]
	local vo
	local actId
	-- 内置活动
	if fixList then
		for i = 1, #fixList do
			vo = DataCenter.internalActData:getActivityVo(fixList[i])
			if vo.bOpened == true then
				arr:add(vo)
				tab[vo.id] = 1

				if vo.hasSecTab then
					for j = 1, #vo.sec_tab_list do
						actId = vo.sec_tab_list[j]
						tab[actId] = 1
					end
				end
			end
		end
	end

	-- 后台活动
	local actArr = DataCenter.backstageActData:getActArrByMainIconId(iconId)
	if actArr then
		for i = 1, actArr:getSize() do
			vo = DataCenter.backstageActData:getActVoByIdx(actArr[i])
			arr:add(vo)
			tab[vo.actType] = 1
		end
	end

	arr:sort("sort", false)
	return arr, tab
end

function Lua_OperationalActivitiesUtil:setPreLoadById(actId)
	local actVo = DataCenter.internalActData:getActivityVo(actId)
	self:setPreLoadByVo(actVo)
	return actVo
end

function Lua_OperationalActivitiesUtil:setPreLoadByType(actType)
	local arr = DataCenter.backstageActData:getActIdxArrByType(actType)
	if arr then
		local actVo = DataCenter.backstageActData:getActVoByIdx(arr[1])
		self:setPreLoadByVo(actVo)
		return actVo
	end
	return nil
end

function Lua_OperationalActivitiesUtil:setPreLoadByVo(actVo)
	if actVo == nil or self.preActVo then
		return
	end
	self.preActVo = actVo
end