-- 内置活动基类
checkRequire("Lua_OperationalActivitiesWindow")
Lua_InternalActivitiesWindow = class("Lua_InternalActivitiesWindow", Lua_OperationalActivitiesWindow);

function Lua_InternalActivitiesWindow:dispose()
	if self.haveBackstageActivities == true then
		self:removePreLoadRes("backstage_activities_lua", Lua_LoadFileType.LUA);
	end
	self.mainActVo = nil;
	self:superCall("dispose");
end

function Lua_InternalActivitiesWindow:checkActList(actVo)
	local arr, dic = DataCenter.operationalActUtil:getActivityArr(self.iconId);
	self.actDic = dic;

	local selectIdx = 1;
	if type(self.showData) == "table" then
		if self.showData.actIdx and self.showData.actIdx > 0 then
			if self.showData.mainIconId and self.showData.mainIconId > 0 then
				selectIdx = self:getSelectIdx(arr, self.showData);
			else
				table.clear(self.actDic);
				self.actDic[self.showData.actType] = 1;
				arr:clear();
				arr:add(self.showData.actIdx);
				selectIdx = 1;
			end
		else
			selectIdx = self:getSelectIdx(arr, self.showData.main_id);
		end
	elseif type(self.showData) == "number" then
		selectIdx = self:getSelectIdx(arr, self.showData);
	end

	if actVo ~= nil then
		selectIdx = self:getSelectIdx(arr, actVo);
	end
	self:setShowActList(arr, selectIdx, actVo);
end

function Lua_InternalActivitiesWindow:setShowActList(arr, selectIdx, actVo)
	selectIdx = selectIdx or 1;
	local width = self.mainItemW * arr:getSize();
	width = width > 605 and 605 or width;
	self.actList:setContentRect(width, self.mainItemH, false);
	self.actList:setArrayData(arr);
	self.actList.canDrag = not self.actList.isTheEnd
	self.actList:moveToIndex(selectIdx, true);
	self.actList:setSelectClick(selectIdx);
end

-- 获取选中索引，并且设置是否当前界面显示的活动
function Lua_InternalActivitiesWindow:getSelectIdx(arr, param)
	if type(param) == "table" then
		for i = 1, arr:getSize() do
			if (arr[i].actIdx and arr[i].actIdx == param.actIdx and arr[i].actType == param.actType) or arr[i].id == param.id then
				print(i)
				return i;
			end
		end
	else
		for i = 1, arr:getSize() do
			if (arr[i].actIdx and arr[i].actIdx == param) or (arr[i].id and arr[i].id == param) then
				return i;
			end
		end
	end
	return 1;
end

function Lua_InternalActivitiesWindow:onActivitySelected(actVo)
	if self.mainActVo == actVo or not self:checkActivityIsExist(actVo) then -- 一级页签重复点击
		return;
	end
	DataCenter.operationalActUtil.selectedActVo = actVo;
	self.mainActVo = actVo;

	if actVo.actIdx == nil and actVo.hasSecTab == true then
		if self.btnList == nil then
			self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal)
			self.btnList:setRectAnchor(7)
			self.btnList:setLocation(0, 223, 0)
			self.btnList:setButtonCell(Lua_ActivitySubItem)
			self.btnList:setButtonItem(162, 60)
			self.btnList:setClickCallBack(self, self.onSubActivitySelected)
		end
		self.btnList:setEnable(true);

		local arr = actVo.secTabArr;
		local selectIdx = 1;
		if type(self.showData) == "table" then
			selectIdx = self:getSelectIdx(arr, self.showData.sub_id);
		elseif type(self.showData) == "number" then
			selectIdx = self:getSelectIdx(arr, self.showData);
		end

		if not arr[selectIdx].bOpened then
			selectIdx = nil
			local len = arr:getSize();
			local index = 1;
			while index <= len do
				if arr[index].bOpened then
					selectIdx = index;
					break;
				end
				index = index + 1
			end
		end
		self.btnList:setData(arr)
		if selectIdx then
			self.btnList:setSelected(selectIdx);
		end
	else
		if self.btnList then
			self.btnList:setEnable(false);
		end
		self:updateShowPanel(actVo);
	end
	self.showData = nil;
end

function Lua_InternalActivitiesWindow:onSubActivitySelected(index, actVo)
	if self.actVo == actVo or not self:checkActivityIsExist(actVo) then
		return;
	end
	self:updateShowPanel(actVo);
end