Lua_ResourcesData = class("Lua_ResourcesData")
function Lua_ResourcesData.getConfigDataById(id)
    if Lua_ResourcesData.configs == nil then
        Lua_ResourcesData.configs = { };
    end
    if Lua_ResourcesData.configs[id] == nil then
        local config = getConfig("resources", id);
        if config == nil then
            return nil;
        end
        Lua_ResourcesData.configs[id] = Lua_ResourcesData.new(id, config);
    end
    return Lua_ResourcesData.configs[id];
end

function Lua_ResourcesData:ctor(id, config)
    self:superCall("ctor");
	self.id = id;
    self.config = config;
    if config == nil then
        self.config = getConfig("resources", id);
    end
end

function Lua_ResourcesData.Get:itemVo()
    if self._itemVo == nil then
        self._itemVo = Lua_ToolVo.createToolVo(self.id);
    end
    return self._itemVo;
end

function Lua_ResourcesData.Get:iconAtlas()
    return self.itemVo.iconAtlas;
end

function Lua_ResourcesData.Get:iconSprite()
    return self.itemVo.iconSprite;
end

function Lua_ResourcesData.Get:iconWidth()
    return self.itemVo.iconWidth;
end

function Lua_ResourcesData.Get:iconHeight()
    return self.itemVo.iconHeight;
end

-------------------- 配置数据 --------------------

function Lua_ResourcesData.Get:name()
    return self.config.name;
end

function Lua_ResourcesData.Get:resources_limit()
    if self.config.resources_limit == nil then
        return 0;
    end
    return self.config.resources_limit;
end

function Lua_ResourcesData.Get:buy_consume()
    return self.config.buy_consume;
end