Lua_PackUtil = class("Lua_PackUtil");
function Lua_PackUtil:ctor()
	self:superCall("ctor");
end

function Lua_PackUtil:doActClick(data, actVal)
	if data == nil then
		return;
	end
	if data.isExpired then
		OperateAlert.showLangValue(309077);
		return;
	end

	-- 1使用 2合成 3分解 4出售 5详情 6穿戴 7重铸 8洗练
	if actVal == 1 then
		self:useItem(data, actVal);
	elseif actVal == 2 then
		self:syntheticItem(data, actVal);
	elseif actVal == 3 then
		self:decomposeItem(data, actVal);
	elseif actVal == 4 then
		self:sellItem(data, actVal);
	elseif actVal == 5 then
		self:checkDetails(data);
	elseif actVal == 6 then
	elseif actVal == 7 then
	elseif actVal == 8 then
	end
end

-- 使用
function Lua_PackUtil:useItem(data, actVal)
	if data == nil then
		return;
	end

	if data.main_type == Lua_PackDefine.GIFT_BAG then
		if data.limit_times ~= nil and data.use_times ~= nil and data.limit_times - data.use_times <= 0 then
			OperateAlert.showLangValue(309033);
			return;
		end

		if data.count < data.eachAmount then
			OperateAlert.showLangValue(124013);
			return;
		end

		if data.sub_type == Lua_PackDefine.GIFT_BAG_SELECT or data.sub_type == Lua_PackDefine.GIFT_BAG_SELECT_HERO then
			Lua_WindowUtil.openWin("Lua_GiftSelectionWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = actVal });
			return;
		end
	end

	if data.use_type == 1 then
		if data.main_type == Lua_PackDefine.ROLE_DRESSUP then
			Lua_ProxyManager.getProxy("Lua_RoleProxy"):sActivateDressUp(data.clothes_id);
			Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
		else
			if data.isBatch > 0 then
				Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = actVal });
			else
				Lua_ProxyManager.getProxy("Lua_PackProxy"):sUseItem(data.pack_type, data.unique_id, 1, nil);
				Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
			end
		end
	elseif data.use_type == 2 then
		DataCenter.funcPathUtil:gotoFunction(data.func_path_id, true)
	end
end

-- 合成
function Lua_PackUtil:syntheticItem(data, actVal)
	if data == nil then
		return;
	end

	if data.count < data.compound[2] then
		OperateAlert.showLangValue(124013);
	else
		Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = actVal });
	end
end

-- 分解
function Lua_PackUtil:decomposeItem(data, actVal)
	if data == nil then
		return;
	end

	-- if data.count == 1 then
	-- 	Lua_ProxyManager.getProxy("Lua_PackProxy"):sDecomposeItem(data.id, 1);
	-- 	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
	-- elseif data.count  > 1 then
	-- 	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = actVal });
	-- end
	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = actVal });
end

-- 出售
function Lua_PackUtil:sellItem(data, actVal)
	if data == nil then
		return;
	end
	
	if data.sell_tips == 1 then
		local tipsData = { data = data, actVal = actVal, des = LanUtil.formateStr(309067, data.colorName), 
							btnType = 1, owner = self, sureFun = self.sellSureFun };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:onSell(data, actVal);
	end
end

function Lua_PackUtil:sellSureFun(tipsData)
	if tipsData == nil then
		return;
	end

	self:onSell(tipsData.data, tipsData.actVal);
end

function Lua_PackUtil:onSell(data, actVal)
	-- if data.count == 1 then
	-- 	local tab = {};
	-- 	tab[data.unique_id] = data;
	-- 	Lua_ProxyManager.getProxy("Lua_PackProxy"):sSellItem(tab);
	-- 	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
	-- else
	-- 	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = actVal });
	-- end
	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, actVal = actVal });
end

function Lua_PackUtil:checkDetails(data)
	if data.main_type == Lua_PackDefine.HERO then
		DataCenter.heroAtlasData:onOpenAtlasWindow(data.hero_id);
	elseif data.main_type == Lua_PackDefine.HERO_CHIP_FIXED then
		DataCenter.heroAtlasData:onOpenAtlasWindow(data.compound[1]);
	end
	Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_ItemInfoWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_HeroItemDetailsWindow", Lua_WinParam.ACTION_CLOSE);
end

-- 道具详情
-- 普通道具 value1=是否在背包中打开
-- 藏品 value1=玩家ID
function Lua_PackUtil:showItemInfo(data, isShowBtns, value1)
	if data == nil or (self.startTime ~= nil and getTime() - self.startTime <= 0.3) then
		return;
	end
    self.startTime = getTime();

	if type(data) == "number" or type(data) == "string" then
		data = Lua_ToolVo.createToolVo(tonumber(data));
	end
	isShowBtns = isShowBtns ~= nil and isShowBtns or false;
	
	if data.main_type == Lua_PackDefine.HERO then
		Lua_WindowUtil.openWin("Lua_HeroItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, isShowBtns = true })
	elseif data.main_type == Lua_PackDefine.EQUIP then
		Lua_WindowUtil.openWin("Lua_EquipTipsWindow", Lua_WinParam.ACTION_OPEN, { data = data, isShowBtns = isShowBtns });
	elseif data.main_type == Lua_PackDefine.RUNES then
		if data.cur_prop == nil or #data.cur_prop <= 0 then
			Lua_WindowUtil.openWin("Lua_RunesRecastSkillDesWindow", Lua_WinParam.ACTION_OPEN, data);
		else
			Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_OPEN, { data = data, isShowBtns = isShowBtns });
		end
	elseif data.main_type == Lua_PackDefine.COLLECTION then
		if value1 == nil or value1 == DataCenter.roleData.roleId then
			Lua_WindowUtil.openWin("Lua_CollectionDetailWindow", Lua_WinParam.ACTION_OPEN, {id = data.id, isShowInfo = false});
		else
			Lua_ProxyManager.getProxy("Lua_CollectionProxy"):sOtherCollectionInfo(value1, data.id);
		end
	elseif data.isHeroSystem == true then
		if data.bExplainTips then--英雄核心机制说明tips
			Lua_WindowUtil.openWin("Lua_HeroExplainTipsWindow", Lua_WinParam.ACTION_OPEN, data);
			return
		end
		if data.unique_id == nil then--请求展示配置表英雄数据
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroAttr(data.id, data.star, data.level);
		else
			Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, data);
		end
	else
		if Lua_WindowUtil.isWindowShowing("Lua_ItemDetailsWindow") then
			Lua_WindowUtil.openWin("Lua_ItemInfoWindow", Lua_WinParam.ACTION_OPEN, { data = data, isShowBtns = isShowBtns, isInPack = value1 });
		else
			Lua_WindowUtil.openWin("Lua_ItemDetailsWindow", Lua_WinParam.ACTION_OPEN, { data = data, isShowBtns = isShowBtns, isInPack = value1 });
		end
	end
end

-- 获取途径 param：道具Id或Lua_ToolVo
function Lua_PackUtil:openPathWindow(param, showTips)
	if type(param) == "number" or type(param) == "string" then
		param = Lua_ToolVo.createToolVo(tonumber(param));
	end

	if showTips ~= false then
		OperateAlert.show(LanUtil.formateStr(300, param.name));
	end

	Lua_WindowUtil.openWin("Lua_ObtainPathWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_PackUtil:openHeroWindow(arr)
	if arr == nil then
		return;
	end

    local heroId = arr:shift();
    if heroId == nil then
        return;
    end
    local heroVo = Lua_HeroVo.new(heroId);
    local param = { heroVo = heroVo, heroArr = arr };
    DataCenter.preLoadData:preShowModelScene("Lua_RecruitShowSingleHeroWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, param, heroVo);
end

function Lua_PackUtil:onShowModel(param, modelScenePanel, isSuccess)
	if isSuccess == true then
	    param.modelScenePanel = modelScenePanel;
	    Lua_WindowUtil.openWin("Lua_RecruitShowSingleHeroWindow", Lua_WinParam.ACTION_OPEN, param);
	end
	self:removeShowModel();
end

function Lua_PackUtil:removeShowModel()
    DataCenter.preLoadData:removeBySign("Lua_RecruitShowSingleHeroWindow", self, self.onShowModel);
end