--巅峰对决数据
Lua_PeakDuelData = class("Lua_PeakDuelData")
function Lua_PeakDuelData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_PeakDuelData:dispose()
	self:stopTimer();
	self.segmentLvl = 101;
	self.region_id = 0;
	self._start_tick = nil;
	self._match_end_tick = nil;
	self.times = 1;
	self.top_three_role = nil;
	self.buy_times = 0;
	self.left_buy_times = 0;
	self._left_match_times = 0;
	self._left_praise_times = 0;
	self._left_support_times = 0;
	self.last_fight_tick = 0; -- 匹配冷却时间
	self._segment_reward_state = nil;
	self.match_result = 0;
end

function Lua_PeakDuelData:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true
		Lua_CommonUtil.addTimer("Lua_PeakDuelData", 1, self, self.onTimer)
	end
end

function Lua_PeakDuelData:stopTimer()
	if self.bTimer == true then
		self.bTimer = false
		Lua_CommonUtil.removeTimer(self, self.onTimer)
	end
end

function Lua_PeakDuelData:onTimer()
	self.hookIntervalSec = self.hookIntervalSec + 1
	if self.hookIntervalSec > 59 then -- 1分钟更新挂机收益
		Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDHookTime()
		self.hookIntervalSec = 0
	end
end

function Lua_PeakDuelData.Get:startTick()
	return self._start_tick or 0
end

function Lua_PeakDuelData.Get:matchEndTick()
	return self._match_end_tick or 0
end

-- 匹配冷却时间
function Lua_PeakDuelData.Get:matchCoolTime()
	if self.last_fight_tick > 0 then
		local matching_cool_time = DataCenter.peakDuelUtil.matching_cool_time
		local interval = DataCenter.roleData.serverTime - self.last_fight_tick
		return matching_cool_time - interval
	end
	return 0
end

-- 剩余匹配次数
function Lua_PeakDuelData.Get:left_match_times()
	return self._left_match_times or 0
end

function Lua_PeakDuelData.Set:left_match_times(value)
	self._left_match_times = value
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.PeakDuel_Match, self.is_off_season == 0 and value > 0)
end

-- 剩余点赞次数
function Lua_PeakDuelData.Get:left_praise_times()
	return self._left_praise_times or 0
end

function Lua_PeakDuelData.Set:left_praise_times(value)
	self._left_praise_times = value
	if value > 0 then
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.PeakDuel_Like, true)
	else
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.PeakDuel_Like, false)
	end
end

function Lua_PeakDuelData.Get:segment_reward_state()
	return self._segment_reward_state or 0
end

-- 段位奖励状态 0:不可领 1:可领 2：已领取
function Lua_PeakDuelData.Set:segment_reward_state(value)
	self._segment_reward_state = value
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.PeakDuel_Reward, self.is_off_season == 0 and value == 1)
end

-- 巅峰对决界面信息(返回)
function Lua_PeakDuelData:fromServer50161001(msg)
	if msg == nil then
		return;
	end
	self.segmentLvl = msg.segment_lvl; -- 当前段位
	self.region_name = msg.region_name; -- 赛区
	self.region_id = tonumber(msg.region_id); -- 赛区id
	self._start_tick = tonumber(msg.start_tick); -- 赛季开始时间
	self._match_end_tick = tonumber(msg.match_end_tick); -- 比赛结束时间
	self.times = msg.times; -- 第几赛季
	self.is_off_season = msg.is_off_season; -- 是否是休赛期 1：是 0：不是休赛期
	self.top_three_role = msg.top_three_role; -- 前三名
	self.buy_times = msg.buy_times; -- 今日已经够买匹配次数
	self.left_buy_times = msg.left_buy_times; -- 剩余购买次数
	self.left_match_times = msg.left_match_times; -- 剩余匹配次数
	self.left_praise_times = msg.left_praise_times; -- 剩余点赞次数
	self.last_fight_tick = tonumber(msg.last_fight_tick); -- 上次战斗时戳
	self.segment_reward_state = msg.segment_reward_state;

	self:checkHookRedPoint(msg)
end

function Lua_PeakDuelData:fromServer50161003(msg)
	if msg == nil then
		return;
	end
	self.left_match_times = msg.left_match_times; -- 剩余匹配次数
	self.match_result = msg.match_result; -- 匹配结果 1：成功 0：失败
end

function Lua_PeakDuelData:fromServer50161005(msg)
	if msg == nil then
		return;
	end
	self.segment_reward_state = msg.segment_reward_state;
end

function Lua_PeakDuelData:fromServer50161009(msg)
	if msg == nil then
		return;
	end
	self.left_praise_times = msg.left_praise_times; --剩余点赞次数
end

function Lua_PeakDuelData:fromServer50161026(msg)
	if msg == nil then
		return;
	end	
	self.left_praise_times = msg.left_praise_times; --剩余点赞次数
end

function Lua_PeakDuelData:fromServer50161021(msg)
	if msg == nil then
		return;
	end
	self.left_buy_times = msg.left_buy_times; -- 剩余购买次数
	self.left_match_times = msg.left_match_times; -- 剩余匹配次数
	self.buy_times = msg.buy_times; -- 今日已经够买匹配次数
end

function Lua_PeakDuelData:fromServer50161022(msg)
	if msg == nil then
		return;
	end
	self.left_match_times = msg.left_match_times; -- 剩余匹配次数
	self.match_result = msg.is_have_match; -- 是否有匹配数据 0没有 1有匹配数据
end

function Lua_PeakDuelData:fromServer80161027(msg)
	if msg == nil then
		return;
	end
	local info
	for i = 1, #msg.red_point_info do
		info = msg.red_point_info[i]
		if info.key == 1 then -- 巅峰对决竞猜
			DataCenter.redPointData:updateRedPointState(Lua_RedPointList.PeakDuel_Guess, info.value == 1);
		end
	end	
end










function Lua_PeakDuelData:checkHookRedPoint(msg)
	local state = false
	if self.is_off_season == 0 then
		local config = DataCenter.peakDuelUtil:getSegmentInfoByid(self.segmentLvl)
		if msg.offline_score_profit >= config.score_limit then
			self:stopTimer()
		else
			self.hookIntervalSec = tonumber(msg.offline_duration) % 3600 % 60
			self:startTimer()
		end
		state = (msg.offline_score_profit / config.score_limit) >= DataCenter.peakDuelUtil.hook_limit_per
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.PeakDuel_Hook, state)
end