--巅峰对决配置
Lua_PeakDuelUtil = class("Lua_PeakDuelUtil");
function Lua_PeakDuelUtil:ctor()
	self:superCall("ctor");
end

---------------------------------- 巅峰对决常量数据 -------------------------------------------

-- 每日免费匹配次数
function Lua_PeakDuelUtil.Get:match_times()
    return getConfig("peak_duel_const", "daily_free_match_times", "value");
end

-- 匹配冷却时间
function Lua_PeakDuelUtil.Get:matching_cool_time()
    return getConfig("peak_duel_const", "matching_cool_time", "value");
end

-- 每日竞猜支持次数
function Lua_PeakDuelUtil.Get:daily_guess_times()
    return getConfig("peak_duel_const", "daily_guess_times", "value");
end

-- 竞猜正确奖励
function Lua_PeakDuelUtil.Get:guess_reward()
    return getConfig("peak_duel_const", "guess_reward", "json_value1");
end

-- 竞猜错误奖励
function Lua_PeakDuelUtil.Get:guess_fail_reward()
    return getConfig("peak_duel_const", "guess_fail_reward", "json_value1");
end

-- 每日点赞次数
function Lua_PeakDuelUtil.Get:daily_praise_num()
    return getConfig("peak_duel_const", "daily_praise_num", "value");
end

function Lua_PeakDuelUtil.Get:hook_limit_per()
    return getConfig("peak_duel_const", "hook_limit_per", "value_float");
end


---------------------------------- 巅峰对决段位数据 -------------------------------------------

function Lua_PeakDuelUtil:getSegmentArr()
	if self._segmentArr == nil then
		self._segmentArr = Array();
		local config = getConfig("peak_duel_segment_lvl");
		for k, _ in pairs(config) do
			self._segmentArr:add(k);
		end
		quickSort(self._segmentArr, nil, false);
	end
	return self._segmentArr;
end

-- 首达奖励
function Lua_PeakDuelUtil:getFirstPassRewards()
	if self.firstArr == nil then
		self.firstArr = Array();
		local arr = self:getSegmentArr();
		local configData;
		local list;
		local rewards;
		local tvo;
		for i = 1, arr:getSize() do
			configData = self:getSegmentInfoByid(arr[i]);
			list = configData.segment_lvl_reward;
			if list then
				rewards = Array();
				for j = 1, #list do
					tvo = Lua_ToolVo.createToolVo(list[j][1], list[j][2]);
					rewards:add(tvo);
				end
				self.firstArr:add({ id = arr[i], rewards = rewards });
			end
		end
	end
	return self.firstArr;
end

-- 段位奖励
function Lua_PeakDuelUtil:getRankRewards()
	if self.rankArr == nil then
		self.rankArr = Array();
		local arr = self:getSegmentArr();
		local configData;
		local list;
		local rewards;
		local tvo;
		for i = 1, arr:getSize() do
			configData = self:getSegmentInfoByid(arr[i]);
			list = configData.sports_reward;
			if list then
				rewards = Array();
				for j = 1, #list do
					tvo = Lua_ToolVo.createToolVo(list[j][1], list[j][2]);
					rewards:add(tvo);
				end
				self.rankArr:add({ id = arr[i], rewards = rewards });
			end
		end
	end
	return self.rankArr;
end

-- 挂机奖励
function Lua_PeakDuelUtil:getHookRewards()
	if self.hookArr == nil then
		self.hookArr = Array();
		local arr = self:getSegmentArr();
		local configData;
		local list;
		local rewards;
		local tvo;
		for i = 1, arr:getSize() do
			configData = self:getSegmentInfoByid(arr[i]);
			list = configData.each_sec_score;
			if list then
				rewards = Array();
				tvo = Lua_ToolVo.createToolVo(list[1], list[2]);
				rewards:add(tvo);
				self.hookArr:add({ id = arr[i], rewards = rewards });
			end
		end
	end
	return self.hookArr;
end

-- 获取某个段位数据
function Lua_PeakDuelUtil:getSegmentInfoByid(segment_id)
	local config = getConfig("peak_duel_segment_lvl", segment_id)
	if config == nil then
		config = getConfig("peak_duel_segment_lvl", 101)
	end
	return config;
end

-- 赛区数据
function Lua_PeakDuelUtil:getDivisionConfig(id)
	return getConfig("peak_duel_range_name", id);
end

function Lua_PeakDuelUtil:getMatchTimesConfig(id)
	return getConfig("peak_duel_buy_match", id);
end