--问卷调查配置
Lua_QuestionUtil = class("Lua_QuestionUtil");
function Lua_QuestionUtil:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_QuestionUtil:dispose()
    self.wordsDic = nil;--答题内容
    self.indexDic = nil;--答题选择
    self.triggerDic = nil;--前置触发列表
    self._questionDic = nil;
end

function Lua_QuestionUtil:getQuestionDic()
    local version_id = DataCenter.questionData.version_id;
    local configData = self:getQuestionVersionCfgData(version_id)
    if configData == nil then 
        return
    end

    if self._questionDic == nil then
        self._questionDic = {};
        local page;--页数
        local cfgData;
        local list = configData.question_list;
        self.all_num = 0;
        for i=1,#list do
            cfgData =  self:getQuestionCfgDataById(list[i]);
            if cfgData ~= nil then
                page = cfgData.page;
                if self._questionDic[page] == nil then
                    self._questionDic[page] = Array();
                    self.all_num = self.all_num + 1;
                end
                self._questionDic[page]:add(list[i]);
            end
        end
    end

    return self._questionDic, self.all_num;
end

--问卷版本
function Lua_QuestionUtil:getQuestionVersionCfgData(version_id)
    return getConfig("question_version",version_id);
end

--问卷选项
function Lua_QuestionUtil:getQuestionOptionCfgData(id)
    return getConfig("question_option", id);
end

--问卷题
function Lua_QuestionUtil:getQuestionCfgDataById(id)
    return getConfig("question_reward", id);
end



--当前提号id列表
function Lua_QuestionUtil:getQuestionArrByPage(page)
    if self._questionDic == nil then
        self:getQuestionDic();
    end
    if self._questionDic[page] == nil then
        return Array();
    end
    return self._questionDic[page];
end











--记录客户端选择题 index 选择的索引  words 填空题内容
function Lua_QuestionUtil:addClientQuestion(id, index, words)
    if self.wordsDic == nil then
        self.wordsDic = {};
    end
    
    if index ~= nil then
        if self.indexDic == nil then
            self.indexDic = {};
        end
        if self.indexDic[id] == nil then
            self.indexDic[id] = Array();
        end

        if self.indexDic[id]:indexOf(index) <= 0 then
            self.indexDic[id]:add(index);
        end
        if self.wordsDic[id] == nil then
            self.wordsDic[id] = {};
        end
        -- print(id," c   ",index,"   self.indexDic[id]  = =",self.indexDic[id]:getSize())
        self.wordsDic[id][index] = words;
        self:updateTriggerState(id, index, true);
    else
        self.wordsDic[id] = words;
    end
end

--获取选择提的答案
function Lua_QuestionUtil:getSelectQuestionArr(id)
    if self.indexDic ~= nil and self.indexDic[id] ~= nil then
        return self.indexDic[id];
    end

    return nil;
end

--获取填空题的答案
function Lua_QuestionUtil:getWordsQuestion(id, index)
    if self.wordsDic ~= nil and self.wordsDic[id] ~= nil then
        if index ~= nil then
            return self.wordsDic[id][index];
        else
            return self.wordsDic[id];
        end
    end

    return nil;
end


--移除记录客户端选择题
function Lua_QuestionUtil:removeClientQuestion(id, index)

    if self.indexDic ~= nil and self.indexDic[id] ~= nil then
        self.indexDic[id]:removeItem(index);
        -- print(id, "   移除记录客户端选择题     ",index,"    ",self.indexDic[id]:getSize())
    end

    if self.wordsDic ~= nil and self.wordsDic[id] ~= nil then
        self.wordsDic[id] = nil;
    end
    self:updateTriggerState(id, index, false);
end

--更新激活前置条件状态
function Lua_QuestionUtil:updateTriggerState(id, index, bool)
    if self.triggerDic == nil then
        self.triggerDic = {};--触发列表
    end

    local cfgData = self:getQuestionCfgDataById(id);
    local index_list = cfgData.trigger_list;--触发列表
    local section_or = cfgData.trigger_section_or;--触发区间列表（或）
    local section_and = cfgData.trigger_section_and;--触发区间列表（且）

    
    --选中指定索引，激活指定题目列表
    if index_list ~= nil then
        for i=1, #index_list do
            -- print("index_list[i][1] = =",index_list[i][1])
            if index_list[i][1] == index then
                local list = index_list[i][2];
                local trigger_id;--触发的id
                for j=1, #list do
                    -- print(list[j],"  激活 1111111  = =",bool)
                    trigger_id = list[j]
                    self.triggerDic[trigger_id] = bool;
                    self:closeActivitieIdState(trigger_id, bool);
                end
            end
        end
    end

    local arr = self:getSelectQuestionArr(id);--选中的索引列表

    --选中任意一个索引，激活指定题目
    if section_or ~= nil and arr ~= nil then
        local tag_index = {};
        for i=1, arr:getSize() do
            tag_index[arr[i]] = 1;
        end

        local bState = false;
        local list = section_or[1];
        for i=1, #list do
            if tag_index[list[i]] == 1 then
                bState = true;
                break;
            end
        end

        local trigger_id = section_or[2];
        self.triggerDic[trigger_id] = bState;
        -- print(trigger_id,"  激活 22222222  = =",bState)
        if bState == false then
            self:closeActivitieIdState(trigger_id, false);
        end
    end

    --选中所有索引，激活指定题目
    if section_and ~= nil and arr ~= nil then
        local tag_index = {};
        for i=1, arr:getSize() do
            tag_index[arr[i]] = 1;
        end

        local bState = true;
        local list = section_and[1];
        for i=1, #list do
            if tag_index[list[i]] ~= 1 then
                bState = false;
                break;
            end
        end

        local trigger_id = section_and[2];
        self.triggerDic[trigger_id] = bState;
        -- print(trigger_id,"   激活 1 @  ",bState)
        if bState == false then
            self:closeActivitieIdState(trigger_id, bool);
        end
    end
end

-- 关闭已激活的id状态
function Lua_QuestionUtil:closeActivitieIdState(trigger_id, bool)
    if bool == false then--关闭触发的id
        local arr = self:getSelectQuestionArr(trigger_id);
        if arr ~= nil then
            for i=1,arr:getSize() do
                self:updateTriggerState(trigger_id, arr[i], false);--关闭触发的id，如果还有触发列表，就检测列表的id是否被激活，如果被激活就继续关闭
                --关闭触发的id，移除id的选择项
                if self.indexDic ~= nil then
                    self.indexDic[trigger_id] = nil;
                end
                if self.wordsDic ~= nil then
                    self.wordsDic[trigger_id] = nil;
                end
            end
        end
    end
end


--是否激活
function Lua_QuestionUtil:getTriggerState(id)
    local cfgData = self:getQuestionCfgDataById(id);
    if cfgData.before == nil then
        return true;
    end

    if self.triggerDic == nil then
        return false;
    end
    return self.triggerDic[id] == true;
end

--当前提是否已选择
function Lua_QuestionUtil:bSelectCurPage(page)
    local arr = self:getQuestionArrByPage(page);
    local bool = false;
    for i=1,arr:getSize() do
        local questionArr = DataCenter.questionUtil:getSelectQuestionArr(arr[i]);
        bool = (questionArr ~= nil and questionArr:getSize() > 0);
        if bool then
            break;
        end
    end
    return bool;
end

--是否已选择了答案
function Lua_QuestionUtil:bSelectQuestion(page, showTips)
    local cfgData;
    local arr = self:getQuestionArrByPage(page);
    for i=1,arr:getSize() do
        cfgData = self:getQuestionCfgDataById(arr[i]);
        if cfgData.contentTemplate == 1 then--选择
            local questionArr = self:getSelectQuestionArr(arr[i]);
            if questionArr == nil or questionArr:getSize() == 0 then
                if showTips then
                    OperateAlert.show(LanUtil.formateStr(650001,tostring(cfgData.limit_min)));
                end
                return false;
            else
                local list = cfgData.content;
                local tag_index;--补充填空选项的索引
                for j=1,#list do
                    if self:getQuestionOptionCfgData(list[j]).limit_num ~= nil then
                        tag_index = j;
                    end
                end
                -- print(tag_index,"  1111111111111  ",questionArr:indexOf(tag_index),"     ", self:getWordsQuestion(arr[i], tag_index))
                if questionArr:indexOf(tag_index) > 0 then--选中了补充填空选项的索引
                    local str = self:getWordsQuestion(arr[i], tag_index);
                    if str == nil then
                        if showTips then
                            OperateAlert.showLangValue(650003);
                        end
                        return false;
                    else
                        if str ~= "" then
                            -- 敏感字限制
                            if LanUtil.isIncludeInvalidWord(str) or string.find(str, "\\") ~= nil then     --含违规字符
                                OperateAlert.showLangValue(171031);
                                return false;
                            end
                        end
                    end
                end
            end
        elseif cfgData.contentTemplate == 2 then--矩阵
            local questionArr = self:getSelectQuestionArr(arr[i]);
            if questionArr == nil or questionArr:getSize() == 0  then
                if showTips then
                    OperateAlert.showLangValue(650013);
                end
                return false;
            end
        elseif cfgData.contentTemplate == 3 then--填空
            local str = self:getWordsQuestion(arr[i]);
            if str == nil then
                if showTips then
                    OperateAlert.showLangValue(650003);
                end
                return false;
            else
                if str ~= "" then
                    -- 敏感字限制
                    if LanUtil.isIncludeInvalidWord(str) or string.find(str, "\\") ~= nil then     --含违规字符
                        OperateAlert.showLangValue(171031);
                        return false;
                    end
                end
            end
        elseif cfgData.contentTemplate == 4 then--量表
            --量表默认有选择
        end
    end

    return true;
end


--获取当前答题题目
function Lua_QuestionUtil.Get:curPage()
    if self.indexDic == nil and self.wordsDic == nil then
        return 1;
    end

    local curpage = 0;
    local curId = 0;
    for k,v in pairs(self.indexDic) do
        if curId < k then
            curId = k;
        end
    end
    local list;
    local all_num;
    list, all_num = self:getQuestionDic();
    for page, arr in pairs(list) do
        for i=1,arr:getSize() do
            if arr[i] == curId then
               curpage = page;
               break;
            end 
        end
        if curpage > 0 then
            break;
        end
    end

    -- print(curpage,"   222222222222222  ",   curpage)
    if curpage ~= all_num then
        local bActive = false;
        while bActive == false do
            curpage = curpage + 1;
            local arr = list[curpage];
            for i=1,arr:getSize() do
                bActive = DataCenter.questionUtil:getTriggerState(arr[i]);
                if bActive then
                    break;
                end
            end
        end
    end
    -- print("11111111 = ",curpage);

    return curpage;
end