checkRequire("Lua_MonthlyGiftVo");
Lua_MonthlyGiftData = class("Lua_MonthlyGiftData")
function Lua_MonthlyGiftData:ctor()
	self:dispose();
end

function Lua_MonthlyGiftData:dispose()
	self._monthlyGiftArr = Array();
	self.monthlyGiftVo = {};
	self.openWeek = nil;
	self.worldLv = nil;
end

function Lua_MonthlyGiftData:fromServer50197014(msg)
	if msg == nil then
		return;
	end

	self.openWeek = msg.open_week; -- 开服天数
	self.worldLv = msg.world_level; -- 世界等级
	self.nextMonth = msg.next_month; -- 下月刷新时间戳
	self:updateMonthlyGiftInfo(msg.grade_state); -- 各档位剩余领取次数 key礼包id value剩余次数
end

function Lua_MonthlyGiftData:updateMonthlyGiftInfo(msg)
	local obj;
	local vo;
	local redShowState = false;
	self._monthlyGiftArr:clear();
	for i = 1, #msg do
		obj = msg[i];
		vo = self.monthlyGiftVo[obj.key];
		if vo == nil then
			local config = getConfig("month_gift", obj.key);
			if config ~= nil then
				vo = Lua_MonthlyGiftVo.new(obj.key, config);
				self.monthlyGiftVo[obj.key] = vo;
			end
		end

		if vo ~= nil then
			vo:updateBuyTimes(obj.value, self.openWeek, self.worldLv);
			if vo.isOpened then
				self._monthlyGiftArr:add(vo);
				if not redShowState and vo.recharge == 0 and vo.curLimitTimes > 0 then
					redShowState = true;
				end
			end
		end
	end
	-- 策划要求屏蔽月卡，红点隐藏
	-- DataCenter.redPointData:updateRedPointState(Lua_RedPointList.RaccoonMart_GiftShop_MonthlyGift, redShowState);
end

function Lua_MonthlyGiftData:getMonthlyGiftVoById(id)
	return self.monthlyGiftVo[id];
end

function Lua_MonthlyGiftData.Get:monthlyGiftArr()
	self._monthlyGiftArr:sortf(self, self.sortFun);
	return self._monthlyGiftArr;
end

function Lua_MonthlyGiftData:sortFun(a, b)
	local _a = a.curLimitTimes;
	local _b = b.curLimitTimes;
	if (_a > 0 and _b > 0) or (_a <= 0 and _b <= 0) then
		if a.id > b.id then
			return false;
		end
	elseif _b > 0 then
		return false;
	end
	return true;
end