Lua_MonthlyGiftVo = class("Lua_MonthlyGiftVo")
function Lua_MonthlyGiftVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_MonthlyGiftVo:updateBuyTimes(times, openWeek, worldLv)
	self.curLimitTimes = times;
	self.openWeek = openWeek;
	self.worldLv = worldLv;
end

function Lua_MonthlyGiftVo.Get:isOpened()
	local isOpenCond = self.openWeek >= self.open_week;
	local isLvCond = #self.world_level > 1 and self.world_level[1] <= self.worldLv and self.world_level[2] >= self.worldLv;
	return isOpenCond and isLvCond;
end










function Lua_MonthlyGiftVo.Get:config()
	if self._config == nil then
		self._config = getConfig("month_gift", self.id);
	end
	return self._config;
end

-- 购买金额
function Lua_MonthlyGiftVo.Get:recharge()
	local recharge;
	if self.config.recharge_type == 1 then
		recharge = 0;
	else
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.id);
		recharge = tonumber(rechargeInfo.money);
	end
	return recharge;
end

-- 限制购买次数
function Lua_MonthlyGiftVo.Get:curLimitTimes()
	if self._curLimitTimes == nil then
		self._curLimitTimes = self.limit_times;
	end
	return self._curLimitTimes or 0;
end

function Lua_MonthlyGiftVo.Set:curLimitTimes(val)
	self._curLimitTimes = val;
end

-- 开服周数
function Lua_MonthlyGiftVo.Get:open_week()
	return self.config.open_week;
end

-- 世界等级区间
function Lua_MonthlyGiftVo.Get:world_level()
	return self.config.world_level;
end

-- 限购总次数
function Lua_MonthlyGiftVo.Get:limit_times()
	return self.config.limit_times;
end

-- 奖励
function Lua_MonthlyGiftVo.Get:reward()
	return self.config.reward;
end

-- 奖励icon
function Lua_MonthlyGiftVo.Get:reward_icon()
	return self.config.reward_icon;
end

-- 道具比列
function Lua_MonthlyGiftVo.Get:rate()
	return #self.reward < 4 and 0.5 or 0.4;
end