checkRequire("Lua_RechargeConfigData");
Lua_RechargeData = class("Lua_RechargeData");

function Lua_RechargeData:ctor()
    self:dispose();
end

function Lua_RechargeData:dispose()
    self.rechargeDic = {};
    self.recharge_money = 0--每月累计充值金额
end

function Lua_RechargeData:formServer50110001(msg)
    self.recharge_money = msg.total_money;
    self.recharge_gold = msg.total_gold;

    for k, v in ipairs(msg.recharge_list) do
        self.rechargeDic[v.recharge_id] = v;
    end

    local list = self.rechargeShowList;
    for i = 1, list:getSize() do
        if list[i] ~= nil then
            list[i] = self:getServerDataById(list[i].recharge_id);
        end
    end
end

function Lua_RechargeData:getServerDataById(id)
    if self.rechargeDic[id] == nil then
        local config = getConfig("recharge", id);
        if config ~= nil then
            local dic = {}
            dic.recharge_id = id;
            dic.type = config.type;
            dic.money = config.money;
            dic.money_type = config.money_type;
            dic.gold = config.gold;
            dic.rebate = config.rebate;
            dic.first_flag = 1; --首充标识，1 显示，0 不显示
            self.rechargeDic[id] = dic;
        end
    end
    return self.rechargeDic[id];
end

--获取充值显示单位
function Lua_RechargeData.Get:rechargeShowList()
    if self._rechargeShowList == nil then --根据不同平台获取不同的档位显示 [1,2,3,4,5,6,75]
        self._rechargeShowList = Array();
        
        local cid = ServerConfig.market;
        local showList = getConfig("recharge_show", cid, "show_moneys");
        if showList == nil then
            if CommonUtil.isApplePlatform then
                showList = getConfig("recharge_show", "default_ios", "show_moneys");
            else
                showList = getConfig("recharge_show", "default_android", "show_moneys");
            end
        end

        if showList ~= nil then
            for i = 1, #showList do
                local mitem = self:getServerDataById(showList[i]);
                if mitem ~= nil then
                    self._rechargeShowList:add(mitem);
                end
            end
        end
    end
    return self._rechargeShowList;
end