-- 充值配置
Lua_RechargeConfigData = class("Lua_RechargeConfigData");

function Lua_RechargeConfigData.getRechargeConfig(id)
	if Lua_RechargeConfigData.configsDic == nil then
		Lua_RechargeConfigData.configsDic = {};
	end

	id = tonumber(id);
	if Lua_RechargeConfigData.configsDic[id] == nil then
		local configData = Lua_RechargeConfigData.new(id);
		if configData.config == nil then
			return nil;
		end
		Lua_RechargeConfigData.configsDic[id] = configData;
	end
	return Lua_RechargeConfigData.configsDic[id];
end

function Lua_RechargeConfigData:ctor(id)
	self.id = tonumber(id);
end

function Lua_RechargeConfigData.Get:config()
	local config = DataCenter.roleData:getBackConfig("tb_back_recharge", self.id);
	if config ~= nil then
		return config;
	end

	if self._config == nil then
		self._config = getConfig("recharge", self.id);
	end
	if self._config == nil then
		LogManager.LogError("no recharge id = " .. self.id, false);
	end
	return self._config;
end

function Lua_RechargeConfigData.Get:money_type()
	if self.config == nil or self.config.money_type == nil then
		return 0;
	end
	return self.config.money_type;
end

function Lua_RechargeConfigData.Get:money()
	if self.config == nil or self.config.money == nil then
		return 0;
	end
	return self.config.money;
end

function Lua_RechargeConfigData.Get:gold()
	if self.config == nil or self.config.gold == nil then
		return 0;
	end
	return self.config.gold;
end

function Lua_RechargeConfigData.Get:doubletime()
	if self.config == nil or self.config.doubletime == nil then
		return 0;
	end
	return self.config.doubletime;
end

function Lua_RechargeConfigData.Get:rebate()
	if self.config == nil or self.config.rebate == nil then
		return 0;
	end
	return self.config.rebate;
end

function Lua_RechargeConfigData.Get:type()
	if self.config == nil or self.config.type == nil then
		return 0;
	end
	return self.config.type;
end

function Lua_RechargeConfigData.Get:gift_name()
	if self.config == nil or self.config.gift_name == nil then
		return 0;
	end
	return self.config.gift_name;
end

function Lua_RechargeConfigData.Get:recharge_altas()
	if self.config == nil or self.config.recharge_icon == nil then
		return nil;
	end
	return self.config.recharge_icon[1];
end

function Lua_RechargeConfigData.Get:recharge_icon()
	if self.config == nil or self.config.recharge_icon == nil then
		return nil;
	end
	return self.config.recharge_icon[2];
end