checkRequire("Lua_RecruitData");
checkRequire("Lua_RecruitUtil");
Lua_RecruitProxy = class("Lua_RecruitProxy");

function Lua_RecruitProxy:ctor()
    self:superCall("ctor");

	DataCenter.recruitData = Lua_RecruitData.new();
	DataCenter.recruitUtil = Lua_RecruitUtil.new(); 

	Lua_MsgUtil.addLuaMsg(80131001, self, self.rRecruitStruRed);--通知签约中心红点

    Lua_MsgUtil.addLuaMsg(50131001, self, self.rRecruitMain);--召唤信息（返回）
	Lua_MsgUtil.addLuaMsg(50131005, self, self.rRecruitStar);--召唤（返回）
	Lua_MsgUtil.addLuaMsg(50131009, self, self.rWishListInfo);--请求心愿单界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50131014, self, self.rWishBlessInfo);--请求心愿祝福界面信息(返回)
	Lua_MsgUtil.addLuaMsg(50131016, self, self.rRequireLuckyRankInfo);--请求欧气排行榜(返回)
	Lua_MsgUtil.addLuaMsg(50131017, self, self.rRequireShopExchangeItem);--请求购买兑换道具(返回)

	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.onMoneyUpdate);
	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.onMoneyUpdate);
end

function Lua_RecruitProxy:onMoneyUpdate(dic)
	if dic[Lua_ResourcesDefine.FRIENDSHIP] == nil and dic[Lua_PackDefine.ONE_DOLLAR_TICKET] == nil then
		return;
	end
	DataCenter.recruitData:updateRedPoint();
end

------------------------ 请求 ------------------------

function Lua_RecruitProxy:sRecruitMain()--召唤信息
    sendMsg(10131001);
end

--[[召唤类型： 
1：普通召唤  
2：友情召唤  
3：高级召唤  
4：水晶召唤----draw_times（1-5：表示阵营） 
5：碎片召唤----draw_times（0：一键合成，非0表示需要合成的碎片id） 
6：先知召唤----draw_times（1-10：招募次数+100-400 ：表示阵营）  
7：积分召唤----draw_times（0表示抽取）]]--
function Lua_RecruitProxy:sRecruitStar(rtype, times, num)--召唤
	local cmd = ProtoPublic_pb.Proto10131005();
    cmd.type = rtype;--招募类型
	cmd.draw_times = times;--招募次数（0：十连抽，1：抽一次）
	cmd.celebrity_num = num ~= nil and num or 0;--合成英雄数量（碎片召唤用）
    sendMsg(10131005, cmd);
end

function Lua_RecruitProxy:sWishListInfo()--请求心愿单界面信息
    sendMsg(10131009);
end

function Lua_RecruitProxy:sAddWishList(data)--请求添加心愿单
	local cmd = ProtoPublic_pb.Proto10131010();
	local struct;
	for k, v in pairs(data) do
		if v.other ~= 2 then
			struct = getProtoMsg("ProtoPair");
			struct.key = v.key;
			struct.value = v.value;
			cmd.wish_list_state:addToList(struct);
		end
	end
	sendMsg(10131010, cmd);
end

function Lua_RecruitProxy:sWishBlessInfo()--请求心愿祝福界面信息
    sendMsg(10131014);
end

function Lua_RecruitProxy:sChangeWishBless(hero_id)--请求添加心愿祝福英雄
	local cmd = ProtoPublic_pb.Proto10131015();
	cmd.hero_id = tonumber(hero_id);--英雄配置id
    sendMsg(10131015, cmd);
end

function Lua_RecruitProxy:sRequireLuckyRankInfo(rank_type) --请求欧气排行榜
	local cmd = ProtoPublic_pb.Proto10131016(); -- rank_type	说明：1 每周 2 历史
	cmd.rank_type = tonumber(rank_type);--英雄配置id
    sendMsg(10131016, cmd);
end

function Lua_RecruitProxy:sRequireShopExchangeItem(item_id, item_amount) --请求购买兑换道具
	local cmd = ProtoPublic_pb.Proto10131017(); 
	cmd.item_id = tonumber(item_id);
	cmd.item_amount = tonumber(item_amount);
    sendMsg(10131017, cmd);
end



















------------------------ 返回 ------------------------

function Lua_RecruitProxy:rRecruitStruRed(mp)--通知签约中心红点
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80131001();
		msg:ParseFromString(mp.data);
		DataCenter.recruitData:fromServer80131001(msg);
	end
end

function Lua_RecruitProxy:rRecruitMain(mp)--召唤信息（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131001();
		msg:ParseFromString(mp.data);
		DataCenter.recruitData:fromServer50131001(msg);
		Lua_MsgUtil.callFunc("UPDATE_RECRUIT_MAIN_INFO");
	end
end

function Lua_RecruitProxy:rRecruitStar(mp)--召唤（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131005();
		msg:ParseFromString(mp.data);
		DataCenter.recruitData:fromServer50131005(msg);
		Lua_MsgUtil.callFunc("CALL_RECRUIT_END");
	end
end

function Lua_RecruitProxy:rRecruitTranstPanel(mp)--英雄转换界面（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131007();
		msg:ParseFromString(mp.data);
		DataCenter.recruitData:fromServer50131007(msg);
		Lua_MsgUtil.callFunc("UPDATE_RECRUIT_TRANSPANEL_INFO");
	end
end

function Lua_RecruitProxy:rWishListInfo(mp)--请求心愿单界面信息（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131009();
		msg:ParseFromString(mp.data);
		DataCenter.recruitData:fromServer50131009(msg);
		Lua_MsgUtil.callFunc("UPDATE_RECRUIT_WISHLIST_INFO");
	end
end

function Lua_RecruitProxy:rWishBlessInfo(mp)--请求心愿祝福界面信息(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131014();
		msg:ParseFromString(mp.data);
		DataCenter.recruitData:updateWishBlessHeroFromServer(msg);
		Lua_MsgUtil.callFunc("UPDATE_RECRUIT_WISHBLESS_INFO", msg);
	end
end

function Lua_RecruitProxy:rRequireLuckyRankInfo(mp)--请求欧气排行榜(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131016();
		msg:ParseFromString(mp.data);
		DataCenter.recruitData:fromServer50131016(msg);
		Lua_MsgUtil.callFunc("UPDATE_RECRUIT_LUCKYRANK", msg.rank_type == 1);
	end
end

function Lua_RecruitProxy:rRequireShopExchangeItem(mp)--请求购买兑换道具(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50131017();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("RECRUIT_EXCHANGEITEM_UPDATECOUNT", tonumber(msg.item_residue));
	end
end