checkRequire("Lua_RecruitTypeVo");
Lua_RecruitUtil = class("Lua_RecruitUtil");

function Lua_RecruitUtil:ctor()
end

function Lua_RecruitUtil:initRecruitInfo()
    if self._recruitTotalArr == nil then
        self._recruitTotalArr = Array();
        self._recruitTotalDic = {};
        local config = getConfig("hero_recruit");
        for k,v in pairs(config) do
            local vo = Lua_RecruitTypeVo.new(k);
            self._recruitTotalArr:add(vo);
            self._recruitTotalDic[k] = vo;
        end
        self._recruitTotalArr:sort("type", false);
    end
end

function Lua_RecruitUtil.Get:recruitTotalArr()
    self:initRecruitInfo();
    return self._recruitTotalArr;
end

function Lua_RecruitUtil.Get:recruitTotalDic()
    self:initRecruitInfo();
    return self._recruitTotalDic;
end

function Lua_RecruitUtil:getRecTotVoById(id)
    return self.recruitTotalDic[id];
end





------------------------------ 心愿单 ------------------------------

function Lua_RecruitUtil:getWishListConfig(name)
    if self._wishListConfig == nil then
        self._wishListConfig = getConfig("wish_list", 1);
    end
    return self._wishListConfig[name];
end

function Lua_RecruitUtil:getWishListHeroArr(camp)
    local config = self:getWishListConfig("show_limit_hero");
    local star = DataCenter.heroUtil:getHeroAwakenStarByQuality(config[1], config[2]);
    local idArr = DataCenter.heroUtil:getHeroIdArr(star, camp);
    local arr = Array();
    local maxQuality;
    local maxStar;
    local unique_id;
    local vo;

    local uidArr;
    local uidVo;
    if idArr ~= nil then
        for i = 1, idArr:getSize() do
            vo = Lua_HeroVo.new(idArr[i]);
            maxQuality = vo.quality;
            maxStar = vo.quality_star;
            unique_id = nil;

            if DataCenter.heroData:isExistHeroById(idArr[i]) then
                vo.isHasHero = true;
                uidArr = DataCenter.heroData:getHeroUidArrById(idArr[i]);
                if uidArr ~= nil then
                    for i = 1, uidArr:getSize() do
                        uidVo = DataCenter.heroData:getItemByUniqueId(uidArr[i]);
                        if maxQuality <= uidVo.quality and maxStar < uidVo.quality_star and uidVo.is_league_transaction == false and not uidVo.trial_state then
                            maxQuality = uidVo.quality;
                            maxStar = uidVo.quality_star;
                            unique_id = uidVo.unique_id;
                        end
                    end
                end
            end

            vo.quality = maxQuality;
            vo.quality_star = maxStar;
            vo.unique_id = unique_id;
            
            if idArr[i] ~= 102001505 then
                arr:add(vo);
            end
        end
    end
    return arr;
end








-------------------------小卖部规则说明匹配------------------------------

function Lua_RecruitUtil:initRecruitRuleIntroduce()
    if self.recruitRuleIntroduce == nil then
        self.recruitRuleIntroduce = {};
        local config = getConfig("recruit_rule");
        local vo;
        for k, v in pairs(config) do
            vo = self:getRecruitRuleIntroduceById(k);
            if vo == nil then
                vo = self:dealwithRecruitRule(v);
                self.recruitRuleIntroduce[k] = vo;
            end
            self:setRuleList(k, vo.ruleType);
        end
        self:sortRules();
    end
end

-- 根据id获取招募规则具体说明
function Lua_RecruitUtil:getRecruitRuleIntroduceById(id)
    if id == nil or self.recruitRuleIntroduce[id] == nil then
        return;
    end
    return self.recruitRuleIntroduce[id];
end

-- 处理规则
function Lua_RecruitUtil:dealwithRecruitRule(ruleInfo)
    if ruleInfo.reward_btn ~= 1 then
        return { ruleType = ruleInfo.rule_type, hasRewardBtn = false, rule = ruleInfo.rule};
    else
        return { ruleType = ruleInfo.rule_type, hasRewardBtn = true, rewardItem = ruleInfo.item,
                        probability = ruleInfo.probability, sort = ruleInfo.sort, heroList = ruleInfo.hero_list};
    end
end

-- 记录每种规则的id列表
function Lua_RecruitUtil:setRuleList(id, ruleType)
    if self.ruleList == nil then
        self.ruleList = {};
    end

    if self.ruleList[ruleType] == nil then
        self.ruleList[ruleType] = {};
    end
    local count = #self.ruleList[ruleType];
    self.ruleList[ruleType][count + 1] = id;
end

-- 每种规则的id列表中元素排序
function Lua_RecruitUtil:sortRules()
    for k, v in pairs(self.ruleList) do
        table.sort( v, function(a, b)
            return self:getRecruitRuleIntroduceById(a).sort < self:getRecruitRuleIntroduceById(b).sort; end);
    end
end

-- 获取type规则的id列表
function Lua_RecruitUtil:getRuleListByType(type)
    if self.recruitRuleIntroduce == nil then
        self:initRecruitRuleIntroduce();
    end
    return self.ruleList[type];
end

-- 获取全部规则的type
function Lua_RecruitUtil:getAllRuleType()
    if self.recruitRuleIntroduce == nil then
        self:initRecruitRuleIntroduce();
    end
    return self.ruleList;
end









------------------------------ 老客回顾 ------------------------------

function Lua_RecruitUtil:openWishBlessType(bShowTips)-- 开启条件: 1:未开启 2：刚好开启 3：已开启
    local advTypeVo = self:getRecTotVoById(Lua_RecruitData.SENIOR);
    local openNeedNum = self:getWishListConfig("open_times");
    local residueNum = advTypeVo == nil and 1 or openNeedNum - advTypeVo.adv_draw_times;
    if residueNum > 0 then
        if advTypeVo ~= nil and bShowTips then
            OperateAlert.show(LanUtil.formateStr(140339, residueNum));
        end
        return 1;
    elseif residueNum == 0 then
        return 2;
    else 
        return 3
    end
end








------------------------------ 先知召唤 ------------------------------

function Lua_RecruitUtil.Get:type_list() -- 面板要显示的类型列表
    if self.typeList == nil then
        self.typeList = Array()
        local typeConfig = getConfig("scoutType");
        for k, v in pairs(typeConfig) do
            if v.scout_sort~=nil and tonumber(v.scout_sort)>0 then
                local vo = {}
                vo.type = k;
                vo.name = v.name;
                vo.scout_sort = v.scout_sort;
                vo.sprite = v.sprite;
                self.typeList:add(vo)
            end
        end
        self.typeList:sort("scout_sort", false);
    end
    return self.typeList;
end 

function Lua_RecruitUtil.Get:rate_table() -- 面板要显示的类型列表
    if self.rateTable == nil then
        self.rateTable = {};
        local rateConfig = getConfig("scout_rate");

        for k, v in pairs(rateConfig) do
            self.rateTable[k] = self:dealwithRateTabData(v);
            table.sort( self.rateTable[k].rateList, function(a, b)
                local ATvo = Lua_ToolVo.createToolVo(a.itemId);
                local BTvo = Lua_ToolVo.createToolVo(b.itemId);
                return ATvo.sort_weight < BTvo.sort_weight; end );
        end
    end
    return self.rateTable;
end 

function Lua_RecruitUtil:dealwithRateTabData(singleData)
    local obj;
    local vo = { id = singleData.id,  rateList = {} };
    for i = 1, #singleData.rate_list do
        obj = singleData.rate_list[i];
        vo.rateList[i] = { itemId = obj[1], itemCount = obj[2], itemRate = obj[3] };
    end
    return vo;
end














-------------------------小卖部盲盒机兑换------------------------------

function Lua_RecruitUtil:initExchangeItemList()
    if self._exchangeItemList == nil then
        self._exchangeItemList = {}
        self._exchangeIdList = {};

        local camp;
        local count;
        local config = getConfig("recruit_shop");
        for k, v in pairs(config) do
            self._exchangeItemList[k] = self:dealWithExchangeItemData(v);
            self:recordItemId(v.camp, k);
            self:recordItemId(Lua_HeroUtil.All_TYPE, k);
        end

        for k, v in pairs(self._exchangeIdList) do
            self:sortExchangeItemIdList(v);
        end
    end
end

function Lua_RecruitUtil:recordItemId(camp, id)
    if self._exchangeIdList[camp] == nil then
        self._exchangeIdList[camp] = {};
    end 
    local count = #self._exchangeIdList[camp] + 1;
    self._exchangeIdList[camp][count] = id;
end

function Lua_RecruitUtil:sortExchangeItemIdList(list)
    table.sort(list, function(a, b) 
        local AVo = self:getExchangeItemInfoById(a);
        local BVo = self:getExchangeItemInfoById(b);
        return AVo.sort < BVo.sort; end
        );
end

function Lua_RecruitUtil:dealWithExchangeItemData(itemData)
    if itemData == nil then
        return;
    end
    return {id = itemData.id, camp = itemData.camp, sort = itemData.sort, count = itemData.item_amount, costItem = itemData.use_item};
end

function Lua_RecruitUtil:getExchangeItemInfoById(id)
    if id == nil then
        return;
    end
    return self.exchangeItemList[id];
end

function Lua_RecruitUtil.Get:exchangeItemList()
    if self._exchangeItemList == nil then
        self:initExchangeItemList();
    end

    return self._exchangeItemList;
end

function Lua_RecruitUtil.Get:exchangeIdList()
    if self._exchangeItemList == nil then
        self:initExchangeItemList();
    end

    return self._exchangeIdList;
end

function Lua_RecruitUtil:getExchangeIdListByType(type)
    if type == nil then
        return;
    end

    return self.exchangeIdList[type];
end

function Lua_RecruitUtil.Get:scoutDelayTime()
    local time = getConfig("star_recruit", "delay_time", "float_value");
    time = time ~= nil and time >= 0 and time or 2.2;
    return time;  
end











------------------------------动画------------------------------

--老客回顾、心愿单动画
function Lua_RecruitUtil.Get:recruitTweenId()
    if self._recruitTweenId == nil then
        self._recruitTweenId = getConfig("recruit_const", "recruit_tween_id", "value");
    end
    return self._recruitTweenId;
end

--小卖部规则说明动画
function Lua_RecruitUtil.Get:recruitRuleTweenId()
    if self._recruitRuleTweenId == nil then
        self._recruitRuleTweenId = getConfig("recruit_const", "recruit_rule_tween_id", "value");
    end
    return self._recruitRuleTweenId;
end

--小卖部排行榜top3动画idlist
function Lua_RecruitUtil.Get:recruitRankTweenList()
    if self._recruitRankTweenList == nil then
        self._recruitRankTweenList = getConfig("recruit_const", "recruit_rank_tween_list", "jsonvalue");
    end
    return self._recruitRankTweenList;
end

--小卖部排行榜非top3动画id
function Lua_RecruitUtil.Get:recruitRankTweenId()
    if self._recruitRankTweenId == nil then
        self._recruitRankTweenId = getConfig("recruit_const", "recruit_rank_tween_id", "value");
    end
    return self._recruitRankTweenId;
end

function Lua_RecruitUtil.Get:danchouCrumbEffArr()
    if self._danchouCrumbEffArr == nil then
        self._danchouCrumbEffArr = Array();
        local config = getConfig("recruit_tween", "danchou_crumb_effect_list", "arr_value");
        for i = 1, #config do
            self._danchouCrumbEffArr:add(config[i]);
        end
    end
    return self._danchouCrumbEffArr;
end

function Lua_RecruitUtil.Get:duochouCrumbEffArr()
    if self._duochouCrumbEffArr == nil then
        self._duochouCrumbEffArr = Array();
        local config = getConfig("recruit_tween", "duochou_crumb_effect_list", "arr_value");
        for i = 1, #config do
            self._duochouCrumbEffArr:add(config[i]);
        end
    end
    return self._duochouCrumbEffArr;
end

function Lua_RecruitUtil:getCrumbEffCfg(t, num)
    local arr;
    if t == 1 then
        arr = self.danchouCrumbEffArr;
    else
        arr = self.duochouCrumbEffArr;
    end

    local config;
    for i = 1, arr:getSize() do
        config = arr[i];
        if num == config[1] or num < config[1] then
            break;
        end
    end
    return config;
end

function Lua_RecruitUtil:getCrumbEffLimit(t)
    local arr;
    if t == 1 then
        arr = self.danchouCrumbEffArr;
    else
        arr = self.duochouCrumbEffArr;
    end
    local config = arr[arr:getSize()];
    return config[1];
end