checkRequire("Lua_ArtifactData");
checkRequire("Lua_ArtifactUtil");
Lua_ArtifactProxy = class("Lua_ArtifactProxy");
function Lua_ArtifactProxy:ctor()
    DataCenter.artifactData = Lua_ArtifactData.new();
    DataCenter.artifactUtil = Lua_ArtifactUtil.new();

    Lua_MsgUtil.addEventListener("UPDATE_HERO_LINEUP_INFO", self, self.onLineupInfoUpdate)

    Lua_MsgUtil.addLuaMsg(50181001, self, self.rArtifactInfo); -- 请求神器界面(返回)
    Lua_MsgUtil.addLuaMsg(50181003, self, self.rUpgrade); -- 升级神器(返回)
    -- Lua_MsgUtil.addLuaMsg(50181005, self, self.rRefine); -- 精炼神器(返回)
    -- Lua_MsgUtil.addLuaMsg(50181007, self, self.rUpgradeSkill); -- 升级神器技能(返回)
    Lua_MsgUtil.addLuaMsg(50181008, self, self.rClothesInfo); -- 请求神器时装界面(返回)
    -- Lua_MsgUtil.addLuaMsg(50181010, self, self.rSeal); -- 添加神器圣痕印记(返回)
    Lua_MsgUtil.addLuaMsg(50181011, self, self.rTaskReward); -- 请求领取神器任务奖励(返回)
    -- Lua_MsgUtil.addLuaMsg(50181012, self, self.rWearClothes); -- 请求穿上神器幻化时装(返回)
    Lua_MsgUtil.addLuaMsg(50181013, self, self.rRecast); -- 请求神器重铸(返回)
    Lua_MsgUtil.addLuaMsg(50181014, self, self.rActivateClothes); -- 请求道具激活神器幻化(返回)
    Lua_MsgUtil.addLuaMsg(50181018, self, self.rUnStar); -- 请求神器升星(返回)

    Lua_MsgUtil.addLuaMsg(80181015, self, self.updateArtifact);
    Lua_MsgUtil.addLuaMsg(80181016, self, self.updateTask); -- 通知神器幻化任务完成
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
function Lua_ArtifactProxy:onLineupInfoUpdate(lineup_type)
    if lineup_type == Lua_HeroUtil.LINEUP_MAIN_TYPE then
        DataCenter.artifactData:checkLineupRedPoint()
    end
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求神器界面
function Lua_ArtifactProxy:sArtifactInfo()
    sendMsg(10181001);
end

-- 装备神器
function Lua_ArtifactProxy:sWear(id)
    local cmd = ProtoPublic_pb.Proto10181002();
    cmd.id = id;
    sendMsg(10181002, cmd);
end

-- 升级神器
function Lua_ArtifactProxy:sUpgrade(id)
    local cmd = ProtoPublic_pb.Proto10181003();
    cmd.id = id;
    sendMsg(10181003, cmd);
end

-- 精炼神器
-- function Lua_ArtifactProxy:sRefine(id)
--     local cmd = ProtoPublic_pb.Proto10181005();
--     cmd.id = id;
--     sendMsg(10181005, cmd);
-- end

-- 升级神器技能
-- function Lua_ArtifactProxy:sUpgradeSkill(id)
--     local cmd = ProtoPublic_pb.Proto10181007();
--     cmd.id = id;
--     sendMsg(10181007, cmd);
-- end

-- 请求神器时装界面
function Lua_ArtifactProxy:sClothesInfo()
    sendMsg(10181008);
end

-- 添加神器圣痕印记
-- function Lua_ArtifactProxy:sSeal(id, times)
--     local cmd = ProtoPublic_pb.Proto10181010();
--     cmd.id = id;
--     cmd.times = times;
--     sendMsg(10181010, cmd);
-- end

-- 请求领取神器任务奖励
function Lua_ArtifactProxy:sTaskReward(artifact_clothes_id, task_id)
    local cmd = ProtoPublic_pb.Proto10181011();
    cmd.artifact_clothes_id = artifact_clothes_id;
    cmd.task_id = task_id;
    sendMsg(10181011, cmd);
end

-- 请求穿上神器幻化时装
function Lua_ArtifactProxy:sWearClothes(artifact_id, clothes_id)
    local cmd = ProtoPublic_pb.Proto10181012();
    cmd.artifact_id = artifact_id;
    cmd.clothes_id = clothes_id;
    sendMsg(10181012, cmd);
end

-- 请求神器重铸
function Lua_ArtifactProxy:sRecast(artifact_id)
    local cmd = ProtoPublic_pb.Proto10181013();
    cmd.artifact_id = artifact_id;
    sendMsg(10181013, cmd);
end

-- 请求道具激活神器幻化
function Lua_ArtifactProxy:sActivateClothes(clothes_id)
    local cmd = ProtoPublic_pb.Proto10181014();
    cmd.clothes_id = clothes_id;
    sendMsg(10181014, cmd);
end

-- 请求激活神器
function Lua_ArtifactProxy:sUnlock(artifact_id)
    local cmd = ProtoPublic_pb.Proto10181017();
    cmd.artifact_id = artifact_id;
    sendMsg(10181017, cmd);
end

-- 请求神器升星
function Lua_ArtifactProxy:sUnStar(artifact_id)
    local cmd = ProtoPublic_pb.Proto10181018();
    cmd.artifact_id = artifact_id;
    sendMsg(10181018, cmd);
end



------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_ArtifactProxy:rArtifactInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50181001();
        msg:ParseFromString(mp.data);
        DataCenter.artifactData:fromServer50181001(msg);
        Lua_MsgUtil.callFunc("UPDATE_ARTIFACT_INFO");
    end
end

function Lua_ArtifactProxy:rUpgrade(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50181003();
        msg:ParseFromString(mp.data);
        DataCenter.artifactData.last_artifact = msg.artifact.artifact_id;

        local vo = DataCenter.artifactUtil:getArtifactVoById(msg.artifact.artifact_id);
        if vo.level < msg.artifact.artifact_level then
            vo:fromServer(msg.artifact);
            Lua_MsgUtil.callFunc("UPDATE_ARTIFACT_INFO", "hx_sj_02");
        else
            vo:fromServer(msg.artifact);
            Lua_MsgUtil.callFunc("UPDATE_SINGLE_ARTIFACT_INFO", "hx_sj_01");
        end
        DataCenter.artifactData:checkRedPoint();

        -- local str = DataCenter.attributesUtil:getAttrStrByServer(msg.inc_props);
        -- if not strIsNullOrEmpty(str) then
        --     OperateAlert.show(str);
        -- end
    end
end

-- function Lua_ArtifactProxy:rRefine(mp)
--     if mp.errno == 0 then
--         local msg = ProtoPublic_pb.Proto50181005();
--         msg:ParseFromString(mp.data);
--         DataCenter.artifactData:updateSingleArtifact(msg.artifact);
--     end
-- end

-- function Lua_ArtifactProxy:rUpgradeSkill(mp)
--     if mp.errno == 0 then
--         local msg = ProtoPublic_pb.Proto50181007();
--         msg:ParseFromString(mp.data);
--         DataCenter.artifactData:updateSingleArtifact(msg.artifact);
--     end
-- end

function Lua_ArtifactProxy:rClothesInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50181008();
        msg:ParseFromString(mp.data);
        DataCenter.artifactData:fromServer50181008(msg);
        Lua_MsgUtil.callFunc("UPDATE_ARTIFACT_CLOTHES");
    end
end

-- function Lua_ArtifactProxy:rSeal(mp)
--     if mp.errno == 0 then
--         local msg = ProtoPublic_pb.Proto50181010();
--         msg:ParseFromString(mp.data);
--         DataCenter.artifactData:updateSingleArtifact(msg.artifact);

--         OperateAlert.show("刻印成功");
--         local str = DataCenter.attributesUtil:getAttrStrByServer(msg.inc_props);
--         if str ~= "" then
--             OperateAlert.show(str);
--         end
--     end
-- end

function Lua_ArtifactProxy:rTaskReward(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50181011();
        msg:ParseFromString(mp.data);
        DataCenter.artifactData:updateSingleClothes(msg.clothes);
    end
end

-- function Lua_ArtifactProxy:rWearClothes(mp)
--     if mp.errno == 0 then
--         local msg = ProtoPublic_pb.Proto50181012();
--         msg:ParseFromString(mp.data);
--         DataCenter.artifactData:updateSingleClothes(msg.clothes);
--     end
-- end

function Lua_ArtifactProxy:rRecast(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50181013();
        msg:ParseFromString(mp.data);
        DataCenter.artifactData:updateSingleArtifact(msg.artifact);
        DataCenter.artifactData.reset_free_times = msg.free_times;
        DataCenter.artifactData.last_artifact = msg.artifact.artifact_id;
        OperateAlert.showLangValue(350030);
    end
end

function Lua_ArtifactProxy:rActivateClothes(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50181014();
        msg:ParseFromString(mp.data);
        DataCenter.artifactData:updateSingleClothes(msg.clothes);
    end
end

function Lua_ArtifactProxy:rUnStar(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50181018();
        msg:ParseFromString(mp.data);

        local vo = DataCenter.artifactUtil:getArtifactVoById(msg.artifact.artifact_id);
        if vo.star_id < msg.artifact.star_id then
            vo:fromServer(msg.artifact);
            Lua_WindowUtil.openWin("Lua_ArtifactUpStarWindow", Lua_WinParam.ACTION_CLOSE);
            Lua_MsgUtil.callFunc("UPDATE_SINGLE_ARTIFACT_INFO", "hx_sx_01");
        end
        DataCenter.artifactData:checkRedPoint();
    end
end

function Lua_ArtifactProxy:updateArtifact(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80181015();
        msg:ParseFromString(mp.data);
        DataCenter.artifactData:fromServer80181015(msg);
        Lua_MsgUtil.callFunc("UPDATE_ARTIFACT_INFO");
    end
end

function Lua_ArtifactProxy:updateTask(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80181016();
        msg:ParseFromString(mp.data);
        DataCenter.artifactData:fromServer80181016(msg);
    end
end