checkRequire("Lua_RoleUtil");
checkRequire("Lua_RoleData");
checkRequire("Lua_DeviceQuality");
Lua_RoleProxy = class("Lua_RoleProxy");
function Lua_RoleProxy:ctor()
    DataCenter.roleUtil = Lua_RoleUtil.new();
    DataCenter.roleData = Lua_RoleData.new();
    DataCenter.deviceQuality = Lua_DeviceQuality.new();
    
    Lua_MsgUtil.addEventListener("UPDATE_ROLE_LEVEL", self, self.onRoleLevelChange);

    Lua_MsgUtil.addLuaMsg(80111001, self, self.updateRoleAttr); -- 通知玩家属性更新
    Lua_MsgUtil.addLuaMsg(80111003, self, self.updateRoleLevel); -- 主角等级提升

    Lua_MsgUtil.addLuaMsg(50111002, self, self.rOtherRoleInfo); -- 请求其他玩家信息(返回)
    Lua_MsgUtil.addLuaMsg(50111003, self, self.rRoleInfo); -- 请求主角界面(返回)
    Lua_MsgUtil.addLuaMsg(50111004, self, self.rRoleWorldLv); -- 请求获取世界等级(返回)
    Lua_MsgUtil.addLuaMsg(50111006, self, self.rOtherRoleLineup); -- 请求获取世界等级(返回)

    Lua_MsgUtil.addLuaMsg(50180001, self, self.rFateInfo); -- 请求命格界面(返回)

    Lua_MsgUtil.addLuaMsg(50184001, self, self.rAlchemyInfo); -- 炼金工坊界面（返回）
    Lua_MsgUtil.addLuaMsg(50184002, self, self.rAlchemy); -- 请求炼金（返回）

    Lua_MsgUtil.addLuaMsg(50190002, self, self.rRename); -- 请求改名返回
    Lua_MsgUtil.addLuaMsg(50190004, self, self.rFeedback); -- 请求游戏反馈返回
    Lua_MsgUtil.addLuaMsg(50190005, self, self.rGiftCode); -- 请求兑换奖励返回
    Lua_MsgUtil.addLuaMsg(50190006, self, self.rRenameInfo); -- 请求改名信息返回
    
    Lua_MsgUtil.addLuaMsg(80182001, self, self.rOperationRecord); -- 通知个人信息常量记录
    Lua_MsgUtil.addLuaMsg(50182001, self, self.rSetUp); -- 请求游戏设置返回
    Lua_MsgUtil.addLuaMsg(50182003, self, self.rOperate); -- 请求设置客户端每日重置操作返回

    Lua_MsgUtil.addLuaMsg(80111004, self, self.updateDressUpInfo); -- 通知玩家装扮更新
    Lua_MsgUtil.addLuaMsg(50190007, self, self.rDressUpInfo); -- 请求装扮信息返回
    Lua_MsgUtil.addLuaMsg(50190008, self, self.rActivateDressUp); -- 请求激活装扮返回
    Lua_MsgUtil.addLuaMsg(50190009, self, self.rWearDressUp); -- 请求穿戴装扮返回
    Lua_MsgUtil.addLuaMsg(80190010, self, self.updateDressUpRed); -- 通知装扮红点
    Lua_MsgUtil.addLuaMsg(80190012, self, self.updateDressUp); -- 通知装扮红点

    Lua_MsgUtil.addLuaMsg(80113002, self, self.updateBackConfig); -- 通知客户端更新后台配置

    Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateRedPoint);
    Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateRedPoint);
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
function Lua_RoleProxy:updateRedPoint(tab)
    if DataCenter.funcOpenData:isOpened(10210) and tab[Lua_PackDefine.POTENTIAL] ~= nil then
        DataCenter.roleData:checkFateRedPoint();
    end
    if DataCenter.funcOpenData:isOpened(10209) then
        DataCenter.artifactData:checkRedPointByItem(tab);
    end
    if DataCenter.funcOpenData:isOpened(10024) then
        DataCenter.roleData:checkDressUpRedByItem(tab);
    end
end





------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 事件监听
-- 与等级相关 需要重新获取服务端数据
function Lua_RoleProxy:onRoleLevelChange()
    DataCenter.roleData.bInitRoleData = false;
    DataCenter.roleData.bInitFateData = false;
end



------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求其他玩家信息
function Lua_RoleProxy:sOtherRoleId(id, server_flag)
    if DataCenter.roleData:isMyself(id) then
        OperateAlert.showLangValue(123656);
        return;
    end

    local cmd = ProtoPublic_pb.Proto10111002();
    cmd.player_id = tonumber(id);
    if not strIsNullOrEmpty(server_flag) then
        cmd.server_flag = server_flag;
    end
    sendMsg(10111002, cmd);
end

-- 请求主角界面
function Lua_RoleProxy:sRoleInfo()
    sendMsg(10111003);
end

-- 请求获取世界等级
function Lua_RoleProxy:sRoleWorldLv()
    sendMsg(10111004);
end

-- 请求获取世界等级
function Lua_RoleProxy:sSaveArtifact(look_id)
    local cmd = ProtoPublic_pb.Proto10111005();
    cmd.look_id = look_id;
    sendMsg(10111005, cmd);
end

-- 请求命格界面
function Lua_RoleProxy:sFateInfo()
    sendMsg(10180001);
end

-- 命格碎片激活
function Lua_RoleProxy:sFateActivate(destiny_active)
    local cmd = ProtoPublic_pb.Proto10180002();
    cmd.destiny_active = destiny_active; -- 激活命格类型 0 一个潜能 1 剩余整个潜能
    sendMsg(10180002, cmd);
end

-- 炼金工坊界面
function Lua_RoleProxy:sAlchemyInfo()
    sendMsg(10184001);
end

-- 请求炼金
function Lua_RoleProxy:sAlchemy(index)
    local cmd = ProtoPublic_pb.Proto10184002();
    cmd.index = index;
    sendMsg(10184002, cmd);
end

-- 请求投喂鸽子
function Lua_RoleProxy:sPigeonFeeding()
    sendMsg(10184003);
end

-- 客户端操作状态记录 -- key需要小写
function Lua_RoleProxy:sSetUp(tab)
    if tab == nil then
        return;
    end

    local cmd = ProtoPublic_pb.Proto10182001();
    local struct;
    for k,v in pairs(tab) do
        struct = getProtoMsg("ProtoStrInt");
        struct.key = string.lower(k);
        struct.value = v;
        cmd.operator_list:addToList(struct);
    end
    sendMsg(10182001, cmd);
end

function Lua_RoleProxy:sOperate(key, value)
    local cmd = ProtoPublic_pb.Proto10182003();
    cmd.key = string.lower(key);
    cmd.value = value;
    sendMsg(10182003, cmd);
end

-- 请求改名
function Lua_RoleProxy:sRename(name)
    local cmd = ProtoPublic_pb.Proto10190002();
    cmd.name = name;
    sendMsg(10190002, cmd);
end

-- 请求游戏反馈
function Lua_RoleProxy:sFeedback(feedback_type, feedback_content)
    local cmd = ProtoPublic_pb.Proto10190004();
    cmd.feedback_type = feedback_type;
    cmd.feedback_content = feedback_content;
    sendMsg(10190004, cmd);
end

-- 请求兑换奖励
function Lua_RoleProxy:sGiftCode(exchange_code)
    local cmd = ProtoPublic_pb.Proto10190005();
    cmd.exchange_code = exchange_code;
    sendMsg(10190005, cmd);
end

-- 请求改名信息
function Lua_RoleProxy:sRenameInfo()
    sendMsg(10190006);
end

-- 请求装扮信息
function Lua_RoleProxy:sDressUpInfo(dress_type)
    local cmd = ProtoPublic_pb.Proto10190007();
    cmd.dress_type = dress_type;
    sendMsg(10190007, cmd);
end

-- 请求激活装扮
function Lua_RoleProxy:sActivateDressUp(dress_id)
    local cmd = ProtoPublic_pb.Proto10190008();
    cmd.dress_id = tonumber(dress_id);
    sendMsg(10190008, cmd);
end

-- 请求穿戴装扮
function Lua_RoleProxy:sWearDressUp(dress_id)
    local cmd = ProtoPublic_pb.Proto10190009();
    cmd.dress_id = tonumber(dress_id);
    sendMsg(10190009, cmd);
end

-- 请求确认新装扮信息
function Lua_RoleProxy:sConfirmDressUpInfo(dress_id)
    local cmd = ProtoPublic_pb.Proto10190011();
    cmd.dress_id = tonumber(dress_id);
    sendMsg(10190011, cmd);
end

-- 请求角色阵型英雄信息
function Lua_RoleProxy:sOtherRoleLineup(id, server_flag, lineup_type)
    local cmd = ProtoPublic_pb.Proto10111006();
    cmd.id = id;
    cmd.server_flag = server_flag;
    cmd.lineup_type = lineup_type;
    sendMsg(10111006, cmd);
end



------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行

function Lua_RoleProxy:updateRoleInfo(msg, reportType)
    if DataCenter.bConfigLoaded ~= true then
        self.msg80101001 = msg;
        return;
    end

    if msg == nil and self.msg80101001 ~= nil then
        msg = self.msg80101001;
    end
    
    if msg ~= nil then
        DataCenter.roleData:fromServer(msg, reportType);
        DataCenter.mainLineData.checkpointId = msg.stage_id;
        Lua_MsgUtil.callFunc("UPDATE_ROLE_INFO");
    end
    self.msg80101001 = nil;
end

function Lua_RoleProxy:updateRoleAttr(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80111001();
        msg:ParseFromString(mp.data);
        DataCenter.roleData.prop_list = msg.prop_list;
        if DataCenter.bConfigLoaded and tonumber(msg.force) > DataCenter.roleData.force then
            Lua_WindowUtil.openWin("Lua_ForceChangeTipsWindow", Lua_WinParam.ACTION_OPEN, {oldForce = DataCenter.roleData.force, newForce = tonumber(msg.force)});
        end
        DataCenter.roleData.force = tonumber(msg.force);
        DataCenter.roleData.leaderForce = tonumber(msg.role_force);
        DataCenter.gameReported:UpdatePlayerInfo(Lua_SDKMessageType.UpdatePlayerInfo_PlayerUpdate);
        Lua_MsgUtil.callFunc("UPDATE_ROLE_FORCE");
    end
end

function Lua_RoleProxy:updateRoleLevel(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80111003();
        msg:ParseFromString(mp.data);
        DataCenter.roleData.level = msg.level;
        DataCenter.gameReported:UpdatePlayerInfo(Lua_SDKMessageType.UpdatePlayerInfo_PlayerUpdate);
        Lua_WindowUtil.openWin("Lua_RoleLevelUpWindow", Lua_WinParam.ACTION_OPEN, msg);
    end
end

function Lua_RoleProxy:rOtherRoleInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50111002();
        msg:ParseFromString(mp.data);
        Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_OPEN, msg);
    end
end

function Lua_RoleProxy:rRoleInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50111003();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer50111003(msg);
        Lua_MsgUtil.callFunc("UPDATE_ROLE_INFO");
    end
end

function Lua_RoleProxy:rRoleWorldLv(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50111004();
        msg:ParseFromString(mp.data);
        DataCenter.roleData.worldLv = msg.world_level;
        Lua_MsgUtil.callFunc("UPDATE_ROLE_WORLD_LEVEL");
    end
end

function Lua_RoleProxy:rFateInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50180001();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer50180001(msg);
        Lua_MsgUtil.callFunc("UPDATE_FATE_INFO");
    end
end

function Lua_RoleProxy:rAlchemyInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50184001();
        msg:ParseFromString(mp.data);
        local config
        local state = false
        for i = 1, #msg.alchemy_list do
            config = getConfig("alchemy", msg.alchemy_list[i].index)
            if config.free == 1 and msg.alchemy_list[i].left_times > 0 then
                state = true
            end
        end
        DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Alchemy, state)
        Lua_MsgUtil.callFunc("UPDATE_ALCHEMY_INFO", msg);
    end
end

function Lua_RoleProxy:rAlchemy(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50184002();
        msg:ParseFromString(mp.data);
        local config = getConfig("alchemy", msg.alchemy_info.index)
        if config.free == 1 then
            DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Alchemy, msg.alchemy_info.left_times > 0)
        end
        Lua_MsgUtil.callFunc("UPDATE_SINGLE_ALCHEMY_INFO", msg);
    end
end

function Lua_RoleProxy:rRename(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50190002();
        msg:ParseFromString(mp.data);
        if msg.ret == 1 then
            OperateAlert.showLangValue(300024);
            Lua_WindowUtil.openWin("Lua_RenameWindow", Lua_WinParam.ACTION_CLOSE);
            DataCenter.roleData.name = msg.name;
            DataCenter.gameReported:UpdatePlayerInfo(Lua_SDKMessageType.UpdatePlayerInfo_PlayerUpdate);
            Lua_MsgUtil.callFunc("UPDATE_ROLE_INFO");
        elseif msg.ret == 2 then
            OperateAlert.showLangValue(300025);
        end
    end
end

function Lua_RoleProxy:rFeedback(mp)
    if mp.errno == 0 then
        OperateAlert.showLangValue(300010);
        Lua_WindowUtil.openWin("Lua_FeedbackWindow", Lua_WinParam.ACTION_CLOSE);
    end
end

function Lua_RoleProxy:rGiftCode(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50190005();
        msg:ParseFromString(mp.data);
        if msg.ret == 1 then
            OperateAlert.showLangValue(300014);
        elseif msg.ret == 2 then
            OperateAlert.showLangValue(300015);
        elseif msg.ret == 3 then
            OperateAlert.showLangValue(300016);
        end
        Lua_WindowUtil.openWin("Lua_GiftCodeWindow", Lua_WinParam.ACTION_CLOSE);
    end
end

function Lua_RoleProxy:rRenameInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50190006();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("UPDATE_RENAME_INFO", msg);
    end
end

function Lua_RoleProxy:rOperationRecord(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80182001();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer80182001(msg);
        Lua_MsgUtil.callFunc("UPDATE_OPERATION_RECORD");
    end
end

function Lua_RoleProxy:rSetUp(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50182001();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer50182001(msg);
    end
end

function Lua_RoleProxy:rOperate(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50182003();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer50182003(msg);
        Lua_MsgUtil.callFunc("UPDATE_OPERATION_RECORD");
    end
end

function Lua_RoleProxy:updateDressUpInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80111004();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer80111004(msg);
        Lua_MsgUtil.callFunc("UPDATE_DRESSUP_INFO");
    end
end

function Lua_RoleProxy:rDressUpInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50190007();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer50190007(msg);
        Lua_MsgUtil.callFunc("UPDATE_DRESSUP_INFO");
    end
end

function Lua_RoleProxy:rActivateDressUp(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50190008();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer50190008(msg);
        Lua_MsgUtil.callFunc("UPDATE_DRESSUP_INFO");
    end
end

function Lua_RoleProxy:rWearDressUp(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50190009();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer50190009(msg);
        Lua_MsgUtil.callFunc("UPDATE_DRESSUP_INFO");
        OperateAlert.showLangValue(301016);
    end
end

function Lua_RoleProxy:updateDressUpRed(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80190010();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer80190010(msg);
    end
end

function Lua_RoleProxy:updateDressUp(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80190012();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer50190009(msg);
    end
end

function Lua_RoleProxy:updateBackConfig(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80113002();
        msg:ParseFromString(mp.data);
        DataCenter.roleData:fromServer80113002(msg);
    end
end

function Lua_RoleProxy:rOtherRoleLineup(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50111006();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("UPDATE_OTHER_ROLE_LINEUP", msg);
    end
end