Lua_ArtifactClothesVo = class("Lua_ArtifactClothesVo")
function Lua_ArtifactClothesVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if config == nil then
		self.config = getConfig("artifact_clothes", id);
	end
end

function Lua_ArtifactClothesVo:fromServer(data)
	if data == nil or data.cloth_id ~= self.id then
		return;
	end
	self._is_activate = data.is_activate; -- 是否激活（0：未激活，1：已激活）
	self._artifact_id = data.state; -- 装备状态 （0：未装备， 装备的神器id）
	self._progress = data.progress;
	self.task_list = data.task_list; -- 激活任务列表

	self.taskDic = nil;
	for i = 1, #data.task_list do
		self:setTaskState(data.task_list[i].task_id, data.task_list[i].state);
	end
end

function Lua_ArtifactClothesVo.Get:is_activate()
	return self._is_activate == nil and 0 or self._is_activate;
end

function Lua_ArtifactClothesVo.Get:artifact_id()
	return self._artifact_id == nil and 0 or self._artifact_id;
end

function Lua_ArtifactClothesVo.Get:progress()
	return self._progress == nil and 0 or self._progress;
end

function Lua_ArtifactClothesVo.Get:max_progress()
	return self.task_list == nil and 0 or #self.task_list;
end

function Lua_ArtifactClothesVo:setTaskState(id, state)
	if self.taskDic == nil then
		self.taskDic = {};
	end
	self.taskDic[id] = state;
end

function Lua_ArtifactClothesVo:getTaskState(id)
	if self.taskDic == nil then
		return 0;
	end
	return self.taskDic[id];
end

function Lua_ArtifactClothesVo.Get:canUnlock()
	if self.is_activate == 0 and self.type == 1 then
		local haveCount;
		for i = 1, #self.cost do
			haveCount = DataCenter.packData:getItemCountById(self.cost[i][1]);
			if haveCount < self.cost[i][2] then
				return false;
			end
		end
		return true;
	end
	return false;
end

function Lua_ArtifactClothesVo:getCheckId()
	if self.is_activate == 0 and self.type == 1 then
		local haveCount;
		for i = 1, #self.cost do
			haveCount = DataCenter.packData:getItemCountById(self.cost[i][1]);
			if haveCount < self.cost[i][2] then
				return self.cost[i][1], self.cost[i][2];
			end
		end
	end
	return nil, nil;
end

function Lua_ArtifactClothesVo.Get:canReceive()
	if self.is_activate == 0 and self.type == 2 and self.task_list ~= nil then
		for i = 1, #self.task_list do
			if self.task_list[i].state == 1 then
				return true;
			end
		end
	end
	return false;
end

function Lua_ArtifactClothesVo.Get:canWear()
	if self.is_activate == 1 and self.artifact_id == 0 then

	end
	return false;
end

-------------------- 配置数据 --------------------

function Lua_ArtifactClothesVo.Get:name()
	return self.config.name;
end

function Lua_ArtifactClothesVo.Get:type()
	return self.config.type;
end

function Lua_ArtifactClothesVo.Get:cost()
	return self.config.cost;
end

function Lua_ArtifactClothesVo.Get:skill()
	return self.config.skill;
end

function Lua_ArtifactClothesVo.Get:prop_rate()
	return self.config.prop_rate;
end

function Lua_ArtifactClothesVo.Get:obtain_str()
	return self.config.obtain_str;
end

function Lua_ArtifactClothesVo.Get:prompt_str()
	return self.config.prompt_str;
end

function Lua_ArtifactClothesVo.Get:icon_name()
	return self.config.icon_name;
end