checkRequire("Lua_ArtifactVo");
checkRequire("Lua_ArtifactClothesVo");
Lua_ArtifactUtil = class("Lua_ArtifactUtil");
function Lua_ArtifactUtil:ctor()
	self:superCall("ctor");
end

function Lua_ArtifactUtil:dispose()
	self.artifactDic = nil
	self.clothesDic = nil
end

function Lua_ArtifactUtil.Get:lvl_progress_rate()
	return getConfig("artifact_const", "lvl_progress_rate", "value" ) or 1
end

function Lua_ArtifactUtil.Get:reset_cost()
	return getConfig("artifact_const", "reset_cost", "arr_value" )
end

function Lua_ArtifactUtil.Get:unlock_level()
	return getConfig("artifact_const", "unlock_level", "arr_value" )
end

function Lua_ArtifactUtil.Get:artifact_show_prop()
	return getConfig("artifact_const", "artifact_show_prop", "arr_value" )
end

function Lua_ArtifactUtil.Get:line_sound_list()
	return getConfig("artifact_const", "line_sound_list", "arr_value" )
end

function Lua_ArtifactUtil.Get:play_line_interval()
	return getConfig("artifact_const", "play_line_interval", "value" ) or 0
end

function Lua_ArtifactUtil.Get:look_id()
	return getConfig("artifact_const", "look_id", "value" ) or 999
end

function Lua_ArtifactUtil:getArtifactVoById(id)
	if self.artifactDic == nil then
		self.artifactDic = {}
	end
	if self.artifactDic[id] == nil then
		local config = getConfig("artifact", id)
		if config == nil then
			return nil
		end
		self.artifactDic[id] = Lua_ArtifactVo.new(id, config)
	end
	return self.artifactDic[id]
end

function Lua_ArtifactUtil:getRaccoonList()
	if self.roleArtifactList == nil then
		self.roleArtifactList = Array()
		local config = getConfig("artifact")
		for k, _ in pairs(config) do
			self.roleArtifactList:add(k)
		end
		self.roleArtifactList:sortf(self, self.onArtifactSort)
	end
	return self.roleArtifactList
end

function Lua_ArtifactUtil:onArtifactSort(a, b)
	a = self:getArtifactVoById(a)
	b = self:getArtifactVoById(b)
	if a.sort > b.sort then
		return false
	end
	return true
end

function Lua_ArtifactUtil:getArtifactList()
	if self.artifactList == nil then
		self.artifactList = Array()
		local config = getConfig("artifact")
		for k, v in pairs(config) do
			if v.is_shield ~= 1 then
				self.artifactList:add(k)
			end
		end
		self.artifactList:sortf(self, self.onArtifactSort)
	end
	return self.artifactList
end

function Lua_ArtifactUtil:getTalentListById(id)
	if self.talentDic == nil then
		self.talentDic = {}
		local config = getConfig("artifact_talent")
		for _, v in pairs(config) do
			if self.talentDic[v.artifact] == nil then
				self.talentDic[v.artifact] = Array()
			end
			self.talentDic[v.artifact]:add(v)
		end
		for _, v in pairs(self.talentDic) do
			v:sort("level", false)
		end
	end
	return self.talentDic[id]
end

function Lua_ArtifactUtil:getLevelConfig(id)
	return getConfig("artifact_level", id);
end

function Lua_ArtifactUtil:getStarConfig(id)
	return getConfig("artifact_star", id);
end

function Lua_ArtifactUtil:getTalentConfig(id)
	return getConfig("artifact_talent", id);
end

function Lua_ArtifactUtil:checkEmbattleLatticeIsUnlock(index)
	if self.unlock_level == nil or self.unlock_level[index] == nil then
		return true
	end
	return self.unlock_level[index] <= DataCenter.roleData.level
end











function Lua_ArtifactUtil:getClothesVoById(id, config)
	if self.clothesDic == nil then
		self.clothesDic = {};
	end
	if self.clothesDic[id] == nil then
		self.clothesDic[id] = Lua_ArtifactClothesVo.new(id, config);
	end
	return self.clothesDic[id];
end

function Lua_ArtifactUtil:getArtifactClothesList()
	if self.clothesList == nil then
		self.clothesList = Array()
		local config = getConfig("artifact_clothes")
		for k, _ in pairs(config) do
			self.clothesList:add(k)
		end
		self.clothesList:sortf(self, self.onClothesSort)
	end
	return self.clothesList
end

function Lua_ArtifactUtil:onClothesSort(a, b)
	if a > b then
		return false;
	end
	return true;
end

function Lua_ArtifactUtil:getTaskConfigById(id)
	return getConfig("total_task", id);
end





--------------------------------------------------
--------------------------------------------------
-------------------------------------------------- 外部接口
-- 默认神器
function Lua_ArtifactUtil:getDefaultArtifact()
	return self:getArtifactVoById(999)
end

-- 当前神器
function Lua_ArtifactUtil:getCurArtifact()
	local id = DataCenter.artifactData.last_artifact
	if id > 0 then
		return id
	end
	return self:getArtifactList()[1]
end