checkRequire("Lua_RoleLevelVo");
checkRequire("Lua_RoleFateVo");
checkRequire("Lua_DressUpVo");
Lua_RoleUtil = class("Lua_RoleUtil");
function Lua_RoleUtil:ctor()
	self:superCall("ctor");
end

function Lua_RoleUtil:dispose()
	self.fateDic = nil;
	self.dressUpDic = nil;
end

function Lua_RoleUtil.Get:destiny_show_count()
	return getConfig("role_const", "destiny_show_count", "value");
end

------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
function Lua_RoleUtil:getRoleVoByLv(id)
	if self.roleLvDic == nil then
		self.roleLvDic = {};
	end
	if self.roleLvDic[id] == nil then
		self.roleLvDic[id] = Lua_RoleLevelVo.new(id);
	end
	return self.roleLvDic[id];
end

function Lua_RoleUtil:getAttrArr(dic, attrType, arr)
	local data;
	local attrVo;
	for k,v in pairs(dic) do
		attrVo = DataCenter.attributesUtil:createAttrVo(k);
		data = {};
		data.attrType = attrType;
		data.name = attrVo.show_name;
		data.value = (attrVo.isPercent == 1) and (v * 100).."%" or v;
		data.icon = attrVo.hero_attr_icon;
		data.sortNum = attrType * 100 + attrVo.sort;
		arr:add(data);
	end
end

function Lua_RoleUtil:getAttrArr2(prev_dic, cur_dic, attrType, arr)
	local data;
	local attrVo;
	for k,v in pairs(prev_dic) do
		if cur_dic[k] ~= nil then
			attrVo = DataCenter.attributesUtil:createAttrVo(k);
			data = {};
			data.attrType = attrType;
			data.name = attrVo.show_name;
			data.value = (attrVo.isPercent == 1) and (v * 100).."%" or v;
			data.icon = attrVo.hero_attr_icon;
			data.nextValue = (attrVo.isPercent == 1) and (cur_dic[k] * 100).."%" or cur_dic[k];
			data.sortNum = attrType * 100 + attrVo.sort;
			arr:add(data);
		end
	end
end

function Lua_RoleUtil:getAttrArr3(dic, attrType, arr)
	local data;
	for k, attrVo in pairs(dic) do
		data = {};
		data.attrType = attrType;
		data.name = attrVo.show_name;
		data.value = attrVo.showValue;
		data.icon = attrVo.hero_attr_icon;
		data.sortNum = attrType * 100 + attrVo.sort;
		arr:add(data);
	end
end

------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 命格

function Lua_RoleUtil:getFateVoById(id)
	if self.fateDic == nil then
		self.fateDic = {};
	end
	if self.fateDic[id] == nil then
		local config = getConfig("destiny", id);
		if config == nil then
			return nil;
		end
		self.fateDic[id] = Lua_RoleFateVo.new(id, config);
	end
	return self.fateDic[id];
end

function Lua_RoleUtil:initFate()
	if self.fateArr == nil then
		self.fateArr = Array();
		local config = getConfig("destiny");
		for k,v in pairs(config) do
			self.fateArr:add(k);
		end
	end
end

function Lua_RoleUtil:getFateArr(faceId)
	self:initFate();
	local arr = Array();
	faceId = faceId + self.destiny_show_count;
	local id;
	for i = 1, self.fateArr:getSize() do
		id = self.fateArr[i];
		if id > faceId then
			break;
		end
		arr:add(id);
	end
	return arr;
end

function Lua_RoleUtil:getFitstFateId()
	self:initFate();
	return self.fateArr[1];
end

function Lua_RoleUtil:getFateChipConfig(chipId)
	if chipId == nil then
		return nil;
	end
	return getConfig("destiny_level", chipId);
end

function Lua_RoleUtil:checkFateChipIsActivate(id, index)
	local vo = self:getFateVoById(id);
	if vo ~= nil and vo.level >= index then
		return true;
	end
	return false;
end

function Lua_RoleUtil:getFateAttr(vo, roleAttrDic, heroAttrDic)
	local configData;
	-- if vo.is_activate == 1 then
		local bActivate;
		for i = 1, #vo.chips do
			configData = self:getFateChipConfig(vo.chips[i]);
			bActivate = self:checkFateChipIsActivate(vo.id, configData.index);
			if bActivate then
				DataCenter.attributesUtil:getAttrDic(configData.leader, roleAttrDic);
				DataCenter.attributesUtil:getAttrDic(configData.hero, heroAttrDic);
			end
		end
	-- end
end

------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 个人信息

function Lua_RoleUtil.Get:feedback_content_limit()
	return getConfig("personal_data_const", "feedback_content_limit", "value") or 200
end

function Lua_RoleUtil.Get:rename_interval()
	return getConfig("personal_data_const", "rename_interval", "value") or 24
end

function Lua_RoleUtil.Get:rename_free_times()
	return getConfig("personal_data_const", "rename_free_times", "value") or 1
end

function Lua_RoleUtil.Get:rename_consume()
	return getConfig("personal_data_const", "rename_consume", "json_value") or {}
end

function Lua_RoleUtil:getDressUpVoById(id, config)
	if id == nil or id <= 0 then
		return nil;
	end
	
	if self.dressUpDic == nil then
		self.dressUpDic = {};
	end
	if self.dressUpDic[id] == nil then
		if config == nil then
			config = getConfig("dress", id);
			if config == nil then
				return nil;
			end
		end
		local vo = Lua_DressUpVo.new(id, config);
		if vo.is_active == 0 and vo.active_item then
			DataCenter.roleData:setDressCheckItem(vo.active_item[1], id);
		end
		self.dressUpDic[id] = vo
	end
	return self.dressUpDic[id];
end

function Lua_RoleUtil:getDressUpArr(mainType)
	local config = getConfig("dress");
	local openState, openDay;
	local arr = Array()
	for k,v in pairs(config) do
		-- 达到开服天数限制才显示
		openState, openDay = true, 0;
		if v.active_hero_id then
			openState, openDay = DataCenter.heroUtil:getNewHeroFuncOpenState(v.active_hero_id, Lua_NewHeroFuncOpen.dress);
		end

		if v.is_shield ~= 1
			and v.main_type == mainType
			and (v.sex == 0 or v.sex == nil or v.sex == DataCenter.roleData.sex)
			and openState then
				arr:add(k);
		end
	end
	-- quickSortf(arr, self, self.onDressUpSort)
	arr:sortf(self, self.onDressUpSort)
	return arr;
end

function Lua_RoleUtil:onDressUpSort(a, b)
	a = self:getDressUpVoById(a)
	b = self:getDressUpVoById(b)
	if a.sortWeights > b.sortWeights then
		return false
	end
	return true
end