Lua_ConstructData = class("Lua_ConstructData");
function Lua_ConstructData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ConstructData:dispose()

end

function Lua_ConstructData:buildStructure(sceneId)
	local arr = DataCenter.constructUtil:getStructureArr(sceneId);
	if arr == nil then
		return;
	end

	local vo;
	for i = 1, arr:getSize() do
		vo = DataCenter.constructUtil:getStructureVo(arr[i]);
		if vo.canBuild then
			self:buildSingleStructure(vo);
		end
	end
end

function Lua_ConstructData:buildSingleStructure(vo)
	local structureData = self:getStructureData(vo);
	local tp = ThingUtil.instance:getThingById(vo.sceneId, 0, vo.id);
	if tp == nil then
		ThingUtil.instance:addConstruction(structureData, vo.bGray);
	else
		tp.data = structureData;
		tp:setGray(vo.bGray);
	end
	structureData = nil;
end

function Lua_ConstructData:getStructureData(vo)
	local structureData = StructureData();
	structureData.ownerId = DataCenter.roleData.roleId;
	structureData.roleId = vo.id; --服务端分配唯一Id
	structureData.objId = vo.id; --配置Id
	structureData.kind = Lua_ThingDefine.STRUCTURE;
	structureData.IsUI = false;
	structureData.mustShow = true;
	structureData.isShowName = false;
	structureData.canBeClick = true;
	structureData.buildState = 1;
	structureData.showState = 1;
	structureData.clothesId = 0;
	structureData.hangerEffId = vo.hangerEffId;
	structureData.sceneId = vo.sceneId;
	structureData.px = vo.scenePosTab[1];
	structureData.py = vo.scenePosTab[2];
	structureData.pz = vo.scenePosTab[3];
	structureData.dir = vo.dir;
	return structureData;
end