Lua_SceneData = class("Lua_SceneData");
function Lua_SceneData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_SceneData:dispose()
	self.bFirstEnter = true;
	self.curSceneId = 0;
	self.openSceneId = 0;
	self.lastcurSceneId = 0;
	self.curSceneData = nil;
	self.curSceneShowStep = 0;
	self:clearSceneShowTimer();
	self.bFirstSceneLoad = true;
end

function Lua_SceneData:showScene(sId)
	self.lastcurSceneId = self.curSceneId;--记录上次打开的场景id
	local lastHideWinType = nil;
	local sceneData = Lua_SceneConfigData.getSceneConfig(self.curSceneId);
	if sceneData ~= nil then
		lastHideWinType = sceneData.hideWinType;
	end

	-- 控制当前场景界面逻辑
	self.curSceneId = sId;
	self.curSceneShowStep = 0;
	sceneData = Lua_SceneConfigData.getSceneConfig(sId);
	if sceneData ~= nil then
		self.curSceneData = sceneData;
		Lua_MsgUtil.callFunc("UPDATE_MAIN_MENU", sceneData.menuItem);
		self:addSceneShowTimer();
		if lastHideWinType ~= nil and lastHideWinType == 1 and sceneData.hideWinType ~= 1 then
			-- WindowMananger.getInstance():showOrHideBackStageByWinName(true);  
		end
	else
		self.curSceneData = nil;
		self:clearSceneShowTimer();
		Lua_MsgUtil.callFunc("SCENE_SHOW", self.curSceneId);
	end

	-- 第一次进场景强制执行一次GC
	if DataCenter.bConfigLoaded and self.bFirstEnter == true then
		self.bFirstEnter = false;
		LanUtil.systemGcCollect();
		LanUtil.luaGcCollect();
	end
end

function Lua_SceneData:addSceneShowTimer()
	if self._bAddSceneShowTimer ~= true then
		self._bAddSceneShowTimer = true;
		Lua_CommonUtil.addTimer("onSceneShowTimer", 0.02, self, self.onSceneShowTimer, nil, -1);
	end
end

function Lua_SceneData:clearSceneShowTimer()
	if self._bAddSceneShowTimer == true then
		self._bAddSceneShowTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onSceneShowTimer);
	end
end

function Lua_SceneData:onSceneShowTimer()
	if self.curSceneData ~= nil then
		self.curSceneShowStep = self.curSceneShowStep + 1;
		if self.curSceneShowStep == 1 then-- 关闭界面
			local list = self.curSceneData.closeWins;
			if list ~= nil and #list > 0 then
				for i = 1, #list do
					Lua_WindowUtil.openWin(list[i], Lua_WinParam.ACTION_CLOSE);
				end
				return;
			end

			-- 无打开的则继续下一个节点
			self.curSceneShowStep = self.curSceneShowStep + 1;
		end

		if self.curSceneShowStep == 2 then
			if WindowMananger.getInstance():closeWinsExceptBySceneId(self.curSceneId) == true then
				return;
			end

			-- 无打开的则继续下一个节点
			self.curSceneShowStep = self.curSceneShowStep + 1; 
		end

		if self.curSceneShowStep == 3 then-- 针对已打开界面操作
			if self.curSceneData.hideWinType == 1 then
				-- WindowMananger.getInstance():showOrHideBackStageByWinName(false);
				return;
			end

		-- 无打开的则继续下一个节点
			self.curSceneShowStep = self.curSceneShowStep + 1; 
		end

		if self.curSceneShowStep == 4 then
			local list = self.curSceneData.openWins;-- 打开界面
			if list ~= nil and #list > 0 then
				for i = 1, #list do
					Lua_WindowUtil.openWin(list[i], Lua_WinParam.ACTION_OPEN);
				end
			return;
		end

			-- 无打开的则继续下一个节点
			self.curSceneShowStep = self.curSceneShowStep + 1;   
		end
	end

	-- 上面全部流程初始化完成
	self.curSceneData = nil;
	self.curSceneShowStep = 0;
	self:clearSceneShowTimer();
	Lua_MsgUtil.callFunc("SCENE_SHOW", self.curSceneId);
end

function Lua_SceneData:onSceneLoaded()
	if GlobalVar.isInGame == 1 and self.bFirstSceneLoad == true then
		self.bFirstSceneLoad = false;
		local t = SDKInfo.isWifi() and 30 or 180;
		Lua_CommonUtil.delayCall(t, self, self.onStartUpdateBackgroundRes, nil);
		Lua_WindowUtil.openWin("LoadingScreenWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

-- 后台下载开始
function Lua_SceneData:onStartUpdateBackgroundRes()
	--进入游戏后，检查是否需要在后台下载后续资源
	UpdateResManager.getInstance():initDefaultState();
end