-- 行为
Lua_SceneOrnamentBehaviorVo = class("Lua_SceneOrnamentBehaviorVo");
function Lua_SceneOrnamentBehaviorVo:ctor(bid, intervalTime, time, rate)
	self:superCall("ctor");

	self.behaviorIntervalTimeConst = 0;
	self.behaviorTimeConst = 0;
	self.behaviorRateConst = 100;
	self._behaviorIntervalTime = 0;
	self._behaviorTime = 0;
	self.ornamentSceneId = 0;
	self.ornamentRoleId = 0;
	self.sceneModelName = nil;
	self.behaviorAsBorn = false;
	self._operatingActTime = 0;
	self._operatingHideTime = 0;
	self.canOperateBehavior = false;
	self._startActTime = 0;
	self._startClickActTime = 0;
	self.clickContinueTime = 0;
	self.startShowBubbleTime = 0;
	self.bubbleShowTime = 0;
	self:setBehaviorId(bid, intervalTime, time, rate);
end

function Lua_SceneOrnamentBehaviorVo:dispose()
	if self.ornamentRoleId ~= nil and self.ornamentRoleId > 0 then
		Lua_MsgUtil.callFunc("SceneOrnament_Bubble_Hide", self.ornamentRoleId);
	end
	self.config = nil;
	self.qipaoCfg = nil;
end

function Lua_SceneOrnamentBehaviorVo:clean()
	if self.ornamentRoleId ~= nil and self.ornamentRoleId > 0 then
		Lua_MsgUtil.callFunc("SceneOrnament_Bubble_Hide", self.ornamentRoleId);
	end
	self.config = nil;
	self.qipaoCfg = nil;
	self._behaviorId = 0;
	self._behaviorIntervalTime = 0;
	self._behaviorTime = 0;
	self.canOperateBehavior = false;
	self.behaviorIntervalTimeConst = 0;
	self.behaviorTimeConst = 0;
	self.behaviorRateConst = 100;
	self.ornamentSceneId = 0;
	self.ornamentRoleId = 0;
	self.sceneModelName = nil;
	self.behaviorAsBorn = false;
	self._operatingActTime = 0;
	self._operatingHideTime = 0;
	self._bOperatingClickAct = false;
	self._bOperatingAct = false;
	self._bOperatingMove = false;
	self._bOperatingHide = false;
	self._startActTime = 0;
	self._startClickActTime = 0;
	self.clickContinueTime = 0;
	self.startShowBubbleTime = 0;
	self.bubbleShowTime = 0;
end

function Lua_SceneOrnamentBehaviorVo:setBehaviorId(bid, intervalTime, time, rate)
	self.behaviorIntervalTimeConst = intervalTime ~= nil and intervalTime or 0;
	self.behaviorTimeConst = time ~= nil and time or 0;
	self.behaviorRateConst = rate;
	self.behaviorId = bid;
end

function Lua_SceneOrnamentBehaviorVo:setOrnament(sid, rid, sceneModelName, behaviorAsBorn)
	self.ornamentSceneId = sid;
	self.ornamentRoleId = rid;
	self.sceneModelName = sceneModelName;
	self.behaviorAsBorn = behaviorAsBorn;
end

function Lua_SceneOrnamentBehaviorVo.Get:id()
	return self._behaviorId;
end

function Lua_SceneOrnamentBehaviorVo.Get:behaviorId()
	return self._behaviorId;
end

function Lua_SceneOrnamentBehaviorVo.Set:behaviorId(val)
	if self._behaviorId ~= val then
		self._operatingActTime = 0;
		self._operatingHideTime = 0;
		self._bOperatingAct = false;
		self._bOperatingMove = false;
		self._bOperatingHide = false;
		self.config = DataCenter.sceneUtil:getOrnamentBehaviorById(val);
		-- print("Set behaviorId", val, getTraceback());
		if self.config == nil then -- 完成
			self._behaviorId = 0;
			self.canOperateBehavior = false;
			self._behaviorTime = self.behaviorTimeConst;
		else
			self._behaviorId = val;
		end
	end
end

function Lua_SceneOrnamentBehaviorVo.Get:bOperating()
	return self._bOperatingAct or self._bOperatingMove or self._bOperatingHide or self._bOperatingClickAct;
end

function Lua_SceneOrnamentBehaviorVo.Get:hasBehavior()
	return self.config ~= nil;
end

function Lua_SceneOrnamentBehaviorVo.Get:isComplete()
	return self.config == nil and self._behaviorTime <= 0 and self._behaviorIntervalTime <= 0;
end

function Lua_SceneOrnamentBehaviorVo.Get:bCooling()
	return self._behaviorTime > 0;
end

function Lua_SceneOrnamentBehaviorVo.Get:canBehavior()
	return self._behaviorIntervalTime <= 0;
end

function Lua_SceneOrnamentBehaviorVo.Get:bubbleTime()
	if self.startShowBubbleTime > 0 then
		local t = getTime() - self.startShowBubbleTime;
		t = self.bubbleShowTime - t;
		if t <= 0 then
			return 0;
		end
		return t; 
	end
	return 0;
end

function Lua_SceneOrnamentBehaviorVo:frameScript(dt)
	if self._behaviorIntervalTime > 0 then
		self._behaviorIntervalTime = self._behaviorIntervalTime - dt;
	end
	if self._behaviorTime > 0 then
		self._behaviorTime = self._behaviorTime - dt;
	end

	-- 点击暂停时间
	if self.clickContinueTime > 0 then
		if self._startActTime > 0 then -- 矫正动作起始时间
			self._startActTime = self._startActTime + dt;
		end
		self.clickContinueTime = self.clickContinueTime - dt;
		if self.clickContinueTime <= 0 then
			self:completeClickOperate();
		end
		return;
	end

	if self._operatingActTime > 0 then
		self._operatingActTime = self._operatingActTime - dt;
		if self._operatingActTime <= 0 then
			self:completeAction();
		end
	end

	if self._operatingHideTime > 0 then
		self._operatingHideTime = self._operatingHideTime - dt;
		if self._operatingHideTime <= 0 then
			self:completeHideState();
		end
	end

	-- 执行行为
	self:operateBehavior();
end

function Lua_SceneOrnamentBehaviorVo:randomOperateBehavior()
	if self.canOperateBehavior then
		return true;
	end

	if self._behaviorTime > 0 or self._behaviorIntervalTime > 0 then -- 不可行动
		-- print("不可行动", self.behaviorId, self._behaviorTime, self._behaviorIntervalTime)
		self.canOperateBehavior = false;
		return false;
	end

	if self.behaviorRateConst == 0 or Mathf.Random(0, 100) > self.behaviorRateConst then
		-- print("generate 概率不足", self.behaviorId, self.ornamentRoleId);
		self._behaviorIntervalTime = self.behaviorIntervalTimeConst;
		self.canOperateBehavior = false;
		return false;
	end

	-- print("可执行行为", self.behaviorId, self.ornamentRoleId);
	self.canOperateBehavior = true;
	return true;
end

-- 执行该步骤
function Lua_SceneOrnamentBehaviorVo:operateBehavior()
	-- print("operateBehavior", self.behaviorId, self.sceneModelName, self.canOperateBehavior, self._bOperatingAct, self._bOperatingMove, self._bOperatingHide, self._behaviorTime, self._behaviorIntervalTime);
	if not self.canOperateBehavior then
		return false;
	end

	if self._bOperatingAct or self._bOperatingMove or self._bOperatingHide or self._bOperatingClickAct then -- 行动中
		-- print(self.behaviorId, "行动中", self._bOperatingAct, self._bOperatingMove, self._bOperatingHide)
		return false;
	end

	if self.config == nil then -- 完成
		-- print("完成", self._behaviorTime, self._behaviorIntervalTime);
		return false;
	end

	if not self.canBehavior then
		return;
	end

	if self.ornamentRoleId <= 0 or self.ornamentSceneId <= 0 then
		-- print("ornamentSceneId ", self.ornamentRoleId, self.ornamentSceneId)
		return false;
	end

	local thing = nil;
	if strIsNullOrEmpty(self.sceneModelName) then -- 非场景对象
		thing = DataCenter.thingData:getThingPlayer(self.ornamentSceneId, 0, self.ornamentRoleId);
		if thing == nil then
			return false;
		end
	end

	-- 动作
	local act = self.config.action;
	-- print("动作", self.sceneModelName, act);
	if act ~= nil then
		if thing ~= nil then
			if thing.player ~= nil then
				self._bOperatingAct = true;
				local nextAct = self.config.nextAction ~= nil and self.config.nextAction or 0;
				thing.player:forceUpdate(act, true, -1, nextAct, true, -1, 0, false);
			end
		else
			self._bOperatingAct = Scene3DManager.instance:setGameObjectAction(self.ornamentSceneId, self.sceneModelName, act, tostring(self.ornamentRoleId));
			-- print("setGameObjectAction", self.sceneModelName, act);
		end
	end

	-- 移动目标
	if thing ~= nil then
		local tx = self.config.targetPx;
		local ty = self.config.targetPy;
		local tz = self.config.targetPz;
		if tx ~= nil or ty ~= nil or tz ~= nil then
			tx = tx ~= nil and tx or thing.data.px;
			ty = ty ~= nil and ty or thing.data.py;
			tz = tz ~= nil and tz or thing.data.pz;
			local spd = self.config.moveSpd;
			self._bOperatingMove = true;
			if spd == nil then -- 瞬移
				if thing.player ~= nil then
					thing.player:setPosPoint(tx, ty, tz, false);
				end
				self:completeMove();
			else
				thing.data.spd = spd;
				WorldMapUtil.genMoveCompleteAction(self.ornamentRoleId, tx, ty, tz, self.ornamentSceneId, 0);
			end
		end
	end

	-- 隐藏
	self._operatingHideTime = 0; 
	if self.config.hideState ~= nil and self.config.hideState == 1 then 
		local hideTime = self.config.hideTime;
		if hideTime ~= nil and hideTime > 0 then
			self._bOperatingHide = true;
			self._operatingHideTime = hideTime;
		end
		if thing ~= nil and thing.player ~= nil then
			thing.player:setActive(false);
		end
	else
		if thing ~= nil and thing.player ~= nil then
			thing.player:setActive(true);
		end
	end

	if self._bOperatingAct then
		self._startActTime = getTime();
		self._operatingActTime = (self.config.actFrame ~= nil) and ((self.config.actFrame + 10) / 30) or 0;
	else
		self._startActTime = 0;
	end

	if self._bOperatingAct or self._bOperatingMove or self._bOperatingHide then -- 行动中
		self._behaviorIntervalTime = 0;
		self._behaviorTime = self.behaviorTimeConst;
	end
	return true;
end

-- 动作播放完成
function Lua_SceneOrnamentBehaviorVo:completeAction()
	-- print("completeAction", self.behaviorId, self.ornamentRoleId, self._bOperatingClickAct, self._bOperatingAct, getTraceback());
	if self._bOperatingClickAct then -- 点击动作
		self._startClickActTime = 0;
		self._bOperatingClickAct = false;
	elseif self._bOperatingAct then
		self._operatingActTime = 0;
		self._bOperatingAct = false;
		if self.config ~= nil and not strIsNullOrEmpty(self.sceneModelName) then -- 场景对象结束的时候设置还原动作id
			local nextAct = self.config.nextAction;
			if nextAct ~= nil then
				Scene3DManager.instance:setGameObjectAction(self.ornamentSceneId, self.sceneModelName, nextAct);
			end
		end
	end
	
	self:checkOperateNextBehavior();
	Lua_MsgUtil.callFunc("SceneOrnament_Bubble_Hide", self.ornamentRoleId);
end

function Lua_SceneOrnamentBehaviorVo:completeHideState()
	if self._bOperatingHide then
		self._operatingHideTime = 0;
		self._bOperatingHide = false;
		self:checkOperateNextBehavior();
	end
end

function Lua_SceneOrnamentBehaviorVo:completeMove()
	if self._bOperatingMove then
		self._bOperatingMove = false;
		self:checkOperateNextBehavior();
	end
end

function Lua_SceneOrnamentBehaviorVo:checkOperateNextBehavior()
	if self._bOperatingAct or self._bOperatingMove or self._bOperatingHide or self._bOperatingClickAct then -- 行动中
		return;
	end

	local bid = self._behaviorId;
	self.behaviorId = bid + 1;
end

-- 根据时间重新设置动画播放
function Lua_SceneOrnamentBehaviorVo:resetAction()
	if self.config == nil then 
		return false;
	end

	if self._startActTime <= 0 and self._startClickActTime <= 0 then
		self:playPrevAction();
		-- print("resetAction return 1", self.behaviorId)
		return false;
	end

	local act;
	local frame;
	local actName;
	local startT;
	if self._bOperatingClickAct then
		frame = self.config.clickActFrame;
		actName = self.config.clickActName;
		act = self.config.clickAct;
		startT = self._startClickActTime;
	elseif self._bOperatingAct then
		frame = self.config.actFrame;
		actName = self.config.actName;
		act = self.config.action;
		startT = self._startActTime;
	end

	if frame == nil or actName == nil or act == nil then
		self:playPrevAction();
		-- print("resetAction return 2", self.behaviorId, frame, actName, act)
		return false;
	end

	local t = getTime() - startT;
	local normalTime = t / (frame / 30);
	normalTime = normalTime > 1 and 1 or normalTime;
	if strIsNullOrEmpty(self.sceneModelName) then -- 非场景对象
		local thing = DataCenter.thingData:getThingPlayer(self.ornamentSceneId, 0, self.ornamentRoleId);
		if thing ~= nil and thing.player ~= nil then
			return true;
		end
	else
		Scene3DManager.instance:setGameObjectAction(self.ornamentSceneId, self.sceneModelName, act, actName, tostring(self.ornamentRoleId), normalTime);
		-- print("resetAction", self.behaviorId, self.sceneModelName, act, actName, normalTime);
		return true;
	end
	return false;
end

function Lua_SceneOrnamentBehaviorVo:playPrevAction()
	if self.config == nil then
		return;
	end

	local id = self.config.prevId;
	if id == nil or id <= 0 then
		return;
	end

	local config = DataCenter.sceneUtil:getOrnamentBehaviorById(id);
	if config == nil or config.action == nil or config.actName == nil then
		return;
	end

	if strIsNullOrEmpty(self.sceneModelName) then -- 非场景对象
		local thing = DataCenter.thingData:getThingPlayer(self.ornamentSceneId, 0, self.ornamentRoleId);
		if thing ~= nil and thing.player ~= nil then

		end
	else
		Scene3DManager.instance:setGameObjectAction(self.ornamentSceneId, self.sceneModelName, config.action, config.actName, tostring(self.ornamentRoleId), 1);
		-- print("playPrevAction", config.action, config.actName, self.ornamentRoleId);
	end	
end

function Lua_SceneOrnamentBehaviorVo:resetBubble()
	if self.startShowBubbleTime > 0 and self.bubbleShowTime > 0 then
		local t = self.bubbleTime;
		if t > 0 then
			Lua_MsgUtil.callFunc("SceneOrnament_Bubble_Show", self);
		end
	end
end

-- 场景对象显示气泡
function Lua_SceneOrnamentBehaviorVo:showQipao(qipaoCfg, bPlayAct)
	-- 在执行点击动画
	if self._bOperatingClickAct then
		-- print("1")
		return;
	end

	if self.clickContinueTime > 0 then
		-- print("2")
		return;
	end

	if self.bubbleTime > 0 then
		-- print("3")
		return;
	end

	if self.config == nil then
		-- print("3")
		return;
	end

	if self.config.canClick == nil or self.config.canClick ~= 1 then
		-- print("5")
		return;
	end

	if self.ornamentRoleId <= 0 or self.ornamentSceneId <= 0 then
		-- print("6")
		return;
	end
	
	local thing = nil;
	if strIsNullOrEmpty(self.sceneModelName) then -- 非场景对象
		thing = DataCenter.thingData:getThingPlayer(self.ornamentSceneId, 0, self.ornamentRoleId);
		if thing == nil then
			return;
		end
	end

	self.qipaoCfg = qipaoCfg;
	-- 点击显示气泡
	if qipaoCfg ~= nil and qipaoCfg.bubbleTemplate ~= nil and qipaoCfg.bubbleTime ~= nil and qipaoCfg.bubbleTime > 0 then
		self.startShowBubbleTime = getTime();
		self.bubbleShowTime = qipaoCfg.bubbleTime / 1000;
		Lua_MsgUtil.callFunc("SceneOrnament_Bubble_Show", self);
	else
		self.startShowBubbleTime = 0;
		self.bubbleShowTime = 0;
	end

	-- 点击后步骤持续时间
	self.clickContinueTime = self.config.clickContinueTime ~= nil and self.config.clickContinueTime / 1000 or 0;

	-- 点击停止
	local clickStop = self.config.clickStop ~= nil and self.config.clickStop == 1 or false;
	if clickStop then
		if thing ~= nil and thing.player ~= nil then
			thing.player:clearAction();
			thing.player:stopMove(true);
		end
	end
	
	-- 点击后动作
	if self.config.clickPlay == 1 or bPlayAct == true then
		local act = self.config.clickAct;
		if act ~= nil then
			if thing ~= nil then
				if thing.player ~= nil then
					self._bOperatingClickAct = true;
					thing.player:forceUpdate(act, true, -1, 0, true, -1, 0, false);
				end
			else
				self._bOperatingClickAct = Scene3DManager.instance:setGameObjectAction(self.ornamentSceneId, self.sceneModelName, act, tostring(self.ornamentRoleId));
			end
		end

		if self._bOperatingClickAct then
			self._operatingActTime = 0; -- 不继续完成当前动作的处理
			self._bOperatingAct = false;
			self._startClickActTime = getTime();
		else
			self._startClickActTime = 0;
		end
	end
end

function Lua_SceneOrnamentBehaviorVo:completeClickOperate()
	self._startClickActTime = 0;
	self._bOperatingClickAct = false;
	self.clickContinueTime = 0;

	local thing = nil;
	if strIsNullOrEmpty(self.sceneModelName) then -- 非场景对象
		thing = DataCenter.thingData:getThingPlayer(self.ornamentSceneId, 0, self.ornamentRoleId);
		if thing == nil then
			return;
		end
	end

	-- 恢复行为目标点
	if self._bOperatingMove then
		local clickStop = self.config.clickStop ~= nil and self.config.clickStop == 1 or false;
		if clickStop and thing ~= nil then 
			local tx = self.config.targetPx;
			local ty = self.config.targetPy;
			local tz = self.config.targetPz;
			if tx ~= nil or ty ~= nil or tz ~= nil then
				tx = tx ~= nil and tx or thing.data.px;
				ty = ty ~= nil and ty or thing.data.py;
				tz = tz ~= nil and tz or thing.data.pz;
				local spd = self.config.moveSpd;
				if spd ~= nil then -- 瞬移
					thing.data.spd = spd;
					WorldMapUtil.genMoveCompleteAction(self.ornamentRoleId, tx, ty, tz, self.ornamentSceneId, 0);
				end
			end
		end
	end

	-- 恢复动作
	if not self:resetAction() and self._bOperatingAct then
		local act = self.config.action;
		if act ~= nil then
			if thing ~= nil then
				if thing.player ~= nil then
					local nextAct = self.config.nextAction ~= nil and self.config.nextAction or 0;
					thing.player:forceUpdate(act, true, -1, nextAct, true, -1, 0, false);
				end
			else
				Scene3DManager.instance:setGameObjectAction(self.ornamentSceneId, self.sceneModelName, act, tostring(self.ornamentRoleId));
			end
		end
	end
end