-- 场景装饰物生成相关信息
Lua_SceneOrnamentGenerateVo = class("Lua_SceneOrnamentGenerateVo");
function Lua_SceneOrnamentGenerateVo:ctor(gid)
	self:superCall("ctor");

	self._bornIntervalTime = -1;
	self._bornIdleTime = -1;
	self:setGenerateId(gid);
end

function Lua_SceneOrnamentGenerateVo:dispose()
	self.config = nil;
	self.behaviorConfig = nil;
end

function Lua_SceneOrnamentGenerateVo:clean()
	self.config = nil;
	self.behaviorConfig = nil;
	self.generateId = 0;
	self._bornIntervalTime = -1;
	self._bornIdleTime = -1;
end

function Lua_SceneOrnamentGenerateVo.Get:id()
	return self.generateId;
end

function Lua_SceneOrnamentGenerateVo.Get:sceneId()
	return (self.config ~= nil and self.config.sceneId ~= nil) and self.config.sceneId or 0;
end

function Lua_SceneOrnamentGenerateVo.Get:behaviorGroup()
	return (self.config ~= nil and self.config.behaviorGroup ~= nil) and self.config.behaviorGroup or 0;
end

function Lua_SceneOrnamentGenerateVo:setGenerateId(gid)
	self.generateId = gid;
	self.config = DataCenter.sceneUtil:getOrnamentById(gid);
	self.behaviorConfig = DataCenter.sceneUtil:getOrnamentBehaviorById(self.config.behaviorId);
end

function Lua_SceneOrnamentGenerateVo:frameScript(dt)
	if self._bornIntervalTime > 0 then
		self._bornIntervalTime = self._bornIntervalTime - dt;
	end
	if self._bornIdleTime > 0 then
		self._bornIdleTime = self._bornIdleTime - dt;
	end
end

-- 出生
function Lua_SceneOrnamentGenerateVo:born()
	self._bornIntervalTime = 0;
	self._bornIdleTime = (self.config ~= nil) and self.config.bornIdleTime or 0;
end

function Lua_SceneOrnamentGenerateVo:coolBorn()
	self._bornIntervalTime = (self.config ~= nil) and self.config.bornIntervalTime or 0;
	self._bornIdleTime = 0;
end

-- 是否可出生
function Lua_SceneOrnamentGenerateVo.Get:canBorn()
	return self._bornIntervalTime <= 0 and self._bornIdleTime <= 0;
end

-- 行为归属为生成事件
function Lua_SceneOrnamentGenerateVo.Get:behaviorAsBorn()
	return self.config ~= nil and self.config.behaviorAsBorn ~= nil and self.config.behaviorAsBorn == 1;
end

-- 行动id
function Lua_SceneOrnamentGenerateVo.Get:behaviorId()
	return (self.config ~= nil and self.config.behaviorId ~= nil) and self.config.behaviorId or 0;
end

function Lua_SceneOrnamentGenerateVo.Set:bornIntervalTime(val)
	self._bornIntervalTime = val;
end

function Lua_SceneOrnamentGenerateVo.Get:bornIntervalTime()
	return self._bornIntervalTime;
end

function Lua_SceneOrnamentGenerateVo.Set:bornIdleTime(val)
	self._bornIdleTime = val;
end

function Lua_SceneOrnamentGenerateVo.Get:bornIdleTime()
	return self._bornIdleTime;
end

-- 行为冷却时间
function Lua_SceneOrnamentGenerateVo.Get:behaviorIntervalTime()
	return (self.config ~= nil and self.config.behaviorIntervalTime ~= nil) and self.config.behaviorIntervalTime or 0;
end

-- 行为间隔时间
function Lua_SceneOrnamentGenerateVo.Get:behaviorTime()
	return (self.config ~= nil and self.config.behaviorTime ~= nil) and self.config.behaviorTime or 0;
end

function Lua_SceneOrnamentGenerateVo.Get:behaviorRate()
	return (self.config ~= nil and self.config.behaviorRate ~= nil) and self.config.behaviorRate or 100;
end