Lua_ShopData = class("Lua_ShopData");
Lua_ShopData.NORMAL_SHOP = 1; -- 百货商店
Lua_ShopData.HERO_SHOP = 2; -- 英雄商店
Lua_ShopData.TALENT_SHOP = 3; -- 天赋商店
Lua_ShopData.SKIN_SHOP = 4; -- 皮肤商店
Lua_ShopData.LEAGUE_SHOP = 5; -- 联盟商店
Lua_ShopData.ARENA_SHOP = 6; -- 竞技商店
Lua_ShopData.TREASURE_SHOP = 7; -- 探宝商店
Lua_ShopData.WAR_SHOP = 8; -- 远征商店
Lua_ShopData.PEAK_SHOP = 9; -- 巅峰商店
Lua_ShopData.SPIRIT_SHOP = 11; --精灵商店
Lua_ShopData.SEER_SHOP = 12; --先知商店
Lua_ShopData.EQUIP_SHOP = 13; --魔灵商店
function Lua_ShopData:ctor()
	self:dispose();
end

function Lua_ShopData:dispose()
	self.mainType = nil;
	self.subType = nil;
	self.shopType = nil;
end

function Lua_ShopData:fromServer50113001(msg)
	if msg == nil then
		return;
	end
	
	self.curShopType = msg.type;--商城类型
	self.itemList = msg.item_list;--商城道具列表
	self.segmentLv = msg.segment_lvl;--巅峰对决段位（巅峰商店）

	local shopTypeVo = DataCenter.shopUtil:getShopTypeVo(self.curShopType);
	if shopTypeVo ~= nil and shopTypeVo.model == 1 then
		local obj;
		for i = 1, #self.itemList do
			obj = self.itemList[i];
			DataCenter.shopUtil:updateShopItemInfo(self.curShopType, obj);
		end
	else
		DataCenter.shopUtil:updateShopTypeInfo(msg.type, msg.refresh);--商城刷新信息
	end
end

function Lua_ShopData:fromServer80113001(msg)
	if msg == nil then
		return;
	end
	if msg.refresh == 1 then
		DataCenter.shopUtil:resetBuyTime();
		Lua_MsgUtil.callFunc("REFRESH_SHOP_INFO");
	end
end

function Lua_ShopData:fromServer50113004(msg)
	if msg == nil then
		return;
	end
	DataCenter.shopUtil:updateShopTypeInfo(msg.shop_type, msg.refresh);--商城刷新信息
end

function Lua_ShopData:getCurShopItemList(shopType)
	local list = {};
	local shopTypeVo = DataCenter.shopUtil:getShopTypeVo(shopType);
	if shopTypeVo ~= nil then 
		if shopTypeVo.model == 1 then 
			list = DataCenter.shopUtil:getShopItemList(shopType);
		elseif shopTypeVo.model == 3 or shopTypeVo.model == 2 then
			local obj;
			for i = 1, #self.itemList do
				obj = self.itemList[i];
				local vo = Lua_ShopItemVo.new(obj.id);
				vo:updateServerInfo(obj);
				list[i] = vo;
			end
			if shopTypeVo.shopType ~= Lua_ShopData.SPIRIT_SHOP then
				table.sort( list, function(a, b) return a.sortIndex < b.sortIndex; end);
			end
		end
	end
	return list;
end



------------------------- 先知商店 ------------------------

function Lua_ShopData:getCurItemArrByCamp(campType)
	local arr = Array()
	local list;
	if self.curShopType == Lua_ShopData.SEER_SHOP then
		list = self:getCurShopItemList(self.curShopType);
	else
		list = DataCenter.shopUtil:getShopItemList(Lua_ShopData.SEER_SHOP);
	end
	for i = 1, #list do
		if curShopItemArr[i].hero_camp ~= nil then
			if campType == Lua_HeroUtil.All_TYPE or campType == curShopItemArr[i].hero_camp then
				arr:add(curShopItemArr[i]);
			end
		end
	end
	return arr;
end