checkRequire("Lua_ShopUtil");
checkRequire("Lua_ShopData");
Lua_ShopProxy = class("Lua_ShopProxy");
function Lua_ShopProxy:ctor()
	DataCenter.shopUtil = Lua_ShopUtil.new();
	DataCenter.shopData = Lua_ShopData.new();

	Lua_MsgUtil.addLuaMsg(50113001, self, self.rShopInfo); -- 获取商城信息(返回)
	Lua_MsgUtil.addLuaMsg(50113002, self, self.rBuyShopItem); -- 购买商城道具(返回)
	Lua_MsgUtil.addLuaMsg(50113003, self, self.rRefreshShop); -- 刷新商城(返回)
	Lua_MsgUtil.addLuaMsg(50113004, self, self.rBuyRefreshTimes); -- 购买刷新次数(返回)
	Lua_MsgUtil.addLuaMsg(80113001, self, self.rRefreshShopInNewDay); -- 商城刷新时间
end

-------------------- 上行 --------------------

-- 获取商城信息
function Lua_ShopProxy:sShopInfo(shopType)
	local cmd = ProtoPublic_pb.Proto10113001();
    cmd.type = shopType;
    sendMsg(10113001, cmd);
end

-- 购买商城道具
function Lua_ShopProxy:sBuyShopItem(id, shopType, amount, index)
	local cmd = ProtoPublic_pb.Proto10113002();
    cmd.id = id;
    cmd.shop_type = shopType;
    cmd.amount = amount;
	if index ~= nil then
	    cmd.index = index;
	end
    sendMsg(10113002, cmd);
end

-- 刷新商城
function Lua_ShopProxy:sRefreshShop(shopType, refreshType)
	local cmd = ProtoPublic_pb.Proto10113003();
    cmd.shop_type = shopType;
    cmd.refresh_type = refreshType; -- 刷新类型, 0: 免费 1: 自费
    sendMsg(10113003, cmd);
end

-- 购买刷新次数
function Lua_ShopProxy:sBuyRefreshTimes(shopType, times)
	local cmd = ProtoPublic_pb.Proto10113004();
    cmd.shop_type = shopType;
    cmd.times = times;
    sendMsg(10113004, cmd);
end

-------------------- 下行 --------------------

function Lua_ShopProxy:rShopInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50113001();
		msg:ParseFromString(mp.data);
		DataCenter.shopData:fromServer50113001(msg);
		Lua_MsgUtil.callFunc("UPDATE_SHOP_INFO");
	end
end

function Lua_ShopProxy:rBuyShopItem(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_BuyGoodsWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_ShopProxy:rRefreshShop(mp)
	if mp.errno == 0 then
		OperateAlert.showLangValue(125024);
	end
end

function Lua_ShopProxy:rBuyRefreshTimes(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50113004();
		msg:ParseFromString(mp.data);
		DataCenter.shopData:fromServer50113004(msg);
		Lua_MsgUtil.callFunc("UPDATE_SHOP_INFO");

		Lua_WindowUtil.openWin("Lua_BuyTimesWindow", Lua_WinParam.ACTION_CLOSE);
		OperateAlert.showLangValue(125025);
	end
end

function Lua_ShopProxy:rRefreshShopInNewDay(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80113001();
		msg:ParseFromString(mp.data);
		DataCenter.shopData:fromServer80113001(msg);
	end
end