-- 特效数据
Lua_EffectConfigData = class("Lua_EffectConfigData");
function Lua_EffectConfigData.getConfigData(id)
	if id == nil then
		return nil;
	end
	
    if Lua_EffectConfigData.configsDic == nil then
        Lua_EffectConfigData.configsDic = {};
    end
    if Lua_EffectConfigData.configsDic[id] == nil then
    	local cfg = getConfig("tb_effect", id);
    	if cfg == nil then
    		return nil;
    	end
        Lua_EffectConfigData.configsDic[id] = Lua_EffectConfigData.new(id, cfg);
    end
    return Lua_EffectConfigData.configsDic[id];
end

function Lua_EffectConfigData.getAllEffConfig()
	if Lua_EffectConfigData.configArr == nil then
		Lua_EffectConfigData.configArr = Array();
		if Lua_EffectConfigData.configsDic == nil then
			Lua_EffectConfigData.configsDic = {};
		end

		local config = getConfig("tb_effect");
		for k, v in pairs(config) do
			local vo = Lua_EffectConfigData.configsDic[k];
			if vo == nil then
				vo = Lua_EffectConfigData.new(k, v);
				Lua_EffectConfigData.configsDic[k] = vo;
			end
			Lua_EffectConfigData.configArr:add(vo);
		end
	end
	return Lua_EffectConfigData.configArr;
end





function Lua_EffectConfigData:ctor(id, cfg)
	self:superCall("ctor");

	self.configId = id;
	self.config = cfg;
	if self.config == nil then
		self.config = getConfig("tb_effect", id);
	end
end

function Lua_EffectConfigData.Get:name()
	if self.config.name == nil then
		return "";
	end
	return self.config.name;
end

function Lua_EffectConfigData.Get:floder()
	return self.config.floder;
end

function Lua_EffectConfigData.Get:path()
	return self.config.path;
end

function Lua_EffectConfigData.Get:url()
	if self.floder == nil or self.path == nil then
		return "";
	end
	return "/"..self.floder .. "/" .. self.path;
end

function Lua_EffectConfigData.Get:modelName()
	return self.path;
end