-- 技能数据
checkRequire("Lua_SkillEffectConfigData");
Lua_SkillConfigData = class("Lua_SkillConfigData");
function Lua_SkillConfigData.getConfigData(id)
	if id == nil then
		return nil;
	end
	id = tonumber(id);
	
    if Lua_SkillConfigData.configsDic == nil then
        Lua_SkillConfigData.configsDic = {};
    end
    if Lua_SkillConfigData.configsDic[id] == nil then
    	local cfg = getConfig("tb_skill", id);
    	if cfg == nil then
    		return nil;
    	end
        Lua_SkillConfigData.configsDic[id] = Lua_SkillConfigData.new(id, cfg);
    end
    return Lua_SkillConfigData.configsDic[id];
end

function Lua_SkillConfigData.getAllSkillConfig()
	if Lua_SkillConfigData.configArr == nil then
		Lua_SkillConfigData.configArr = Array();
		if Lua_SkillConfigData.configsDic == nil then
			Lua_SkillConfigData.configsDic = {};
		end

		local config = getConfig("tb_skill");
		for k, v in pairs(config) do
			local vo = Lua_SkillConfigData.configsDic[k];
			if vo == nil then
				vo = Lua_SkillConfigData.new(k, v);
				Lua_SkillConfigData.configsDic[k] = vo;
			end
			Lua_SkillConfigData.configArr:add(vo);
		end
	end
	return Lua_SkillConfigData.configArr;
end



function Lua_SkillConfigData:ctor(id, cfg)
	self:superCall("ctor");

	self.skillId = id;
	self.config = cfg;
	if self.config == nil then
		self.config = getConfig("tb_skill", id);
	end
end

function Lua_SkillConfigData.Get:name()
	return self.config.name;
end

function Lua_SkillConfigData.Get:remark()
	return self.config.remark;
end

function Lua_SkillConfigData.Get:level()
	if self.config.level == nil then
		return 0;
	end
	return self.config.level;
end

function Lua_SkillConfigData.Get:skillEffID()
	return self.config.skillEffID;
end

function Lua_SkillConfigData.Get:prevId()
	return self.config.prev_id or 0;
end

function Lua_SkillConfigData.Get:nextId()
	return self.config.next_id or 0;
end

-- 技能类型
function Lua_SkillConfigData.Get:skillType()
	return self.config.skill_type;
end

function Lua_SkillConfigData.Get:subType()
	return self.config.sub_type;
end

-- 首次触发的回合数
function Lua_SkillConfigData.Get:start_round()
	if self.config.start_round == nil then
		return 1;
	end
	return self.config.start_round;
end

-- 冷却回合数
function Lua_SkillConfigData.Get:cool_round()
	if self.config.cool_round == nil then
		return 1;
	end
	return self.config.cool_round;
end

-- 展示冷却回合数
function Lua_SkillConfigData.Get:show_cool_round()
	if self.config.cool_round == nil then
		return 0;
	end
	return self.config.cool_round;
end

function Lua_SkillConfigData.Get:target()
	if self.config.target == nil then
		return 0;
	end
	return self.config.target;
end

function Lua_SkillConfigData.Get:targetAmount()
	if self.config.target_amount == nil then
		return 1;
	end
	return self.config.target_amount;
end

function Lua_SkillConfigData.Get:hurtTimes()
	return self.config.hurt_times;
end

-- 显隐状态
function Lua_SkillConfigData.Get:show_type()
    return self.config.show_type;
end

-- 消耗能量
function Lua_SkillConfigData.Get:costEnergy()
    return self.config.cost_energy or 0;
end

-- 神器ID
function Lua_SkillConfigData.Get:artifactId()
    return self.config.artifact_id or 0;
end










function Lua_SkillConfigData.Get:skillEffCfgData()
	return Lua_SkillEffectConfigData.getConfigData(self.skillEffID);
end

function Lua_SkillConfigData.Get:showHurtTimes()
	if self.skillEffCfgData == nil then
		return 0;
	end
	return self.skillEffCfgData.hurtTimes;
end

function Lua_SkillConfigData.Get:countTime()
	if self.skillEffCfgData == nil then
		return 0;
	end
	return self.skillEffCfgData.countTime;
end

function Lua_SkillConfigData.Get:atlas()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.atlas;
end

function Lua_SkillConfigData.Get:sprite()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.sprite;
end

-- 解锁等级
function Lua_SkillConfigData.Get:unlock_level_list()
	return self.skillEffCfgData.unlock_level_list;
end

-- 是否根据解锁条件展示
function Lua_SkillConfigData.Get:isCondition()
	return self.skillEffCfgData.isCondition;
end

-- 技能标签
function Lua_SkillConfigData.Get:skill_tag()
	if self.skillEffCfgData == nil then
		return nil;
	end
	return self.skillEffCfgData.skill_tag;
end

-- 技能描述
function Lua_SkillConfigData.Get:des()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.des;
end

-- 技能描述(1级)
function Lua_SkillConfigData.Get:des1()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.des1;
end

-- 技能描述(2级)
function Lua_SkillConfigData.Get:des2()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.des2;
end

-- 技能描述(3级)
function Lua_SkillConfigData.Get:des3()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.des3;
end

-- 技能描述(4级)
function Lua_SkillConfigData.Get:des4()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.des4;
end

function Lua_SkillConfigData.Get:des5()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.des5;
end

-- 技能描述（颜色值以功能为主）
function Lua_SkillConfigData.Get:white_des()
	if self.skillEffCfgData == nil then
		return "";
	end
	return self.skillEffCfgData.white_des;
end

-- buff效果
function Lua_SkillConfigData.Get:buff_list() 
	return self.skillEffCfgData.buff_list;
end

function Lua_SkillConfigData.Get:skillTypeName()
	if self.skillType == 2 then
		return LanUtil.getValue(126103);
	elseif self.skillType == 3 then
		return LanUtil.getValue(126102);
	elseif self.skillType == 1 then
		return LanUtil.getValue(126118);
	end
	return "";
end

function Lua_SkillConfigData.Get:switch_skill_consume()
	return self.config.switch_skill_consume;
end

function Lua_SkillConfigData.Get:bShowFlash()
	if self.skillEffCfgData == nil then
		return false;
	end
	return self.skillEffCfgData.bShowFlash;
end

--稀有度
function Lua_SkillConfigData.Get:rarity()
	return self.skillEffCfgData.rarity;
end

--技能评分
function Lua_SkillConfigData.Get:grade()
	return self.skillEffCfgData.grade;
end

-- 目标选择类型，搭配target字段一起使用
function Lua_SkillConfigData.Get:targetType()
	return self.skillEffCfgData.targetType;
end

function Lua_SkillConfigData.Get:flyEff()
	return self.skillEffCfgData.flyEff;
end

function Lua_SkillConfigData.Get:flyTogetherNum()
	return self.skillEffCfgData.flyTogetherNum;
end

function Lua_SkillConfigData.Get:color()
    return self.skillEffCfgData.color;
end

function Lua_SkillConfigData.Get:connect_id()
    return self.skillEffCfgData.connect_id;
end