--星魂试炼Proxy 
checkRequire("Lua_StarTrialData");
checkRequire("Lua_StarTrialUtil");
Lua_StarTrialProxy = class("Lua_StarTrialProxy");

function Lua_StarTrialProxy:ctor()
	DataCenter.starTrialData = Lua_StarTrialData.new();
	DataCenter.starTrialUitl = Lua_StarTrialUtil.new();

	Lua_MsgUtil.addLuaMsg(50194001, self, self.rStarTrialInfo); --请求星魂试炼界面信息（返回）
	Lua_MsgUtil.addLuaMsg(50194002, self, self.rGetStarReward); --请求领取星魂试炼星数奖励（返回）
	Lua_MsgUtil.addLuaMsg(50194003, self, self.rGetDailyReward); --请求领取星魂试炼每日奖励（返回）
	Lua_MsgUtil.addLuaMsg(50194004, self, self.rStarTrialRankInfo); --请求星魂试炼排行信息（返回）
	Lua_MsgUtil.addLuaMsg(50194005, self, self.rChapterInfo); --请求星魂试炼章节信息界面信息(返回)
	Lua_MsgUtil.addLuaMsg(50194006, self, self.rNoMaxStarChapterInfo) --请求未满星章节信息(返回)
end

------------------------------------上行------------------------------------

function Lua_StarTrialProxy:sStarTrialInfo(curr_chapter)--请求星魂试炼界面信息
	local cmd = ProtoPublic_pb.Proto10194001();
	cmd.curr_chapter = curr_chapter;
	sendMsg(10194001, cmd);
end

function Lua_StarTrialProxy:sGetStarReward(chapter, index)--请求领取星魂试炼星数奖励
	local cmd = ProtoPublic_pb.Proto10194002();
	cmd.chapter = chapter;
	cmd.index = index;
	sendMsg(10194002, cmd);
end

function Lua_StarTrialProxy:sGetDailyReward()--请求领取星魂试炼每日奖励
	sendMsg(10194003);
end

function Lua_StarTrialProxy:sStarTrialRankInfo(page)--请求星魂试炼排行信息
	local cmd = ProtoPublic_pb.Proto10194004();
	cmd.page = page;
	sendMsg(10194004, cmd);
end

function Lua_StarTrialProxy:sChapterInfo()--请求星魂试炼章节信息界面信息
	sendMsg(10194005);
end

function Lua_StarTrialProxy:sNoMaxStarChapterInfo()--请求未满星章节信息
	sendMsg(10194006);
end

------------------------------------下行------------------------------------

function Lua_StarTrialProxy:rStarTrialInfo(mp)--请求星魂试炼界面信息（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194001();
		msg:ParseFromString(mp.data);
		DataCenter.starTrialData:fromServer50194001(msg);
	end
end

function Lua_StarTrialProxy:rGetStarReward(mp)--请求领取星魂试炼星数奖励（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194002();
		msg:ParseFromString(mp.data);
		DataCenter.starTrialData:fromServer50194002(msg);
	end
end

function Lua_StarTrialProxy:rGetDailyReward(mp)--请求扫荡（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194003();
		msg:ParseFromString(mp.data);
		DataCenter.starTrialData:updateSweepState(msg.day_reward);
	end
end

function Lua_StarTrialProxy:rStarTrialRankInfo(mp)--请求星魂试炼排行信息（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194004();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_RANK", msg);
	end
end

function Lua_StarTrialProxy:rChapterInfo(mp)--请求星魂试炼章节信息界面信息(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194005();
		msg:ParseFromString(mp.data);
		DataCenter.starTrialData:fromServer50194005(msg);
	end
end

function Lua_StarTrialProxy:rNoMaxStarChapterInfo(mp)--请求未满星章节信息(返回)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50194006();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("INIT_NOMAXCHAPTER_DATA", msg.lose_chapter);
	end
end