--星魂试炼 章节Vo
Lua_StarTrialChapterVo = class("Lua_StarTrialChapterVo");

function Lua_StarTrialChapterVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig("star_trial_chatper", tonumber(id));
	end
	self.nextCfg = getConfig("star_trial_chatper", self.id + 1);
end

function Lua_StarTrialChapterVo:fromServer(msg)
	self.starNum = msg.star;--本章获得的星数
	self._state = msg.state;--挑战状态：0未解锁，1可挑战

	local vo;
	self.isUnlockNewStage = false;--是否有新关卡解锁
	if self.stageVoArr == nil then
		self.stageVoArr = Array()
	end
	for i = 1, #msg.stage do
		vo = DataCenter.starTrialUitl:getStageVo(msg.stage[i].stage_id);
		vo:fromServer(msg.stage[i]);
		if msg.stage[i].state == 1 and msg.stage[i].stage_id ~= self.curStageId then --有新的关卡解锁
			self.isUnlockNewStage = true;
			self.curStageId = msg.stage[i].stage_id;
		end
		if self.stageVoArr:indexOf(vo) == -1 then
			self.stageVoArr:add(vo);
		end
	end
	self:updateStarRewardState(msg.reward);--星数奖励，key索引，value奖励状态：0不可领取，1可领取，2已领取
end

function Lua_StarTrialChapterVo.Get:starNum()
	return self._starNum == nil and 0 or self._starNum;
end

function Lua_StarTrialChapterVo.Set:starNum(value)
	self._starNum = value;
end

function Lua_StarTrialChapterVo.Get:state()
	return self._state == nil and 0 or self._state;
end

function Lua_StarTrialChapterVo.Set:state(value)
	self._state = value;
end

--是否全部关卡已通过
function Lua_StarTrialChapterVo.Get:isPass()
	if self.stageVoArr == nil then
		return false;
	else
		local len = self.stageVoArr:getSize();
		return self.stageVoArr[len].state == 2;
	end
end

--是否满足开启下一章节条件
function Lua_StarTrialChapterVo.Get:canOpenNextChapter()
	if self.nextCfg == nil then
		return false;
	end
	if self._starNum >= self.nextCfg.unlock_star and DataCenter.roleData.level >= self.nextCfg.limit_lvl then
		return true;
	else
		return false;
	end
end

function Lua_StarTrialChapterVo:updateStarRewardState(data)
	local id;
	self.canDraw = false;
	if self.starRewardList == nil then
		self.starRewardList = {};
	end
	for i = 1, #data do
		if tonumber(data[i].key) == nil then
			return;
		end
		if tonumber(data[i].value) == 1 then
			self.canDraw = true;
		end

		id = tonumber(data[i].key) % 10000;
		if self.starRewardList[id] == nil then
			self.starRewardList[id] = Lua_StarTrialStarRewardVo.new(tonumber(data[i].key));
		end
		self.starRewardList[id]:fromServer(data[i]);
	end

	if Lua_WindowUtil.isWindowShowing("Lua_StarTrialStarRewardWindow") then
		Lua_MsgUtil.callFunc("UPDATE_REWARD_DATE", self.starRewardList);
    end
end

function Lua_StarTrialChapterVo.Get:isMaxStar()
	return self.starNum >= self.total_star;
end

------------------------------------配置数据------------------------------------

function Lua_StarTrialChapterVo.Get:remark()--备注
	return self.config.remark;
end

function Lua_StarTrialChapterVo.Get:prev_chapter()--上一章节
	return self.config.prev_chapter;
end

function Lua_StarTrialChapterVo.Get:next_chapter()--下一章节
	return self.config.next_chapter;
end

function Lua_StarTrialChapterVo.Get:total_star()--总星数
	return self.config.total_star;
end

function Lua_StarTrialChapterVo.Get:limit_lvl()--等级限制
	return self.config.limit_lvl;
end

function Lua_StarTrialChapterVo.Get:unlock_star()--解锁需要上一章获得的星数
	return self.config.unlock_star;
end

function Lua_StarTrialChapterVo.Get:star_reward()--星数奖励
	return self.config.star_reward;
end