Lua_TenRecruitSelectVo = class("Lua_TenRecruitSelectVo")
function Lua_TenRecruitSelectVo:ctor(type)
	self.type = type;
	self:dispose();
end

function Lua_TenRecruitSelectVo:dispose()
	self.lastState = nil;
	self.fiveStarHero = nil;
	self.heroInfoArr = Array();
	self.showStarList = Array();
end

function Lua_TenRecruitSelectVo:updateInfo(msg)
	self.lastState = self.extractState; -- 用于记录前一次的状态，只有前一次状态为可抽取时播放动画
	self.extractState = msg.key; -- 挡位的抽取状态 0不可抽取 1可以抽取 2已抽取
	self.heroIdList = msg.list; -- 英雄ID列表
	self:initHeroInfo();
end

-- 英雄信息
function Lua_TenRecruitSelectVo:initHeroInfo()
	if self.heroInfoArr ~= nil then
		self.heroInfoArr:dispose();
		self.heroInfoArr:clear();
	end
	if self.showStarList ~= nil then
		self.showStarList:dispose();
		self.showStarList:clear();
	end

	local vo;
	local config;
	for i = 1, #self.heroIdList do
		config = Lua_HeroConfigData.getConfig(self.heroIdList[i]);
		if config ~= nil then
			vo = Lua_HeroVo.new(self.heroIdList[i], config)
			self.heroInfoArr:add(vo);

			if vo.initial_star > 3 then
				self.showStarList:add(vo); -- 用于显示动画
			end
			if vo.initial_star == 5 then
				self.fiveStarHero = vo; -- 只有一个5星
			end
		end
	end
end

function Lua_TenRecruitSelectVo:heroInfoByType(idx)
	return self.heroInfoArr[idx];
end