checkRequire("Lua_AttributesVo");
Lua_AttributesUtil = class("Lua_AttributesUtil");
function Lua_AttributesUtil:ctor()
    self:superCall("ctor");
end

function Lua_AttributesUtil:init()
	if self.bInit == nil or self.bInit == false then
		self.bInit = true;
		self._attributesDic = {};
		self._attributeIdsArr = Array();
		local config = getConfig("tb_prop");
		for k,v in pairs(config) do
			self._attributesDic[k] = v;
			self._attributeIdsArr:add(k);
		end
	end
end

function Lua_AttributesUtil.Get:attributesDic()
	self:init();
	return self._attributesDic;
end

function Lua_AttributesUtil.Get:attributeIdsArr()
	self:init();
	return self._attributeIdsArr;
end

function Lua_AttributesUtil:isAtttribute(val)
	if val == nil or self.attributesDic[val] == nil then
		return false;
	end
	return true;
end

function Lua_AttributesUtil:createAttrVo(id)
	local obj = self.attributesDic[id];
	if obj ~= nil then
		return Lua_AttributesVo.new(id, obj);
	end
	return nil;
end

------------------------------ 服务端数据 ------------------------------
-- list：服务端数据
function Lua_AttributesUtil:getAttrArrByServer(list)
	local arr = Array();
	if list ~= nil then	
		local vo;
		for i = 1, #list do
			vo = self:createAttrVo(list[i].name);
			if vo ~= nil then
				vo.value = list[i].value;
				if list[i].nextValue ~= nil then
					vo.nextValue = list[i].nextValue;
				end
				arr:add(vo);
			end
		end
		arr:sort("sort", false);
	end
	return arr;
end

-- list：服务端数据 (当前属性，下一个属性)
function Lua_AttributesUtil:getAttrArrByServer2(cur_list, next_list)
	local arr = Array();
	if cur_list ~= nil then	
		local vo;
		for i = 1, #cur_list do
			vo = self:createAttrVo(cur_list[i].name);
			if vo ~= nil then
				vo.value = cur_list[i].value;
				vo.nextValue = next_list[i].value;
				arr:add(vo);
			end
		end
		arr:sort("sort", false);
	end
	return arr;
end

function Lua_AttributesUtil:getAttrDicByServer(cur_list, next_list, dic)
	if dic == nil then
		dic = {};
	end
	if cur_list ~= nil then
		local vo;
		for i = 1, #cur_list do
			vo = self:createAttrVo(cur_list[i].name);
			if vo ~= nil then
				vo.value = cur_list[i].value;
				if next_list ~= nil and next_list[i] ~= nil then
					vo.nextValue = cur_list[i].value;
				end
				dic[vo.id] = vo;
			end
		end
	end
	return dic;
end

function Lua_AttributesUtil:getAttrStrByServer(list, joiner, preValStr)
	local str = "";
	if list ~= nil and #list > 0 then
		joiner = joiner == nil and " " or joiner;
		preValStr = preValStr == nil and "+" or preValStr;
		local vo;
		for i = 1, #list do
			vo = self:createAttrVo(list[i].name);
			vo.value = list[i].value;
			if str == "" then
				str = vo.show_name..preValStr..vo.showValue;
			else
				str = str..joiner..vo.show_name..preValStr..vo.showValue;
			end
		end
	end
	return str;
end

------------------------------ 配置表数据 ------------------------------

-- attr, nextAttr：配置表数据或自定义配置Vo  attr：当前属性 nextAttr：下一属性
function Lua_AttributesUtil:getAttrArrByConfig(attr, nextAttr, canZero)
	local arr = Array();
	if attr ~= nil then
		if canZero == nil then
			canZero = true;
		end
		
		local vo;
		local attrId;
		local len = self.attributeIdsArr:getSize();
		for i = 1, len do
			attrId = self.attributeIdsArr[i];
			if canZero == false and attr[attrId] == 0 then
				attr[attrId] = nil;
			end
			if attr[attrId] ~= nil then
				vo = self:createAttrVo(attrId);
				if vo ~= nil then
					vo.value = attr[attrId];
					if nextAttr ~= nil and nextAttr[attrId] ~= nil then
						vo.nextValue = nextAttr[attrId];
					end
					arr:add(vo);
				end
			end
		end
		arr:sort("sort", false);
	end
	return arr;
end

-- dic, nextDic：封装数据
function Lua_AttributesUtil:getAttrArrByDic(dic, nextDic)
	local vo;
	local arr = Array();
	for k, v in pairs(dic) do
		vo = self:createAttrVo(k);
		if vo ~= nil then
			vo.value = v;
			if nextDic ~= nil and nextDic[k] ~= nil then
				vo.nextValue = nextDic[k];
			end
			arr:add(vo);
		end
	end
	arr:sort("sort", false);
	return arr;
end

function Lua_AttributesUtil:getAttrDic(data, dic)
	if dic == nil then
		dic = {};
	end
	if data ~= nil then
		for k,v in pairs(data) do
			if self:isAtttribute(k) then
				if dic[k] == nil then
					dic[k] = v;
				else
					dic[k] = dic[k] + v;
				end
			end
		end
	end
	return dic;
end

function Lua_AttributesUtil:getAttrStr(tab, joiner, preValStr)
	local str = "";
	if tab ~= nil then
		joiner = joiner == nil and " " or joiner;
		preValStr = preValStr == nil and "+" or preValStr;
		local vo;
		for k,v in pairs(tab) do
			if self:isAtttribute(k) then
				vo = self:createAttrVo(k);
				vo.value = v;
				if str == "" then
					str = vo.show_name..preValStr..vo.showValue;
				else
					str = str..joiner..vo.show_name..preValStr..vo.showValue;
				end
			end
		end
	end
	return str;
end

function Lua_AttributesUtil:getListAttrStr(list, joiner, preValStr)
	local str = "";
	if list ~= nil and #list > 0 then
		joiner = joiner == nil and " " or joiner;
		preValStr = preValStr == nil and "" or preValStr;
		local vo;
		for i = 1, #list do
			local obj = list[i];
			if self:isAtttribute(obj.name) then
				local val = tonumber(tostring(obj.value));
				if val ~= 0 then
					vo = self:createAttrVo(obj.name);
					vo.value = val;
					if str == "" then
						str = vo.show_name..preValStr..vo.showValue;
					else
						str = str..joiner..vo.show_name..preValStr..vo.showValue;
					end
				end
			end
		end
	end
	return str;
end

------------------------------  ------------------------------
-- 战斗调试界面显示的属性列表
function Lua_AttributesUtil:getDebugSetProps()
	if self._debugSetAttrsArr == nil then
		self._debugSetAttrsArr = Array();
		local len = self.attributeIdsArr:getSize();
		for i = 1, len do
			local attrId = self.attributeIdsArr[i];
			local obj = self.attributesDic[attrId];
			if obj ~= nil and obj.show_state == 1 then
				self._debugSetAttrsArr:add(Lua_AttributesVo.new(attrId, obj));
			end
		end
		self._debugSetAttrsArr:sort("sort", false);
	end

	return self._debugSetAttrsArr;
end