-- hero配置表数据
Lua_HeroConfigData = class("Lua_HeroConfigData");
function Lua_HeroConfigData.getConfig(id)
	if id == nil then
		return nil;
	end
	
	id = tonumber(id);
	if Lua_HeroConfigData.configDic == nil then
		Lua_HeroConfigData.configDic = {};
	end

	if Lua_HeroConfigData.configDic[id] == nil then
		local cfg = getConfig("hero", id);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_HeroConfigData.configDic[id] = Lua_HeroConfigData.new(id, cfg);
	end
	return Lua_HeroConfigData.configDic[id];
end

function Lua_HeroConfigData.getAllHeroConfig()
	if Lua_HeroConfigData.configArr == nil then
		Lua_HeroConfigData.configArr = Array();
		if Lua_HeroConfigData.configDic == nil then
			Lua_HeroConfigData.configDic = {};
		end

		local config = getConfig("hero");
		for k, v in pairs(config) do
			local vo = Lua_HeroConfigData.configDic[k];
			if vo == nil then
				vo = Lua_HeroConfigData.new(k, v);
				Lua_HeroConfigData.configDic[k] = vo;
			end
			Lua_HeroConfigData.configArr:add(vo);
		end
		Lua_HeroConfigData.configArr:sort("id", false);
	end
	return Lua_HeroConfigData.configArr;
end

function Lua_HeroConfigData:ctor(id, config)
	self:superCall("ctor");
    self.id = id;
    self.config = config;
    if self.config == nil then
	    self.config = getConfig("hero", id);
	end
end

function Lua_HeroConfigData.Get:name()--名字
	return self.config.name;
end

function Lua_HeroConfigData.Get:title()--称号
	return self.config.title;
end

function Lua_HeroConfigData.Get:gender()--性别
	if self.config.gender == nil then
		return 0;
	end
	return self.config.gender;
end

function Lua_HeroConfigData.Get:camp()--阵营
	if self.config.camp == nil then
		return 0;
	end
	return self.config.camp;
end

function Lua_HeroConfigData.Get:career_des()--职业名
	if self.config.career_des == nil then
		return "";
	end
	return self.config.career_des;
end

function Lua_HeroConfigData.Get:rarity()--英雄稀有度
    return self.config.rarity;
end

function Lua_HeroConfigData.Get:bcore()--是否是核心
    return self.config.bcore;
end

function Lua_HeroConfigData.Get:initial_star() --初始星级
	return self.config.initial_star;
end

function Lua_HeroConfigData.Get:awaken_star_id() --初始觉醒星级id
	return self.config.awaken_star_id;
end

function Lua_HeroConfigData.Get:color() --初始品质色
	if self.config.color == nil then
		return 1;
	end
	return self.config.color;
end

function Lua_HeroConfigData.Get:max_star() -- 最大星级
	return self.config.max_star;
end

function Lua_HeroConfigData.Get:quality() -- 初始质量
	return self.config.quality;
end

function Lua_HeroConfigData.Get:quality_star() -- 初始质量星级
	return self.config.quality_star;
end

function Lua_HeroConfigData.Get:max_quality() -- 最高质量
	return self.config.max_quality;
end

function Lua_HeroConfigData.Get:max_quality_star() -- 最高质量星级
	return self.config.max_quality_star;
end

function Lua_HeroConfigData.Get:isShield()--是否屏蔽英雄
	if self.config.is_shield == nil then
		return false;
	end
    return self.config.is_shield == 1;
end

function Lua_HeroConfigData.Get:isMonster()--是否是怪物
    if self.config.is_monster == nil then
    	return false;
    end
    return self.config.is_monster == 1;
end

function Lua_HeroConfigData.Get:chip_id()--碎片ID
    return self.config.chip_id;
end

function Lua_HeroConfigData.Get:tran_chip_amount()--英雄转换碎片数量
    return self.config.tran_chip_amount;
end

function Lua_HeroConfigData.Get:career()--职业
	if self.config.career == nil then
		return 0;
	end
	return self.config.career;
end

function Lua_HeroConfigData.Get:sort()--排序
	return self.config.sort;
end

function Lua_HeroConfigData.Get:clothes_list()-- 时装数据
    return self.config.clothes_list;
end

function Lua_HeroConfigData.Get:lvl_skill_list()--等级技能等级列表
	return self.config.lvl_skill_list;
end

function Lua_HeroConfigData.Get:fight_skill()--战斗技能
	return self.config.fight_skill;
end

function Lua_HeroConfigData.Get:biography()--传记奖励
	return self.config.biography;
end

function Lua_HeroConfigData.Get:des_list()--传记描述列表
	return self.config.des_list;
end

function Lua_HeroConfigData.Get:avatar_atlas_1()
	return self.config.avatar_atlas_1;
end

function Lua_HeroConfigData.Get:avatar_sprite_1()
	return self.config.avatar_sprite_1;
end

function Lua_HeroConfigData.Get:avatar_atlas_2()
	return self.config.avatar_atlas_2;
end

function Lua_HeroConfigData.Get:avatar_sprite_2()
	return self.config.avatar_sprite_2;
end

function Lua_HeroConfigData.Get:atlas() -- atlas
	return self.config.atlas;
end

function Lua_HeroConfigData.Get:sprite() -- sprite
	return self.config.sprite;
end

function Lua_HeroConfigData.Get:path()
	if self._path == nil then
		if self.config.path then
			self._path = "/images/hero_item/"..self.config.path..".png"
		else
			self._path = ""
		end
	end
	return self._path
end

function Lua_HeroConfigData.Get:path1()
	if self._path1 == nil then
		if self.config.path1 then
			self._path1 = "/images/recruit/"..self.config.path1..".png"
		else
			self._path1 = ""
		end
	end
	return self._path1
end

function Lua_HeroConfigData.Get:trans()--是否可调度
	if self.config.trans == nil then
		return 0;
	end
	return self.config.trans;
end

function Lua_HeroConfigData.Get:scale()--缩放
	if self.config.scale == nil or self.config.scale <= 0 then
		return 1;
	end
	return self.config.scale;
end

function Lua_HeroConfigData.Get:nameHeight()--名字显示高度
	if self.config.name_height == nil then
		return 230;
	end
	return self.config.name_height;
end

function Lua_HeroConfigData.Get:nameScale()
	if self.config.name_scale == nil or self.config.name_scale <= 0 then
		return 1;
	end
	return self.config.name_scale;
end

function Lua_HeroConfigData.Get:namePos()
	if self._namePos == nil then
		local list = self.config.namePos;
        if list ~= nil then
            if #list >= 3 then
                self._namePos = Vector3(list[1], list[2], list[3]);
            elseif #list >= 2 then
                self._namePos = Vector3(list[1], list[2], 0);
            elseif #list >= 1 then
                self._namePos = Vector3(list[1], 0, 0);
            else
                self._namePos = Vector3(0, 2, 0);
            end
        elseif self.config.name_height ~= nil then
        	self._namePos = Vector3(0, self.config.name_height, 0);
        else
            self._namePos = Vector3(0, 2, 0);
        end
    end
	return self._namePos;
end

function Lua_HeroConfigData.Get:spd()--移速
	if self.config.spd == nil then
		return 0;
	end
	return self.config.spd;
end

function Lua_HeroConfigData.Get:floder()--jta代替ID
	return self.config.floder or "/model/";
end

function Lua_HeroConfigData.Get:jid()--jta代替ID
	return self.config.jid;
end

function Lua_HeroConfigData.Get:modelUrl()
	if self._modelUrl == nil then
		self._modelUrl = LanUtil.StringProfile(self.floder, self.jid);
	end
	return self._modelUrl;
end

function Lua_HeroConfigData.Get:modelSrc()--模型名
	return self.config.modelSrc;
end

function Lua_HeroConfigData.Get:effect()
	return self.config.effect;
end

function Lua_HeroConfigData.Get:material()
	return self.config.material;
end

function Lua_HeroConfigData.Get:bShowFlash()
	if self.config.bShowFlash == nil then
		return false;
	end
	return self.config.bShowFlash == 1;
end

function Lua_HeroConfigData.Get:flashColor()
	return self.config.flashColor;
end

function Lua_HeroConfigData.Get:flashWidth()
	if self.config.flashWidth == nil then
		return 0;
	end
	return self.config.flashWidth;
end

function Lua_HeroConfigData.Get:des()--描述
	if self.config.des == nil then
		return "";
	end
	return self.config.des;
end

function Lua_HeroConfigData.Get:show_effect_limit()
	return self.config.show_effect_limit;
end

function Lua_HeroConfigData.Get:isShowWish()
    return self.config.isShowWish;
end

function Lua_HeroConfigData.Get:nameAtlas()
    return self.config.nameAtlas;
end

function Lua_HeroConfigData.Get:nameIcon()
    return self.config.nameIcon;
end

function Lua_HeroConfigData.Get:descAtlas()
    return self.config.descAtlas;
end

function Lua_HeroConfigData.Get:descIcon()
    return self.config.descIcon;
end

function Lua_HeroConfigData.Get:guide_model_image()
    return self.config.guide_model_image;
end

function Lua_HeroConfigData.Get:guide_model_pos()
    return self.config.guide_model_pos;
end

function Lua_HeroConfigData.Get:guide_model_sca()
    return self.config.guide_model_sca;
end

function Lua_HeroConfigData.Get:head_star_height()
    return self.config.head_star_height;
end

function Lua_HeroConfigData.Get:obtain_path_id()-- 获取途径
    return self.config.obtain_path_id;
end

function Lua_HeroConfigData.Get:uiSceneId()
    return self.config.uiSceneId;
end

function Lua_HeroConfigData.Get:uiModelUrl()
	if self._uiModelUrl == nil then
		self._uiModelUrl = LanUtil.StringProfile(self.floder, self.uiModelSrc);
	end
	return self._uiModelUrl;
end

function Lua_HeroConfigData.Get:uiModelSrc()
	return self.config.uiModelSrc;
end

function Lua_HeroConfigData.Get:uiModelAvatarName()
    return self.config.uiModelAvatarName;
end

function Lua_HeroConfigData.Get:uiModelCamController()
	return self.config.uiModelCamController;
end

function Lua_HeroConfigData.Get:uiModelScale()
	return self.config.uiModelScale;
end

function Lua_HeroConfigData.Get:talent_list()
    return self.config.talent_list;
end

function Lua_HeroConfigData.Get:recom_awake()
    return self.config.recom_awake;
end

function Lua_HeroConfigData.Get:poseActEffs()
	if self.config == nil then
		return nil;
	end
	return self.config.poseActEffs;
end

function Lua_HeroConfigData.Get:activatePoseActEffs()
	if self.config == nil then
		return nil;
	end
	return self.config.activatePoseActEffs;
end

function Lua_HeroConfigData.Get:showActEffs()
	if self.config == nil then
		return nil;
	end
    return self.config.showActEffs;
end

function Lua_HeroConfigData.Get:uiShowAct()
	if self.config == nil or self.config.uiShowAct == nil then
		return Lua_ThingDefine.UIWAIT;
	end
    return self.config.uiShowAct;
end

function Lua_HeroConfigData.Get:lysisCountTime()
	if self._lysisCountTime == nil then
		if self.config ~= nil and self.config.lysisCountTime ~= nil then
			self._lysisCountTime = self.config.lysisCountTime / 30;
		end
		if self._lysisCountTime == nil or self._lysisCountTime <= 0 then
			self._lysisCountTime = Lua_CommonUtil.getCommonConfig("fight_lysis_usetime", 4, 1);
		end
	end
	return self._lysisCountTime;
end

function Lua_HeroConfigData.Get:itemId()
	if self.config == nil then
		return nil;
	end
	return self.config.item_id;
end

function Lua_HeroConfigData.Get:weaponId()
	if self.config == nil or self.config.weapon_id == nil then
		return 0;
	end
	return self.config.weapon_id;
end

-- 昆墟圣地进入战斗界面时显示的立绘
function Lua_HeroConfigData.Get:heroRolePath()
	if self._heroRolePath == nil then
		if self.config.hero_role_path then
			self._heroRolePath = "/images/hero_role/"..self.config.hero_role_path..".png";
		else
			self._heroRolePath = "";
		end
	end
    return self._heroRolePath;
end

-- -- 英雄羁绊显示的立绘
-- function Lua_HeroConfigData.Get:heroFetterPath()
-- 	if self._heroFetterPath == nil and self.config.hero_fetter_path then
-- 		self._heroFetterPath = "/images/hero_fetter/"..self.config.hero_fetter_path..".png";
-- 	end
--     return self._heroFetterPath;
-- end

--故事卡id
function Lua_HeroConfigData.Get:cardList()
	if self.config == nil or self.config.card_list == nil then
		return {};
	end
	return self.config.card_list;
end

--英雄简介
function Lua_HeroConfigData.Get:hero_des()
	if self.config == nil or self.config.hero_des == nil then
		return "";
	end
	return self.config.hero_des;
end

--定位
function Lua_HeroConfigData.Get:posit_des()
	if self.config == nil or self.config.posit_des == nil then
		return "";
	end
	return self.config.posit_des;
end

--特长
function Lua_HeroConfigData.Get:expertise_des()
	if self.config == nil or self.config.expertise_des == nil then
		return "";
	end
	return self.config.expertise_des;
end

function Lua_HeroConfigData.Get:line_sound()
	if self.config == nil or self.config.line_sound == nil then
		return "";
	end
	return self.config.line_sound;
end

function Lua_HeroConfigData.Get:connect_id()
	if self.config == nil then
		return 0;
	end
	return self.config.connect_id or 0
end