Lua_MonsterPlayerConfigData = class("Lua_MonsterPlayerConfigData");
function Lua_MonsterPlayerConfigData.getConfigData(id)
	if id == nil then
		return nil;
	end
	
	if Lua_MonsterPlayerConfigData.configs == nil then
		Lua_MonsterPlayerConfigData.configs = {};
	end

	id = tonumber(id);
	if Lua_MonsterPlayerConfigData.configs[id] == nil then
		local indexId = Mathf.Floor(id / 100000)
		local value = getConfig("tb_monster_player_index", indexId, "index")
		local config
		if value == nil then
			config = getConfig("tb_monster_player", id);
		else
			config = getConfig(value, id);
		end
		if config == nil then
			return nil
		end
		Lua_MonsterPlayerConfigData.configs[id] = Lua_MonsterPlayerConfigData.new(id, config);
	end
	return Lua_MonsterPlayerConfigData.configs[id];
end

function Lua_MonsterPlayerConfigData:ctor(id, config)
	self:superCall("ctor");
	self.id = tonumber(id);
	if config == nil then
		local indexId = Mathf.Floor(id / 100000)
		local value = getConfig("tb_monster_player_index", indexId, "index")
		if value == nil then
			self.config = getConfig("tb_monster_player", id);
		else
			self.config = getConfig(value, id);
		end
	else
		self.config = config
	end
end

-------------------- 配置数据 --------------------

function Lua_MonsterPlayerConfigData.Get:name()
	return self.config.name or {};
end

function Lua_MonsterPlayerConfigData.Get:force()
	return self.config.force or {};
end

function Lua_MonsterPlayerConfigData.Get:camp_aureole_id()
	return self.config.camp_aureole_id;
end

function Lua_MonsterPlayerConfigData.Get:fighter_list()
	return self.config.fighter_list;
end