Lua_PlayerHangerConfigData = class("Lua_PlayerHangerConfigData");
function Lua_PlayerHangerConfigData.getConfig(cId)
	if Lua_PlayerHangerConfigData.configDic == nil then
		Lua_PlayerHangerConfigData.configDic = {};
	end

	if Lua_PlayerHangerConfigData.configDic[cId] == nil then
		local cfg = getConfig("tb_playerHanger", cId);
	    if cfg == nil then
	    	return nil;
	    end
		Lua_PlayerHangerConfigData.configDic[cId] = Lua_PlayerHangerConfigData.new(cId, cfg);
	end
	return Lua_PlayerHangerConfigData.configDic[cId];
end

function Lua_PlayerHangerConfigData:ctor(id, config)
	self:superCall("ctor");
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig("tb_playerHanger", self.id);
	end
	if self.config == nil then
		LogManager.LogError("no tb_playerHanger id = " .. id, false);
	end
end

function Lua_PlayerHangerConfigData.Get:offsetPos()
	return self.config.offset_pos;
end

function Lua_PlayerHangerConfigData.Get:offsetSca()
	return self.config.offset_sca;
end

function Lua_PlayerHangerConfigData.Get:mirrorType()
	if self.config.mirrorType == nil then
		return 0;
	end
	return self.config.mirrorType;
end