-- 古城秘藏 路径格子Vo
Lua_TownTreasureCellVo = class("Lua_TownTreasureCellVo");

function Lua_TownTreasureCellVo:ctor(id, config)
	self.id = id;
	self.config = config;
	if self.config == nil then
		self.config = getConfig("tower_secrete_cell", id);
	end
end

function Lua_TownTreasureCellVo:fromServerInfo(msg)
	self.eventId = msg.cell_reward; -- 奖励id/建筑id
	self.levelId = msg.level_id; -- 建筑等级id
	self.value = msg.output; -- 建筑累计常量/道具数量
	self.curTime =  msg.curr_times; -- 累计投掷次数
end

function Lua_TownTreasureCellVo.Get:cellWidth()
	if self._cellWidth == nil then
		self._cellWidth =  DataCenter.townTreasureUtil:getCellWidth(self.version_id);
	end
	return self._cellWidth;
end

function Lua_TownTreasureCellVo.Get:cellHight()
	if self._cellHight == nil then
		self._cellHight = DataCenter.townTreasureUtil:getCellHight(self.version_id);
	end
	return self._cellHight;
end

function Lua_TownTreasureCellVo.Get:posX()
	if self._posX == nil then
		self._posX = self.cellWidth * (self.column - 1) + self.cellWidth / 2;
	end
	return self._posX;
end

function Lua_TownTreasureCellVo.Get:posY()
	if self._posY == nil then
		self._posY = self.cellHight * (self.row - 1) + self.cellHight / 2;
	end
	return self._posY;
end

--------------------------- 配置数据 ---------------------------

function Lua_TownTreasureCellVo.Get:row()
	return self.config.row;
end

function Lua_TownTreasureCellVo.Get:column()
	return self.config.column;
end

function Lua_TownTreasureCellVo.Get:version_id()
	return self.config.version_id;
end

function Lua_TownTreasureCellVo.Get:bind_build_id()
	return self.config.bind_build_id;
end

function Lua_TownTreasureCellVo.Get:is_building()
	return self.config.is_building ~= nil;
end

function Lua_TownTreasureCellVo.Get:next_stage()
	return self.config.next_stage;
end

function Lua_TownTreasureCellVo.Get:icon_res()
	return self.config.icon_res;
end

function Lua_TownTreasureCellVo.Get:img_path()
	return self.config.img_path;
end

function Lua_TownTreasureCellVo.Get:build_offset_pos()
	return self.config.build_offset_pos;
end

function Lua_TownTreasureCellVo.Get:name_offset_pos()
	return self.config.name_offset_pos;
end

function Lua_TownTreasureCellVo.Get:icon_offset_pos()
	return self.config.icon_offset_pos;
end

--------------------------- 额外通用配置 ---------------------------

function Lua_TownTreasureCellVo.Get:addCfg()
	local id = self.is_building and self.levelId or self.eventId;
	if id ~= nil and self.addCfgId ~= id then
		self.addCfgId = id;
		if self.is_building then
			self._addCfg = DataCenter.townTreasureUtil:buildCfg(self.addCfgId);
		else
			self._addCfg = DataCenter.townTreasureUtil:eventCfg(self.addCfgId);
		end
	end
	return self._addCfg;
end

function Lua_TownTreasureCellVo.Get:itemId()
	if self.addCfg == nil then return nil end
	if self.is_building then
		return self.addCfg.create;
	else
		return self.addCfg.item;
	end
end

function Lua_TownTreasureCellVo.Get:addIcon()
	if self.addCfg == nil then return nil end
	return self.addCfg.icon_res;
end

function Lua_TownTreasureCellVo.Get:icon_size()
	if self.addCfg == nil then return nil end
	return self.addCfg.icon_size;
end

--------------------------- 额外建筑配置 ---------------------------

function Lua_TownTreasureCellVo.Get:level()
	if self.addCfg == nil then return nil end
	return self.addCfg.level;
end


function Lua_TownTreasureCellVo.Get:max_level()
	if self.addCfg == nil then return nil end
	return self.addCfg.max_level;
end

function Lua_TownTreasureCellVo.Get:limit()
	if self.addCfg == nil then return nil end
	return self.addCfg[DataCenter.townTreasureData.keyWord][1];
end

function Lua_TownTreasureCellVo.Get:output_time()
	if self.addCfg == nil then return nil end
	return self.addCfg[DataCenter.townTreasureData.keyWord][2];
end

function Lua_TownTreasureCellVo.Get:output()
	if self.addCfg == nil then return nil end
	return self.addCfg[DataCenter.townTreasureData.keyWord][3];
end

function Lua_TownTreasureCellVo.Get:building_name()
	if self.addCfg == nil then return nil end
	return self.addCfg.building_name;
end

--------------------------- 额外事件配置 ---------------------------

function Lua_TownTreasureCellVo.Get:reward_type()
	if self.addCfg == nil then return nil end
	return self.addCfg.reward_type;
end

function Lua_TownTreasureCellVo.Get:describe()
	if self.addCfg == nil then return nil end
	return self.addCfg.describe;
end

function Lua_TownTreasureCellVo.Get:is_now()
	if self.addCfg == nil then return nil end
	return self.addCfg.is_now;
end

function Lua_TownTreasureCellVo.Get:buff_icon()
	if self.addCfg == nil then return nil end
	return self.addCfg.buff_icon;
end

function Lua_TownTreasureCellVo.Get:delay_time()
	if self.addCfg == nil then return nil end
	return self.addCfg.delay_time;
end