-- 古城秘藏 Proxy
checkRequire("Lua_TownTreasureData");
checkRequire("Lua_TownTreasureUtil");
Lua_TownTreasureProxy = class("Lua_TownTreasureProxy");

function Lua_TownTreasureProxy:ctor()
    DataCenter.townTreasureUtil = Lua_TownTreasureUtil:new();
    DataCenter.townTreasureData = Lua_TownTreasureData:new();

    Lua_MsgUtil.addLuaMsg(50207001, self, self.rActivityInfo);
    Lua_MsgUtil.addLuaMsg(50207002, self, self.rTaskInfo);
    Lua_MsgUtil.addLuaMsg(50207004, self, self.rExploreInfo);
    Lua_MsgUtil.addLuaMsg(50207007, self, self.rBuyDiceCount);

    Lua_MsgUtil.addLuaMsg(80207003, self, self.iBuildingInfo);
end

---------------------------- 上行 ----------------------------

-- 请求古城秘藏界面信息
function Lua_TownTreasureProxy:sActivityInfo()
    sendMsg(10207001);
end

-- 请求古城秘藏任务界面信息
function Lua_TownTreasureProxy:sTaskInfo()
    sendMsg(10207002);
end

-- 请求古城秘藏活动探索
function Lua_TownTreasureProxy:sExploreInfo()
    sendMsg(10207004);
end

-- 请求领取古城秘藏任务奖励
function Lua_TownTreasureProxy:sGetTaskReward(draw_id)
    local cmd = ProtoPublic_pb.Proto10207005();
    cmd.draw_id = draw_id; -- 领取奖励id 0一键领取
    sendMsg(10207005, cmd);
end

-- 请求使用古城秘藏特殊道具
function Lua_TownTreasureProxy:sUseSpecialItem(item_id, temp)
    local cmd = ProtoPublic_pb.Proto10207006();
    cmd.item_id = item_id; -- 使用道具id
    cmd.temp = temp; -- 道具参数
    sendMsg(10207006, cmd);
end

-- 请求购买古城秘藏投掷次数
function Lua_TownTreasureProxy:sBuyDiceCount(buy_times)
    local cmd = ProtoPublic_pb.Proto10207007();
    cmd.buy_times = buy_times; -- 购买次数
    sendMsg(10207007, cmd);
end












---------------------------- 下行 ----------------------------

-- 请求古城秘藏界面信息(返回)
function Lua_TownTreasureProxy:rActivityInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50207001();
        msg:ParseFromString(mp.data);
        DataCenter.townTreasureData:fromServer50207001(msg);
    end
end

-- 请求古城秘藏任务界面信息(返回)
function Lua_TownTreasureProxy:rTaskInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50207002();
        msg:ParseFromString(mp.data);
        DataCenter.townTreasureData:fromServer50207002(msg);
    end
end

-- 请求古城秘藏活动探索(返回)
function Lua_TownTreasureProxy:rExploreInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50207004();
        msg:ParseFromString(mp.data);
        DataCenter.townTreasureData:fromServer50207004(msg);
    end
end

-- 更新古城秘藏建筑信息
function Lua_TownTreasureProxy:iBuildingInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80207003();
        msg:ParseFromString(mp.data);
        DataCenter.townTreasureData:fromServer80207003(msg);
    end
end

-- 请求购买古城秘藏投掷次数(返回)
function Lua_TownTreasureProxy:rBuyDiceCount(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50207007();
        msg:ParseFromString(mp.data);
        DataCenter.townTreasureData:fromServer50207007(msg);
    end
end