-- 古城秘藏 Util
Lua_TownTreasureUtil = class("Lua_TownTreasureUtil");

function Lua_TownTreasureUtil:ctor()
	self:dispose();
end

function Lua_TownTreasureUtil:dispose()
end

------------------------------ 常量配置 ------------------------------

function Lua_TownTreasureUtil:getConstConfig(id, key)
	local config = getConfig("tower_secrete_const", id);
	if config ~= nil then
		if key == 1 then
			return config.value;
		elseif key == 2 then
			return config.float_value;
		elseif key == 3 then
			return config.jsonvalue;
		end
	end
	return nil;
end

function Lua_TownTreasureUtil.Get:getMoneyShow()
	return self:getConstConfig("top_money_show", 3);
end

function Lua_TownTreasureUtil.Get:commonDiceId()
	return self:getConstConfig("common_dice", 1);
end

function Lua_TownTreasureUtil.Get:moveSpeed()
	return self:getConstConfig("role_move_speed", 3);
end

function Lua_TownTreasureUtil.Get:modelScale()
	return self:getConstConfig("role_model_scale", 2);
end

function Lua_TownTreasureUtil.Get:closeSec()
	return self:getConstConfig("loop_window_close_sec", 1);
end

------------------------------ 版本配置 ------------------------------

function Lua_TownTreasureUtil:getVersionInfo(id, key)
	local config = getConfig("tower_secrete_version", id);
	if config ~= nil then
		return config[key];
	end
	return nil;
end

function Lua_TownTreasureUtil:getCellWidth(id)
	return self:getVersionInfo(id, "cell_size_width");
end

function Lua_TownTreasureUtil:getCellHight(id)
	return self:getVersionInfo(id, "cell_size_hight");
end

function Lua_TownTreasureUtil:getMapSize(id)
	local cellNumW = self:getVersionInfo(id, "map_width_num");
	local cellNumH = self:getVersionInfo(id, "map_hight_num");
	local cellW = self:getCellWidth(id);
	local cellH = self:getCellHight(id);
	return cellNumW * cellW, cellNumH * cellH;
end

function Lua_TownTreasureUtil:getMapBg(id)
	return self:getVersionInfo(id, "map_bg");
end

function Lua_TownTreasureUtil:getKeyWord(id)
	return self:getVersionInfo(id, "key_word");
end

function Lua_TownTreasureUtil:getLoopRewardLv(id, loop)
	local maxLoop = self:getVersionInfo(id, "max_loop_times");
	if loop > maxLoop then
		loop = maxLoop;
	end
	return loop;
end

------------------------------ 任务配置 ------------------------------

function Lua_TownTreasureUtil.Get:getTaskArr()
	if self._taskArr == nil then
		self._taskArr = Array();
		local config = getConfig("tower_secrete_task");
		for k, v in pairs(config) do
			self._taskArr:add(v);
		end
		self._taskArr:sort("times", false);
	end
	return self._taskArr;
end

function Lua_TownTreasureUtil:getNextTask(num)
	for i = 1, self.getTaskArr:getSize() do
		if self.getTaskArr[i].times > num then
			return self.getTaskArr[i];
		end
	end
	return self.getTaskArr[self.getTaskArr:getSize()];
end

function Lua_TownTreasureUtil:getTaskConfig(id)
	for i = 1, self.getTaskArr:getSize() do
		if self.getTaskArr[i].times == id then
			return self.getTaskArr[i];
		end
	end
	return self.getTaskArr[self.getTaskArr:getSize()];
end

------------------------------ 格子配置 ------------------------------

function Lua_TownTreasureUtil:buildCfg(id)
	return getConfig("tower_secrete_building", id);
end

function Lua_TownTreasureUtil:eventCfg(id)
	return getConfig("tower_secrete_reward", id);
end