checkRequire("Lua_TrialTypeInfoVo");
checkRequire("Lua_TrialEachInfoVo");
Lua_TrialData = class("Lua_TrialData");
Lua_TrialData.COIN = 1; -- 金币副本
Lua_TrialData.EXP = 2; -- 经验副本
Lua_TrialData.HERO = 3; -- 英雄副本
Lua_TrialData.ARTIFACT = 4; -- 神器副本
Lua_TrialData.STONE = 5; -- 符石副本
function Lua_TrialData:ctor()
	self:dispose();
end

function Lua_TrialData:dispose()
	self._trialTypeInfoDic = nil;
	self._trialEachInfoDic = nil;
	self._trialTypeInfoArr = Array();
	self.fightToShowType = nil; -- 战斗完返回对应试炼类型
	self.curShowType = 1; -- 当前显示的试炼类型
	self.rec_Index = 0; -- 对应类型可挑战或扫荡的id
end

function Lua_TrialData:fromServer50150001(msg)
	self:getTrialTypeById(msg.trial_info.type):updateTrialData(msg.trial_info);
end

function Lua_TrialData:initInfoDic()
	if self._trialTypeInfoDic == nil then
		self._trialTypeInfoDic = {};
		self._trialTypeInfoArr = Array();

		local vo;
		local config = getConfig("trial_type");
		for k,v in pairs(config) do
			vo = Lua_TrialTypeInfoVo.new(k, v);
			self._trialTypeInfoDic[k] = vo;
			self._trialTypeInfoArr:add(vo);
		end
		self._trialTypeInfoArr:sort("id", false);
	end
end

function Lua_TrialData.Get:trialEachInfoDic()
	if self._trialEachInfoDic == nil then
		self._trialEachInfoDic = {};

		local vo;
		local config = getConfig("trial");
		for k,v in pairs(config) do
			vo = Lua_TrialEachInfoVo.new(k, v);
			self._trialEachInfoDic[k] = vo;
		end
	end
	return self._trialEachInfoDic;
end

function Lua_TrialData:getTrialTypeArr()
	self:initInfoDic();
	return self._trialTypeInfoArr;
end

function Lua_TrialData:getTrialTypeById(type)
	self:initInfoDic();
	return self._trialTypeInfoDic[type];
end

function Lua_TrialData:getTrialEachById(id)
	if self.trialEachInfoDic[id] ~= nil then
		return self.trialEachInfoDic[id];
	end
	return nil;
end

-- 可挑战的最小试炼id
function Lua_TrialData:getTypeMinId(type)
	local info = self:getTrialTypeById(type);
	if info ~= nil then
		for i = 1, info.script_arr:getSize() do
			if info.script_arr[i].state == 1 then
				return info.script_arr[i].id;
			end
		end
	end
	return nil;
end

-- 可挑战>可扫荡>未开启
function Lua_TrialData:getTypeRecIndex(trialType)
	self.rec_Index = 0;
	local showIdx = 1;
	local info = self:getTrialTypeById(trialType);
	if info ~= nil then
		for i = 1, info.script_arr:getSize() do
			if info.script_arr[i].state == 1 then -- 可挑战
				self.rec_Index = info.script_arr[i].id;
				showIdx = i;
				break;
			elseif info.script_arr[i].state == 2 then -- 可扫荡
				self.rec_Index = info.script_arr[i].id;
				showIdx = i;
			else -- 未开启
				break;
			end
		end
	end
	return showIdx;
end