checkRequire("Lua_LuckyTurntableData");
checkRequire("Lua_LuckyTurntableUtil");
Lua_LuckyTurntableProxy = class("Lua_LuckyTurntableProxy");
function Lua_LuckyTurntableProxy:ctor()
	DataCenter.luckyTurntableData = Lua_LuckyTurntableData.new();
	DataCenter.luckyTurntableUtil = Lua_LuckyTurntableUtil.new();

	Lua_MsgUtil.addLuaMsg(50188001, self, self.rLuckyTurntableInfo);
	Lua_MsgUtil.addLuaMsg(80188002, self, self.nDrawLuckyTurntableReward);
	Lua_MsgUtil.addLuaMsg(50188003, self, self.rRefreshLuckyTurntableInfo);
	Lua_MsgUtil.addLuaMsg(50188004, self, self.rTurntableRewardInfo);
	Lua_MsgUtil.addLuaMsg(50188005, self, self.rTurntableWishRewardInfo);
	Lua_MsgUtil.addLuaMsg(50188006, self, self.rSkipRotateAnimation);
	Lua_MsgUtil.addLuaMsg(50188007, self, self.rCumulateDrawInfo);
	Lua_MsgUtil.addLuaMsg(80188007, self, self.nUpdateFirstOpenRedPoint); -- 首次打开红点
	Lua_MsgUtil.addLuaMsg(80188008, self, self.nUpdateSeniorResidueTime); -- 更新高级抽奖钻石使用次数

	Lua_MsgUtil.addEventListener("PACK_ITEMS_UPDATE", self, self.updateRedDot); -- 道具数量改变时更新红点
	Lua_MsgUtil.addEventListener("MONEY_UPDATE", self, self.updateRedDot); -- 货币改变时更新红点（高级转盘钻石抽奖）
	Lua_MsgUtil.addEventListener("VIP_LEVEL_UPDATE", self, self.updateRedDot); -- VIP更新，普通多抽消耗数量改变
end

-- 请求幸运转盘界面信息（返回）
function Lua_LuckyTurntableProxy:rLuckyTurntableInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50188001();
		msg:ParseFromString(mp.data);
		DataCenter.luckyTurntableData:fromServer50188001(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_INFO");
	end
end

-- 通知幸运转盘可领取奖励（通知）reward_state 1：普通转盘 2：高级转盘 3：普通和高级
function Lua_LuckyTurntableProxy:nDrawLuckyTurntableReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80188002();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("NOTICE_LUCKY_TURNTABLE_REWARD", msg.reward_state);
	end
end

-- 请求刷新幸运转盘（返回）
function Lua_LuckyTurntableProxy:rRefreshLuckyTurntableInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50188003();
		msg:ParseFromString(mp.data);
		DataCenter.luckyTurntableData:fromServer50188003(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_INFO");
	end
end

-- 请求幸运转盘抽奖（返回）
function Lua_LuckyTurntableProxy:rTurntableRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50188004();
		msg:ParseFromString(mp.data);
		DataCenter.luckyTurntableData:fromServer50188004(msg);

		local isSelectedWishReward = DataCenter.luckyTurntableData:isSelectedWishReward(msg.turntable_type);
		local isPlay;
		if isSelectedWishReward == 1 or DataCenter.luckyTurntableData.againReward then
			DataCenter.luckyTurntableData.againReward = false;
			isPlay = false;
		else
			isPlay = true;
		end
		Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_REWARD_INFO", isPlay);
	end
end

-- 请求设置心愿奖励（返回）
function Lua_LuckyTurntableProxy:rTurntableWishRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50188005();
		msg:ParseFromString(mp.data);
		DataCenter.luckyTurntableData:fromServer50188005(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_WISHHERO");
	end
end

-- 请求跳过幸运转盘动画（返回）
function Lua_LuckyTurntableProxy:rSkipRotateAnimation(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50188006();
		msg:ParseFromString(mp.data);
		DataCenter.luckyTurntableData:fromServer50188006(msg);
	end
end

-- 请求累计抽奖信息（返回）
function Lua_LuckyTurntableProxy:rCumulateDrawInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50188007();
		msg:ParseFromString(mp.data);
		DataCenter.luckyTurntableData:fromServer50188007(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_CUMULATEDRAWINFO", msg);
	end
end

-- 通知幸运转盘登录红点
function Lua_LuckyTurntableProxy:nUpdateFirstOpenRedPoint(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80188007();
		msg:ParseFromString(mp.data);
		DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LuckyTurntable_firstOpen, msg.red_point_state == 1);
	end
end

-- 更新高级抽奖钻石使用次数
function Lua_LuckyTurntableProxy:nUpdateSeniorResidueTime(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80188008();
		msg:ParseFromString(mp.data);
		DataCenter.luckyTurntableData:fromServer80188008(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_REDPOINT"); -- 按钮红点及消耗道具数量
	end
end

function Lua_LuckyTurntableProxy:updateRedDot(dic)
	local ordinaryCostId, ordinaryCostNum = DataCenter.luckyTurntableData:getOrdinaryItemInfo();
	local ordinaryHasNum = DataCenter.packData:getItemCountById(ordinaryCostId);
	local drawNum = DataCenter.luckyTurntableUtil:getTurntableConstConfig("advanced_multi_draw", 1);
	local seniorCostId, seniorCostNum = DataCenter.luckyTurntableData:getSeniorItemInfo(drawNum);
	local seniorHasNum = DataCenter.packData:getItemCountById(seniorCostId);
	local turntableType;
	local showState;
	if dic ~= nil then -- 道具数量改变时
		if DataCenter.funcOpenData:isOpened(10204) and dic[ordinaryCostId] ~= nil then
			Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_REDPOINT", Lua_LuckyTurntableData.ordinaryTurnTable);
			turntableType = Lua_LuckyTurntableData.ordinaryTurnTable;
			showState = ordinaryHasNum >= ordinaryCostNum;
		end
		if DataCenter.funcOpenData:isOpened(10205) and dic[seniorCostId] ~= nil then
			Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_REDPOINT", Lua_LuckyTurntableData.seniorTurnTable);
			turntableType = Lua_LuckyTurntableData.seniorTurnTable;
			showState = seniorHasNum >= seniorCostNum;
		end
	else -- VIP更新
		if DataCenter.funcOpenData:isOpened(10204) then
			Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_REDPOINT", Lua_LuckyTurntableData.ordinaryTurnTable);
			turntableType = Lua_LuckyTurntableData.ordinaryTurnTable;
			showState = ordinaryHasNum >= ordinaryCostNum;
		end
		if DataCenter.funcOpenData:isOpened(10205) then
			Lua_MsgUtil.callFunc("UPDATE_LUCKY_TURNTABLE_REDPOINT", Lua_LuckyTurntableData.seniorTurnTable);
			turntableType = Lua_LuckyTurntableData.seniorTurnTable;
			showState = seniorHasNum >= seniorCostNum;
		end
	end
	if turntableType ~= nil then
		DataCenter.luckyTurntableData:setItemUseRedDot(turntableType, showState);
	end
end










-- 请求幸运转盘界面信息 turntable_type 1普通转盘 2高级转盘
function Lua_LuckyTurntableProxy:sLuckyTurntableInfo(turntable_type)
	local cmd = ProtoPublic_pb.Proto10188001();
	cmd.turntable_type = turntable_type;
	sendMsg(10188001, cmd);
end

-- 请求刷新幸运转盘
function Lua_LuckyTurntableProxy:sRefreshLuckyTurntableInfo()
	sendMsg(10188003);
end

-- 请求幸运转盘抽奖 draw_type 1：单抽 2：多抽，turntable_type，1普通转盘 2高级转盘
function Lua_LuckyTurntableProxy:sTurntableRewardInfo(draw_type, turntable_type)
	local cmd = ProtoPublic_pb.Proto10188004();
	cmd.draw_type = draw_type;
	cmd.turntable_type = turntable_type;
	sendMsg(10188004, cmd);
end

-- 请求设置心愿奖励 turntable_type 1普通转盘 2高级转盘，wish_reward_id 心愿奖励 id
function Lua_LuckyTurntableProxy:sTurntableWishRewardInfo(turntable_type, wish_reward_id)
	local cmd = ProtoPublic_pb.Proto10188005();
	cmd.turntable_type = turntable_type;
	cmd.wish_reward_id = wish_reward_id;
	sendMsg(10188005, cmd);
end

-- 请求跳过幸运转盘动画 turntable_type 1普通转盘 2高级转盘，is_skip 是否跳过动画 1跳过 0不跳过
function Lua_LuckyTurntableProxy:sSkipRotateAnimation(turntable_type, is_skip)
	local cmd = ProtoPublic_pb.Proto10188006();
	cmd.turntable_type = turntable_type;
	cmd.is_skip = is_skip;
	sendMsg(10188006, cmd);
end

-- 请求累计抽奖信息 turntable_type 1普通转盘 2高级转盘
function Lua_LuckyTurntableProxy:sCumulateDrawInfo(turntable_type)
	local cmd = ProtoPublic_pb.Proto10188007();
	cmd.turntable_type = turntable_type;
	sendMsg(10188007, cmd);
end

-- 请求领取累计抽奖奖励 turntable_type 1普通转盘 2高级转盘，id领取奖励道具id
function Lua_LuckyTurntableProxy:sDrawCumulateTimesReward(turntable_type, id)
	local cmd = ProtoPublic_pb.Proto10188008();
	cmd.turntable_type = turntable_type;
	cmd.id = id;
	sendMsg(10188008, cmd);
end