checkRequire("Lua_VideoVo")
Lua_VideosData = class("Lua_VideosData")
function Lua_VideosData:ctor()
	self:superCall("ctor")

	self:dispose()
end

function Lua_VideosData:dispose()
	self._like_times = 0
	self._like_rewrad_times = 0
	self._save_times = 0
end

function Lua_VideosData.Get:like_times()
	return self._like_times or 0
end

function Lua_VideosData.Set:like_times(value)
	self._like_times = value
	local like_limit = DataCenter.videosUtil.like_times
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Video_Like, value < like_limit)
end

function Lua_VideosData.Get:like_rewrad_times()
	return self._like_rewrad_times
end

function Lua_VideosData.Get:save_times()
	return self._save_times
end

function Lua_VideosData.Get:videoArr()
	return self._videoArr
end

function Lua_VideosData:fromServer50199001(msg)
	self.like_times = msg.like_times -- 已点赞次数
	self._like_rewrad_times = msg.like_rewrad_times -- 已获得点赞奖励次数
	self._save_times = msg.save_times -- 已收藏数量

	if self._videoArr == nil then
		self._videoArr = Array()
		self._videoDic = {}
	else
		table.clear(self._videoDic)
	end
	local dataLen = msg.video_list == nil and 0 or #msg.video_list
	local len = self._videoArr:getSize()
	local num = len - dataLen
	local vo
    while (num > 0) do
        vo = self._videoArr:remove()
        vo:dispose()
        num = num - 1
    end
    while (num < 0) do
        vo = Lua_VideoVo.new()
        self._videoArr:add(vo)
        num = num + 1
    end

    for i = 1, dataLen do
    	vo = msg.video_list[i]
    	self._videoArr[i]:fromServer(vo)
    	self._videoDic[vo.record_id] = i
    end
end

function Lua_VideosData:fromServer50199002(msg)
	if self._videoArr == nil then
		return
	end

	local recordId = tonumber(msg.video_info.record_id)
	local index = self._videoDic[recordId]
	local vo = self._videoArr[index]
	if vo == nil then
		return
	end
	
	vo.replay_times = msg.video_info.replay_times
	vo.send_times = msg.video_info.send_times
	vo.like_times = msg.video_info.like_times
	if msg.action_type == 1 or msg.action_type == 4 then -- 收藏/取消收藏
		vo.is_saved = msg.video_info.is_saved
	elseif msg.action_type == 2 then -- 点赞
		vo.is_liked = msg.video_info.is_liked
	end
end

function Lua_VideosData:fromServer50199004(msg)
	self.like_times = msg.like_times;
	self._like_rewrad_times = msg.like_rewrad_times;
end