checkRequire("Lua_VideosData");
checkRequire("Lua_VideosUtil");
Lua_VideosProxy = class("Lua_VideosProxy");
function Lua_VideosProxy:ctor()
	DataCenter.videosData = Lua_VideosData.new();
	DataCenter.videosUtil = Lua_VideosUtil.new();

	Lua_MsgUtil.addLuaMsg(50199001, self, self.rVideoInfo); -- 请求录像馆界面(返回)
	Lua_MsgUtil.addLuaMsg(50199002, self, self.rHandle); -- 请求处理录像(返回)
	Lua_MsgUtil.addLuaMsg(50199003, self, self.rCheckHeroInfo); -- 录像馆请求英雄信息(返回)
	Lua_MsgUtil.addLuaMsg(50199004, self, self.rLikeInfo); -- 请求录像馆玩家点赞信息(返回)
end



------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 上行
-- 请求录像馆界面
function Lua_VideosProxy:sVideoInfo(index, is_filter, condition)
    local cmd = ProtoPublic_pb.Proto10199001();
    cmd.index = index; -- 列表类型
    cmd.is_filter = is_filter; -- 是否筛选临近等级（0：不筛选， 1筛选）
    cmd.condition = condition; -- 筛选条件值
    sendMsg(10199001, cmd);
end

-- 请求处理录像
function Lua_VideosProxy:sHandle(action_type, record_id)
    local cmd = ProtoPublic_pb.Proto10199002();
    cmd.action_type = action_type; -- 1：收藏，2：点赞，3：转发， 4：取消收藏
    cmd.record_id = tonumber(record_id); -- 记录id
    sendMsg(10199002, cmd);
end

-- 录像馆请求英雄信息
function Lua_VideosProxy:sCheckHeroInfo(record_id, unique_id, index)
    local cmd = ProtoPublic_pb.Proto10199003();
    cmd.record_id = tonumber(record_id);
    cmd.unique_id = tonumber(unique_id);
    cmd.index = index;
    sendMsg(10199003, cmd);
end

-- 录像馆请求英雄信息
function Lua_VideosProxy:sLikeInfo()
    sendMsg(10199004);
end




------------------------------------------------------------
------------------------------------------------------------
------------------------------------------------------------
-- 下行
function Lua_VideosProxy:rVideoInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50199001();
		msg:ParseFromString(mp.data);
		DataCenter.videosData:fromServer50199001(msg);
		Lua_MsgUtil.callFunc("UPDATE_VIDEO_INFO");
	end
end

function Lua_VideosProxy:rHandle(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50199002();
		msg:ParseFromString(mp.data);
		if msg.action_type == 1 then
			OperateAlert.showLangValue(480006);
		elseif msg.action_type == 2 then
			OperateAlert.show(DataCenter.videosUtil:getLikeTips());
		elseif msg.action_type == 3 then
			OperateAlert.showLangValue(480008);
		elseif msg.action_type == 4 then
			OperateAlert.showLangValue(480007);
		end
		DataCenter.videosData:fromServer50199002(msg);
		Lua_MsgUtil.callFunc("REQUEST_VIDEO_INFO");
	end
end

function Lua_VideosProxy:rCheckHeroInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50199003();
		msg:ParseFromString(mp.data);
		local vo = Lua_HeroVo.new(tonumber(msg.hero_info.hero_id));
		vo:fromServer(msg.hero_info);
		Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, vo);
	end
end

function Lua_VideosProxy:rLikeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50199004();
		msg:ParseFromString(mp.data);
		DataCenter.videosData:fromServer50199004(msg);
	end
end