Lua_VideosUtil = class("Lua_VideosUtil");
function Lua_VideosUtil:ctor()
	self:superCall("ctor");
end

function Lua_VideosUtil:getConstConfig(key, valType, defaultVal)
	local config = getConfig("video_room_const", key);
	if config ~= nil then
		if valType == 1 then
			return config.value;
		elseif valType == 2 then
			return config.strvalue;
		elseif valType == 3 then
			return config.arr_value;
		elseif valType == 4 then
			return config.float_value;
		end
	end
	return defaultVal;
end

function Lua_VideosUtil:getVideoConfig(id)
	return getConfig("video_room", id);
end

function Lua_VideosUtil:getLikeTips()
	if self.lileTips == nil then
		local reward = self:getConstConfig("like_reward", 3);
		local tvo;
		local str;
		for i = 1, #reward do
			tvo = Lua_ToolVo.createToolVo(reward[i][1], reward[i][2]);
			if str == nil then
				str = tvo.colorName.."*"..tvo.count;
			else
				str = str..tvo.colorName.."*"..tvo.count;
			end
		end
		self.lileTips = LanUtil.formateStr(480009, str)
	end
	return self.lileTips;
end

function Lua_VideosUtil:getCategory(index)
	return getConfig("video_room_const", "category_list", "arr_value", index)
end

function Lua_VideosUtil.Get:like_times()
	return getConfig("video_room_const", "like_times", "value") or 0
end

function Lua_VideosUtil.Get:self_save_limit()
	return getConfig("video_room_const", "self_save_limit", "value") or 0
end