checkRequire("Lua_VipData");
Lua_VipProxy = class("Lua_VipProxy");

function Lua_VipProxy:ctor()
    DataCenter.vipData = Lua_VipData.new()

    Lua_MsgUtil.addLuaMsg(50112001, self, self.rGetVipPanelInfo);--请求vip界面信息(返回)
    Lua_MsgUtil.addLuaMsg(50112002, self, self.rGetGiftReward);--购买/领取vip礼包(返回)
    Lua_MsgUtil.addLuaMsg(80112001, self, self.updateVipLevel);--VIP等级提升（通知）
end

------------------------------------ 上行 ------------------------------------

function Lua_VipProxy:sGetVipPanelInfo()--请求vip界面信息
    sendMsg(10112001);
end

function Lua_VipProxy:sGetGiftReward(vip_level)--购买/领取vip礼包
    local cmd = ProtoPublic_pb.Proto10112002();
    cmd.vip_level = vip_level;--购买vip等级礼包ID（vip等级）
    sendMsg(10112002, cmd);
end

------------------------------------ 下行 ------------------------------------

function Lua_VipProxy:rGetVipPanelInfo(mp)--请求vip界面信息(返回)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50112001();
        msg:ParseFromString(mp.data);
        DataCenter.vipData:fromServer50112001(msg);
    end
end

function Lua_VipProxy:rGetGiftReward(mp)--购买/领取vip礼包(返回)
    if mp.errno == 0 then
        Lua_MsgUtil.callFunc("GET_VIPGIFT_SUCCEED");
    end
end

function Lua_VipProxy:updateVipLevel(mp)--VIP等级提升（通知)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80112001();
        msg:ParseFromString(mp.data);
        DataCenter.vipData:fromServer80112001(msg);

        if DataCenter.funcOpenData:isOpened(10017) then
            self:showVipUpTipsFun(msg.vip_level);
        end
    end
end

function Lua_VipProxy:showVipUpTipsFun(vipLv)
    if vipLv > 0 and vipLv <= DataCenter.vipData.maxVipLevel then
        Lua_WindowUtil.openWin("Lua_VipUpTipsWindow", Lua_WinParam.ACTION_OPEN, vipLv);
    end
end