--独家企划数据类
checkRequire("Lua_ExclusivePlanTaskVo");
checkRequire("Lua_ExclusivePlanLevelVo");
Lua_ExclusivePlanData = class("Lua_ExclusivePlanData");
function Lua_ExclusivePlanData:ctor()
	self:dispose();
end

function Lua_ExclusivePlanData:dispose()
	self.taskVoList = {};
	self.levelVoList = {};
	self.curPeriod = nil;
	
	if self.levelIdArr ~= nil then
		self.levelIdArr:dispose();
		self.levelIdArr:clear();
		self.levelIdArr = nil;
	end
end

function Lua_ExclusivePlanData:fromServer50197036(msg)
	if msg == nil then
		return;
	end

	if self.levelIdArr == nil then
		self.levelIdArr = Array();
	end

	if self.curPeriod ~= msg.plan_type then
		self.levelIdArr:clear();
		self.levelVoList = {};
	end

	local id;
	local state;
	local seniorState;
	self.rewardState = 0;
	for i = 1, #msg.reward_list do
		id = msg.reward_list[i].key;
		state = msg.reward_list[i].value;
		seniorState = msg.senior_reward_list[i].value;
		if self.levelVoList[id] == nil then
			self.levelVoList[id] = Lua_ExclusivePlanLevelVo.new(id, msg.plan_type);
			self.levelIdArr:add(id);
		end
		self.levelVoList[id]:fromServer(state, seniorState);

		if state == 1 or seniorState == 1 then
			self.rewardState = 1;
		end
	end
	if self.curPeriod ~= msg.plan_type then
	    self.levelIdArr:sort(nil, true);
	end

    self.planLevel = msg.plan_level; --企划等级
	self.stateList = msg.reward_list; --奖励状态
	self.seniorStateList = msg.senior_reward_list; --高级奖励状态
	self.endTime = msg.end_time; --结束时间
	self.curPeriod = msg.plan_type; -- 版本期数
	self.planType = msg.plan_state; -- 企划类型
	self.extraExpState = msg.week_reward; -- 额外经验领取状态
	self.maxLevel = #msg.reward_list; --最大等级

    self:updateRedPoint();
	Lua_MsgUtil.callFunc("SHOW_PLAN_PANEL_INFO");
end

function Lua_ExclusivePlanData:fromServer50197041(msg)
	if msg == nil or DataCenter.funcOpenData:isOpened(10247) == false then
		return;
	end
	
	if self.taskIdArr == nil then
		self.taskIdArr = Array();
	end
	self.taskIdArr:clear();

	self.taskState = 0;
	local data;
	local taskList = msg.task_list;
	if taskList ~= nil and taskList[1].task_list ~= nil and self.curPeriod ~= nil then
		for i = 1, #taskList[1].task_list do
			data = taskList[1].task_list[i];
		    if self.taskVoList[data.id] == nil then
		    	self.taskVoList[data.id] = Lua_ExclusivePlanTaskVo.new();
		    end
		    self.taskIdArr:add(data.id);
		    self.taskVoList[data.id]:fromServer(data);

		    if data.flag == 1 then
		    	self.taskState = 1;
		    end
		end

		self:updateRedPoint();
	    Lua_MsgUtil.callFunc("UPDATE_TASK_INFO");
	end
end

function Lua_ExclusivePlanData:sortTaskIdArr()
	local vo;
	local nextVo;
	local tempId;
	for i = 1, self.taskIdArr:getSize() do
		for j = i + 1, self.taskIdArr:getSize() do
			vo = self:getTaskVoById(self.taskIdArr[i]);
			nextVo = self:getTaskVoById(self.taskIdArr[j]);
			if vo ~= nil and nextVo ~= nil then
				if vo.sort > nextVo.sort then
					tempId = self.taskIdArr[i];
					self.taskIdArr[i] = self.taskIdArr[j];
					self.taskIdArr[j] = tempId;
				end
			end
		end
	end
	return self.taskIdArr;
end

function Lua_ExclusivePlanData:getTaskVoById(id)
	return self.taskVoList[id];
end

function Lua_ExclusivePlanData:getLevelVoById(id)
	return self.levelVoList[id];
end

function Lua_ExclusivePlanData:updateRedPoint()
	local state = self.rewardState == 1 or self.extraExpState == 1 or (self.taskState == 1 and self.maxLevel ~= self.planLevel);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.WarOrder_ExclusivePlan, state);
end