Lua_WelfareData = class("Lua_WelfareData")
function Lua_WelfareData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_WelfareData:dispose()
	-- 签到数据
	self:initSignInData();
	-- 等级礼包数据
	self:initGradeData();
end

function Lua_WelfareData:initSignInData()
	self.totalDay = 30; -- 签到一轮为期30天
	self.day = 0; -- 签到天数
	self.round = 1; -- 轮数
	self.repair = 0; -- 已补签次数->再领一次 0-不能领取 1-可领取 2-已领取
	self.sign = 1; -- 今日签到标识 0-未签到  1-已签到
	self.curDay = 1; -- 当前天数
	self.leftDay = self.totalDay; -- 本轮剩余天数
	self.leftRepair = 0; -- 剩余可补签次数
end

function Lua_WelfareData:initGradeData()
	if self._giftInfoArr ~= nil then
		self._giftInfoArr:dispose();
		self._giftInfoArr:clear();
		self._giftInfoArr = nil;
	end
	self._endGradeVo = nil;
end










-------------------- 签到数据 --------------------

function Lua_WelfareData:fromServer50126001(msg)
	if msg == nil then
		return;
	end
	
	self.day = msg.day;
	self.repair = msg.repair;
	self.sign = msg.sign;

	self.round = DataCenter.welfareUtil.signInLimit;
	if msg.round <= self.round then
		self.round = msg.round;
	end
	if self.round <= 0 then
		self.round = 1;
	end

	self.curDay = msg.create_day % self.totalDay;
	if self.curDay == 0 then
		self.curDay = self.totalDay;
	end
	self.leftDay = self.totalDay - self.curDay + 1; -- 本轮剩余天数

	self:checkSignInRedPoint();
end

function Lua_WelfareData:checkSignInRedPoint()
	local state = false;
	if state == false then
		if self.sign == 0 or self.repair == 1 then
			state = true;
		end
	end

	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Welfare_SignIn, state);
end










-------------------- 等级礼包 --------------------

function Lua_WelfareData:fromServer50126008(msg)
	if msg == nil then
		return;
	end

	local id;
	local vo;
	for i = 1, #msg.draw_reward do -- draw_reward：已领取的礼包id列表
		id = msg.draw_reward[i];
		vo = DataCenter.welfareUtil:getGradeGiftVo(id);
		if vo ~= nil then
			vo:setReceiveState(true); -- 已领取的置为true
		end
	end

	local redState = false;
	local arr = self.giftInfoArr;
	for i = 1, arr:getSize() do
		if not redState and arr[i].isCanDraw then
			redState = true;
			break;
		end
	end
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Welfare_GradeGift, redState);

	-- print(self.endGradeVo.level, self.endGradeVo.isDraw);
	if self.endGradeVo.isDraw then
		local vo = DataCenter.internalActData:getActivityVo(Lua_ActivityList.ID_GradeGift);
		vo:fromServerInfo(0, 0);
	end
end

function Lua_WelfareData.Get:giftInfoArr()
	if self._giftInfoArr == nil then
		self._giftInfoArr = Array();

		local vo;
		local config = getConfig("rewardhall_lvl_gift");
		for k,v in pairs(config) do
			vo = DataCenter.welfareUtil:getGradeGiftVo(k);
			self._giftInfoArr:add(vo);
		end
	end
	self._giftInfoArr:sortf(self, self.sortFun);
	return self._giftInfoArr;
end

-- 将对象按照领取状态 isdraw 以及等级排序
function Lua_WelfareData:sortFun(a, b)
	local _a = a.isDraw;
	local _b = b.isDraw;
	if _a ~= _b then
		if _a == true then
			return false;
		end
	else
		if a.level > b.level then
			return false;
		end
	end
	return true;
end

function Lua_WelfareData.Get:endGradeVo()
	if self._endGradeVo == nil then
		local idx;
		local lvTag = 0;
		local arr = self.giftInfoArr;
		for i = 1, arr:getSize() do
			if lvTag < arr[i].level then
				lvTag = arr[i].level;
				idx = i;
			end
		end
		self._endGradeVo = arr[idx];
	end
	return self._endGradeVo;
end