Lua_SignInVo = class("Lua_SignInVo")
function Lua_SignInVo:ctor(id, config)
	self.id = id;
	self._config = config;
end

function Lua_SignInVo.Get:config()
	if self._config == nil then
		self._config = getConfig("rewardhall_sign", self.id);
	end
	return self._config;
end

function Lua_SignInVo.Get:signInType()
	local dd = DataCenter.welfareData.day;
	if DataCenter.welfareData.sign == 0 then
		dd = dd + 1;
	end

	if self.day < dd then -- 已签到
		return 1;
	elseif self.day == dd then -- 当天
		if DataCenter.welfareData.sign == 0 then -- 当天可签到
			return 2;
		else
			if DataCenter.welfareData.repair ~= 2 then -- 当天可再次领取
				return 3;
			else -- 当天已签到不可再次领取
				return 4;
			end
		end
	else -- 未到
		return 5;
	end
end

function Lua_SignInVo.Get:itemVo()
	if self._itemVo == nil then
		self._itemVo = Lua_ToolVo.createToolVo(self.reward[1], self.reward[2]);
	end
	return self._itemVo;
end

-------------------- 配置数据 --------------------

function Lua_SignInVo.Get:day()
	return self.config.day;
end

function Lua_SignInVo.Get:round()
	return self.config.round;
end

function Lua_SignInVo.Get:vip()
	return self.config.vip;
end

function Lua_SignInVo.Get:reward()
	return self.config.reward;
end