-- 场景关卡节点
checkRequire("Lua_SceneLevelNodeHeadInfoPanel");
Lua_SceneLevelNode = class("Lua_SceneLevelNode");
function Lua_SceneLevelNode:setPlayer(player)
    self.player = player;
end

function Lua_SceneLevelNode:initData()
    if self.player.IsUI == true then
        return;
    end

    self.data = self.player.data;
    self.sceneId = self.data.sceneId; -- 场景
    self.formationType = self.data.formationType; -- 攻守方
    self.formationPos = self.data.formationPos; -- 阵型位置
    self.playerId = tonumber(tostring(self.data.roleId)); -- 玩家唯一id
    self.objId = tonumber(tostring(self.data.objId)); -- objId
    self.kind = self.data.kind; -- 种类
    self.fightRecordId = tonumber(tostring(self.data.fightRecordId)); -- 战斗id
    DataCenter.thingData:addThingPlayer(self, self.playerId, self.objId, self.sceneId, self.fightRecordId, self.formationType, self.formationPos);

    self.needTween = self.player.viewState and DataCenter.mainLineData.sceneNodeTween == true;
    self.needEffect = self.player.viewState and DataCenter.mainLineData.sceneNodeEffect == true;
end

function Lua_SceneLevelNode:getLuaData()
    return DataCenter.thingData:getThingData(self.playerId);
end

function Lua_SceneLevelNode:loadBodyComplete()
    self.player.bRefreshHeadSprPos = true; -- 配置点可能为Vector3.zero
    if self.player.viewState == true and self.data.isShowName == true then
        if self.needEffect == true and self.bAddEff ~= true then
            self.bAddEff = true;
            local config = Lua_MainLineCheckpointConfigData.getConfig(self.objId)
            if config.is_boss == 1 then
                self.player:addHangerEffect(Lua_ThingDefine.PLAYER_EFFECT, "diaoluo_light1")
            else
                self.player:addHangerEffect(Lua_ThingDefine.PLAYER_EFFECT, "diaoluo_light2")
            end
        end
        self:updateHeadPos();
        self:updateHeadInfo();
        Lua_CommonUtil.addTimer("SCENELEVELNODE_UPDATE_HEADINFO", 0.02, self, self.updateHeadPos);
    end
end

-- 更新头顶挂件偏移数据
function Lua_SceneLevelNode.Get:headContainerPosY()
    if self._headContainerPosY == nil then
        self._headContainerPosY = 100;
    end
    return self._headContainerPosY;
end

-- 更新头顶挂件偏移数据
function Lua_SceneLevelNode.Get:scaleValue()
    if self._scaleValue == nil then
        self._scaleValue = 1;
    end
    return self._scaleValue;
end

-- 更新头顶挂件
function Lua_SceneLevelNode:updateHeadPos()
    if self.player == nil or self.player.IsUI == true then
        return;
    end
end

function Lua_SceneLevelNode:showHeadInfo()
    if self.data.isShowName == false or self.headContainer == nil then
        return;
    end
end

function Lua_SceneLevelNode:refreshHeadPos()
    if self.uiContainer ~= nil then
        if self.player.bRefreshHeadSprPos == true then
            self.player.bRefreshHeadSprPos = false;
            self.rootPos = self:getTfWorldPos(self.player.root.transform, self.rootPos, true);
            self.rootPos.y = self.rootPos.y + self.headContainerPosY * self.scaleValue * 0.01;
            LuaUtil.setUIHeadObjPos(self.uiContainer, self.rootPos.x, self.rootPos.y, self.rootPos.z);
        end
    end
end

function Lua_SceneLevelNode:getTfWorldPos(tf, vec, reset)
    if tf == nil then
        return vec;
    end

    if vec == nil then
        vec = Vector3(0, 0, 0);
    elseif reset == true then
        vec:Set(0, 0, 0);
    end

    local pos = tf.localPosition;
    vec.x = vec.x + pos.x;
    vec.y = vec.y + pos.y;
    vec.z = vec.z + pos.z;
    return self:getTfWorldPos(tf.parent, vec, false);
end

function Lua_SceneLevelNode:refreshActive(val)
    if self.uiContainer ~= nil then
        self.uiContainer:SetActive(val);
    end
end

function Lua_SceneLevelNode:clearRes()
    if self.headInfoPanel ~= nil then
        TweenUtil.getInstance():stop(self.headInfoPanel.content);
        self.headInfoPanel:dispose();
        self.headInfoPanel = nil;
    end

    if self.headContainer ~= nil then
        UnityEngine.GameObject.Destroy(self.headContainer);
        self.headContainer = nil;
    end

    if self.uiContainer ~= nil then
        UnityEngine.GameObject.Destroy(self.uiContainer);
        self.uiContainer = nil;
    end
end

function Lua_SceneLevelNode:dispose()
    if self.isDispose == true then
        return;
    end

    self.isDispose = true;
    Lua_CommonUtil.removeTimer(self, self.updateHeadPos);
    if not self.player.IsUI then
        DataCenter.thingData:removeThingPlayer(self, self.playerId, self.objId, self.sceneId, self.fightRecordId, self.formationType, self.formationPos);
    end
    self:clearRes();
    self.player = nil;
    self.data = nil;
end

function Lua_SceneLevelNode:showClickInfo(clickStr)

end

function Lua_SceneLevelNode:updateHeadInfo()
    local isView = self.player.viewState;
    if self.objId == DataCenter.mainLineData.checkpointId and isView == true then
        if self.uiContainer == nil then
            self.uiContainer = UICreate.createGameObject(GlobalVar.uiHeadContainer);
            self.uiContainer.name = self.playerId.."_headContainer";
            LuaUtil.setObjScale(self.uiContainer, self.scaleValue, self.scaleValue, self.scaleValue);
        end

        if self.headContainer == nil then
            self.headContainer = UICreate.createGameObject(self.uiContainer);
            self.headContainer.name = "headSpr";
            LuaUtil.setObjRot(self.headContainer, 0, 0, 0);
            LuaUtil.setObjPos(self.headContainer, 0, 0, 0);
        end 

        if self.headInfoPanel == nil then
            self.headInfoPanel = Lua_SceneLevelNodeHeadInfoPanel.new(self.headContainer, self.objId);
            if self.needTween == true then
                self.needTween = false;
                self.headInfoPanel:setLocation(0, DataCenter.mainLineUtil.headPanelStartPos, 0);
                TweenUtil.getInstance():addTweenTargetPos(self.headInfoPanel.content, DataCenter.mainLineUtil.headPanelTweenTime, 0, 0, 0, 0);
            else
                TweenUtil.getInstance():stop(self.headInfoPanel.content);
                self.headInfoPanel:setLocation(0, 0, 0);
            end
        end

        self:refreshHeadPos();
        self:refreshActive(self.player.bActive);
    else
        self:clearRes();
    end
end