-- 战斗角色头顶信息面板
checkRequire("Lua_BuffVo");
checkRequire("Lua_BuffConfigData");
checkRequire("Lua_FightHpBar");
checkRequire("Lua_FightShieldBar");
Lua_FightPlayerHeadInfoPanel = class("Lua_FightPlayerHeadInfoPanel", Lua_DisplayObject);
function Lua_FightPlayerHeadInfoPanel:ctor(p, formationType)
    self.formationType = formationType;
	self:superCall("ctor", p, "FightPlayerHeadInfoPanel_skin");
end

function Lua_FightPlayerHeadInfoPanel:buildShowItem()
    self:superCall("buildShowItem");

    -- self.shieldBar = Lua_FightShieldBar.new(self.content, "fight_atlas_1", nil, "xui_zd_progress_1_f", 97, 13);
    -- self.shieldBar:setLocation(11, 10, 0);
    -- self.shieldBar:init();
    -- self.shieldBar.timerName = "THINGPLAYER_SHIELD";
    -- self.shieldBar:setEnable(false);

    if self.formationType == Lua_FightDefine.FIGHT_ATTACKER then
        self.healthBar = Lua_FightHpBar.new(self.content, "fight_atlas_1", "xui_zd_progress_1_b", "xui_zd_progress_1_f", 102, 19);
        self.healthBar:createSecondBar("fight_atlas_1", "xui_zd_progress_7_f"); -- 回血
        self.healthBar:createAnimationBar("fight_atlas_1", "xui_zd_progress_2_f"); -- 扣血
    else
        self.healthBar = Lua_FightHpBar.new(self.content, "fight_atlas_1", "xui_zd_progress_1_b", "xui_zd_progress_2_f", 102, 19);
        self.healthBar:createSecondBar("fight_atlas_1", "xui_zd_progress_7_f"); -- 回血
        self.healthBar:createAnimationBar("fight_atlas_1", "xui_zd_progress_6_f"); -- 扣血
    end
    self.healthBar:setSiblingIndex(0);
    self.healthBar:setBarOffset(0, 0);
    self.healthBar:init();
    self.healthBar.timerName = "THINGPLAYER_HP";
end

function Lua_FightPlayerHeadInfoPanel:dispose()
    if self.shieldBar ~= nil then
        self.shieldBar:dispose();
        self.shieldBar = nil;
    end
    if self.healthBar ~= nil then
        self.healthBar:dispose();
        self.healthBar = nil;
    end
	self:clearBuffIcon();
    self:superCall("dispose");
end

function Lua_FightPlayerHeadInfoPanel:updateCamp(camp)
    if camp == nil or camp <= 0 or camp > 6 then
    	self.campImg:setEnable(false);
    else
    	self.campImg:setEnable(true);
    	self.campImg:setAltas("common_altas_2", "xui_common_attribute_"..(camp + 6));
    end
end

function Lua_FightPlayerHeadInfoPanel:updateShield(speedRate, maxValue, value)
    -- if maxValue == nil or maxValue <= 0 or value == nil or value <= 0 then
    --     self.shieldBar:setEnable(false);
    -- else
    --     -- print("updateShield ", maxValue, value)
    --     self.shieldBar:setEnable(true);
    --     self.shieldBar:setSpeedRate(speedRate);
    --     self.shieldBar:setMaxValue(maxValue);
    --     self.shieldBar:setValue(value);
    -- end
end

function Lua_FightPlayerHeadInfoPanel:updateHealth(speedRate, maxHp, hp)
    if maxHp == nil or maxHp <= 0 then
        maxHp = 1;
    end
    if hp == nil or hp < 0 then
        hp = 0;
    end

    -- print("updateHealth ", maxHp, hp)
    self.healthBar:setSpeedRate(speedRate);
    self.healthBar:setMaxValue(maxHp);
    self.healthBar:setValue(hp);
end

function Lua_FightPlayerHeadInfoPanel:updateBuffIcon(data)
    self:returnIcon();
    if data == nil or data.buffCount <= 0 then
        return;
    end

    local count = data.buffCount - 1;
    local dic = {};
    local idx = 0;
    for i = 0, count do
        local buffId = data:getBuffIdByIdx(i);
        local buffData = Lua_BuffConfigData.getConfigData(buffId);
        if buffData and not strIsNullOrEmpty(buffData.atlas) and not strIsNullOrEmpty(buffData.sprite) then
            local vo = Lua_BuffVo.new();
            vo.atlas = buffData.atlas;
            vo.sprite = buffData.sprite;
            vo.sortWeight = buffData.sort;
            vo.overlayNum = data:getBuffOverlayNumByIdx(i);
            if buffData.main_type == nil then
                dic[buffId] = vo;
            else
                if dic[buffData.main_type] == nil then
                    dic[buffData.main_type] = vo;
                else
                    dic[buffData.main_type].overlayNum = dic[buffData.main_type].overlayNum + 1;
                end
            end

            idx = idx + 1;
            if idx >= 3 then
                break;
            end
        end
    end

    if idx > 0 then
        local arr = Array();
        for k,v in pairs(dic) do
            arr:add(v);
        end
        arr:sort("sortWeight", false);

        local icon;
        for i = 1, idx do
            icon = self:createIcon();
            icon:setScale(0.6, 0.6);
            icon:setLocation((i - 1) * 25, 0, 0);
            icon:setData(arr[i]);
        end
    end
end

function Lua_FightPlayerHeadInfoPanel:clearBuffIcon()
    if self.showList ~= nil then
        self.showList:dispose();
        self.showList:clear();
        self.showList = nil;
    end
    if self.hideList ~= nil then
        self.hideList:dispose();
        self.hideList:clear();
        self.hideList = nil;
    end
end

function Lua_FightPlayerHeadInfoPanel:createIcon()
    if self.showList == nil then
        self.showList = Array();
    end
    if self.hideList == nil then
        self.hideList = Array();
    end

    local len = self.hideList:getSize();
    local icon = nil;
    if len > 0 then
        icon = self.hideList:remove();
    end

    if icon == nil then
        icon = Lua_BuffIcon.new(self.buffObj);
    end
    icon:setEnable(true);
    self.showList:add(icon);
    return icon;
end

function Lua_FightPlayerHeadInfoPanel:returnIcon()
    if self.showList == nil or self.hideList == nil then
        return;
    end

    local len = self.showList:getSize();
    local icon;
    while len > 0 do
        icon = self.showList:remove(len);
        icon:setEnable(false);
        self.hideList:add(icon)
        len = len - 1;
    end
end