Lua_PigeonFeedingPanel = class("Lua_PigeonFeedingPanel", Lua_DisplayObject)
function Lua_PigeonFeedingPanel:ctor(p)
	self:superCall("ctor", p, "PigeonFeedingPanel_skin");
end

function Lua_PigeonFeedingPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.btnFeeding:addClickFuntion(self, self.onFeeding);
	self.btnHide:addClickFuntion(self, self.onHide);
end

function Lua_PigeonFeedingPanel:dispose()
	self.behaviorVo = nil;
	self:superCall("dispose");
end

function Lua_PigeonFeedingPanel:setData(behaviorVo)
	if self.behaviorVo == behaviorVo then
		return;
	end
	self.behaviorVo = behaviorVo;
	self:updatePos();
end

function Lua_PigeonFeedingPanel:startTimer()
	if not self.bTimer then
		self.bTimer = true;
		self:addTimer("PigeonFeedingPanel_Timer", 0.02, self, self.onTimer);
	end
end

function Lua_PigeonFeedingPanel:stopTimer()
	if self.bTimer then
		self.bTimer = false;
		self:emoveTimer(self, self.onTimer);
	end
end

function Lua_PigeonFeedingPanel:onTimer()
	self:updatePos();
end

function Lua_PigeonFeedingPanel:updatePos()
	if strIsNullOrEmpty(self.behaviorVo.sceneModelName) then -- 非场景对象
		local thing = DataCenter.thingData:getThingPlayer(self.behaviorVo.ornamentSceneId, 0, self.behaviorVo.ornamentRoleId);
		if thing ~= nil then
			local bubbleOffset = self.behaviorVo.qipaoCfg.bubbleOffset;
			local bubbleOffsetX = (bubbleOffset ~= nil and #bubbleOffset > 0) and bubbleOffset[1] or 0;
			local bubbleOffsetY = (bubbleOffset ~= nil and #bubbleOffset > 1) and bubbleOffset[2] or 0;
			local bubbleOffsetZ = (bubbleOffset ~= nil and #bubbleOffset > 2) and bubbleOffset[3] or 0;
			LuaUtil.setUIObjPos(self.parent, self.content, thing.data.px * 0.01, thing.data.py * 0.01, thing.data.pz * 0.01, 
				bubbleOffsetX, bubbleOffsetY, bubbleOffsetZ);
		end
	else
		local bubbleHangRoot = self.behaviorVo.qipaoCfg.bubbleHangRoot;
		if bubbleHangRoot == nil then
			bubbleHangRoot = self.behaviorVo.sceneModelName;
		end
		if bubbleHangRoot ~= nil then
			local bubbleOffset = self.behaviorVo.qipaoCfg.bubbleOffset;
			local bubbleOffsetX = (bubbleOffset ~= nil and #bubbleOffset > 0) and bubbleOffset[1] or 0;
			local bubbleOffsetY = (bubbleOffset ~= nil and #bubbleOffset > 1) and bubbleOffset[2] or 0;
			local bubbleOffsetZ = (bubbleOffset ~= nil and #bubbleOffset > 2) and bubbleOffset[3] or 0;
			LuaUtil.setUIObjPos(self.parent, self.content, self.behaviorVo.ornamentSceneId, bubbleHangRoot,
				bubbleOffsetX, bubbleOffsetY, bubbleOffsetZ);
		end
	end
end

function Lua_PigeonFeedingPanel:onFeeding(go)
	if self.clickTime and getTime() - self.clickTime < 0.3 then
		OperateAlert.showLangValue(10031);
		return;
	end
	self.clickTime = getTime();

	local config = self.behaviorVo.qipaoCfg;
	self.behaviorVo:showQipao(config, true);
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sPigeonFeeding();
	self:onHide(go);
end

function Lua_PigeonFeedingPanel:onHide(go)
	Lua_MsgUtil.callFunc("SceneOrnament_Bubble_Hide", self.behaviorVo.ornamentRoleId);
end