-- 模型相机管理
Lua_ModelCameraManager = class("Lua_ModelCameraManager")
function Lua_ModelCameraManager:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_ModelCameraManager:dispose()
	if self.modelCameraControllerArr ~= nil then
		ModelCameraManager.instance:changeAniController(nil); 
		local len = self.modelCameraControllerArr:getSize();
		while len > 0 do
			local cid = self.modelCameraControllerArr:remove(len);
			self.modelCameraControllerTab[cid] = nil;
			self.modelCameraControllerSceneTab[cid] = nil;
			len = len - 1;
		end
	end
end

function Lua_ModelCameraManager:checkSceneShow(sceneId)
	if sceneId == nil or sceneId <= 0 then return; end
	local curSceneId = self.curShowSceneId;
	if curSceneId == nil or curSceneId <= 0 or curSceneId == sceneId then
		return;
	end

	ModelCameraManager.instance:changeAniController(nil); 
end

function Lua_ModelCameraManager:changeAniController(cid, sceneId, camControllerName)
	-- print("changeAniController", cid, sceneId, camControllerName);
	if cid == nil then return; end
	if camControllerName ~= nil then
		if self.modelCameraControllerArr == nil then
			self.modelCameraControllerArr = Array();
			self.modelCameraControllerArr:add(cid);
			self.modelCameraControllerTab = {};
			self.modelCameraControllerSceneTab = {};
			self.modelCameraControllerTab[cid] = camControllerName;
			self.modelCameraControllerSceneTab[cid] = sceneId;
		else
			local idx = self.modelCameraControllerArr:indexOf(cid);
			if idx ~= -1 then
				self.modelCameraControllerArr:remove(idx);
				self.modelCameraControllerArr:add(cid);
			else
				self.modelCameraControllerArr:add(cid);
				self.modelCameraControllerTab[cid] = camControllerName;
				self.modelCameraControllerSceneTab[cid] = sceneId;
			end
		end
	else
		if self.modelCameraControllerArr ~= nil then
			if self.modelCameraControllerTab[cid] ~= nil then
				self.modelCameraControllerTab[cid] = nil;
				self.modelCameraControllerSceneTab[cid] = nil;
				self.modelCameraControllerArr:removeItem(cid);
			end
		end
	end

	local cname = nil;
	if self.modelCameraControllerArr ~= nil then
		local len = self.modelCameraControllerArr:getSize();
		cid = self.modelCameraControllerArr[len];
		cname = self.modelCameraControllerTab[cid];
	end
	ModelCameraManager.instance:changeAniController(cname); 
end

function Lua_ModelCameraManager.Get:curShowSceneId()
	local sceneId = nil;
	if self.modelCameraControllerArr ~= nil then
		local len = self.modelCameraControllerArr:getSize();
		cid = self.modelCameraControllerArr[len];
		sceneId = self.modelCameraControllerSceneTab[cid];
	end
	return sceneId;
end